/*
 * @author Mário Soares
 * @contributors Jefferson González
 * 
 * @license 
 * This file is part of wxPHP check the LICENSE file for information.
 * 
 * @note
 * This file was auto-generated by the wxPHP source maker
*/

#ifndef WXPHP_HELP_H_GUARD
#define WXPHP_HELP_H_GUARD

#include "references.h"
#include "object_types.h"

ZEND_BEGIN_ARG_INFO_EX(wxphp_help_get_args, 0, 0, 1)
	ZEND_ARG_INFO(0, name)
ZEND_END_ARG_INFO()

extern zend_class_entry* php_wxHtmlHelpController_entry;
void php_wxHtmlHelpController_destruction_handler(zend_rsrc_list_entry * TSRMLS_DC);

class wxHtmlHelpController_php: public wxHtmlHelpController{
	public:
	
	wxHtmlHelpController_php(int style=wxHF_DEFAULT_STYLE, wxWindow* parentWindow=NULL):wxHtmlHelpController(style, parentWindow){}
		
	wxHtmlHelpDialog* CreateHelpDialog(wxHtmlHelpData* data);
	wxHtmlHelpFrame* CreateHelpFrame(wxHtmlHelpData* data);
	
	
	void ***tsrm_ls;
	zval* phpObj;
	wxPHPObjectReferences references;
};

BEGIN_EXTERN_C()
struct zo_wxHtmlHelpController 
{
    zend_object zo;
    wxHtmlHelpController_php* native_object;
    wxphp_object_type object_type;
    int is_user_initialized;
};

void php_wxHtmlHelpController_free(void *object TSRMLS_DC);
zend_object_value php_wxHtmlHelpController_new(zend_class_entry *class_type TSRMLS_DC);
END_EXTERN_C()

#ifdef WXPHP_INCLUDE_METHOD_TABLES
static zend_function_entry php_wxHtmlHelpController_functions[] = {
	PHP_ME(php_wxHtmlHelpController, AddBook, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpController, Display, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpController, DisplayContents, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpController, DisplayIndex, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpController, KeywordSearch, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpController, ReadCustomization, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpController, SetShouldPreventAppExit, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpController, SetTempDir, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpController, SetTitleFormat, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpController, UseConfig, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpController, WriteCustomization, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpController, __construct, NULL, ZEND_ACC_PUBLIC|ZEND_ACC_CTOR)
	PHP_FE_END
};
#endif

extern zend_class_entry* php_wxHtmlModalHelp_entry;
void php_wxHtmlModalHelp_destruction_handler(zend_rsrc_list_entry * TSRMLS_DC);

class wxHtmlModalHelp_php: public wxHtmlModalHelp{
	public:
	
	wxHtmlModalHelp_php(wxWindow* parent, const wxString& helpFile, const wxString& topic=wxEmptyString, int style=wxHF_DEFAULT_STYLE|wxHF_DIALOG|wxHF_MODAL):wxHtmlModalHelp(parent, helpFile, topic, style){}
		
	
	
	void ***tsrm_ls;
	zval* phpObj;
	wxPHPObjectReferences references;
};

BEGIN_EXTERN_C()
struct zo_wxHtmlModalHelp 
{
    zend_object zo;
    wxHtmlModalHelp_php* native_object;
    wxphp_object_type object_type;
    int is_user_initialized;
};

void php_wxHtmlModalHelp_free(void *object TSRMLS_DC);
zend_object_value php_wxHtmlModalHelp_new(zend_class_entry *class_type TSRMLS_DC);
END_EXTERN_C()

#ifdef WXPHP_INCLUDE_METHOD_TABLES
static zend_function_entry php_wxHtmlModalHelp_functions[] = {
	PHP_ME(php_wxHtmlModalHelp, __construct, NULL, ZEND_ACC_PUBLIC|ZEND_ACC_CTOR)
	PHP_FE_END
};
#endif

extern zend_class_entry* php_wxHtmlHelpData_entry;
void php_wxHtmlHelpData_destruction_handler(zend_rsrc_list_entry * TSRMLS_DC);

class wxHtmlHelpData_php: public wxHtmlHelpData{
	public:
	
	wxHtmlHelpData_php():wxHtmlHelpData(){}
		
	
	
	void ***tsrm_ls;
	zval* phpObj;
	wxPHPObjectReferences references;
};

BEGIN_EXTERN_C()
struct zo_wxHtmlHelpData 
{
    zend_object zo;
    wxHtmlHelpData_php* native_object;
    wxphp_object_type object_type;
    int is_user_initialized;
};

void php_wxHtmlHelpData_free(void *object TSRMLS_DC);
zend_object_value php_wxHtmlHelpData_new(zend_class_entry *class_type TSRMLS_DC);
END_EXTERN_C()

#ifdef WXPHP_INCLUDE_METHOD_TABLES
static zend_function_entry php_wxHtmlHelpData_functions[] = {
	PHP_ME(php_wxHtmlHelpData, AddBook, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpData, FindPageById, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpData, FindPageByName, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpData, SetTempDir, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpData, __construct, NULL, ZEND_ACC_PUBLIC|ZEND_ACC_CTOR)
	PHP_FE_END
};
#endif

extern zend_class_entry* php_wxHtmlHelpDialog_entry;
void php_wxHtmlHelpDialog_destruction_handler(zend_rsrc_list_entry * TSRMLS_DC);

class wxHtmlHelpDialog_php: public wxHtmlHelpDialog{
	public:
	
	wxHtmlHelpDialog_php(wxHtmlHelpData* data=NULL):wxHtmlHelpDialog(data){}
	wxHtmlHelpDialog_php(wxWindow* parent, wxWindowID id, const wxString& title=wxEmptyString, int style=wxHF_DEFAULT_STYLE, wxHtmlHelpData* data=NULL):wxHtmlHelpDialog(parent, id, title, style, data){}
		
	
	
	void ***tsrm_ls;
	zval* phpObj;
	wxPHPObjectReferences references;
};

BEGIN_EXTERN_C()
struct zo_wxHtmlHelpDialog 
{
    zend_object zo;
    wxHtmlHelpDialog_php* native_object;
    wxphp_object_type object_type;
    int is_user_initialized;
};

void php_wxHtmlHelpDialog_free(void *object TSRMLS_DC);
zend_object_value php_wxHtmlHelpDialog_new(zend_class_entry *class_type TSRMLS_DC);
END_EXTERN_C()

#ifdef WXPHP_INCLUDE_METHOD_TABLES
static zend_function_entry php_wxHtmlHelpDialog_functions[] = {
	PHP_ME(php_wxHtmlHelpDialog, AddToolbarButtons, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpDialog, Create, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpDialog, GetController, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpDialog, SetController, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpDialog, SetTitleFormat, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpDialog, __construct, NULL, ZEND_ACC_PUBLIC|ZEND_ACC_CTOR)
	PHP_FE_END
};
#endif

extern zend_class_entry* php_wxHtmlHelpFrame_entry;
void php_wxHtmlHelpFrame_destruction_handler(zend_rsrc_list_entry * TSRMLS_DC);

class wxHtmlHelpFrame_php: public wxHtmlHelpFrame{
	public:
	
	wxHtmlHelpFrame_php(wxHtmlHelpData* data=NULL):wxHtmlHelpFrame(data){}
	wxHtmlHelpFrame_php(wxWindow* parent, wxWindowID id, const wxString& title=wxEmptyString, int style=wxHF_DEFAULT_STYLE, wxHtmlHelpData* data=NULL, wxConfigBase* config=NULL, const wxString& rootpath=wxEmptyString):wxHtmlHelpFrame(parent, id, title, style, data, config, rootpath){}
		
	
	
	void ***tsrm_ls;
	zval* phpObj;
	wxPHPObjectReferences references;
};

BEGIN_EXTERN_C()
struct zo_wxHtmlHelpFrame 
{
    zend_object zo;
    wxHtmlHelpFrame_php* native_object;
    wxphp_object_type object_type;
    int is_user_initialized;
};

void php_wxHtmlHelpFrame_free(void *object TSRMLS_DC);
zend_object_value php_wxHtmlHelpFrame_new(zend_class_entry *class_type TSRMLS_DC);
END_EXTERN_C()

#ifdef WXPHP_INCLUDE_METHOD_TABLES
static zend_function_entry php_wxHtmlHelpFrame_functions[] = {
	PHP_ME(php_wxHtmlHelpFrame, AddToolbarButtons, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpFrame, Create, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpFrame, GetController, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpFrame, SetController, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpFrame, SetTitleFormat, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpFrame, __construct, NULL, ZEND_ACC_PUBLIC|ZEND_ACC_CTOR)
	PHP_FE_END
};
#endif

extern zend_class_entry* php_wxHtmlHelpWindow_entry;
void php_wxHtmlHelpWindow_destruction_handler(zend_rsrc_list_entry * TSRMLS_DC);

class wxHtmlHelpWindow_php: public wxHtmlHelpWindow{
	public:
	
	wxHtmlHelpWindow_php(wxHtmlHelpData* data=NULL):wxHtmlHelpWindow(data){}
	wxHtmlHelpWindow_php(wxWindow* parent, int wxWindowID, const wxPoint& pos=wxDefaultPosition, const wxSize& size=wxDefaultSize, int style=wxTAB_TRAVERSAL|wxBORDER_NONE, int helpStyle=wxHF_DEFAULT_STYLE, wxHtmlHelpData* data=NULL):wxHtmlHelpWindow(parent, wxWindowID, pos, size, style, helpStyle, data){}
		
	void AddToolbarButtons(wxToolBar* toolBar, int style);
	
	
	void ***tsrm_ls;
	zval* phpObj;
	wxPHPObjectReferences references;
};

BEGIN_EXTERN_C()
struct zo_wxHtmlHelpWindow 
{
    zend_object zo;
    wxHtmlHelpWindow_php* native_object;
    wxphp_object_type object_type;
    int is_user_initialized;
};

void php_wxHtmlHelpWindow_free(void *object TSRMLS_DC);
zend_object_value php_wxHtmlHelpWindow_new(zend_class_entry *class_type TSRMLS_DC);
END_EXTERN_C()

#ifdef WXPHP_INCLUDE_METHOD_TABLES
static zend_function_entry php_wxHtmlHelpWindow_functions[] = {
	PHP_ME(php_wxHtmlHelpWindow, Create, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpWindow, Display, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpWindow, DisplayIndex, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpWindow, GetData, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpWindow, DisplayContents, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpWindow, KeywordSearch, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpWindow, ReadCustomization, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpWindow, RefreshLists, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpWindow, UseConfig, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpWindow, WriteCustomization, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxHtmlHelpWindow, __construct, NULL, ZEND_ACC_PUBLIC|ZEND_ACC_CTOR)
	PHP_FE_END
};
#endif

extern zend_class_entry* php_wxToolTip_entry;
void php_wxToolTip_destruction_handler(zend_rsrc_list_entry * TSRMLS_DC);

class wxToolTip_php: public wxToolTip{
	public:
	
	wxToolTip_php(const wxString& tip):wxToolTip(tip){}
		
	
	
	void ***tsrm_ls;
	zval* phpObj;
	wxPHPObjectReferences references;
};

BEGIN_EXTERN_C()
struct zo_wxToolTip 
{
    zend_object zo;
    wxToolTip_php* native_object;
    wxphp_object_type object_type;
    int is_user_initialized;
};

void php_wxToolTip_free(void *object TSRMLS_DC);
zend_object_value php_wxToolTip_new(zend_class_entry *class_type TSRMLS_DC);
END_EXTERN_C()

#ifdef WXPHP_INCLUDE_METHOD_TABLES
static zend_function_entry php_wxToolTip_functions[] = {
	PHP_ME(php_wxToolTip, __construct, NULL, ZEND_ACC_PUBLIC|ZEND_ACC_CTOR)
	PHP_ME(php_wxToolTip, SetTip, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxToolTip, SetReshow, NULL, ZEND_ACC_STATIC|ZEND_ACC_PUBLIC)
	PHP_ME(php_wxToolTip, SetDelay, NULL, ZEND_ACC_STATIC|ZEND_ACC_PUBLIC)
	PHP_ME(php_wxToolTip, SetAutoPop, NULL, ZEND_ACC_STATIC|ZEND_ACC_PUBLIC)
	PHP_ME(php_wxToolTip, GetWindow, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxToolTip, GetTip, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxToolTip, Enable, NULL, ZEND_ACC_STATIC|ZEND_ACC_PUBLIC)
	PHP_FE_END
};
#endif

#endif //WXPHP_HELP_H_GUARD
