/*
 * @author Jefferson González
 * 
 * @license 
 * This file is part of wxPHP check the LICENSE file for information.
 * 
 * @descirption
 * File that stores all types of classes used to check if an object 
 * passed to a method or function is castable to another type by
 * inheritance.
 * 
*/

#ifndef WXPHP_OBJECT_TYPES_H_GUARD
#define WXPHP_OBJECT_TYPES_H_GUARD

enum wxphp_object_type
{
	PHP_WXAPP_TYPE,
	PHP_WXSCROLLEDWINDOW_TYPE,
	PHP_WXRIBBONBUTTONBARBUTTONBASE_TYPE,
	PHP_WXRIBBONGALLERYITEM_TYPE,
	PHP_WXRIBBONTOOLBARTOOLBASE_TYPE,
	PHP_WXABOUTDIALOGINFO_TYPE,
	PHP_WXGRIDCELLCOORDS_TYPE,
	PHP_WXFRAME_TYPE,
	PHP_WXTOPLEVELWINDOW_TYPE,
	PHP_WXNONOWNEDWINDOW_TYPE,
	PHP_WXWINDOW_TYPE,
	PHP_WXSIZE_TYPE,
	PHP_WXPOINT_TYPE,
	PHP_WXREALPOINT_TYPE,
	PHP_WXEVTHANDLER_TYPE,
	PHP_WXSTATUSBAR_TYPE,
	PHP_WXBUTTON_TYPE,
	PHP_WXANYBUTTON_TYPE,
	PHP_WXCONTROL_TYPE,
	PHP_WXVALIDATOR_TYPE,
	PHP_WXBITMAPHANDLER_TYPE,
	PHP_WXBITMAP_TYPE,
	PHP_WXPALETTE_TYPE,
	PHP_WXIMAGE_TYPE,
	PHP_WXICON_TYPE,
	PHP_WXSPLITTERWINDOW_TYPE,
	PHP_WXBOXSIZER_TYPE,
	PHP_WXSIZER_TYPE,
	PHP_WXSIZERITEM_TYPE,
	PHP_WXSIZERFLAGS_TYPE,
	PHP_WXRECT_TYPE,
	PHP_WXTREECTRL_TYPE,
	PHP_WXTREEITEMID_TYPE,
	PHP_WXTREEITEMDATA_TYPE,
	PHP_WXCLIENTDATA_TYPE,
	PHP_WXIMAGELIST_TYPE,
	PHP_WXDC_TYPE,
	PHP_WXCOLOUR_TYPE,
	PHP_WXFONT_TYPE,
	PHP_WXPANEL_TYPE,
	PHP_WXCHECKLISTBOX_TYPE,
	PHP_WXLISTBOX_TYPE,
	PHP_WXCONTROLWITHITEMS_TYPE,
	PHP_WXMENUBAR_TYPE,
	PHP_WXMENUEVENT_TYPE,
	PHP_WXMENUITEM_TYPE,
	PHP_WXMENU_TYPE,
	PHP_WXEVENT_TYPE,
	PHP_WXTREEEVENT_TYPE,
	PHP_WXKEYEVENT_TYPE,
	PHP_WXKEYBOARDSTATE_TYPE,
	PHP_WXNOTIFYEVENT_TYPE,
	PHP_WXCOMMANDEVENT_TYPE,
	PHP_WXCLOSEEVENT_TYPE,
	PHP_WXACTIVATEEVENT_TYPE,
	PHP_WXAUIMANAGER_TYPE,
	PHP_WXAUIDOCKART_TYPE,
	PHP_WXAUIPANEINFO_TYPE,
	PHP_WXAUIMANAGEREVENT_TYPE,
	PHP_WXAUINOTEBOOK_TYPE,
	PHP_WXAUINOTEBOOKEVENT_TYPE,
	PHP_WXBOOKCTRLEVENT_TYPE,
	PHP_WXAUIDEFAULTTOOLBARART_TYPE,
	PHP_WXBOOKCTRLBASE_TYPE,
	PHP_WXWITHIMAGES_TYPE,
	PHP_WXACCELERATORENTRY_TYPE,
	PHP_WXACCELERATORTABLE_TYPE,
	PHP_WXGDIOBJECT_TYPE,
	PHP_WXANIMATION_TYPE,
	PHP_WXANIMATIONCTRL_TYPE,
	PHP_WXARTPROVIDER_TYPE,
	PHP_WXICONBUNDLE_TYPE,
	PHP_WXSTYLEDTEXTCTRL_TYPE,
	PHP_WXSTYLEDTEXTEVENT_TYPE,
	PHP_WXVERSIONINFO_TYPE,
	PHP_WXSCROLLBAR_TYPE,
	PHP_WXSTATICTEXT_TYPE,
	PHP_WXSTATUSBARPANE_TYPE,
	PHP_WXSTATICLINE_TYPE,
	PHP_WXSTATICBOXSIZER_TYPE,
	PHP_WXSTATICBOX_TYPE,
	PHP_WXSTATICBITMAP_TYPE,
	PHP_WXAUITOOLBARITEM_TYPE,
	PHP_WXCHECKBOX_TYPE,
	PHP_WXWRAPSIZER_TYPE,
	PHP_WXBITMAPBUTTON_TYPE,
	PHP_WXTEXTENTRY_TYPE,
	PHP_WXTEXTCOMPLETER_TYPE,
	PHP_WXTEXTCTRL_TYPE,
	PHP_WXTEXTATTR_TYPE,
	PHP_WXTEXTENTRYDIALOG_TYPE,
	PHP_WXCOMBOBOX_TYPE,
	PHP_WXITEMCONTAINER_TYPE,
	PHP_WXITEMCONTAINERIMMUTABLE_TYPE,
	PHP_WXBITMAPCOMBOBOX_TYPE,
	PHP_WXAUITOOLBAREVENT_TYPE,
	PHP_WXAUITOOLBAR_TYPE,
	PHP_WXBANNERWINDOW_TYPE,
	PHP_WXCHOICE_TYPE,
	PHP_WXLISTEVENT_TYPE,
	PHP_WXLISTCTRL_TYPE,
	PHP_WXLISTITEMATTR_TYPE,
	PHP_WXLISTITEM_TYPE,
	PHP_WXLISTBOOK_TYPE,
	PHP_WXCHILDFOCUSEVENT_TYPE,
	PHP_WXCHOICEBOOK_TYPE,
	PHP_WXRADIOBOX_TYPE,
	PHP_WXRADIOBUTTON_TYPE,
	PHP_WXREARRANGECTRL_TYPE,
	PHP_WXREARRANGEDIALOG_TYPE,
	PHP_WXREARRANGELIST_TYPE,
	PHP_WXSLIDER_TYPE,
	PHP_WXSPINCTRL_TYPE,
	PHP_WXSPINBUTTON_TYPE,
	PHP_WXSPINEVENT_TYPE,
	PHP_WXSPLITTEREVENT_TYPE,
	PHP_WXSPLASHSCREEN_TYPE,
	PHP_WXSIZEEVENT_TYPE,
	PHP_WXGAUGE_TYPE,
	PHP_WXHTMLWINDOW_TYPE,
	PHP_WXHTMLCONTAINERCELL_TYPE,
	PHP_WXHTMLCELL_TYPE,
	PHP_WXHTMLCELLEVENT_TYPE,
	PHP_WXHTMLCOLOURCELL_TYPE,
	PHP_WXHTMLEASYPRINTING_TYPE,
	PHP_WXHTMLLINKEVENT_TYPE,
	PHP_WXHTMLLINKINFO_TYPE,
	PHP_WXMOUSEEVENT_TYPE,
	PHP_WXMOUSESTATE_TYPE,
	PHP_WXMOVEEVENT_TYPE,
	PHP_WXMOUSEEVENTSMANAGER_TYPE,
	PHP_WXMESSAGEDIALOG_TYPE,
	PHP_WXHTMLLISTBOX_TYPE,
	PHP_WXVLISTBOX_TYPE,
	PHP_WXHTMLTAG_TYPE,
	PHP_WXHYPERLINKCTRL_TYPE,
	PHP_WXHYPERLINKEVENT_TYPE,
	PHP_WXCURSOR_TYPE,
	PHP_WXTOGGLEBUTTON_TYPE,
	PHP_WXTIMER_TYPE,
	PHP_WXTIMEREVENT_TYPE,
	PHP_WXTHREADEVENT_TYPE,
	PHP_WXSEARCHCTRL_TYPE,
	PHP_WXCOLOURPICKEREVENT_TYPE,
	PHP_WXCOLOURPICKERCTRL_TYPE,
	PHP_WXFONTPICKERCTRL_TYPE,
	PHP_WXFONTPICKEREVENT_TYPE,
	PHP_WXFILEPICKERCTRL_TYPE,
	PHP_WXFINDREPLACEDIALOG_TYPE,
	PHP_WXFINDREPLACEDATA_TYPE,
	PHP_WXDIRPICKERCTRL_TYPE,
	PHP_WXDIRDIALOG_TYPE,
	PHP_WXSPINDOUBLEEVENT_TYPE,
	PHP_WXSPINCTRLDOUBLE_TYPE,
	PHP_WXGENERICDIRCTRL_TYPE,
	PHP_WXFILENAME_TYPE,
	PHP_WXGRIDSIZEEVENT_TYPE,
	PHP_WXGRIDSIZER_TYPE,
	PHP_WXFLEXGRIDSIZER_TYPE,
	PHP_WXGRIDBAGSIZER_TYPE,
	PHP_WXSTDDIALOGBUTTONSIZER_TYPE,
	PHP_WXSCROLLEVENT_TYPE,
	PHP_WXSCROLLWINEVENT_TYPE,
	PHP_WXNOTEBOOK_TYPE,
	PHP_WXDIALOG_TYPE,
	PHP_WXSYSCOLOURCHANGEDEVENT_TYPE,
	PHP_WXSYMBOLPICKERDIALOG_TYPE,
	PHP_WXGBPOSITION_TYPE,
	PHP_WXGBSPAN_TYPE,
	PHP_WXGBSIZERITEM_TYPE,
	PHP_WXPOPUPWINDOW_TYPE,
	PHP_WXMDICHILDFRAME_TYPE,
	PHP_WXMDICLIENTWINDOW_TYPE,
	PHP_WXMDIPARENTFRAME_TYPE,
	PHP_WXMINIFRAME_TYPE,
	PHP_WXPROPERTYSHEETDIALOG_TYPE,
	PHP_WXWIZARD_TYPE,
	PHP_WXWIZARDEVENT_TYPE,
	PHP_WXWIZARDPAGE_TYPE,
	PHP_WXWIZARDPAGESIMPLE_TYPE,
	PHP_WXWINDOWMODALDIALOGEVENT_TYPE,
	PHP_WXTREELISTITEM_TYPE,
	PHP_WXTREEBOOK_TYPE,
	PHP_WXTREELISTCTRL_TYPE,
	PHP_WXSOUND_TYPE,
	PHP_WXSIMPLEHTMLLISTBOX_TYPE,
	PHP_WXFILESYSTEM_TYPE,
	PHP_WXFILESYSTEMHANDLER_TYPE,
	PHP_WXNATIVEFONTINFO_TYPE,
	PHP_WXDATEEVENT_TYPE,
	PHP_WXBITMAPTOGGLEBUTTON_TYPE,
	PHP_WXCALENDARDATEATTR_TYPE,
	PHP_WXCALENDARCTRL_TYPE,
	PHP_WXMASK_TYPE,
	PHP_WXTOOLTIP_TYPE,
	PHP_WXCARET_TYPE,
	PHP_WXREGION_TYPE,
	PHP_WXPOINT2DDOUBLE_TYPE,
	PHP_WXPOINT2DINT_TYPE,
	PHP_WXPOPUPTRANSIENTWINDOW_TYPE,
	PHP_WXPROCESSEVENT_TYPE,
	PHP_WXPROGRESSDIALOG_TYPE,
	PHP_WXGRAPHICSMATRIX_TYPE,
	PHP_WXGRAPHICSRENDERER_TYPE,
	PHP_WXWINDOWDC_TYPE,
	PHP_WXWINDOWCREATEEVENT_TYPE,
	PHP_WXWINDOWDESTROYEVENT_TYPE,
	PHP_WXGRAPHICSGRADIENTSTOP_TYPE,
	PHP_WXGRAPHICSGRADIENTSTOPS_TYPE,
	PHP_WXEVENTFILTER_TYPE,
	PHP_WXEVENTBLOCKER_TYPE,
	PHP_WXERASEEVENT_TYPE,
	PHP_WXEVENTLOOPACTIVATOR_TYPE,
	PHP_WXEVENTLOOPBASE_TYPE,
	PHP_WXPICKERBASE_TYPE,
	PHP_WXGRIDEVENT_TYPE,
	PHP_WXUPDATEUIEVENT_TYPE,
	PHP_WXHELPEVENT_TYPE,
	PHP_WXLAYOUTCONSTRAINTS_TYPE,
	PHP_WXDROPTARGET_TYPE,
	PHP_WXOBJECT_TYPE,
	PHP_WXFFILE_TYPE,
	PHP_WXFSFILE_TYPE,
	PHP_WXINPUTSTREAM_TYPE,
	PHP_WXSTREAMBASE_TYPE,
	PHP_WXTHREAD_TYPE,
	PHP_WXTIMEPICKERCTRL_TYPE,
	PHP_WXOUTPUTSTREAM_TYPE,
	PHP_WXCOLOURDIALOG_TYPE,
	PHP_WXCOLOURDATA_TYPE,
	PHP_WXFILEDIALOG_TYPE,
	PHP_WXFONTDATA_TYPE,
	PHP_WXFONTDIALOG_TYPE,
	PHP_WXTHREADHELPER_TYPE,
	PHP_WXTOOLBAR_TYPE,
	PHP_WXAUITABART_TYPE,
	PHP_WXCALENDAREVENT_TYPE,
	PHP_WXGRID_TYPE,
	PHP_WXGRIDCELLATTR_TYPE,
	PHP_WXGRIDCELLATTRPROVIDER_TYPE,
	PHP_WXGRIDCELLBOOLEDITOR_TYPE,
	PHP_WXGRIDCELLCHOICEEDITOR_TYPE,
	PHP_WXGRIDCELLDATETIMERENDERER_TYPE,
	PHP_WXGRIDCELLBOOLRENDERER_TYPE,
	PHP_WXGRIDCELLAUTOWRAPSTRINGRENDERER_TYPE,
	PHP_WXGRIDCELLAUTOWRAPSTRINGEDITOR_TYPE,
	PHP_WXGRIDCELLEDITOR_TYPE,
	PHP_WXGRIDCELLENUMEDITOR_TYPE,
	PHP_WXGRIDCELLENUMRENDERER_TYPE,
	PHP_WXGRIDCELLFLOATEDITOR_TYPE,
	PHP_WXGRIDCELLFLOATRENDERER_TYPE,
	PHP_WXGRIDCELLNUMBEREDITOR_TYPE,
	PHP_WXGRIDCELLNUMBERRENDERER_TYPE,
	PHP_WXGRIDCELLRENDERER_TYPE,
	PHP_WXGRIDCELLSTRINGRENDERER_TYPE,
	PHP_WXGRIDCELLTEXTEDITOR_TYPE,
	PHP_WXGRIDCOLUMNHEADERRENDERER_TYPE,
	PHP_WXGRIDCOLUMNHEADERRENDERERDEFAULT_TYPE,
	PHP_WXGRIDCORNERHEADERRENDERER_TYPE,
	PHP_WXGRIDCORNERHEADERRENDERERDEFAULT_TYPE,
	PHP_WXGRIDEDITORCREATEDEVENT_TYPE,
	PHP_WXGRIDHEADERLABELSRENDERER_TYPE,
	PHP_WXGRIDRANGESELECTEVENT_TYPE,
	PHP_WXGRIDROWHEADERRENDERER_TYPE,
	PHP_WXGRIDROWHEADERRENDERERDEFAULT_TYPE,
	PHP_WXGRIDSIZESINFO_TYPE,
	PHP_WXGRIDTABLEBASE_TYPE,
	PHP_WXGRIDUPDATELOCKER_TYPE,
	PHP_WXDATEPICKERCTRL_TYPE,
	PHP_WXPASSWORDENTRYDIALOG_TYPE,
	PHP_WXSCREENDC_TYPE,
	PHP_WXCOLLAPSIBLEPANE_TYPE,
	PHP_WXCOLLAPSIBLEPANEEVENT_TYPE,
	PHP_WXCOMBOCTRL_TYPE,
	PHP_WXCOMBOPOPUP_TYPE,
	PHP_WXDATAVIEWCTRL_TYPE,
	PHP_WXDATAVIEWITEM_TYPE,
	PHP_WXDATAVIEWCOLUMN_TYPE,
	PHP_WXDATAVIEWRENDERER_TYPE,
	PHP_WXDATAVIEWMODEL_TYPE,
	PHP_WXDATAVIEWMODELNOTIFIER_TYPE,
	PHP_WXREFCOUNTER_TYPE,
	PHP_WXDATAVIEWLISTCTRL_TYPE,
	PHP_WXDATAVIEWLISTSTORE_TYPE,
	PHP_WXDATAVIEWLISTMODEL_TYPE,
	PHP_WXDATAVIEWEVENT_TYPE,
	PHP_WXDATAFORMAT_TYPE,
	PHP_WXDATAINPUTSTREAM_TYPE,
	PHP_WXDATAOBJECT_TYPE,
	PHP_WXDATAOBJECTCOMPOSITE_TYPE,
	PHP_WXDATAOBJECTSIMPLE_TYPE,
	PHP_WXDATAOUTPUTSTREAM_TYPE,
	PHP_WXDATAVIEWBITMAPRENDERER_TYPE,
	PHP_WXDATAVIEWCHOICERENDERER_TYPE,
	PHP_WXDATAVIEWCUSTOMRENDERER_TYPE,
	PHP_WXDATAVIEWDATERENDERER_TYPE,
	PHP_WXDATAVIEWICONTEXT_TYPE,
	PHP_WXDATAVIEWICONTEXTRENDERER_TYPE,
	PHP_WXDATAVIEWINDEXLISTMODEL_TYPE,
	PHP_WXDATAVIEWITEMATTR_TYPE,
	PHP_WXDATAVIEWPROGRESSRENDERER_TYPE,
	PHP_WXDATAVIEWSPINRENDERER_TYPE,
	PHP_WXDATAVIEWTEXTRENDERER_TYPE,
	PHP_WXDATAVIEWTOGGLERENDERER_TYPE,
	PHP_WXDATAVIEWTREECTRL_TYPE,
	PHP_WXDATAVIEWTREESTORE_TYPE,
	PHP_WXDATAVIEWVIRTUALLISTMODEL_TYPE,
	PHP_WXVARIANT_TYPE,
	PHP_WXVARIANTDATA_TYPE,
	PHP_WXCLASSINFO_TYPE,
	PHP_WXCOLOURDATABASE_TYPE,
	PHP_WXCLIPBOARD_TYPE,
	PHP_WXCLIPBOARDTEXTEVENT_TYPE,
	PHP_WXLISTVIEW_TYPE,
	PHP_WXCONFIGBASE_TYPE,
	PHP_WXHEADERCTRLEVENT_TYPE,
	PHP_WXHEADERCTRL_TYPE,
	PHP_WXHEADERCOLUMN_TYPE,
	PHP_WXHEADERCTRLSIMPLE_TYPE,
	PHP_WXHEADERCOLUMNSIMPLE_TYPE,
	PHP_WXSETTABLEHEADERCOLUMN_TYPE,
	PHP_WXSETCURSOREVENT_TYPE,
	PHP_WXIDLEEVENT_TYPE,
	PHP_WXPEN_TYPE,
	PHP_WXEDITABLELISTBOX_TYPE,
	PHP_WXFILECTRLEVENT_TYPE,
	PHP_WXFILECTRL_TYPE,
	PHP_WXPROCESS_TYPE,
	PHP_WXTEXTVALIDATOR_TYPE,
	PHP_WXHSCROLLEDWINDOW_TYPE,
	PHP_WXINFOBAR_TYPE,
	PHP_WXRICHTOOLTIP_TYPE,
	PHP_WXPOSITION_TYPE,
	PHP_WXMUTEX_TYPE,
	PHP_WXMUTEXLOCKER_TYPE,
	PHP_WXXMLRESOURCE_TYPE,
	PHP_WXGENERICVALIDATOR_TYPE,
	PHP_WXSASHWINDOW_TYPE,
	PHP_WXSASHEVENT_TYPE,
	PHP_WXSASHLAYOUTWINDOW_TYPE,
	PHP_WXSEMAPHORE_TYPE,
	PHP_WXAUITOOLBARART_TYPE,
	PHP_WXBRUSH_TYPE,
	PHP_WXPLATFORMINFO_TYPE,
	PHP_WXPAGESETUPDIALOG_TYPE,
	PHP_WXPAGESETUPDIALOGDATA_TYPE,
	PHP_WXPRINTDIALOG_TYPE,
	PHP_WXPRINTDIALOGDATA_TYPE,
	PHP_WXPRINTDATA_TYPE,
	PHP_WXPOSTSCRIPTDC_TYPE,
	PHP_WXPRINTPREVIEW_TYPE,
	PHP_WXPRINTER_TYPE,
	PHP_WXPRINTERDC_TYPE,
	PHP_WXPRINTOUT_TYPE,
	PHP_WXPREVIEWFRAME_TYPE,
	PHP_WXPREVIEWCONTROLBAR_TYPE,
	PHP_WXPREVIEWCANVAS_TYPE,
	PHP_WXSINGLECHOICEDIALOG_TYPE,
	PHP_WXHTMLDCRENDERER_TYPE,
	PHP_WXHTMLFILTER_TYPE,
	PHP_WXHTMLHELPCONTROLLER_TYPE,
	PHP_WXHTMLHELPDATA_TYPE,
	PHP_WXHTMLHELPDIALOG_TYPE,
	PHP_WXHTMLHELPFRAME_TYPE,
	PHP_WXHTMLHELPWINDOW_TYPE,
	PHP_WXHTMLMODALHELP_TYPE,
	PHP_WXHTMLPRINTOUT_TYPE,
	PHP_WXHTMLRENDERINGINFO_TYPE,
	PHP_WXHTMLRENDERINGSTYLE_TYPE,
	PHP_WXHTMLTAGHANDLER_TYPE,
	PHP_WXHTMLTAGSMODULE_TYPE,
	PHP_WXMODULE_TYPE,
	PHP_WXHTMLWIDGETCELL_TYPE,
	PHP_WXHTMLWINPARSER_TYPE,
	PHP_WXHTMLWINTAGHANDLER_TYPE,
	PHP_WXAUTOBUFFEREDPAINTDC_TYPE,
	PHP_WXBUFFEREDDC_TYPE,
	PHP_WXBUFFEREDPAINTDC_TYPE,
	PHP_WXCLIENTDC_TYPE,
	PHP_WXPAINTEVENT_TYPE,
	PHP_WXPAINTDC_TYPE,
	PHP_WXMEMORYDC_TYPE,
	PHP_WXMIRRORDC_TYPE,
	PHP_WXDCCLIPPER_TYPE,
	PHP_WXFONTLIST_TYPE,
	PHP_WXPENLIST_TYPE,
	PHP_WXPALETTECHANGEDEVENT_TYPE,
	PHP_WXRENDERERNATIVE_TYPE,
	PHP_WXIMAGEHANDLER_TYPE,
	PHP_WXINITDIALOGEVENT_TYPE,
	PHP_WXMAXIMIZEEVENT_TYPE,
	PHP_WXNAVIGATIONKEYEVENT_TYPE,
	PHP_WXPATHLIST_TYPE,
	PHP_WXCRITICALSECTION_TYPE,
	PHP_WXCRITICALSECTIONLOCKER_TYPE,
	PHP_WXCONDITION_TYPE,
	PHP_WXBUSYCURSOR_TYPE,
	PHP_WXBUSYINFO_TYPE,
	PHP_WXXMLRESOURCEHANDLER_TYPE,
	PHP_WXXMLNODE_TYPE,
	PHP_WXXMLDOCUMENT_TYPE,
	PHP_WXXMLATTRIBUTE_TYPE,
	PHP_WXLAYOUTALGORITHM_TYPE,
	PHP_WXFOCUSEVENT_TYPE,
	PHP_WXFONTMAPPER_TYPE,
	PHP_WXFONTENUMERATOR_TYPE,
	PHP_WXFFILEINPUTSTREAM_TYPE,
	PHP_WXFFILEOUTPUTSTREAM_TYPE,
	PHP_WXFFILESTREAM_TYPE,
	PHP_WXFILE_TYPE,
	PHP_WXFILECONFIG_TYPE,
	PHP_WXFILEDIRPICKEREVENT_TYPE,
	PHP_WXFILEHISTORY_TYPE,
	PHP_WXFILEINPUTSTREAM_TYPE,
	PHP_WXFILEDROPTARGET_TYPE,
	PHP_WXFILEOUTPUTSTREAM_TYPE,
	PHP_WXFILESTREAM_TYPE,
	PHP_WXFILESYSTEMWATCHER_TYPE,
	PHP_WXFILESYSTEMWATCHEREVENT_TYPE,
	PHP_WXFILETYPE_TYPE,
	PHP_WXFILETYPEINFO_TYPE,
	PHP_WXSTOPWATCH_TYPE,
	PHP_WXSINGLEINSTANCECHECKER_TYPE,
	PHP_WXSTANDARDPATHS_TYPE,
	PHP_WXLOG_TYPE,
	PHP_WXLOGBUFFER_TYPE,
	PHP_WXLOGCHAIN_TYPE,
	PHP_WXLOGGUI_TYPE,
	PHP_WXLOGINTERPOSER_TYPE,
	PHP_WXLOGWINDOW_TYPE,
	PHP_WXLOGTEXTCTRL_TYPE,
	PHP_WXTEXTDATAOBJECT_TYPE,
	PHP_WXFILEDATAOBJECT_TYPE,
	PHP_WXBITMAPDATAOBJECT_TYPE,
	PHP_WXURLDATAOBJECT_TYPE,
	PHP_WXCUSTOMDATAOBJECT_TYPE,
	PHP_WXTEXTDROPTARGET_TYPE,
	PHP_WXDISPLAY_TYPE,
	PHP_WXDISPLAYCHANGEDEVENT_TYPE,
	PHP_WXCALCULATELAYOUTEVENT_TYPE,
	PHP_WXCONTEXTMENUEVENT_TYPE,
	PHP_WXQUERYLAYOUTINFOEVENT_TYPE,
	PHP_WXTOOLBOOK_TYPE,
	PHP_WXVIDEOMODE_TYPE,
	PHP_WXRIBBONCONTROL_TYPE,
	PHP_WXRIBBONBAR_TYPE,
	PHP_WXRIBBONBAREVENT_TYPE,
	PHP_WXRIBBONBUTTONBAR_TYPE,
	PHP_WXRIBBONBUTTONBAREVENT_TYPE,
	PHP_WXRIBBONARTPROVIDER_TYPE,
	PHP_WXRIBBONGALLERY_TYPE,
	PHP_WXRIBBONGALLERYEVENT_TYPE,
	PHP_WXRIBBONPAGE_TYPE,
	PHP_WXRIBBONPANEL_TYPE,
	PHP_WXRIBBONTOOLBAR_TYPE,
	PHP_WXTASKBARICON_TYPE,
	PHP_WXTASKBARICONEVENT_TYPE,
	PHP_WXTIMERRUNNER_TYPE,
	PHP_WXNOTIFICATIONMESSAGE_TYPE,
	PHP_WXSYSTEMOPTIONS_TYPE,
	PHP_WXSYSTEMSETTINGS_TYPE,
	PHP_WXWINDOWDISABLER_TYPE,
	PHP_WXGENERICPROGRESSDIALOG_TYPE,
	PHP_WXTOOLBARTOOLBASE_TYPE,
	PHP_WXWEBVIEWHISTORYITEM_TYPE,
	PHP_WXWEBVIEWHANDLER_TYPE,
	PHP_WXWEBVIEWEVENT_TYPE,
	PHP_WXWEBVIEWARCHIVEHANDLER_TYPE,
	PHP_WXWEBVIEW_TYPE,
	PHP_WXTEXTCOMPLETERSIMPLE_TYPE,
	PHP_WXMEDIACTRL_TYPE,
	PHP_WXURI_TYPE,
	PHP_WXMEDIAEVENT_TYPE,
	PHP_WXSCROLLED_TYPE
};

#endif //WXPHP_OBJECT_TYPES_H_GUARD
