/*
 * @author Mário Soares
 * @contributors Jefferson González
 * 
 * @license 
 * This file is part of wxPHP check the LICENSE file for information.
 * 
 * @note
 * This file was auto-generated by the wxPHP source maker
*/

#ifndef WXPHP_VFS_H_GUARD
#define WXPHP_VFS_H_GUARD

#include "references.h"
#include "object_types.h"

ZEND_BEGIN_ARG_INFO_EX(wxphp_vfs_get_args, 0, 0, 1)
	ZEND_ARG_INFO(0, name)
ZEND_END_ARG_INFO()

extern zend_class_entry* php_wxFileSystem_entry;
void php_wxFileSystem_destruction_handler(zend_rsrc_list_entry * TSRMLS_DC);

class wxFileSystem_php: public wxFileSystem{
	public:
	
	wxFileSystem_php():wxFileSystem(){}
		
	
	
	void ***tsrm_ls;
	zval* phpObj;
	wxPHPObjectReferences references;
};

BEGIN_EXTERN_C()
struct zo_wxFileSystem 
{
    zend_object zo;
    wxFileSystem_php* native_object;
    wxphp_object_type object_type;
    int is_user_initialized;
};

void php_wxFileSystem_free(void *object TSRMLS_DC);
zend_object_value php_wxFileSystem_new(zend_class_entry *class_type TSRMLS_DC);
END_EXTERN_C()

#ifdef WXPHP_INCLUDE_METHOD_TABLES
static zend_function_entry php_wxFileSystem_functions[] = {
	PHP_ME(php_wxFileSystem, __construct, NULL, ZEND_ACC_PUBLIC|ZEND_ACC_CTOR)
	PHP_ME(php_wxFileSystem, URLToFileName, NULL, ZEND_ACC_STATIC|ZEND_ACC_PUBLIC)
	PHP_ME(php_wxFileSystem, OpenFile, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxFileSystem, HasHandlerForPath, NULL, ZEND_ACC_STATIC|ZEND_ACC_PUBLIC)
	PHP_ME(php_wxFileSystem, GetPath, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxFileSystem, FindNext, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxFileSystem, FindFirst, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxFileSystem, FindFileInPath, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxFileSystem, FileNameToURL, NULL, ZEND_ACC_STATIC|ZEND_ACC_PUBLIC)
	PHP_ME(php_wxFileSystem, ChangePathTo, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxFileSystem, AddHandler, NULL, ZEND_ACC_STATIC|ZEND_ACC_PUBLIC)
	PHP_FE_END
};
#endif

extern zend_class_entry* php_wxFileSystemHandler_entry;
void php_wxFileSystemHandler_destruction_handler(zend_rsrc_list_entry * TSRMLS_DC);

class wxFileSystemHandler_php: public wxFileSystemHandler{
	public:
	
	wxFileSystemHandler_php():wxFileSystemHandler(){}
		
	bool CanOpen(const wxString& location);
	wxFSFile* OpenFile(wxFileSystem& fs, const wxString& location);
	
	
	void ***tsrm_ls;
	zval* phpObj;
	wxPHPObjectReferences references;
};

BEGIN_EXTERN_C()
struct zo_wxFileSystemHandler 
{
    zend_object zo;
    wxFileSystemHandler_php* native_object;
    wxphp_object_type object_type;
    int is_user_initialized;
};

void php_wxFileSystemHandler_free(void *object TSRMLS_DC);
zend_object_value php_wxFileSystemHandler_new(zend_class_entry *class_type TSRMLS_DC);
END_EXTERN_C()

#ifdef WXPHP_INCLUDE_METHOD_TABLES
static zend_function_entry php_wxFileSystemHandler_functions[] = {
	PHP_ME(php_wxFileSystemHandler, FindFirst, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxFileSystemHandler, FindNext, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(php_wxFileSystemHandler, GetMimeTypeFromExt, NULL, ZEND_ACC_STATIC|ZEND_ACC_PUBLIC)
	PHP_ME(php_wxFileSystemHandler, __construct, NULL, ZEND_ACC_PUBLIC|ZEND_ACC_CTOR)
	PHP_FE_END
};
#endif

#endif //WXPHP_VFS_H_GUARD
