/*
 * @author Mário Soares
 * @contributors Jefferson González
 * 
 * @license 
 * This file is part of wxPHP check the LICENSE file for information.
 * 
 * @note
 * This file was auto-generated by the wxPHP source maker
*/

#include "php_wxwidgets.h"
#include "appmanagement.h"
#include "aui.h"
#include "bookctrl.h"
#include "cfg.h"
#include "cmndlg.h"
#include "containers.h"
#include "ctrl.h"
#include "data.h"
#include "dc.h"
#include "dnd.h"
#include "docview.h"
#include "dvc.h"
#include "events.h"
#include "file.h"
#include "gdi.h"
#include "grid.h"
#include "help.h"
#include "html.h"
#include "logging.h"
#include "managedwnd.h"
#include "media.h"
#include "menus.h"
#include "misc.h"
#include "miscwnd.h"
#include "net.h"
#include "pickers.h"
#include "printing.h"
#include "ribbon.h"
#include "richtext.h"
#include "rtti.h"
#include "stc.h"
#include "streams.h"
#include "threading.h"
#include "validator.h"
#include "vfs.h"
#include "webview.h"
#include "winlayout.h"
#include "xml.h"
#include "xrc.h"
#include "others.h"


BEGIN_EXTERN_C()
void php_wxBannerWindow_free(void *object TSRMLS_DC) 
{
    zo_wxBannerWindow* custom_object = (zo_wxBannerWindow*) object;
    
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxBannerWindow_free on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	if(custom_object->native_object != NULL)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Pointer not null\n");
		php_printf("Pointer address %x\n", (unsigned int)(size_t)custom_object->native_object);
		#endif
		
		if(custom_object->is_user_initialized)
		{
	
			#ifdef USE_WXPHP_DEBUG
			php_printf("Deleting object by calling destroy and delete\n");
			#endif
			
			custom_object->native_object->Destroy();
			delete custom_object->native_object;
			
			custom_object->native_object = NULL;
		}
		
		#ifdef USE_WXPHP_DEBUG
		php_printf("Deletion of wxBannerWindow done\n");
		php_printf("===========================================\n\n");
		#endif
	}
	else
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Not user space initialized\n");
		#endif
	}

	zend_object_std_dtor(&custom_object->zo TSRMLS_CC);
    efree(custom_object);
}

zend_object_value php_wxBannerWindow_new(zend_class_entry *class_type TSRMLS_DC)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxBannerWindow_new on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	zval *temp;
    zend_object_value retval;
    zo_wxBannerWindow* custom_object;
    custom_object = (zo_wxBannerWindow*) emalloc(sizeof(zo_wxBannerWindow));

    zend_object_std_init(&custom_object->zo, class_type TSRMLS_CC);

#if PHP_VERSION_ID < 50399
	ALLOC_HASHTABLE(custom_object->zo.properties);
    zend_hash_init(custom_object->zo.properties, 0, NULL, ZVAL_PTR_DTOR, 0);
    zend_hash_copy(custom_object->zo.properties, &class_type->default_properties, (copy_ctor_func_t) zval_add_ref,(void *) &temp, sizeof(zval *));
#else
	object_properties_init(&custom_object->zo, class_type);
#endif

	retval.handle = zend_objects_store_put(custom_object, NULL, php_wxBannerWindow_free, NULL TSRMLS_CC);
	retval.handlers = zend_get_std_object_handlers();

    custom_object->native_object = NULL;
	custom_object->object_type = PHP_WXBANNERWINDOW_TYPE;
	custom_object->is_user_initialized = 0;
	
    return retval;
}
END_EXTERN_C()

/* {{{ proto  wxBannerWindow::wxBannerWindow()
   Default constructor, use Create() later. */
PHP_METHOD(php_wxBannerWindow, __construct)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxBannerWindow::__construct\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxBannerWindow* current_object;
	wxBannerWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	int arguments_received = ZEND_NUM_ARGS();
	
	
	//Parameters for overload 0
	bool overload0_called = false;
	//Parameters for overload 1
	zval* parent1 = 0;
	wxWindow* object_pointer1_0 = 0;
	long dir1;
	bool overload1_called = false;
	//Parameters for overload 2
	zval* parent2 = 0;
	wxWindow* object_pointer2_0 = 0;
	long winid2;
	long dir2;
	zval* pos2 = 0;
	wxPoint* object_pointer2_3 = 0;
	zval* size2 = 0;
	wxSize* object_pointer2_4 = 0;
	long style2;
	char* name2;
	long name_len2;
	bool overload2_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|l' (&parent1, &dir1)\n");
		#endif

		char parse_parameters_string[] = "z|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent1, &dir1 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxWindow*) argument_native_object;
					if (!object_pointer1_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload2;
					}
				}
				else if(Z_TYPE_P(parent1) != IS_NULL)
				{
					goto overload2;
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

	//Overload 2
	overload2:
	if(!already_called && arguments_received >= 2  && arguments_received <= 7)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|lOOls' (&parent2, &winid2, &dir2, &pos2, php_wxPoint_entry, &size2, php_wxSize_entry, &style2, &name2, &name_len2)\n");
		#endif

		char parse_parameters_string[] = "zl|lOOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent2, &winid2, &dir2, &pos2, php_wxPoint_entry, &size2, php_wxSize_entry, &style2, &name2, &name_len2 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent2) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent2 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent2 TSRMLS_CC))->native_object;
					object_pointer2_0 = (wxWindow*) argument_native_object;
					if (!object_pointer2_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent2) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos2) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos2 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos2 TSRMLS_CC))->native_object;
					object_pointer2_3 = (wxPoint*) argument_native_object;
					if (!object_pointer2_3 )
					{
						zend_error(E_ERROR, "Parameter 'pos' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(pos2) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'pos' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size2) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size2 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size2 TSRMLS_CC))->native_object;
					object_pointer2_4 = (wxSize*) argument_native_object;
					if (!object_pointer2_4 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size2) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload2_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct()\n");
				#endif

				native_object = new wxBannerWindow_php();

				native_object->references.Initialize();
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0)\n");
				#endif

				native_object = new wxBannerWindow_php((wxWindow*) object_pointer1_0);

				native_object->references.Initialize();
				((wxBannerWindow_php*) native_object)->references.AddReference(parent1, "wxBannerWindow::wxBannerWindow at call with 1 argument(s)");
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxDirection) dir1)\n");
				#endif

				native_object = new wxBannerWindow_php((wxWindow*) object_pointer1_0, (wxDirection) dir1);

				native_object->references.Initialize();
				((wxBannerWindow_php*) native_object)->references.AddReference(parent1, "wxBannerWindow::wxBannerWindow at call with 2 argument(s)");
				break;
			}
		}
	}

	if(overload2_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer2_0, (wxWindowID) winid2)\n");
				#endif

				native_object = new wxBannerWindow_php((wxWindow*) object_pointer2_0, (wxWindowID) winid2);

				native_object->references.Initialize();
				((wxBannerWindow_php*) native_object)->references.AddReference(parent2, "wxBannerWindow::wxBannerWindow at call with 2 argument(s)");
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer2_0, (wxWindowID) winid2, (wxDirection) dir2)\n");
				#endif

				native_object = new wxBannerWindow_php((wxWindow*) object_pointer2_0, (wxWindowID) winid2, (wxDirection) dir2);

				native_object->references.Initialize();
				((wxBannerWindow_php*) native_object)->references.AddReference(parent2, "wxBannerWindow::wxBannerWindow at call with 3 argument(s)");
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer2_0, (wxWindowID) winid2, (wxDirection) dir2, *(wxPoint*) object_pointer2_3)\n");
				#endif

				native_object = new wxBannerWindow_php((wxWindow*) object_pointer2_0, (wxWindowID) winid2, (wxDirection) dir2, *(wxPoint*) object_pointer2_3);

				native_object->references.Initialize();
				((wxBannerWindow_php*) native_object)->references.AddReference(parent2, "wxBannerWindow::wxBannerWindow at call with 4 argument(s)");
				((wxBannerWindow_php*) native_object)->references.AddReference(pos2, "wxBannerWindow::wxBannerWindow at call with 4 argument(s)");
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer2_0, (wxWindowID) winid2, (wxDirection) dir2, *(wxPoint*) object_pointer2_3, *(wxSize*) object_pointer2_4)\n");
				#endif

				native_object = new wxBannerWindow_php((wxWindow*) object_pointer2_0, (wxWindowID) winid2, (wxDirection) dir2, *(wxPoint*) object_pointer2_3, *(wxSize*) object_pointer2_4);

				native_object->references.Initialize();
				((wxBannerWindow_php*) native_object)->references.AddReference(parent2, "wxBannerWindow::wxBannerWindow at call with 5 argument(s)");
				((wxBannerWindow_php*) native_object)->references.AddReference(pos2, "wxBannerWindow::wxBannerWindow at call with 5 argument(s)");
				((wxBannerWindow_php*) native_object)->references.AddReference(size2, "wxBannerWindow::wxBannerWindow at call with 5 argument(s)");
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer2_0, (wxWindowID) winid2, (wxDirection) dir2, *(wxPoint*) object_pointer2_3, *(wxSize*) object_pointer2_4, (long) style2)\n");
				#endif

				native_object = new wxBannerWindow_php((wxWindow*) object_pointer2_0, (wxWindowID) winid2, (wxDirection) dir2, *(wxPoint*) object_pointer2_3, *(wxSize*) object_pointer2_4, (long) style2);

				native_object->references.Initialize();
				((wxBannerWindow_php*) native_object)->references.AddReference(parent2, "wxBannerWindow::wxBannerWindow at call with 6 argument(s)");
				((wxBannerWindow_php*) native_object)->references.AddReference(pos2, "wxBannerWindow::wxBannerWindow at call with 6 argument(s)");
				((wxBannerWindow_php*) native_object)->references.AddReference(size2, "wxBannerWindow::wxBannerWindow at call with 6 argument(s)");
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer2_0, (wxWindowID) winid2, (wxDirection) dir2, *(wxPoint*) object_pointer2_3, *(wxSize*) object_pointer2_4, (long) style2, wxString(name2, wxConvUTF8))\n");
				#endif

				native_object = new wxBannerWindow_php((wxWindow*) object_pointer2_0, (wxWindowID) winid2, (wxDirection) dir2, *(wxPoint*) object_pointer2_3, *(wxSize*) object_pointer2_4, (long) style2, wxString(name2, wxConvUTF8));

				native_object->references.Initialize();
				((wxBannerWindow_php*) native_object)->references.AddReference(parent2, "wxBannerWindow::wxBannerWindow at call with 7 argument(s)");
				((wxBannerWindow_php*) native_object)->references.AddReference(pos2, "wxBannerWindow::wxBannerWindow at call with 7 argument(s)");
				((wxBannerWindow_php*) native_object)->references.AddReference(size2, "wxBannerWindow::wxBannerWindow at call with 7 argument(s)");
				break;
			}
		}
	}

		
	if(already_called)
	{
		native_object->phpObj = getThis();
		

		current_object = (zo_wxBannerWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		current_object->native_object = native_object;
		
		current_object->is_user_initialized = 1;
		
		#ifdef ZTS 
		native_object->TSRMLS_C = TSRMLS_C;
		#endif
	}
	else
	{
		zend_error(E_ERROR, "Abstract class or wrong type/count of parameters passed to: wxBannerWindow::__construct\n");
	}
	
	#ifdef USE_WXPHP_DEBUG
		php_printf("===========================================\n\n");
	#endif
}
/* }}} */

/* {{{ proto  wxBannerWindow::SetText(string title, string message)
   Set the text to display. */
PHP_METHOD(php_wxBannerWindow, SetText)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxBannerWindow::SetText\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxBannerWindow* current_object;
	wxphp_object_type current_object_type;
	wxBannerWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxBannerWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxBannerWindow::SetText call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXBANNERWINDOW_TYPE){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	char* title0;
	long title_len0;
	char* message0;
	long message_len0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'ss' (&title0, &title_len0, &message0, &message_len0)\n");
		#endif

		char parse_parameters_string[] = "ss";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &title0, &title_len0, &message0, &message_len0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxBannerWindow::SetText(wxString(title0, wxConvUTF8), wxString(message0, wxConvUTF8))\n\n");
				#endif

				((wxBannerWindow_php*)native_object)->SetText(wxString(title0, wxConvUTF8), wxString(message0, wxConvUTF8));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxBannerWindow::SetText\n");
	}
}
/* }}} */

/* {{{ proto  wxBannerWindow::SetGradient(wxColour start, wxColour end)
   Set the colours between which the gradient runs. */
PHP_METHOD(php_wxBannerWindow, SetGradient)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxBannerWindow::SetGradient\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxBannerWindow* current_object;
	wxphp_object_type current_object_type;
	wxBannerWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxBannerWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxBannerWindow::SetGradient call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXBANNERWINDOW_TYPE){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* start0 = 0;
	wxColour* object_pointer0_0 = 0;
	zval* end0 = 0;
	wxColour* object_pointer0_1 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'OO' (&start0, php_wxColour_entry, &end0, php_wxColour_entry)\n");
		#endif

		char parse_parameters_string[] = "OO";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &start0, php_wxColour_entry, &end0, php_wxColour_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(start0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxColour*) zend_object_store_get_object(start0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxColour*) zend_object_store_get_object(start0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxColour*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'start' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(start0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'start' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 2){
				if(Z_TYPE_P(end0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxColour*) zend_object_store_get_object(end0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxColour*) zend_object_store_get_object(end0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxColour*) argument_native_object;
					if (!object_pointer0_1 )
					{
						zend_error(E_ERROR, "Parameter 'end' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(end0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'end' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxBannerWindow::SetGradient(*(wxColour*) object_pointer0_0, *(wxColour*) object_pointer0_1)\n\n");
				#endif

				((wxBannerWindow_php*)native_object)->SetGradient(*(wxColour*) object_pointer0_0, *(wxColour*) object_pointer0_1);

				references->AddReference(start0, "wxBannerWindow::SetGradient at call with 2 argument(s)");
				references->AddReference(end0, "wxBannerWindow::SetGradient at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxBannerWindow::SetGradient\n");
	}
}
/* }}} */

/* {{{ proto  wxBannerWindow::SetBitmap(wxBitmap bmp)
   Provide the bitmap to use as background. */
PHP_METHOD(php_wxBannerWindow, SetBitmap)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxBannerWindow::SetBitmap\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxBannerWindow* current_object;
	wxphp_object_type current_object_type;
	wxBannerWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxBannerWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxBannerWindow::SetBitmap call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXBANNERWINDOW_TYPE){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* bmp0 = 0;
	wxBitmap* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&bmp0, php_wxBitmap_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &bmp0, php_wxBitmap_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(bmp0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(bmp0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(bmp0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxBitmap*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'bmp' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(bmp0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'bmp' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxBannerWindow::SetBitmap(*(wxBitmap*) object_pointer0_0)\n\n");
				#endif

				((wxBannerWindow_php*)native_object)->SetBitmap(*(wxBitmap*) object_pointer0_0);

				references->AddReference(bmp0, "wxBannerWindow::SetBitmap at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxBannerWindow::SetBitmap\n");
	}
}
/* }}} */

/* {{{ proto bool wxBannerWindow::Create(wxWindow &parent, int winid, wxDirection dir, wxPoint pos, wxSize size, int style, string name)
   Really create the banner window for the objects created using the default constructor. */
PHP_METHOD(php_wxBannerWindow, Create)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxBannerWindow::Create\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxBannerWindow* current_object;
	wxphp_object_type current_object_type;
	wxBannerWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxBannerWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxBannerWindow::Create call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXBANNERWINDOW_TYPE){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* parent0 = 0;
	wxWindow* object_pointer0_0 = 0;
	long winid0;
	long dir0;
	zval* pos0 = 0;
	wxPoint* object_pointer0_3 = 0;
	zval* size0 = 0;
	wxSize* object_pointer0_4 = 0;
	long style0;
	char* name0;
	long name_len0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 2  && arguments_received <= 7)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|lOOls' (&parent0, &winid0, &dir0, &pos0, php_wxPoint_entry, &size0, php_wxSize_entry, &style0, &name0, &name_len0)\n");
		#endif

		char parse_parameters_string[] = "zl|lOOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent0, &winid0, &dir0, &pos0, php_wxPoint_entry, &size0, php_wxSize_entry, &style0, &name0, &name_len0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos0 TSRMLS_CC))->native_object;
					object_pointer0_3 = (wxPoint*) argument_native_object;
					if (!object_pointer0_3 )
					{
						zend_error(E_ERROR, "Parameter 'pos' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(pos0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'pos' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->native_object;
					object_pointer0_4 = (wxSize*) argument_native_object;
					if (!object_pointer0_4 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBannerWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) winid0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBannerWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) winid0));

				references->AddReference(parent0, "wxBannerWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBannerWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) winid0, (wxDirection) dir0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBannerWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) winid0, (wxDirection) dir0));

				references->AddReference(parent0, "wxBannerWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBannerWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) winid0, (wxDirection) dir0, *(wxPoint*) object_pointer0_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBannerWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) winid0, (wxDirection) dir0, *(wxPoint*) object_pointer0_3));

				references->AddReference(parent0, "wxBannerWindow::Create at call with 4 argument(s)");
				references->AddReference(pos0, "wxBannerWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBannerWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) winid0, (wxDirection) dir0, *(wxPoint*) object_pointer0_3, *(wxSize*) object_pointer0_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBannerWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) winid0, (wxDirection) dir0, *(wxPoint*) object_pointer0_3, *(wxSize*) object_pointer0_4));

				references->AddReference(parent0, "wxBannerWindow::Create at call with 5 argument(s)");
				references->AddReference(pos0, "wxBannerWindow::Create at call with 5 argument(s)");
				references->AddReference(size0, "wxBannerWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBannerWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) winid0, (wxDirection) dir0, *(wxPoint*) object_pointer0_3, *(wxSize*) object_pointer0_4, (long) style0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBannerWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) winid0, (wxDirection) dir0, *(wxPoint*) object_pointer0_3, *(wxSize*) object_pointer0_4, (long) style0));

				references->AddReference(parent0, "wxBannerWindow::Create at call with 6 argument(s)");
				references->AddReference(pos0, "wxBannerWindow::Create at call with 6 argument(s)");
				references->AddReference(size0, "wxBannerWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBannerWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) winid0, (wxDirection) dir0, *(wxPoint*) object_pointer0_3, *(wxSize*) object_pointer0_4, (long) style0, wxString(name0, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBannerWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) winid0, (wxDirection) dir0, *(wxPoint*) object_pointer0_3, *(wxSize*) object_pointer0_4, (long) style0, wxString(name0, wxConvUTF8)));

				references->AddReference(parent0, "wxBannerWindow::Create at call with 7 argument(s)");
				references->AddReference(pos0, "wxBannerWindow::Create at call with 7 argument(s)");
				references->AddReference(size0, "wxBannerWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxBannerWindow::Create\n");
	}
}
/* }}} */

BEGIN_EXTERN_C()
void php_wxInfoBar_free(void *object TSRMLS_DC) 
{
    zo_wxInfoBar* custom_object = (zo_wxInfoBar*) object;
    
	#ifdef USE_WXPHP_DEBUG
	php_printf("Obviate delete call for wxInfoBar on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n\n");
	#endif

	zend_object_std_dtor(&custom_object->zo TSRMLS_CC);
    efree(custom_object);
}

zend_object_value php_wxInfoBar_new(zend_class_entry *class_type TSRMLS_DC)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxInfoBar_new on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	zval *temp;
    zend_object_value retval;
    zo_wxInfoBar* custom_object;
    custom_object = (zo_wxInfoBar*) emalloc(sizeof(zo_wxInfoBar));

    zend_object_std_init(&custom_object->zo, class_type TSRMLS_CC);

#if PHP_VERSION_ID < 50399
	ALLOC_HASHTABLE(custom_object->zo.properties);
    zend_hash_init(custom_object->zo.properties, 0, NULL, ZVAL_PTR_DTOR, 0);
    zend_hash_copy(custom_object->zo.properties, &class_type->default_properties, (copy_ctor_func_t) zval_add_ref,(void *) &temp, sizeof(zval *));
#else
	object_properties_init(&custom_object->zo, class_type);
#endif

	retval.handle = zend_objects_store_put(custom_object, NULL, php_wxInfoBar_free, NULL TSRMLS_CC);
	retval.handlers = zend_get_std_object_handlers();

    custom_object->native_object = NULL;
	custom_object->object_type = PHP_WXINFOBAR_TYPE;
	custom_object->is_user_initialized = 0;
	
    return retval;
}
END_EXTERN_C()

/* {{{ proto  wxInfoBar::wxInfoBar()
   Default constructor. */
PHP_METHOD(php_wxInfoBar, __construct)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxInfoBar::__construct\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxInfoBar* current_object;
	wxInfoBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	int arguments_received = ZEND_NUM_ARGS();
	
	
	//Parameters for overload 0
	bool overload0_called = false;
	//Parameters for overload 1
	zval* parent1 = 0;
	wxWindow* object_pointer1_0 = 0;
	long winid1;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|l' (&parent1, &winid1)\n");
		#endif

		char parse_parameters_string[] = "z|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent1, &winid1 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxWindow*) argument_native_object;
					if (!object_pointer1_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct()\n");
				#endif

				native_object = new wxInfoBar_php();

				native_object->references.Initialize();
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0)\n");
				#endif

				native_object = new wxInfoBar_php((wxWindow*) object_pointer1_0);

				native_object->references.Initialize();
				((wxInfoBar_php*) native_object)->references.AddReference(parent1, "wxInfoBar::wxInfoBar at call with 1 argument(s)");
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) winid1)\n");
				#endif

				native_object = new wxInfoBar_php((wxWindow*) object_pointer1_0, (wxWindowID) winid1);

				native_object->references.Initialize();
				((wxInfoBar_php*) native_object)->references.AddReference(parent1, "wxInfoBar::wxInfoBar at call with 2 argument(s)");
				break;
			}
		}
	}

		
	if(already_called)
	{
		native_object->phpObj = getThis();
		

		current_object = (zo_wxInfoBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		current_object->native_object = native_object;
		
		current_object->is_user_initialized = 1;
		
		#ifdef ZTS 
		native_object->TSRMLS_C = TSRMLS_C;
		#endif
	}
	else
	{
		zend_error(E_ERROR, "Abstract class or wrong type/count of parameters passed to: wxInfoBar::__construct\n");
	}
	
	#ifdef USE_WXPHP_DEBUG
		php_printf("===========================================\n\n");
	#endif
}
/* }}} */

/* {{{ proto  wxInfoBar::ShowMessage(string msg, int flags)
   Show a message in the bar. */
PHP_METHOD(php_wxInfoBar, ShowMessage)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxInfoBar::ShowMessage\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxInfoBar* current_object;
	wxphp_object_type current_object_type;
	wxInfoBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxInfoBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxInfoBar::ShowMessage call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXINFOBAR_TYPE){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	char* msg0;
	long msg_len0;
	long flags0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 's|l' (&msg0, &msg_len0, &flags0)\n");
		#endif

		char parse_parameters_string[] = "s|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &msg0, &msg_len0, &flags0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxInfoBar::ShowMessage(wxString(msg0, wxConvUTF8))\n\n");
				#endif

				((wxInfoBar_php*)native_object)->ShowMessage(wxString(msg0, wxConvUTF8));


				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxInfoBar::ShowMessage(wxString(msg0, wxConvUTF8), (int) flags0)\n\n");
				#endif

				((wxInfoBar_php*)native_object)->ShowMessage(wxString(msg0, wxConvUTF8), (int) flags0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxInfoBar::ShowMessage\n");
	}
}
/* }}} */

/* {{{ proto bool wxInfoBar::SetFont(wxFont font)
   Overridden base class methods changes the font of the text message. */
PHP_METHOD(php_wxInfoBar, SetFont)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxInfoBar::SetFont\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxInfoBar* current_object;
	wxphp_object_type current_object_type;
	wxInfoBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxInfoBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxInfoBar::SetFont call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXINFOBAR_TYPE){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* font0 = 0;
	wxFont* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&font0, php_wxFont_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &font0, php_wxFont_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(font0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxFont*) zend_object_store_get_object(font0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxFont*) zend_object_store_get_object(font0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxFont*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'font' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(font0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'font' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxInfoBar::SetFont(*(wxFont*) object_pointer0_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxInfoBar_php*)native_object)->SetFont(*(wxFont*) object_pointer0_0));

				references->AddReference(font0, "wxInfoBar::SetFont at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxInfoBar::SetFont\n");
	}
}
/* }}} */

/* {{{ proto  wxInfoBar::SetEffectDuration(int duration)
   Set the duration of the animation used when showing or hiding the bar. */
PHP_METHOD(php_wxInfoBar, SetEffectDuration)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxInfoBar::SetEffectDuration\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxInfoBar* current_object;
	wxphp_object_type current_object_type;
	wxInfoBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxInfoBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxInfoBar::SetEffectDuration call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXINFOBAR_TYPE){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long duration0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&duration0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &duration0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxInfoBar::SetEffectDuration((int) duration0)\n\n");
				#endif

				((wxInfoBar_php*)native_object)->SetEffectDuration((int) duration0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxInfoBar::SetEffectDuration\n");
	}
}
/* }}} */

/* {{{ proto  wxInfoBar::RemoveButton(int btnid)
   Remove a button previously added by AddButton(). */
PHP_METHOD(php_wxInfoBar, RemoveButton)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxInfoBar::RemoveButton\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxInfoBar* current_object;
	wxphp_object_type current_object_type;
	wxInfoBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxInfoBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxInfoBar::RemoveButton call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXINFOBAR_TYPE){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long btnid0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&btnid0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &btnid0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxInfoBar::RemoveButton((wxWindowID) btnid0)\n\n");
				#endif

				((wxInfoBar_php*)native_object)->RemoveButton((wxWindowID) btnid0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxInfoBar::RemoveButton\n");
	}
}
/* }}} */

/* {{{ proto wxShowEffect wxInfoBar::GetShowEffect()
   Return the effect currently used for showing the bar. */
PHP_METHOD(php_wxInfoBar, GetShowEffect)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxInfoBar::GetShowEffect\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxInfoBar* current_object;
	wxphp_object_type current_object_type;
	wxInfoBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxInfoBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxInfoBar::GetShowEffect call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXINFOBAR_TYPE){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxInfoBar::GetShowEffect())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxInfoBar_php*)native_object)->GetShowEffect());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxInfoBar::GetShowEffect\n");
	}
}
/* }}} */

/* {{{ proto wxShowEffect wxInfoBar::GetHideEffect()
   Return the effect currently used for hiding the bar. */
PHP_METHOD(php_wxInfoBar, GetHideEffect)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxInfoBar::GetHideEffect\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxInfoBar* current_object;
	wxphp_object_type current_object_type;
	wxInfoBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxInfoBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxInfoBar::GetHideEffect call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXINFOBAR_TYPE){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxInfoBar::GetHideEffect())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxInfoBar_php*)native_object)->GetHideEffect());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxInfoBar::GetHideEffect\n");
	}
}
/* }}} */

/* {{{ proto int wxInfoBar::GetEffectDuration()
   Return the effect animation duration currently used. */
PHP_METHOD(php_wxInfoBar, GetEffectDuration)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxInfoBar::GetEffectDuration\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxInfoBar* current_object;
	wxphp_object_type current_object_type;
	wxInfoBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxInfoBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxInfoBar::GetEffectDuration call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXINFOBAR_TYPE){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxInfoBar::GetEffectDuration())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxInfoBar_php*)native_object)->GetEffectDuration());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxInfoBar::GetEffectDuration\n");
	}
}
/* }}} */

/* {{{ proto bool wxInfoBar::Create(wxWindow &parent, int winid)
   Create the info bar window. */
PHP_METHOD(php_wxInfoBar, Create)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxInfoBar::Create\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxInfoBar* current_object;
	wxphp_object_type current_object_type;
	wxInfoBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxInfoBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxInfoBar::Create call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXINFOBAR_TYPE){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* parent0 = 0;
	wxWindow* object_pointer0_0 = 0;
	long winid0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|l' (&parent0, &winid0)\n");
		#endif

		char parse_parameters_string[] = "z|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent0, &winid0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxInfoBar::Create((wxWindow*) object_pointer0_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxInfoBar_php*)native_object)->Create((wxWindow*) object_pointer0_0));

				references->AddReference(parent0, "wxInfoBar::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxInfoBar::Create((wxWindow*) object_pointer0_0, (wxWindowID) winid0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxInfoBar_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) winid0));

				references->AddReference(parent0, "wxInfoBar::Create at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxInfoBar::Create\n");
	}
}
/* }}} */

/* {{{ proto  wxInfoBar::AddButton(int btnid, string label)
   Add a button to be shown in the info bar. */
PHP_METHOD(php_wxInfoBar, AddButton)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxInfoBar::AddButton\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxInfoBar* current_object;
	wxphp_object_type current_object_type;
	wxInfoBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxInfoBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxInfoBar::AddButton call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXINFOBAR_TYPE){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long btnid0;
	char* label0;
	long label_len0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l|s' (&btnid0, &label0, &label_len0)\n");
		#endif

		char parse_parameters_string[] = "l|s";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &btnid0, &label0, &label_len0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxInfoBar::AddButton((wxWindowID) btnid0)\n\n");
				#endif

				((wxInfoBar_php*)native_object)->AddButton((wxWindowID) btnid0);


				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxInfoBar::AddButton((wxWindowID) btnid0, wxString(label0, wxConvUTF8))\n\n");
				#endif

				((wxInfoBar_php*)native_object)->AddButton((wxWindowID) btnid0, wxString(label0, wxConvUTF8));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxInfoBar::AddButton\n");
	}
}
/* }}} */

/* {{{ proto  wxInfoBar::SetShowHideEffects(wxShowEffect showEffect, wxShowEffect hideEffect)
   Set the effects to use when showing and hiding the bar. */
PHP_METHOD(php_wxInfoBar, SetShowHideEffects)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxInfoBar::SetShowHideEffects\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxInfoBar* current_object;
	wxphp_object_type current_object_type;
	wxInfoBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxInfoBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxInfoBar::SetShowHideEffects call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXINFOBAR_TYPE){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long showEffect0;
	long hideEffect0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'll' (&showEffect0, &hideEffect0)\n");
		#endif

		char parse_parameters_string[] = "ll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &showEffect0, &hideEffect0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxInfoBar::SetShowHideEffects((wxShowEffect) showEffect0, (wxShowEffect) hideEffect0)\n\n");
				#endif

				((wxInfoBar_php*)native_object)->SetShowHideEffects((wxShowEffect) showEffect0, (wxShowEffect) hideEffect0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxInfoBar::SetShowHideEffects\n");
	}
}
/* }}} */

/* {{{ proto  wxInfoBar::Dismiss()
   Hide the info bar window. */
PHP_METHOD(php_wxInfoBar, Dismiss)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxInfoBar::Dismiss\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxInfoBar* current_object;
	wxphp_object_type current_object_type;
	wxInfoBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxInfoBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxInfoBar::Dismiss call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXINFOBAR_TYPE){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxInfoBar::Dismiss()\n\n");
				#endif

				((wxInfoBar_php*)native_object)->Dismiss();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxInfoBar::Dismiss\n");
	}
}
/* }}} */

BEGIN_EXTERN_C()
void php_wxRichToolTip_free(void *object TSRMLS_DC) 
{
    zo_wxRichToolTip* custom_object = (zo_wxRichToolTip*) object;
    
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxRichToolTip_free on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	if(custom_object->native_object != NULL)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Pointer not null\n");
		php_printf("Pointer address %x\n", (unsigned int)(size_t)custom_object->native_object);
		#endif
		
		if(custom_object->is_user_initialized)
		{
			#ifdef USE_WXPHP_DEBUG
			php_printf("Deleting pointer with delete\n");
			#endif
			
       
            delete custom_object->native_object;
			
			custom_object->native_object = NULL;
		}
		
		#ifdef USE_WXPHP_DEBUG
		php_printf("Deletion of wxRichToolTip done\n");
		php_printf("===========================================\n\n");
		#endif
	}
	else
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Not user space initialized\n");
		#endif
	}

	zend_object_std_dtor(&custom_object->zo TSRMLS_CC);
    efree(custom_object);
}

zend_object_value php_wxRichToolTip_new(zend_class_entry *class_type TSRMLS_DC)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxRichToolTip_new on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	zval *temp;
    zend_object_value retval;
    zo_wxRichToolTip* custom_object;
    custom_object = (zo_wxRichToolTip*) emalloc(sizeof(zo_wxRichToolTip));

    zend_object_std_init(&custom_object->zo, class_type TSRMLS_CC);

#if PHP_VERSION_ID < 50399
	ALLOC_HASHTABLE(custom_object->zo.properties);
    zend_hash_init(custom_object->zo.properties, 0, NULL, ZVAL_PTR_DTOR, 0);
    zend_hash_copy(custom_object->zo.properties, &class_type->default_properties, (copy_ctor_func_t) zval_add_ref,(void *) &temp, sizeof(zval *));
#else
	object_properties_init(&custom_object->zo, class_type);
#endif

	retval.handle = zend_objects_store_put(custom_object, NULL, php_wxRichToolTip_free, NULL TSRMLS_CC);
	retval.handlers = zend_get_std_object_handlers();

    custom_object->native_object = NULL;
	custom_object->object_type = PHP_WXRICHTOOLTIP_TYPE;
	custom_object->is_user_initialized = 0;
	
    return retval;
}
END_EXTERN_C()

/* {{{ proto  wxRichToolTip::SetBackgroundColour(wxColour col, wxColour colEnd)
   Set the background colour. */
PHP_METHOD(php_wxRichToolTip, SetBackgroundColour)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxRichToolTip::SetBackgroundColour\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxRichToolTip* current_object;
	wxphp_object_type current_object_type;
	wxRichToolTip_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxRichToolTip*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxRichToolTip::SetBackgroundColour call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXRICHTOOLTIP_TYPE){
				references = &((wxRichToolTip_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* col0 = 0;
	wxColour* object_pointer0_0 = 0;
	zval* colEnd0 = 0;
	wxColour* object_pointer0_1 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O|O' (&col0, php_wxColour_entry, &colEnd0, php_wxColour_entry)\n");
		#endif

		char parse_parameters_string[] = "O|O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &col0, php_wxColour_entry, &colEnd0, php_wxColour_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(col0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxColour*) zend_object_store_get_object(col0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxColour*) zend_object_store_get_object(col0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxColour*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'col' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(col0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'col' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 2){
				if(Z_TYPE_P(colEnd0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxColour*) zend_object_store_get_object(colEnd0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxColour*) zend_object_store_get_object(colEnd0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxColour*) argument_native_object;
					if (!object_pointer0_1 )
					{
						zend_error(E_ERROR, "Parameter 'colEnd' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(colEnd0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'colEnd' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxRichToolTip::SetBackgroundColour(*(wxColour*) object_pointer0_0)\n\n");
				#endif

				((wxRichToolTip_php*)native_object)->SetBackgroundColour(*(wxColour*) object_pointer0_0);

				references->AddReference(col0, "wxRichToolTip::SetBackgroundColour at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxRichToolTip::SetBackgroundColour(*(wxColour*) object_pointer0_0, *(wxColour*) object_pointer0_1)\n\n");
				#endif

				((wxRichToolTip_php*)native_object)->SetBackgroundColour(*(wxColour*) object_pointer0_0, *(wxColour*) object_pointer0_1);

				references->AddReference(col0, "wxRichToolTip::SetBackgroundColour at call with 2 argument(s)");
				references->AddReference(colEnd0, "wxRichToolTip::SetBackgroundColour at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxRichToolTip::SetBackgroundColour\n");
	}
}
/* }}} */

/* {{{ proto  wxRichToolTip::SetTimeout(int millisecondsTimeout, int millisecondsDelay)
   Set timeout after which the tooltip should disappear and optionally set a delay before the tooltip is shown, in milliseconds. */
PHP_METHOD(php_wxRichToolTip, SetTimeout)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxRichToolTip::SetTimeout\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxRichToolTip* current_object;
	wxphp_object_type current_object_type;
	wxRichToolTip_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxRichToolTip*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxRichToolTip::SetTimeout call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXRICHTOOLTIP_TYPE){
				references = &((wxRichToolTip_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long millisecondsTimeout0;
	long millisecondsDelay0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l|l' (&millisecondsTimeout0, &millisecondsDelay0)\n");
		#endif

		char parse_parameters_string[] = "l|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &millisecondsTimeout0, &millisecondsDelay0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxRichToolTip::SetTimeout((unsigned) millisecondsTimeout0)\n\n");
				#endif

				((wxRichToolTip_php*)native_object)->SetTimeout((unsigned) millisecondsTimeout0);


				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxRichToolTip::SetTimeout((unsigned) millisecondsTimeout0, (unsigned) millisecondsDelay0)\n\n");
				#endif

				((wxRichToolTip_php*)native_object)->SetTimeout((unsigned) millisecondsTimeout0, (unsigned) millisecondsDelay0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxRichToolTip::SetTimeout\n");
	}
}
/* }}} */

/* {{{ proto  wxRichToolTip::SetIcon(int icon)
   Set the small icon to show. */
PHP_METHOD(php_wxRichToolTip, SetIcon)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxRichToolTip::SetIcon\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxRichToolTip* current_object;
	wxphp_object_type current_object_type;
	wxRichToolTip_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxRichToolTip*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxRichToolTip::SetIcon call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXRICHTOOLTIP_TYPE){
				references = &((wxRichToolTip_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long icon0;
	bool overload0_called = false;
	//Parameters for overload 1
	zval* icon1 = 0;
	wxIcon* object_pointer1_0 = 0;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|l' (&icon0)\n");
		#endif

		char parse_parameters_string[] = "|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &icon0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&icon1, php_wxIcon_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &icon1, php_wxIcon_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(icon1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxIcon*) zend_object_store_get_object(icon1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxIcon*) zend_object_store_get_object(icon1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxIcon*) argument_native_object;
					if (!object_pointer1_0 )
					{
						zend_error(E_ERROR, "Parameter 'icon' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(icon1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'icon' not null, could not be retreived correctly.");
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxRichToolTip::SetIcon()\n\n");
				#endif

				((wxRichToolTip_php*)native_object)->SetIcon();


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxRichToolTip::SetIcon((int) icon0)\n\n");
				#endif

				((wxRichToolTip_php*)native_object)->SetIcon((int) icon0);


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxRichToolTip::SetIcon(*(wxIcon*) object_pointer1_0)\n\n");
				#endif

				((wxRichToolTip_php*)native_object)->SetIcon(*(wxIcon*) object_pointer1_0);

				references->AddReference(icon1, "wxRichToolTip::SetIcon at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxRichToolTip::SetIcon\n");
	}
}
/* }}} */

/* {{{ proto  wxRichToolTip::SetTipKind(wxTipKind tipKind)
   Choose the tip kind, possibly none. */
PHP_METHOD(php_wxRichToolTip, SetTipKind)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxRichToolTip::SetTipKind\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxRichToolTip* current_object;
	wxphp_object_type current_object_type;
	wxRichToolTip_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxRichToolTip*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxRichToolTip::SetTipKind call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXRICHTOOLTIP_TYPE){
				references = &((wxRichToolTip_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long tipKind0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&tipKind0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &tipKind0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxRichToolTip::SetTipKind((wxTipKind) tipKind0)\n\n");
				#endif

				((wxRichToolTip_php*)native_object)->SetTipKind((wxTipKind) tipKind0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxRichToolTip::SetTipKind\n");
	}
}
/* }}} */

/* {{{ proto  wxRichToolTip::ShowFor(wxWindow &win, wxRect rect)
   Show the tooltip for the given window and optionally specify where to show the tooltip. */
PHP_METHOD(php_wxRichToolTip, ShowFor)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxRichToolTip::ShowFor\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxRichToolTip* current_object;
	wxphp_object_type current_object_type;
	wxRichToolTip_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxRichToolTip*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxRichToolTip::ShowFor call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXRICHTOOLTIP_TYPE){
				references = &((wxRichToolTip_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* win0 = 0;
	wxWindow* object_pointer0_0 = 0;
	zval* rect0 = 0;
	wxRect* object_pointer0_1 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|z' (&win0, &rect0)\n");
		#endif

		char parse_parameters_string[] = "z|z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &win0, &rect0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(win0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(win0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(win0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'win' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(win0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'win' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 2){
				if(Z_TYPE_P(rect0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxRect*) zend_object_store_get_object(rect0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxRect*) zend_object_store_get_object(rect0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxRect*) argument_native_object;
					if (!object_pointer0_1 || (argument_type != PHP_WXRECT_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'rect' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(rect0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'rect' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxRichToolTip::ShowFor((wxWindow*) object_pointer0_0)\n\n");
				#endif

				((wxRichToolTip_php*)native_object)->ShowFor((wxWindow*) object_pointer0_0);

				references->AddReference(win0, "wxRichToolTip::ShowFor at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxRichToolTip::ShowFor((wxWindow*) object_pointer0_0, (const wxRect*) object_pointer0_1)\n\n");
				#endif

				((wxRichToolTip_php*)native_object)->ShowFor((wxWindow*) object_pointer0_0, (const wxRect*) object_pointer0_1);

				references->AddReference(win0, "wxRichToolTip::ShowFor at call with 2 argument(s)");
				references->AddReference(rect0, "wxRichToolTip::ShowFor at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxRichToolTip::ShowFor\n");
	}
}
/* }}} */

/* {{{ proto  wxRichToolTip::wxRichToolTip(string title, string message)
   Constructor must specify the tooltip title and main message. */
PHP_METHOD(php_wxRichToolTip, __construct)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxRichToolTip::__construct\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxRichToolTip* current_object;
	wxRichToolTip_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	int arguments_received = ZEND_NUM_ARGS();
	
	
	//Parameters for overload 0
	char* title0;
	long title_len0;
	char* message0;
	long message_len0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'ss' (&title0, &title_len0, &message0, &message_len0)\n");
		#endif

		char parse_parameters_string[] = "ss";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &title0, &title_len0, &message0, &message_len0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct(wxString(title0, wxConvUTF8), wxString(message0, wxConvUTF8))\n");
				#endif

				native_object = new wxRichToolTip_php(wxString(title0, wxConvUTF8), wxString(message0, wxConvUTF8));

				native_object->references.Initialize();
				break;
			}
		}
	}

		
	if(already_called)
	{
		native_object->phpObj = getThis();
		

		current_object = (zo_wxRichToolTip*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		current_object->native_object = native_object;
		
		current_object->is_user_initialized = 1;
		
		#ifdef ZTS 
		native_object->TSRMLS_C = TSRMLS_C;
		#endif
	}
	else
	{
		zend_error(E_ERROR, "Abstract class or wrong type/count of parameters passed to: wxRichToolTip::__construct\n");
	}
	
	#ifdef USE_WXPHP_DEBUG
		php_printf("===========================================\n\n");
	#endif
}
/* }}} */

BEGIN_EXTERN_C()
void php_wxScrolled_free(void *object TSRMLS_DC) 
{
    zo_wxScrolled* custom_object = (zo_wxScrolled*) object;
    
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxScrolled_free on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	if(custom_object->native_object != NULL)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Pointer not null\n");
		php_printf("Pointer address %x\n", (unsigned int)(size_t)custom_object->native_object);
		#endif
		
		if(custom_object->is_user_initialized)
		{
			#ifdef USE_WXPHP_DEBUG
			php_printf("Deleting pointer with delete\n");
			#endif
			
       
            delete custom_object->native_object;
			
			custom_object->native_object = NULL;
		}
		
		#ifdef USE_WXPHP_DEBUG
		php_printf("Deletion of wxScrolled done\n");
		php_printf("===========================================\n\n");
		#endif
	}
	else
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Not user space initialized\n");
		#endif
	}

	zend_object_std_dtor(&custom_object->zo TSRMLS_CC);
    efree(custom_object);
}

zend_object_value php_wxScrolled_new(zend_class_entry *class_type TSRMLS_DC)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxScrolled_new on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	zval *temp;
    zend_object_value retval;
    zo_wxScrolled* custom_object;
    custom_object = (zo_wxScrolled*) emalloc(sizeof(zo_wxScrolled));

    zend_object_std_init(&custom_object->zo, class_type TSRMLS_CC);

#if PHP_VERSION_ID < 50399
	ALLOC_HASHTABLE(custom_object->zo.properties);
    zend_hash_init(custom_object->zo.properties, 0, NULL, ZVAL_PTR_DTOR, 0);
    zend_hash_copy(custom_object->zo.properties, &class_type->default_properties, (copy_ctor_func_t) zval_add_ref,(void *) &temp, sizeof(zval *));
#else
	object_properties_init(&custom_object->zo, class_type);
#endif

	retval.handle = zend_objects_store_put(custom_object, NULL, php_wxScrolled_free, NULL TSRMLS_CC);
	retval.handlers = zend_get_std_object_handlers();

    custom_object->native_object = NULL;
	custom_object->object_type = PHP_WXSCROLLED_TYPE;
	custom_object->is_user_initialized = 0;
	
    return retval;
}
END_EXTERN_C()

/* {{{ proto  wxScrolled::SetScrollRate(int xstep, int ystep)
   Set the horizontal and vertical scrolling increment only. */
PHP_METHOD(php_wxScrolled, SetScrollRate)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::SetScrollRate\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::SetScrollRate call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long xstep0;
	long ystep0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'll' (&xstep0, &ystep0)\n");
		#endif

		char parse_parameters_string[] = "ll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &xstep0, &ystep0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::SetScrollRate((int) xstep0, (int) ystep0)\n\n");
				#endif

				((wxScrolled_php*)native_object)->SetScrollRate((int) xstep0, (int) ystep0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::SetScrollRate\n");
	}
}
/* }}} */

/* {{{ proto  wxScrolled::SetScrollbars(int pixelsPerUnitX, int pixelsPerUnitY, int noUnitsX, int noUnitsY, int xPos, int yPos, bool noRefresh)
   Sets up vertical and/or horizontal scrollbars. */
PHP_METHOD(php_wxScrolled, SetScrollbars)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::SetScrollbars\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::SetScrollbars call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long pixelsPerUnitX0;
	long pixelsPerUnitY0;
	long noUnitsX0;
	long noUnitsY0;
	long xPos0;
	long yPos0;
	bool noRefresh0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 4  && arguments_received <= 7)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'llll|llb' (&pixelsPerUnitX0, &pixelsPerUnitY0, &noUnitsX0, &noUnitsY0, &xPos0, &yPos0, &noRefresh0)\n");
		#endif

		char parse_parameters_string[] = "llll|llb";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pixelsPerUnitX0, &pixelsPerUnitY0, &noUnitsX0, &noUnitsY0, &xPos0, &yPos0, &noRefresh0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::SetScrollbars((int) pixelsPerUnitX0, (int) pixelsPerUnitY0, (int) noUnitsX0, (int) noUnitsY0)\n\n");
				#endif

				((wxScrolled_php*)native_object)->SetScrollbars((int) pixelsPerUnitX0, (int) pixelsPerUnitY0, (int) noUnitsX0, (int) noUnitsY0);


				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::SetScrollbars((int) pixelsPerUnitX0, (int) pixelsPerUnitY0, (int) noUnitsX0, (int) noUnitsY0, (int) xPos0)\n\n");
				#endif

				((wxScrolled_php*)native_object)->SetScrollbars((int) pixelsPerUnitX0, (int) pixelsPerUnitY0, (int) noUnitsX0, (int) noUnitsY0, (int) xPos0);


				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::SetScrollbars((int) pixelsPerUnitX0, (int) pixelsPerUnitY0, (int) noUnitsX0, (int) noUnitsY0, (int) xPos0, (int) yPos0)\n\n");
				#endif

				((wxScrolled_php*)native_object)->SetScrollbars((int) pixelsPerUnitX0, (int) pixelsPerUnitY0, (int) noUnitsX0, (int) noUnitsY0, (int) xPos0, (int) yPos0);


				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::SetScrollbars((int) pixelsPerUnitX0, (int) pixelsPerUnitY0, (int) noUnitsX0, (int) noUnitsY0, (int) xPos0, (int) yPos0, noRefresh0)\n\n");
				#endif

				((wxScrolled_php*)native_object)->SetScrollbars((int) pixelsPerUnitX0, (int) pixelsPerUnitY0, (int) noUnitsX0, (int) noUnitsY0, (int) xPos0, (int) yPos0, noRefresh0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::SetScrollbars\n");
	}
}
/* }}} */

/* {{{ proto  wxScrolled::SetTargetRect(wxRect rect) */
PHP_METHOD(php_wxScrolled, SetTargetRect)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::SetTargetRect\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::SetTargetRect call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* rect0 = 0;
	wxRect* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&rect0, php_wxRect_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &rect0, php_wxRect_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(rect0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxRect*) zend_object_store_get_object(rect0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxRect*) zend_object_store_get_object(rect0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxRect*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'rect' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(rect0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'rect' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::SetTargetRect(*(wxRect*) object_pointer0_0)\n\n");
				#endif

				((wxScrolled_php*)native_object)->SetTargetRect(*(wxRect*) object_pointer0_0);

				references->AddReference(rect0, "wxScrolled::SetTargetRect at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::SetTargetRect\n");
	}
}
/* }}} */

/* {{{ proto  wxScrolled::SetTargetWindow(wxWindow &window)
   Call this function to tell wxScrolled to perform the actual scrolling on a different window (and not on itself). */
PHP_METHOD(php_wxScrolled, SetTargetWindow)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::SetTargetWindow\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::SetTargetWindow call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* window0 = 0;
	wxWindow* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&window0)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &window0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(window0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(window0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(window0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'window' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(window0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'window' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::SetTargetWindow((wxWindow*) object_pointer0_0)\n\n");
				#endif

				((wxScrolled_php*)native_object)->SetTargetWindow((wxWindow*) object_pointer0_0);

				references->AddReference(window0, "wxScrolled::SetTargetWindow at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::SetTargetWindow\n");
	}
}
/* }}} */

/* {{{ proto  wxScrolled::ShowScrollbars(wxScrollbarVisibility horz, wxScrollbarVisibility vert)
   Set the scrollbar visibility. */
PHP_METHOD(php_wxScrolled, ShowScrollbars)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::ShowScrollbars\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::ShowScrollbars call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long horz0;
	long vert0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'll' (&horz0, &vert0)\n");
		#endif

		char parse_parameters_string[] = "ll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &horz0, &vert0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::ShowScrollbars((wxScrollbarVisibility) horz0, (wxScrollbarVisibility) vert0)\n\n");
				#endif

				((wxScrolled_php*)native_object)->ShowScrollbars((wxScrollbarVisibility) horz0, (wxScrollbarVisibility) vert0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::ShowScrollbars\n");
	}
}
/* }}} */

/* {{{ proto  wxScrolled::StopAutoScrolling()
   Stop generating the scroll events when mouse is held outside the window. */
PHP_METHOD(php_wxScrolled, StopAutoScrolling)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::StopAutoScrolling\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::StopAutoScrolling call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::StopAutoScrolling()\n\n");
				#endif

				((wxScrolled_php*)native_object)->StopAutoScrolling();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::StopAutoScrolling\n");
	}
}
/* }}} */

/* {{{ proto  wxScrolled::SetScrollPageSize(int orient, int pageSize) */
PHP_METHOD(php_wxScrolled, SetScrollPageSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::SetScrollPageSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::SetScrollPageSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long orient0;
	long pageSize0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'll' (&orient0, &pageSize0)\n");
		#endif

		char parse_parameters_string[] = "ll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &orient0, &pageSize0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::SetScrollPageSize((int) orient0, (int) pageSize0)\n\n");
				#endif

				((wxScrolled_php*)native_object)->SetScrollPageSize((int) orient0, (int) pageSize0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::SetScrollPageSize\n");
	}
}
/* }}} */

/* {{{ proto  wxScrolled::SetScale(float xs, float ys) */
PHP_METHOD(php_wxScrolled, SetScale)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::SetScale\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::SetScale call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	double xs0;
	double ys0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'dd' (&xs0, &ys0)\n");
		#endif

		char parse_parameters_string[] = "dd";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &xs0, &ys0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::SetScale(xs0, ys0)\n\n");
				#endif

				((wxScrolled_php*)native_object)->SetScale(xs0, ys0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::SetScale\n");
	}
}
/* }}} */

/* {{{ proto  wxScrolled::Scroll(wxPoint pt)
   This is an overload of Scroll(int,int); see that function for more info. */
PHP_METHOD(php_wxScrolled, Scroll)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::Scroll\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::Scroll call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* pt0 = 0;
	wxPoint* object_pointer0_0 = 0;
	bool overload0_called = false;
	//Parameters for overload 1
	long x1;
	long y1;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&pt0, php_wxPoint_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pt0, php_wxPoint_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(pt0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pt0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pt0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxPoint*) argument_native_object;
					if (!object_pointer0_0 )
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(pt0) != IS_NULL)
				{
					goto overload1;
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'll' (&x1, &y1)\n");
		#endif

		char parse_parameters_string[] = "ll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &x1, &y1 ) == SUCCESS)
		{
			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::Scroll(*(wxPoint*) object_pointer0_0)\n\n");
				#endif

				((wxScrolled_php*)native_object)->Scroll(*(wxPoint*) object_pointer0_0);

				references->AddReference(pt0, "wxScrolled::Scroll at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::Scroll((int) x1, (int) y1)\n\n");
				#endif

				((wxScrolled_php*)native_object)->Scroll((int) x1, (int) y1);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::Scroll\n");
	}
}
/* }}} */

/* {{{ proto bool wxScrolled::SendAutoScrollEvents(wxScrollWinEvent &event)
   This method can be overridden in a derived class to forbid sending the auto scroll events - note that unlike StopAutoScrolling() it doesn't stop the timer, so it will be called repeatedly and will typically return different values depending on the current mouse position. */
PHP_METHOD(php_wxScrolled, SendAutoScrollEvents)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::SendAutoScrollEvents\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::SendAutoScrollEvents call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* event0 = 0;
	wxScrollWinEvent* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&event0, php_wxScrollWinEvent_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &event0, php_wxScrollWinEvent_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(event0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxScrollWinEvent*) zend_object_store_get_object(event0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxScrollWinEvent*) zend_object_store_get_object(event0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxScrollWinEvent*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'event' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(event0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'event' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxScrolled::SendAutoScrollEvents(*(wxScrollWinEvent*) object_pointer0_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxScrolled_php*)native_object)->SendAutoScrollEvents(*(wxScrollWinEvent*) object_pointer0_0));

				references->AddReference(event0, "wxScrolled::SendAutoScrollEvents at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::SendAutoScrollEvents\n");
	}
}
/* }}} */

/* {{{ proto  wxScrolled::PrepareDC(wxDC &dc)
   This function is for backwards compatibility only and simply calls DoPrepareDC() now. */
PHP_METHOD(php_wxScrolled, PrepareDC)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::PrepareDC\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::PrepareDC call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* dc0 = 0;
	wxDC* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'o' (&dc0)\n");
		#endif

		char parse_parameters_string[] = "o";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &dc0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(dc0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxDC*) zend_object_store_get_object(dc0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxDC*) zend_object_store_get_object(dc0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxDC*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXDC_TYPE && argument_type != PHP_WXWINDOWDC_TYPE && argument_type != PHP_WXCLIENTDC_TYPE && argument_type != PHP_WXPAINTDC_TYPE && argument_type != PHP_WXSCREENDC_TYPE && argument_type != PHP_WXPOSTSCRIPTDC_TYPE && argument_type != PHP_WXPRINTERDC_TYPE && argument_type != PHP_WXMEMORYDC_TYPE && argument_type != PHP_WXBUFFEREDDC_TYPE && argument_type != PHP_WXBUFFEREDPAINTDC_TYPE && argument_type != PHP_WXAUTOBUFFEREDPAINTDC_TYPE && argument_type != PHP_WXMIRRORDC_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'dc' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(dc0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'dc' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::PrepareDC(*(wxDC*) object_pointer0_0)\n\n");
				#endif

				((wxScrolled_php*)native_object)->PrepareDC(*(wxDC*) object_pointer0_0);

				references->AddReference(dc0, "wxScrolled::PrepareDC at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::PrepareDC\n");
	}
}
/* }}} */

/* {{{ proto  wxScrolled::OnDraw(wxDC &dc)
   Called by the default paint event handler to allow the application to define painting behaviour without having to worry about calling DoPrepareDC(). */
void wxScrolled_php::OnDraw(wxDC& dc)
{
	static zend_function* cached_function = NULL;
	static bool is_php_user_space_implemented = true;
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking virtual wxScrolled::OnDraw\n");
	php_printf("===========================================\n");
	#endif
	
	zval** params[1];
	zval *arguments[1];
	
	//Initilize arguments array
	for(int i=0; i<1; i++)
	{
		ALLOC_INIT_ZVAL(arguments[i]);
	}

	zval* return_value;
	MAKE_STD_ZVAL(return_value);
	zval function_name;
	ZVAL_STRING(&function_name, "OnDraw", 0);
	char* temp_string;
	void* return_object;
	int function_called;
	
	//Parameters for conversion
	object_init_ex(arguments[0], php_wxDC_entry);
	((zo_wxDC*) zend_object_store_get_object(arguments[0] TSRMLS_CC))->native_object = (wxDC_php*) &dc;
		
	for(int i=0; i<1; i++)
	{
		params[i] = &arguments[i];
	}

	#ifdef USE_WXPHP_DEBUG
	php_printf("Trying to call user defined method\n");
	#endif
	
	if(is_php_user_space_implemented)
	{
		function_called = wxphp_call_method((zval**) &this->phpObj, NULL, &cached_function, "OnDraw", 6, &return_value, 1, params TSRMLS_CC);
	}
	else
	{
		function_called = FAILURE;
	}
    
    	
	//Delete already used parameters from memory
	for(int i=0; i<1; i++)
	{
		zval_ptr_dtor(&arguments[i]);
	}
	
	if(function_called == FAILURE)
	{
		is_php_user_space_implemented = false;
		
		#ifdef USE_WXPHP_DEBUG
		php_printf("Invocation of user defined method failed\n");
		#endif
		
	}
	else
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Returning userspace value.\n");
		#endif
		
		return;
	}
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling original method\n");
	php_printf("===========================================\n\n");
	#endif
	
	//Call original method
	wxScrolled::OnDraw(dc);
}
/* }}} */

/* {{{ proto bool wxScrolled::IsRetained()
   Motif only: true if the window has a backing bitmap. */
PHP_METHOD(php_wxScrolled, IsRetained)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::IsRetained\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::IsRetained call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxScrolled::IsRetained())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxScrolled_php*)native_object)->IsRetained());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::IsRetained\n");
	}
}
/* }}} */

/* {{{ proto bool wxScrolled::IsAutoScrolling()
   Are we generating the autoscroll events? */
PHP_METHOD(php_wxScrolled, IsAutoScrolling)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::IsAutoScrolling\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::IsAutoScrolling call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxScrolled::IsAutoScrolling())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxScrolled_php*)native_object)->IsAutoScrolling());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::IsAutoScrolling\n");
	}
}
/* }}} */

/* {{{ proto wxPoint wxScrolled::GetViewStart()
   This is a simple overload of GetViewStart(int*,int*); see that function for more info. */
PHP_METHOD(php_wxScrolled, GetViewStart)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::GetViewStart\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::GetViewStart call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
	//Parameters for overload 1
	long* x1;
	zval* x1_ref;
	long* y1;
	zval* y1_ref;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'll' (x1, y1)\n");
		#endif

		char parse_parameters_string[] = "ll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, x1, y1 ) == SUCCESS)
		{
			overload1_called = true;
			already_called = true;

			char parse_references_string[] = "zz";
			zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_references_string, &x1_ref, &y1_ref );
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::GetViewStart() to return new object\n\n");
				#endif

				wxPoint value_to_return0;
				value_to_return0 = ((wxScrolled_php*)native_object)->GetViewStart();
				void* ptr = safe_emalloc(1, sizeof(wxPoint_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxPoint));
				object_init_ex(return_value, php_wxPoint_entry);
				((wxPoint_php*)ptr)->phpObj = return_value;
				((wxPoint_php*)ptr)->InitProperties();
				zo_wxPoint* zo0 = (zo_wxPoint*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxPoint_php*) ptr;


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::GetViewStart((int*) x1, (int*) y1)\n\n");
				#endif

				((wxScrolled_php*)native_object)->GetViewStart((int*) x1, (int*) y1);

				size_t elements_returned1_0 = sizeof(x1)/sizeof(*x1);
				array_init(x1_ref);
				for(size_t i=0; i<elements_returned1_0; i++)
				{
					add_next_index_long(x1_ref, x1[i]);
				}
				size_t elements_returned1_1 = sizeof(y1)/sizeof(*y1);
				array_init(y1_ref);
				for(size_t i=0; i<elements_returned1_1; i++)
				{
					add_next_index_long(y1_ref, y1[i]);
				}

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::GetViewStart\n");
	}
}
/* }}} */

/* {{{ proto  wxScrolled::GetVirtualSize(int &x, int &y)
   Gets the size in device units of the scrollable window area (as opposed to the client size, which is the area of the window currently visible). */
PHP_METHOD(php_wxScrolled, GetVirtualSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::GetVirtualSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::GetVirtualSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long* x0;
	zval* x0_ref;
	long* y0;
	zval* y0_ref;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'll' (x0, y0)\n");
		#endif

		char parse_parameters_string[] = "ll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, x0, y0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;

			char parse_references_string[] = "zz";
			zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_references_string, &x0_ref, &y0_ref );
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::GetVirtualSize((int*) x0, (int*) y0)\n\n");
				#endif

				((wxScrolled_php*)native_object)->GetVirtualSize((int*) x0, (int*) y0);

				size_t elements_returned0_0 = sizeof(x0)/sizeof(*x0);
				array_init(x0_ref);
				for(size_t i=0; i<elements_returned0_0; i++)
				{
					add_next_index_long(x0_ref, x0[i]);
				}
				size_t elements_returned0_1 = sizeof(y0)/sizeof(*y0);
				array_init(y0_ref);
				for(size_t i=0; i<elements_returned0_1; i++)
				{
					add_next_index_long(y0_ref, y0[i]);
				}

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::GetVirtualSize\n");
	}
}
/* }}} */

/* {{{ proto wxWindow wxScrolled::GetTargetWindow() */
PHP_METHOD(php_wxScrolled, GetTargetWindow)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::GetTargetWindow\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::GetTargetWindow call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::GetTargetWindow() to return object pointer\n\n");
				#endif

				wxWindow_php* value_to_return0;
				value_to_return0 = (wxWindow_php*) ((wxScrolled_php*)native_object)->GetTargetWindow();

				if(value_to_return0 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return0->references.IsUserInitialized()){
					if(value_to_return0->phpObj != NULL){
						*return_value = *value_to_return0->phpObj;
						zval_add_ref(&value_to_return0->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxWindow_entry);
					((zo_wxWindow*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxWindow_php*) value_to_return0;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return0 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxScrolled::GetTargetWindow at call with 0 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::GetTargetWindow\n");
	}
}
/* }}} */

/* {{{ proto wxRect wxScrolled::GetTargetRect() */
PHP_METHOD(php_wxScrolled, GetTargetRect)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::GetTargetRect\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::GetTargetRect call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::GetTargetRect() to return new object\n\n");
				#endif

				wxRect value_to_return0;
				value_to_return0 = ((wxScrolled_php*)native_object)->GetTargetRect();
				void* ptr = safe_emalloc(1, sizeof(wxRect_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxRect));
				object_init_ex(return_value, php_wxRect_entry);
				((wxRect_php*)ptr)->phpObj = return_value;
				((wxRect_php*)ptr)->InitProperties();
				zo_wxRect* zo0 = (zo_wxRect*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxRect_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::GetTargetRect\n");
	}
}
/* }}} */

/* {{{ proto wxSize wxScrolled::GetSizeAvailableForScrollTarget(wxSize size)
   Function which must be overridden to implement the size available for the scroll target for the given size of the main window. */
wxSize wxScrolled_php::GetSizeAvailableForScrollTarget(const wxSize& size)
{
	static zend_function* cached_function = NULL;
	static bool is_php_user_space_implemented = true;
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking virtual wxScrolled::GetSizeAvailableForScrollTarget\n");
	php_printf("===========================================\n");
	#endif
	
	zval** params[1];
	zval *arguments[1];
	
	//Initilize arguments array
	for(int i=0; i<1; i++)
	{
		ALLOC_INIT_ZVAL(arguments[i]);
	}

	zval* return_value;
	MAKE_STD_ZVAL(return_value);
	zval function_name;
	ZVAL_STRING(&function_name, "GetSizeAvailableForScrollTarget", 0);
	char* temp_string;
	void* return_object;
	int function_called;
	
	//Parameters for conversion
	object_init_ex(arguments[0], php_wxSize_entry);
	((zo_wxSize*) zend_object_store_get_object(arguments[0] TSRMLS_CC))->native_object = (wxSize_php*) &size;
		
	for(int i=0; i<1; i++)
	{
		params[i] = &arguments[i];
	}

	#ifdef USE_WXPHP_DEBUG
	php_printf("Trying to call user defined method\n");
	#endif
	
	if(is_php_user_space_implemented)
	{
		function_called = wxphp_call_method((zval**) &this->phpObj, NULL, &cached_function, "GetSizeAvailableForScrollTarget", 31, &return_value, 1, params TSRMLS_CC);
	}
	else
	{
		function_called = FAILURE;
	}
    
    	
	//Delete already used parameters from memory
	for(int i=0; i<1; i++)
	{
		zval_ptr_dtor(&arguments[i]);
	}
	
	if(function_called == FAILURE)
	{
		is_php_user_space_implemented = false;
		
		#ifdef USE_WXPHP_DEBUG
		php_printf("Invocation of user defined method failed\n");
		#endif
		
	}
	else
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Returning userspace value.\n");
		#endif
		
		if(Z_TYPE_P(return_value) == IS_OBJECT)
	{
		return_object = (void*) ((zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object;
	}

	//Threat it as a normal object on the calling function and not a php user space intiialized one
	((zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC))->is_user_initialized = 0;
	wxSize_php* var = (wxSize_php*) return_object;
	var->references.UnInitialize();

	return *(wxSize*) return_object;
	}
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling original method\n");
	php_printf("===========================================\n\n");
	#endif
	
	//Call original method
	return wxScrolled::GetSizeAvailableForScrollTarget(size);
}
/* }}} */

/* {{{ proto  wxScrolled::GetScrollPixelsPerUnit(int &xUnit, int &yUnit)
   Get the number of pixels per scroll unit (line), in each direction, as set by SetScrollbars(). */
PHP_METHOD(php_wxScrolled, GetScrollPixelsPerUnit)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::GetScrollPixelsPerUnit\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::GetScrollPixelsPerUnit call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long* xUnit0;
	zval* xUnit0_ref;
	long* yUnit0;
	zval* yUnit0_ref;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'll' (xUnit0, yUnit0)\n");
		#endif

		char parse_parameters_string[] = "ll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, xUnit0, yUnit0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;

			char parse_references_string[] = "zz";
			zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_references_string, &xUnit0_ref, &yUnit0_ref );
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::GetScrollPixelsPerUnit((int*) xUnit0, (int*) yUnit0)\n\n");
				#endif

				((wxScrolled_php*)native_object)->GetScrollPixelsPerUnit((int*) xUnit0, (int*) yUnit0);

				size_t elements_returned0_0 = sizeof(xUnit0)/sizeof(*xUnit0);
				array_init(xUnit0_ref);
				for(size_t i=0; i<elements_returned0_0; i++)
				{
					add_next_index_long(xUnit0_ref, xUnit0[i]);
				}
				size_t elements_returned0_1 = sizeof(yUnit0)/sizeof(*yUnit0);
				array_init(yUnit0_ref);
				for(size_t i=0; i<elements_returned0_1; i++)
				{
					add_next_index_long(yUnit0_ref, yUnit0[i]);
				}

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::GetScrollPixelsPerUnit\n");
	}
}
/* }}} */

/* {{{ proto int wxScrolled::GetScrollPageSize(int orient) */
PHP_METHOD(php_wxScrolled, GetScrollPageSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::GetScrollPageSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::GetScrollPageSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long orient0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&orient0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &orient0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxScrolled::GetScrollPageSize((int) orient0))\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxScrolled_php*)native_object)->GetScrollPageSize((int) orient0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::GetScrollPageSize\n");
	}
}
/* }}} */

/* {{{ proto int wxScrolled::GetScrollLines(int orient) */
PHP_METHOD(php_wxScrolled, GetScrollLines)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::GetScrollLines\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::GetScrollLines call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long orient0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&orient0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &orient0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxScrolled::GetScrollLines((int) orient0))\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxScrolled_php*)native_object)->GetScrollLines((int) orient0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::GetScrollLines\n");
	}
}
/* }}} */

/* {{{ proto float wxScrolled::GetScaleY() */
PHP_METHOD(php_wxScrolled, GetScaleY)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::GetScaleY\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::GetScaleY call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxScrolled::GetScaleY())\n\n");
				#endif

				ZVAL_DOUBLE(return_value, ((wxScrolled_php*)native_object)->GetScaleY());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::GetScaleY\n");
	}
}
/* }}} */

/* {{{ proto float wxScrolled::GetScaleX() */
PHP_METHOD(php_wxScrolled, GetScaleX)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::GetScaleX\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::GetScaleX call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxScrolled::GetScaleX())\n\n");
				#endif

				ZVAL_DOUBLE(return_value, ((wxScrolled_php*)native_object)->GetScaleX());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::GetScaleX\n");
	}
}
/* }}} */

/* {{{ proto  wxScrolled::EnableScrolling(bool xScrolling, bool yScrolling)
   Enable or disable use of wxWindow::ScrollWindow() for scrolling. */
PHP_METHOD(php_wxScrolled, EnableScrolling)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::EnableScrolling\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::EnableScrolling call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool xScrolling0;
	bool yScrolling0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'bb' (&xScrolling0, &yScrolling0)\n");
		#endif

		char parse_parameters_string[] = "bb";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &xScrolling0, &yScrolling0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::EnableScrolling(xScrolling0, yScrolling0)\n\n");
				#endif

				((wxScrolled_php*)native_object)->EnableScrolling(xScrolling0, yScrolling0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::EnableScrolling\n");
	}
}
/* }}} */

/* {{{ proto  wxScrolled::DoPrepareDC(wxDC &dc)
   Call this function to prepare the device context for drawing a scrolled image. */
PHP_METHOD(php_wxScrolled, DoPrepareDC)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::DoPrepareDC\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::DoPrepareDC call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* dc0 = 0;
	wxDC* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'o' (&dc0)\n");
		#endif

		char parse_parameters_string[] = "o";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &dc0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(dc0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxDC*) zend_object_store_get_object(dc0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxDC*) zend_object_store_get_object(dc0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxDC*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXDC_TYPE && argument_type != PHP_WXWINDOWDC_TYPE && argument_type != PHP_WXCLIENTDC_TYPE && argument_type != PHP_WXPAINTDC_TYPE && argument_type != PHP_WXSCREENDC_TYPE && argument_type != PHP_WXPOSTSCRIPTDC_TYPE && argument_type != PHP_WXPRINTERDC_TYPE && argument_type != PHP_WXMEMORYDC_TYPE && argument_type != PHP_WXBUFFEREDDC_TYPE && argument_type != PHP_WXBUFFEREDPAINTDC_TYPE && argument_type != PHP_WXAUTOBUFFEREDPAINTDC_TYPE && argument_type != PHP_WXMIRRORDC_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'dc' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(dc0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'dc' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::DoPrepareDC(*(wxDC*) object_pointer0_0)\n\n");
				#endif

				((wxScrolled_php*)native_object)->DoPrepareDC(*(wxDC*) object_pointer0_0);

				references->AddReference(dc0, "wxScrolled::DoPrepareDC at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::DoPrepareDC\n");
	}
}
/* }}} */

/* {{{ proto  wxScrolled::DisableKeyboardScrolling()
   Disable use of keyboard keys for scrolling. */
PHP_METHOD(php_wxScrolled, DisableKeyboardScrolling)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::DisableKeyboardScrolling\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::DisableKeyboardScrolling call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::DisableKeyboardScrolling()\n\n");
				#endif

				((wxScrolled_php*)native_object)->DisableKeyboardScrolling();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::DisableKeyboardScrolling\n");
	}
}
/* }}} */

/* {{{ proto wxPoint wxScrolled::CalcUnscrolledPosition(wxPoint pt) */
PHP_METHOD(php_wxScrolled, CalcUnscrolledPosition)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::CalcUnscrolledPosition\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::CalcUnscrolledPosition call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* pt0 = 0;
	wxPoint* object_pointer0_0 = 0;
	bool overload0_called = false;
	//Parameters for overload 1
	long x1;
	long y1;
	long* xx1;
	zval* xx1_ref;
	long* yy1;
	zval* yy1_ref;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&pt0, php_wxPoint_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pt0, php_wxPoint_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(pt0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pt0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pt0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxPoint*) argument_native_object;
					if (!object_pointer0_0 )
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(pt0) != IS_NULL)
				{
					goto overload1;
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 4)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'llll' (&x1, &y1, xx1, yy1)\n");
		#endif

		char parse_parameters_string[] = "llll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &x1, &y1, xx1, yy1 ) == SUCCESS)
		{
			overload1_called = true;
			already_called = true;

			char parse_references_string[] = "zzzz";
			zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_references_string, &dummy, &dummy, &xx1_ref, &yy1_ref );
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::CalcUnscrolledPosition(*(wxPoint*) object_pointer0_0) to return new object\n\n");
				#endif

				wxPoint value_to_return1;
				value_to_return1 = ((wxScrolled_php*)native_object)->CalcUnscrolledPosition(*(wxPoint*) object_pointer0_0);
				void* ptr = safe_emalloc(1, sizeof(wxPoint_php), 0);
				memcpy(ptr, (void*) &value_to_return1, sizeof(wxPoint));
				object_init_ex(return_value, php_wxPoint_entry);
				((wxPoint_php*)ptr)->phpObj = return_value;
				((wxPoint_php*)ptr)->InitProperties();
				zo_wxPoint* zo1 = (zo_wxPoint*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo1->native_object = (wxPoint_php*) ptr;

				references->AddReference(pt0, "wxScrolled::CalcUnscrolledPosition at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::CalcUnscrolledPosition((int) x1, (int) y1, (int*) xx1, (int*) yy1)\n\n");
				#endif

				((wxScrolled_php*)native_object)->CalcUnscrolledPosition((int) x1, (int) y1, (int*) xx1, (int*) yy1);

				size_t elements_returned1_2 = sizeof(xx1)/sizeof(*xx1);
				array_init(xx1_ref);
				for(size_t i=0; i<elements_returned1_2; i++)
				{
					add_next_index_long(xx1_ref, xx1[i]);
				}
				size_t elements_returned1_3 = sizeof(yy1)/sizeof(*yy1);
				array_init(yy1_ref);
				for(size_t i=0; i<elements_returned1_3; i++)
				{
					add_next_index_long(yy1_ref, yy1[i]);
				}

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::CalcUnscrolledPosition\n");
	}
}
/* }}} */

/* {{{ proto wxPoint wxScrolled::CalcScrolledPosition(wxPoint pt) */
PHP_METHOD(php_wxScrolled, CalcScrolledPosition)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::CalcScrolledPosition\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::CalcScrolledPosition call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* pt0 = 0;
	wxPoint* object_pointer0_0 = 0;
	bool overload0_called = false;
	//Parameters for overload 1
	long x1;
	long y1;
	long* xx1;
	zval* xx1_ref;
	long* yy1;
	zval* yy1_ref;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&pt0, php_wxPoint_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pt0, php_wxPoint_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(pt0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pt0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pt0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxPoint*) argument_native_object;
					if (!object_pointer0_0 )
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(pt0) != IS_NULL)
				{
					goto overload1;
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 4)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'llll' (&x1, &y1, xx1, yy1)\n");
		#endif

		char parse_parameters_string[] = "llll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &x1, &y1, xx1, yy1 ) == SUCCESS)
		{
			overload1_called = true;
			already_called = true;

			char parse_references_string[] = "zzzz";
			zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_references_string, &dummy, &dummy, &xx1_ref, &yy1_ref );
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::CalcScrolledPosition(*(wxPoint*) object_pointer0_0) to return new object\n\n");
				#endif

				wxPoint value_to_return1;
				value_to_return1 = ((wxScrolled_php*)native_object)->CalcScrolledPosition(*(wxPoint*) object_pointer0_0);
				void* ptr = safe_emalloc(1, sizeof(wxPoint_php), 0);
				memcpy(ptr, (void*) &value_to_return1, sizeof(wxPoint));
				object_init_ex(return_value, php_wxPoint_entry);
				((wxPoint_php*)ptr)->phpObj = return_value;
				((wxPoint_php*)ptr)->InitProperties();
				zo_wxPoint* zo1 = (zo_wxPoint*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo1->native_object = (wxPoint_php*) ptr;

				references->AddReference(pt0, "wxScrolled::CalcScrolledPosition at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::CalcScrolledPosition((int) x1, (int) y1, (int*) xx1, (int*) yy1)\n\n");
				#endif

				((wxScrolled_php*)native_object)->CalcScrolledPosition((int) x1, (int) y1, (int*) xx1, (int*) yy1);

				size_t elements_returned1_2 = sizeof(xx1)/sizeof(*xx1);
				array_init(xx1_ref);
				for(size_t i=0; i<elements_returned1_2; i++)
				{
					add_next_index_long(xx1_ref, xx1[i]);
				}
				size_t elements_returned1_3 = sizeof(yy1)/sizeof(*yy1);
				array_init(yy1_ref);
				for(size_t i=0; i<elements_returned1_3; i++)
				{
					add_next_index_long(yy1_ref, yy1[i]);
				}

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::CalcScrolledPosition\n");
	}
}
/* }}} */

/* {{{ proto  wxScrolled::AdjustScrollbars() */
PHP_METHOD(php_wxScrolled, AdjustScrollbars)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::AdjustScrollbars\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxphp_object_type current_object_type;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxScrolled::AdjustScrollbars call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSCROLLED_TYPE){
				references = &((wxScrolled_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxScrolled::AdjustScrollbars()\n\n");
				#endif

				((wxScrolled_php*)native_object)->AdjustScrollbars();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxScrolled::AdjustScrollbars\n");
	}
}
/* }}} */

/* {{{ proto  wxScrolled::wxScrolled()
   Default constructor. */
PHP_METHOD(php_wxScrolled, __construct)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxScrolled::__construct\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxScrolled* current_object;
	wxScrolled_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	int arguments_received = ZEND_NUM_ARGS();
	
	
	//Parameters for overload 0
	bool overload0_called = false;
	//Parameters for overload 1
	zval* parent1 = 0;
	wxWindow* object_pointer1_0 = 0;
	long id1;
	zval* pos1 = 0;
	wxPoint* object_pointer1_2 = 0;
	zval* size1 = 0;
	wxSize* object_pointer1_3 = 0;
	long style1;
	char* name1;
	long name_len1;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received >= 1  && arguments_received <= 6)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lOOls' (&parent1, &id1, &pos1, php_wxPoint_entry, &size1, php_wxSize_entry, &style1, &name1, &name_len1)\n");
		#endif

		char parse_parameters_string[] = "z|lOOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent1, &id1, &pos1, php_wxPoint_entry, &size1, php_wxSize_entry, &style1, &name1, &name_len1 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxWindow*) argument_native_object;
					if (!object_pointer1_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos1 TSRMLS_CC))->native_object;
					object_pointer1_2 = (wxPoint*) argument_native_object;
					if (!object_pointer1_2 )
					{
						zend_error(E_ERROR, "Parameter 'pos' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(pos1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'pos' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->native_object;
					object_pointer1_3 = (wxSize*) argument_native_object;
					if (!object_pointer1_3 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct()\n");
				#endif

				native_object = new wxScrolled_php();

				native_object->references.Initialize();
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0)\n");
				#endif

				native_object = new wxScrolled_php((wxWindow*) object_pointer1_0);

				native_object->references.Initialize();
				((wxScrolled_php*) native_object)->references.AddReference(parent1, "wxScrolled::wxScrolled at call with 1 argument(s)");
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1)\n");
				#endif

				native_object = new wxScrolled_php((wxWindow*) object_pointer1_0, (wxWindowID) id1);

				native_object->references.Initialize();
				((wxScrolled_php*) native_object)->references.AddReference(parent1, "wxScrolled::wxScrolled at call with 2 argument(s)");
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2)\n");
				#endif

				native_object = new wxScrolled_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2);

				native_object->references.Initialize();
				((wxScrolled_php*) native_object)->references.AddReference(parent1, "wxScrolled::wxScrolled at call with 3 argument(s)");
				((wxScrolled_php*) native_object)->references.AddReference(pos1, "wxScrolled::wxScrolled at call with 3 argument(s)");
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3)\n");
				#endif

				native_object = new wxScrolled_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3);

				native_object->references.Initialize();
				((wxScrolled_php*) native_object)->references.AddReference(parent1, "wxScrolled::wxScrolled at call with 4 argument(s)");
				((wxScrolled_php*) native_object)->references.AddReference(pos1, "wxScrolled::wxScrolled at call with 4 argument(s)");
				((wxScrolled_php*) native_object)->references.AddReference(size1, "wxScrolled::wxScrolled at call with 4 argument(s)");
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1)\n");
				#endif

				native_object = new wxScrolled_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1);

				native_object->references.Initialize();
				((wxScrolled_php*) native_object)->references.AddReference(parent1, "wxScrolled::wxScrolled at call with 5 argument(s)");
				((wxScrolled_php*) native_object)->references.AddReference(pos1, "wxScrolled::wxScrolled at call with 5 argument(s)");
				((wxScrolled_php*) native_object)->references.AddReference(size1, "wxScrolled::wxScrolled at call with 5 argument(s)");
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1, wxString(name1, wxConvUTF8))\n");
				#endif

				native_object = new wxScrolled_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1, wxString(name1, wxConvUTF8));

				native_object->references.Initialize();
				((wxScrolled_php*) native_object)->references.AddReference(parent1, "wxScrolled::wxScrolled at call with 6 argument(s)");
				((wxScrolled_php*) native_object)->references.AddReference(pos1, "wxScrolled::wxScrolled at call with 6 argument(s)");
				((wxScrolled_php*) native_object)->references.AddReference(size1, "wxScrolled::wxScrolled at call with 6 argument(s)");
				break;
			}
		}
	}

		
	if(already_called)
	{
		native_object->phpObj = getThis();
		

		current_object = (zo_wxScrolled*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		current_object->native_object = native_object;
		
		current_object->is_user_initialized = 1;
		
		#ifdef ZTS 
		native_object->TSRMLS_C = TSRMLS_C;
		#endif
	}
	else
	{
		zend_error(E_ERROR, "Abstract class or wrong type/count of parameters passed to: wxScrolled::__construct\n");
	}
	
	#ifdef USE_WXPHP_DEBUG
		php_printf("===========================================\n\n");
	#endif
}
/* }}} */

BEGIN_EXTERN_C()
void php_wxSashLayoutWindow_free(void *object TSRMLS_DC) 
{
    zo_wxSashLayoutWindow* custom_object = (zo_wxSashLayoutWindow*) object;
    
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxSashLayoutWindow_free on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	if(custom_object->native_object != NULL)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Pointer not null\n");
		php_printf("Pointer address %x\n", (unsigned int)(size_t)custom_object->native_object);
		#endif
		
		if(custom_object->is_user_initialized)
		{
	
			#ifdef USE_WXPHP_DEBUG
			php_printf("Deleting object by calling destroy and delete\n");
			#endif
			
			custom_object->native_object->Destroy();
			delete custom_object->native_object;
			
			custom_object->native_object = NULL;
		}
		
		#ifdef USE_WXPHP_DEBUG
		php_printf("Deletion of wxSashLayoutWindow done\n");
		php_printf("===========================================\n\n");
		#endif
	}
	else
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Not user space initialized\n");
		#endif
	}

	zend_object_std_dtor(&custom_object->zo TSRMLS_CC);
    efree(custom_object);
}

zend_object_value php_wxSashLayoutWindow_new(zend_class_entry *class_type TSRMLS_DC)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxSashLayoutWindow_new on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	zval *temp;
    zend_object_value retval;
    zo_wxSashLayoutWindow* custom_object;
    custom_object = (zo_wxSashLayoutWindow*) emalloc(sizeof(zo_wxSashLayoutWindow));

    zend_object_std_init(&custom_object->zo, class_type TSRMLS_CC);

#if PHP_VERSION_ID < 50399
	ALLOC_HASHTABLE(custom_object->zo.properties);
    zend_hash_init(custom_object->zo.properties, 0, NULL, ZVAL_PTR_DTOR, 0);
    zend_hash_copy(custom_object->zo.properties, &class_type->default_properties, (copy_ctor_func_t) zval_add_ref,(void *) &temp, sizeof(zval *));
#else
	object_properties_init(&custom_object->zo, class_type);
#endif

	retval.handle = zend_objects_store_put(custom_object, NULL, php_wxSashLayoutWindow_free, NULL TSRMLS_CC);
	retval.handlers = zend_get_std_object_handlers();

    custom_object->native_object = NULL;
	custom_object->object_type = PHP_WXSASHLAYOUTWINDOW_TYPE;
	custom_object->is_user_initialized = 0;
	
    return retval;
}
END_EXTERN_C()

/* {{{ proto bool wxSashLayoutWindow::Create(wxWindow &parent, int id, wxPoint pos, wxSize size, int style, string name)
   Initializes a sash layout window, which can be a child of a frame, dialog or any other non-control window. */
PHP_METHOD(php_wxSashLayoutWindow, Create)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSashLayoutWindow::Create\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSashLayoutWindow* current_object;
	wxphp_object_type current_object_type;
	wxSashLayoutWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSashLayoutWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSashLayoutWindow::Create call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* parent0 = 0;
	wxWindow* object_pointer0_0 = 0;
	long id0;
	zval* pos0 = 0;
	wxPoint* object_pointer0_2 = 0;
	zval* size0 = 0;
	wxSize* object_pointer0_3 = 0;
	long style0;
	char* name0;
	long name_len0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 6)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lOOls' (&parent0, &id0, &pos0, php_wxPoint_entry, &size0, php_wxSize_entry, &style0, &name0, &name_len0)\n");
		#endif

		char parse_parameters_string[] = "z|lOOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent0, &id0, &pos0, php_wxPoint_entry, &size0, php_wxSize_entry, &style0, &name0, &name_len0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos0 TSRMLS_CC))->native_object;
					object_pointer0_2 = (wxPoint*) argument_native_object;
					if (!object_pointer0_2 )
					{
						zend_error(E_ERROR, "Parameter 'pos' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(pos0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'pos' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->native_object;
					object_pointer0_3 = (wxSize*) argument_native_object;
					if (!object_pointer0_3 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSashLayoutWindow::Create((wxWindow*) object_pointer0_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSashLayoutWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0));

				references->AddReference(parent0, "wxSashLayoutWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSashLayoutWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSashLayoutWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0));

				references->AddReference(parent0, "wxSashLayoutWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSashLayoutWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSashLayoutWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2));

				references->AddReference(parent0, "wxSashLayoutWindow::Create at call with 3 argument(s)");
				references->AddReference(pos0, "wxSashLayoutWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSashLayoutWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSashLayoutWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3));

				references->AddReference(parent0, "wxSashLayoutWindow::Create at call with 4 argument(s)");
				references->AddReference(pos0, "wxSashLayoutWindow::Create at call with 4 argument(s)");
				references->AddReference(size0, "wxSashLayoutWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSashLayoutWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSashLayoutWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0));

				references->AddReference(parent0, "wxSashLayoutWindow::Create at call with 5 argument(s)");
				references->AddReference(pos0, "wxSashLayoutWindow::Create at call with 5 argument(s)");
				references->AddReference(size0, "wxSashLayoutWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSashLayoutWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0, wxString(name0, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSashLayoutWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0, wxString(name0, wxConvUTF8)));

				references->AddReference(parent0, "wxSashLayoutWindow::Create at call with 6 argument(s)");
				references->AddReference(pos0, "wxSashLayoutWindow::Create at call with 6 argument(s)");
				references->AddReference(size0, "wxSashLayoutWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSashLayoutWindow::Create\n");
	}
}
/* }}} */

/* {{{ proto wxLayoutAlignment wxSashLayoutWindow::GetAlignment()
   Returns the alignment of the window: one of wxLAYOUT_TOP, wxLAYOUT_LEFT, wxLAYOUT_RIGHT, wxLAYOUT_BOTTOM. */
PHP_METHOD(php_wxSashLayoutWindow, GetAlignment)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSashLayoutWindow::GetAlignment\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSashLayoutWindow* current_object;
	wxphp_object_type current_object_type;
	wxSashLayoutWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSashLayoutWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSashLayoutWindow::GetAlignment call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxSashLayoutWindow::GetAlignment())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxSashLayoutWindow_php*)native_object)->GetAlignment());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSashLayoutWindow::GetAlignment\n");
	}
}
/* }}} */

/* {{{ proto wxLayoutOrientation wxSashLayoutWindow::GetOrientation()
   Returns the orientation of the window: one of wxLAYOUT_HORIZONTAL, wxLAYOUT_VERTICAL. */
PHP_METHOD(php_wxSashLayoutWindow, GetOrientation)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSashLayoutWindow::GetOrientation\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSashLayoutWindow* current_object;
	wxphp_object_type current_object_type;
	wxSashLayoutWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSashLayoutWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSashLayoutWindow::GetOrientation call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxSashLayoutWindow::GetOrientation())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxSashLayoutWindow_php*)native_object)->GetOrientation());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSashLayoutWindow::GetOrientation\n");
	}
}
/* }}} */

/* {{{ proto  wxSashLayoutWindow::SetAlignment(wxLayoutAlignment alignment)
   Sets the alignment of the window (which edge of the available parent client area the window is attached to). */
PHP_METHOD(php_wxSashLayoutWindow, SetAlignment)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSashLayoutWindow::SetAlignment\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSashLayoutWindow* current_object;
	wxphp_object_type current_object_type;
	wxSashLayoutWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSashLayoutWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSashLayoutWindow::SetAlignment call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long alignment0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&alignment0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &alignment0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxSashLayoutWindow::SetAlignment((wxLayoutAlignment) alignment0)\n\n");
				#endif

				((wxSashLayoutWindow_php*)native_object)->SetAlignment((wxLayoutAlignment) alignment0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSashLayoutWindow::SetAlignment\n");
	}
}
/* }}} */

/* {{{ proto  wxSashLayoutWindow::SetDefaultSize(wxSize size)
   Sets the default dimensions of the window. */
PHP_METHOD(php_wxSashLayoutWindow, SetDefaultSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSashLayoutWindow::SetDefaultSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSashLayoutWindow* current_object;
	wxphp_object_type current_object_type;
	wxSashLayoutWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSashLayoutWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSashLayoutWindow::SetDefaultSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* size0 = 0;
	wxSize* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&size0, php_wxSize_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &size0, php_wxSize_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(size0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxSize*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxSashLayoutWindow::SetDefaultSize(*(wxSize*) object_pointer0_0)\n\n");
				#endif

				((wxSashLayoutWindow_php*)native_object)->SetDefaultSize(*(wxSize*) object_pointer0_0);

				references->AddReference(size0, "wxSashLayoutWindow::SetDefaultSize at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSashLayoutWindow::SetDefaultSize\n");
	}
}
/* }}} */

/* {{{ proto  wxSashLayoutWindow::SetOrientation(wxLayoutOrientation orientation)
   Sets the orientation of the window (the direction the window will stretch in, to fill the available parent client area). */
PHP_METHOD(php_wxSashLayoutWindow, SetOrientation)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSashLayoutWindow::SetOrientation\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSashLayoutWindow* current_object;
	wxphp_object_type current_object_type;
	wxSashLayoutWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSashLayoutWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSashLayoutWindow::SetOrientation call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long orientation0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&orientation0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &orientation0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxSashLayoutWindow::SetOrientation((wxLayoutOrientation) orientation0)\n\n");
				#endif

				((wxSashLayoutWindow_php*)native_object)->SetOrientation((wxLayoutOrientation) orientation0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSashLayoutWindow::SetOrientation\n");
	}
}
/* }}} */

/* {{{ proto  wxSashLayoutWindow::wxSashLayoutWindow()
   Default ctor. */
PHP_METHOD(php_wxSashLayoutWindow, __construct)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSashLayoutWindow::__construct\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSashLayoutWindow* current_object;
	wxSashLayoutWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	int arguments_received = ZEND_NUM_ARGS();
	
	
	//Parameters for overload 0
	bool overload0_called = false;
	//Parameters for overload 1
	zval* parent1 = 0;
	wxWindow* object_pointer1_0 = 0;
	long id1;
	zval* pos1 = 0;
	wxPoint* object_pointer1_2 = 0;
	zval* size1 = 0;
	wxSize* object_pointer1_3 = 0;
	long style1;
	char* name1;
	long name_len1;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received >= 2  && arguments_received <= 6)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|OOls' (&parent1, &id1, &pos1, php_wxPoint_entry, &size1, php_wxSize_entry, &style1, &name1, &name_len1)\n");
		#endif

		char parse_parameters_string[] = "zl|OOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent1, &id1, &pos1, php_wxPoint_entry, &size1, php_wxSize_entry, &style1, &name1, &name_len1 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxWindow*) argument_native_object;
					if (!object_pointer1_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos1 TSRMLS_CC))->native_object;
					object_pointer1_2 = (wxPoint*) argument_native_object;
					if (!object_pointer1_2 )
					{
						zend_error(E_ERROR, "Parameter 'pos' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(pos1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'pos' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->native_object;
					object_pointer1_3 = (wxSize*) argument_native_object;
					if (!object_pointer1_3 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct()\n");
				#endif

				native_object = new wxSashLayoutWindow_php();

				native_object->references.Initialize();
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1)\n");
				#endif

				native_object = new wxSashLayoutWindow_php((wxWindow*) object_pointer1_0, (wxWindowID) id1);

				native_object->references.Initialize();
				((wxSashLayoutWindow_php*) native_object)->references.AddReference(parent1, "wxSashLayoutWindow::wxSashLayoutWindow at call with 2 argument(s)");
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2)\n");
				#endif

				native_object = new wxSashLayoutWindow_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2);

				native_object->references.Initialize();
				((wxSashLayoutWindow_php*) native_object)->references.AddReference(parent1, "wxSashLayoutWindow::wxSashLayoutWindow at call with 3 argument(s)");
				((wxSashLayoutWindow_php*) native_object)->references.AddReference(pos1, "wxSashLayoutWindow::wxSashLayoutWindow at call with 3 argument(s)");
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3)\n");
				#endif

				native_object = new wxSashLayoutWindow_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3);

				native_object->references.Initialize();
				((wxSashLayoutWindow_php*) native_object)->references.AddReference(parent1, "wxSashLayoutWindow::wxSashLayoutWindow at call with 4 argument(s)");
				((wxSashLayoutWindow_php*) native_object)->references.AddReference(pos1, "wxSashLayoutWindow::wxSashLayoutWindow at call with 4 argument(s)");
				((wxSashLayoutWindow_php*) native_object)->references.AddReference(size1, "wxSashLayoutWindow::wxSashLayoutWindow at call with 4 argument(s)");
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1)\n");
				#endif

				native_object = new wxSashLayoutWindow_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1);

				native_object->references.Initialize();
				((wxSashLayoutWindow_php*) native_object)->references.AddReference(parent1, "wxSashLayoutWindow::wxSashLayoutWindow at call with 5 argument(s)");
				((wxSashLayoutWindow_php*) native_object)->references.AddReference(pos1, "wxSashLayoutWindow::wxSashLayoutWindow at call with 5 argument(s)");
				((wxSashLayoutWindow_php*) native_object)->references.AddReference(size1, "wxSashLayoutWindow::wxSashLayoutWindow at call with 5 argument(s)");
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1, wxString(name1, wxConvUTF8))\n");
				#endif

				native_object = new wxSashLayoutWindow_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1, wxString(name1, wxConvUTF8));

				native_object->references.Initialize();
				((wxSashLayoutWindow_php*) native_object)->references.AddReference(parent1, "wxSashLayoutWindow::wxSashLayoutWindow at call with 6 argument(s)");
				((wxSashLayoutWindow_php*) native_object)->references.AddReference(pos1, "wxSashLayoutWindow::wxSashLayoutWindow at call with 6 argument(s)");
				((wxSashLayoutWindow_php*) native_object)->references.AddReference(size1, "wxSashLayoutWindow::wxSashLayoutWindow at call with 6 argument(s)");
				break;
			}
		}
	}

		
	if(already_called)
	{
		native_object->phpObj = getThis();
		

		current_object = (zo_wxSashLayoutWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		current_object->native_object = native_object;
		
		current_object->is_user_initialized = 1;
		
		#ifdef ZTS 
		native_object->TSRMLS_C = TSRMLS_C;
		#endif
	}
	else
	{
		zend_error(E_ERROR, "Abstract class or wrong type/count of parameters passed to: wxSashLayoutWindow::__construct\n");
	}
	
	#ifdef USE_WXPHP_DEBUG
		php_printf("===========================================\n\n");
	#endif
}
/* }}} */

BEGIN_EXTERN_C()
void php_wxPanel_free(void *object TSRMLS_DC) 
{
    zo_wxPanel* custom_object = (zo_wxPanel*) object;
    
	#ifdef USE_WXPHP_DEBUG
	php_printf("Obviate delete call for wxPanel on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n\n");
	#endif

	zend_object_std_dtor(&custom_object->zo TSRMLS_CC);
    efree(custom_object);
}

zend_object_value php_wxPanel_new(zend_class_entry *class_type TSRMLS_DC)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxPanel_new on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	zval *temp;
    zend_object_value retval;
    zo_wxPanel* custom_object;
    custom_object = (zo_wxPanel*) emalloc(sizeof(zo_wxPanel));

    zend_object_std_init(&custom_object->zo, class_type TSRMLS_CC);

#if PHP_VERSION_ID < 50399
	ALLOC_HASHTABLE(custom_object->zo.properties);
    zend_hash_init(custom_object->zo.properties, 0, NULL, ZVAL_PTR_DTOR, 0);
    zend_hash_copy(custom_object->zo.properties, &class_type->default_properties, (copy_ctor_func_t) zval_add_ref,(void *) &temp, sizeof(zval *));
#else
	object_properties_init(&custom_object->zo, class_type);
#endif

	retval.handle = zend_objects_store_put(custom_object, NULL, php_wxPanel_free, NULL TSRMLS_CC);
	retval.handlers = zend_get_std_object_handlers();

    custom_object->native_object = NULL;
	custom_object->object_type = PHP_WXPANEL_TYPE;
	custom_object->is_user_initialized = 0;
	
    return retval;
}
END_EXTERN_C()

/* {{{ proto bool wxPanel::AcceptsFocus()
   This method is overridden from wxWindow::AcceptsFocus() and returns true only if there is no child window in the panel which can accept the focus. */
PHP_METHOD(php_wxPanel, AcceptsFocus)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxPanel::AcceptsFocus\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxPanel* current_object;
	wxphp_object_type current_object_type;
	wxPanel_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxPanel*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxPanel::AcceptsFocus call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXPANEL_TYPE){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxPanel::AcceptsFocus())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxPanel_php*)native_object)->AcceptsFocus());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxPanel::AcceptsFocus\n");
	}
}
/* }}} */

/* {{{ proto bool wxPanel::Create(wxWindow &parent, int id, wxPoint pos, wxSize size, int style, string name)
   Used for two-step panel construction. */
PHP_METHOD(php_wxPanel, Create)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxPanel::Create\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxPanel* current_object;
	wxphp_object_type current_object_type;
	wxPanel_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxPanel*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxPanel::Create call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXPANEL_TYPE){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* parent0 = 0;
	wxWindow* object_pointer0_0 = 0;
	long id0;
	zval* pos0 = 0;
	wxPoint* object_pointer0_2 = 0;
	zval* size0 = 0;
	wxSize* object_pointer0_3 = 0;
	long style0;
	char* name0;
	long name_len0;
	bool overload0_called = false;
	//Parameters for overload 1
	zval* parent1 = 0;
	wxWindow* object_pointer1_0 = 0;
	long id1;
	char* label1;
	long label_len1;
	zval* pos1 = 0;
	wxPoint* object_pointer1_3 = 0;
	zval* size1 = 0;
	wxSize* object_pointer1_4 = 0;
	long style1;
	char* name1;
	long name_len1;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 6)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lOOls' (&parent0, &id0, &pos0, php_wxPoint_entry, &size0, php_wxSize_entry, &style0, &name0, &name_len0)\n");
		#endif

		char parse_parameters_string[] = "z|lOOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent0, &id0, &pos0, php_wxPoint_entry, &size0, php_wxSize_entry, &style0, &name0, &name_len0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(parent0) != IS_NULL)
				{
					goto overload1;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos0 TSRMLS_CC))->native_object;
					object_pointer0_2 = (wxPoint*) argument_native_object;
					if (!object_pointer0_2 )
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(pos0) != IS_NULL)
				{
					goto overload1;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->native_object;
					object_pointer0_3 = (wxSize*) argument_native_object;
					if (!object_pointer0_3 )
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(size0) != IS_NULL)
				{
					goto overload1;
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received >= 3  && arguments_received <= 7 && (current_object_type == PHP_WXEDITABLELISTBOX_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zls|OOls' (&parent1, &id1, &label1, &label_len1, &pos1, php_wxPoint_entry, &size1, php_wxSize_entry, &style1, &name1, &name_len1)\n");
		#endif

		char parse_parameters_string[] = "zls|OOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent1, &id1, &label1, &label_len1, &pos1, php_wxPoint_entry, &size1, php_wxSize_entry, &style1, &name1, &name_len1 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxWindow*) argument_native_object;
					if (!object_pointer1_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos1 TSRMLS_CC))->native_object;
					object_pointer1_3 = (wxPoint*) argument_native_object;
					if (!object_pointer1_3 )
					{
						zend_error(E_ERROR, "Parameter 'pos' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(pos1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'pos' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->native_object;
					object_pointer1_4 = (wxSize*) argument_native_object;
					if (!object_pointer1_4 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxPanel::Create((wxWindow*) object_pointer0_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxPanel_php*)native_object)->Create((wxWindow*) object_pointer0_0));

				references->AddReference(parent0, "wxPanel::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxPanel::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxPanel_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0));

				references->AddReference(parent0, "wxPanel::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxPanel::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxPanel_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2));

				references->AddReference(parent0, "wxPanel::Create at call with 3 argument(s)");
				references->AddReference(pos0, "wxPanel::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxPanel::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxPanel_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3));

				references->AddReference(parent0, "wxPanel::Create at call with 4 argument(s)");
				references->AddReference(pos0, "wxPanel::Create at call with 4 argument(s)");
				references->AddReference(size0, "wxPanel::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxPanel::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxPanel_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0));

				references->AddReference(parent0, "wxPanel::Create at call with 5 argument(s)");
				references->AddReference(pos0, "wxPanel::Create at call with 5 argument(s)");
				references->AddReference(size0, "wxPanel::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxPanel::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0, wxString(name0, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxPanel_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0, wxString(name0, wxConvUTF8)));

				references->AddReference(parent0, "wxPanel::Create at call with 6 argument(s)");
				references->AddReference(pos0, "wxPanel::Create at call with 6 argument(s)");
				references->AddReference(size0, "wxPanel::Create at call with 6 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxEditableListBox::Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(label1, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxEditableListBox_php*)native_object)->Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(label1, wxConvUTF8)));

				references->AddReference(parent1, "wxPanel::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxEditableListBox::Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(label1, wxConvUTF8), *(wxPoint*) object_pointer1_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxEditableListBox_php*)native_object)->Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(label1, wxConvUTF8), *(wxPoint*) object_pointer1_3));

				references->AddReference(parent1, "wxPanel::Create at call with 4 argument(s)");
				references->AddReference(pos1, "wxPanel::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxEditableListBox::Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(label1, wxConvUTF8), *(wxPoint*) object_pointer1_3, *(wxSize*) object_pointer1_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxEditableListBox_php*)native_object)->Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(label1, wxConvUTF8), *(wxPoint*) object_pointer1_3, *(wxSize*) object_pointer1_4));

				references->AddReference(parent1, "wxPanel::Create at call with 5 argument(s)");
				references->AddReference(pos1, "wxPanel::Create at call with 5 argument(s)");
				references->AddReference(size1, "wxPanel::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxEditableListBox::Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(label1, wxConvUTF8), *(wxPoint*) object_pointer1_3, *(wxSize*) object_pointer1_4, (long) style1))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxEditableListBox_php*)native_object)->Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(label1, wxConvUTF8), *(wxPoint*) object_pointer1_3, *(wxSize*) object_pointer1_4, (long) style1));

				references->AddReference(parent1, "wxPanel::Create at call with 6 argument(s)");
				references->AddReference(pos1, "wxPanel::Create at call with 6 argument(s)");
				references->AddReference(size1, "wxPanel::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxEditableListBox::Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(label1, wxConvUTF8), *(wxPoint*) object_pointer1_3, *(wxSize*) object_pointer1_4, (long) style1, wxString(name1, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxEditableListBox_php*)native_object)->Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(label1, wxConvUTF8), *(wxPoint*) object_pointer1_3, *(wxSize*) object_pointer1_4, (long) style1, wxString(name1, wxConvUTF8)));

				references->AddReference(parent1, "wxPanel::Create at call with 7 argument(s)");
				references->AddReference(pos1, "wxPanel::Create at call with 7 argument(s)");
				references->AddReference(size1, "wxPanel::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxPanel::Create\n");
	}
}
/* }}} */

/* {{{ proto  wxPanel::InitDialog()
   Sends a wxInitDialogEvent, which in turn transfers data to the dialog via validators. */
PHP_METHOD(php_wxPanel, InitDialog)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxPanel::InitDialog\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxPanel* current_object;
	wxphp_object_type current_object_type;
	wxPanel_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxPanel*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxPanel::InitDialog call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXPANEL_TYPE){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxPanel::InitDialog()\n\n");
				#endif

				((wxPanel_php*)native_object)->InitDialog();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxPanel::InitDialog\n");
	}
}
/* }}} */

/* {{{ proto bool wxPanel::Layout()
   See wxWindow::SetAutoLayout(): when auto layout is on, this function gets called automatically when the window is resized. */
PHP_METHOD(php_wxPanel, Layout)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxPanel::Layout\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxPanel* current_object;
	wxphp_object_type current_object_type;
	wxPanel_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxPanel*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxPanel::Layout call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXPANEL_TYPE){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxPanel::Layout())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxPanel_php*)native_object)->Layout());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxPanel::Layout\n");
	}
}
/* }}} */

/* {{{ proto  wxPanel::SetFocus()
   Overrides wxWindow::SetFocus(). */
PHP_METHOD(php_wxPanel, SetFocus)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxPanel::SetFocus\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxPanel* current_object;
	wxphp_object_type current_object_type;
	wxPanel_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxPanel*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxPanel::SetFocus call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXPANEL_TYPE){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxPanel::SetFocus()\n\n");
				#endif

				((wxPanel_php*)native_object)->SetFocus();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxPanel::SetFocus\n");
	}
}
/* }}} */

/* {{{ proto  wxPanel::SetFocusIgnoringChildren()
   In contrast to SetFocus() (see above) this will set the focus to the panel even if there are child windows in the panel. */
PHP_METHOD(php_wxPanel, SetFocusIgnoringChildren)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxPanel::SetFocusIgnoringChildren\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxPanel* current_object;
	wxphp_object_type current_object_type;
	wxPanel_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxPanel*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxPanel::SetFocusIgnoringChildren call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXPANEL_TYPE){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxPanel::SetFocusIgnoringChildren()\n\n");
				#endif

				((wxPanel_php*)native_object)->SetFocusIgnoringChildren();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxPanel::SetFocusIgnoringChildren\n");
	}
}
/* }}} */

/* {{{ proto  wxPanel::wxPanel()
   Default constructor. */
PHP_METHOD(php_wxPanel, __construct)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxPanel::__construct\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxPanel* current_object;
	wxPanel_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	int arguments_received = ZEND_NUM_ARGS();
	
	
	//Parameters for overload 0
	bool overload0_called = false;
	//Parameters for overload 1
	zval* parent1 = 0;
	wxWindow* object_pointer1_0 = 0;
	long id1;
	zval* pos1 = 0;
	wxPoint* object_pointer1_2 = 0;
	zval* size1 = 0;
	wxSize* object_pointer1_3 = 0;
	long style1;
	char* name1;
	long name_len1;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received >= 1  && arguments_received <= 6)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lOOls' (&parent1, &id1, &pos1, php_wxPoint_entry, &size1, php_wxSize_entry, &style1, &name1, &name_len1)\n");
		#endif

		char parse_parameters_string[] = "z|lOOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent1, &id1, &pos1, php_wxPoint_entry, &size1, php_wxSize_entry, &style1, &name1, &name_len1 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxWindow*) argument_native_object;
					if (!object_pointer1_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos1 TSRMLS_CC))->native_object;
					object_pointer1_2 = (wxPoint*) argument_native_object;
					if (!object_pointer1_2 )
					{
						zend_error(E_ERROR, "Parameter 'pos' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(pos1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'pos' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->native_object;
					object_pointer1_3 = (wxSize*) argument_native_object;
					if (!object_pointer1_3 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct()\n");
				#endif

				native_object = new wxPanel_php();

				native_object->references.Initialize();
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0)\n");
				#endif

				native_object = new wxPanel_php((wxWindow*) object_pointer1_0);

				native_object->references.Initialize();
				((wxPanel_php*) native_object)->references.AddReference(parent1, "wxPanel::wxPanel at call with 1 argument(s)");
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1)\n");
				#endif

				native_object = new wxPanel_php((wxWindow*) object_pointer1_0, (wxWindowID) id1);

				native_object->references.Initialize();
				((wxPanel_php*) native_object)->references.AddReference(parent1, "wxPanel::wxPanel at call with 2 argument(s)");
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2)\n");
				#endif

				native_object = new wxPanel_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2);

				native_object->references.Initialize();
				((wxPanel_php*) native_object)->references.AddReference(parent1, "wxPanel::wxPanel at call with 3 argument(s)");
				((wxPanel_php*) native_object)->references.AddReference(pos1, "wxPanel::wxPanel at call with 3 argument(s)");
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3)\n");
				#endif

				native_object = new wxPanel_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3);

				native_object->references.Initialize();
				((wxPanel_php*) native_object)->references.AddReference(parent1, "wxPanel::wxPanel at call with 4 argument(s)");
				((wxPanel_php*) native_object)->references.AddReference(pos1, "wxPanel::wxPanel at call with 4 argument(s)");
				((wxPanel_php*) native_object)->references.AddReference(size1, "wxPanel::wxPanel at call with 4 argument(s)");
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1)\n");
				#endif

				native_object = new wxPanel_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1);

				native_object->references.Initialize();
				((wxPanel_php*) native_object)->references.AddReference(parent1, "wxPanel::wxPanel at call with 5 argument(s)");
				((wxPanel_php*) native_object)->references.AddReference(pos1, "wxPanel::wxPanel at call with 5 argument(s)");
				((wxPanel_php*) native_object)->references.AddReference(size1, "wxPanel::wxPanel at call with 5 argument(s)");
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1, wxString(name1, wxConvUTF8))\n");
				#endif

				native_object = new wxPanel_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1, wxString(name1, wxConvUTF8));

				native_object->references.Initialize();
				((wxPanel_php*) native_object)->references.AddReference(parent1, "wxPanel::wxPanel at call with 6 argument(s)");
				((wxPanel_php*) native_object)->references.AddReference(pos1, "wxPanel::wxPanel at call with 6 argument(s)");
				((wxPanel_php*) native_object)->references.AddReference(size1, "wxPanel::wxPanel at call with 6 argument(s)");
				break;
			}
		}
	}

		
	if(already_called)
	{
		native_object->phpObj = getThis();
		

		current_object = (zo_wxPanel*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		current_object->native_object = native_object;
		
		current_object->is_user_initialized = 1;
		
		#ifdef ZTS 
		native_object->TSRMLS_C = TSRMLS_C;
		#endif
	}
	else
	{
		zend_error(E_ERROR, "Abstract class or wrong type/count of parameters passed to: wxPanel::__construct\n");
	}
	
	#ifdef USE_WXPHP_DEBUG
		php_printf("===========================================\n\n");
	#endif
}
/* }}} */

BEGIN_EXTERN_C()
void php_wxSashWindow_free(void *object TSRMLS_DC) 
{
    zo_wxSashWindow* custom_object = (zo_wxSashWindow*) object;
    
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxSashWindow_free on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	if(custom_object->native_object != NULL)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Pointer not null\n");
		php_printf("Pointer address %x\n", (unsigned int)(size_t)custom_object->native_object);
		#endif
		
		if(custom_object->is_user_initialized)
		{
	
			#ifdef USE_WXPHP_DEBUG
			php_printf("Deleting object by calling destroy and delete\n");
			#endif
			
			custom_object->native_object->Destroy();
			delete custom_object->native_object;
			
			custom_object->native_object = NULL;
		}
		
		#ifdef USE_WXPHP_DEBUG
		php_printf("Deletion of wxSashWindow done\n");
		php_printf("===========================================\n\n");
		#endif
	}
	else
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Not user space initialized\n");
		#endif
	}

	zend_object_std_dtor(&custom_object->zo TSRMLS_CC);
    efree(custom_object);
}

zend_object_value php_wxSashWindow_new(zend_class_entry *class_type TSRMLS_DC)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxSashWindow_new on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	zval *temp;
    zend_object_value retval;
    zo_wxSashWindow* custom_object;
    custom_object = (zo_wxSashWindow*) emalloc(sizeof(zo_wxSashWindow));

    zend_object_std_init(&custom_object->zo, class_type TSRMLS_CC);

#if PHP_VERSION_ID < 50399
	ALLOC_HASHTABLE(custom_object->zo.properties);
    zend_hash_init(custom_object->zo.properties, 0, NULL, ZVAL_PTR_DTOR, 0);
    zend_hash_copy(custom_object->zo.properties, &class_type->default_properties, (copy_ctor_func_t) zval_add_ref,(void *) &temp, sizeof(zval *));
#else
	object_properties_init(&custom_object->zo, class_type);
#endif

	retval.handle = zend_objects_store_put(custom_object, NULL, php_wxSashWindow_free, NULL TSRMLS_CC);
	retval.handlers = zend_get_std_object_handlers();

    custom_object->native_object = NULL;
	custom_object->object_type = PHP_WXSASHWINDOW_TYPE;
	custom_object->is_user_initialized = 0;
	
    return retval;
}
END_EXTERN_C()

/* {{{ proto int wxSashWindow::GetMaximumSizeX()
   Gets the maximum window size in the x direction. */
PHP_METHOD(php_wxSashWindow, GetMaximumSizeX)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSashWindow::GetMaximumSizeX\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSashWindow* current_object;
	wxphp_object_type current_object_type;
	wxSashWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSashWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSashWindow::GetMaximumSizeX call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSASHWINDOW_TYPE){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxSashWindow::GetMaximumSizeX())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxSashWindow_php*)native_object)->GetMaximumSizeX());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSashWindow::GetMaximumSizeX\n");
	}
}
/* }}} */

/* {{{ proto int wxSashWindow::GetMaximumSizeY()
   Gets the maximum window size in the y direction. */
PHP_METHOD(php_wxSashWindow, GetMaximumSizeY)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSashWindow::GetMaximumSizeY\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSashWindow* current_object;
	wxphp_object_type current_object_type;
	wxSashWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSashWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSashWindow::GetMaximumSizeY call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSASHWINDOW_TYPE){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxSashWindow::GetMaximumSizeY())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxSashWindow_php*)native_object)->GetMaximumSizeY());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSashWindow::GetMaximumSizeY\n");
	}
}
/* }}} */

/* {{{ proto int wxSashWindow::GetMinimumSizeX()
   Gets the minimum window size in the x direction. */
PHP_METHOD(php_wxSashWindow, GetMinimumSizeX)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSashWindow::GetMinimumSizeX\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSashWindow* current_object;
	wxphp_object_type current_object_type;
	wxSashWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSashWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSashWindow::GetMinimumSizeX call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSASHWINDOW_TYPE){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxSashWindow::GetMinimumSizeX())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxSashWindow_php*)native_object)->GetMinimumSizeX());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSashWindow::GetMinimumSizeX\n");
	}
}
/* }}} */

/* {{{ proto int wxSashWindow::GetMinimumSizeY()
   Gets the minimum window size in the y direction. */
PHP_METHOD(php_wxSashWindow, GetMinimumSizeY)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSashWindow::GetMinimumSizeY\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSashWindow* current_object;
	wxphp_object_type current_object_type;
	wxSashWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSashWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSashWindow::GetMinimumSizeY call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSASHWINDOW_TYPE){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxSashWindow::GetMinimumSizeY())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxSashWindow_php*)native_object)->GetMinimumSizeY());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSashWindow::GetMinimumSizeY\n");
	}
}
/* }}} */

/* {{{ proto bool wxSashWindow::GetSashVisible(wxSashEdgePosition edge)
   Returns true if a sash is visible on the given edge, false otherwise. */
PHP_METHOD(php_wxSashWindow, GetSashVisible)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSashWindow::GetSashVisible\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSashWindow* current_object;
	wxphp_object_type current_object_type;
	wxSashWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSashWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSashWindow::GetSashVisible call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSASHWINDOW_TYPE){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long edge0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&edge0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &edge0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSashWindow::GetSashVisible((wxSashEdgePosition) edge0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSashWindow_php*)native_object)->GetSashVisible((wxSashEdgePosition) edge0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSashWindow::GetSashVisible\n");
	}
}
/* }}} */

/* {{{ proto  wxSashWindow::SetMaximumSizeX(int min)
   Sets the maximum window size in the x direction. */
PHP_METHOD(php_wxSashWindow, SetMaximumSizeX)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSashWindow::SetMaximumSizeX\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSashWindow* current_object;
	wxphp_object_type current_object_type;
	wxSashWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSashWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSashWindow::SetMaximumSizeX call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSASHWINDOW_TYPE){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long min0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&min0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &min0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxSashWindow::SetMaximumSizeX((int) min0)\n\n");
				#endif

				((wxSashWindow_php*)native_object)->SetMaximumSizeX((int) min0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSashWindow::SetMaximumSizeX\n");
	}
}
/* }}} */

/* {{{ proto  wxSashWindow::SetMaximumSizeY(int min)
   Sets the maximum window size in the y direction. */
PHP_METHOD(php_wxSashWindow, SetMaximumSizeY)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSashWindow::SetMaximumSizeY\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSashWindow* current_object;
	wxphp_object_type current_object_type;
	wxSashWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSashWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSashWindow::SetMaximumSizeY call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSASHWINDOW_TYPE){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long min0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&min0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &min0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxSashWindow::SetMaximumSizeY((int) min0)\n\n");
				#endif

				((wxSashWindow_php*)native_object)->SetMaximumSizeY((int) min0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSashWindow::SetMaximumSizeY\n");
	}
}
/* }}} */

/* {{{ proto  wxSashWindow::SetMinimumSizeX(int min)
   Sets the minimum window size in the x direction. */
PHP_METHOD(php_wxSashWindow, SetMinimumSizeX)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSashWindow::SetMinimumSizeX\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSashWindow* current_object;
	wxphp_object_type current_object_type;
	wxSashWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSashWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSashWindow::SetMinimumSizeX call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSASHWINDOW_TYPE){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long min0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&min0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &min0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxSashWindow::SetMinimumSizeX((int) min0)\n\n");
				#endif

				((wxSashWindow_php*)native_object)->SetMinimumSizeX((int) min0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSashWindow::SetMinimumSizeX\n");
	}
}
/* }}} */

/* {{{ proto  wxSashWindow::SetMinimumSizeY(int min)
   Sets the minimum window size in the y direction. */
PHP_METHOD(php_wxSashWindow, SetMinimumSizeY)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSashWindow::SetMinimumSizeY\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSashWindow* current_object;
	wxphp_object_type current_object_type;
	wxSashWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSashWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSashWindow::SetMinimumSizeY call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSASHWINDOW_TYPE){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long min0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&min0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &min0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxSashWindow::SetMinimumSizeY((int) min0)\n\n");
				#endif

				((wxSashWindow_php*)native_object)->SetMinimumSizeY((int) min0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSashWindow::SetMinimumSizeY\n");
	}
}
/* }}} */

/* {{{ proto  wxSashWindow::SetSashVisible(wxSashEdgePosition edge, bool visible)
   Call this function to make a sash visible or invisible on a particular edge. */
PHP_METHOD(php_wxSashWindow, SetSashVisible)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSashWindow::SetSashVisible\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSashWindow* current_object;
	wxphp_object_type current_object_type;
	wxSashWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSashWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSashWindow::SetSashVisible call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSASHWINDOW_TYPE){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long edge0;
	bool visible0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'lb' (&edge0, &visible0)\n");
		#endif

		char parse_parameters_string[] = "lb";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &edge0, &visible0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxSashWindow::SetSashVisible((wxSashEdgePosition) edge0, visible0)\n\n");
				#endif

				((wxSashWindow_php*)native_object)->SetSashVisible((wxSashEdgePosition) edge0, visible0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSashWindow::SetSashVisible\n");
	}
}
/* }}} */

/* {{{ proto  wxSashWindow::wxSashWindow()
   Default ctor. */
PHP_METHOD(php_wxSashWindow, __construct)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSashWindow::__construct\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSashWindow* current_object;
	wxSashWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	int arguments_received = ZEND_NUM_ARGS();
	
	
	//Parameters for overload 0
	bool overload0_called = false;
	//Parameters for overload 1
	zval* parent1 = 0;
	wxWindow* object_pointer1_0 = 0;
	long id1;
	zval* pos1 = 0;
	wxPoint* object_pointer1_2 = 0;
	zval* size1 = 0;
	wxSize* object_pointer1_3 = 0;
	long style1;
	char* name1;
	long name_len1;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received >= 2  && arguments_received <= 6)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|OOls' (&parent1, &id1, &pos1, php_wxPoint_entry, &size1, php_wxSize_entry, &style1, &name1, &name_len1)\n");
		#endif

		char parse_parameters_string[] = "zl|OOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent1, &id1, &pos1, php_wxPoint_entry, &size1, php_wxSize_entry, &style1, &name1, &name_len1 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxWindow*) argument_native_object;
					if (!object_pointer1_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos1 TSRMLS_CC))->native_object;
					object_pointer1_2 = (wxPoint*) argument_native_object;
					if (!object_pointer1_2 )
					{
						zend_error(E_ERROR, "Parameter 'pos' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(pos1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'pos' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->native_object;
					object_pointer1_3 = (wxSize*) argument_native_object;
					if (!object_pointer1_3 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct()\n");
				#endif

				native_object = new wxSashWindow_php();

				native_object->references.Initialize();
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1)\n");
				#endif

				native_object = new wxSashWindow_php((wxWindow*) object_pointer1_0, (wxWindowID) id1);

				native_object->references.Initialize();
				((wxSashWindow_php*) native_object)->references.AddReference(parent1, "wxSashWindow::wxSashWindow at call with 2 argument(s)");
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2)\n");
				#endif

				native_object = new wxSashWindow_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2);

				native_object->references.Initialize();
				((wxSashWindow_php*) native_object)->references.AddReference(parent1, "wxSashWindow::wxSashWindow at call with 3 argument(s)");
				((wxSashWindow_php*) native_object)->references.AddReference(pos1, "wxSashWindow::wxSashWindow at call with 3 argument(s)");
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3)\n");
				#endif

				native_object = new wxSashWindow_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3);

				native_object->references.Initialize();
				((wxSashWindow_php*) native_object)->references.AddReference(parent1, "wxSashWindow::wxSashWindow at call with 4 argument(s)");
				((wxSashWindow_php*) native_object)->references.AddReference(pos1, "wxSashWindow::wxSashWindow at call with 4 argument(s)");
				((wxSashWindow_php*) native_object)->references.AddReference(size1, "wxSashWindow::wxSashWindow at call with 4 argument(s)");
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1)\n");
				#endif

				native_object = new wxSashWindow_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1);

				native_object->references.Initialize();
				((wxSashWindow_php*) native_object)->references.AddReference(parent1, "wxSashWindow::wxSashWindow at call with 5 argument(s)");
				((wxSashWindow_php*) native_object)->references.AddReference(pos1, "wxSashWindow::wxSashWindow at call with 5 argument(s)");
				((wxSashWindow_php*) native_object)->references.AddReference(size1, "wxSashWindow::wxSashWindow at call with 5 argument(s)");
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1, wxString(name1, wxConvUTF8))\n");
				#endif

				native_object = new wxSashWindow_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1, wxString(name1, wxConvUTF8));

				native_object->references.Initialize();
				((wxSashWindow_php*) native_object)->references.AddReference(parent1, "wxSashWindow::wxSashWindow at call with 6 argument(s)");
				((wxSashWindow_php*) native_object)->references.AddReference(pos1, "wxSashWindow::wxSashWindow at call with 6 argument(s)");
				((wxSashWindow_php*) native_object)->references.AddReference(size1, "wxSashWindow::wxSashWindow at call with 6 argument(s)");
				break;
			}
		}
	}

		
	if(already_called)
	{
		native_object->phpObj = getThis();
		

		current_object = (zo_wxSashWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		current_object->native_object = native_object;
		
		current_object->is_user_initialized = 1;
		
		#ifdef ZTS 
		native_object->TSRMLS_C = TSRMLS_C;
		#endif
	}
	else
	{
		zend_error(E_ERROR, "Abstract class or wrong type/count of parameters passed to: wxSashWindow::__construct\n");
	}
	
	#ifdef USE_WXPHP_DEBUG
		php_printf("===========================================\n\n");
	#endif
}
/* }}} */

BEGIN_EXTERN_C()
void php_wxSplitterWindow_free(void *object TSRMLS_DC) 
{
    zo_wxSplitterWindow* custom_object = (zo_wxSplitterWindow*) object;
    
	#ifdef USE_WXPHP_DEBUG
	php_printf("Obviate delete call for wxSplitterWindow on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n\n");
	#endif

	zend_object_std_dtor(&custom_object->zo TSRMLS_CC);
    efree(custom_object);
}

zend_object_value php_wxSplitterWindow_new(zend_class_entry *class_type TSRMLS_DC)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxSplitterWindow_new on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	zval *temp;
    zend_object_value retval;
    zo_wxSplitterWindow* custom_object;
    custom_object = (zo_wxSplitterWindow*) emalloc(sizeof(zo_wxSplitterWindow));

    zend_object_std_init(&custom_object->zo, class_type TSRMLS_CC);

#if PHP_VERSION_ID < 50399
	ALLOC_HASHTABLE(custom_object->zo.properties);
    zend_hash_init(custom_object->zo.properties, 0, NULL, ZVAL_PTR_DTOR, 0);
    zend_hash_copy(custom_object->zo.properties, &class_type->default_properties, (copy_ctor_func_t) zval_add_ref,(void *) &temp, sizeof(zval *));
#else
	object_properties_init(&custom_object->zo, class_type);
#endif

	retval.handle = zend_objects_store_put(custom_object, NULL, php_wxSplitterWindow_free, NULL TSRMLS_CC);
	retval.handlers = zend_get_std_object_handlers();

    custom_object->native_object = NULL;
	custom_object->object_type = PHP_WXSPLITTERWINDOW_TYPE;
	custom_object->is_user_initialized = 0;
	
    return retval;
}
END_EXTERN_C()

/* {{{ proto  wxSplitterWindow::wxSplitterWindow()
   Default constructor. */
PHP_METHOD(php_wxSplitterWindow, __construct)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::__construct\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	int arguments_received = ZEND_NUM_ARGS();
	
	
	//Parameters for overload 0
	bool overload0_called = false;
	//Parameters for overload 1
	zval* parent1 = 0;
	wxWindow* object_pointer1_0 = 0;
	long id1;
	zval* pos1 = 0;
	wxPoint* object_pointer1_2 = 0;
	zval* size1 = 0;
	wxSize* object_pointer1_3 = 0;
	long style1;
	char* name1;
	long name_len1;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received >= 1  && arguments_received <= 6)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lOOls' (&parent1, &id1, &pos1, php_wxPoint_entry, &size1, php_wxSize_entry, &style1, &name1, &name_len1)\n");
		#endif

		char parse_parameters_string[] = "z|lOOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent1, &id1, &pos1, php_wxPoint_entry, &size1, php_wxSize_entry, &style1, &name1, &name_len1 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxWindow*) argument_native_object;
					if (!object_pointer1_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos1 TSRMLS_CC))->native_object;
					object_pointer1_2 = (wxPoint*) argument_native_object;
					if (!object_pointer1_2 )
					{
						zend_error(E_ERROR, "Parameter 'pos' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(pos1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'pos' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->native_object;
					object_pointer1_3 = (wxSize*) argument_native_object;
					if (!object_pointer1_3 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct()\n");
				#endif

				native_object = new wxSplitterWindow_php();

				native_object->references.Initialize();
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0)\n");
				#endif

				native_object = new wxSplitterWindow_php((wxWindow*) object_pointer1_0);

				native_object->references.Initialize();
				((wxSplitterWindow_php*) native_object)->references.AddReference(parent1, "wxSplitterWindow::wxSplitterWindow at call with 1 argument(s)");
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1)\n");
				#endif

				native_object = new wxSplitterWindow_php((wxWindow*) object_pointer1_0, (wxWindowID) id1);

				native_object->references.Initialize();
				((wxSplitterWindow_php*) native_object)->references.AddReference(parent1, "wxSplitterWindow::wxSplitterWindow at call with 2 argument(s)");
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2)\n");
				#endif

				native_object = new wxSplitterWindow_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2);

				native_object->references.Initialize();
				((wxSplitterWindow_php*) native_object)->references.AddReference(parent1, "wxSplitterWindow::wxSplitterWindow at call with 3 argument(s)");
				((wxSplitterWindow_php*) native_object)->references.AddReference(pos1, "wxSplitterWindow::wxSplitterWindow at call with 3 argument(s)");
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3)\n");
				#endif

				native_object = new wxSplitterWindow_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3);

				native_object->references.Initialize();
				((wxSplitterWindow_php*) native_object)->references.AddReference(parent1, "wxSplitterWindow::wxSplitterWindow at call with 4 argument(s)");
				((wxSplitterWindow_php*) native_object)->references.AddReference(pos1, "wxSplitterWindow::wxSplitterWindow at call with 4 argument(s)");
				((wxSplitterWindow_php*) native_object)->references.AddReference(size1, "wxSplitterWindow::wxSplitterWindow at call with 4 argument(s)");
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1)\n");
				#endif

				native_object = new wxSplitterWindow_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1);

				native_object->references.Initialize();
				((wxSplitterWindow_php*) native_object)->references.AddReference(parent1, "wxSplitterWindow::wxSplitterWindow at call with 5 argument(s)");
				((wxSplitterWindow_php*) native_object)->references.AddReference(pos1, "wxSplitterWindow::wxSplitterWindow at call with 5 argument(s)");
				((wxSplitterWindow_php*) native_object)->references.AddReference(size1, "wxSplitterWindow::wxSplitterWindow at call with 5 argument(s)");
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1, wxString(name1, wxConvUTF8))\n");
				#endif

				native_object = new wxSplitterWindow_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1, wxString(name1, wxConvUTF8));

				native_object->references.Initialize();
				((wxSplitterWindow_php*) native_object)->references.AddReference(parent1, "wxSplitterWindow::wxSplitterWindow at call with 6 argument(s)");
				((wxSplitterWindow_php*) native_object)->references.AddReference(pos1, "wxSplitterWindow::wxSplitterWindow at call with 6 argument(s)");
				((wxSplitterWindow_php*) native_object)->references.AddReference(size1, "wxSplitterWindow::wxSplitterWindow at call with 6 argument(s)");
				break;
			}
		}
	}

		
	if(already_called)
	{
		native_object->phpObj = getThis();
		

		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		current_object->native_object = native_object;
		
		current_object->is_user_initialized = 1;
		
		#ifdef ZTS 
		native_object->TSRMLS_C = TSRMLS_C;
		#endif
	}
	else
	{
		zend_error(E_ERROR, "Abstract class or wrong type/count of parameters passed to: wxSplitterWindow::__construct\n");
	}
	
	#ifdef USE_WXPHP_DEBUG
		php_printf("===========================================\n\n");
	#endif
}
/* }}} */

/* {{{ proto  wxSplitterWindow::UpdateSize()
   Causes any pending sizing of the sash and child panes to take place immediately. */
PHP_METHOD(php_wxSplitterWindow, UpdateSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::UpdateSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxphp_object_type current_object_type;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSplitterWindow::UpdateSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSPLITTERWINDOW_TYPE){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxSplitterWindow::UpdateSize()\n\n");
				#endif

				((wxSplitterWindow_php*)native_object)->UpdateSize();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSplitterWindow::UpdateSize\n");
	}
}
/* }}} */

/* {{{ proto bool wxSplitterWindow::Unsplit(wxWindow &toRemove)
   Unsplits the window. */
PHP_METHOD(php_wxSplitterWindow, Unsplit)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::Unsplit\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxphp_object_type current_object_type;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSplitterWindow::Unsplit call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSPLITTERWINDOW_TYPE){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* toRemove0 = 0;
	wxWindow* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|z' (&toRemove0)\n");
		#endif

		char parse_parameters_string[] = "|z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &toRemove0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(toRemove0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(toRemove0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(toRemove0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'toRemove' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(toRemove0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'toRemove' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSplitterWindow::Unsplit())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSplitterWindow_php*)native_object)->Unsplit());


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSplitterWindow::Unsplit((wxWindow*) object_pointer0_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSplitterWindow_php*)native_object)->Unsplit((wxWindow*) object_pointer0_0));

				references->AddReference(toRemove0, "wxSplitterWindow::Unsplit at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSplitterWindow::Unsplit\n");
	}
}
/* }}} */

/* {{{ proto bool wxSplitterWindow::SplitVertically(wxWindow &window1, wxWindow &window2, int sashPosition)
   Initializes the left and right panes of the splitter window. */
PHP_METHOD(php_wxSplitterWindow, SplitVertically)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::SplitVertically\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxphp_object_type current_object_type;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSplitterWindow::SplitVertically call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSPLITTERWINDOW_TYPE){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* window10 = 0;
	wxWindow* object_pointer0_0 = 0;
	zval* window20 = 0;
	wxWindow* object_pointer0_1 = 0;
	long sashPosition0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 2  && arguments_received <= 3)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zz|l' (&window10, &window20, &sashPosition0)\n");
		#endif

		char parse_parameters_string[] = "zz|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &window10, &window20, &sashPosition0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(window10) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(window10 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(window10 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'window1' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(window10) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'window1' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 2){
				if(Z_TYPE_P(window20) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(window20 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(window20 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxWindow*) argument_native_object;
					if (!object_pointer0_1 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'window2' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(window20) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'window2' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSplitterWindow::SplitVertically((wxWindow*) object_pointer0_0, (wxWindow*) object_pointer0_1))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSplitterWindow_php*)native_object)->SplitVertically((wxWindow*) object_pointer0_0, (wxWindow*) object_pointer0_1));

				references->AddReference(window10, "wxSplitterWindow::SplitVertically at call with 2 argument(s)");
				references->AddReference(window20, "wxSplitterWindow::SplitVertically at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSplitterWindow::SplitVertically((wxWindow*) object_pointer0_0, (wxWindow*) object_pointer0_1, (int) sashPosition0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSplitterWindow_php*)native_object)->SplitVertically((wxWindow*) object_pointer0_0, (wxWindow*) object_pointer0_1, (int) sashPosition0));

				references->AddReference(window10, "wxSplitterWindow::SplitVertically at call with 3 argument(s)");
				references->AddReference(window20, "wxSplitterWindow::SplitVertically at call with 3 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSplitterWindow::SplitVertically\n");
	}
}
/* }}} */

/* {{{ proto bool wxSplitterWindow::SplitHorizontally(wxWindow &window1, wxWindow &window2, int sashPosition)
   Initializes the top and bottom panes of the splitter window. */
PHP_METHOD(php_wxSplitterWindow, SplitHorizontally)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::SplitHorizontally\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxphp_object_type current_object_type;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSplitterWindow::SplitHorizontally call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSPLITTERWINDOW_TYPE){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* window10 = 0;
	wxWindow* object_pointer0_0 = 0;
	zval* window20 = 0;
	wxWindow* object_pointer0_1 = 0;
	long sashPosition0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 2  && arguments_received <= 3)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zz|l' (&window10, &window20, &sashPosition0)\n");
		#endif

		char parse_parameters_string[] = "zz|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &window10, &window20, &sashPosition0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(window10) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(window10 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(window10 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'window1' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(window10) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'window1' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 2){
				if(Z_TYPE_P(window20) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(window20 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(window20 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxWindow*) argument_native_object;
					if (!object_pointer0_1 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'window2' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(window20) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'window2' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSplitterWindow::SplitHorizontally((wxWindow*) object_pointer0_0, (wxWindow*) object_pointer0_1))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSplitterWindow_php*)native_object)->SplitHorizontally((wxWindow*) object_pointer0_0, (wxWindow*) object_pointer0_1));

				references->AddReference(window10, "wxSplitterWindow::SplitHorizontally at call with 2 argument(s)");
				references->AddReference(window20, "wxSplitterWindow::SplitHorizontally at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSplitterWindow::SplitHorizontally((wxWindow*) object_pointer0_0, (wxWindow*) object_pointer0_1, (int) sashPosition0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSplitterWindow_php*)native_object)->SplitHorizontally((wxWindow*) object_pointer0_0, (wxWindow*) object_pointer0_1, (int) sashPosition0));

				references->AddReference(window10, "wxSplitterWindow::SplitHorizontally at call with 3 argument(s)");
				references->AddReference(window20, "wxSplitterWindow::SplitHorizontally at call with 3 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSplitterWindow::SplitHorizontally\n");
	}
}
/* }}} */

/* {{{ proto  wxSplitterWindow::SetSplitMode(int mode)
   Sets the split mode. */
PHP_METHOD(php_wxSplitterWindow, SetSplitMode)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::SetSplitMode\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxphp_object_type current_object_type;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSplitterWindow::SetSplitMode call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSPLITTERWINDOW_TYPE){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long mode0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&mode0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &mode0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxSplitterWindow::SetSplitMode((int) mode0)\n\n");
				#endif

				((wxSplitterWindow_php*)native_object)->SetSplitMode((int) mode0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSplitterWindow::SetSplitMode\n");
	}
}
/* }}} */

/* {{{ proto  wxSplitterWindow::SetSashPosition(int position, bool redraw)
   Sets the sash position. */
PHP_METHOD(php_wxSplitterWindow, SetSashPosition)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::SetSashPosition\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxphp_object_type current_object_type;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSplitterWindow::SetSashPosition call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSPLITTERWINDOW_TYPE){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long position0;
	bool redraw0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l|b' (&position0, &redraw0)\n");
		#endif

		char parse_parameters_string[] = "l|b";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &position0, &redraw0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxSplitterWindow::SetSashPosition((int) position0)\n\n");
				#endif

				((wxSplitterWindow_php*)native_object)->SetSashPosition((int) position0);


				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxSplitterWindow::SetSashPosition((int) position0, redraw0)\n\n");
				#endif

				((wxSplitterWindow_php*)native_object)->SetSashPosition((int) position0, redraw0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSplitterWindow::SetSashPosition\n");
	}
}
/* }}} */

/* {{{ proto  wxSplitterWindow::SetSashGravity(float gravity)
   Sets the sash gravity. */
PHP_METHOD(php_wxSplitterWindow, SetSashGravity)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::SetSashGravity\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxphp_object_type current_object_type;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSplitterWindow::SetSashGravity call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSPLITTERWINDOW_TYPE){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	double gravity0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'd' (&gravity0)\n");
		#endif

		char parse_parameters_string[] = "d";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &gravity0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxSplitterWindow::SetSashGravity(gravity0)\n\n");
				#endif

				((wxSplitterWindow_php*)native_object)->SetSashGravity(gravity0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSplitterWindow::SetSashGravity\n");
	}
}
/* }}} */

/* {{{ proto bool wxSplitterWindow::ReplaceWindow(wxWindow &winOld, wxWindow &winNew)
   This function replaces one of the windows managed by the wxSplitterWindow with another one. */
PHP_METHOD(php_wxSplitterWindow, ReplaceWindow)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::ReplaceWindow\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxphp_object_type current_object_type;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSplitterWindow::ReplaceWindow call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSPLITTERWINDOW_TYPE){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* winOld0 = 0;
	wxWindow* object_pointer0_0 = 0;
	zval* winNew0 = 0;
	wxWindow* object_pointer0_1 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zz' (&winOld0, &winNew0)\n");
		#endif

		char parse_parameters_string[] = "zz";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &winOld0, &winNew0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(winOld0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(winOld0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(winOld0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'winOld' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(winOld0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'winOld' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 2){
				if(Z_TYPE_P(winNew0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(winNew0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(winNew0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxWindow*) argument_native_object;
					if (!object_pointer0_1 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'winNew' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(winNew0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'winNew' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSplitterWindow::ReplaceWindow((wxWindow*) object_pointer0_0, (wxWindow*) object_pointer0_1))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSplitterWindow_php*)native_object)->ReplaceWindow((wxWindow*) object_pointer0_0, (wxWindow*) object_pointer0_1));

				references->AddReference(winOld0, "wxSplitterWindow::ReplaceWindow at call with 2 argument(s)");
				references->AddReference(winNew0, "wxSplitterWindow::ReplaceWindow at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSplitterWindow::ReplaceWindow\n");
	}
}
/* }}} */

/* {{{ proto  wxSplitterWindow::SetMinimumPaneSize(int paneSize)
   Sets the minimum pane size. */
PHP_METHOD(php_wxSplitterWindow, SetMinimumPaneSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::SetMinimumPaneSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxphp_object_type current_object_type;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSplitterWindow::SetMinimumPaneSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSPLITTERWINDOW_TYPE){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long paneSize0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&paneSize0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &paneSize0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxSplitterWindow::SetMinimumPaneSize((int) paneSize0)\n\n");
				#endif

				((wxSplitterWindow_php*)native_object)->SetMinimumPaneSize((int) paneSize0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSplitterWindow::SetMinimumPaneSize\n");
	}
}
/* }}} */

/* {{{ proto bool wxSplitterWindow::IsSplit()
   Returns true if the window is split, false otherwise. */
PHP_METHOD(php_wxSplitterWindow, IsSplit)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::IsSplit\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxphp_object_type current_object_type;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSplitterWindow::IsSplit call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSPLITTERWINDOW_TYPE){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSplitterWindow::IsSplit())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSplitterWindow_php*)native_object)->IsSplit());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSplitterWindow::IsSplit\n");
	}
}
/* }}} */

/* {{{ proto  wxSplitterWindow::Initialize(wxWindow &window)
   Initializes the splitter window to have one pane. */
PHP_METHOD(php_wxSplitterWindow, Initialize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::Initialize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxphp_object_type current_object_type;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSplitterWindow::Initialize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSPLITTERWINDOW_TYPE){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* window0 = 0;
	wxWindow* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&window0)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &window0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(window0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(window0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(window0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'window' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(window0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'window' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxSplitterWindow::Initialize((wxWindow*) object_pointer0_0)\n\n");
				#endif

				((wxSplitterWindow_php*)native_object)->Initialize((wxWindow*) object_pointer0_0);

				references->AddReference(window0, "wxSplitterWindow::Initialize at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSplitterWindow::Initialize\n");
	}
}
/* }}} */

/* {{{ proto wxWindow wxSplitterWindow::GetWindow2()
   Returns the right/bottom pane. */
PHP_METHOD(php_wxSplitterWindow, GetWindow2)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::GetWindow2\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxphp_object_type current_object_type;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSplitterWindow::GetWindow2 call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSPLITTERWINDOW_TYPE){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxSplitterWindow::GetWindow2() to return object pointer\n\n");
				#endif

				wxWindow_php* value_to_return0;
				value_to_return0 = (wxWindow_php*) ((wxSplitterWindow_php*)native_object)->GetWindow2();

				if(value_to_return0 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return0->references.IsUserInitialized()){
					if(value_to_return0->phpObj != NULL){
						*return_value = *value_to_return0->phpObj;
						zval_add_ref(&value_to_return0->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxWindow_entry);
					((zo_wxWindow*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxWindow_php*) value_to_return0;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return0 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxSplitterWindow::GetWindow2 at call with 0 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSplitterWindow::GetWindow2\n");
	}
}
/* }}} */

/* {{{ proto wxWindow wxSplitterWindow::GetWindow1()
   Returns the left/top or only pane. */
PHP_METHOD(php_wxSplitterWindow, GetWindow1)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::GetWindow1\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxphp_object_type current_object_type;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSplitterWindow::GetWindow1 call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSPLITTERWINDOW_TYPE){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxSplitterWindow::GetWindow1() to return object pointer\n\n");
				#endif

				wxWindow_php* value_to_return0;
				value_to_return0 = (wxWindow_php*) ((wxSplitterWindow_php*)native_object)->GetWindow1();

				if(value_to_return0 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return0->references.IsUserInitialized()){
					if(value_to_return0->phpObj != NULL){
						*return_value = *value_to_return0->phpObj;
						zval_add_ref(&value_to_return0->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxWindow_entry);
					((zo_wxWindow*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxWindow_php*) value_to_return0;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return0 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxSplitterWindow::GetWindow1 at call with 0 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSplitterWindow::GetWindow1\n");
	}
}
/* }}} */

/* {{{ proto wxSplitMode wxSplitterWindow::GetSplitMode()
   Gets the split mode. */
PHP_METHOD(php_wxSplitterWindow, GetSplitMode)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::GetSplitMode\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxphp_object_type current_object_type;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSplitterWindow::GetSplitMode call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSPLITTERWINDOW_TYPE){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxSplitterWindow::GetSplitMode())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxSplitterWindow_php*)native_object)->GetSplitMode());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSplitterWindow::GetSplitMode\n");
	}
}
/* }}} */

/* {{{ proto int wxSplitterWindow::GetSashSize()
   Returns the default sash size in pixels or 0 if it is invisible. */
PHP_METHOD(php_wxSplitterWindow, GetSashSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::GetSashSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxphp_object_type current_object_type;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSplitterWindow::GetSashSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSPLITTERWINDOW_TYPE){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxSplitterWindow::GetSashSize())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxSplitterWindow_php*)native_object)->GetSashSize());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSplitterWindow::GetSashSize\n");
	}
}
/* }}} */

/* {{{ proto int wxSplitterWindow::GetSashPosition()
   Returns the current sash position. */
PHP_METHOD(php_wxSplitterWindow, GetSashPosition)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::GetSashPosition\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxphp_object_type current_object_type;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSplitterWindow::GetSashPosition call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSPLITTERWINDOW_TYPE){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxSplitterWindow::GetSashPosition())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxSplitterWindow_php*)native_object)->GetSashPosition());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSplitterWindow::GetSashPosition\n");
	}
}
/* }}} */

/* {{{ proto float wxSplitterWindow::GetSashGravity()
   Returns the current sash gravity. */
PHP_METHOD(php_wxSplitterWindow, GetSashGravity)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::GetSashGravity\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxphp_object_type current_object_type;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSplitterWindow::GetSashGravity call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSPLITTERWINDOW_TYPE){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxSplitterWindow::GetSashGravity())\n\n");
				#endif

				ZVAL_DOUBLE(return_value, ((wxSplitterWindow_php*)native_object)->GetSashGravity());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSplitterWindow::GetSashGravity\n");
	}
}
/* }}} */

/* {{{ proto int wxSplitterWindow::GetMinimumPaneSize()
   Returns the current minimum pane size (defaults to zero). */
PHP_METHOD(php_wxSplitterWindow, GetMinimumPaneSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::GetMinimumPaneSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxphp_object_type current_object_type;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSplitterWindow::GetMinimumPaneSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSPLITTERWINDOW_TYPE){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxSplitterWindow::GetMinimumPaneSize())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxSplitterWindow_php*)native_object)->GetMinimumPaneSize());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSplitterWindow::GetMinimumPaneSize\n");
	}
}
/* }}} */

/* {{{ proto bool wxSplitterWindow::Create(wxWindow &parent, int id, wxPoint point, wxSize size, int style, string name)
   Creation function, for two-step construction. */
PHP_METHOD(php_wxSplitterWindow, Create)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxSplitterWindow::Create\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxSplitterWindow* current_object;
	wxphp_object_type current_object_type;
	wxSplitterWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxSplitterWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxSplitterWindow::Create call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSPLITTERWINDOW_TYPE){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* parent0 = 0;
	wxWindow* object_pointer0_0 = 0;
	long id0;
	zval* point0 = 0;
	wxPoint* object_pointer0_2 = 0;
	zval* size0 = 0;
	wxSize* object_pointer0_3 = 0;
	long style0;
	char* name0;
	long name_len0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 6)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lOOls' (&parent0, &id0, &point0, php_wxPoint_entry, &size0, php_wxSize_entry, &style0, &name0, &name_len0)\n");
		#endif

		char parse_parameters_string[] = "z|lOOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent0, &id0, &point0, php_wxPoint_entry, &size0, php_wxSize_entry, &style0, &name0, &name_len0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(point0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(point0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(point0 TSRMLS_CC))->native_object;
					object_pointer0_2 = (wxPoint*) argument_native_object;
					if (!object_pointer0_2 )
					{
						zend_error(E_ERROR, "Parameter 'point' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(point0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'point' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->native_object;
					object_pointer0_3 = (wxSize*) argument_native_object;
					if (!object_pointer0_3 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSplitterWindow::Create((wxWindow*) object_pointer0_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSplitterWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0));

				references->AddReference(parent0, "wxSplitterWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSplitterWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSplitterWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0));

				references->AddReference(parent0, "wxSplitterWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSplitterWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSplitterWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2));

				references->AddReference(parent0, "wxSplitterWindow::Create at call with 3 argument(s)");
				references->AddReference(point0, "wxSplitterWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSplitterWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSplitterWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3));

				references->AddReference(parent0, "wxSplitterWindow::Create at call with 4 argument(s)");
				references->AddReference(point0, "wxSplitterWindow::Create at call with 4 argument(s)");
				references->AddReference(size0, "wxSplitterWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSplitterWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSplitterWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0));

				references->AddReference(parent0, "wxSplitterWindow::Create at call with 5 argument(s)");
				references->AddReference(point0, "wxSplitterWindow::Create at call with 5 argument(s)");
				references->AddReference(size0, "wxSplitterWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSplitterWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0, wxString(name0, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSplitterWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0, wxString(name0, wxConvUTF8)));

				references->AddReference(parent0, "wxSplitterWindow::Create at call with 6 argument(s)");
				references->AddReference(point0, "wxSplitterWindow::Create at call with 6 argument(s)");
				references->AddReference(size0, "wxSplitterWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxSplitterWindow::Create\n");
	}
}
/* }}} */

/* {{{ proto  wxSplitterWindow::OnDoubleClickSash(int x, int y)
   Application-overridable function called when the sash is double-clicked with the left mouse button. */
void wxSplitterWindow_php::OnDoubleClickSash(int x, int y)
{
	static zend_function* cached_function = NULL;
	static bool is_php_user_space_implemented = true;
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking virtual wxSplitterWindow::OnDoubleClickSash\n");
	php_printf("===========================================\n");
	#endif
	
	zval** params[2];
	zval *arguments[2];
	
	//Initilize arguments array
	for(int i=0; i<2; i++)
	{
		ALLOC_INIT_ZVAL(arguments[i]);
	}

	zval* return_value;
	MAKE_STD_ZVAL(return_value);
	zval function_name;
	ZVAL_STRING(&function_name, "OnDoubleClickSash", 0);
	char* temp_string;
	void* return_object;
	int function_called;
	
	//Parameters for conversion
	ZVAL_LONG(arguments[0], x);
	ZVAL_LONG(arguments[1], y);
		
	for(int i=0; i<2; i++)
	{
		params[i] = &arguments[i];
	}

	#ifdef USE_WXPHP_DEBUG
	php_printf("Trying to call user defined method\n");
	#endif
	
	if(is_php_user_space_implemented)
	{
		function_called = wxphp_call_method((zval**) &this->phpObj, NULL, &cached_function, "OnDoubleClickSash", 17, &return_value, 2, params TSRMLS_CC);
	}
	else
	{
		function_called = FAILURE;
	}
    
    	
	//Delete already used parameters from memory
	for(int i=0; i<2; i++)
	{
		zval_ptr_dtor(&arguments[i]);
	}
	
	if(function_called == FAILURE)
	{
		is_php_user_space_implemented = false;
		
		#ifdef USE_WXPHP_DEBUG
		php_printf("Invocation of user defined method failed\n");
		#endif
		
	}
	else
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Returning userspace value.\n");
		#endif
		
		return;
	}
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling original method\n");
	php_printf("===========================================\n\n");
	#endif
	
	//Call original method
	wxSplitterWindow::OnDoubleClickSash(x, y);
}
/* }}} */

/* {{{ proto bool wxSplitterWindow::OnSashPositionChange(int newSashPosition)
   Application-overridable function called when the sash position is changed by user. */
bool wxSplitterWindow_php::OnSashPositionChange(int newSashPosition)
{
	static zend_function* cached_function = NULL;
	static bool is_php_user_space_implemented = true;
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking virtual wxSplitterWindow::OnSashPositionChange\n");
	php_printf("===========================================\n");
	#endif
	
	zval** params[1];
	zval *arguments[1];
	
	//Initilize arguments array
	for(int i=0; i<1; i++)
	{
		ALLOC_INIT_ZVAL(arguments[i]);
	}

	zval* return_value;
	MAKE_STD_ZVAL(return_value);
	zval function_name;
	ZVAL_STRING(&function_name, "OnSashPositionChange", 0);
	char* temp_string;
	void* return_object;
	int function_called;
	
	//Parameters for conversion
	ZVAL_LONG(arguments[0], newSashPosition);
		
	for(int i=0; i<1; i++)
	{
		params[i] = &arguments[i];
	}

	#ifdef USE_WXPHP_DEBUG
	php_printf("Trying to call user defined method\n");
	#endif
	
	if(is_php_user_space_implemented)
	{
		function_called = wxphp_call_method((zval**) &this->phpObj, NULL, &cached_function, "OnSashPositionChange", 20, &return_value, 1, params TSRMLS_CC);
	}
	else
	{
		function_called = FAILURE;
	}
    
    	
	//Delete already used parameters from memory
	for(int i=0; i<1; i++)
	{
		zval_ptr_dtor(&arguments[i]);
	}
	
	if(function_called == FAILURE)
	{
		is_php_user_space_implemented = false;
		
		#ifdef USE_WXPHP_DEBUG
		php_printf("Invocation of user defined method failed\n");
		#endif
		
	}
	else
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Returning userspace value.\n");
		#endif
		
		return Z_BVAL_P(return_value);
	}
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling original method\n");
	php_printf("===========================================\n\n");
	#endif
	
	//Call original method
	return wxSplitterWindow::OnSashPositionChange(newSashPosition);
}
/* }}} */

/* {{{ proto  wxSplitterWindow::OnUnsplit(wxWindow &removed)
   Application-overridable function called when the window is unsplit, either programmatically or using the wxSplitterWindow user interface. */
void wxSplitterWindow_php::OnUnsplit(wxWindow* removed)
{
	static zend_function* cached_function = NULL;
	static bool is_php_user_space_implemented = true;
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking virtual wxSplitterWindow::OnUnsplit\n");
	php_printf("===========================================\n");
	#endif
	
	zval** params[1];
	zval *arguments[1];
	
	//Initilize arguments array
	for(int i=0; i<1; i++)
	{
		ALLOC_INIT_ZVAL(arguments[i]);
	}

	zval* return_value;
	MAKE_STD_ZVAL(return_value);
	zval function_name;
	ZVAL_STRING(&function_name, "OnUnsplit", 0);
	char* temp_string;
	void* return_object;
	int function_called;
	
	//Parameters for conversion
	object_init_ex(arguments[0], php_wxWindow_entry);
	((zo_wxWindow*) zend_object_store_get_object(arguments[0] TSRMLS_CC))->native_object = (wxWindow_php*) removed;
		
	for(int i=0; i<1; i++)
	{
		params[i] = &arguments[i];
	}

	#ifdef USE_WXPHP_DEBUG
	php_printf("Trying to call user defined method\n");
	#endif
	
	if(is_php_user_space_implemented)
	{
		function_called = wxphp_call_method((zval**) &this->phpObj, NULL, &cached_function, "OnUnsplit", 9, &return_value, 1, params TSRMLS_CC);
	}
	else
	{
		function_called = FAILURE;
	}
    
    	
	//Delete already used parameters from memory
	for(int i=0; i<1; i++)
	{
		zval_ptr_dtor(&arguments[i]);
	}
	
	if(function_called == FAILURE)
	{
		is_php_user_space_implemented = false;
		
		#ifdef USE_WXPHP_DEBUG
		php_printf("Invocation of user defined method failed\n");
		#endif
		
	}
	else
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Returning userspace value.\n");
		#endif
		
		return;
	}
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling original method\n");
	php_printf("===========================================\n\n");
	#endif
	
	//Call original method
	wxSplitterWindow::OnUnsplit(removed);
}
/* }}} */

BEGIN_EXTERN_C()
void php_wxStatusBar_free(void *object TSRMLS_DC) 
{
    zo_wxStatusBar* custom_object = (zo_wxStatusBar*) object;
    
	#ifdef USE_WXPHP_DEBUG
	php_printf("Obviate delete call for wxStatusBar on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n\n");
	#endif

	zend_object_std_dtor(&custom_object->zo TSRMLS_CC);
    efree(custom_object);
}

zend_object_value php_wxStatusBar_new(zend_class_entry *class_type TSRMLS_DC)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxStatusBar_new on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	zval *temp;
    zend_object_value retval;
    zo_wxStatusBar* custom_object;
    custom_object = (zo_wxStatusBar*) emalloc(sizeof(zo_wxStatusBar));

    zend_object_std_init(&custom_object->zo, class_type TSRMLS_CC);

#if PHP_VERSION_ID < 50399
	ALLOC_HASHTABLE(custom_object->zo.properties);
    zend_hash_init(custom_object->zo.properties, 0, NULL, ZVAL_PTR_DTOR, 0);
    zend_hash_copy(custom_object->zo.properties, &class_type->default_properties, (copy_ctor_func_t) zval_add_ref,(void *) &temp, sizeof(zval *));
#else
	object_properties_init(&custom_object->zo, class_type);
#endif

	retval.handle = zend_objects_store_put(custom_object, NULL, php_wxStatusBar_free, NULL TSRMLS_CC);
	retval.handlers = zend_get_std_object_handlers();

    custom_object->native_object = NULL;
	custom_object->object_type = PHP_WXSTATUSBAR_TYPE;
	custom_object->is_user_initialized = 0;
	
    return retval;
}
END_EXTERN_C()

/* {{{ proto  wxStatusBar::wxStatusBar(wxWindow &parent, int id, int style, string name)
   Constructor, creating the window. */
PHP_METHOD(php_wxStatusBar, __construct)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxStatusBar::__construct\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxStatusBar* current_object;
	wxStatusBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	int arguments_received = ZEND_NUM_ARGS();
	
	
	//Parameters for overload 0
	zval* parent0 = 0;
	wxWindow* object_pointer0_0 = 0;
	long id0;
	long style0;
	char* name0;
	long name_len0;
	bool overload0_called = false;
	//Parameters for overload 1
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 4)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lls' (&parent0, &id0, &style0, &name0, &name_len0)\n");
		#endif

		char parse_parameters_string[] = "z|lls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent0, &id0, &style0, &name0, &name_len0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(parent0) != IS_NULL)
				{
					goto overload1;
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload1_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer0_0)\n");
				#endif

				native_object = new wxStatusBar_php((wxWindow*) object_pointer0_0);

				native_object->references.Initialize();
				((wxStatusBar_php*) native_object)->references.AddReference(parent0, "wxStatusBar::wxStatusBar at call with 1 argument(s)");
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer0_0, (wxWindowID) id0)\n");
				#endif

				native_object = new wxStatusBar_php((wxWindow*) object_pointer0_0, (wxWindowID) id0);

				native_object->references.Initialize();
				((wxStatusBar_php*) native_object)->references.AddReference(parent0, "wxStatusBar::wxStatusBar at call with 2 argument(s)");
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer0_0, (wxWindowID) id0, (long) style0)\n");
				#endif

				native_object = new wxStatusBar_php((wxWindow*) object_pointer0_0, (wxWindowID) id0, (long) style0);

				native_object->references.Initialize();
				((wxStatusBar_php*) native_object)->references.AddReference(parent0, "wxStatusBar::wxStatusBar at call with 3 argument(s)");
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer0_0, (wxWindowID) id0, (long) style0, wxString(name0, wxConvUTF8))\n");
				#endif

				native_object = new wxStatusBar_php((wxWindow*) object_pointer0_0, (wxWindowID) id0, (long) style0, wxString(name0, wxConvUTF8));

				native_object->references.Initialize();
				((wxStatusBar_php*) native_object)->references.AddReference(parent0, "wxStatusBar::wxStatusBar at call with 4 argument(s)");
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct()\n");
				#endif

				native_object = new wxStatusBar_php();

				native_object->references.Initialize();
				break;
			}
		}
	}

		
	if(already_called)
	{
		native_object->phpObj = getThis();
		

		current_object = (zo_wxStatusBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		current_object->native_object = native_object;
		
		current_object->is_user_initialized = 1;
		
		#ifdef ZTS 
		native_object->TSRMLS_C = TSRMLS_C;
		#endif
	}
	else
	{
		zend_error(E_ERROR, "Abstract class or wrong type/count of parameters passed to: wxStatusBar::__construct\n");
	}
	
	#ifdef USE_WXPHP_DEBUG
		php_printf("===========================================\n\n");
	#endif
}
/* }}} */

/* {{{ proto  wxStatusBar::SetMinHeight(int height)
   Sets the minimal possible height for the status bar. */
PHP_METHOD(php_wxStatusBar, SetMinHeight)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxStatusBar::SetMinHeight\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxStatusBar* current_object;
	wxphp_object_type current_object_type;
	wxStatusBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxStatusBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxStatusBar::SetMinHeight call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSTATUSBAR_TYPE){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long height0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&height0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &height0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxStatusBar::SetMinHeight((int) height0)\n\n");
				#endif

				((wxStatusBar_php*)native_object)->SetMinHeight((int) height0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxStatusBar::SetMinHeight\n");
	}
}
/* }}} */

/* {{{ proto  wxStatusBar::SetStatusText(string text, int i)
   Sets the status text for the i-th field. */
PHP_METHOD(php_wxStatusBar, SetStatusText)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxStatusBar::SetStatusText\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxStatusBar* current_object;
	wxphp_object_type current_object_type;
	wxStatusBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxStatusBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxStatusBar::SetStatusText call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSTATUSBAR_TYPE){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	char* text0;
	long text_len0;
	long i0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 's|l' (&text0, &text_len0, &i0)\n");
		#endif

		char parse_parameters_string[] = "s|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &text0, &text_len0, &i0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxStatusBar::SetStatusText(wxString(text0, wxConvUTF8))\n\n");
				#endif

				((wxStatusBar_php*)native_object)->SetStatusText(wxString(text0, wxConvUTF8));


				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxStatusBar::SetStatusText(wxString(text0, wxConvUTF8), (int) i0)\n\n");
				#endif

				((wxStatusBar_php*)native_object)->SetStatusText(wxString(text0, wxConvUTF8), (int) i0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxStatusBar::SetStatusText\n");
	}
}
/* }}} */

/* {{{ proto bool wxStatusBar::Create(wxWindow &parent, int id, int style, string name)
   Creates the window, for two-step construction. */
PHP_METHOD(php_wxStatusBar, Create)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxStatusBar::Create\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxStatusBar* current_object;
	wxphp_object_type current_object_type;
	wxStatusBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxStatusBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxStatusBar::Create call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSTATUSBAR_TYPE){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* parent0 = 0;
	wxWindow* object_pointer0_0 = 0;
	long id0;
	long style0;
	char* name0;
	long name_len0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 4)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lls' (&parent0, &id0, &style0, &name0, &name_len0)\n");
		#endif

		char parse_parameters_string[] = "z|lls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent0, &id0, &style0, &name0, &name_len0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStatusBar::Create((wxWindow*) object_pointer0_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStatusBar_php*)native_object)->Create((wxWindow*) object_pointer0_0));

				references->AddReference(parent0, "wxStatusBar::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStatusBar::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStatusBar_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0));

				references->AddReference(parent0, "wxStatusBar::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStatusBar::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, (long) style0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStatusBar_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, (long) style0));

				references->AddReference(parent0, "wxStatusBar::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStatusBar::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, (long) style0, wxString(name0, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStatusBar_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, (long) style0, wxString(name0, wxConvUTF8)));

				references->AddReference(parent0, "wxStatusBar::Create at call with 4 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxStatusBar::Create\n");
	}
}
/* }}} */

/* {{{ proto wxSize wxStatusBar::GetBorders()
   Returns the horizontal and vertical borders used when rendering the field text inside the field area. */
PHP_METHOD(php_wxStatusBar, GetBorders)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxStatusBar::GetBorders\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxStatusBar* current_object;
	wxphp_object_type current_object_type;
	wxStatusBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxStatusBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxStatusBar::GetBorders call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSTATUSBAR_TYPE){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxStatusBar::GetBorders() to return new object\n\n");
				#endif

				wxSize value_to_return0;
				value_to_return0 = ((wxStatusBar_php*)native_object)->GetBorders();
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo0 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxSize_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxStatusBar::GetBorders\n");
	}
}
/* }}} */

/* {{{ proto wxStatusBarPane wxStatusBar::GetField(int n)
   Returns the wxStatusBarPane representing the n-th field. */
PHP_METHOD(php_wxStatusBar, GetField)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxStatusBar::GetField\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxStatusBar* current_object;
	wxphp_object_type current_object_type;
	wxStatusBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxStatusBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxStatusBar::GetField call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSTATUSBAR_TYPE){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long n0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&n0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &n0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxStatusBar::GetField((int) n0) to return object reference\n\n");
				#endif

				wxStatusBarPane_php* value_to_return1;
				value_to_return1 = (wxStatusBarPane_php*) &((wxStatusBar_php*)native_object)->GetField((int) n0);

				if(value_to_return1->references.IsUserInitialized()){
					if(value_to_return1->phpObj != NULL){
						*return_value = *value_to_return1->phpObj;
						zval_add_ref(&value_to_return1->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value,php_wxStatusBarPane_entry);
					((zo_wxStatusBarPane*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxStatusBarPane_php*) value_to_return1;
				}

				if((void*)value_to_return1 != (void*)native_object && return_is_user_initialized){ //Prevent adding references to it self
					references->AddReference(return_value, "wxStatusBar::GetField at call with 1 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxStatusBar::GetField\n");
	}
}
/* }}} */

/* {{{ proto bool wxStatusBar::GetFieldRect(int i, wxRect &rect)
   Returns the size and position of a field's internal bounding rectangle. */
PHP_METHOD(php_wxStatusBar, GetFieldRect)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxStatusBar::GetFieldRect\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxStatusBar* current_object;
	wxphp_object_type current_object_type;
	wxStatusBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxStatusBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxStatusBar::GetFieldRect call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSTATUSBAR_TYPE){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long i0;
	zval* rect0 = 0;
	wxRect* object_pointer0_1 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'lO' (&i0, &rect0, php_wxRect_entry)\n");
		#endif

		char parse_parameters_string[] = "lO";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &i0, &rect0, php_wxRect_entry ) == SUCCESS)
		{
			if(arguments_received >= 2){
				if(Z_TYPE_P(rect0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxRect*) zend_object_store_get_object(rect0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxRect*) zend_object_store_get_object(rect0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxRect*) argument_native_object;
					if (!object_pointer0_1 )
					{
						zend_error(E_ERROR, "Parameter 'rect' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(rect0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'rect' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStatusBar::GetFieldRect((int) i0, *(wxRect*) object_pointer0_1))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStatusBar_php*)native_object)->GetFieldRect((int) i0, *(wxRect*) object_pointer0_1));

				references->AddReference(rect0, "wxStatusBar::GetFieldRect at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxStatusBar::GetFieldRect\n");
	}
}
/* }}} */

/* {{{ proto int wxStatusBar::GetFieldsCount()
   Returns the number of fields in the status bar. */
PHP_METHOD(php_wxStatusBar, GetFieldsCount)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxStatusBar::GetFieldsCount\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxStatusBar* current_object;
	wxphp_object_type current_object_type;
	wxStatusBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxStatusBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxStatusBar::GetFieldsCount call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSTATUSBAR_TYPE){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxStatusBar::GetFieldsCount())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxStatusBar_php*)native_object)->GetFieldsCount());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxStatusBar::GetFieldsCount\n");
	}
}
/* }}} */

/* {{{ proto int wxStatusBar::GetStatusStyle(int n)
   Returns the style of the n-th field. */
PHP_METHOD(php_wxStatusBar, GetStatusStyle)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxStatusBar::GetStatusStyle\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxStatusBar* current_object;
	wxphp_object_type current_object_type;
	wxStatusBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxStatusBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxStatusBar::GetStatusStyle call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSTATUSBAR_TYPE){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long n0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&n0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &n0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxStatusBar::GetStatusStyle((int) n0))\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxStatusBar_php*)native_object)->GetStatusStyle((int) n0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxStatusBar::GetStatusStyle\n");
	}
}
/* }}} */

/* {{{ proto string wxStatusBar::GetStatusText(int i)
   Returns the string associated with a status bar field. */
PHP_METHOD(php_wxStatusBar, GetStatusText)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxStatusBar::GetStatusText\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxStatusBar* current_object;
	wxphp_object_type current_object_type;
	wxStatusBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxStatusBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxStatusBar::GetStatusText call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSTATUSBAR_TYPE){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long i0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|l' (&i0)\n");
		#endif

		char parse_parameters_string[] = "|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &i0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_STRING(wxStatusBar::GetStatusText().fn_str(), 1)\n\n");
				#endif

				wxString value_to_return0;
				value_to_return0 = ((wxStatusBar_php*)native_object)->GetStatusText();
				char* temp_string0;
				temp_string0 = (char*)malloc(sizeof(wxChar)*(value_to_return0.size()+1));
				strcpy (temp_string0, (const char *) value_to_return0.char_str() );
				ZVAL_STRING(return_value, temp_string0, 1);
				free(temp_string0);


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_STRING(wxStatusBar::GetStatusText((int) i0).fn_str(), 1)\n\n");
				#endif

				wxString value_to_return1;
				value_to_return1 = ((wxStatusBar_php*)native_object)->GetStatusText((int) i0);
				char* temp_string1;
				temp_string1 = (char*)malloc(sizeof(wxChar)*(value_to_return1.size()+1));
				strcpy (temp_string1, (const char *) value_to_return1.char_str() );
				ZVAL_STRING(return_value, temp_string1, 1);
				free(temp_string1);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxStatusBar::GetStatusText\n");
	}
}
/* }}} */

/* {{{ proto int wxStatusBar::GetStatusWidth(int n)
   Returns the width of the n-th field. */
PHP_METHOD(php_wxStatusBar, GetStatusWidth)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxStatusBar::GetStatusWidth\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxStatusBar* current_object;
	wxphp_object_type current_object_type;
	wxStatusBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxStatusBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxStatusBar::GetStatusWidth call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSTATUSBAR_TYPE){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long n0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&n0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &n0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxStatusBar::GetStatusWidth((int) n0))\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxStatusBar_php*)native_object)->GetStatusWidth((int) n0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxStatusBar::GetStatusWidth\n");
	}
}
/* }}} */

/* {{{ proto  wxStatusBar::PopStatusText(int field)
   Restores the text to the value it had before the last call to PushStatusText(). */
PHP_METHOD(php_wxStatusBar, PopStatusText)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxStatusBar::PopStatusText\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxStatusBar* current_object;
	wxphp_object_type current_object_type;
	wxStatusBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxStatusBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxStatusBar::PopStatusText call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSTATUSBAR_TYPE){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long field0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|l' (&field0)\n");
		#endif

		char parse_parameters_string[] = "|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &field0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxStatusBar::PopStatusText()\n\n");
				#endif

				((wxStatusBar_php*)native_object)->PopStatusText();


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxStatusBar::PopStatusText((int) field0)\n\n");
				#endif

				((wxStatusBar_php*)native_object)->PopStatusText((int) field0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxStatusBar::PopStatusText\n");
	}
}
/* }}} */

/* {{{ proto  wxStatusBar::PushStatusText(string string, int field)
   Saves the current field text in a per-field stack, and sets the field text to the string passed as argument. */
PHP_METHOD(php_wxStatusBar, PushStatusText)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxStatusBar::PushStatusText\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxStatusBar* current_object;
	wxphp_object_type current_object_type;
	wxStatusBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxStatusBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxStatusBar::PushStatusText call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSTATUSBAR_TYPE){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	char* string0;
	long string_len0;
	long field0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 's|l' (&string0, &string_len0, &field0)\n");
		#endif

		char parse_parameters_string[] = "s|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &string0, &string_len0, &field0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxStatusBar::PushStatusText(wxString(string0, wxConvUTF8))\n\n");
				#endif

				((wxStatusBar_php*)native_object)->PushStatusText(wxString(string0, wxConvUTF8));


				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxStatusBar::PushStatusText(wxString(string0, wxConvUTF8), (int) field0)\n\n");
				#endif

				((wxStatusBar_php*)native_object)->PushStatusText(wxString(string0, wxConvUTF8), (int) field0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxStatusBar::PushStatusText\n");
	}
}
/* }}} */

/* {{{ proto  wxStatusBar::SetFieldsCount(int number, array widths)
   Sets the number of fields, and optionally the field widths. */
PHP_METHOD(php_wxStatusBar, SetFieldsCount)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxStatusBar::SetFieldsCount\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxStatusBar* current_object;
	wxphp_object_type current_object_type;
	wxStatusBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxStatusBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxStatusBar::SetFieldsCount call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSTATUSBAR_TYPE){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long number0;
	zval* widths0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|la' (&number0, &widths0)\n");
		#endif

		char parse_parameters_string[] = "|la";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &number0, &widths0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		int array_count0_1 = 1;
		HashTable* arr_hash0_1;
		if(arguments_received > 1)
		{
			arr_hash0_1 = Z_ARRVAL_P(widths0);
			array_count0_1 = zend_hash_num_elements(arr_hash0_1);
		}
		int* integers_array0_1 = new int[array_count0_1];
		bool integers_continue0_1 = true;

		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxStatusBar::SetFieldsCount()\n\n");
				#endif

				((wxStatusBar_php*)native_object)->SetFieldsCount();


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxStatusBar::SetFieldsCount((int) number0)\n\n");
				#endif

				((wxStatusBar_php*)native_object)->SetFieldsCount((int) number0);


				return;
				break;
			}
			case 2:
			{
				int array_index0_1 = 0;
				zval** temp_array_value0_1 = 0;
				while(integers_continue0_1)
				{
					if(zend_hash_index_find(HASH_OF(widths0), array_index0_1, (void**)&temp_array_value0_1) == SUCCESS)
					{
						convert_to_long_ex(temp_array_value0_1);
						integers_array0_1[array_index0_1] = (int) Z_LVAL_PP(temp_array_value0_1);
						array_index0_1++;
					}
					else
					{
						integers_continue0_1 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxStatusBar::SetFieldsCount((int) number0, (const int*) integers_array0_1)\n\n");
				#endif

				((wxStatusBar_php*)native_object)->SetFieldsCount((int) number0, (const int*) integers_array0_1);

				delete[] integers_array0_1;

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxStatusBar::SetFieldsCount\n");
	}
}
/* }}} */

/* {{{ proto  wxStatusBar::SetStatusStyles(int n, array styles)
   Sets the styles of the fields in the status line which can make fields appear flat or raised instead of the standard sunken 3D border. */
PHP_METHOD(php_wxStatusBar, SetStatusStyles)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxStatusBar::SetStatusStyles\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxStatusBar* current_object;
	wxphp_object_type current_object_type;
	wxStatusBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxStatusBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxStatusBar::SetStatusStyles call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSTATUSBAR_TYPE){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long n0;
	zval* styles0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'la' (&n0, &styles0)\n");
		#endif

		char parse_parameters_string[] = "la";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &n0, &styles0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		int array_count0_1 = 1;
		HashTable* arr_hash0_1;
		if(arguments_received > 1)
		{
			arr_hash0_1 = Z_ARRVAL_P(styles0);
			array_count0_1 = zend_hash_num_elements(arr_hash0_1);
		}
		int* integers_array0_1 = new int[array_count0_1];
		bool integers_continue0_1 = true;

		switch(arguments_received)
		{
			case 2:
			{
				int array_index0_1 = 0;
				zval** temp_array_value0_1 = 0;
				while(integers_continue0_1)
				{
					if(zend_hash_index_find(HASH_OF(styles0), array_index0_1, (void**)&temp_array_value0_1) == SUCCESS)
					{
						convert_to_long_ex(temp_array_value0_1);
						integers_array0_1[array_index0_1] = (int) Z_LVAL_PP(temp_array_value0_1);
						array_index0_1++;
					}
					else
					{
						integers_continue0_1 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxStatusBar::SetStatusStyles((int) n0, (const int*) integers_array0_1)\n\n");
				#endif

				((wxStatusBar_php*)native_object)->SetStatusStyles((int) n0, (const int*) integers_array0_1);

				delete[] integers_array0_1;

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxStatusBar::SetStatusStyles\n");
	}
}
/* }}} */

/* {{{ proto  wxStatusBar::SetStatusWidths(int n, array widths_field)
   Sets the widths of the fields in the status line. */
PHP_METHOD(php_wxStatusBar, SetStatusWidths)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxStatusBar::SetStatusWidths\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxStatusBar* current_object;
	wxphp_object_type current_object_type;
	wxStatusBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxStatusBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxStatusBar::SetStatusWidths call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXSTATUSBAR_TYPE){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long n0;
	zval* widths_field0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'la' (&n0, &widths_field0)\n");
		#endif

		char parse_parameters_string[] = "la";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &n0, &widths_field0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		int array_count0_1 = 1;
		HashTable* arr_hash0_1;
		if(arguments_received > 1)
		{
			arr_hash0_1 = Z_ARRVAL_P(widths_field0);
			array_count0_1 = zend_hash_num_elements(arr_hash0_1);
		}
		int* integers_array0_1 = new int[array_count0_1];
		bool integers_continue0_1 = true;

		switch(arguments_received)
		{
			case 2:
			{
				int array_index0_1 = 0;
				zval** temp_array_value0_1 = 0;
				while(integers_continue0_1)
				{
					if(zend_hash_index_find(HASH_OF(widths_field0), array_index0_1, (void**)&temp_array_value0_1) == SUCCESS)
					{
						convert_to_long_ex(temp_array_value0_1);
						integers_array0_1[array_index0_1] = (int) Z_LVAL_PP(temp_array_value0_1);
						array_index0_1++;
					}
					else
					{
						integers_continue0_1 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxStatusBar::SetStatusWidths((int) n0, (const int*) integers_array0_1)\n\n");
				#endif

				((wxStatusBar_php*)native_object)->SetStatusWidths((int) n0, (const int*) integers_array0_1);

				delete[] integers_array0_1;

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxStatusBar::SetStatusWidths\n");
	}
}
/* }}} */

BEGIN_EXTERN_C()
void php_wxToolBar_free(void *object TSRMLS_DC) 
{
    zo_wxToolBar* custom_object = (zo_wxToolBar*) object;
    
	#ifdef USE_WXPHP_DEBUG
	php_printf("Obviate delete call for wxToolBar on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n\n");
	#endif

	zend_object_std_dtor(&custom_object->zo TSRMLS_CC);
    efree(custom_object);
}

zend_object_value php_wxToolBar_new(zend_class_entry *class_type TSRMLS_DC)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxToolBar_new on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	zval *temp;
    zend_object_value retval;
    zo_wxToolBar* custom_object;
    custom_object = (zo_wxToolBar*) emalloc(sizeof(zo_wxToolBar));

    zend_object_std_init(&custom_object->zo, class_type TSRMLS_CC);

#if PHP_VERSION_ID < 50399
	ALLOC_HASHTABLE(custom_object->zo.properties);
    zend_hash_init(custom_object->zo.properties, 0, NULL, ZVAL_PTR_DTOR, 0);
    zend_hash_copy(custom_object->zo.properties, &class_type->default_properties, (copy_ctor_func_t) zval_add_ref,(void *) &temp, sizeof(zval *));
#else
	object_properties_init(&custom_object->zo, class_type);
#endif

	retval.handle = zend_objects_store_put(custom_object, NULL, php_wxToolBar_free, NULL TSRMLS_CC);
	retval.handlers = zend_get_std_object_handlers();

    custom_object->native_object = NULL;
	custom_object->object_type = PHP_WXTOOLBAR_TYPE;
	custom_object->is_user_initialized = 0;
	
    return retval;
}
END_EXTERN_C()

/* {{{ proto  wxToolBar::wxToolBar()
   Default constructor. */
PHP_METHOD(php_wxToolBar, __construct)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::__construct\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	int arguments_received = ZEND_NUM_ARGS();
	
	
	//Parameters for overload 0
	bool overload0_called = false;
	//Parameters for overload 1
	zval* parent1 = 0;
	wxWindow* object_pointer1_0 = 0;
	long id1;
	zval* pos1 = 0;
	wxPoint* object_pointer1_2 = 0;
	zval* size1 = 0;
	wxSize* object_pointer1_3 = 0;
	long style1;
	char* name1;
	long name_len1;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received >= 2  && arguments_received <= 6)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|OOls' (&parent1, &id1, &pos1, php_wxPoint_entry, &size1, php_wxSize_entry, &style1, &name1, &name_len1)\n");
		#endif

		char parse_parameters_string[] = "zl|OOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent1, &id1, &pos1, php_wxPoint_entry, &size1, php_wxSize_entry, &style1, &name1, &name_len1 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxWindow*) argument_native_object;
					if (!object_pointer1_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos1 TSRMLS_CC))->native_object;
					object_pointer1_2 = (wxPoint*) argument_native_object;
					if (!object_pointer1_2 )
					{
						zend_error(E_ERROR, "Parameter 'pos' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(pos1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'pos' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->native_object;
					object_pointer1_3 = (wxSize*) argument_native_object;
					if (!object_pointer1_3 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct()\n");
				#endif

				native_object = new wxToolBar_php();

				native_object->references.Initialize();
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1)\n");
				#endif

				native_object = new wxToolBar_php((wxWindow*) object_pointer1_0, (wxWindowID) id1);

				native_object->references.Initialize();
				((wxToolBar_php*) native_object)->references.AddReference(parent1, "wxToolBar::wxToolBar at call with 2 argument(s)");
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2)\n");
				#endif

				native_object = new wxToolBar_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2);

				native_object->references.Initialize();
				((wxToolBar_php*) native_object)->references.AddReference(parent1, "wxToolBar::wxToolBar at call with 3 argument(s)");
				((wxToolBar_php*) native_object)->references.AddReference(pos1, "wxToolBar::wxToolBar at call with 3 argument(s)");
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3)\n");
				#endif

				native_object = new wxToolBar_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3);

				native_object->references.Initialize();
				((wxToolBar_php*) native_object)->references.AddReference(parent1, "wxToolBar::wxToolBar at call with 4 argument(s)");
				((wxToolBar_php*) native_object)->references.AddReference(pos1, "wxToolBar::wxToolBar at call with 4 argument(s)");
				((wxToolBar_php*) native_object)->references.AddReference(size1, "wxToolBar::wxToolBar at call with 4 argument(s)");
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1)\n");
				#endif

				native_object = new wxToolBar_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1);

				native_object->references.Initialize();
				((wxToolBar_php*) native_object)->references.AddReference(parent1, "wxToolBar::wxToolBar at call with 5 argument(s)");
				((wxToolBar_php*) native_object)->references.AddReference(pos1, "wxToolBar::wxToolBar at call with 5 argument(s)");
				((wxToolBar_php*) native_object)->references.AddReference(size1, "wxToolBar::wxToolBar at call with 5 argument(s)");
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1, wxString(name1, wxConvUTF8))\n");
				#endif

				native_object = new wxToolBar_php((wxWindow*) object_pointer1_0, (wxWindowID) id1, *(wxPoint*) object_pointer1_2, *(wxSize*) object_pointer1_3, (long) style1, wxString(name1, wxConvUTF8));

				native_object->references.Initialize();
				((wxToolBar_php*) native_object)->references.AddReference(parent1, "wxToolBar::wxToolBar at call with 6 argument(s)");
				((wxToolBar_php*) native_object)->references.AddReference(pos1, "wxToolBar::wxToolBar at call with 6 argument(s)");
				((wxToolBar_php*) native_object)->references.AddReference(size1, "wxToolBar::wxToolBar at call with 6 argument(s)");
				break;
			}
		}
	}

		
	if(already_called)
	{
		native_object->phpObj = getThis();
		

		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		current_object->native_object = native_object;
		
		current_object->is_user_initialized = 1;
		
		#ifdef ZTS 
		native_object->TSRMLS_C = TSRMLS_C;
		#endif
	}
	else
	{
		zend_error(E_ERROR, "Abstract class or wrong type/count of parameters passed to: wxToolBar::__construct\n");
	}
	
	#ifdef USE_WXPHP_DEBUG
		php_printf("===========================================\n\n");
	#endif
}
/* }}} */

/* {{{ proto  wxToolBar::ToggleTool(int toolId, bool toggle)
   Toggles a tool on or off. */
PHP_METHOD(php_wxToolBar, ToggleTool)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::ToggleTool\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::ToggleTool call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long toolId0;
	bool toggle0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'lb' (&toolId0, &toggle0)\n");
		#endif

		char parse_parameters_string[] = "lb";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &toolId0, &toggle0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::ToggleTool((int) toolId0, toggle0)\n\n");
				#endif

				((wxToolBar_php*)native_object)->ToggleTool((int) toolId0, toggle0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::ToggleTool\n");
	}
}
/* }}} */

/* {{{ proto  wxToolBar::SetToolShortHelp(int toolId, string helpString)
   Sets the short help for the given tool. */
PHP_METHOD(php_wxToolBar, SetToolShortHelp)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::SetToolShortHelp\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::SetToolShortHelp call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long toolId0;
	char* helpString0;
	long helpString_len0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'ls' (&toolId0, &helpString0, &helpString_len0)\n");
		#endif

		char parse_parameters_string[] = "ls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &toolId0, &helpString0, &helpString_len0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::SetToolShortHelp((int) toolId0, wxString(helpString0, wxConvUTF8))\n\n");
				#endif

				((wxToolBar_php*)native_object)->SetToolShortHelp((int) toolId0, wxString(helpString0, wxConvUTF8));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::SetToolShortHelp\n");
	}
}
/* }}} */

/* {{{ proto  wxToolBar::SetToolSeparation(int separation)
   Sets the default separator size. */
PHP_METHOD(php_wxToolBar, SetToolSeparation)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::SetToolSeparation\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::SetToolSeparation call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long separation0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&separation0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &separation0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::SetToolSeparation((int) separation0)\n\n");
				#endif

				((wxToolBar_php*)native_object)->SetToolSeparation((int) separation0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::SetToolSeparation\n");
	}
}
/* }}} */

/* {{{ proto  wxToolBar::SetToolPacking(int packing)
   Sets the value used for spacing tools. */
PHP_METHOD(php_wxToolBar, SetToolPacking)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::SetToolPacking\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::SetToolPacking call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long packing0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&packing0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &packing0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::SetToolPacking((int) packing0)\n\n");
				#endif

				((wxToolBar_php*)native_object)->SetToolPacking((int) packing0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::SetToolPacking\n");
	}
}
/* }}} */

/* {{{ proto  wxToolBar::SetToolNormalBitmap(int id, wxBitmap bitmap)
   Sets the bitmap to be used by the tool with the given ID. */
PHP_METHOD(php_wxToolBar, SetToolNormalBitmap)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::SetToolNormalBitmap\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::SetToolNormalBitmap call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long id0;
	zval* bitmap0 = 0;
	wxBitmap* object_pointer0_1 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'lO' (&id0, &bitmap0, php_wxBitmap_entry)\n");
		#endif

		char parse_parameters_string[] = "lO";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &id0, &bitmap0, php_wxBitmap_entry ) == SUCCESS)
		{
			if(arguments_received >= 2){
				if(Z_TYPE_P(bitmap0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(bitmap0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(bitmap0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxBitmap*) argument_native_object;
					if (!object_pointer0_1 )
					{
						zend_error(E_ERROR, "Parameter 'bitmap' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(bitmap0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'bitmap' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::SetToolNormalBitmap((int) id0, *(wxBitmap*) object_pointer0_1)\n\n");
				#endif

				((wxToolBar_php*)native_object)->SetToolNormalBitmap((int) id0, *(wxBitmap*) object_pointer0_1);

				references->AddReference(bitmap0, "wxToolBar::SetToolNormalBitmap at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::SetToolNormalBitmap\n");
	}
}
/* }}} */

/* {{{ proto  wxToolBar::SetToolLongHelp(int toolId, string helpString)
   Sets the long help for the given tool. */
PHP_METHOD(php_wxToolBar, SetToolLongHelp)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::SetToolLongHelp\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::SetToolLongHelp call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long toolId0;
	char* helpString0;
	long helpString_len0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'ls' (&toolId0, &helpString0, &helpString_len0)\n");
		#endif

		char parse_parameters_string[] = "ls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &toolId0, &helpString0, &helpString_len0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::SetToolLongHelp((int) toolId0, wxString(helpString0, wxConvUTF8))\n\n");
				#endif

				((wxToolBar_php*)native_object)->SetToolLongHelp((int) toolId0, wxString(helpString0, wxConvUTF8));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::SetToolLongHelp\n");
	}
}
/* }}} */

/* {{{ proto  wxToolBar::SetToolDisabledBitmap(int id, wxBitmap bitmap)
   Sets the bitmap to be used by the tool with the given ID when the tool is in a disabled state. */
PHP_METHOD(php_wxToolBar, SetToolDisabledBitmap)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::SetToolDisabledBitmap\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::SetToolDisabledBitmap call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long id0;
	zval* bitmap0 = 0;
	wxBitmap* object_pointer0_1 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'lO' (&id0, &bitmap0, php_wxBitmap_entry)\n");
		#endif

		char parse_parameters_string[] = "lO";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &id0, &bitmap0, php_wxBitmap_entry ) == SUCCESS)
		{
			if(arguments_received >= 2){
				if(Z_TYPE_P(bitmap0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(bitmap0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(bitmap0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxBitmap*) argument_native_object;
					if (!object_pointer0_1 )
					{
						zend_error(E_ERROR, "Parameter 'bitmap' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(bitmap0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'bitmap' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::SetToolDisabledBitmap((int) id0, *(wxBitmap*) object_pointer0_1)\n\n");
				#endif

				((wxToolBar_php*)native_object)->SetToolDisabledBitmap((int) id0, *(wxBitmap*) object_pointer0_1);

				references->AddReference(bitmap0, "wxToolBar::SetToolDisabledBitmap at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::SetToolDisabledBitmap\n");
	}
}
/* }}} */

/* {{{ proto  wxToolBar::SetToolClientData(int id, wxObject &clientData)
   Sets the client data associated with the tool. */
PHP_METHOD(php_wxToolBar, SetToolClientData)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::SetToolClientData\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::SetToolClientData call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long id0;
	zval* clientData0 = 0;
	wxObject* object_pointer0_1 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'lz' (&id0, &clientData0)\n");
		#endif

		char parse_parameters_string[] = "lz";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &id0, &clientData0 ) == SUCCESS)
		{
			if(arguments_received >= 2){
				if(Z_TYPE_P(clientData0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxObject*) zend_object_store_get_object(clientData0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxObject*) zend_object_store_get_object(clientData0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxObject*) argument_native_object;
					if (!object_pointer0_1 || (argument_type != PHP_WXOBJECT_TYPE && argument_type != PHP_WXEVTHANDLER_TYPE && argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE && argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE && argument_type != PHP_WXMENU_TYPE && argument_type != PHP_WXAUIMANAGER_TYPE && argument_type != PHP_WXMOUSEEVENTSMANAGER_TYPE && argument_type != PHP_WXTIMER_TYPE && argument_type != PHP_WXEVENTBLOCKER_TYPE && argument_type != PHP_WXPROCESS_TYPE && argument_type != PHP_WXFILESYSTEMWATCHER_TYPE && argument_type != PHP_WXTASKBARICON_TYPE && argument_type != PHP_WXNOTIFICATIONMESSAGE_TYPE && argument_type != PHP_WXBITMAPHANDLER_TYPE && argument_type != PHP_WXIMAGE_TYPE && argument_type != PHP_WXSIZER_TYPE && argument_type != PHP_WXBOXSIZER_TYPE && argument_type != PHP_WXSTATICBOXSIZER_TYPE && argument_type != PHP_WXWRAPSIZER_TYPE && argument_type != PHP_WXSTDDIALOGBUTTONSIZER_TYPE && argument_type != PHP_WXGRIDSIZER_TYPE && argument_type != PHP_WXFLEXGRIDSIZER_TYPE && argument_type != PHP_WXGRIDBAGSIZER_TYPE && argument_type != PHP_WXSIZERITEM_TYPE && argument_type != PHP_WXGBSIZERITEM_TYPE && argument_type != PHP_WXIMAGELIST_TYPE && argument_type != PHP_WXDC_TYPE && argument_type != PHP_WXWINDOWDC_TYPE && argument_type != PHP_WXCLIENTDC_TYPE && argument_type != PHP_WXPAINTDC_TYPE && argument_type != PHP_WXSCREENDC_TYPE && argument_type != PHP_WXPOSTSCRIPTDC_TYPE && argument_type != PHP_WXPRINTERDC_TYPE && argument_type != PHP_WXMEMORYDC_TYPE && argument_type != PHP_WXBUFFEREDDC_TYPE && argument_type != PHP_WXBUFFEREDPAINTDC_TYPE && argument_type != PHP_WXAUTOBUFFEREDPAINTDC_TYPE && argument_type != PHP_WXMIRRORDC_TYPE && argument_type != PHP_WXCOLOUR_TYPE && argument_type != PHP_WXMENUITEM_TYPE && argument_type != PHP_WXEVENT_TYPE && argument_type != PHP_WXMENUEVENT_TYPE && argument_type != PHP_WXKEYEVENT_TYPE && argument_type != PHP_WXCOMMANDEVENT_TYPE && argument_type != PHP_WXNOTIFYEVENT_TYPE && argument_type != PHP_WXTREEEVENT_TYPE && argument_type != PHP_WXBOOKCTRLEVENT_TYPE && argument_type != PHP_WXAUINOTEBOOKEVENT_TYPE && argument_type != PHP_WXAUITOOLBAREVENT_TYPE && argument_type != PHP_WXLISTEVENT_TYPE && argument_type != PHP_WXSPINEVENT_TYPE && argument_type != PHP_WXSPLITTEREVENT_TYPE && argument_type != PHP_WXSPINDOUBLEEVENT_TYPE && argument_type != PHP_WXGRIDSIZEEVENT_TYPE && argument_type != PHP_WXWIZARDEVENT_TYPE && argument_type != PHP_WXGRIDEVENT_TYPE && argument_type != PHP_WXGRIDRANGESELECTEVENT_TYPE && argument_type != PHP_WXDATAVIEWEVENT_TYPE && argument_type != PHP_WXHEADERCTRLEVENT_TYPE && argument_type != PHP_WXRIBBONBAREVENT_TYPE && argument_type != PHP_WXWEBVIEWEVENT_TYPE && argument_type != PHP_WXMEDIAEVENT_TYPE && argument_type != PHP_WXSTYLEDTEXTEVENT_TYPE && argument_type != PHP_WXCHILDFOCUSEVENT_TYPE && argument_type != PHP_WXHTMLCELLEVENT_TYPE && argument_type != PHP_WXHTMLLINKEVENT_TYPE && argument_type != PHP_WXHYPERLINKEVENT_TYPE && argument_type != PHP_WXCOLOURPICKEREVENT_TYPE && argument_type != PHP_WXFONTPICKEREVENT_TYPE && argument_type != PHP_WXSCROLLEVENT_TYPE && argument_type != PHP_WXWINDOWMODALDIALOGEVENT_TYPE && argument_type != PHP_WXDATEEVENT_TYPE && argument_type != PHP_WXCALENDAREVENT_TYPE && argument_type != PHP_WXWINDOWCREATEEVENT_TYPE && argument_type != PHP_WXWINDOWDESTROYEVENT_TYPE && argument_type != PHP_WXUPDATEUIEVENT_TYPE && argument_type != PHP_WXHELPEVENT_TYPE && argument_type != PHP_WXGRIDEDITORCREATEDEVENT_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANEEVENT_TYPE && argument_type != PHP_WXCLIPBOARDTEXTEVENT_TYPE && argument_type != PHP_WXFILECTRLEVENT_TYPE && argument_type != PHP_WXSASHEVENT_TYPE && argument_type != PHP_WXFILEDIRPICKEREVENT_TYPE && argument_type != PHP_WXCONTEXTMENUEVENT_TYPE && argument_type != PHP_WXRIBBONBUTTONBAREVENT_TYPE && argument_type != PHP_WXRIBBONGALLERYEVENT_TYPE && argument_type != PHP_WXCLOSEEVENT_TYPE && argument_type != PHP_WXACTIVATEEVENT_TYPE && argument_type != PHP_WXAUIMANAGEREVENT_TYPE && argument_type != PHP_WXSIZEEVENT_TYPE && argument_type != PHP_WXMOUSEEVENT_TYPE && argument_type != PHP_WXMOVEEVENT_TYPE && argument_type != PHP_WXTIMEREVENT_TYPE && argument_type != PHP_WXTHREADEVENT_TYPE && argument_type != PHP_WXSCROLLWINEVENT_TYPE && argument_type != PHP_WXSYSCOLOURCHANGEDEVENT_TYPE && argument_type != PHP_WXPROCESSEVENT_TYPE && argument_type != PHP_WXERASEEVENT_TYPE && argument_type != PHP_WXSETCURSOREVENT_TYPE && argument_type != PHP_WXIDLEEVENT_TYPE && argument_type != PHP_WXPAINTEVENT_TYPE && argument_type != PHP_WXPALETTECHANGEDEVENT_TYPE && argument_type != PHP_WXINITDIALOGEVENT_TYPE && argument_type != PHP_WXMAXIMIZEEVENT_TYPE && argument_type != PHP_WXNAVIGATIONKEYEVENT_TYPE && argument_type != PHP_WXFOCUSEVENT_TYPE && argument_type != PHP_WXFILESYSTEMWATCHEREVENT_TYPE && argument_type != PHP_WXDISPLAYCHANGEDEVENT_TYPE && argument_type != PHP_WXCALCULATELAYOUTEVENT_TYPE && argument_type != PHP_WXQUERYLAYOUTINFOEVENT_TYPE && argument_type != PHP_WXTASKBARICONEVENT_TYPE && argument_type != PHP_WXACCELERATORTABLE_TYPE && argument_type != PHP_WXGDIOBJECT_TYPE && argument_type != PHP_WXBITMAP_TYPE && argument_type != PHP_WXPALETTE_TYPE && argument_type != PHP_WXICON_TYPE && argument_type != PHP_WXFONT_TYPE && argument_type != PHP_WXANIMATION_TYPE && argument_type != PHP_WXICONBUNDLE_TYPE && argument_type != PHP_WXCURSOR_TYPE && argument_type != PHP_WXREGION_TYPE && argument_type != PHP_WXPEN_TYPE && argument_type != PHP_WXBRUSH_TYPE && argument_type != PHP_WXARTPROVIDER_TYPE && argument_type != PHP_WXHTMLCELL_TYPE && argument_type != PHP_WXHTMLCONTAINERCELL_TYPE && argument_type != PHP_WXHTMLCOLOURCELL_TYPE && argument_type != PHP_WXHTMLWIDGETCELL_TYPE && argument_type != PHP_WXHTMLEASYPRINTING_TYPE && argument_type != PHP_WXHTMLLINKINFO_TYPE && argument_type != PHP_WXFINDREPLACEDATA_TYPE && argument_type != PHP_WXSOUND_TYPE && argument_type != PHP_WXFILESYSTEM_TYPE && argument_type != PHP_WXFILESYSTEMHANDLER_TYPE && argument_type != PHP_WXMASK_TYPE && argument_type != PHP_WXTOOLTIP_TYPE && argument_type != PHP_WXGRAPHICSRENDERER_TYPE && argument_type != PHP_WXLAYOUTCONSTRAINTS_TYPE && argument_type != PHP_WXFSFILE_TYPE && argument_type != PHP_WXCOLOURDATA_TYPE && argument_type != PHP_WXFONTDATA_TYPE && argument_type != PHP_WXGRIDTABLEBASE_TYPE && argument_type != PHP_WXDATAVIEWRENDERER_TYPE && argument_type != PHP_WXDATAVIEWBITMAPRENDERER_TYPE && argument_type != PHP_WXDATAVIEWCHOICERENDERER_TYPE && argument_type != PHP_WXDATAVIEWCUSTOMRENDERER_TYPE && argument_type != PHP_WXDATAVIEWSPINRENDERER_TYPE && argument_type != PHP_WXDATAVIEWDATERENDERER_TYPE && argument_type != PHP_WXDATAVIEWICONTEXTRENDERER_TYPE && argument_type != PHP_WXDATAVIEWPROGRESSRENDERER_TYPE && argument_type != PHP_WXDATAVIEWTEXTRENDERER_TYPE && argument_type != PHP_WXDATAVIEWTOGGLERENDERER_TYPE && argument_type != PHP_WXDATAVIEWICONTEXT_TYPE && argument_type != PHP_WXVARIANT_TYPE && argument_type != PHP_WXCLIPBOARD_TYPE && argument_type != PHP_WXCONFIGBASE_TYPE && argument_type != PHP_WXFILECONFIG_TYPE && argument_type != PHP_WXXMLRESOURCE_TYPE && argument_type != PHP_WXPAGESETUPDIALOG_TYPE && argument_type != PHP_WXPAGESETUPDIALOGDATA_TYPE && argument_type != PHP_WXPRINTDIALOG_TYPE && argument_type != PHP_WXPRINTDIALOGDATA_TYPE && argument_type != PHP_WXPRINTDATA_TYPE && argument_type != PHP_WXPRINTPREVIEW_TYPE && argument_type != PHP_WXPRINTER_TYPE && argument_type != PHP_WXPRINTOUT_TYPE && argument_type != PHP_WXHTMLPRINTOUT_TYPE && argument_type != PHP_WXHTMLDCRENDERER_TYPE && argument_type != PHP_WXHTMLFILTER_TYPE && argument_type != PHP_WXHTMLHELPDATA_TYPE && argument_type != PHP_WXHTMLTAGHANDLER_TYPE && argument_type != PHP_WXHTMLWINTAGHANDLER_TYPE && argument_type != PHP_WXMODULE_TYPE && argument_type != PHP_WXHTMLTAGSMODULE_TYPE && argument_type != PHP_WXIMAGEHANDLER_TYPE && argument_type != PHP_WXXMLRESOURCEHANDLER_TYPE && argument_type != PHP_WXXMLDOCUMENT_TYPE && argument_type != PHP_WXLAYOUTALGORITHM_TYPE && argument_type != PHP_WXFILEHISTORY_TYPE && argument_type != PHP_WXTOOLBARTOOLBASE_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'clientData' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(clientData0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'clientData' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::SetToolClientData((int) id0, (wxObject*) object_pointer0_1)\n\n");
				#endif

				((wxToolBar_php*)native_object)->SetToolClientData((int) id0, (wxObject*) object_pointer0_1);

				references->AddReference(clientData0, "wxToolBar::SetToolClientData at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::SetToolClientData\n");
	}
}
/* }}} */

/* {{{ proto  wxToolBar::SetToolBitmapSize(wxSize size)
   Sets the default size of each tool bitmap. */
PHP_METHOD(php_wxToolBar, SetToolBitmapSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::SetToolBitmapSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::SetToolBitmapSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* size0 = 0;
	wxSize* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&size0, php_wxSize_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &size0, php_wxSize_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(size0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxSize*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::SetToolBitmapSize(*(wxSize*) object_pointer0_0)\n\n");
				#endif

				((wxToolBar_php*)native_object)->SetToolBitmapSize(*(wxSize*) object_pointer0_0);

				references->AddReference(size0, "wxToolBar::SetToolBitmapSize at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::SetToolBitmapSize\n");
	}
}
/* }}} */

/* {{{ proto  wxToolBar::SetMargins(wxSize size)
   Set the margins for the toolbar. */
PHP_METHOD(php_wxToolBar, SetMargins)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::SetMargins\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::SetMargins call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* size0 = 0;
	wxSize* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&size0, php_wxSize_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &size0, php_wxSize_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(size0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxSize*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::SetMargins(*(wxSize*) object_pointer0_0)\n\n");
				#endif

				((wxToolBar_php*)native_object)->SetMargins(*(wxSize*) object_pointer0_0);

				references->AddReference(size0, "wxToolBar::SetMargins at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::SetMargins\n");
	}
}
/* }}} */

/* {{{ proto bool wxToolBar::SetDropdownMenu(int id, wxMenu &menu)
   Sets the dropdown menu for the tool given by its id. */
PHP_METHOD(php_wxToolBar, SetDropdownMenu)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::SetDropdownMenu\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::SetDropdownMenu call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long id0;
	zval* menu0 = 0;
	wxMenu* object_pointer0_1 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'lz' (&id0, &menu0)\n");
		#endif

		char parse_parameters_string[] = "lz";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &id0, &menu0 ) == SUCCESS)
		{
			if(arguments_received >= 2){
				if(Z_TYPE_P(menu0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxMenu*) zend_object_store_get_object(menu0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxMenu*) zend_object_store_get_object(menu0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxMenu*) argument_native_object;
					if (!object_pointer0_1 || (argument_type != PHP_WXMENU_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'menu' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(menu0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'menu' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxToolBar::SetDropdownMenu((int) id0, (wxMenu*) object_pointer0_1))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxToolBar_php*)native_object)->SetDropdownMenu((int) id0, (wxMenu*) object_pointer0_1));

				references->AddReference(menu0, "wxToolBar::SetDropdownMenu at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::SetDropdownMenu\n");
	}
}
/* }}} */

/* {{{ proto  wxToolBar::OnMouseEnter(int toolId)
   This is called when the mouse cursor moves into a tool or out of the toolbar. */
void wxToolBar_php::OnMouseEnter(int toolId)
{
	static zend_function* cached_function = NULL;
	static bool is_php_user_space_implemented = true;
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking virtual wxToolBar::OnMouseEnter\n");
	php_printf("===========================================\n");
	#endif
	
	zval** params[1];
	zval *arguments[1];
	
	//Initilize arguments array
	for(int i=0; i<1; i++)
	{
		ALLOC_INIT_ZVAL(arguments[i]);
	}

	zval* return_value;
	MAKE_STD_ZVAL(return_value);
	zval function_name;
	ZVAL_STRING(&function_name, "OnMouseEnter", 0);
	char* temp_string;
	void* return_object;
	int function_called;
	
	//Parameters for conversion
	ZVAL_LONG(arguments[0], toolId);
		
	for(int i=0; i<1; i++)
	{
		params[i] = &arguments[i];
	}

	#ifdef USE_WXPHP_DEBUG
	php_printf("Trying to call user defined method\n");
	#endif
	
	if(is_php_user_space_implemented)
	{
		function_called = wxphp_call_method((zval**) &this->phpObj, NULL, &cached_function, "OnMouseEnter", 12, &return_value, 1, params TSRMLS_CC);
	}
	else
	{
		function_called = FAILURE;
	}
    
    	
	//Delete already used parameters from memory
	for(int i=0; i<1; i++)
	{
		zval_ptr_dtor(&arguments[i]);
	}
	
	if(function_called == FAILURE)
	{
		is_php_user_space_implemented = false;
		
		#ifdef USE_WXPHP_DEBUG
		php_printf("Invocation of user defined method failed\n");
		#endif
		
	}
	else
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Returning userspace value.\n");
		#endif
		
		return;
	}
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling original method\n");
	php_printf("===========================================\n\n");
	#endif
	
	//Call original method
	wxToolBar::OnMouseEnter(toolId);
}
/* }}} */

/* {{{ proto bool wxToolBar::OnLeftClick(int toolId, bool toggleDown)
   Called when the user clicks on a tool with the left mouse button. */
bool wxToolBar_php::OnLeftClick(int toolId, bool toggleDown)
{
	static zend_function* cached_function = NULL;
	static bool is_php_user_space_implemented = true;
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking virtual wxToolBar::OnLeftClick\n");
	php_printf("===========================================\n");
	#endif
	
	zval** params[2];
	zval *arguments[2];
	
	//Initilize arguments array
	for(int i=0; i<2; i++)
	{
		ALLOC_INIT_ZVAL(arguments[i]);
	}

	zval* return_value;
	MAKE_STD_ZVAL(return_value);
	zval function_name;
	ZVAL_STRING(&function_name, "OnLeftClick", 0);
	char* temp_string;
	void* return_object;
	int function_called;
	
	//Parameters for conversion
	ZVAL_LONG(arguments[0], toolId);
	ZVAL_BOOL(arguments[1], toggleDown);
		
	for(int i=0; i<2; i++)
	{
		params[i] = &arguments[i];
	}

	#ifdef USE_WXPHP_DEBUG
	php_printf("Trying to call user defined method\n");
	#endif
	
	if(is_php_user_space_implemented)
	{
		function_called = wxphp_call_method((zval**) &this->phpObj, NULL, &cached_function, "OnLeftClick", 11, &return_value, 2, params TSRMLS_CC);
	}
	else
	{
		function_called = FAILURE;
	}
    
    	
	//Delete already used parameters from memory
	for(int i=0; i<2; i++)
	{
		zval_ptr_dtor(&arguments[i]);
	}
	
	if(function_called == FAILURE)
	{
		is_php_user_space_implemented = false;
		
		#ifdef USE_WXPHP_DEBUG
		php_printf("Invocation of user defined method failed\n");
		#endif
		
	}
	else
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Returning userspace value.\n");
		#endif
		
		return Z_BVAL_P(return_value);
	}
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling original method\n");
	php_printf("===========================================\n\n");
	#endif
	
	//Call original method
	return wxToolBar::OnLeftClick(toolId, toggleDown);
}
/* }}} */

/* {{{ proto int wxToolBar::GetToolsCount()
   Returns the number of tools in the toolbar. */
PHP_METHOD(php_wxToolBar, GetToolsCount)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::GetToolsCount\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::GetToolsCount call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxToolBar::GetToolsCount())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxToolBar_php*)native_object)->GetToolsCount());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::GetToolsCount\n");
	}
}
/* }}} */

/* {{{ proto bool wxToolBar::GetToolState(int toolId)
   Gets the on/off state of a toggle tool. */
PHP_METHOD(php_wxToolBar, GetToolState)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::GetToolState\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::GetToolState call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long toolId0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&toolId0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &toolId0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxToolBar::GetToolState((int) toolId0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxToolBar_php*)native_object)->GetToolState((int) toolId0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::GetToolState\n");
	}
}
/* }}} */

/* {{{ proto wxSize wxToolBar::GetToolSize()
   Returns the size of a whole button, which is usually larger than a tool bitmap because of added 3D effects. */
PHP_METHOD(php_wxToolBar, GetToolSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::GetToolSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::GetToolSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::GetToolSize() to return new object\n\n");
				#endif

				wxSize value_to_return0;
				value_to_return0 = ((wxToolBar_php*)native_object)->GetToolSize();
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo0 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxSize_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::GetToolSize\n");
	}
}
/* }}} */

/* {{{ proto string wxToolBar::GetToolShortHelp(int toolId)
   Returns the short help for the given tool. */
PHP_METHOD(php_wxToolBar, GetToolShortHelp)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::GetToolShortHelp\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::GetToolShortHelp call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long toolId0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&toolId0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &toolId0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_STRING(wxToolBar::GetToolShortHelp((int) toolId0).fn_str(), 1)\n\n");
				#endif

				wxString value_to_return1;
				value_to_return1 = ((wxToolBar_php*)native_object)->GetToolShortHelp((int) toolId0);
				char* temp_string1;
				temp_string1 = (char*)malloc(sizeof(wxChar)*(value_to_return1.size()+1));
				strcpy (temp_string1, (const char *) value_to_return1.char_str() );
				ZVAL_STRING(return_value, temp_string1, 1);
				free(temp_string1);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::GetToolShortHelp\n");
	}
}
/* }}} */

/* {{{ proto int wxToolBar::GetToolSeparation()
   Returns the default separator size. */
PHP_METHOD(php_wxToolBar, GetToolSeparation)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::GetToolSeparation\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::GetToolSeparation call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxToolBar::GetToolSeparation())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxToolBar_php*)native_object)->GetToolSeparation());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::GetToolSeparation\n");
	}
}
/* }}} */

/* {{{ proto int wxToolBar::GetToolPos(int toolId)
   Returns the tool position in the toolbar, or wxNOT_FOUND if the tool is not found. */
PHP_METHOD(php_wxToolBar, GetToolPos)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::GetToolPos\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::GetToolPos call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long toolId0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&toolId0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &toolId0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxToolBar::GetToolPos((int) toolId0))\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxToolBar_php*)native_object)->GetToolPos((int) toolId0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::GetToolPos\n");
	}
}
/* }}} */

/* {{{ proto int wxToolBar::GetToolPacking()
   Returns the value used for packing tools. */
PHP_METHOD(php_wxToolBar, GetToolPacking)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::GetToolPacking\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::GetToolPacking call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxToolBar::GetToolPacking())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxToolBar_php*)native_object)->GetToolPacking());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::GetToolPacking\n");
	}
}
/* }}} */

/* {{{ proto string wxToolBar::GetToolLongHelp(int toolId)
   Returns the long help for the given tool. */
PHP_METHOD(php_wxToolBar, GetToolLongHelp)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::GetToolLongHelp\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::GetToolLongHelp call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long toolId0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&toolId0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &toolId0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_STRING(wxToolBar::GetToolLongHelp((int) toolId0).fn_str(), 1)\n\n");
				#endif

				wxString value_to_return1;
				value_to_return1 = ((wxToolBar_php*)native_object)->GetToolLongHelp((int) toolId0);
				char* temp_string1;
				temp_string1 = (char*)malloc(sizeof(wxChar)*(value_to_return1.size()+1));
				strcpy (temp_string1, (const char *) value_to_return1.char_str() );
				ZVAL_STRING(return_value, temp_string1, 1);
				free(temp_string1);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::GetToolLongHelp\n");
	}
}
/* }}} */

/* {{{ proto bool wxToolBar::GetToolEnabled(int toolId)
   Called to determine whether a tool is enabled (responds to user input). */
PHP_METHOD(php_wxToolBar, GetToolEnabled)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::GetToolEnabled\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::GetToolEnabled call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long toolId0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&toolId0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &toolId0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxToolBar::GetToolEnabled((int) toolId0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxToolBar_php*)native_object)->GetToolEnabled((int) toolId0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::GetToolEnabled\n");
	}
}
/* }}} */

/* {{{ proto wxObject wxToolBar::GetToolClientData(int toolId)
   Get any client data associated with the tool. */
PHP_METHOD(php_wxToolBar, GetToolClientData)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::GetToolClientData\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::GetToolClientData call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long toolId0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&toolId0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &toolId0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::GetToolClientData((int) toolId0) to return object pointer\n\n");
				#endif

				wxObject_php* value_to_return1;
				value_to_return1 = (wxObject_php*) ((wxToolBar_php*)native_object)->GetToolClientData((int) toolId0);

				if(value_to_return1 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return1->references.IsUserInitialized()){
					if(value_to_return1->phpObj != NULL){
						*return_value = *value_to_return1->phpObj;
						zval_add_ref(&value_to_return1->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxObject_entry);
					((zo_wxObject*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxObject_php*) value_to_return1;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return1 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::GetToolClientData at call with 1 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::GetToolClientData\n");
	}
}
/* }}} */

/* {{{ proto wxSize wxToolBar::GetToolBitmapSize()
   Returns the size of bitmap that the toolbar expects to have. */
PHP_METHOD(php_wxToolBar, GetToolBitmapSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::GetToolBitmapSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::GetToolBitmapSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::GetToolBitmapSize() to return new object\n\n");
				#endif

				wxSize value_to_return0;
				value_to_return0 = ((wxToolBar_php*)native_object)->GetToolBitmapSize();
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo0 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxSize_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::GetToolBitmapSize\n");
	}
}
/* }}} */

/* {{{ proto wxSize wxToolBar::GetMargins()
   Returns the left/right and top/bottom margins, which are also used for inter-toolspacing. */
PHP_METHOD(php_wxToolBar, GetMargins)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::GetMargins\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::GetMargins call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::GetMargins() to return new object\n\n");
				#endif

				wxSize value_to_return0;
				value_to_return0 = ((wxToolBar_php*)native_object)->GetMargins();
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo0 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxSize_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::GetMargins\n");
	}
}
/* }}} */

/* {{{ proto wxControl wxToolBar::FindControl(int id)
   Returns a pointer to the control identified by id or NULL if no corresponding control is found. */
PHP_METHOD(php_wxToolBar, FindControl)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::FindControl\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::FindControl call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long id0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&id0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &id0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::FindControl((int) id0) to return object pointer\n\n");
				#endif

				wxControl_php* value_to_return1;
				value_to_return1 = (wxControl_php*) ((wxToolBar_php*)native_object)->FindControl((int) id0);

				if(value_to_return1 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return1->references.IsUserInitialized()){
					if(value_to_return1->phpObj != NULL){
						*return_value = *value_to_return1->phpObj;
						zval_add_ref(&value_to_return1->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxControl_entry);
					((zo_wxControl*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxControl_php*) value_to_return1;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return1 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::FindControl at call with 1 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::FindControl\n");
	}
}
/* }}} */

/* {{{ proto  wxToolBar::EnableTool(int toolId, bool enable)
   Enables or disables the tool. */
PHP_METHOD(php_wxToolBar, EnableTool)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::EnableTool\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::EnableTool call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long toolId0;
	bool enable0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'lb' (&toolId0, &enable0)\n");
		#endif

		char parse_parameters_string[] = "lb";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &toolId0, &enable0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::EnableTool((int) toolId0, enable0)\n\n");
				#endif

				((wxToolBar_php*)native_object)->EnableTool((int) toolId0, enable0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::EnableTool\n");
	}
}
/* }}} */

/* {{{ proto bool wxToolBar::DeleteToolByPos(int pos)
   This function behaves like DeleteTool() but it deletes the tool at the specified position and not the one with the given id. */
PHP_METHOD(php_wxToolBar, DeleteToolByPos)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::DeleteToolByPos\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::DeleteToolByPos call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long pos0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&pos0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pos0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxToolBar::DeleteToolByPos((size_t) pos0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxToolBar_php*)native_object)->DeleteToolByPos((size_t) pos0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::DeleteToolByPos\n");
	}
}
/* }}} */

/* {{{ proto bool wxToolBar::DeleteTool(int toolId)
   Removes the specified tool from the toolbar and deletes it. */
PHP_METHOD(php_wxToolBar, DeleteTool)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::DeleteTool\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::DeleteTool call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long toolId0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&toolId0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &toolId0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxToolBar::DeleteTool((int) toolId0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxToolBar_php*)native_object)->DeleteTool((int) toolId0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::DeleteTool\n");
	}
}
/* }}} */

/* {{{ proto  wxToolBar::ClearTools()
   Deletes all the tools in the toolbar. */
PHP_METHOD(php_wxToolBar, ClearTools)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::ClearTools\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::ClearTools call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::ClearTools()\n\n");
				#endif

				((wxToolBar_php*)native_object)->ClearTools();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::ClearTools\n");
	}
}
/* }}} */

/* {{{ proto wxToolBarToolBase wxToolBar::AddCheckTool(int toolId, string label, wxBitmap bitmap1, wxBitmap bmpDisabled, string shortHelp, string longHelp, wxObject &clientData)
   Adds a new check (or toggle) tool to the toolbar. */
PHP_METHOD(php_wxToolBar, AddCheckTool)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::AddCheckTool\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::AddCheckTool call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long toolId0;
	char* label0;
	long label_len0;
	zval* bitmap10 = 0;
	wxBitmap* object_pointer0_2 = 0;
	zval* bmpDisabled0 = 0;
	wxBitmap* object_pointer0_3 = 0;
	char* shortHelp0;
	long shortHelp_len0;
	char* longHelp0;
	long longHelp_len0;
	zval* clientData0 = 0;
	wxObject* object_pointer0_6 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 3  && arguments_received <= 7)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'lsO|Ossz' (&toolId0, &label0, &label_len0, &bitmap10, php_wxBitmap_entry, &bmpDisabled0, php_wxBitmap_entry, &shortHelp0, &shortHelp_len0, &longHelp0, &longHelp_len0, &clientData0)\n");
		#endif

		char parse_parameters_string[] = "lsO|Ossz";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &toolId0, &label0, &label_len0, &bitmap10, php_wxBitmap_entry, &bmpDisabled0, php_wxBitmap_entry, &shortHelp0, &shortHelp_len0, &longHelp0, &longHelp_len0, &clientData0 ) == SUCCESS)
		{
			if(arguments_received >= 3){
				if(Z_TYPE_P(bitmap10) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(bitmap10 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(bitmap10 TSRMLS_CC))->native_object;
					object_pointer0_2 = (wxBitmap*) argument_native_object;
					if (!object_pointer0_2 )
					{
						zend_error(E_ERROR, "Parameter 'bitmap1' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(bitmap10) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'bitmap1' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(bmpDisabled0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(bmpDisabled0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(bmpDisabled0 TSRMLS_CC))->native_object;
					object_pointer0_3 = (wxBitmap*) argument_native_object;
					if (!object_pointer0_3 )
					{
						zend_error(E_ERROR, "Parameter 'bmpDisabled' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(bmpDisabled0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'bmpDisabled' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(clientData0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxObject*) zend_object_store_get_object(clientData0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxObject*) zend_object_store_get_object(clientData0 TSRMLS_CC))->native_object;
					object_pointer0_6 = (wxObject*) argument_native_object;
					if (!object_pointer0_6 || (argument_type != PHP_WXOBJECT_TYPE && argument_type != PHP_WXEVTHANDLER_TYPE && argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE && argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE && argument_type != PHP_WXMENU_TYPE && argument_type != PHP_WXAUIMANAGER_TYPE && argument_type != PHP_WXMOUSEEVENTSMANAGER_TYPE && argument_type != PHP_WXTIMER_TYPE && argument_type != PHP_WXEVENTBLOCKER_TYPE && argument_type != PHP_WXPROCESS_TYPE && argument_type != PHP_WXFILESYSTEMWATCHER_TYPE && argument_type != PHP_WXTASKBARICON_TYPE && argument_type != PHP_WXNOTIFICATIONMESSAGE_TYPE && argument_type != PHP_WXBITMAPHANDLER_TYPE && argument_type != PHP_WXIMAGE_TYPE && argument_type != PHP_WXSIZER_TYPE && argument_type != PHP_WXBOXSIZER_TYPE && argument_type != PHP_WXSTATICBOXSIZER_TYPE && argument_type != PHP_WXWRAPSIZER_TYPE && argument_type != PHP_WXSTDDIALOGBUTTONSIZER_TYPE && argument_type != PHP_WXGRIDSIZER_TYPE && argument_type != PHP_WXFLEXGRIDSIZER_TYPE && argument_type != PHP_WXGRIDBAGSIZER_TYPE && argument_type != PHP_WXSIZERITEM_TYPE && argument_type != PHP_WXGBSIZERITEM_TYPE && argument_type != PHP_WXIMAGELIST_TYPE && argument_type != PHP_WXDC_TYPE && argument_type != PHP_WXWINDOWDC_TYPE && argument_type != PHP_WXCLIENTDC_TYPE && argument_type != PHP_WXPAINTDC_TYPE && argument_type != PHP_WXSCREENDC_TYPE && argument_type != PHP_WXPOSTSCRIPTDC_TYPE && argument_type != PHP_WXPRINTERDC_TYPE && argument_type != PHP_WXMEMORYDC_TYPE && argument_type != PHP_WXBUFFEREDDC_TYPE && argument_type != PHP_WXBUFFEREDPAINTDC_TYPE && argument_type != PHP_WXAUTOBUFFEREDPAINTDC_TYPE && argument_type != PHP_WXMIRRORDC_TYPE && argument_type != PHP_WXCOLOUR_TYPE && argument_type != PHP_WXMENUITEM_TYPE && argument_type != PHP_WXEVENT_TYPE && argument_type != PHP_WXMENUEVENT_TYPE && argument_type != PHP_WXKEYEVENT_TYPE && argument_type != PHP_WXCOMMANDEVENT_TYPE && argument_type != PHP_WXNOTIFYEVENT_TYPE && argument_type != PHP_WXTREEEVENT_TYPE && argument_type != PHP_WXBOOKCTRLEVENT_TYPE && argument_type != PHP_WXAUINOTEBOOKEVENT_TYPE && argument_type != PHP_WXAUITOOLBAREVENT_TYPE && argument_type != PHP_WXLISTEVENT_TYPE && argument_type != PHP_WXSPINEVENT_TYPE && argument_type != PHP_WXSPLITTEREVENT_TYPE && argument_type != PHP_WXSPINDOUBLEEVENT_TYPE && argument_type != PHP_WXGRIDSIZEEVENT_TYPE && argument_type != PHP_WXWIZARDEVENT_TYPE && argument_type != PHP_WXGRIDEVENT_TYPE && argument_type != PHP_WXGRIDRANGESELECTEVENT_TYPE && argument_type != PHP_WXDATAVIEWEVENT_TYPE && argument_type != PHP_WXHEADERCTRLEVENT_TYPE && argument_type != PHP_WXRIBBONBAREVENT_TYPE && argument_type != PHP_WXWEBVIEWEVENT_TYPE && argument_type != PHP_WXMEDIAEVENT_TYPE && argument_type != PHP_WXSTYLEDTEXTEVENT_TYPE && argument_type != PHP_WXCHILDFOCUSEVENT_TYPE && argument_type != PHP_WXHTMLCELLEVENT_TYPE && argument_type != PHP_WXHTMLLINKEVENT_TYPE && argument_type != PHP_WXHYPERLINKEVENT_TYPE && argument_type != PHP_WXCOLOURPICKEREVENT_TYPE && argument_type != PHP_WXFONTPICKEREVENT_TYPE && argument_type != PHP_WXSCROLLEVENT_TYPE && argument_type != PHP_WXWINDOWMODALDIALOGEVENT_TYPE && argument_type != PHP_WXDATEEVENT_TYPE && argument_type != PHP_WXCALENDAREVENT_TYPE && argument_type != PHP_WXWINDOWCREATEEVENT_TYPE && argument_type != PHP_WXWINDOWDESTROYEVENT_TYPE && argument_type != PHP_WXUPDATEUIEVENT_TYPE && argument_type != PHP_WXHELPEVENT_TYPE && argument_type != PHP_WXGRIDEDITORCREATEDEVENT_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANEEVENT_TYPE && argument_type != PHP_WXCLIPBOARDTEXTEVENT_TYPE && argument_type != PHP_WXFILECTRLEVENT_TYPE && argument_type != PHP_WXSASHEVENT_TYPE && argument_type != PHP_WXFILEDIRPICKEREVENT_TYPE && argument_type != PHP_WXCONTEXTMENUEVENT_TYPE && argument_type != PHP_WXRIBBONBUTTONBAREVENT_TYPE && argument_type != PHP_WXRIBBONGALLERYEVENT_TYPE && argument_type != PHP_WXCLOSEEVENT_TYPE && argument_type != PHP_WXACTIVATEEVENT_TYPE && argument_type != PHP_WXAUIMANAGEREVENT_TYPE && argument_type != PHP_WXSIZEEVENT_TYPE && argument_type != PHP_WXMOUSEEVENT_TYPE && argument_type != PHP_WXMOVEEVENT_TYPE && argument_type != PHP_WXTIMEREVENT_TYPE && argument_type != PHP_WXTHREADEVENT_TYPE && argument_type != PHP_WXSCROLLWINEVENT_TYPE && argument_type != PHP_WXSYSCOLOURCHANGEDEVENT_TYPE && argument_type != PHP_WXPROCESSEVENT_TYPE && argument_type != PHP_WXERASEEVENT_TYPE && argument_type != PHP_WXSETCURSOREVENT_TYPE && argument_type != PHP_WXIDLEEVENT_TYPE && argument_type != PHP_WXPAINTEVENT_TYPE && argument_type != PHP_WXPALETTECHANGEDEVENT_TYPE && argument_type != PHP_WXINITDIALOGEVENT_TYPE && argument_type != PHP_WXMAXIMIZEEVENT_TYPE && argument_type != PHP_WXNAVIGATIONKEYEVENT_TYPE && argument_type != PHP_WXFOCUSEVENT_TYPE && argument_type != PHP_WXFILESYSTEMWATCHEREVENT_TYPE && argument_type != PHP_WXDISPLAYCHANGEDEVENT_TYPE && argument_type != PHP_WXCALCULATELAYOUTEVENT_TYPE && argument_type != PHP_WXQUERYLAYOUTINFOEVENT_TYPE && argument_type != PHP_WXTASKBARICONEVENT_TYPE && argument_type != PHP_WXACCELERATORTABLE_TYPE && argument_type != PHP_WXGDIOBJECT_TYPE && argument_type != PHP_WXBITMAP_TYPE && argument_type != PHP_WXPALETTE_TYPE && argument_type != PHP_WXICON_TYPE && argument_type != PHP_WXFONT_TYPE && argument_type != PHP_WXANIMATION_TYPE && argument_type != PHP_WXICONBUNDLE_TYPE && argument_type != PHP_WXCURSOR_TYPE && argument_type != PHP_WXREGION_TYPE && argument_type != PHP_WXPEN_TYPE && argument_type != PHP_WXBRUSH_TYPE && argument_type != PHP_WXARTPROVIDER_TYPE && argument_type != PHP_WXHTMLCELL_TYPE && argument_type != PHP_WXHTMLCONTAINERCELL_TYPE && argument_type != PHP_WXHTMLCOLOURCELL_TYPE && argument_type != PHP_WXHTMLWIDGETCELL_TYPE && argument_type != PHP_WXHTMLEASYPRINTING_TYPE && argument_type != PHP_WXHTMLLINKINFO_TYPE && argument_type != PHP_WXFINDREPLACEDATA_TYPE && argument_type != PHP_WXSOUND_TYPE && argument_type != PHP_WXFILESYSTEM_TYPE && argument_type != PHP_WXFILESYSTEMHANDLER_TYPE && argument_type != PHP_WXMASK_TYPE && argument_type != PHP_WXTOOLTIP_TYPE && argument_type != PHP_WXGRAPHICSRENDERER_TYPE && argument_type != PHP_WXLAYOUTCONSTRAINTS_TYPE && argument_type != PHP_WXFSFILE_TYPE && argument_type != PHP_WXCOLOURDATA_TYPE && argument_type != PHP_WXFONTDATA_TYPE && argument_type != PHP_WXGRIDTABLEBASE_TYPE && argument_type != PHP_WXDATAVIEWRENDERER_TYPE && argument_type != PHP_WXDATAVIEWBITMAPRENDERER_TYPE && argument_type != PHP_WXDATAVIEWCHOICERENDERER_TYPE && argument_type != PHP_WXDATAVIEWCUSTOMRENDERER_TYPE && argument_type != PHP_WXDATAVIEWSPINRENDERER_TYPE && argument_type != PHP_WXDATAVIEWDATERENDERER_TYPE && argument_type != PHP_WXDATAVIEWICONTEXTRENDERER_TYPE && argument_type != PHP_WXDATAVIEWPROGRESSRENDERER_TYPE && argument_type != PHP_WXDATAVIEWTEXTRENDERER_TYPE && argument_type != PHP_WXDATAVIEWTOGGLERENDERER_TYPE && argument_type != PHP_WXDATAVIEWICONTEXT_TYPE && argument_type != PHP_WXVARIANT_TYPE && argument_type != PHP_WXCLIPBOARD_TYPE && argument_type != PHP_WXCONFIGBASE_TYPE && argument_type != PHP_WXFILECONFIG_TYPE && argument_type != PHP_WXXMLRESOURCE_TYPE && argument_type != PHP_WXPAGESETUPDIALOG_TYPE && argument_type != PHP_WXPAGESETUPDIALOGDATA_TYPE && argument_type != PHP_WXPRINTDIALOG_TYPE && argument_type != PHP_WXPRINTDIALOGDATA_TYPE && argument_type != PHP_WXPRINTDATA_TYPE && argument_type != PHP_WXPRINTPREVIEW_TYPE && argument_type != PHP_WXPRINTER_TYPE && argument_type != PHP_WXPRINTOUT_TYPE && argument_type != PHP_WXHTMLPRINTOUT_TYPE && argument_type != PHP_WXHTMLDCRENDERER_TYPE && argument_type != PHP_WXHTMLFILTER_TYPE && argument_type != PHP_WXHTMLHELPDATA_TYPE && argument_type != PHP_WXHTMLTAGHANDLER_TYPE && argument_type != PHP_WXHTMLWINTAGHANDLER_TYPE && argument_type != PHP_WXMODULE_TYPE && argument_type != PHP_WXHTMLTAGSMODULE_TYPE && argument_type != PHP_WXIMAGEHANDLER_TYPE && argument_type != PHP_WXXMLRESOURCEHANDLER_TYPE && argument_type != PHP_WXXMLDOCUMENT_TYPE && argument_type != PHP_WXLAYOUTALGORITHM_TYPE && argument_type != PHP_WXFILEHISTORY_TYPE && argument_type != PHP_WXTOOLBARTOOLBASE_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'clientData' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(clientData0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'clientData' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddCheckTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return3;
				value_to_return3 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddCheckTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2);

				if(value_to_return3 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return3->references.IsUserInitialized()){
					if(value_to_return3->phpObj != NULL){
						*return_value = *value_to_return3->phpObj;
						zval_add_ref(&value_to_return3->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return3;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return3 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddCheckTool at call with 3 argument(s)");
				}

				references->AddReference(bitmap10, "wxToolBar::AddCheckTool at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddCheckTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, *(wxBitmap*) object_pointer0_3) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return4;
				value_to_return4 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddCheckTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, *(wxBitmap*) object_pointer0_3);

				if(value_to_return4 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return4->references.IsUserInitialized()){
					if(value_to_return4->phpObj != NULL){
						*return_value = *value_to_return4->phpObj;
						zval_add_ref(&value_to_return4->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return4;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return4 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddCheckTool at call with 4 argument(s)");
				}

				references->AddReference(bitmap10, "wxToolBar::AddCheckTool at call with 4 argument(s)");
				references->AddReference(bmpDisabled0, "wxToolBar::AddCheckTool at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddCheckTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, *(wxBitmap*) object_pointer0_3, wxString(shortHelp0, wxConvUTF8)) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return5;
				value_to_return5 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddCheckTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, *(wxBitmap*) object_pointer0_3, wxString(shortHelp0, wxConvUTF8));

				if(value_to_return5 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return5->references.IsUserInitialized()){
					if(value_to_return5->phpObj != NULL){
						*return_value = *value_to_return5->phpObj;
						zval_add_ref(&value_to_return5->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return5;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return5 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddCheckTool at call with 5 argument(s)");
				}

				references->AddReference(bitmap10, "wxToolBar::AddCheckTool at call with 5 argument(s)");
				references->AddReference(bmpDisabled0, "wxToolBar::AddCheckTool at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddCheckTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, *(wxBitmap*) object_pointer0_3, wxString(shortHelp0, wxConvUTF8), wxString(longHelp0, wxConvUTF8)) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return6;
				value_to_return6 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddCheckTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, *(wxBitmap*) object_pointer0_3, wxString(shortHelp0, wxConvUTF8), wxString(longHelp0, wxConvUTF8));

				if(value_to_return6 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return6->references.IsUserInitialized()){
					if(value_to_return6->phpObj != NULL){
						*return_value = *value_to_return6->phpObj;
						zval_add_ref(&value_to_return6->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return6;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return6 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddCheckTool at call with 6 argument(s)");
				}

				references->AddReference(bitmap10, "wxToolBar::AddCheckTool at call with 6 argument(s)");
				references->AddReference(bmpDisabled0, "wxToolBar::AddCheckTool at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddCheckTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, *(wxBitmap*) object_pointer0_3, wxString(shortHelp0, wxConvUTF8), wxString(longHelp0, wxConvUTF8), (wxObject*) object_pointer0_6) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return7;
				value_to_return7 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddCheckTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, *(wxBitmap*) object_pointer0_3, wxString(shortHelp0, wxConvUTF8), wxString(longHelp0, wxConvUTF8), (wxObject*) object_pointer0_6);

				if(value_to_return7 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return7->references.IsUserInitialized()){
					if(value_to_return7->phpObj != NULL){
						*return_value = *value_to_return7->phpObj;
						zval_add_ref(&value_to_return7->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return7;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return7 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddCheckTool at call with 7 argument(s)");
				}

				references->AddReference(bitmap10, "wxToolBar::AddCheckTool at call with 7 argument(s)");
				references->AddReference(bmpDisabled0, "wxToolBar::AddCheckTool at call with 7 argument(s)");
				references->AddReference(clientData0, "wxToolBar::AddCheckTool at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::AddCheckTool\n");
	}
}
/* }}} */

/* {{{ proto wxToolBarToolBase wxToolBar::AddControl(wxControl &control, string label)
   Adds any control to the toolbar, typically e.g. a wxComboBox. */
PHP_METHOD(php_wxToolBar, AddControl)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::AddControl\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::AddControl call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* control0 = 0;
	wxControl* object_pointer0_0 = 0;
	char* label0;
	long label_len0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|s' (&control0, &label0, &label_len0)\n");
		#endif

		char parse_parameters_string[] = "z|s";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &control0, &label0, &label_len0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(control0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxControl*) zend_object_store_get_object(control0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxControl*) zend_object_store_get_object(control0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxControl*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'control' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(control0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'control' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddControl((wxControl*) object_pointer0_0) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return1;
				value_to_return1 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddControl((wxControl*) object_pointer0_0);

				if(value_to_return1 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return1->references.IsUserInitialized()){
					if(value_to_return1->phpObj != NULL){
						*return_value = *value_to_return1->phpObj;
						zval_add_ref(&value_to_return1->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return1;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return1 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddControl at call with 1 argument(s)");
				}

				references->AddReference(control0, "wxToolBar::AddControl at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddControl((wxControl*) object_pointer0_0, wxString(label0, wxConvUTF8)) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return2;
				value_to_return2 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddControl((wxControl*) object_pointer0_0, wxString(label0, wxConvUTF8));

				if(value_to_return2 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return2->references.IsUserInitialized()){
					if(value_to_return2->phpObj != NULL){
						*return_value = *value_to_return2->phpObj;
						zval_add_ref(&value_to_return2->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return2;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return2 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddControl at call with 2 argument(s)");
				}

				references->AddReference(control0, "wxToolBar::AddControl at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::AddControl\n");
	}
}
/* }}} */

/* {{{ proto wxToolBarToolBase wxToolBar::AddRadioTool(int toolId, string label, wxBitmap bitmap1, wxBitmap bmpDisabled, string shortHelp, string longHelp, wxObject &clientData)
   Adds a new radio tool to the toolbar. */
PHP_METHOD(php_wxToolBar, AddRadioTool)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::AddRadioTool\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::AddRadioTool call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long toolId0;
	char* label0;
	long label_len0;
	zval* bitmap10 = 0;
	wxBitmap* object_pointer0_2 = 0;
	zval* bmpDisabled0 = 0;
	wxBitmap* object_pointer0_3 = 0;
	char* shortHelp0;
	long shortHelp_len0;
	char* longHelp0;
	long longHelp_len0;
	zval* clientData0 = 0;
	wxObject* object_pointer0_6 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 3  && arguments_received <= 7)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'lsO|Ossz' (&toolId0, &label0, &label_len0, &bitmap10, php_wxBitmap_entry, &bmpDisabled0, php_wxBitmap_entry, &shortHelp0, &shortHelp_len0, &longHelp0, &longHelp_len0, &clientData0)\n");
		#endif

		char parse_parameters_string[] = "lsO|Ossz";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &toolId0, &label0, &label_len0, &bitmap10, php_wxBitmap_entry, &bmpDisabled0, php_wxBitmap_entry, &shortHelp0, &shortHelp_len0, &longHelp0, &longHelp_len0, &clientData0 ) == SUCCESS)
		{
			if(arguments_received >= 3){
				if(Z_TYPE_P(bitmap10) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(bitmap10 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(bitmap10 TSRMLS_CC))->native_object;
					object_pointer0_2 = (wxBitmap*) argument_native_object;
					if (!object_pointer0_2 )
					{
						zend_error(E_ERROR, "Parameter 'bitmap1' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(bitmap10) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'bitmap1' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(bmpDisabled0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(bmpDisabled0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(bmpDisabled0 TSRMLS_CC))->native_object;
					object_pointer0_3 = (wxBitmap*) argument_native_object;
					if (!object_pointer0_3 )
					{
						zend_error(E_ERROR, "Parameter 'bmpDisabled' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(bmpDisabled0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'bmpDisabled' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(clientData0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxObject*) zend_object_store_get_object(clientData0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxObject*) zend_object_store_get_object(clientData0 TSRMLS_CC))->native_object;
					object_pointer0_6 = (wxObject*) argument_native_object;
					if (!object_pointer0_6 || (argument_type != PHP_WXOBJECT_TYPE && argument_type != PHP_WXEVTHANDLER_TYPE && argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE && argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE && argument_type != PHP_WXMENU_TYPE && argument_type != PHP_WXAUIMANAGER_TYPE && argument_type != PHP_WXMOUSEEVENTSMANAGER_TYPE && argument_type != PHP_WXTIMER_TYPE && argument_type != PHP_WXEVENTBLOCKER_TYPE && argument_type != PHP_WXPROCESS_TYPE && argument_type != PHP_WXFILESYSTEMWATCHER_TYPE && argument_type != PHP_WXTASKBARICON_TYPE && argument_type != PHP_WXNOTIFICATIONMESSAGE_TYPE && argument_type != PHP_WXBITMAPHANDLER_TYPE && argument_type != PHP_WXIMAGE_TYPE && argument_type != PHP_WXSIZER_TYPE && argument_type != PHP_WXBOXSIZER_TYPE && argument_type != PHP_WXSTATICBOXSIZER_TYPE && argument_type != PHP_WXWRAPSIZER_TYPE && argument_type != PHP_WXSTDDIALOGBUTTONSIZER_TYPE && argument_type != PHP_WXGRIDSIZER_TYPE && argument_type != PHP_WXFLEXGRIDSIZER_TYPE && argument_type != PHP_WXGRIDBAGSIZER_TYPE && argument_type != PHP_WXSIZERITEM_TYPE && argument_type != PHP_WXGBSIZERITEM_TYPE && argument_type != PHP_WXIMAGELIST_TYPE && argument_type != PHP_WXDC_TYPE && argument_type != PHP_WXWINDOWDC_TYPE && argument_type != PHP_WXCLIENTDC_TYPE && argument_type != PHP_WXPAINTDC_TYPE && argument_type != PHP_WXSCREENDC_TYPE && argument_type != PHP_WXPOSTSCRIPTDC_TYPE && argument_type != PHP_WXPRINTERDC_TYPE && argument_type != PHP_WXMEMORYDC_TYPE && argument_type != PHP_WXBUFFEREDDC_TYPE && argument_type != PHP_WXBUFFEREDPAINTDC_TYPE && argument_type != PHP_WXAUTOBUFFEREDPAINTDC_TYPE && argument_type != PHP_WXMIRRORDC_TYPE && argument_type != PHP_WXCOLOUR_TYPE && argument_type != PHP_WXMENUITEM_TYPE && argument_type != PHP_WXEVENT_TYPE && argument_type != PHP_WXMENUEVENT_TYPE && argument_type != PHP_WXKEYEVENT_TYPE && argument_type != PHP_WXCOMMANDEVENT_TYPE && argument_type != PHP_WXNOTIFYEVENT_TYPE && argument_type != PHP_WXTREEEVENT_TYPE && argument_type != PHP_WXBOOKCTRLEVENT_TYPE && argument_type != PHP_WXAUINOTEBOOKEVENT_TYPE && argument_type != PHP_WXAUITOOLBAREVENT_TYPE && argument_type != PHP_WXLISTEVENT_TYPE && argument_type != PHP_WXSPINEVENT_TYPE && argument_type != PHP_WXSPLITTEREVENT_TYPE && argument_type != PHP_WXSPINDOUBLEEVENT_TYPE && argument_type != PHP_WXGRIDSIZEEVENT_TYPE && argument_type != PHP_WXWIZARDEVENT_TYPE && argument_type != PHP_WXGRIDEVENT_TYPE && argument_type != PHP_WXGRIDRANGESELECTEVENT_TYPE && argument_type != PHP_WXDATAVIEWEVENT_TYPE && argument_type != PHP_WXHEADERCTRLEVENT_TYPE && argument_type != PHP_WXRIBBONBAREVENT_TYPE && argument_type != PHP_WXWEBVIEWEVENT_TYPE && argument_type != PHP_WXMEDIAEVENT_TYPE && argument_type != PHP_WXSTYLEDTEXTEVENT_TYPE && argument_type != PHP_WXCHILDFOCUSEVENT_TYPE && argument_type != PHP_WXHTMLCELLEVENT_TYPE && argument_type != PHP_WXHTMLLINKEVENT_TYPE && argument_type != PHP_WXHYPERLINKEVENT_TYPE && argument_type != PHP_WXCOLOURPICKEREVENT_TYPE && argument_type != PHP_WXFONTPICKEREVENT_TYPE && argument_type != PHP_WXSCROLLEVENT_TYPE && argument_type != PHP_WXWINDOWMODALDIALOGEVENT_TYPE && argument_type != PHP_WXDATEEVENT_TYPE && argument_type != PHP_WXCALENDAREVENT_TYPE && argument_type != PHP_WXWINDOWCREATEEVENT_TYPE && argument_type != PHP_WXWINDOWDESTROYEVENT_TYPE && argument_type != PHP_WXUPDATEUIEVENT_TYPE && argument_type != PHP_WXHELPEVENT_TYPE && argument_type != PHP_WXGRIDEDITORCREATEDEVENT_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANEEVENT_TYPE && argument_type != PHP_WXCLIPBOARDTEXTEVENT_TYPE && argument_type != PHP_WXFILECTRLEVENT_TYPE && argument_type != PHP_WXSASHEVENT_TYPE && argument_type != PHP_WXFILEDIRPICKEREVENT_TYPE && argument_type != PHP_WXCONTEXTMENUEVENT_TYPE && argument_type != PHP_WXRIBBONBUTTONBAREVENT_TYPE && argument_type != PHP_WXRIBBONGALLERYEVENT_TYPE && argument_type != PHP_WXCLOSEEVENT_TYPE && argument_type != PHP_WXACTIVATEEVENT_TYPE && argument_type != PHP_WXAUIMANAGEREVENT_TYPE && argument_type != PHP_WXSIZEEVENT_TYPE && argument_type != PHP_WXMOUSEEVENT_TYPE && argument_type != PHP_WXMOVEEVENT_TYPE && argument_type != PHP_WXTIMEREVENT_TYPE && argument_type != PHP_WXTHREADEVENT_TYPE && argument_type != PHP_WXSCROLLWINEVENT_TYPE && argument_type != PHP_WXSYSCOLOURCHANGEDEVENT_TYPE && argument_type != PHP_WXPROCESSEVENT_TYPE && argument_type != PHP_WXERASEEVENT_TYPE && argument_type != PHP_WXSETCURSOREVENT_TYPE && argument_type != PHP_WXIDLEEVENT_TYPE && argument_type != PHP_WXPAINTEVENT_TYPE && argument_type != PHP_WXPALETTECHANGEDEVENT_TYPE && argument_type != PHP_WXINITDIALOGEVENT_TYPE && argument_type != PHP_WXMAXIMIZEEVENT_TYPE && argument_type != PHP_WXNAVIGATIONKEYEVENT_TYPE && argument_type != PHP_WXFOCUSEVENT_TYPE && argument_type != PHP_WXFILESYSTEMWATCHEREVENT_TYPE && argument_type != PHP_WXDISPLAYCHANGEDEVENT_TYPE && argument_type != PHP_WXCALCULATELAYOUTEVENT_TYPE && argument_type != PHP_WXQUERYLAYOUTINFOEVENT_TYPE && argument_type != PHP_WXTASKBARICONEVENT_TYPE && argument_type != PHP_WXACCELERATORTABLE_TYPE && argument_type != PHP_WXGDIOBJECT_TYPE && argument_type != PHP_WXBITMAP_TYPE && argument_type != PHP_WXPALETTE_TYPE && argument_type != PHP_WXICON_TYPE && argument_type != PHP_WXFONT_TYPE && argument_type != PHP_WXANIMATION_TYPE && argument_type != PHP_WXICONBUNDLE_TYPE && argument_type != PHP_WXCURSOR_TYPE && argument_type != PHP_WXREGION_TYPE && argument_type != PHP_WXPEN_TYPE && argument_type != PHP_WXBRUSH_TYPE && argument_type != PHP_WXARTPROVIDER_TYPE && argument_type != PHP_WXHTMLCELL_TYPE && argument_type != PHP_WXHTMLCONTAINERCELL_TYPE && argument_type != PHP_WXHTMLCOLOURCELL_TYPE && argument_type != PHP_WXHTMLWIDGETCELL_TYPE && argument_type != PHP_WXHTMLEASYPRINTING_TYPE && argument_type != PHP_WXHTMLLINKINFO_TYPE && argument_type != PHP_WXFINDREPLACEDATA_TYPE && argument_type != PHP_WXSOUND_TYPE && argument_type != PHP_WXFILESYSTEM_TYPE && argument_type != PHP_WXFILESYSTEMHANDLER_TYPE && argument_type != PHP_WXMASK_TYPE && argument_type != PHP_WXTOOLTIP_TYPE && argument_type != PHP_WXGRAPHICSRENDERER_TYPE && argument_type != PHP_WXLAYOUTCONSTRAINTS_TYPE && argument_type != PHP_WXFSFILE_TYPE && argument_type != PHP_WXCOLOURDATA_TYPE && argument_type != PHP_WXFONTDATA_TYPE && argument_type != PHP_WXGRIDTABLEBASE_TYPE && argument_type != PHP_WXDATAVIEWRENDERER_TYPE && argument_type != PHP_WXDATAVIEWBITMAPRENDERER_TYPE && argument_type != PHP_WXDATAVIEWCHOICERENDERER_TYPE && argument_type != PHP_WXDATAVIEWCUSTOMRENDERER_TYPE && argument_type != PHP_WXDATAVIEWSPINRENDERER_TYPE && argument_type != PHP_WXDATAVIEWDATERENDERER_TYPE && argument_type != PHP_WXDATAVIEWICONTEXTRENDERER_TYPE && argument_type != PHP_WXDATAVIEWPROGRESSRENDERER_TYPE && argument_type != PHP_WXDATAVIEWTEXTRENDERER_TYPE && argument_type != PHP_WXDATAVIEWTOGGLERENDERER_TYPE && argument_type != PHP_WXDATAVIEWICONTEXT_TYPE && argument_type != PHP_WXVARIANT_TYPE && argument_type != PHP_WXCLIPBOARD_TYPE && argument_type != PHP_WXCONFIGBASE_TYPE && argument_type != PHP_WXFILECONFIG_TYPE && argument_type != PHP_WXXMLRESOURCE_TYPE && argument_type != PHP_WXPAGESETUPDIALOG_TYPE && argument_type != PHP_WXPAGESETUPDIALOGDATA_TYPE && argument_type != PHP_WXPRINTDIALOG_TYPE && argument_type != PHP_WXPRINTDIALOGDATA_TYPE && argument_type != PHP_WXPRINTDATA_TYPE && argument_type != PHP_WXPRINTPREVIEW_TYPE && argument_type != PHP_WXPRINTER_TYPE && argument_type != PHP_WXPRINTOUT_TYPE && argument_type != PHP_WXHTMLPRINTOUT_TYPE && argument_type != PHP_WXHTMLDCRENDERER_TYPE && argument_type != PHP_WXHTMLFILTER_TYPE && argument_type != PHP_WXHTMLHELPDATA_TYPE && argument_type != PHP_WXHTMLTAGHANDLER_TYPE && argument_type != PHP_WXHTMLWINTAGHANDLER_TYPE && argument_type != PHP_WXMODULE_TYPE && argument_type != PHP_WXHTMLTAGSMODULE_TYPE && argument_type != PHP_WXIMAGEHANDLER_TYPE && argument_type != PHP_WXXMLRESOURCEHANDLER_TYPE && argument_type != PHP_WXXMLDOCUMENT_TYPE && argument_type != PHP_WXLAYOUTALGORITHM_TYPE && argument_type != PHP_WXFILEHISTORY_TYPE && argument_type != PHP_WXTOOLBARTOOLBASE_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'clientData' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(clientData0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'clientData' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddRadioTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return3;
				value_to_return3 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddRadioTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2);

				if(value_to_return3 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return3->references.IsUserInitialized()){
					if(value_to_return3->phpObj != NULL){
						*return_value = *value_to_return3->phpObj;
						zval_add_ref(&value_to_return3->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return3;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return3 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddRadioTool at call with 3 argument(s)");
				}

				references->AddReference(bitmap10, "wxToolBar::AddRadioTool at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddRadioTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, *(wxBitmap*) object_pointer0_3) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return4;
				value_to_return4 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddRadioTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, *(wxBitmap*) object_pointer0_3);

				if(value_to_return4 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return4->references.IsUserInitialized()){
					if(value_to_return4->phpObj != NULL){
						*return_value = *value_to_return4->phpObj;
						zval_add_ref(&value_to_return4->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return4;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return4 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddRadioTool at call with 4 argument(s)");
				}

				references->AddReference(bitmap10, "wxToolBar::AddRadioTool at call with 4 argument(s)");
				references->AddReference(bmpDisabled0, "wxToolBar::AddRadioTool at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddRadioTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, *(wxBitmap*) object_pointer0_3, wxString(shortHelp0, wxConvUTF8)) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return5;
				value_to_return5 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddRadioTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, *(wxBitmap*) object_pointer0_3, wxString(shortHelp0, wxConvUTF8));

				if(value_to_return5 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return5->references.IsUserInitialized()){
					if(value_to_return5->phpObj != NULL){
						*return_value = *value_to_return5->phpObj;
						zval_add_ref(&value_to_return5->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return5;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return5 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddRadioTool at call with 5 argument(s)");
				}

				references->AddReference(bitmap10, "wxToolBar::AddRadioTool at call with 5 argument(s)");
				references->AddReference(bmpDisabled0, "wxToolBar::AddRadioTool at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddRadioTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, *(wxBitmap*) object_pointer0_3, wxString(shortHelp0, wxConvUTF8), wxString(longHelp0, wxConvUTF8)) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return6;
				value_to_return6 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddRadioTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, *(wxBitmap*) object_pointer0_3, wxString(shortHelp0, wxConvUTF8), wxString(longHelp0, wxConvUTF8));

				if(value_to_return6 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return6->references.IsUserInitialized()){
					if(value_to_return6->phpObj != NULL){
						*return_value = *value_to_return6->phpObj;
						zval_add_ref(&value_to_return6->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return6;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return6 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddRadioTool at call with 6 argument(s)");
				}

				references->AddReference(bitmap10, "wxToolBar::AddRadioTool at call with 6 argument(s)");
				references->AddReference(bmpDisabled0, "wxToolBar::AddRadioTool at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddRadioTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, *(wxBitmap*) object_pointer0_3, wxString(shortHelp0, wxConvUTF8), wxString(longHelp0, wxConvUTF8), (wxObject*) object_pointer0_6) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return7;
				value_to_return7 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddRadioTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, *(wxBitmap*) object_pointer0_3, wxString(shortHelp0, wxConvUTF8), wxString(longHelp0, wxConvUTF8), (wxObject*) object_pointer0_6);

				if(value_to_return7 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return7->references.IsUserInitialized()){
					if(value_to_return7->phpObj != NULL){
						*return_value = *value_to_return7->phpObj;
						zval_add_ref(&value_to_return7->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return7;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return7 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddRadioTool at call with 7 argument(s)");
				}

				references->AddReference(bitmap10, "wxToolBar::AddRadioTool at call with 7 argument(s)");
				references->AddReference(bmpDisabled0, "wxToolBar::AddRadioTool at call with 7 argument(s)");
				references->AddReference(clientData0, "wxToolBar::AddRadioTool at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::AddRadioTool\n");
	}
}
/* }}} */

/* {{{ proto wxToolBarToolBase wxToolBar::AddSeparator()
   Adds a separator for spacing groups of tools. */
PHP_METHOD(php_wxToolBar, AddSeparator)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::AddSeparator\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::AddSeparator call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddSeparator() to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return0;
				value_to_return0 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddSeparator();

				if(value_to_return0 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return0->references.IsUserInitialized()){
					if(value_to_return0->phpObj != NULL){
						*return_value = *value_to_return0->phpObj;
						zval_add_ref(&value_to_return0->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return0;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return0 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddSeparator at call with 0 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::AddSeparator\n");
	}
}
/* }}} */

/* {{{ proto wxToolBarToolBase wxToolBar::AddStretchableSpace()
   Adds a stretchable space to the toolbar. */
PHP_METHOD(php_wxToolBar, AddStretchableSpace)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::AddStretchableSpace\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::AddStretchableSpace call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddStretchableSpace() to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return0;
				value_to_return0 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddStretchableSpace();

				if(value_to_return0 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return0->references.IsUserInitialized()){
					if(value_to_return0->phpObj != NULL){
						*return_value = *value_to_return0->phpObj;
						zval_add_ref(&value_to_return0->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return0;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return0 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddStretchableSpace at call with 0 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::AddStretchableSpace\n");
	}
}
/* }}} */

/* {{{ proto wxToolBarToolBase wxToolBar::AddTool(int toolId, string label, wxBitmap bitmap, string shortHelp, wxItemKind kind)
   Adds a tool to the toolbar. */
PHP_METHOD(php_wxToolBar, AddTool)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::AddTool\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::AddTool call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long toolId0;
	char* label0;
	long label_len0;
	zval* bitmap0 = 0;
	wxBitmap* object_pointer0_2 = 0;
	char* shortHelp0;
	long shortHelp_len0;
	long kind0;
	bool overload0_called = false;
	//Parameters for overload 1
	long toolId1;
	char* label1;
	long label_len1;
	zval* bitmap1 = 0;
	wxBitmap* object_pointer1_2 = 0;
	zval* bmpDisabled1 = 0;
	wxBitmap* object_pointer1_3 = 0;
	long kind1;
	char* shortHelpString1;
	long shortHelpString_len1;
	char* longHelpString1;
	long longHelpString_len1;
	zval* clientData1 = 0;
	wxObject* object_pointer1_7 = 0;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 3  && arguments_received <= 5)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'lsO|sl' (&toolId0, &label0, &label_len0, &bitmap0, php_wxBitmap_entry, &shortHelp0, &shortHelp_len0, &kind0)\n");
		#endif

		char parse_parameters_string[] = "lsO|sl";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &toolId0, &label0, &label_len0, &bitmap0, php_wxBitmap_entry, &shortHelp0, &shortHelp_len0, &kind0 ) == SUCCESS)
		{
			if(arguments_received >= 3){
				if(Z_TYPE_P(bitmap0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(bitmap0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(bitmap0 TSRMLS_CC))->native_object;
					object_pointer0_2 = (wxBitmap*) argument_native_object;
					if (!object_pointer0_2 )
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(bitmap0) != IS_NULL)
				{
					goto overload1;
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received >= 4  && arguments_received <= 8)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'lsOO|lssz' (&toolId1, &label1, &label_len1, &bitmap1, php_wxBitmap_entry, &bmpDisabled1, php_wxBitmap_entry, &kind1, &shortHelpString1, &shortHelpString_len1, &longHelpString1, &longHelpString_len1, &clientData1)\n");
		#endif

		char parse_parameters_string[] = "lsOO|lssz";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &toolId1, &label1, &label_len1, &bitmap1, php_wxBitmap_entry, &bmpDisabled1, php_wxBitmap_entry, &kind1, &shortHelpString1, &shortHelpString_len1, &longHelpString1, &longHelpString_len1, &clientData1 ) == SUCCESS)
		{
			if(arguments_received >= 3){
				if(Z_TYPE_P(bitmap1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(bitmap1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(bitmap1 TSRMLS_CC))->native_object;
					object_pointer1_2 = (wxBitmap*) argument_native_object;
					if (!object_pointer1_2 )
					{
						zend_error(E_ERROR, "Parameter 'bitmap' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(bitmap1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'bitmap' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(bmpDisabled1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(bmpDisabled1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(bmpDisabled1 TSRMLS_CC))->native_object;
					object_pointer1_3 = (wxBitmap*) argument_native_object;
					if (!object_pointer1_3 )
					{
						zend_error(E_ERROR, "Parameter 'bmpDisabled' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(bmpDisabled1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'bmpDisabled' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 8){
				if(Z_TYPE_P(clientData1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxObject*) zend_object_store_get_object(clientData1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxObject*) zend_object_store_get_object(clientData1 TSRMLS_CC))->native_object;
					object_pointer1_7 = (wxObject*) argument_native_object;
					if (!object_pointer1_7 || (argument_type != PHP_WXOBJECT_TYPE && argument_type != PHP_WXEVTHANDLER_TYPE && argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE && argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE && argument_type != PHP_WXMENU_TYPE && argument_type != PHP_WXAUIMANAGER_TYPE && argument_type != PHP_WXMOUSEEVENTSMANAGER_TYPE && argument_type != PHP_WXTIMER_TYPE && argument_type != PHP_WXEVENTBLOCKER_TYPE && argument_type != PHP_WXPROCESS_TYPE && argument_type != PHP_WXFILESYSTEMWATCHER_TYPE && argument_type != PHP_WXTASKBARICON_TYPE && argument_type != PHP_WXNOTIFICATIONMESSAGE_TYPE && argument_type != PHP_WXBITMAPHANDLER_TYPE && argument_type != PHP_WXIMAGE_TYPE && argument_type != PHP_WXSIZER_TYPE && argument_type != PHP_WXBOXSIZER_TYPE && argument_type != PHP_WXSTATICBOXSIZER_TYPE && argument_type != PHP_WXWRAPSIZER_TYPE && argument_type != PHP_WXSTDDIALOGBUTTONSIZER_TYPE && argument_type != PHP_WXGRIDSIZER_TYPE && argument_type != PHP_WXFLEXGRIDSIZER_TYPE && argument_type != PHP_WXGRIDBAGSIZER_TYPE && argument_type != PHP_WXSIZERITEM_TYPE && argument_type != PHP_WXGBSIZERITEM_TYPE && argument_type != PHP_WXIMAGELIST_TYPE && argument_type != PHP_WXDC_TYPE && argument_type != PHP_WXWINDOWDC_TYPE && argument_type != PHP_WXCLIENTDC_TYPE && argument_type != PHP_WXPAINTDC_TYPE && argument_type != PHP_WXSCREENDC_TYPE && argument_type != PHP_WXPOSTSCRIPTDC_TYPE && argument_type != PHP_WXPRINTERDC_TYPE && argument_type != PHP_WXMEMORYDC_TYPE && argument_type != PHP_WXBUFFEREDDC_TYPE && argument_type != PHP_WXBUFFEREDPAINTDC_TYPE && argument_type != PHP_WXAUTOBUFFEREDPAINTDC_TYPE && argument_type != PHP_WXMIRRORDC_TYPE && argument_type != PHP_WXCOLOUR_TYPE && argument_type != PHP_WXMENUITEM_TYPE && argument_type != PHP_WXEVENT_TYPE && argument_type != PHP_WXMENUEVENT_TYPE && argument_type != PHP_WXKEYEVENT_TYPE && argument_type != PHP_WXCOMMANDEVENT_TYPE && argument_type != PHP_WXNOTIFYEVENT_TYPE && argument_type != PHP_WXTREEEVENT_TYPE && argument_type != PHP_WXBOOKCTRLEVENT_TYPE && argument_type != PHP_WXAUINOTEBOOKEVENT_TYPE && argument_type != PHP_WXAUITOOLBAREVENT_TYPE && argument_type != PHP_WXLISTEVENT_TYPE && argument_type != PHP_WXSPINEVENT_TYPE && argument_type != PHP_WXSPLITTEREVENT_TYPE && argument_type != PHP_WXSPINDOUBLEEVENT_TYPE && argument_type != PHP_WXGRIDSIZEEVENT_TYPE && argument_type != PHP_WXWIZARDEVENT_TYPE && argument_type != PHP_WXGRIDEVENT_TYPE && argument_type != PHP_WXGRIDRANGESELECTEVENT_TYPE && argument_type != PHP_WXDATAVIEWEVENT_TYPE && argument_type != PHP_WXHEADERCTRLEVENT_TYPE && argument_type != PHP_WXRIBBONBAREVENT_TYPE && argument_type != PHP_WXWEBVIEWEVENT_TYPE && argument_type != PHP_WXMEDIAEVENT_TYPE && argument_type != PHP_WXSTYLEDTEXTEVENT_TYPE && argument_type != PHP_WXCHILDFOCUSEVENT_TYPE && argument_type != PHP_WXHTMLCELLEVENT_TYPE && argument_type != PHP_WXHTMLLINKEVENT_TYPE && argument_type != PHP_WXHYPERLINKEVENT_TYPE && argument_type != PHP_WXCOLOURPICKEREVENT_TYPE && argument_type != PHP_WXFONTPICKEREVENT_TYPE && argument_type != PHP_WXSCROLLEVENT_TYPE && argument_type != PHP_WXWINDOWMODALDIALOGEVENT_TYPE && argument_type != PHP_WXDATEEVENT_TYPE && argument_type != PHP_WXCALENDAREVENT_TYPE && argument_type != PHP_WXWINDOWCREATEEVENT_TYPE && argument_type != PHP_WXWINDOWDESTROYEVENT_TYPE && argument_type != PHP_WXUPDATEUIEVENT_TYPE && argument_type != PHP_WXHELPEVENT_TYPE && argument_type != PHP_WXGRIDEDITORCREATEDEVENT_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANEEVENT_TYPE && argument_type != PHP_WXCLIPBOARDTEXTEVENT_TYPE && argument_type != PHP_WXFILECTRLEVENT_TYPE && argument_type != PHP_WXSASHEVENT_TYPE && argument_type != PHP_WXFILEDIRPICKEREVENT_TYPE && argument_type != PHP_WXCONTEXTMENUEVENT_TYPE && argument_type != PHP_WXRIBBONBUTTONBAREVENT_TYPE && argument_type != PHP_WXRIBBONGALLERYEVENT_TYPE && argument_type != PHP_WXCLOSEEVENT_TYPE && argument_type != PHP_WXACTIVATEEVENT_TYPE && argument_type != PHP_WXAUIMANAGEREVENT_TYPE && argument_type != PHP_WXSIZEEVENT_TYPE && argument_type != PHP_WXMOUSEEVENT_TYPE && argument_type != PHP_WXMOVEEVENT_TYPE && argument_type != PHP_WXTIMEREVENT_TYPE && argument_type != PHP_WXTHREADEVENT_TYPE && argument_type != PHP_WXSCROLLWINEVENT_TYPE && argument_type != PHP_WXSYSCOLOURCHANGEDEVENT_TYPE && argument_type != PHP_WXPROCESSEVENT_TYPE && argument_type != PHP_WXERASEEVENT_TYPE && argument_type != PHP_WXSETCURSOREVENT_TYPE && argument_type != PHP_WXIDLEEVENT_TYPE && argument_type != PHP_WXPAINTEVENT_TYPE && argument_type != PHP_WXPALETTECHANGEDEVENT_TYPE && argument_type != PHP_WXINITDIALOGEVENT_TYPE && argument_type != PHP_WXMAXIMIZEEVENT_TYPE && argument_type != PHP_WXNAVIGATIONKEYEVENT_TYPE && argument_type != PHP_WXFOCUSEVENT_TYPE && argument_type != PHP_WXFILESYSTEMWATCHEREVENT_TYPE && argument_type != PHP_WXDISPLAYCHANGEDEVENT_TYPE && argument_type != PHP_WXCALCULATELAYOUTEVENT_TYPE && argument_type != PHP_WXQUERYLAYOUTINFOEVENT_TYPE && argument_type != PHP_WXTASKBARICONEVENT_TYPE && argument_type != PHP_WXACCELERATORTABLE_TYPE && argument_type != PHP_WXGDIOBJECT_TYPE && argument_type != PHP_WXBITMAP_TYPE && argument_type != PHP_WXPALETTE_TYPE && argument_type != PHP_WXICON_TYPE && argument_type != PHP_WXFONT_TYPE && argument_type != PHP_WXANIMATION_TYPE && argument_type != PHP_WXICONBUNDLE_TYPE && argument_type != PHP_WXCURSOR_TYPE && argument_type != PHP_WXREGION_TYPE && argument_type != PHP_WXPEN_TYPE && argument_type != PHP_WXBRUSH_TYPE && argument_type != PHP_WXARTPROVIDER_TYPE && argument_type != PHP_WXHTMLCELL_TYPE && argument_type != PHP_WXHTMLCONTAINERCELL_TYPE && argument_type != PHP_WXHTMLCOLOURCELL_TYPE && argument_type != PHP_WXHTMLWIDGETCELL_TYPE && argument_type != PHP_WXHTMLEASYPRINTING_TYPE && argument_type != PHP_WXHTMLLINKINFO_TYPE && argument_type != PHP_WXFINDREPLACEDATA_TYPE && argument_type != PHP_WXSOUND_TYPE && argument_type != PHP_WXFILESYSTEM_TYPE && argument_type != PHP_WXFILESYSTEMHANDLER_TYPE && argument_type != PHP_WXMASK_TYPE && argument_type != PHP_WXTOOLTIP_TYPE && argument_type != PHP_WXGRAPHICSRENDERER_TYPE && argument_type != PHP_WXLAYOUTCONSTRAINTS_TYPE && argument_type != PHP_WXFSFILE_TYPE && argument_type != PHP_WXCOLOURDATA_TYPE && argument_type != PHP_WXFONTDATA_TYPE && argument_type != PHP_WXGRIDTABLEBASE_TYPE && argument_type != PHP_WXDATAVIEWRENDERER_TYPE && argument_type != PHP_WXDATAVIEWBITMAPRENDERER_TYPE && argument_type != PHP_WXDATAVIEWCHOICERENDERER_TYPE && argument_type != PHP_WXDATAVIEWCUSTOMRENDERER_TYPE && argument_type != PHP_WXDATAVIEWSPINRENDERER_TYPE && argument_type != PHP_WXDATAVIEWDATERENDERER_TYPE && argument_type != PHP_WXDATAVIEWICONTEXTRENDERER_TYPE && argument_type != PHP_WXDATAVIEWPROGRESSRENDERER_TYPE && argument_type != PHP_WXDATAVIEWTEXTRENDERER_TYPE && argument_type != PHP_WXDATAVIEWTOGGLERENDERER_TYPE && argument_type != PHP_WXDATAVIEWICONTEXT_TYPE && argument_type != PHP_WXVARIANT_TYPE && argument_type != PHP_WXCLIPBOARD_TYPE && argument_type != PHP_WXCONFIGBASE_TYPE && argument_type != PHP_WXFILECONFIG_TYPE && argument_type != PHP_WXXMLRESOURCE_TYPE && argument_type != PHP_WXPAGESETUPDIALOG_TYPE && argument_type != PHP_WXPAGESETUPDIALOGDATA_TYPE && argument_type != PHP_WXPRINTDIALOG_TYPE && argument_type != PHP_WXPRINTDIALOGDATA_TYPE && argument_type != PHP_WXPRINTDATA_TYPE && argument_type != PHP_WXPRINTPREVIEW_TYPE && argument_type != PHP_WXPRINTER_TYPE && argument_type != PHP_WXPRINTOUT_TYPE && argument_type != PHP_WXHTMLPRINTOUT_TYPE && argument_type != PHP_WXHTMLDCRENDERER_TYPE && argument_type != PHP_WXHTMLFILTER_TYPE && argument_type != PHP_WXHTMLHELPDATA_TYPE && argument_type != PHP_WXHTMLTAGHANDLER_TYPE && argument_type != PHP_WXHTMLWINTAGHANDLER_TYPE && argument_type != PHP_WXMODULE_TYPE && argument_type != PHP_WXHTMLTAGSMODULE_TYPE && argument_type != PHP_WXIMAGEHANDLER_TYPE && argument_type != PHP_WXXMLRESOURCEHANDLER_TYPE && argument_type != PHP_WXXMLDOCUMENT_TYPE && argument_type != PHP_WXLAYOUTALGORITHM_TYPE && argument_type != PHP_WXFILEHISTORY_TYPE && argument_type != PHP_WXTOOLBARTOOLBASE_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'clientData' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(clientData1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'clientData' not null, could not be retreived correctly.");
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return3;
				value_to_return3 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2);

				if(value_to_return3 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return3->references.IsUserInitialized()){
					if(value_to_return3->phpObj != NULL){
						*return_value = *value_to_return3->phpObj;
						zval_add_ref(&value_to_return3->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return3;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return3 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddTool at call with 3 argument(s)");
				}

				references->AddReference(bitmap0, "wxToolBar::AddTool at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, wxString(shortHelp0, wxConvUTF8)) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return4;
				value_to_return4 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, wxString(shortHelp0, wxConvUTF8));

				if(value_to_return4 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return4->references.IsUserInitialized()){
					if(value_to_return4->phpObj != NULL){
						*return_value = *value_to_return4->phpObj;
						zval_add_ref(&value_to_return4->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return4;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return4 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddTool at call with 4 argument(s)");
				}

				references->AddReference(bitmap0, "wxToolBar::AddTool at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, wxString(shortHelp0, wxConvUTF8), (wxItemKind) kind0) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return5;
				value_to_return5 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddTool((int) toolId0, wxString(label0, wxConvUTF8), *(wxBitmap*) object_pointer0_2, wxString(shortHelp0, wxConvUTF8), (wxItemKind) kind0);

				if(value_to_return5 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return5->references.IsUserInitialized()){
					if(value_to_return5->phpObj != NULL){
						*return_value = *value_to_return5->phpObj;
						zval_add_ref(&value_to_return5->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return5;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return5 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddTool at call with 5 argument(s)");
				}

				references->AddReference(bitmap0, "wxToolBar::AddTool at call with 5 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddTool((int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_2, *(wxBitmap*) object_pointer1_3) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return4;
				value_to_return4 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddTool((int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_2, *(wxBitmap*) object_pointer1_3);

				if(value_to_return4 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return4->references.IsUserInitialized()){
					if(value_to_return4->phpObj != NULL){
						*return_value = *value_to_return4->phpObj;
						zval_add_ref(&value_to_return4->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return4;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return4 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddTool at call with 4 argument(s)");
				}

				references->AddReference(bitmap1, "wxToolBar::AddTool at call with 4 argument(s)");
				references->AddReference(bmpDisabled1, "wxToolBar::AddTool at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddTool((int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_2, *(wxBitmap*) object_pointer1_3, (wxItemKind) kind1) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return5;
				value_to_return5 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddTool((int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_2, *(wxBitmap*) object_pointer1_3, (wxItemKind) kind1);

				if(value_to_return5 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return5->references.IsUserInitialized()){
					if(value_to_return5->phpObj != NULL){
						*return_value = *value_to_return5->phpObj;
						zval_add_ref(&value_to_return5->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return5;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return5 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddTool at call with 5 argument(s)");
				}

				references->AddReference(bitmap1, "wxToolBar::AddTool at call with 5 argument(s)");
				references->AddReference(bmpDisabled1, "wxToolBar::AddTool at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddTool((int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_2, *(wxBitmap*) object_pointer1_3, (wxItemKind) kind1, wxString(shortHelpString1, wxConvUTF8)) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return6;
				value_to_return6 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddTool((int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_2, *(wxBitmap*) object_pointer1_3, (wxItemKind) kind1, wxString(shortHelpString1, wxConvUTF8));

				if(value_to_return6 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return6->references.IsUserInitialized()){
					if(value_to_return6->phpObj != NULL){
						*return_value = *value_to_return6->phpObj;
						zval_add_ref(&value_to_return6->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return6;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return6 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddTool at call with 6 argument(s)");
				}

				references->AddReference(bitmap1, "wxToolBar::AddTool at call with 6 argument(s)");
				references->AddReference(bmpDisabled1, "wxToolBar::AddTool at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddTool((int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_2, *(wxBitmap*) object_pointer1_3, (wxItemKind) kind1, wxString(shortHelpString1, wxConvUTF8), wxString(longHelpString1, wxConvUTF8)) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return7;
				value_to_return7 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddTool((int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_2, *(wxBitmap*) object_pointer1_3, (wxItemKind) kind1, wxString(shortHelpString1, wxConvUTF8), wxString(longHelpString1, wxConvUTF8));

				if(value_to_return7 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return7->references.IsUserInitialized()){
					if(value_to_return7->phpObj != NULL){
						*return_value = *value_to_return7->phpObj;
						zval_add_ref(&value_to_return7->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return7;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return7 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddTool at call with 7 argument(s)");
				}

				references->AddReference(bitmap1, "wxToolBar::AddTool at call with 7 argument(s)");
				references->AddReference(bmpDisabled1, "wxToolBar::AddTool at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::AddTool((int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_2, *(wxBitmap*) object_pointer1_3, (wxItemKind) kind1, wxString(shortHelpString1, wxConvUTF8), wxString(longHelpString1, wxConvUTF8), (wxObject*) object_pointer1_7) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return8;
				value_to_return8 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->AddTool((int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_2, *(wxBitmap*) object_pointer1_3, (wxItemKind) kind1, wxString(shortHelpString1, wxConvUTF8), wxString(longHelpString1, wxConvUTF8), (wxObject*) object_pointer1_7);

				if(value_to_return8 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return8->references.IsUserInitialized()){
					if(value_to_return8->phpObj != NULL){
						*return_value = *value_to_return8->phpObj;
						zval_add_ref(&value_to_return8->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return8;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return8 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::AddTool at call with 8 argument(s)");
				}

				references->AddReference(bitmap1, "wxToolBar::AddTool at call with 8 argument(s)");
				references->AddReference(bmpDisabled1, "wxToolBar::AddTool at call with 8 argument(s)");
				references->AddReference(clientData1, "wxToolBar::AddTool at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::AddTool\n");
	}
}
/* }}} */

/* {{{ proto wxToolBarToolBase wxToolBar::FindById(int id)
   Returns a pointer to the tool identified by id or NULL if no corresponding tool is found. */
PHP_METHOD(php_wxToolBar, FindById)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::FindById\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::FindById call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long id0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&id0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &id0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::FindById((int) id0) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return1;
				value_to_return1 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->FindById((int) id0);

				if(value_to_return1 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return1->references.IsUserInitialized()){
					if(value_to_return1->phpObj != NULL){
						*return_value = *value_to_return1->phpObj;
						zval_add_ref(&value_to_return1->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return1;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return1 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::FindById at call with 1 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::FindById\n");
	}
}
/* }}} */

/* {{{ proto wxToolBarToolBase wxToolBar::FindToolForPosition(int x, int y)
   Finds a tool for the given mouse position. */
PHP_METHOD(php_wxToolBar, FindToolForPosition)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::FindToolForPosition\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::FindToolForPosition call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long x0;
	long y0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'll' (&x0, &y0)\n");
		#endif

		char parse_parameters_string[] = "ll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &x0, &y0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::FindToolForPosition((wxCoord) x0, (wxCoord) y0) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return2;
				value_to_return2 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->FindToolForPosition((wxCoord) x0, (wxCoord) y0);

				if(value_to_return2 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return2->references.IsUserInitialized()){
					if(value_to_return2->phpObj != NULL){
						*return_value = *value_to_return2->phpObj;
						zval_add_ref(&value_to_return2->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return2;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return2 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::FindToolForPosition at call with 2 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::FindToolForPosition\n");
	}
}
/* }}} */

/* {{{ proto wxToolBarToolBase wxToolBar::GetToolByPos(int pos)
   Returns a pointer to the tool at ordinal position pos. */
PHP_METHOD(php_wxToolBar, GetToolByPos)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::GetToolByPos\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::GetToolByPos call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long pos0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&pos0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pos0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::GetToolByPos((int) pos0) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return1;
				value_to_return1 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->GetToolByPos((int) pos0);

				if(value_to_return1 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return1->references.IsUserInitialized()){
					if(value_to_return1->phpObj != NULL){
						*return_value = *value_to_return1->phpObj;
						zval_add_ref(&value_to_return1->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return1;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return1 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::GetToolByPos at call with 1 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::GetToolByPos\n");
	}
}
/* }}} */

/* {{{ proto wxToolBarToolBase wxToolBar::InsertControl(int pos, wxControl &control, string label)
   Inserts the control into the toolbar at the given position. */
PHP_METHOD(php_wxToolBar, InsertControl)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::InsertControl\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::InsertControl call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long pos0;
	zval* control0 = 0;
	wxControl* object_pointer0_1 = 0;
	char* label0;
	long label_len0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 2  && arguments_received <= 3)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'lz|s' (&pos0, &control0, &label0, &label_len0)\n");
		#endif

		char parse_parameters_string[] = "lz|s";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pos0, &control0, &label0, &label_len0 ) == SUCCESS)
		{
			if(arguments_received >= 2){
				if(Z_TYPE_P(control0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxControl*) zend_object_store_get_object(control0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxControl*) zend_object_store_get_object(control0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxControl*) argument_native_object;
					if (!object_pointer0_1 || (argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'control' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(control0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'control' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::InsertControl((size_t) pos0, (wxControl*) object_pointer0_1) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return2;
				value_to_return2 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->InsertControl((size_t) pos0, (wxControl*) object_pointer0_1);

				if(value_to_return2 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return2->references.IsUserInitialized()){
					if(value_to_return2->phpObj != NULL){
						*return_value = *value_to_return2->phpObj;
						zval_add_ref(&value_to_return2->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return2;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return2 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::InsertControl at call with 2 argument(s)");
				}

				references->AddReference(control0, "wxToolBar::InsertControl at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::InsertControl((size_t) pos0, (wxControl*) object_pointer0_1, wxString(label0, wxConvUTF8)) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return3;
				value_to_return3 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->InsertControl((size_t) pos0, (wxControl*) object_pointer0_1, wxString(label0, wxConvUTF8));

				if(value_to_return3 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return3->references.IsUserInitialized()){
					if(value_to_return3->phpObj != NULL){
						*return_value = *value_to_return3->phpObj;
						zval_add_ref(&value_to_return3->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return3;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return3 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::InsertControl at call with 3 argument(s)");
				}

				references->AddReference(control0, "wxToolBar::InsertControl at call with 3 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::InsertControl\n");
	}
}
/* }}} */

/* {{{ proto wxToolBarToolBase wxToolBar::InsertSeparator(int pos)
   Inserts the separator into the toolbar at the given position. */
PHP_METHOD(php_wxToolBar, InsertSeparator)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::InsertSeparator\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::InsertSeparator call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long pos0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&pos0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pos0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::InsertSeparator((size_t) pos0) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return1;
				value_to_return1 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->InsertSeparator((size_t) pos0);

				if(value_to_return1 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return1->references.IsUserInitialized()){
					if(value_to_return1->phpObj != NULL){
						*return_value = *value_to_return1->phpObj;
						zval_add_ref(&value_to_return1->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return1;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return1 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::InsertSeparator at call with 1 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::InsertSeparator\n");
	}
}
/* }}} */

/* {{{ proto wxToolBarToolBase wxToolBar::InsertStretchableSpace(int pos)
   Inserts a stretchable space at the given position. */
PHP_METHOD(php_wxToolBar, InsertStretchableSpace)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::InsertStretchableSpace\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::InsertStretchableSpace call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long pos0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&pos0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pos0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::InsertStretchableSpace((size_t) pos0) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return1;
				value_to_return1 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->InsertStretchableSpace((size_t) pos0);

				if(value_to_return1 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return1->references.IsUserInitialized()){
					if(value_to_return1->phpObj != NULL){
						*return_value = *value_to_return1->phpObj;
						zval_add_ref(&value_to_return1->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return1;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return1 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::InsertStretchableSpace at call with 1 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::InsertStretchableSpace\n");
	}
}
/* }}} */

/* {{{ proto wxToolBarToolBase wxToolBar::InsertTool(int pos, wxToolBarToolBase &tool)
   Inserts the tool with the specified attributes into the toolbar at the given position. */
PHP_METHOD(php_wxToolBar, InsertTool)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::InsertTool\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::InsertTool call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long pos0;
	zval* tool0 = 0;
	wxToolBarToolBase* object_pointer0_1 = 0;
	bool overload0_called = false;
	//Parameters for overload 1
	long pos1;
	long toolId1;
	char* label1;
	long label_len1;
	zval* bitmap1 = 0;
	wxBitmap* object_pointer1_3 = 0;
	zval* bmpDisabled1 = 0;
	wxBitmap* object_pointer1_4 = 0;
	long kind1;
	char* shortHelp1;
	long shortHelp_len1;
	char* longHelp1;
	long longHelp_len1;
	zval* clientData1 = 0;
	wxObject* object_pointer1_8 = 0;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'lz' (&pos0, &tool0)\n");
		#endif

		char parse_parameters_string[] = "lz";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pos0, &tool0 ) == SUCCESS)
		{
			if(arguments_received >= 2){
				if(Z_TYPE_P(tool0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxToolBarToolBase*) zend_object_store_get_object(tool0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxToolBarToolBase*) zend_object_store_get_object(tool0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxToolBarToolBase*) argument_native_object;
					if (!object_pointer0_1 || (argument_type != PHP_WXTOOLBARTOOLBASE_TYPE))
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(tool0) != IS_NULL)
				{
					goto overload1;
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received >= 4  && arguments_received <= 9)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'llsO|Olssz' (&pos1, &toolId1, &label1, &label_len1, &bitmap1, php_wxBitmap_entry, &bmpDisabled1, php_wxBitmap_entry, &kind1, &shortHelp1, &shortHelp_len1, &longHelp1, &longHelp_len1, &clientData1)\n");
		#endif

		char parse_parameters_string[] = "llsO|Olssz";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pos1, &toolId1, &label1, &label_len1, &bitmap1, php_wxBitmap_entry, &bmpDisabled1, php_wxBitmap_entry, &kind1, &shortHelp1, &shortHelp_len1, &longHelp1, &longHelp_len1, &clientData1 ) == SUCCESS)
		{
			if(arguments_received >= 4){
				if(Z_TYPE_P(bitmap1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(bitmap1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(bitmap1 TSRMLS_CC))->native_object;
					object_pointer1_3 = (wxBitmap*) argument_native_object;
					if (!object_pointer1_3 )
					{
						zend_error(E_ERROR, "Parameter 'bitmap' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(bitmap1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'bitmap' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(bmpDisabled1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(bmpDisabled1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(bmpDisabled1 TSRMLS_CC))->native_object;
					object_pointer1_4 = (wxBitmap*) argument_native_object;
					if (!object_pointer1_4 )
					{
						zend_error(E_ERROR, "Parameter 'bmpDisabled' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(bmpDisabled1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'bmpDisabled' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 9){
				if(Z_TYPE_P(clientData1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxObject*) zend_object_store_get_object(clientData1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxObject*) zend_object_store_get_object(clientData1 TSRMLS_CC))->native_object;
					object_pointer1_8 = (wxObject*) argument_native_object;
					if (!object_pointer1_8 || (argument_type != PHP_WXOBJECT_TYPE && argument_type != PHP_WXEVTHANDLER_TYPE && argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE && argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE && argument_type != PHP_WXMENU_TYPE && argument_type != PHP_WXAUIMANAGER_TYPE && argument_type != PHP_WXMOUSEEVENTSMANAGER_TYPE && argument_type != PHP_WXTIMER_TYPE && argument_type != PHP_WXEVENTBLOCKER_TYPE && argument_type != PHP_WXPROCESS_TYPE && argument_type != PHP_WXFILESYSTEMWATCHER_TYPE && argument_type != PHP_WXTASKBARICON_TYPE && argument_type != PHP_WXNOTIFICATIONMESSAGE_TYPE && argument_type != PHP_WXBITMAPHANDLER_TYPE && argument_type != PHP_WXIMAGE_TYPE && argument_type != PHP_WXSIZER_TYPE && argument_type != PHP_WXBOXSIZER_TYPE && argument_type != PHP_WXSTATICBOXSIZER_TYPE && argument_type != PHP_WXWRAPSIZER_TYPE && argument_type != PHP_WXSTDDIALOGBUTTONSIZER_TYPE && argument_type != PHP_WXGRIDSIZER_TYPE && argument_type != PHP_WXFLEXGRIDSIZER_TYPE && argument_type != PHP_WXGRIDBAGSIZER_TYPE && argument_type != PHP_WXSIZERITEM_TYPE && argument_type != PHP_WXGBSIZERITEM_TYPE && argument_type != PHP_WXIMAGELIST_TYPE && argument_type != PHP_WXDC_TYPE && argument_type != PHP_WXWINDOWDC_TYPE && argument_type != PHP_WXCLIENTDC_TYPE && argument_type != PHP_WXPAINTDC_TYPE && argument_type != PHP_WXSCREENDC_TYPE && argument_type != PHP_WXPOSTSCRIPTDC_TYPE && argument_type != PHP_WXPRINTERDC_TYPE && argument_type != PHP_WXMEMORYDC_TYPE && argument_type != PHP_WXBUFFEREDDC_TYPE && argument_type != PHP_WXBUFFEREDPAINTDC_TYPE && argument_type != PHP_WXAUTOBUFFEREDPAINTDC_TYPE && argument_type != PHP_WXMIRRORDC_TYPE && argument_type != PHP_WXCOLOUR_TYPE && argument_type != PHP_WXMENUITEM_TYPE && argument_type != PHP_WXEVENT_TYPE && argument_type != PHP_WXMENUEVENT_TYPE && argument_type != PHP_WXKEYEVENT_TYPE && argument_type != PHP_WXCOMMANDEVENT_TYPE && argument_type != PHP_WXNOTIFYEVENT_TYPE && argument_type != PHP_WXTREEEVENT_TYPE && argument_type != PHP_WXBOOKCTRLEVENT_TYPE && argument_type != PHP_WXAUINOTEBOOKEVENT_TYPE && argument_type != PHP_WXAUITOOLBAREVENT_TYPE && argument_type != PHP_WXLISTEVENT_TYPE && argument_type != PHP_WXSPINEVENT_TYPE && argument_type != PHP_WXSPLITTEREVENT_TYPE && argument_type != PHP_WXSPINDOUBLEEVENT_TYPE && argument_type != PHP_WXGRIDSIZEEVENT_TYPE && argument_type != PHP_WXWIZARDEVENT_TYPE && argument_type != PHP_WXGRIDEVENT_TYPE && argument_type != PHP_WXGRIDRANGESELECTEVENT_TYPE && argument_type != PHP_WXDATAVIEWEVENT_TYPE && argument_type != PHP_WXHEADERCTRLEVENT_TYPE && argument_type != PHP_WXRIBBONBAREVENT_TYPE && argument_type != PHP_WXWEBVIEWEVENT_TYPE && argument_type != PHP_WXMEDIAEVENT_TYPE && argument_type != PHP_WXSTYLEDTEXTEVENT_TYPE && argument_type != PHP_WXCHILDFOCUSEVENT_TYPE && argument_type != PHP_WXHTMLCELLEVENT_TYPE && argument_type != PHP_WXHTMLLINKEVENT_TYPE && argument_type != PHP_WXHYPERLINKEVENT_TYPE && argument_type != PHP_WXCOLOURPICKEREVENT_TYPE && argument_type != PHP_WXFONTPICKEREVENT_TYPE && argument_type != PHP_WXSCROLLEVENT_TYPE && argument_type != PHP_WXWINDOWMODALDIALOGEVENT_TYPE && argument_type != PHP_WXDATEEVENT_TYPE && argument_type != PHP_WXCALENDAREVENT_TYPE && argument_type != PHP_WXWINDOWCREATEEVENT_TYPE && argument_type != PHP_WXWINDOWDESTROYEVENT_TYPE && argument_type != PHP_WXUPDATEUIEVENT_TYPE && argument_type != PHP_WXHELPEVENT_TYPE && argument_type != PHP_WXGRIDEDITORCREATEDEVENT_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANEEVENT_TYPE && argument_type != PHP_WXCLIPBOARDTEXTEVENT_TYPE && argument_type != PHP_WXFILECTRLEVENT_TYPE && argument_type != PHP_WXSASHEVENT_TYPE && argument_type != PHP_WXFILEDIRPICKEREVENT_TYPE && argument_type != PHP_WXCONTEXTMENUEVENT_TYPE && argument_type != PHP_WXRIBBONBUTTONBAREVENT_TYPE && argument_type != PHP_WXRIBBONGALLERYEVENT_TYPE && argument_type != PHP_WXCLOSEEVENT_TYPE && argument_type != PHP_WXACTIVATEEVENT_TYPE && argument_type != PHP_WXAUIMANAGEREVENT_TYPE && argument_type != PHP_WXSIZEEVENT_TYPE && argument_type != PHP_WXMOUSEEVENT_TYPE && argument_type != PHP_WXMOVEEVENT_TYPE && argument_type != PHP_WXTIMEREVENT_TYPE && argument_type != PHP_WXTHREADEVENT_TYPE && argument_type != PHP_WXSCROLLWINEVENT_TYPE && argument_type != PHP_WXSYSCOLOURCHANGEDEVENT_TYPE && argument_type != PHP_WXPROCESSEVENT_TYPE && argument_type != PHP_WXERASEEVENT_TYPE && argument_type != PHP_WXSETCURSOREVENT_TYPE && argument_type != PHP_WXIDLEEVENT_TYPE && argument_type != PHP_WXPAINTEVENT_TYPE && argument_type != PHP_WXPALETTECHANGEDEVENT_TYPE && argument_type != PHP_WXINITDIALOGEVENT_TYPE && argument_type != PHP_WXMAXIMIZEEVENT_TYPE && argument_type != PHP_WXNAVIGATIONKEYEVENT_TYPE && argument_type != PHP_WXFOCUSEVENT_TYPE && argument_type != PHP_WXFILESYSTEMWATCHEREVENT_TYPE && argument_type != PHP_WXDISPLAYCHANGEDEVENT_TYPE && argument_type != PHP_WXCALCULATELAYOUTEVENT_TYPE && argument_type != PHP_WXQUERYLAYOUTINFOEVENT_TYPE && argument_type != PHP_WXTASKBARICONEVENT_TYPE && argument_type != PHP_WXACCELERATORTABLE_TYPE && argument_type != PHP_WXGDIOBJECT_TYPE && argument_type != PHP_WXBITMAP_TYPE && argument_type != PHP_WXPALETTE_TYPE && argument_type != PHP_WXICON_TYPE && argument_type != PHP_WXFONT_TYPE && argument_type != PHP_WXANIMATION_TYPE && argument_type != PHP_WXICONBUNDLE_TYPE && argument_type != PHP_WXCURSOR_TYPE && argument_type != PHP_WXREGION_TYPE && argument_type != PHP_WXPEN_TYPE && argument_type != PHP_WXBRUSH_TYPE && argument_type != PHP_WXARTPROVIDER_TYPE && argument_type != PHP_WXHTMLCELL_TYPE && argument_type != PHP_WXHTMLCONTAINERCELL_TYPE && argument_type != PHP_WXHTMLCOLOURCELL_TYPE && argument_type != PHP_WXHTMLWIDGETCELL_TYPE && argument_type != PHP_WXHTMLEASYPRINTING_TYPE && argument_type != PHP_WXHTMLLINKINFO_TYPE && argument_type != PHP_WXFINDREPLACEDATA_TYPE && argument_type != PHP_WXSOUND_TYPE && argument_type != PHP_WXFILESYSTEM_TYPE && argument_type != PHP_WXFILESYSTEMHANDLER_TYPE && argument_type != PHP_WXMASK_TYPE && argument_type != PHP_WXTOOLTIP_TYPE && argument_type != PHP_WXGRAPHICSRENDERER_TYPE && argument_type != PHP_WXLAYOUTCONSTRAINTS_TYPE && argument_type != PHP_WXFSFILE_TYPE && argument_type != PHP_WXCOLOURDATA_TYPE && argument_type != PHP_WXFONTDATA_TYPE && argument_type != PHP_WXGRIDTABLEBASE_TYPE && argument_type != PHP_WXDATAVIEWRENDERER_TYPE && argument_type != PHP_WXDATAVIEWBITMAPRENDERER_TYPE && argument_type != PHP_WXDATAVIEWCHOICERENDERER_TYPE && argument_type != PHP_WXDATAVIEWCUSTOMRENDERER_TYPE && argument_type != PHP_WXDATAVIEWSPINRENDERER_TYPE && argument_type != PHP_WXDATAVIEWDATERENDERER_TYPE && argument_type != PHP_WXDATAVIEWICONTEXTRENDERER_TYPE && argument_type != PHP_WXDATAVIEWPROGRESSRENDERER_TYPE && argument_type != PHP_WXDATAVIEWTEXTRENDERER_TYPE && argument_type != PHP_WXDATAVIEWTOGGLERENDERER_TYPE && argument_type != PHP_WXDATAVIEWICONTEXT_TYPE && argument_type != PHP_WXVARIANT_TYPE && argument_type != PHP_WXCLIPBOARD_TYPE && argument_type != PHP_WXCONFIGBASE_TYPE && argument_type != PHP_WXFILECONFIG_TYPE && argument_type != PHP_WXXMLRESOURCE_TYPE && argument_type != PHP_WXPAGESETUPDIALOG_TYPE && argument_type != PHP_WXPAGESETUPDIALOGDATA_TYPE && argument_type != PHP_WXPRINTDIALOG_TYPE && argument_type != PHP_WXPRINTDIALOGDATA_TYPE && argument_type != PHP_WXPRINTDATA_TYPE && argument_type != PHP_WXPRINTPREVIEW_TYPE && argument_type != PHP_WXPRINTER_TYPE && argument_type != PHP_WXPRINTOUT_TYPE && argument_type != PHP_WXHTMLPRINTOUT_TYPE && argument_type != PHP_WXHTMLDCRENDERER_TYPE && argument_type != PHP_WXHTMLFILTER_TYPE && argument_type != PHP_WXHTMLHELPDATA_TYPE && argument_type != PHP_WXHTMLTAGHANDLER_TYPE && argument_type != PHP_WXHTMLWINTAGHANDLER_TYPE && argument_type != PHP_WXMODULE_TYPE && argument_type != PHP_WXHTMLTAGSMODULE_TYPE && argument_type != PHP_WXIMAGEHANDLER_TYPE && argument_type != PHP_WXXMLRESOURCEHANDLER_TYPE && argument_type != PHP_WXXMLDOCUMENT_TYPE && argument_type != PHP_WXLAYOUTALGORITHM_TYPE && argument_type != PHP_WXFILEHISTORY_TYPE && argument_type != PHP_WXTOOLBARTOOLBASE_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'clientData' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(clientData1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'clientData' not null, could not be retreived correctly.");
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::InsertTool((size_t) pos0, (wxToolBarToolBase*) object_pointer0_1) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return2;
				value_to_return2 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->InsertTool((size_t) pos0, (wxToolBarToolBase*) object_pointer0_1);

				if(value_to_return2 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return2->references.IsUserInitialized()){
					if(value_to_return2->phpObj != NULL){
						*return_value = *value_to_return2->phpObj;
						zval_add_ref(&value_to_return2->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return2;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return2 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::InsertTool at call with 2 argument(s)");
				}

				references->AddReference(tool0, "wxToolBar::InsertTool at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::InsertTool((size_t) pos1, (int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_3) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return4;
				value_to_return4 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->InsertTool((size_t) pos1, (int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_3);

				if(value_to_return4 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return4->references.IsUserInitialized()){
					if(value_to_return4->phpObj != NULL){
						*return_value = *value_to_return4->phpObj;
						zval_add_ref(&value_to_return4->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return4;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return4 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::InsertTool at call with 4 argument(s)");
				}

				references->AddReference(bitmap1, "wxToolBar::InsertTool at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::InsertTool((size_t) pos1, (int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_3, *(wxBitmap*) object_pointer1_4) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return5;
				value_to_return5 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->InsertTool((size_t) pos1, (int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_3, *(wxBitmap*) object_pointer1_4);

				if(value_to_return5 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return5->references.IsUserInitialized()){
					if(value_to_return5->phpObj != NULL){
						*return_value = *value_to_return5->phpObj;
						zval_add_ref(&value_to_return5->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return5;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return5 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::InsertTool at call with 5 argument(s)");
				}

				references->AddReference(bitmap1, "wxToolBar::InsertTool at call with 5 argument(s)");
				references->AddReference(bmpDisabled1, "wxToolBar::InsertTool at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::InsertTool((size_t) pos1, (int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_3, *(wxBitmap*) object_pointer1_4, (wxItemKind) kind1) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return6;
				value_to_return6 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->InsertTool((size_t) pos1, (int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_3, *(wxBitmap*) object_pointer1_4, (wxItemKind) kind1);

				if(value_to_return6 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return6->references.IsUserInitialized()){
					if(value_to_return6->phpObj != NULL){
						*return_value = *value_to_return6->phpObj;
						zval_add_ref(&value_to_return6->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return6;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return6 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::InsertTool at call with 6 argument(s)");
				}

				references->AddReference(bitmap1, "wxToolBar::InsertTool at call with 6 argument(s)");
				references->AddReference(bmpDisabled1, "wxToolBar::InsertTool at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::InsertTool((size_t) pos1, (int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_3, *(wxBitmap*) object_pointer1_4, (wxItemKind) kind1, wxString(shortHelp1, wxConvUTF8)) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return7;
				value_to_return7 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->InsertTool((size_t) pos1, (int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_3, *(wxBitmap*) object_pointer1_4, (wxItemKind) kind1, wxString(shortHelp1, wxConvUTF8));

				if(value_to_return7 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return7->references.IsUserInitialized()){
					if(value_to_return7->phpObj != NULL){
						*return_value = *value_to_return7->phpObj;
						zval_add_ref(&value_to_return7->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return7;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return7 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::InsertTool at call with 7 argument(s)");
				}

				references->AddReference(bitmap1, "wxToolBar::InsertTool at call with 7 argument(s)");
				references->AddReference(bmpDisabled1, "wxToolBar::InsertTool at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::InsertTool((size_t) pos1, (int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_3, *(wxBitmap*) object_pointer1_4, (wxItemKind) kind1, wxString(shortHelp1, wxConvUTF8), wxString(longHelp1, wxConvUTF8)) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return8;
				value_to_return8 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->InsertTool((size_t) pos1, (int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_3, *(wxBitmap*) object_pointer1_4, (wxItemKind) kind1, wxString(shortHelp1, wxConvUTF8), wxString(longHelp1, wxConvUTF8));

				if(value_to_return8 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return8->references.IsUserInitialized()){
					if(value_to_return8->phpObj != NULL){
						*return_value = *value_to_return8->phpObj;
						zval_add_ref(&value_to_return8->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return8;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return8 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::InsertTool at call with 8 argument(s)");
				}

				references->AddReference(bitmap1, "wxToolBar::InsertTool at call with 8 argument(s)");
				references->AddReference(bmpDisabled1, "wxToolBar::InsertTool at call with 8 argument(s)");

				return;
				break;
			}
			case 9:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::InsertTool((size_t) pos1, (int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_3, *(wxBitmap*) object_pointer1_4, (wxItemKind) kind1, wxString(shortHelp1, wxConvUTF8), wxString(longHelp1, wxConvUTF8), (wxObject*) object_pointer1_8) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return9;
				value_to_return9 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->InsertTool((size_t) pos1, (int) toolId1, wxString(label1, wxConvUTF8), *(wxBitmap*) object_pointer1_3, *(wxBitmap*) object_pointer1_4, (wxItemKind) kind1, wxString(shortHelp1, wxConvUTF8), wxString(longHelp1, wxConvUTF8), (wxObject*) object_pointer1_8);

				if(value_to_return9 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return9->references.IsUserInitialized()){
					if(value_to_return9->phpObj != NULL){
						*return_value = *value_to_return9->phpObj;
						zval_add_ref(&value_to_return9->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return9;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return9 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::InsertTool at call with 9 argument(s)");
				}

				references->AddReference(bitmap1, "wxToolBar::InsertTool at call with 9 argument(s)");
				references->AddReference(bmpDisabled1, "wxToolBar::InsertTool at call with 9 argument(s)");
				references->AddReference(clientData1, "wxToolBar::InsertTool at call with 9 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::InsertTool\n");
	}
}
/* }}} */

/* {{{ proto bool wxToolBar::Realize()
   This function should be called after you have added tools. */
PHP_METHOD(php_wxToolBar, Realize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::Realize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::Realize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxToolBar::Realize())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxToolBar_php*)native_object)->Realize());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::Realize\n");
	}
}
/* }}} */

/* {{{ proto wxToolBarToolBase wxToolBar::RemoveTool(int id)
   Removes the given tool from the toolbar but doesn't delete it. */
PHP_METHOD(php_wxToolBar, RemoveTool)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxToolBar::RemoveTool\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxToolBar* current_object;
	wxphp_object_type current_object_type;
	wxToolBar_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxToolBar*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxToolBar::RemoveTool call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXTOOLBAR_TYPE){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long id0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&id0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &id0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxToolBar::RemoveTool((int) id0) to return object pointer\n\n");
				#endif

				wxToolBarToolBase_php* value_to_return1;
				value_to_return1 = (wxToolBarToolBase_php*) ((wxToolBar_php*)native_object)->RemoveTool((int) id0);

				if(value_to_return1 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return1->references.IsUserInitialized()){
					if(value_to_return1->phpObj != NULL){
						*return_value = *value_to_return1->phpObj;
						zval_add_ref(&value_to_return1->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolBarToolBase_entry);
					((zo_wxToolBarToolBase*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolBarToolBase_php*) value_to_return1;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return1 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxToolBar::RemoveTool at call with 1 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxToolBar::RemoveTool\n");
	}
}
/* }}} */

BEGIN_EXTERN_C()
void php_wxHScrolledWindow_free(void *object TSRMLS_DC) 
{
    zo_wxHScrolledWindow* custom_object = (zo_wxHScrolledWindow*) object;
    
	#ifdef USE_WXPHP_DEBUG
	php_printf("Obviate delete call for wxHScrolledWindow on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n\n");
	#endif

	zend_object_std_dtor(&custom_object->zo TSRMLS_CC);
    efree(custom_object);
}

zend_object_value php_wxHScrolledWindow_new(zend_class_entry *class_type TSRMLS_DC)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxHScrolledWindow_new on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	zval *temp;
    zend_object_value retval;
    zo_wxHScrolledWindow* custom_object;
    custom_object = (zo_wxHScrolledWindow*) emalloc(sizeof(zo_wxHScrolledWindow));

    zend_object_std_init(&custom_object->zo, class_type TSRMLS_CC);

#if PHP_VERSION_ID < 50399
	ALLOC_HASHTABLE(custom_object->zo.properties);
    zend_hash_init(custom_object->zo.properties, 0, NULL, ZVAL_PTR_DTOR, 0);
    zend_hash_copy(custom_object->zo.properties, &class_type->default_properties, (copy_ctor_func_t) zval_add_ref,(void *) &temp, sizeof(zval *));
#else
	object_properties_init(&custom_object->zo, class_type);
#endif

	retval.handle = zend_objects_store_put(custom_object, NULL, php_wxHScrolledWindow_free, NULL TSRMLS_CC);
	retval.handlers = zend_get_std_object_handlers();

    custom_object->native_object = NULL;
	custom_object->object_type = PHP_WXHSCROLLEDWINDOW_TYPE;
	custom_object->is_user_initialized = 0;
	
    return retval;
}
END_EXTERN_C()

/* {{{ proto bool wxHScrolledWindow::Create(wxWindow &parent, int id, wxPoint pos, wxSize size, int style, string name)
   Same as the non-default constructor, but returns a status code: true if ok, false if the window couldn't be created. */
PHP_METHOD(php_wxHScrolledWindow, Create)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxHScrolledWindow::Create\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxHScrolledWindow* current_object;
	wxphp_object_type current_object_type;
	wxHScrolledWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxHScrolledWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxHScrolledWindow::Create call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* parent0 = 0;
	wxWindow* object_pointer0_0 = 0;
	long id0;
	zval* pos0 = 0;
	wxPoint* object_pointer0_2 = 0;
	zval* size0 = 0;
	wxSize* object_pointer0_3 = 0;
	long style0;
	char* name0;
	long name_len0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 6)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lOOls' (&parent0, &id0, &pos0, php_wxPoint_entry, &size0, php_wxSize_entry, &style0, &name0, &name_len0)\n");
		#endif

		char parse_parameters_string[] = "z|lOOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent0, &id0, &pos0, php_wxPoint_entry, &size0, php_wxSize_entry, &style0, &name0, &name_len0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos0 TSRMLS_CC))->native_object;
					object_pointer0_2 = (wxPoint*) argument_native_object;
					if (!object_pointer0_2 )
					{
						zend_error(E_ERROR, "Parameter 'pos' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(pos0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'pos' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->native_object;
					object_pointer0_3 = (wxSize*) argument_native_object;
					if (!object_pointer0_3 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHScrolledWindow::Create((wxWindow*) object_pointer0_0))\n\n");
				#endif

				if(current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE)
				{
					ZVAL_BOOL(return_value, ((wxHScrolledWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0));
				}

				references->AddReference(parent0, "wxHScrolledWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHScrolledWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0))\n\n");
				#endif

				if(current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE)
				{
					ZVAL_BOOL(return_value, ((wxHScrolledWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0));
				}

				references->AddReference(parent0, "wxHScrolledWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHScrolledWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2))\n\n");
				#endif

				if(current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE)
				{
					ZVAL_BOOL(return_value, ((wxHScrolledWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2));
				}

				references->AddReference(parent0, "wxHScrolledWindow::Create at call with 3 argument(s)");
				references->AddReference(pos0, "wxHScrolledWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHScrolledWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3))\n\n");
				#endif

				if(current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE)
				{
					ZVAL_BOOL(return_value, ((wxHScrolledWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3));
				}

				references->AddReference(parent0, "wxHScrolledWindow::Create at call with 4 argument(s)");
				references->AddReference(pos0, "wxHScrolledWindow::Create at call with 4 argument(s)");
				references->AddReference(size0, "wxHScrolledWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHScrolledWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0))\n\n");
				#endif

				if(current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE)
				{
					ZVAL_BOOL(return_value, ((wxHScrolledWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0));
				}

				references->AddReference(parent0, "wxHScrolledWindow::Create at call with 5 argument(s)");
				references->AddReference(pos0, "wxHScrolledWindow::Create at call with 5 argument(s)");
				references->AddReference(size0, "wxHScrolledWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHScrolledWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0, wxString(name0, wxConvUTF8)))\n\n");
				#endif

				if(current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE)
				{
					ZVAL_BOOL(return_value, ((wxHScrolledWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0, wxString(name0, wxConvUTF8)));
				}

				references->AddReference(parent0, "wxHScrolledWindow::Create at call with 6 argument(s)");
				references->AddReference(pos0, "wxHScrolledWindow::Create at call with 6 argument(s)");
				references->AddReference(size0, "wxHScrolledWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxHScrolledWindow::Create\n");
	}
}
/* }}} */

BEGIN_EXTERN_C()
void php_wxWindow_free(void *object TSRMLS_DC) 
{
    zo_wxWindow* custom_object = (zo_wxWindow*) object;
    
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxWindow_free on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	if(custom_object->native_object != NULL)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Pointer not null\n");
		php_printf("Pointer address %x\n", (unsigned int)(size_t)custom_object->native_object);
		#endif
		
		if(custom_object->is_user_initialized)
		{
			#ifdef USE_WXPHP_DEBUG
			php_printf("Deleting pointer with delete\n");
			#endif
			
       
            delete custom_object->native_object;
			
			custom_object->native_object = NULL;
		}
		
		#ifdef USE_WXPHP_DEBUG
		php_printf("Deletion of wxWindow done\n");
		php_printf("===========================================\n\n");
		#endif
	}
	else
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Not user space initialized\n");
		#endif
	}

	zend_object_std_dtor(&custom_object->zo TSRMLS_CC);
    efree(custom_object);
}

zend_object_value php_wxWindow_new(zend_class_entry *class_type TSRMLS_DC)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxWindow_new on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	zval *temp;
    zend_object_value retval;
    zo_wxWindow* custom_object;
    custom_object = (zo_wxWindow*) emalloc(sizeof(zo_wxWindow));

    zend_object_std_init(&custom_object->zo, class_type TSRMLS_CC);

#if PHP_VERSION_ID < 50399
	ALLOC_HASHTABLE(custom_object->zo.properties);
    zend_hash_init(custom_object->zo.properties, 0, NULL, ZVAL_PTR_DTOR, 0);
    zend_hash_copy(custom_object->zo.properties, &class_type->default_properties, (copy_ctor_func_t) zval_add_ref,(void *) &temp, sizeof(zval *));
#else
	object_properties_init(&custom_object->zo, class_type);
#endif

	retval.handle = zend_objects_store_put(custom_object, NULL, php_wxWindow_free, NULL TSRMLS_CC);
	retval.handlers = zend_get_std_object_handlers();

    custom_object->native_object = NULL;
	custom_object->object_type = PHP_WXWINDOW_TYPE;
	custom_object->is_user_initialized = 0;
	
    return retval;
}
END_EXTERN_C()

/* {{{ proto  wxWindow::wxWindow(wxWindow &parent, int id, wxPoint pos, wxSize size, int style, string name)
   Constructs a window, which can be a child of a frame, dialog or any other non-control window. */
PHP_METHOD(php_wxWindow, __construct)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::__construct\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	int arguments_received = ZEND_NUM_ARGS();
	
	
	//Parameters for overload 0
	zval* parent0 = 0;
	wxWindow* object_pointer0_0 = 0;
	long id0;
	zval* pos0 = 0;
	wxPoint* object_pointer0_2 = 0;
	zval* size0 = 0;
	wxSize* object_pointer0_3 = 0;
	long style0;
	char* name0;
	long name_len0;
	bool overload0_called = false;
	//Parameters for overload 1
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 2  && arguments_received <= 6)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|OOls' (&parent0, &id0, &pos0, php_wxPoint_entry, &size0, php_wxSize_entry, &style0, &name0, &name_len0)\n");
		#endif

		char parse_parameters_string[] = "zl|OOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent0, &id0, &pos0, php_wxPoint_entry, &size0, php_wxSize_entry, &style0, &name0, &name_len0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(parent0) != IS_NULL)
				{
					goto overload1;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos0 TSRMLS_CC))->native_object;
					object_pointer0_2 = (wxPoint*) argument_native_object;
					if (!object_pointer0_2 )
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(pos0) != IS_NULL)
				{
					goto overload1;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->native_object;
					object_pointer0_3 = (wxSize*) argument_native_object;
					if (!object_pointer0_3 )
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(size0) != IS_NULL)
				{
					goto overload1;
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload1_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer0_0, (wxWindowID) id0)\n");
				#endif

				native_object = new wxWindow_php((wxWindow*) object_pointer0_0, (wxWindowID) id0);

				native_object->references.Initialize();
				((wxWindow_php*) native_object)->references.AddReference(parent0, "wxWindow::wxWindow at call with 2 argument(s)");
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2)\n");
				#endif

				native_object = new wxWindow_php((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2);

				native_object->references.Initialize();
				((wxWindow_php*) native_object)->references.AddReference(parent0, "wxWindow::wxWindow at call with 3 argument(s)");
				((wxWindow_php*) native_object)->references.AddReference(pos0, "wxWindow::wxWindow at call with 3 argument(s)");
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3)\n");
				#endif

				native_object = new wxWindow_php((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3);

				native_object->references.Initialize();
				((wxWindow_php*) native_object)->references.AddReference(parent0, "wxWindow::wxWindow at call with 4 argument(s)");
				((wxWindow_php*) native_object)->references.AddReference(pos0, "wxWindow::wxWindow at call with 4 argument(s)");
				((wxWindow_php*) native_object)->references.AddReference(size0, "wxWindow::wxWindow at call with 4 argument(s)");
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0)\n");
				#endif

				native_object = new wxWindow_php((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0);

				native_object->references.Initialize();
				((wxWindow_php*) native_object)->references.AddReference(parent0, "wxWindow::wxWindow at call with 5 argument(s)");
				((wxWindow_php*) native_object)->references.AddReference(pos0, "wxWindow::wxWindow at call with 5 argument(s)");
				((wxWindow_php*) native_object)->references.AddReference(size0, "wxWindow::wxWindow at call with 5 argument(s)");
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0, wxString(name0, wxConvUTF8))\n");
				#endif

				native_object = new wxWindow_php((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0, wxString(name0, wxConvUTF8));

				native_object->references.Initialize();
				((wxWindow_php*) native_object)->references.AddReference(parent0, "wxWindow::wxWindow at call with 6 argument(s)");
				((wxWindow_php*) native_object)->references.AddReference(pos0, "wxWindow::wxWindow at call with 6 argument(s)");
				((wxWindow_php*) native_object)->references.AddReference(size0, "wxWindow::wxWindow at call with 6 argument(s)");
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct()\n");
				#endif

				native_object = new wxWindow_php();

				native_object->references.Initialize();
				break;
			}
		}
	}

		
	if(already_called)
	{
		native_object->phpObj = getThis();
		

		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		current_object->native_object = native_object;
		
		current_object->is_user_initialized = 1;
		
		#ifdef ZTS 
		native_object->TSRMLS_C = TSRMLS_C;
		#endif
	}
	else
	{
		zend_error(E_ERROR, "Abstract class or wrong type/count of parameters passed to: wxWindow::__construct\n");
	}
	
	#ifdef USE_WXPHP_DEBUG
		php_printf("===========================================\n\n");
	#endif
}
/* }}} */

/* {{{ proto bool wxWindow::Show(bool show)
   Shows or hides the window. */
PHP_METHOD(php_wxWindow, Show)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Show\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Show call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool show0;
	bool overload0_called = false;
	//Parameters for overload 1
	long item1;
	bool show1;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|b' (&show0)\n");
		#endif

		char parse_parameters_string[] = "|b";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &show0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2 && (current_object_type == PHP_WXRADIOBOX_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l|b' (&item1, &show1)\n");
		#endif

		char parse_parameters_string[] = "l|b";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &item1, &show1 ) == SUCCESS)
		{
			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::Show())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->Show());


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::Show(show0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->Show(show0));


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioBox::Show((unsigned int) item1))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioBox_php*)native_object)->Show((unsigned int) item1));


				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioBox::Show((unsigned int) item1, show1))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioBox_php*)native_object)->Show((unsigned int) item1, show1));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Show\n");
	}
}
/* }}} */

/* {{{ proto wxWindow wxWindow::FindWindowById(int id, wxWindow parent)
   Find the first window with the given id. */
PHP_METHOD(php_wxWindow, FindWindowById)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::FindWindowById\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::FindWindowById call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long id0;
	zval* parent0 = 0;
	wxWindow* object_pointer0_1 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l|z' (&id0, &parent0)\n");
		#endif

		char parse_parameters_string[] = "l|z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &id0, &parent0 ) == SUCCESS)
		{
			if(arguments_received >= 2){
				if(Z_TYPE_P(parent0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxWindow*) argument_native_object;
					if (!object_pointer0_1 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Static ");
				php_printf("Executing wxWindow::FindWindowById((long) id0) to return object pointer\n\n");
				#endif

				wxWindow_php* value_to_return1;
				value_to_return1 = (wxWindow_php*) wxWindow::FindWindowById((long) id0);
				if(value_to_return1 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return1->references.IsUserInitialized()){
					if(value_to_return1->phpObj != NULL){
						*return_value = *value_to_return1->phpObj;
						zval_add_ref(&value_to_return1->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxWindow_entry);
					((zo_wxWindow*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxWindow_php*) value_to_return1;
				}



				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Static ");
				php_printf("Executing wxWindow::FindWindowById((long) id0, (const wxWindow*) object_pointer0_1) to return object pointer\n\n");
				#endif

				wxWindow_php* value_to_return2;
				value_to_return2 = (wxWindow_php*) wxWindow::FindWindowById((long) id0, (const wxWindow*) object_pointer0_1);
				if(value_to_return2 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return2->references.IsUserInitialized()){
					if(value_to_return2->phpObj != NULL){
						*return_value = *value_to_return2->phpObj;
						zval_add_ref(&value_to_return2->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxWindow_entry);
					((zo_wxWindow*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxWindow_php*) value_to_return2;
				}



				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::FindWindowById\n");
	}
}
/* }}} */

/* {{{ proto wxWindow wxWindow::FindWindow(string name)
   Find a child of this window, by name. */
PHP_METHOD(php_wxWindow, FindWindow)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::FindWindow\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::FindWindow call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	char* name0;
	long name_len0;
	bool overload0_called = false;
	//Parameters for overload 1
	long id1;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 's' (&name0, &name_len0)\n");
		#endif

		char parse_parameters_string[] = "s";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &name0, &name_len0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&id1)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &id1 ) == SUCCESS)
		{
			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::FindWindow(wxString(name0, wxConvUTF8)) to return object pointer\n\n");
				#endif

				wxWindow_php* value_to_return1;
				value_to_return1 = (wxWindow_php*) ((wxWindow_php*)native_object)->FindWindow(wxString(name0, wxConvUTF8));

				if(value_to_return1 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return1->references.IsUserInitialized()){
					if(value_to_return1->phpObj != NULL){
						*return_value = *value_to_return1->phpObj;
						zval_add_ref(&value_to_return1->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxWindow_entry);
					((zo_wxWindow*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxWindow_php*) value_to_return1;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return1 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxWindow::FindWindow at call with 1 argument(s)");
				}


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::FindWindow((long) id1) to return object pointer\n\n");
				#endif

				wxWindow_php* value_to_return1;
				value_to_return1 = (wxWindow_php*) ((wxWindow_php*)native_object)->FindWindow((long) id1);

				if(value_to_return1 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return1->references.IsUserInitialized()){
					if(value_to_return1->phpObj != NULL){
						*return_value = *value_to_return1->phpObj;
						zval_add_ref(&value_to_return1->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxWindow_entry);
					((zo_wxWindow*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxWindow_php*) value_to_return1;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return1 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxWindow::FindWindow at call with 1 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::FindWindow\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::Enable(bool enable)
   Enable or disable the window for user input. */
PHP_METHOD(php_wxWindow, Enable)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Enable\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Enable call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool enable0;
	bool overload0_called = false;
	//Parameters for overload 1
	long n1;
	bool enable1;
	bool overload1_called = false;
	//Parameters for overload 2
	long id2;
	bool enable2;
	bool overload2_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|b' (&enable0)\n");
		#endif

		char parse_parameters_string[] = "|b";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &enable0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2 && (current_object_type == PHP_WXRADIOBOX_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l|b' (&n1, &enable1)\n");
		#endif

		char parse_parameters_string[] = "l|b";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &n1, &enable1 ) == SUCCESS)
		{
			overload1_called = true;
			already_called = true;
		}
	}

	//Overload 2
	overload2:
	if(!already_called && arguments_received == 2 && (current_object_type == PHP_WXMENUBAR_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'lb' (&id2, &enable2)\n");
		#endif

		char parse_parameters_string[] = "lb";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &id2, &enable2 ) == SUCCESS)
		{
			overload2_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::Enable())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->Enable());


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::Enable(enable0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->Enable(enable0));


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioBox::Enable((unsigned int) n1))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioBox_php*)native_object)->Enable((unsigned int) n1));


				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioBox::Enable((unsigned int) n1, enable1))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioBox_php*)native_object)->Enable((unsigned int) n1, enable1));


				return;
				break;
			}
		}
	}

	if(overload2_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxMenuBar::Enable((int) id2, enable2)\n\n");
				#endif

				((wxMenuBar_php*)native_object)->Enable((int) id2, enable2);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Enable\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::Disable()
   Disables the window. */
PHP_METHOD(php_wxWindow, Disable)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Disable\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Disable call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::Disable())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->Disable());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Disable\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::Close(bool force)
   This function simply generates a wxCloseEvent whose handler usually tries to close the window. */
PHP_METHOD(php_wxWindow, Close)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Close\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Close call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool force0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|b' (&force0)\n");
		#endif

		char parse_parameters_string[] = "|b";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &force0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::Close())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->Close());


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::Close(force0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->Close(force0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Close\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetSizer(wxSizer &sizer, bool deleteOld)
   Sets the window to have the given layout sizer. */
PHP_METHOD(php_wxWindow, SetSizer)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetSizer\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetSizer call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* sizer0 = 0;
	wxSizer* object_pointer0_0 = 0;
	bool deleteOld0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|b' (&sizer0, &deleteOld0)\n");
		#endif

		char parse_parameters_string[] = "z|b";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &sizer0, &deleteOld0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(sizer0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSizer*) zend_object_store_get_object(sizer0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSizer*) zend_object_store_get_object(sizer0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxSizer*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXSIZER_TYPE && argument_type != PHP_WXBOXSIZER_TYPE && argument_type != PHP_WXSTATICBOXSIZER_TYPE && argument_type != PHP_WXWRAPSIZER_TYPE && argument_type != PHP_WXSTDDIALOGBUTTONSIZER_TYPE && argument_type != PHP_WXGRIDSIZER_TYPE && argument_type != PHP_WXFLEXGRIDSIZER_TYPE && argument_type != PHP_WXGRIDBAGSIZER_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'sizer' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(sizer0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'sizer' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetSizer((wxSizer*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetSizer((wxSizer*) object_pointer0_0);

				references->AddReference(sizer0, "wxWindow::SetSizer at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetSizer((wxSizer*) object_pointer0_0, deleteOld0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetSizer((wxSizer*) object_pointer0_0, deleteOld0);

				references->AddReference(sizer0, "wxWindow::SetSizer at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetSizer\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetSizerAndFit(wxSizer &sizer, bool deleteOld)
   This method calls SetSizer() and then wxSizer::SetSizeHints which sets the initial window size to the size needed to accommodate all sizer elements and sets the size hints which, if this window is a top level one, prevent the user from resizing it to be less than this minimal size. */
PHP_METHOD(php_wxWindow, SetSizerAndFit)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetSizerAndFit\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetSizerAndFit call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* sizer0 = 0;
	wxSizer* object_pointer0_0 = 0;
	bool deleteOld0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|b' (&sizer0, &deleteOld0)\n");
		#endif

		char parse_parameters_string[] = "z|b";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &sizer0, &deleteOld0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(sizer0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSizer*) zend_object_store_get_object(sizer0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSizer*) zend_object_store_get_object(sizer0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxSizer*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXSIZER_TYPE && argument_type != PHP_WXBOXSIZER_TYPE && argument_type != PHP_WXSTATICBOXSIZER_TYPE && argument_type != PHP_WXWRAPSIZER_TYPE && argument_type != PHP_WXSTDDIALOGBUTTONSIZER_TYPE && argument_type != PHP_WXGRIDSIZER_TYPE && argument_type != PHP_WXFLEXGRIDSIZER_TYPE && argument_type != PHP_WXGRIDBAGSIZER_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'sizer' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(sizer0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'sizer' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetSizerAndFit((wxSizer*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetSizerAndFit((wxSizer*) object_pointer0_0);

				references->AddReference(sizer0, "wxWindow::SetSizerAndFit at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetSizerAndFit((wxSizer*) object_pointer0_0, deleteOld0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetSizerAndFit((wxSizer*) object_pointer0_0, deleteOld0);

				references->AddReference(sizer0, "wxWindow::SetSizerAndFit at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetSizerAndFit\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetToolTip(string tipString)
   Attach a tooltip to the window. */
PHP_METHOD(php_wxWindow, SetToolTip)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetToolTip\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetToolTip call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	char* tipString0;
	long tipString_len0;
	bool overload0_called = false;
	//Parameters for overload 1
	zval* tip1 = 0;
	wxToolTip* object_pointer1_0 = 0;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 's' (&tipString0, &tipString_len0)\n");
		#endif

		char parse_parameters_string[] = "s";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &tipString0, &tipString_len0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&tip1)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &tip1 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(tip1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxToolTip*) zend_object_store_get_object(tip1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxToolTip*) zend_object_store_get_object(tip1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxToolTip*) argument_native_object;
					if (!object_pointer1_0 || (argument_type != PHP_WXTOOLTIP_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'tip' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(tip1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'tip' not null, could not be retreived correctly.");
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetToolTip(wxString(tipString0, wxConvUTF8))\n\n");
				#endif

				((wxWindow_php*)native_object)->SetToolTip(wxString(tipString0, wxConvUTF8));


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetToolTip((wxToolTip*) object_pointer1_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetToolTip((wxToolTip*) object_pointer1_0);

				references->AddReference(tip1, "wxWindow::SetToolTip at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetToolTip\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetWindowStyle(int style)
   See SetWindowStyleFlag() for more info. */
PHP_METHOD(php_wxWindow, SetWindowStyle)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetWindowStyle\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetWindowStyle call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long style0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&style0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &style0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetWindowStyle((long) style0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetWindowStyle((long) style0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetWindowStyle\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetWindowStyleFlag(int style)
   Sets the style of the window. */
PHP_METHOD(php_wxWindow, SetWindowStyleFlag)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetWindowStyleFlag\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetWindowStyleFlag call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long style0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&style0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &style0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetWindowStyleFlag((long) style0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetWindowStyleFlag((long) style0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetWindowStyleFlag\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::Update()
   Calling this method immediately repaints the invalidated area of the window and all of its children recursively (this normally only happens when the flow of control returns to the event loop). */
PHP_METHOD(php_wxWindow, Update)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Update\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Update call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
	//Parameters for overload 1
	long value1;
	char* newmsg1;
	long newmsg_len1;
	bool* skip1;
	zval* skip1_ref;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received >= 1  && arguments_received <= 3 && (current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE || current_object_type == PHP_WXPROGRESSDIALOG_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l|sb' (&value1, &newmsg1, &newmsg_len1, skip1)\n");
		#endif

		char parse_parameters_string[] = "l|sb";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &value1, &newmsg1, &newmsg_len1, skip1 ) == SUCCESS)
		{
			overload1_called = true;
			already_called = true;

			char parse_references_string[] = "z|zz";
			zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_references_string, &dummy, &dummy, &skip1_ref );
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::Update()\n\n");
				#endif

				((wxWindow_php*)native_object)->Update();


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxGenericProgressDialog::Update((int) value1))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxGenericProgressDialog_php*)native_object)->Update((int) value1));


				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxGenericProgressDialog::Update((int) value1, wxString(newmsg1, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxGenericProgressDialog_php*)native_object)->Update((int) value1, wxString(newmsg1, wxConvUTF8)));


				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxGenericProgressDialog::Update((int) value1, wxString(newmsg1, wxConvUTF8), skip1))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxGenericProgressDialog_php*)native_object)->Update((int) value1, wxString(newmsg1, wxConvUTF8), skip1));

				size_t elements_returned1_2 = sizeof(skip1)/sizeof(*skip1);
				array_init(skip1_ref);
				for(size_t i=0; i<elements_returned1_2; i++)
				{
					add_next_index_long(skip1_ref, skip1[i]);
				}

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Update\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::UpdateWindowUI(int flags)
   This function sends one or more wxUpdateUIEvent to the window. */
PHP_METHOD(php_wxWindow, UpdateWindowUI)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::UpdateWindowUI\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::UpdateWindowUI call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long flags0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|l' (&flags0)\n");
		#endif

		char parse_parameters_string[] = "|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &flags0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::UpdateWindowUI()\n\n");
				#endif

				((wxWindow_php*)native_object)->UpdateWindowUI();


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::UpdateWindowUI((long) flags0)\n\n");
				#endif

				((wxWindow_php*)native_object)->UpdateWindowUI((long) flags0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::UpdateWindowUI\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::Validate()
   Validates the current values of the child controls using their validators. */
PHP_METHOD(php_wxWindow, Validate)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Validate\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Validate call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::Validate())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->Validate());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Validate\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::WarpPointer(int x, int y)
   Moves the pointer to the given position on the window. */
PHP_METHOD(php_wxWindow, WarpPointer)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::WarpPointer\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::WarpPointer call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long x0;
	long y0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'll' (&x0, &y0)\n");
		#endif

		char parse_parameters_string[] = "ll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &x0, &y0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::WarpPointer((int) x0, (int) y0)\n\n");
				#endif

				((wxWindow_php*)native_object)->WarpPointer((int) x0, (int) y0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::WarpPointer\n");
	}
}
/* }}} */

/* {{{ proto wxSize wxWindow::WindowToClientSize(wxSize size)
   Converts window size size to corresponding client area size In other words, the returned value is what would GetClientSize() return if this window had given window size. */
PHP_METHOD(php_wxWindow, WindowToClientSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::WindowToClientSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::WindowToClientSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* size0 = 0;
	wxSize* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&size0, php_wxSize_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &size0, php_wxSize_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(size0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxSize*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::WindowToClientSize(*(wxSize*) object_pointer0_0) to return new object\n\n");
				#endif

				wxSize value_to_return1;
				value_to_return1 = ((wxWindow_php*)native_object)->WindowToClientSize(*(wxSize*) object_pointer0_0);
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return1, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo1 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo1->native_object = (wxSize_php*) ptr;

				references->AddReference(size0, "wxWindow::WindowToClientSize at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::WindowToClientSize\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::UnsetToolTip()
   Unset any existing tooltip. */
PHP_METHOD(php_wxWindow, UnsetToolTip)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::UnsetToolTip\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::UnsetToolTip call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::UnsetToolTip()\n\n");
				#endif

				((wxWindow_php*)native_object)->UnsetToolTip();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::UnsetToolTip\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::UnreserveControlId(int id, int count)
   Unreserve an ID or range of IDs that was reserved by NewControlId(). */
PHP_METHOD(php_wxWindow, UnreserveControlId)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::UnreserveControlId\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::UnreserveControlId call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long id0;
	long count0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l|l' (&id0, &count0)\n");
		#endif

		char parse_parameters_string[] = "l|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &id0, &count0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Static ");
				php_printf("Executing wxWindow::UnreserveControlId((wxWindowID) id0)\n\n");
				#endif

				wxWindow::UnreserveControlId((wxWindowID) id0);


				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Static ");
				php_printf("Executing wxWindow::UnreserveControlId((wxWindowID) id0, (int) count0)\n\n");
				#endif

				wxWindow::UnreserveControlId((wxWindowID) id0, (int) count0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::UnreserveControlId\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::TransferDataToWindow()
   Transfers values to child controls from data areas specified by their validators. */
PHP_METHOD(php_wxWindow, TransferDataToWindow)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::TransferDataToWindow\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::TransferDataToWindow call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::TransferDataToWindow())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->TransferDataToWindow());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::TransferDataToWindow\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::TransferDataFromWindow()
   Transfers values from child controls to data areas specified by their validators. */
PHP_METHOD(php_wxWindow, TransferDataFromWindow)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::TransferDataFromWindow\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::TransferDataFromWindow call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::TransferDataFromWindow())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->TransferDataFromWindow());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::TransferDataFromWindow\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::ToggleWindowStyle(int flag)
   Turns the given flag on if it's currently turned off and vice versa. */
PHP_METHOD(php_wxWindow, ToggleWindowStyle)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::ToggleWindowStyle\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::ToggleWindowStyle call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long flag0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&flag0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &flag0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::ToggleWindowStyle((int) flag0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->ToggleWindowStyle((int) flag0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::ToggleWindowStyle\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::Thaw()
   Re-enables window updating after a previous call to Freeze(). */
PHP_METHOD(php_wxWindow, Thaw)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Thaw\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Thaw call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::Thaw()\n\n");
				#endif

				((wxWindow_php*)native_object)->Thaw();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Thaw\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::ShouldInheritColours()
   Return true from here to allow the colours of this window to be changed by InheritAttributes(). */
PHP_METHOD(php_wxWindow, ShouldInheritColours)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::ShouldInheritColours\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::ShouldInheritColours call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::ShouldInheritColours())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->ShouldInheritColours());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::ShouldInheritColours\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetVirtualSize(wxSize size)
   This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. */
PHP_METHOD(php_wxWindow, SetVirtualSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetVirtualSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetVirtualSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* size0 = 0;
	wxSize* object_pointer0_0 = 0;
	bool overload0_called = false;
	//Parameters for overload 1
	long width1;
	long height1;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&size0, php_wxSize_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &size0, php_wxSize_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(size0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxSize*) argument_native_object;
					if (!object_pointer0_0 )
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(size0) != IS_NULL)
				{
					goto overload1;
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'll' (&width1, &height1)\n");
		#endif

		char parse_parameters_string[] = "ll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &width1, &height1 ) == SUCCESS)
		{
			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetVirtualSize(*(wxSize*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetVirtualSize(*(wxSize*) object_pointer0_0);

				references->AddReference(size0, "wxWindow::SetVirtualSize at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetVirtualSize((int) width1, (int) height1)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetVirtualSize((int) width1, (int) height1);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetVirtualSize\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetValidator(wxValidator validator)
   Deletes the current validator (if any) and sets the window validator, having called wxValidator::Clone to create a new validator of this type. */
PHP_METHOD(php_wxWindow, SetValidator)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetValidator\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetValidator call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* validator0 = 0;
	wxValidator* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'o' (&validator0)\n");
		#endif

		char parse_parameters_string[] = "o";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &validator0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(validator0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxValidator*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'validator' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(validator0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'validator' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetValidator(*(wxValidator*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetValidator(*(wxValidator*) object_pointer0_0);

				references->AddReference(validator0, "wxWindow::SetValidator at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetValidator\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::SetTransparent(int alpha)
   Set the transparency of the window. */
PHP_METHOD(php_wxWindow, SetTransparent)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetTransparent\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetTransparent call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long alpha0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&alpha0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &alpha0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::SetTransparent((wxByte) alpha0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->SetTransparent((wxByte) alpha0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetTransparent\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetSizeHints(int minW, int minH, int maxW, int maxH, int incW, int incH)
   Prepare for changing positions of multiple child windows. */
PHP_METHOD(php_wxWindow, SetSizeHints)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetSizeHints\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetSizeHints call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long minW0;
	long minH0;
	long maxW0;
	long maxH0;
	long incW0;
	long incH0;
	bool overload0_called = false;
	//Parameters for overload 1
	zval* minSize1 = 0;
	wxSize* object_pointer1_0 = 0;
	zval* maxSize1 = 0;
	wxSize* object_pointer1_1 = 0;
	zval* incSize1 = 0;
	wxSize* object_pointer1_2 = 0;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 2  && arguments_received <= 6)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'll|llll' (&minW0, &minH0, &maxW0, &maxH0, &incW0, &incH0)\n");
		#endif

		char parse_parameters_string[] = "ll|llll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &minW0, &minH0, &maxW0, &maxH0, &incW0, &incH0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received >= 1  && arguments_received <= 3)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O|OO' (&minSize1, php_wxSize_entry, &maxSize1, php_wxSize_entry, &incSize1, php_wxSize_entry)\n");
		#endif

		char parse_parameters_string[] = "O|OO";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &minSize1, php_wxSize_entry, &maxSize1, php_wxSize_entry, &incSize1, php_wxSize_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(minSize1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(minSize1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(minSize1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxSize*) argument_native_object;
					if (!object_pointer1_0 )
					{
						zend_error(E_ERROR, "Parameter 'minSize' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(minSize1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'minSize' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 2){
				if(Z_TYPE_P(maxSize1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(maxSize1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(maxSize1 TSRMLS_CC))->native_object;
					object_pointer1_1 = (wxSize*) argument_native_object;
					if (!object_pointer1_1 )
					{
						zend_error(E_ERROR, "Parameter 'maxSize' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(maxSize1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'maxSize' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(incSize1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(incSize1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(incSize1 TSRMLS_CC))->native_object;
					object_pointer1_2 = (wxSize*) argument_native_object;
					if (!object_pointer1_2 )
					{
						zend_error(E_ERROR, "Parameter 'incSize' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(incSize1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'incSize' not null, could not be retreived correctly.");
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetSizeHints((int) minW0, (int) minH0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetSizeHints((int) minW0, (int) minH0);


				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetSizeHints((int) minW0, (int) minH0, (int) maxW0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetSizeHints((int) minW0, (int) minH0, (int) maxW0);


				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetSizeHints((int) minW0, (int) minH0, (int) maxW0, (int) maxH0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetSizeHints((int) minW0, (int) minH0, (int) maxW0, (int) maxH0);


				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetSizeHints((int) minW0, (int) minH0, (int) maxW0, (int) maxH0, (int) incW0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetSizeHints((int) minW0, (int) minH0, (int) maxW0, (int) maxH0, (int) incW0);


				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetSizeHints((int) minW0, (int) minH0, (int) maxW0, (int) maxH0, (int) incW0, (int) incH0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetSizeHints((int) minW0, (int) minH0, (int) maxW0, (int) maxH0, (int) incW0, (int) incH0);


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetSizeHints(*(wxSize*) object_pointer1_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetSizeHints(*(wxSize*) object_pointer1_0);

				references->AddReference(minSize1, "wxWindow::SetSizeHints at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetSizeHints(*(wxSize*) object_pointer1_0, *(wxSize*) object_pointer1_1)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetSizeHints(*(wxSize*) object_pointer1_0, *(wxSize*) object_pointer1_1);

				references->AddReference(minSize1, "wxWindow::SetSizeHints at call with 2 argument(s)");
				references->AddReference(maxSize1, "wxWindow::SetSizeHints at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetSizeHints(*(wxSize*) object_pointer1_0, *(wxSize*) object_pointer1_1, *(wxSize*) object_pointer1_2)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetSizeHints(*(wxSize*) object_pointer1_0, *(wxSize*) object_pointer1_1, *(wxSize*) object_pointer1_2);

				references->AddReference(minSize1, "wxWindow::SetSizeHints at call with 3 argument(s)");
				references->AddReference(maxSize1, "wxWindow::SetSizeHints at call with 3 argument(s)");
				references->AddReference(incSize1, "wxWindow::SetSizeHints at call with 3 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetSizeHints\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetSize(int width, int height)
   This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. */
PHP_METHOD(php_wxWindow, SetSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long width0;
	long height0;
	bool overload0_called = false;
	//Parameters for overload 1
	zval* size1 = 0;
	wxSize* object_pointer1_0 = 0;
	bool overload1_called = false;
	//Parameters for overload 2
	zval* rect2 = 0;
	wxRect* object_pointer2_0 = 0;
	bool overload2_called = false;
	//Parameters for overload 3
	long x3;
	long y3;
	long width3;
	long height3;
	long sizeFlags3;
	bool overload3_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'll' (&width0, &height0)\n");
		#endif

		char parse_parameters_string[] = "ll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &width0, &height0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&size1, php_wxSize_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &size1, php_wxSize_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(size1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxSize*) argument_native_object;
					if (!object_pointer1_0 )
					{
						goto overload2;
					}
				}
				else if(Z_TYPE_P(size1) != IS_NULL)
				{
					goto overload2;
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

	//Overload 2
	overload2:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&rect2, php_wxRect_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &rect2, php_wxRect_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(rect2) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxRect*) zend_object_store_get_object(rect2 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxRect*) zend_object_store_get_object(rect2 TSRMLS_CC))->native_object;
					object_pointer2_0 = (wxRect*) argument_native_object;
					if (!object_pointer2_0 )
					{
						goto overload3;
					}
				}
				else if(Z_TYPE_P(rect2) != IS_NULL)
				{
					goto overload3;
				}
			}

			overload2_called = true;
			already_called = true;
		}
	}

	//Overload 3
	overload3:
	if(!already_called && arguments_received >= 4  && arguments_received <= 5)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'llll|l' (&x3, &y3, &width3, &height3, &sizeFlags3)\n");
		#endif

		char parse_parameters_string[] = "llll|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &x3, &y3, &width3, &height3, &sizeFlags3 ) == SUCCESS)
		{
			overload3_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetSize((int) width0, (int) height0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetSize((int) width0, (int) height0);


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetSize(*(wxSize*) object_pointer1_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetSize(*(wxSize*) object_pointer1_0);

				references->AddReference(size1, "wxWindow::SetSize at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload2_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetSize(*(wxRect*) object_pointer2_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetSize(*(wxRect*) object_pointer2_0);

				references->AddReference(rect2, "wxWindow::SetSize at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload3_called)
	{
		switch(arguments_received)
		{
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetSize((int) x3, (int) y3, (int) width3, (int) height3)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetSize((int) x3, (int) y3, (int) width3, (int) height3);


				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetSize((int) x3, (int) y3, (int) width3, (int) height3, (int) sizeFlags3)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetSize((int) x3, (int) y3, (int) width3, (int) height3, (int) sizeFlags3);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetSize\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetScrollbar(int orientation, int position, int thumbSize, int range, bool refresh)
   Sets the scrollbar properties of a built-in scrollbar. */
PHP_METHOD(php_wxWindow, SetScrollbar)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetScrollbar\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetScrollbar call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long orientation0;
	long position0;
	long thumbSize0;
	long range0;
	bool refresh0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 4  && arguments_received <= 5)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'llll|b' (&orientation0, &position0, &thumbSize0, &range0, &refresh0)\n");
		#endif

		char parse_parameters_string[] = "llll|b";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &orientation0, &position0, &thumbSize0, &range0, &refresh0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetScrollbar((int) orientation0, (int) position0, (int) thumbSize0, (int) range0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetScrollbar((int) orientation0, (int) position0, (int) thumbSize0, (int) range0);


				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetScrollbar((int) orientation0, (int) position0, (int) thumbSize0, (int) range0, refresh0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetScrollbar((int) orientation0, (int) position0, (int) thumbSize0, (int) range0, refresh0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetScrollbar\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetScrollPos(int orientation, int pos, bool refresh)
   Sets the position of one of the built-in scrollbars. */
PHP_METHOD(php_wxWindow, SetScrollPos)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetScrollPos\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetScrollPos call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long orientation0;
	long pos0;
	bool refresh0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 2  && arguments_received <= 3)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'll|b' (&orientation0, &pos0, &refresh0)\n");
		#endif

		char parse_parameters_string[] = "ll|b";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &orientation0, &pos0, &refresh0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetScrollPos((int) orientation0, (int) pos0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetScrollPos((int) orientation0, (int) pos0);


				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetScrollPos((int) orientation0, (int) pos0, refresh0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetScrollPos((int) orientation0, (int) pos0, refresh0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetScrollPos\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::AcceptsFocus()
   This method may be overridden in the derived classes to return false to indicate that this control doesn't accept input at all (i.e. behaves like e.g. wxStaticText) and so doesn't need focus. */
PHP_METHOD(php_wxWindow, AcceptsFocus)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::AcceptsFocus\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::AcceptsFocus call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::AcceptsFocus())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->AcceptsFocus());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::AcceptsFocus\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::AcceptsFocusFromKeyboard()
   This method may be overridden in the derived classes to return false to indicate that while this control can, in principle, have focus if the user clicks it with the mouse, it shouldn't be included in the TAB traversal chain when using the keyboard. */
PHP_METHOD(php_wxWindow, AcceptsFocusFromKeyboard)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::AcceptsFocusFromKeyboard\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::AcceptsFocusFromKeyboard call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::AcceptsFocusFromKeyboard())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->AcceptsFocusFromKeyboard());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::AcceptsFocusFromKeyboard\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::AcceptsFocusRecursively()
   Overridden to indicate whether this window or one of its children accepts focus. */
PHP_METHOD(php_wxWindow, AcceptsFocusRecursively)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::AcceptsFocusRecursively\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::AcceptsFocusRecursively call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::AcceptsFocusRecursively())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->AcceptsFocusRecursively());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::AcceptsFocusRecursively\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::AddChild(wxWindow &child)
   Adds a child window. */
PHP_METHOD(php_wxWindow, AddChild)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::AddChild\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::AddChild call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* child0 = 0;
	wxWindow* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&child0)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &child0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(child0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(child0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(child0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'child' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(child0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'child' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::AddChild((wxWindow*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->AddChild((wxWindow*) object_pointer0_0);

				references->AddReference(child0, "wxWindow::AddChild at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::AddChild\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::AddPendingEvent(wxEvent event)
   See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow. */
void wxWindow_php::AddPendingEvent(const wxEvent& event)
{
	static zend_function* cached_function = NULL;
	static bool is_php_user_space_implemented = true;
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking virtual wxWindow::AddPendingEvent\n");
	php_printf("===========================================\n");
	#endif
	
	zval** params[1];
	zval *arguments[1];
	
	//Initilize arguments array
	for(int i=0; i<1; i++)
	{
		ALLOC_INIT_ZVAL(arguments[i]);
	}

	zval* return_value;
	MAKE_STD_ZVAL(return_value);
	zval function_name;
	ZVAL_STRING(&function_name, "AddPendingEvent", 0);
	char* temp_string;
	void* return_object;
	int function_called;
	
	//Parameters for conversion
	object_init_ex(arguments[0], php_wxEvent_entry);
	((zo_wxEvent*) zend_object_store_get_object(arguments[0] TSRMLS_CC))->native_object = (wxEvent_php*) &event;
		
	for(int i=0; i<1; i++)
	{
		params[i] = &arguments[i];
	}

	#ifdef USE_WXPHP_DEBUG
	php_printf("Trying to call user defined method\n");
	#endif
	
	if(is_php_user_space_implemented)
	{
		function_called = wxphp_call_method((zval**) &this->phpObj, NULL, &cached_function, "AddPendingEvent", 15, &return_value, 1, params TSRMLS_CC);
	}
	else
	{
		function_called = FAILURE;
	}
    
    	
	//Delete already used parameters from memory
	for(int i=0; i<1; i++)
	{
		zval_ptr_dtor(&arguments[i]);
	}
	
	if(function_called == FAILURE)
	{
		is_php_user_space_implemented = false;
		
		#ifdef USE_WXPHP_DEBUG
		php_printf("Invocation of user defined method failed\n");
		#endif
		
	}
	else
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Returning userspace value.\n");
		#endif
		
		return;
	}
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling original method\n");
	php_printf("===========================================\n\n");
	#endif
	
	//Call original method
	wxWindow::AddPendingEvent(event);
}
/* }}} */

/* {{{ proto  wxWindow::AlwaysShowScrollbars(bool hflag, bool vflag)
   Call this function to force one or both scrollbars to be always shown, even if the window is big enough to show its entire contents without scrolling. */
PHP_METHOD(php_wxWindow, AlwaysShowScrollbars)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::AlwaysShowScrollbars\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::AlwaysShowScrollbars call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool hflag0;
	bool vflag0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|bb' (&hflag0, &vflag0)\n");
		#endif

		char parse_parameters_string[] = "|bb";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &hflag0, &vflag0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::AlwaysShowScrollbars()\n\n");
				#endif

				((wxWindow_php*)native_object)->AlwaysShowScrollbars();


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::AlwaysShowScrollbars(hflag0)\n\n");
				#endif

				((wxWindow_php*)native_object)->AlwaysShowScrollbars(hflag0);


				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::AlwaysShowScrollbars(hflag0, vflag0)\n\n");
				#endif

				((wxWindow_php*)native_object)->AlwaysShowScrollbars(hflag0, vflag0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::AlwaysShowScrollbars\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::CacheBestSize(wxSize size)
   Sets the cached best size value. */
PHP_METHOD(php_wxWindow, CacheBestSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::CacheBestSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::CacheBestSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* size0 = 0;
	wxSize* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&size0, php_wxSize_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &size0, php_wxSize_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(size0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxSize*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::CacheBestSize(*(wxSize*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->CacheBestSize(*(wxSize*) object_pointer0_0);

				references->AddReference(size0, "wxWindow::CacheBestSize at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::CacheBestSize\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::CanScroll(int orient)
   Returns true if this window can have a scroll bar in this orientation. */
PHP_METHOD(php_wxWindow, CanScroll)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::CanScroll\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::CanScroll call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long orient0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&orient0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &orient0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::CanScroll((int) orient0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->CanScroll((int) orient0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::CanScroll\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::CanSetTransparent()
   Returns true if the system supports transparent windows and calling SetTransparent() may succeed. */
PHP_METHOD(php_wxWindow, CanSetTransparent)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::CanSetTransparent\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::CanSetTransparent call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::CanSetTransparent())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->CanSetTransparent());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::CanSetTransparent\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::CaptureMouse()
   Directs all mouse input to this window. */
PHP_METHOD(php_wxWindow, CaptureMouse)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::CaptureMouse\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::CaptureMouse call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::CaptureMouse()\n\n");
				#endif

				((wxWindow_php*)native_object)->CaptureMouse();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::CaptureMouse\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::Center(int dir)
   A synonym for Centre(). */
PHP_METHOD(php_wxWindow, Center)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Center\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Center call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long dir0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|l' (&dir0)\n");
		#endif

		char parse_parameters_string[] = "|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &dir0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::Center()\n\n");
				#endif

				((wxWindow_php*)native_object)->Center();


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::Center((int) dir0)\n\n");
				#endif

				((wxWindow_php*)native_object)->Center((int) dir0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Center\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::CenterOnParent(int dir)
   A synonym for CentreOnParent(). */
PHP_METHOD(php_wxWindow, CenterOnParent)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::CenterOnParent\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::CenterOnParent call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long dir0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|l' (&dir0)\n");
		#endif

		char parse_parameters_string[] = "|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &dir0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::CenterOnParent()\n\n");
				#endif

				((wxWindow_php*)native_object)->CenterOnParent();


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::CenterOnParent((int) dir0)\n\n");
				#endif

				((wxWindow_php*)native_object)->CenterOnParent((int) dir0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::CenterOnParent\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::Centre(int direction)
   Centres the window. */
PHP_METHOD(php_wxWindow, Centre)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Centre\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Centre call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long direction0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|l' (&direction0)\n");
		#endif

		char parse_parameters_string[] = "|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &direction0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::Centre()\n\n");
				#endif

				((wxWindow_php*)native_object)->Centre();


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::Centre((int) direction0)\n\n");
				#endif

				((wxWindow_php*)native_object)->Centre((int) direction0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Centre\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::CentreOnParent(int direction)
   Centres the window on its parent. */
PHP_METHOD(php_wxWindow, CentreOnParent)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::CentreOnParent\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::CentreOnParent call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long direction0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|l' (&direction0)\n");
		#endif

		char parse_parameters_string[] = "|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &direction0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::CentreOnParent()\n\n");
				#endif

				((wxWindow_php*)native_object)->CentreOnParent();


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::CentreOnParent((int) direction0)\n\n");
				#endif

				((wxWindow_php*)native_object)->CentreOnParent((int) direction0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::CentreOnParent\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::ClearBackground()
   Clears the window by filling it with the current background colour. */
PHP_METHOD(php_wxWindow, ClearBackground)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::ClearBackground\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::ClearBackground call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::ClearBackground()\n\n");
				#endif

				((wxWindow_php*)native_object)->ClearBackground();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::ClearBackground\n");
	}
}
/* }}} */

/* {{{ proto wxPoint wxWindow::ClientToScreen(wxPoint pt)
   Converts to screen coordinates from coordinates relative to this window. */
PHP_METHOD(php_wxWindow, ClientToScreen)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::ClientToScreen\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::ClientToScreen call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* pt0 = 0;
	wxPoint* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&pt0, php_wxPoint_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pt0, php_wxPoint_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(pt0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pt0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pt0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxPoint*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'pt' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(pt0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'pt' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::ClientToScreen(*(wxPoint*) object_pointer0_0) to return new object\n\n");
				#endif

				wxPoint value_to_return1;
				value_to_return1 = ((wxWindow_php*)native_object)->ClientToScreen(*(wxPoint*) object_pointer0_0);
				void* ptr = safe_emalloc(1, sizeof(wxPoint_php), 0);
				memcpy(ptr, (void*) &value_to_return1, sizeof(wxPoint));
				object_init_ex(return_value, php_wxPoint_entry);
				((wxPoint_php*)ptr)->phpObj = return_value;
				((wxPoint_php*)ptr)->InitProperties();
				zo_wxPoint* zo1 = (zo_wxPoint*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo1->native_object = (wxPoint_php*) ptr;

				references->AddReference(pt0, "wxWindow::ClientToScreen at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::ClientToScreen\n");
	}
}
/* }}} */

/* {{{ proto wxSize wxWindow::ClientToWindowSize(wxSize size)
   Converts client area size size to corresponding window size. */
PHP_METHOD(php_wxWindow, ClientToWindowSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::ClientToWindowSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::ClientToWindowSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* size0 = 0;
	wxSize* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&size0, php_wxSize_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &size0, php_wxSize_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(size0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxSize*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::ClientToWindowSize(*(wxSize*) object_pointer0_0) to return new object\n\n");
				#endif

				wxSize value_to_return1;
				value_to_return1 = ((wxWindow_php*)native_object)->ClientToWindowSize(*(wxSize*) object_pointer0_0);
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return1, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo1 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo1->native_object = (wxSize_php*) ptr;

				references->AddReference(size0, "wxWindow::ClientToWindowSize at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::ClientToWindowSize\n");
	}
}
/* }}} */

/* {{{ proto wxPoint wxWindow::ConvertDialogToPixels(wxPoint pt)
   Converts a point or size from dialog units to pixels. */
PHP_METHOD(php_wxWindow, ConvertDialogToPixels)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::ConvertDialogToPixels\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::ConvertDialogToPixels call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* pt0 = 0;
	wxPoint* object_pointer0_0 = 0;
	bool overload0_called = false;
	//Parameters for overload 1
	zval* sz1 = 0;
	wxSize* object_pointer1_0 = 0;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&pt0, php_wxPoint_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pt0, php_wxPoint_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(pt0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pt0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pt0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxPoint*) argument_native_object;
					if (!object_pointer0_0 )
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(pt0) != IS_NULL)
				{
					goto overload1;
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&sz1, php_wxSize_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &sz1, php_wxSize_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(sz1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(sz1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(sz1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxSize*) argument_native_object;
					if (!object_pointer1_0 )
					{
						zend_error(E_ERROR, "Parameter 'sz' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(sz1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'sz' not null, could not be retreived correctly.");
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::ConvertDialogToPixels(*(wxPoint*) object_pointer0_0) to return new object\n\n");
				#endif

				wxPoint value_to_return1;
				value_to_return1 = ((wxWindow_php*)native_object)->ConvertDialogToPixels(*(wxPoint*) object_pointer0_0);
				void* ptr = safe_emalloc(1, sizeof(wxPoint_php), 0);
				memcpy(ptr, (void*) &value_to_return1, sizeof(wxPoint));
				object_init_ex(return_value, php_wxPoint_entry);
				((wxPoint_php*)ptr)->phpObj = return_value;
				((wxPoint_php*)ptr)->InitProperties();
				zo_wxPoint* zo1 = (zo_wxPoint*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo1->native_object = (wxPoint_php*) ptr;

				references->AddReference(pt0, "wxWindow::ConvertDialogToPixels at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::ConvertDialogToPixels(*(wxSize*) object_pointer1_0) to return new object\n\n");
				#endif

				wxSize value_to_return1;
				value_to_return1 = ((wxWindow_php*)native_object)->ConvertDialogToPixels(*(wxSize*) object_pointer1_0);
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return1, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo1 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo1->native_object = (wxSize_php*) ptr;

				references->AddReference(sz1, "wxWindow::ConvertDialogToPixels at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::ConvertDialogToPixels\n");
	}
}
/* }}} */

/* {{{ proto wxPoint wxWindow::ConvertPixelsToDialog(wxPoint pt)
   Converts a point or size from pixels to dialog units. */
PHP_METHOD(php_wxWindow, ConvertPixelsToDialog)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::ConvertPixelsToDialog\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::ConvertPixelsToDialog call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* pt0 = 0;
	wxPoint* object_pointer0_0 = 0;
	bool overload0_called = false;
	//Parameters for overload 1
	zval* sz1 = 0;
	wxSize* object_pointer1_0 = 0;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&pt0, php_wxPoint_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pt0, php_wxPoint_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(pt0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pt0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pt0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxPoint*) argument_native_object;
					if (!object_pointer0_0 )
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(pt0) != IS_NULL)
				{
					goto overload1;
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&sz1, php_wxSize_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &sz1, php_wxSize_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(sz1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(sz1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(sz1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxSize*) argument_native_object;
					if (!object_pointer1_0 )
					{
						zend_error(E_ERROR, "Parameter 'sz' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(sz1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'sz' not null, could not be retreived correctly.");
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::ConvertPixelsToDialog(*(wxPoint*) object_pointer0_0) to return new object\n\n");
				#endif

				wxPoint value_to_return1;
				value_to_return1 = ((wxWindow_php*)native_object)->ConvertPixelsToDialog(*(wxPoint*) object_pointer0_0);
				void* ptr = safe_emalloc(1, sizeof(wxPoint_php), 0);
				memcpy(ptr, (void*) &value_to_return1, sizeof(wxPoint));
				object_init_ex(return_value, php_wxPoint_entry);
				((wxPoint_php*)ptr)->phpObj = return_value;
				((wxPoint_php*)ptr)->InitProperties();
				zo_wxPoint* zo1 = (zo_wxPoint*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo1->native_object = (wxPoint_php*) ptr;

				references->AddReference(pt0, "wxWindow::ConvertPixelsToDialog at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::ConvertPixelsToDialog(*(wxSize*) object_pointer1_0) to return new object\n\n");
				#endif

				wxSize value_to_return1;
				value_to_return1 = ((wxWindow_php*)native_object)->ConvertPixelsToDialog(*(wxSize*) object_pointer1_0);
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return1, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo1 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo1->native_object = (wxSize_php*) ptr;

				references->AddReference(sz1, "wxWindow::ConvertPixelsToDialog at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::ConvertPixelsToDialog\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::Create(wxWindow &parent, int id, wxPoint pos, wxSize size, int style, string name) */
PHP_METHOD(php_wxWindow, Create)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Create\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Create call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* parent0 = 0;
	wxWindow* object_pointer0_0 = 0;
	long id0;
	zval* pos0 = 0;
	wxPoint* object_pointer0_2 = 0;
	zval* size0 = 0;
	wxSize* object_pointer0_3 = 0;
	long style0;
	char* name0;
	long name_len0;
	bool overload0_called = false;
	//Parameters for overload 1
	zval* parent1 = 0;
	wxWindow* object_pointer1_0 = 0;
	long id1;
	char* title1;
	long title_len1;
	zval* pos1 = 0;
	wxPoint* object_pointer1_3 = 0;
	zval* size1 = 0;
	wxSize* object_pointer1_4 = 0;
	long style1;
	char* name1;
	long name_len1;
	bool overload1_called = false;
	//Parameters for overload 2
	zval* parent2 = 0;
	wxWindow* object_pointer2_0 = 0;
	long id2;
	char* title2;
	long title_len2;
	zval* pos2 = 0;
	wxPoint* object_pointer2_3 = 0;
	zval* size2 = 0;
	wxSize* object_pointer2_4 = 0;
	long style2;
	char* name2;
	long name_len2;
	bool overload2_called = false;
	//Parameters for overload 3
	zval* parent3 = 0;
	wxMDIParentFrame* object_pointer3_0 = 0;
	long id3;
	char* title3;
	long title_len3;
	zval* pos3 = 0;
	wxPoint* object_pointer3_3 = 0;
	zval* size3 = 0;
	wxSize* object_pointer3_4 = 0;
	long style3;
	char* name3;
	long name_len3;
	bool overload3_called = false;
	//Parameters for overload 4
	zval* parent4 = 0;
	wxWindow* object_pointer4_0 = 0;
	long id4;
	char* title4;
	long title_len4;
	zval* pos4 = 0;
	wxPoint* object_pointer4_3 = 0;
	zval* size4 = 0;
	wxSize* object_pointer4_4 = 0;
	long style4;
	char* name4;
	long name_len4;
	bool overload4_called = false;
	//Parameters for overload 5
	zval* parent5 = 0;
	wxWindow* object_pointer5_0 = 0;
	long id5;
	char* title5;
	long title_len5;
	zval* pos5 = 0;
	wxPoint* object_pointer5_3 = 0;
	zval* size5 = 0;
	wxSize* object_pointer5_4 = 0;
	long style5;
	char* name5;
	long name_len5;
	bool overload5_called = false;
	//Parameters for overload 6
	zval* parent6 = 0;
	wxWindow* object_pointer6_0 = 0;
	long id6;
	char* title6;
	long title_len6;
	long style6;
	bool overload6_called = false;
	//Parameters for overload 7
	zval* parent7 = 0;
	wxWindow* object_pointer7_0 = 0;
	long id7;
	char* title7;
	long title_len7;
	long style7;
	zval* config7 = 0;
	wxConfigBase* object_pointer7_4 = 0;
	char* rootpath7;
	long rootpath_len7;
	bool overload7_called = false;
	//Parameters for overload 8
	zval* parent8 = 0;
	wxWindow* object_pointer8_0 = 0;
	long id8;
	char* title8;
	long title_len8;
	zval* pos8 = 0;
	wxPoint* object_pointer8_3 = 0;
	zval* size8 = 0;
	wxSize* object_pointer8_4 = 0;
	long style8;
	char* name8;
	long name_len8;
	bool overload8_called = false;
	//Parameters for overload 9
	zval* parent9 = 0;
	wxWindow* object_pointer9_0 = 0;
	zval* data9 = 0;
	wxFindReplaceData* object_pointer9_1 = 0;
	char* title9;
	long title_len9;
	long style9;
	bool overload9_called = false;
	//Parameters for overload 10
	char* symbol10;
	long symbol_len10;
	char* initialFont10;
	long initialFont_len10;
	char* normalTextFont10;
	long normalTextFont_len10;
	zval* parent10 = 0;
	wxWindow* object_pointer10_3 = 0;
	long id10;
	char* caption10;
	long caption_len10;
	zval* pos10 = 0;
	wxPoint* object_pointer10_6 = 0;
	zval* size10 = 0;
	wxSize* object_pointer10_7 = 0;
	long style10;
	bool overload10_called = false;
	//Parameters for overload 11
	zval* parent11 = 0;
	wxWindow* object_pointer11_0 = 0;
	long id11;
	char* title11;
	long title_len11;
	zval* pos11 = 0;
	wxPoint* object_pointer11_3 = 0;
	zval* size11 = 0;
	wxSize* object_pointer11_4 = 0;
	long style11;
	char* name11;
	long name_len11;
	bool overload11_called = false;
	//Parameters for overload 12
	zval* parent12 = 0;
	wxWindow* object_pointer12_0 = 0;
	long id12;
	char* title12;
	long title_len12;
	zval* bitmap12 = 0;
	wxBitmap* object_pointer12_3 = 0;
	zval* pos12 = 0;
	wxPoint* object_pointer12_4 = 0;
	long style12;
	bool overload12_called = false;
	//Parameters for overload 13
	zval* parent13 = 0;
	wxWindow* object_pointer13_0 = 0;
	zval* data13 = 0;
	wxColourData* object_pointer13_1 = 0;
	bool overload13_called = false;
	//Parameters for overload 14
	zval* parent14 = 0;
	wxWindow* object_pointer14_0 = 0;
	bool overload14_called = false;
	//Parameters for overload 15
	zval* parent15 = 0;
	wxWindow* object_pointer15_0 = 0;
	zval* data15 = 0;
	wxFontData* object_pointer15_1 = 0;
	bool overload15_called = false;
	//Parameters for overload 16
	zval* parent16 = 0;
	wxWindow* object_pointer16_0 = 0;
	long flags16;
	bool overload16_called = false;
	//Parameters for overload 17
	zval* parent17 = 0;
	wxWindow* object_pointer17_0 = 0;
	long id17;
	zval* pos17 = 0;
	wxPoint* object_pointer17_2 = 0;
	zval* size17 = 0;
	wxSize* object_pointer17_3 = 0;
	long style17;
	zval* validator17 = 0;
	wxValidator* object_pointer17_5 = 0;
	char* name17;
	long name_len17;
	bool overload17_called = false;
	//Parameters for overload 18
	zval* parent18 = 0;
	wxWindow* object_pointer18_0 = 0;
	long id18;
	long style18;
	char* name18;
	long name_len18;
	bool overload18_called = false;
	//Parameters for overload 19
	zval* parent19 = 0;
	wxWindow* object_pointer19_0 = 0;
	long id19;
	char* label19;
	long label_len19;
	zval* pos19 = 0;
	wxPoint* object_pointer19_3 = 0;
	zval* size19 = 0;
	wxSize* object_pointer19_4 = 0;
	long style19;
	zval* validator19 = 0;
	wxValidator* object_pointer19_6 = 0;
	char* name19;
	long name_len19;
	bool overload19_called = false;
	//Parameters for overload 20
	zval* parent20 = 0;
	wxWindow* object_pointer20_0 = 0;
	long id20;
	zval* bitmap20 = 0;
	wxBitmap* object_pointer20_2 = 0;
	zval* pos20 = 0;
	wxPoint* object_pointer20_3 = 0;
	zval* size20 = 0;
	wxSize* object_pointer20_4 = 0;
	long style20;
	zval* validator20 = 0;
	wxValidator* object_pointer20_6 = 0;
	char* name20;
	long name_len20;
	bool overload20_called = false;
	//Parameters for overload 21
	zval* parent21 = 0;
	wxWindow* object_pointer21_0 = 0;
	long id21;
	char* label21;
	long label_len21;
	zval* pos21 = 0;
	wxPoint* object_pointer21_3 = 0;
	zval* size21 = 0;
	wxSize* object_pointer21_4 = 0;
	long style21;
	zval* val21 = 0;
	wxValidator* object_pointer21_6 = 0;
	char* name21;
	long name_len21;
	bool overload21_called = false;
	//Parameters for overload 22
	zval* parent22 = 0;
	wxWindow* object_pointer22_0 = 0;
	long id22;
	zval* label22 = 0;
	wxBitmap* object_pointer22_2 = 0;
	zval* pos22 = 0;
	wxPoint* object_pointer22_3 = 0;
	zval* size22 = 0;
	wxSize* object_pointer22_4 = 0;
	long style22;
	zval* val22 = 0;
	wxValidator* object_pointer22_6 = 0;
	char* name22;
	long name_len22;
	bool overload22_called = false;
	//Parameters for overload 23
	zval* parent23 = 0;
	wxWindow* object_pointer23_0 = 0;
	long id23;
	zval* pos23 = 0;
	wxPoint* object_pointer23_2 = 0;
	zval* size23 = 0;
	wxSize* object_pointer23_3 = 0;
	long style23;
	zval* validator23 = 0;
	wxValidator* object_pointer23_5 = 0;
	char* name23;
	long name_len23;
	bool overload23_called = false;
	//Parameters for overload 24
	zval* parent24 = 0;
	wxWindow* object_pointer24_0 = 0;
	long id24;
	zval* pos24 = 0;
	wxPoint* object_pointer24_2 = 0;
	zval* size24 = 0;
	wxSize* object_pointer24_3 = 0;
	zval* choices24 = 0;
	long style24;
	zval* validator24 = 0;
	wxValidator* object_pointer24_6 = 0;
	char* name24;
	long name_len24;
	bool overload24_called = false;
	//Parameters for overload 25
	zval* parent25 = 0;
	wxWindow* object_pointer25_0 = 0;
	long id25;
	zval* pos25 = 0;
	wxPoint* object_pointer25_2 = 0;
	zval* size25 = 0;
	wxSize* object_pointer25_3 = 0;
	long n25;
	zval* choices25;
	long style25;
	zval* validator25 = 0;
	wxValidator* object_pointer25_7 = 0;
	char* name25;
	long name_len25;
	bool overload25_called = false;
	//Parameters for overload 26
	zval* parent26 = 0;
	wxWindow* object_pointer26_0 = 0;
	long id26;
	zval* pos26 = 0;
	wxPoint* object_pointer26_2 = 0;
	zval* size26 = 0;
	wxSize* object_pointer26_3 = 0;
	long nStrings26;
	zval* choices26;
	long style26;
	zval* validator26 = 0;
	wxValidator* object_pointer26_7 = 0;
	char* name26;
	long name_len26;
	bool overload26_called = false;
	//Parameters for overload 27
	zval* parent27 = 0;
	wxWindow* object_pointer27_0 = 0;
	long id27;
	zval* pos27 = 0;
	wxPoint* object_pointer27_2 = 0;
	zval* size27 = 0;
	wxSize* object_pointer27_3 = 0;
	zval* choices27 = 0;
	long style27;
	zval* validator27 = 0;
	wxValidator* object_pointer27_6 = 0;
	char* name27;
	long name_len27;
	bool overload27_called = false;
	//Parameters for overload 28
	zval* parent28 = 0;
	wxWindow* object_pointer28_0 = 0;
	long id28;
	zval* pos28 = 0;
	wxPoint* object_pointer28_2 = 0;
	zval* size28 = 0;
	wxSize* object_pointer28_3 = 0;
	zval* choices28 = 0;
	long style28;
	zval* validator28 = 0;
	wxValidator* object_pointer28_6 = 0;
	char* name28;
	long name_len28;
	bool overload28_called = false;
	//Parameters for overload 29
	zval* parent29 = 0;
	wxWindow* object_pointer29_0 = 0;
	long id29;
	zval* pos29 = 0;
	wxPoint* object_pointer29_2 = 0;
	zval* size29 = 0;
	wxSize* object_pointer29_3 = 0;
	long n29;
	zval* choices29;
	long style29;
	zval* validator29 = 0;
	wxValidator* object_pointer29_7 = 0;
	char* name29;
	long name_len29;
	bool overload29_called = false;
	//Parameters for overload 30
	zval* parent30 = 0;
	wxWindow* object_pointer30_0 = 0;
	long id30;
	zval* pos30 = 0;
	wxPoint* object_pointer30_2 = 0;
	zval* size30 = 0;
	wxSize* object_pointer30_3 = 0;
	long style30;
	bool overload30_called = false;
	//Parameters for overload 31
	zval* parent31 = 0;
	wxWindow* object_pointer31_0 = 0;
	long id31;
	zval* anim31 = 0;
	wxAnimation* object_pointer31_2 = 0;
	zval* pos31 = 0;
	wxPoint* object_pointer31_3 = 0;
	zval* size31 = 0;
	wxSize* object_pointer31_4 = 0;
	long style31;
	char* name31;
	long name_len31;
	bool overload31_called = false;
	//Parameters for overload 32
	zval* parent32 = 0;
	wxWindow* object_pointer32_0 = 0;
	long id32;
	zval* pos32 = 0;
	wxPoint* object_pointer32_2 = 0;
	zval* size32 = 0;
	wxSize* object_pointer32_3 = 0;
	long style32;
	zval* validator32 = 0;
	wxValidator* object_pointer32_5 = 0;
	char* name32;
	long name_len32;
	bool overload32_called = false;
	//Parameters for overload 33
	zval* parent33 = 0;
	wxWindow* object_pointer33_0 = 0;
	long id33;
	char* label33;
	long label_len33;
	zval* pos33 = 0;
	wxPoint* object_pointer33_3 = 0;
	zval* size33 = 0;
	wxSize* object_pointer33_4 = 0;
	long style33;
	char* name33;
	long name_len33;
	bool overload33_called = false;
	//Parameters for overload 34
	zval* parent34 = 0;
	wxWindow* object_pointer34_0 = 0;
	long id34;
	char* label34;
	long label_len34;
	zval* pos34 = 0;
	wxPoint* object_pointer34_3 = 0;
	zval* size34 = 0;
	wxSize* object_pointer34_4 = 0;
	long style34;
	char* name34;
	long name_len34;
	bool overload34_called = false;
	//Parameters for overload 35
	zval* parent35 = 0;
	wxWindow* object_pointer35_0 = 0;
	long id35;
	zval* label35 = 0;
	wxBitmap* object_pointer35_2 = 0;
	zval* pos35 = 0;
	wxPoint* object_pointer35_3 = 0;
	zval* size35 = 0;
	wxSize* object_pointer35_4 = 0;
	long style35;
	char* name35;
	long name_len35;
	bool overload35_called = false;
	//Parameters for overload 36
	zval* parent36 = 0;
	wxWindow* object_pointer36_0 = 0;
	long id36;
	char* label36;
	long label_len36;
	zval* pos36 = 0;
	wxPoint* object_pointer36_3 = 0;
	zval* size36 = 0;
	wxSize* object_pointer36_4 = 0;
	long style36;
	zval* validator36 = 0;
	wxValidator* object_pointer36_6 = 0;
	char* name36;
	long name_len36;
	bool overload36_called = false;
	//Parameters for overload 37
	zval* parent37 = 0;
	wxWindow* object_pointer37_0 = 0;
	long id37;
	char* value37;
	long value_len37;
	zval* pos37 = 0;
	wxPoint* object_pointer37_3 = 0;
	zval* size37 = 0;
	wxSize* object_pointer37_4 = 0;
	long style37;
	zval* validator37 = 0;
	wxValidator* object_pointer37_6 = 0;
	char* name37;
	long name_len37;
	bool overload37_called = false;
	//Parameters for overload 38
	zval* parent38 = 0;
	wxWindow* object_pointer38_0 = 0;
	long id38;
	char* value38;
	long value_len38;
	zval* pos38 = 0;
	wxPoint* object_pointer38_3 = 0;
	zval* size38 = 0;
	wxSize* object_pointer38_4 = 0;
	long style38;
	zval* validator38 = 0;
	wxValidator* object_pointer38_6 = 0;
	char* name38;
	long name_len38;
	bool overload38_called = false;
	//Parameters for overload 39
	zval* parent39 = 0;
	wxWindow* object_pointer39_0 = 0;
	long id39;
	char* value39;
	long value_len39;
	zval* pos39 = 0;
	wxPoint* object_pointer39_3 = 0;
	zval* size39 = 0;
	wxSize* object_pointer39_4 = 0;
	long n39;
	zval* choices39;
	long style39;
	zval* validator39 = 0;
	wxValidator* object_pointer39_8 = 0;
	char* name39;
	long name_len39;
	bool overload39_called = false;
	//Parameters for overload 40
	zval* parent40 = 0;
	wxWindow* object_pointer40_0 = 0;
	long id40;
	char* value40;
	long value_len40;
	zval* pos40 = 0;
	wxPoint* object_pointer40_3 = 0;
	zval* size40 = 0;
	wxSize* object_pointer40_4 = 0;
	zval* choices40 = 0;
	long style40;
	zval* validator40 = 0;
	wxValidator* object_pointer40_7 = 0;
	char* name40;
	long name_len40;
	bool overload40_called = false;
	//Parameters for overload 41
	zval* parent41 = 0;
	wxWindow* object_pointer41_0 = 0;
	long id41;
	char* value41;
	long value_len41;
	zval* pos41 = 0;
	wxPoint* object_pointer41_3 = 0;
	zval* size41 = 0;
	wxSize* object_pointer41_4 = 0;
	zval* choices41 = 0;
	long style41;
	zval* validator41 = 0;
	wxValidator* object_pointer41_7 = 0;
	char* name41;
	long name_len41;
	bool overload41_called = false;
	//Parameters for overload 42
	zval* parent42 = 0;
	wxWindow* object_pointer42_0 = 0;
	long id42;
	char* value42;
	long value_len42;
	zval* pos42 = 0;
	wxPoint* object_pointer42_3 = 0;
	zval* size42 = 0;
	wxSize* object_pointer42_4 = 0;
	long n42;
	zval* choices42;
	long style42;
	zval* validator42 = 0;
	wxValidator* object_pointer42_8 = 0;
	char* name42;
	long name_len42;
	bool overload42_called = false;
	//Parameters for overload 43
	zval* parent43 = 0;
	wxWindow* object_pointer43_0 = 0;
	long id43;
	zval* pos43 = 0;
	wxPoint* object_pointer43_2 = 0;
	zval* size43 = 0;
	wxSize* object_pointer43_3 = 0;
	long style43;
	zval* validator43 = 0;
	wxValidator* object_pointer43_5 = 0;
	char* name43;
	long name_len43;
	bool overload43_called = false;
	//Parameters for overload 44
	zval* parent44 = 0;
	wxWindow* object_pointer44_0 = 0;
	long id44;
	char* label44;
	long label_len44;
	zval* pos44 = 0;
	wxPoint* object_pointer44_3 = 0;
	zval* size44 = 0;
	wxSize* object_pointer44_4 = 0;
	long n44;
	zval* choices44;
	long majorDimension44;
	long style44;
	zval* validator44 = 0;
	wxValidator* object_pointer44_9 = 0;
	char* name44;
	long name_len44;
	bool overload44_called = false;
	//Parameters for overload 45
	zval* parent45 = 0;
	wxWindow* object_pointer45_0 = 0;
	long id45;
	char* label45;
	long label_len45;
	zval* pos45 = 0;
	wxPoint* object_pointer45_3 = 0;
	zval* size45 = 0;
	wxSize* object_pointer45_4 = 0;
	zval* choices45 = 0;
	long majorDimension45;
	long style45;
	zval* validator45 = 0;
	wxValidator* object_pointer45_8 = 0;
	char* name45;
	long name_len45;
	bool overload45_called = false;
	//Parameters for overload 46
	zval* parent46 = 0;
	wxWindow* object_pointer46_0 = 0;
	long id46;
	char* label46;
	long label_len46;
	zval* pos46 = 0;
	wxPoint* object_pointer46_3 = 0;
	zval* size46 = 0;
	wxSize* object_pointer46_4 = 0;
	long style46;
	zval* validator46 = 0;
	wxValidator* object_pointer46_6 = 0;
	char* name46;
	long name_len46;
	bool overload46_called = false;
	//Parameters for overload 47
	zval* parent47 = 0;
	wxWindow* object_pointer47_0 = 0;
	long id47;
	long value47;
	long minValue47;
	long maxValue47;
	zval* point47 = 0;
	wxPoint* object_pointer47_5 = 0;
	zval* size47 = 0;
	wxSize* object_pointer47_6 = 0;
	long style47;
	zval* validator47 = 0;
	wxValidator* object_pointer47_8 = 0;
	char* name47;
	long name_len47;
	bool overload47_called = false;
	//Parameters for overload 48
	zval* parent48 = 0;
	wxWindow* object_pointer48_0 = 0;
	long id48;
	char* value48;
	long value_len48;
	zval* pos48 = 0;
	wxPoint* object_pointer48_3 = 0;
	zval* size48 = 0;
	wxSize* object_pointer48_4 = 0;
	long style48;
	long min48;
	long max48;
	long initial48;
	char* name48;
	long name_len48;
	bool overload48_called = false;
	//Parameters for overload 49
	zval* parent49 = 0;
	wxWindow* object_pointer49_0 = 0;
	long id49;
	long range49;
	zval* pos49 = 0;
	wxPoint* object_pointer49_3 = 0;
	zval* size49 = 0;
	wxSize* object_pointer49_4 = 0;
	long style49;
	zval* validator49 = 0;
	wxValidator* object_pointer49_6 = 0;
	char* name49;
	long name_len49;
	bool overload49_called = false;
	//Parameters for overload 50
	zval* parent50 = 0;
	wxWindow* object_pointer50_0 = 0;
	long id50;
	char* label50;
	long label_len50;
	char* url50;
	long url_len50;
	zval* pos50 = 0;
	wxPoint* object_pointer50_4 = 0;
	zval* size50 = 0;
	wxSize* object_pointer50_5 = 0;
	long style50;
	char* name50;
	long name_len50;
	bool overload50_called = false;
	//Parameters for overload 51
	zval* parent51 = 0;
	wxWindow* object_pointer51_0 = 0;
	long id51;
	char* value51;
	long value_len51;
	zval* pos51 = 0;
	wxPoint* object_pointer51_3 = 0;
	zval* size51 = 0;
	wxSize* object_pointer51_4 = 0;
	long style51;
	double min51;
	double max51;
	double initial51;
	double inc51;
	char* name51;
	long name_len51;
	bool overload51_called = false;
	//Parameters for overload 52
	zval* parent52 = 0;
	wxWindow* object_pointer52_0 = 0;
	long id52;
	char* dir52;
	long dir_len52;
	zval* pos52 = 0;
	wxPoint* object_pointer52_3 = 0;
	zval* size52 = 0;
	wxSize* object_pointer52_4 = 0;
	long style52;
	char* filter52;
	long filter_len52;
	long defaultFilter52;
	char* name52;
	long name_len52;
	bool overload52_called = false;
	//Parameters for overload 53
	zval* parent53 = 0;
	wxWindow* object_pointer53_0 = 0;
	long id53;
	time_t date53;
	zval* pos53 = 0;
	wxPoint* object_pointer53_3 = 0;
	zval* size53 = 0;
	wxSize* object_pointer53_4 = 0;
	long style53;
	char* name53;
	long name_len53;
	bool overload53_called = false;
	//Parameters for overload 54
	zval* parent54 = 0;
	wxWindow* object_pointer54_0 = 0;
	long id54;
	zval* colour54 = 0;
	wxColour* object_pointer54_2 = 0;
	zval* pos54 = 0;
	wxPoint* object_pointer54_3 = 0;
	zval* size54 = 0;
	wxSize* object_pointer54_4 = 0;
	long style54;
	zval* validator54 = 0;
	wxValidator* object_pointer54_6 = 0;
	char* name54;
	long name_len54;
	bool overload54_called = false;
	//Parameters for overload 55
	zval* parent55 = 0;
	wxWindow* object_pointer55_0 = 0;
	long id55;
	zval* font55 = 0;
	wxFont* object_pointer55_2 = 0;
	zval* pos55 = 0;
	wxPoint* object_pointer55_3 = 0;
	zval* size55 = 0;
	wxSize* object_pointer55_4 = 0;
	long style55;
	zval* validator55 = 0;
	wxValidator* object_pointer55_6 = 0;
	char* name55;
	long name_len55;
	bool overload55_called = false;
	//Parameters for overload 56
	zval* parent56 = 0;
	wxWindow* object_pointer56_0 = 0;
	long id56;
	char* path56;
	long path_len56;
	char* message56;
	long message_len56;
	char* wildcard56;
	long wildcard_len56;
	zval* pos56 = 0;
	wxPoint* object_pointer56_5 = 0;
	zval* size56 = 0;
	wxSize* object_pointer56_6 = 0;
	long style56;
	zval* validator56 = 0;
	wxValidator* object_pointer56_8 = 0;
	char* name56;
	long name_len56;
	bool overload56_called = false;
	//Parameters for overload 57
	zval* parent57 = 0;
	wxWindow* object_pointer57_0 = 0;
	long id57;
	char* path57;
	long path_len57;
	char* message57;
	long message_len57;
	zval* pos57 = 0;
	wxPoint* object_pointer57_4 = 0;
	zval* size57 = 0;
	wxSize* object_pointer57_5 = 0;
	long style57;
	zval* validator57 = 0;
	wxValidator* object_pointer57_7 = 0;
	char* name57;
	long name_len57;
	bool overload57_called = false;
	//Parameters for overload 58
	zval* parent58 = 0;
	wxWindow* object_pointer58_0 = 0;
	long id58;
	time_t dt58;
	zval* pos58 = 0;
	wxPoint* object_pointer58_3 = 0;
	zval* size58 = 0;
	wxSize* object_pointer58_4 = 0;
	long style58;
	zval* validator58 = 0;
	wxValidator* object_pointer58_6 = 0;
	char* name58;
	long name_len58;
	bool overload58_called = false;
	//Parameters for overload 59
	zval* parent59 = 0;
	wxWindow* object_pointer59_0 = 0;
	long id59;
	time_t dt59;
	zval* pos59 = 0;
	wxPoint* object_pointer59_3 = 0;
	zval* size59 = 0;
	wxSize* object_pointer59_4 = 0;
	long style59;
	zval* validator59 = 0;
	wxValidator* object_pointer59_6 = 0;
	char* name59;
	long name_len59;
	bool overload59_called = false;
	//Parameters for overload 60
	zval* parent60 = 0;
	wxWindow* object_pointer60_0 = 0;
	long id60;
	char* label60;
	long label_len60;
	zval* pos60 = 0;
	wxPoint* object_pointer60_3 = 0;
	zval* size60 = 0;
	wxSize* object_pointer60_4 = 0;
	long style60;
	zval* validator60 = 0;
	wxValidator* object_pointer60_6 = 0;
	char* name60;
	long name_len60;
	bool overload60_called = false;
	//Parameters for overload 61
	zval* parent61 = 0;
	wxWindow* object_pointer61_0 = 0;
	long id61;
	char* value61;
	long value_len61;
	zval* pos61 = 0;
	wxPoint* object_pointer61_3 = 0;
	zval* size61 = 0;
	wxSize* object_pointer61_4 = 0;
	long style61;
	zval* validator61 = 0;
	wxValidator* object_pointer61_6 = 0;
	char* name61;
	long name_len61;
	bool overload61_called = false;
	//Parameters for overload 62
	zval* parent62 = 0;
	wxWindow* object_pointer62_0 = 0;
	long id62;
	zval* pos62 = 0;
	wxPoint* object_pointer62_2 = 0;
	zval* size62 = 0;
	wxSize* object_pointer62_3 = 0;
	long style62;
	zval* validator62 = 0;
	wxValidator* object_pointer62_5 = 0;
	char* name62;
	long name_len62;
	bool overload62_called = false;
	//Parameters for overload 63
	zval* parent63 = 0;
	wxWindow* object_pointer63_0 = 0;
	long id63;
	zval* pos63 = 0;
	wxPoint* object_pointer63_2 = 0;
	zval* size63 = 0;
	wxSize* object_pointer63_3 = 0;
	long style63;
	zval* validator63 = 0;
	wxValidator* object_pointer63_5 = 0;
	bool overload63_called = false;
	//Parameters for overload 64
	zval* parent64 = 0;
	wxWindow* object_pointer64_0 = 0;
	long id64;
	zval* pos64 = 0;
	wxPoint* object_pointer64_2 = 0;
	zval* size64 = 0;
	wxSize* object_pointer64_3 = 0;
	long style64;
	zval* validator64 = 0;
	wxValidator* object_pointer64_5 = 0;
	bool overload64_called = false;
	//Parameters for overload 65
	zval* parent65 = 0;
	wxWindow* object_pointer65_0 = 0;
	long id65;
	char* defaultDirectory65;
	long defaultDirectory_len65;
	char* defaultFilename65;
	long defaultFilename_len65;
	char* wildCard65;
	long wildCard_len65;
	long style65;
	zval* pos65 = 0;
	wxPoint* object_pointer65_6 = 0;
	zval* size65 = 0;
	wxSize* object_pointer65_7 = 0;
	char* name65;
	long name_len65;
	bool overload65_called = false;
	//Parameters for overload 66
	zval* parent66 = 0;
	wxWindow* object_pointer66_0 = 0;
	long winid66;
	bool overload66_called = false;
	//Parameters for overload 67
	zval* parent67 = 0;
	wxWindow* object_pointer67_0 = 0;
	long id67;
	zval* pos67 = 0;
	wxPoint* object_pointer67_2 = 0;
	zval* size67 = 0;
	wxSize* object_pointer67_3 = 0;
	long style67;
	bool overload67_called = false;
	//Parameters for overload 68
	zval* parent68 = 0;
	wxWindow* object_pointer68_0 = 0;
	long id68;
	zval* pos68 = 0;
	wxPoint* object_pointer68_2 = 0;
	zval* size68 = 0;
	wxSize* object_pointer68_3 = 0;
	long style68;
	bool overload68_called = false;
	//Parameters for overload 69
	zval* parent69 = 0;
	wxWindow* object_pointer69_0 = 0;
	long id69;
	zval* pos69 = 0;
	wxPoint* object_pointer69_2 = 0;
	zval* size69 = 0;
	wxSize* object_pointer69_3 = 0;
	long style69;
	bool overload69_called = false;
	//Parameters for overload 70
	zval* parent70 = 0;
	wxRibbonBar* object_pointer70_0 = 0;
	long id70;
	char* label70;
	long label_len70;
	zval* icon70 = 0;
	wxBitmap* object_pointer70_3 = 0;
	long style70;
	bool overload70_called = false;
	//Parameters for overload 71
	zval* parent71 = 0;
	wxWindow* object_pointer71_0 = 0;
	long id71;
	char* label71;
	long label_len71;
	zval* icon71 = 0;
	wxBitmap* object_pointer71_3 = 0;
	zval* pos71 = 0;
	wxPoint* object_pointer71_4 = 0;
	zval* size71 = 0;
	wxSize* object_pointer71_5 = 0;
	long style71;
	bool overload71_called = false;
	//Parameters for overload 72
	zval* parent72 = 0;
	wxWindow* object_pointer72_0 = 0;
	long id72;
	zval* pos72 = 0;
	wxPoint* object_pointer72_2 = 0;
	zval* size72 = 0;
	wxSize* object_pointer72_3 = 0;
	long style72;
	bool overload72_called = false;
	//Parameters for overload 73
	zval* parent73 = 0;
	wxWindow* object_pointer73_0 = 0;
	long id73;
	char* url73;
	long url_len73;
	zval* pos73 = 0;
	wxPoint* object_pointer73_3 = 0;
	zval* size73 = 0;
	wxSize* object_pointer73_4 = 0;
	long style73;
	char* name73;
	long name_len73;
	bool overload73_called = false;
	//Parameters for overload 74
	zval* parent74 = 0;
	wxWindow* object_pointer74_0 = 0;
	long id74;
	char* fileName74;
	long fileName_len74;
	zval* pos74 = 0;
	wxPoint* object_pointer74_3 = 0;
	zval* size74 = 0;
	wxSize* object_pointer74_4 = 0;
	long style74;
	char* szBackend74;
	long szBackend_len74;
	zval* validator74 = 0;
	wxValidator* object_pointer74_7 = 0;
	char* name74;
	long name_len74;
	bool overload74_called = false;
	//Parameters for overload 75
	zval* parent75 = 0;
	wxWindow* object_pointer75_0 = 0;
	long id75;
	char* label75;
	long label_len75;
	zval* pos75 = 0;
	wxPoint* object_pointer75_3 = 0;
	zval* size75 = 0;
	wxSize* object_pointer75_4 = 0;
	long style75;
	char* name75;
	long name_len75;
	bool overload75_called = false;
	//Parameters for overload 76
	zval* parent76 = 0;
	wxWindow* object_pointer76_0 = 0;
	long winid76;
	long dir76;
	zval* pos76 = 0;
	wxPoint* object_pointer76_3 = 0;
	zval* size76 = 0;
	wxSize* object_pointer76_4 = 0;
	long style76;
	char* name76;
	long name_len76;
	bool overload76_called = false;
	//Parameters for overload 77
	zval* parent77 = 0;
	wxWindow* object_pointer77_0 = 0;
	long id77;
	zval* pos77 = 0;
	wxPoint* object_pointer77_2 = 0;
	zval* size77 = 0;
	wxSize* object_pointer77_3 = 0;
	long style77;
	long helpStyle77;
	bool overload77_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 2  && arguments_received <= 6)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|OOls' (&parent0, &id0, &pos0, php_wxPoint_entry, &size0, php_wxSize_entry, &style0, &name0, &name_len0)\n");
		#endif

		char parse_parameters_string[] = "zl|OOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent0, &id0, &pos0, php_wxPoint_entry, &size0, php_wxSize_entry, &style0, &name0, &name_len0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(parent0) != IS_NULL)
				{
					goto overload1;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos0 TSRMLS_CC))->native_object;
					object_pointer0_2 = (wxPoint*) argument_native_object;
					if (!object_pointer0_2 )
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(pos0) != IS_NULL)
				{
					goto overload1;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->native_object;
					object_pointer0_3 = (wxSize*) argument_native_object;
					if (!object_pointer0_3 )
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(size0) != IS_NULL)
				{
					goto overload1;
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received >= 3  && arguments_received <= 7 && (current_object_type == PHP_WXTOPLEVELWINDOW_TYPE || current_object_type == PHP_WXFRAME_TYPE || current_object_type == PHP_WXSPLASHSCREEN_TYPE || current_object_type == PHP_WXMDICHILDFRAME_TYPE || current_object_type == PHP_WXMDIPARENTFRAME_TYPE || current_object_type == PHP_WXMINIFRAME_TYPE || current_object_type == PHP_WXPREVIEWFRAME_TYPE || current_object_type == PHP_WXHTMLHELPDIALOG_TYPE || current_object_type == PHP_WXHTMLHELPFRAME_TYPE || current_object_type == PHP_WXDIALOG_TYPE || current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE || current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE || current_object_type == PHP_WXMESSAGEDIALOG_TYPE || current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE || current_object_type == PHP_WXDIRDIALOG_TYPE || current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE || current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE || current_object_type == PHP_WXWIZARD_TYPE || current_object_type == PHP_WXPROGRESSDIALOG_TYPE || current_object_type == PHP_WXCOLOURDIALOG_TYPE || current_object_type == PHP_WXFILEDIALOG_TYPE || current_object_type == PHP_WXFONTDIALOG_TYPE || current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE || current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zls|OOls' (&parent1, &id1, &title1, &title_len1, &pos1, php_wxPoint_entry, &size1, php_wxSize_entry, &style1, &name1, &name_len1)\n");
		#endif

		char parse_parameters_string[] = "zls|OOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent1, &id1, &title1, &title_len1, &pos1, php_wxPoint_entry, &size1, php_wxSize_entry, &style1, &name1, &name_len1 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxWindow*) argument_native_object;
					if (!object_pointer1_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload2;
					}
				}
				else if(Z_TYPE_P(parent1) != IS_NULL)
				{
					goto overload2;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos1 TSRMLS_CC))->native_object;
					object_pointer1_3 = (wxPoint*) argument_native_object;
					if (!object_pointer1_3 )
					{
						goto overload2;
					}
				}
				else if(Z_TYPE_P(pos1) != IS_NULL)
				{
					goto overload2;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->native_object;
					object_pointer1_4 = (wxSize*) argument_native_object;
					if (!object_pointer1_4 )
					{
						goto overload2;
					}
				}
				else if(Z_TYPE_P(size1) != IS_NULL)
				{
					goto overload2;
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

	//Overload 2
	overload2:
	if(!already_called && arguments_received >= 3  && arguments_received <= 7 && (current_object_type == PHP_WXFRAME_TYPE || current_object_type == PHP_WXSPLASHSCREEN_TYPE || current_object_type == PHP_WXMDICHILDFRAME_TYPE || current_object_type == PHP_WXMDIPARENTFRAME_TYPE || current_object_type == PHP_WXMINIFRAME_TYPE || current_object_type == PHP_WXPREVIEWFRAME_TYPE || current_object_type == PHP_WXHTMLHELPDIALOG_TYPE || current_object_type == PHP_WXHTMLHELPFRAME_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zls|OOls' (&parent2, &id2, &title2, &title_len2, &pos2, php_wxPoint_entry, &size2, php_wxSize_entry, &style2, &name2, &name_len2)\n");
		#endif

		char parse_parameters_string[] = "zls|OOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent2, &id2, &title2, &title_len2, &pos2, php_wxPoint_entry, &size2, php_wxSize_entry, &style2, &name2, &name_len2 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent2) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent2 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent2 TSRMLS_CC))->native_object;
					object_pointer2_0 = (wxWindow*) argument_native_object;
					if (!object_pointer2_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload3;
					}
				}
				else if(Z_TYPE_P(parent2) != IS_NULL)
				{
					goto overload3;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos2) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos2 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos2 TSRMLS_CC))->native_object;
					object_pointer2_3 = (wxPoint*) argument_native_object;
					if (!object_pointer2_3 )
					{
						goto overload3;
					}
				}
				else if(Z_TYPE_P(pos2) != IS_NULL)
				{
					goto overload3;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size2) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size2 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size2 TSRMLS_CC))->native_object;
					object_pointer2_4 = (wxSize*) argument_native_object;
					if (!object_pointer2_4 )
					{
						goto overload3;
					}
				}
				else if(Z_TYPE_P(size2) != IS_NULL)
				{
					goto overload3;
				}
			}

			overload2_called = true;
			already_called = true;
		}
	}

	//Overload 3
	overload3:
	if(!already_called && arguments_received >= 3  && arguments_received <= 7 && (current_object_type == PHP_WXMDICHILDFRAME_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zls|OOls' (&parent3, &id3, &title3, &title_len3, &pos3, php_wxPoint_entry, &size3, php_wxSize_entry, &style3, &name3, &name_len3)\n");
		#endif

		char parse_parameters_string[] = "zls|OOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent3, &id3, &title3, &title_len3, &pos3, php_wxPoint_entry, &size3, php_wxSize_entry, &style3, &name3, &name_len3 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent3) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxMDIParentFrame*) zend_object_store_get_object(parent3 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxMDIParentFrame*) zend_object_store_get_object(parent3 TSRMLS_CC))->native_object;
					object_pointer3_0 = (wxMDIParentFrame*) argument_native_object;
					if (!object_pointer3_0 || (argument_type != PHP_WXMDIPARENTFRAME_TYPE))
					{
						goto overload4;
					}
				}
				else if(Z_TYPE_P(parent3) != IS_NULL)
				{
					goto overload4;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos3) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos3 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos3 TSRMLS_CC))->native_object;
					object_pointer3_3 = (wxPoint*) argument_native_object;
					if (!object_pointer3_3 )
					{
						goto overload4;
					}
				}
				else if(Z_TYPE_P(pos3) != IS_NULL)
				{
					goto overload4;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size3) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size3 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size3 TSRMLS_CC))->native_object;
					object_pointer3_4 = (wxSize*) argument_native_object;
					if (!object_pointer3_4 )
					{
						goto overload4;
					}
				}
				else if(Z_TYPE_P(size3) != IS_NULL)
				{
					goto overload4;
				}
			}

			overload3_called = true;
			already_called = true;
		}
	}

	//Overload 4
	overload4:
	if(!already_called && arguments_received >= 3  && arguments_received <= 7 && (current_object_type == PHP_WXMDIPARENTFRAME_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zls|OOls' (&parent4, &id4, &title4, &title_len4, &pos4, php_wxPoint_entry, &size4, php_wxSize_entry, &style4, &name4, &name_len4)\n");
		#endif

		char parse_parameters_string[] = "zls|OOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent4, &id4, &title4, &title_len4, &pos4, php_wxPoint_entry, &size4, php_wxSize_entry, &style4, &name4, &name_len4 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent4) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent4 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent4 TSRMLS_CC))->native_object;
					object_pointer4_0 = (wxWindow*) argument_native_object;
					if (!object_pointer4_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload5;
					}
				}
				else if(Z_TYPE_P(parent4) != IS_NULL)
				{
					goto overload5;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos4) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos4 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos4 TSRMLS_CC))->native_object;
					object_pointer4_3 = (wxPoint*) argument_native_object;
					if (!object_pointer4_3 )
					{
						goto overload5;
					}
				}
				else if(Z_TYPE_P(pos4) != IS_NULL)
				{
					goto overload5;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size4) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size4 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size4 TSRMLS_CC))->native_object;
					object_pointer4_4 = (wxSize*) argument_native_object;
					if (!object_pointer4_4 )
					{
						goto overload5;
					}
				}
				else if(Z_TYPE_P(size4) != IS_NULL)
				{
					goto overload5;
				}
			}

			overload4_called = true;
			already_called = true;
		}
	}

	//Overload 5
	overload5:
	if(!already_called && arguments_received >= 3  && arguments_received <= 7 && (current_object_type == PHP_WXMINIFRAME_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zls|OOls' (&parent5, &id5, &title5, &title_len5, &pos5, php_wxPoint_entry, &size5, php_wxSize_entry, &style5, &name5, &name_len5)\n");
		#endif

		char parse_parameters_string[] = "zls|OOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent5, &id5, &title5, &title_len5, &pos5, php_wxPoint_entry, &size5, php_wxSize_entry, &style5, &name5, &name_len5 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent5) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent5 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent5 TSRMLS_CC))->native_object;
					object_pointer5_0 = (wxWindow*) argument_native_object;
					if (!object_pointer5_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload6;
					}
				}
				else if(Z_TYPE_P(parent5) != IS_NULL)
				{
					goto overload6;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos5) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos5 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos5 TSRMLS_CC))->native_object;
					object_pointer5_3 = (wxPoint*) argument_native_object;
					if (!object_pointer5_3 )
					{
						goto overload6;
					}
				}
				else if(Z_TYPE_P(pos5) != IS_NULL)
				{
					goto overload6;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size5) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size5 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size5 TSRMLS_CC))->native_object;
					object_pointer5_4 = (wxSize*) argument_native_object;
					if (!object_pointer5_4 )
					{
						goto overload6;
					}
				}
				else if(Z_TYPE_P(size5) != IS_NULL)
				{
					goto overload6;
				}
			}

			overload5_called = true;
			already_called = true;
		}
	}

	//Overload 6
	overload6:
	if(!already_called && arguments_received >= 2  && arguments_received <= 4 && (current_object_type == PHP_WXHTMLHELPDIALOG_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|sl' (&parent6, &id6, &title6, &title_len6, &style6)\n");
		#endif

		char parse_parameters_string[] = "zl|sl";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent6, &id6, &title6, &title_len6, &style6 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent6) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent6 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent6 TSRMLS_CC))->native_object;
					object_pointer6_0 = (wxWindow*) argument_native_object;
					if (!object_pointer6_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload7;
					}
				}
				else if(Z_TYPE_P(parent6) != IS_NULL)
				{
					goto overload7;
				}
			}

			overload6_called = true;
			already_called = true;
		}
	}

	//Overload 7
	overload7:
	if(!already_called && arguments_received >= 2  && arguments_received <= 6 && (current_object_type == PHP_WXHTMLHELPFRAME_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|slzs' (&parent7, &id7, &title7, &title_len7, &style7, &config7, &rootpath7, &rootpath_len7)\n");
		#endif

		char parse_parameters_string[] = "zl|slzs";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent7, &id7, &title7, &title_len7, &style7, &config7, &rootpath7, &rootpath_len7 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent7) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent7 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent7 TSRMLS_CC))->native_object;
					object_pointer7_0 = (wxWindow*) argument_native_object;
					if (!object_pointer7_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload8;
					}
				}
				else if(Z_TYPE_P(parent7) != IS_NULL)
				{
					goto overload8;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(config7) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxConfigBase*) zend_object_store_get_object(config7 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxConfigBase*) zend_object_store_get_object(config7 TSRMLS_CC))->native_object;
					object_pointer7_4 = (wxConfigBase*) argument_native_object;
					if (!object_pointer7_4 || (argument_type != PHP_WXCONFIGBASE_TYPE && argument_type != PHP_WXFILECONFIG_TYPE))
					{
						goto overload8;
					}
				}
				else if(Z_TYPE_P(config7) != IS_NULL)
				{
					goto overload8;
				}
			}

			overload7_called = true;
			already_called = true;
		}
	}

	//Overload 8
	overload8:
	if(!already_called && arguments_received >= 3  && arguments_received <= 7 && (current_object_type == PHP_WXDIALOG_TYPE || current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE || current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE || current_object_type == PHP_WXMESSAGEDIALOG_TYPE || current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE || current_object_type == PHP_WXDIRDIALOG_TYPE || current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE || current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE || current_object_type == PHP_WXWIZARD_TYPE || current_object_type == PHP_WXPROGRESSDIALOG_TYPE || current_object_type == PHP_WXCOLOURDIALOG_TYPE || current_object_type == PHP_WXFILEDIALOG_TYPE || current_object_type == PHP_WXFONTDIALOG_TYPE || current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE || current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zls|OOls' (&parent8, &id8, &title8, &title_len8, &pos8, php_wxPoint_entry, &size8, php_wxSize_entry, &style8, &name8, &name_len8)\n");
		#endif

		char parse_parameters_string[] = "zls|OOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent8, &id8, &title8, &title_len8, &pos8, php_wxPoint_entry, &size8, php_wxSize_entry, &style8, &name8, &name_len8 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent8) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent8 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent8 TSRMLS_CC))->native_object;
					object_pointer8_0 = (wxWindow*) argument_native_object;
					if (!object_pointer8_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload9;
					}
				}
				else if(Z_TYPE_P(parent8) != IS_NULL)
				{
					goto overload9;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos8) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos8 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos8 TSRMLS_CC))->native_object;
					object_pointer8_3 = (wxPoint*) argument_native_object;
					if (!object_pointer8_3 )
					{
						goto overload9;
					}
				}
				else if(Z_TYPE_P(pos8) != IS_NULL)
				{
					goto overload9;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size8) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size8 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size8 TSRMLS_CC))->native_object;
					object_pointer8_4 = (wxSize*) argument_native_object;
					if (!object_pointer8_4 )
					{
						goto overload9;
					}
				}
				else if(Z_TYPE_P(size8) != IS_NULL)
				{
					goto overload9;
				}
			}

			overload8_called = true;
			already_called = true;
		}
	}

	//Overload 9
	overload9:
	if(!already_called && arguments_received >= 3  && arguments_received <= 4 && (current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zzs|l' (&parent9, &data9, &title9, &title_len9, &style9)\n");
		#endif

		char parse_parameters_string[] = "zzs|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent9, &data9, &title9, &title_len9, &style9 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent9) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent9 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent9 TSRMLS_CC))->native_object;
					object_pointer9_0 = (wxWindow*) argument_native_object;
					if (!object_pointer9_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload10;
					}
				}
				else if(Z_TYPE_P(parent9) != IS_NULL)
				{
					goto overload10;
				}
			}

			if(arguments_received >= 2){
				if(Z_TYPE_P(data9) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxFindReplaceData*) zend_object_store_get_object(data9 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxFindReplaceData*) zend_object_store_get_object(data9 TSRMLS_CC))->native_object;
					object_pointer9_1 = (wxFindReplaceData*) argument_native_object;
					if (!object_pointer9_1 || (argument_type != PHP_WXFINDREPLACEDATA_TYPE))
					{
						goto overload10;
					}
				}
				else if(Z_TYPE_P(data9) != IS_NULL)
				{
					goto overload10;
				}
			}

			overload9_called = true;
			already_called = true;
		}
	}

	//Overload 10
	overload10:
	if(!already_called && arguments_received >= 4  && arguments_received <= 9 && (current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'sssz|lsOOl' (&symbol10, &symbol_len10, &initialFont10, &initialFont_len10, &normalTextFont10, &normalTextFont_len10, &parent10, &id10, &caption10, &caption_len10, &pos10, php_wxPoint_entry, &size10, php_wxSize_entry, &style10)\n");
		#endif

		char parse_parameters_string[] = "sssz|lsOOl";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &symbol10, &symbol_len10, &initialFont10, &initialFont_len10, &normalTextFont10, &normalTextFont_len10, &parent10, &id10, &caption10, &caption_len10, &pos10, php_wxPoint_entry, &size10, php_wxSize_entry, &style10 ) == SUCCESS)
		{
			if(arguments_received >= 4){
				if(Z_TYPE_P(parent10) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent10 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent10 TSRMLS_CC))->native_object;
					object_pointer10_3 = (wxWindow*) argument_native_object;
					if (!object_pointer10_3 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload11;
					}
				}
				else if(Z_TYPE_P(parent10) != IS_NULL)
				{
					goto overload11;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(pos10) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos10 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos10 TSRMLS_CC))->native_object;
					object_pointer10_6 = (wxPoint*) argument_native_object;
					if (!object_pointer10_6 )
					{
						goto overload11;
					}
				}
				else if(Z_TYPE_P(pos10) != IS_NULL)
				{
					goto overload11;
				}
			}

			if(arguments_received >= 8){
				if(Z_TYPE_P(size10) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size10 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size10 TSRMLS_CC))->native_object;
					object_pointer10_7 = (wxSize*) argument_native_object;
					if (!object_pointer10_7 )
					{
						goto overload11;
					}
				}
				else if(Z_TYPE_P(size10) != IS_NULL)
				{
					goto overload11;
				}
			}

			overload10_called = true;
			already_called = true;
		}
	}

	//Overload 11
	overload11:
	if(!already_called && arguments_received >= 3  && arguments_received <= 7 && (current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zls|OOls' (&parent11, &id11, &title11, &title_len11, &pos11, php_wxPoint_entry, &size11, php_wxSize_entry, &style11, &name11, &name_len11)\n");
		#endif

		char parse_parameters_string[] = "zls|OOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent11, &id11, &title11, &title_len11, &pos11, php_wxPoint_entry, &size11, php_wxSize_entry, &style11, &name11, &name_len11 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent11) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent11 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent11 TSRMLS_CC))->native_object;
					object_pointer11_0 = (wxWindow*) argument_native_object;
					if (!object_pointer11_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload12;
					}
				}
				else if(Z_TYPE_P(parent11) != IS_NULL)
				{
					goto overload12;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos11) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos11 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos11 TSRMLS_CC))->native_object;
					object_pointer11_3 = (wxPoint*) argument_native_object;
					if (!object_pointer11_3 )
					{
						goto overload12;
					}
				}
				else if(Z_TYPE_P(pos11) != IS_NULL)
				{
					goto overload12;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size11) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size11 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size11 TSRMLS_CC))->native_object;
					object_pointer11_4 = (wxSize*) argument_native_object;
					if (!object_pointer11_4 )
					{
						goto overload12;
					}
				}
				else if(Z_TYPE_P(size11) != IS_NULL)
				{
					goto overload12;
				}
			}

			overload11_called = true;
			already_called = true;
		}
	}

	//Overload 12
	overload12:
	if(!already_called && arguments_received >= 1  && arguments_received <= 6 && (current_object_type == PHP_WXWIZARD_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lsOOl' (&parent12, &id12, &title12, &title_len12, &bitmap12, php_wxBitmap_entry, &pos12, php_wxPoint_entry, &style12)\n");
		#endif

		char parse_parameters_string[] = "z|lsOOl";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent12, &id12, &title12, &title_len12, &bitmap12, php_wxBitmap_entry, &pos12, php_wxPoint_entry, &style12 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent12) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent12 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent12 TSRMLS_CC))->native_object;
					object_pointer12_0 = (wxWindow*) argument_native_object;
					if (!object_pointer12_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload13;
					}
				}
				else if(Z_TYPE_P(parent12) != IS_NULL)
				{
					goto overload13;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(bitmap12) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(bitmap12 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(bitmap12 TSRMLS_CC))->native_object;
					object_pointer12_3 = (wxBitmap*) argument_native_object;
					if (!object_pointer12_3 )
					{
						goto overload13;
					}
				}
				else if(Z_TYPE_P(bitmap12) != IS_NULL)
				{
					goto overload13;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(pos12) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos12 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos12 TSRMLS_CC))->native_object;
					object_pointer12_4 = (wxPoint*) argument_native_object;
					if (!object_pointer12_4 )
					{
						goto overload13;
					}
				}
				else if(Z_TYPE_P(pos12) != IS_NULL)
				{
					goto overload13;
				}
			}

			overload12_called = true;
			already_called = true;
		}
	}

	//Overload 13
	overload13:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2 && (current_object_type == PHP_WXCOLOURDIALOG_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|z' (&parent13, &data13)\n");
		#endif

		char parse_parameters_string[] = "z|z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent13, &data13 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent13) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent13 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent13 TSRMLS_CC))->native_object;
					object_pointer13_0 = (wxWindow*) argument_native_object;
					if (!object_pointer13_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload14;
					}
				}
				else if(Z_TYPE_P(parent13) != IS_NULL)
				{
					goto overload14;
				}
			}

			if(arguments_received >= 2){
				if(Z_TYPE_P(data13) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxColourData*) zend_object_store_get_object(data13 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxColourData*) zend_object_store_get_object(data13 TSRMLS_CC))->native_object;
					object_pointer13_1 = (wxColourData*) argument_native_object;
					if (!object_pointer13_1 || (argument_type != PHP_WXCOLOURDATA_TYPE))
					{
						goto overload14;
					}
				}
				else if(Z_TYPE_P(data13) != IS_NULL)
				{
					goto overload14;
				}
			}

			overload13_called = true;
			already_called = true;
		}
	}

	//Overload 14
	overload14:
	if(!already_called && arguments_received == 1 && (current_object_type == PHP_WXFONTDIALOG_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&parent14)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent14 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent14) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent14 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent14 TSRMLS_CC))->native_object;
					object_pointer14_0 = (wxWindow*) argument_native_object;
					if (!object_pointer14_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload15;
					}
				}
				else if(Z_TYPE_P(parent14) != IS_NULL)
				{
					goto overload15;
				}
			}

			overload14_called = true;
			already_called = true;
		}
	}

	//Overload 15
	overload15:
	if(!already_called && arguments_received == 2 && (current_object_type == PHP_WXFONTDIALOG_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zO' (&parent15, &data15, php_wxFontData_entry)\n");
		#endif

		char parse_parameters_string[] = "zO";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent15, &data15, php_wxFontData_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent15) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent15 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent15 TSRMLS_CC))->native_object;
					object_pointer15_0 = (wxWindow*) argument_native_object;
					if (!object_pointer15_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload16;
					}
				}
				else if(Z_TYPE_P(parent15) != IS_NULL)
				{
					goto overload16;
				}
			}

			if(arguments_received >= 2){
				if(Z_TYPE_P(data15) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxFontData*) zend_object_store_get_object(data15 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxFontData*) zend_object_store_get_object(data15 TSRMLS_CC))->native_object;
					object_pointer15_1 = (wxFontData*) argument_native_object;
					if (!object_pointer15_1 )
					{
						goto overload16;
					}
				}
				else if(Z_TYPE_P(data15) != IS_NULL)
				{
					goto overload16;
				}
			}

			overload15_called = true;
			already_called = true;
		}
	}

	//Overload 16
	overload16:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2 && (current_object_type == PHP_WXPOPUPWINDOW_TYPE || current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|l' (&parent16, &flags16)\n");
		#endif

		char parse_parameters_string[] = "z|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent16, &flags16 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent16) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent16 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent16 TSRMLS_CC))->native_object;
					object_pointer16_0 = (wxWindow*) argument_native_object;
					if (!object_pointer16_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload17;
					}
				}
				else if(Z_TYPE_P(parent16) != IS_NULL)
				{
					goto overload17;
				}
			}

			overload16_called = true;
			already_called = true;
		}
	}

	//Overload 17
	overload17:
	if(!already_called && arguments_received >= 2  && arguments_received <= 7 && (current_object_type == PHP_WXCONTROL_TYPE || current_object_type == PHP_WXSTATUSBAR_TYPE || current_object_type == PHP_WXANYBUTTON_TYPE || current_object_type == PHP_WXBUTTON_TYPE || current_object_type == PHP_WXBITMAPBUTTON_TYPE || current_object_type == PHP_WXTOGGLEBUTTON_TYPE || current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE || current_object_type == PHP_WXTREECTRL_TYPE || current_object_type == PHP_WXCONTROLWITHITEMS_TYPE || current_object_type == PHP_WXLISTBOX_TYPE || current_object_type == PHP_WXCHECKLISTBOX_TYPE || current_object_type == PHP_WXREARRANGELIST_TYPE || current_object_type == PHP_WXCHOICE_TYPE || current_object_type == PHP_WXBOOKCTRLBASE_TYPE || current_object_type == PHP_WXAUINOTEBOOK_TYPE || current_object_type == PHP_WXLISTBOOK_TYPE || current_object_type == PHP_WXCHOICEBOOK_TYPE || current_object_type == PHP_WXNOTEBOOK_TYPE || current_object_type == PHP_WXTREEBOOK_TYPE || current_object_type == PHP_WXTOOLBOOK_TYPE || current_object_type == PHP_WXANIMATIONCTRL_TYPE || current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE || current_object_type == PHP_WXSCROLLBAR_TYPE || current_object_type == PHP_WXSTATICTEXT_TYPE || current_object_type == PHP_WXSTATICLINE_TYPE || current_object_type == PHP_WXSTATICBOX_TYPE || current_object_type == PHP_WXSTATICBITMAP_TYPE || current_object_type == PHP_WXCHECKBOX_TYPE || current_object_type == PHP_WXTEXTCTRL_TYPE || current_object_type == PHP_WXSEARCHCTRL_TYPE || current_object_type == PHP_WXCOMBOBOX_TYPE || current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE || current_object_type == PHP_WXAUITOOLBAR_TYPE || current_object_type == PHP_WXLISTCTRL_TYPE || current_object_type == PHP_WXLISTVIEW_TYPE || current_object_type == PHP_WXRADIOBOX_TYPE || current_object_type == PHP_WXRADIOBUTTON_TYPE || current_object_type == PHP_WXSLIDER_TYPE || current_object_type == PHP_WXSPINCTRL_TYPE || current_object_type == PHP_WXSPINBUTTON_TYPE || current_object_type == PHP_WXGAUGE_TYPE || current_object_type == PHP_WXHYPERLINKCTRL_TYPE || current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE || current_object_type == PHP_WXGENERICDIRCTRL_TYPE || current_object_type == PHP_WXCALENDARCTRL_TYPE || current_object_type == PHP_WXPICKERBASE_TYPE || current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE || current_object_type == PHP_WXFONTPICKERCTRL_TYPE || current_object_type == PHP_WXFILEPICKERCTRL_TYPE || current_object_type == PHP_WXDIRPICKERCTRL_TYPE || current_object_type == PHP_WXTIMEPICKERCTRL_TYPE || current_object_type == PHP_WXTOOLBAR_TYPE || current_object_type == PHP_WXDATEPICKERCTRL_TYPE || current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE || current_object_type == PHP_WXCOMBOCTRL_TYPE || current_object_type == PHP_WXDATAVIEWCTRL_TYPE || current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE || current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE || current_object_type == PHP_WXHEADERCTRL_TYPE || current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE || current_object_type == PHP_WXFILECTRL_TYPE || current_object_type == PHP_WXINFOBAR_TYPE || current_object_type == PHP_WXRIBBONCONTROL_TYPE || current_object_type == PHP_WXRIBBONBAR_TYPE || current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE || current_object_type == PHP_WXRIBBONGALLERY_TYPE || current_object_type == PHP_WXRIBBONPAGE_TYPE || current_object_type == PHP_WXRIBBONPANEL_TYPE || current_object_type == PHP_WXRIBBONTOOLBAR_TYPE || current_object_type == PHP_WXWEBVIEW_TYPE || current_object_type == PHP_WXMEDIACTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|OOlos' (&parent17, &id17, &pos17, php_wxPoint_entry, &size17, php_wxSize_entry, &style17, &validator17, &name17, &name_len17)\n");
		#endif

		char parse_parameters_string[] = "zl|OOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent17, &id17, &pos17, php_wxPoint_entry, &size17, php_wxSize_entry, &style17, &validator17, &name17, &name_len17 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent17) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent17 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent17 TSRMLS_CC))->native_object;
					object_pointer17_0 = (wxWindow*) argument_native_object;
					if (!object_pointer17_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload18;
					}
				}
				else if(Z_TYPE_P(parent17) != IS_NULL)
				{
					goto overload18;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos17) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos17 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos17 TSRMLS_CC))->native_object;
					object_pointer17_2 = (wxPoint*) argument_native_object;
					if (!object_pointer17_2 )
					{
						goto overload18;
					}
				}
				else if(Z_TYPE_P(pos17) != IS_NULL)
				{
					goto overload18;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size17) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size17 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size17 TSRMLS_CC))->native_object;
					object_pointer17_3 = (wxSize*) argument_native_object;
					if (!object_pointer17_3 )
					{
						goto overload18;
					}
				}
				else if(Z_TYPE_P(size17) != IS_NULL)
				{
					goto overload18;
				}
			}

			if(arguments_received >= 6){
				if(Z_TYPE_P(validator17) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator17 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator17 TSRMLS_CC))->native_object;
					object_pointer17_5 = (wxValidator*) argument_native_object;
					if (!object_pointer17_5 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload18;
					}
				}
				else if(Z_TYPE_P(validator17) != IS_NULL)
				{
					goto overload18;
				}
			}

			overload17_called = true;
			already_called = true;
		}
	}

	//Overload 18
	overload18:
	if(!already_called && arguments_received >= 1  && arguments_received <= 4 && (current_object_type == PHP_WXSTATUSBAR_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lls' (&parent18, &id18, &style18, &name18, &name_len18)\n");
		#endif

		char parse_parameters_string[] = "z|lls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent18, &id18, &style18, &name18, &name_len18 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent18) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent18 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent18 TSRMLS_CC))->native_object;
					object_pointer18_0 = (wxWindow*) argument_native_object;
					if (!object_pointer18_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload19;
					}
				}
				else if(Z_TYPE_P(parent18) != IS_NULL)
				{
					goto overload19;
				}
			}

			overload18_called = true;
			already_called = true;
		}
	}

	//Overload 19
	overload19:
	if(!already_called && arguments_received >= 2  && arguments_received <= 8 && (current_object_type == PHP_WXBUTTON_TYPE || current_object_type == PHP_WXBITMAPBUTTON_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|sOOlos' (&parent19, &id19, &label19, &label_len19, &pos19, php_wxPoint_entry, &size19, php_wxSize_entry, &style19, &validator19, &name19, &name_len19)\n");
		#endif

		char parse_parameters_string[] = "zl|sOOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent19, &id19, &label19, &label_len19, &pos19, php_wxPoint_entry, &size19, php_wxSize_entry, &style19, &validator19, &name19, &name_len19 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent19) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent19 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent19 TSRMLS_CC))->native_object;
					object_pointer19_0 = (wxWindow*) argument_native_object;
					if (!object_pointer19_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload20;
					}
				}
				else if(Z_TYPE_P(parent19) != IS_NULL)
				{
					goto overload20;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos19) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos19 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos19 TSRMLS_CC))->native_object;
					object_pointer19_3 = (wxPoint*) argument_native_object;
					if (!object_pointer19_3 )
					{
						goto overload20;
					}
				}
				else if(Z_TYPE_P(pos19) != IS_NULL)
				{
					goto overload20;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size19) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size19 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size19 TSRMLS_CC))->native_object;
					object_pointer19_4 = (wxSize*) argument_native_object;
					if (!object_pointer19_4 )
					{
						goto overload20;
					}
				}
				else if(Z_TYPE_P(size19) != IS_NULL)
				{
					goto overload20;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(validator19) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator19 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator19 TSRMLS_CC))->native_object;
					object_pointer19_6 = (wxValidator*) argument_native_object;
					if (!object_pointer19_6 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload20;
					}
				}
				else if(Z_TYPE_P(validator19) != IS_NULL)
				{
					goto overload20;
				}
			}

			overload19_called = true;
			already_called = true;
		}
	}

	//Overload 20
	overload20:
	if(!already_called && arguments_received >= 3  && arguments_received <= 8 && (current_object_type == PHP_WXBITMAPBUTTON_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zlO|OOlos' (&parent20, &id20, &bitmap20, php_wxBitmap_entry, &pos20, php_wxPoint_entry, &size20, php_wxSize_entry, &style20, &validator20, &name20, &name_len20)\n");
		#endif

		char parse_parameters_string[] = "zlO|OOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent20, &id20, &bitmap20, php_wxBitmap_entry, &pos20, php_wxPoint_entry, &size20, php_wxSize_entry, &style20, &validator20, &name20, &name_len20 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent20) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent20 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent20 TSRMLS_CC))->native_object;
					object_pointer20_0 = (wxWindow*) argument_native_object;
					if (!object_pointer20_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload21;
					}
				}
				else if(Z_TYPE_P(parent20) != IS_NULL)
				{
					goto overload21;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(bitmap20) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(bitmap20 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(bitmap20 TSRMLS_CC))->native_object;
					object_pointer20_2 = (wxBitmap*) argument_native_object;
					if (!object_pointer20_2 )
					{
						goto overload21;
					}
				}
				else if(Z_TYPE_P(bitmap20) != IS_NULL)
				{
					goto overload21;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos20) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos20 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos20 TSRMLS_CC))->native_object;
					object_pointer20_3 = (wxPoint*) argument_native_object;
					if (!object_pointer20_3 )
					{
						goto overload21;
					}
				}
				else if(Z_TYPE_P(pos20) != IS_NULL)
				{
					goto overload21;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size20) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size20 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size20 TSRMLS_CC))->native_object;
					object_pointer20_4 = (wxSize*) argument_native_object;
					if (!object_pointer20_4 )
					{
						goto overload21;
					}
				}
				else if(Z_TYPE_P(size20) != IS_NULL)
				{
					goto overload21;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(validator20) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator20 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator20 TSRMLS_CC))->native_object;
					object_pointer20_6 = (wxValidator*) argument_native_object;
					if (!object_pointer20_6 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload21;
					}
				}
				else if(Z_TYPE_P(validator20) != IS_NULL)
				{
					goto overload21;
				}
			}

			overload20_called = true;
			already_called = true;
		}
	}

	//Overload 21
	overload21:
	if(!already_called && arguments_received >= 3  && arguments_received <= 8 && (current_object_type == PHP_WXTOGGLEBUTTON_TYPE || current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zls|OOlos' (&parent21, &id21, &label21, &label_len21, &pos21, php_wxPoint_entry, &size21, php_wxSize_entry, &style21, &val21, &name21, &name_len21)\n");
		#endif

		char parse_parameters_string[] = "zls|OOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent21, &id21, &label21, &label_len21, &pos21, php_wxPoint_entry, &size21, php_wxSize_entry, &style21, &val21, &name21, &name_len21 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent21) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent21 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent21 TSRMLS_CC))->native_object;
					object_pointer21_0 = (wxWindow*) argument_native_object;
					if (!object_pointer21_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload22;
					}
				}
				else if(Z_TYPE_P(parent21) != IS_NULL)
				{
					goto overload22;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos21) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos21 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos21 TSRMLS_CC))->native_object;
					object_pointer21_3 = (wxPoint*) argument_native_object;
					if (!object_pointer21_3 )
					{
						goto overload22;
					}
				}
				else if(Z_TYPE_P(pos21) != IS_NULL)
				{
					goto overload22;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size21) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size21 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size21 TSRMLS_CC))->native_object;
					object_pointer21_4 = (wxSize*) argument_native_object;
					if (!object_pointer21_4 )
					{
						goto overload22;
					}
				}
				else if(Z_TYPE_P(size21) != IS_NULL)
				{
					goto overload22;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(val21) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(val21 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(val21 TSRMLS_CC))->native_object;
					object_pointer21_6 = (wxValidator*) argument_native_object;
					if (!object_pointer21_6 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload22;
					}
				}
				else if(Z_TYPE_P(val21) != IS_NULL)
				{
					goto overload22;
				}
			}

			overload21_called = true;
			already_called = true;
		}
	}

	//Overload 22
	overload22:
	if(!already_called && arguments_received >= 3  && arguments_received <= 8 && (current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zlO|OOlos' (&parent22, &id22, &label22, php_wxBitmap_entry, &pos22, php_wxPoint_entry, &size22, php_wxSize_entry, &style22, &val22, &name22, &name_len22)\n");
		#endif

		char parse_parameters_string[] = "zlO|OOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent22, &id22, &label22, php_wxBitmap_entry, &pos22, php_wxPoint_entry, &size22, php_wxSize_entry, &style22, &val22, &name22, &name_len22 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent22) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent22 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent22 TSRMLS_CC))->native_object;
					object_pointer22_0 = (wxWindow*) argument_native_object;
					if (!object_pointer22_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload23;
					}
				}
				else if(Z_TYPE_P(parent22) != IS_NULL)
				{
					goto overload23;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(label22) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(label22 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(label22 TSRMLS_CC))->native_object;
					object_pointer22_2 = (wxBitmap*) argument_native_object;
					if (!object_pointer22_2 )
					{
						goto overload23;
					}
				}
				else if(Z_TYPE_P(label22) != IS_NULL)
				{
					goto overload23;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos22) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos22 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos22 TSRMLS_CC))->native_object;
					object_pointer22_3 = (wxPoint*) argument_native_object;
					if (!object_pointer22_3 )
					{
						goto overload23;
					}
				}
				else if(Z_TYPE_P(pos22) != IS_NULL)
				{
					goto overload23;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size22) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size22 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size22 TSRMLS_CC))->native_object;
					object_pointer22_4 = (wxSize*) argument_native_object;
					if (!object_pointer22_4 )
					{
						goto overload23;
					}
				}
				else if(Z_TYPE_P(size22) != IS_NULL)
				{
					goto overload23;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(val22) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(val22 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(val22 TSRMLS_CC))->native_object;
					object_pointer22_6 = (wxValidator*) argument_native_object;
					if (!object_pointer22_6 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload23;
					}
				}
				else if(Z_TYPE_P(val22) != IS_NULL)
				{
					goto overload23;
				}
			}

			overload22_called = true;
			already_called = true;
		}
	}

	//Overload 23
	overload23:
	if(!already_called && arguments_received >= 1  && arguments_received <= 7 && (current_object_type == PHP_WXTREECTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lOOlos' (&parent23, &id23, &pos23, php_wxPoint_entry, &size23, php_wxSize_entry, &style23, &validator23, &name23, &name_len23)\n");
		#endif

		char parse_parameters_string[] = "z|lOOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent23, &id23, &pos23, php_wxPoint_entry, &size23, php_wxSize_entry, &style23, &validator23, &name23, &name_len23 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent23) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent23 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent23 TSRMLS_CC))->native_object;
					object_pointer23_0 = (wxWindow*) argument_native_object;
					if (!object_pointer23_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload24;
					}
				}
				else if(Z_TYPE_P(parent23) != IS_NULL)
				{
					goto overload24;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos23) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos23 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos23 TSRMLS_CC))->native_object;
					object_pointer23_2 = (wxPoint*) argument_native_object;
					if (!object_pointer23_2 )
					{
						goto overload24;
					}
				}
				else if(Z_TYPE_P(pos23) != IS_NULL)
				{
					goto overload24;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size23) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size23 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size23 TSRMLS_CC))->native_object;
					object_pointer23_3 = (wxSize*) argument_native_object;
					if (!object_pointer23_3 )
					{
						goto overload24;
					}
				}
				else if(Z_TYPE_P(size23) != IS_NULL)
				{
					goto overload24;
				}
			}

			if(arguments_received >= 6){
				if(Z_TYPE_P(validator23) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator23 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator23 TSRMLS_CC))->native_object;
					object_pointer23_5 = (wxValidator*) argument_native_object;
					if (!object_pointer23_5 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload24;
					}
				}
				else if(Z_TYPE_P(validator23) != IS_NULL)
				{
					goto overload24;
				}
			}

			overload23_called = true;
			already_called = true;
		}
	}

	//Overload 24
	overload24:
	if(!already_called && arguments_received >= 5  && arguments_received <= 8 && (current_object_type == PHP_WXLISTBOX_TYPE || current_object_type == PHP_WXCHECKLISTBOX_TYPE || current_object_type == PHP_WXREARRANGELIST_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zlOOa|los' (&parent24, &id24, &pos24, php_wxPoint_entry, &size24, php_wxSize_entry, &choices24, &style24, &validator24, &name24, &name_len24)\n");
		#endif

		char parse_parameters_string[] = "zlOOa|los";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent24, &id24, &pos24, php_wxPoint_entry, &size24, php_wxSize_entry, &choices24, &style24, &validator24, &name24, &name_len24 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent24) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent24 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent24 TSRMLS_CC))->native_object;
					object_pointer24_0 = (wxWindow*) argument_native_object;
					if (!object_pointer24_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload25;
					}
				}
				else if(Z_TYPE_P(parent24) != IS_NULL)
				{
					goto overload25;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos24) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos24 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos24 TSRMLS_CC))->native_object;
					object_pointer24_2 = (wxPoint*) argument_native_object;
					if (!object_pointer24_2 )
					{
						goto overload25;
					}
				}
				else if(Z_TYPE_P(pos24) != IS_NULL)
				{
					goto overload25;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size24) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size24 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size24 TSRMLS_CC))->native_object;
					object_pointer24_3 = (wxSize*) argument_native_object;
					if (!object_pointer24_3 )
					{
						goto overload25;
					}
				}
				else if(Z_TYPE_P(size24) != IS_NULL)
				{
					goto overload25;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(validator24) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator24 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator24 TSRMLS_CC))->native_object;
					object_pointer24_6 = (wxValidator*) argument_native_object;
					if (!object_pointer24_6 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload25;
					}
				}
				else if(Z_TYPE_P(validator24) != IS_NULL)
				{
					goto overload25;
				}
			}

			overload24_called = true;
			already_called = true;
		}
	}

	//Overload 25
	overload25:
	if(!already_called && arguments_received >= 2  && arguments_received <= 9 && (current_object_type == PHP_WXLISTBOX_TYPE || current_object_type == PHP_WXCHECKLISTBOX_TYPE || current_object_type == PHP_WXREARRANGELIST_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|OOlalos' (&parent25, &id25, &pos25, php_wxPoint_entry, &size25, php_wxSize_entry, &n25, &choices25, &style25, &validator25, &name25, &name_len25)\n");
		#endif

		char parse_parameters_string[] = "zl|OOlalos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent25, &id25, &pos25, php_wxPoint_entry, &size25, php_wxSize_entry, &n25, &choices25, &style25, &validator25, &name25, &name_len25 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent25) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent25 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent25 TSRMLS_CC))->native_object;
					object_pointer25_0 = (wxWindow*) argument_native_object;
					if (!object_pointer25_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload26;
					}
				}
				else if(Z_TYPE_P(parent25) != IS_NULL)
				{
					goto overload26;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos25) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos25 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos25 TSRMLS_CC))->native_object;
					object_pointer25_2 = (wxPoint*) argument_native_object;
					if (!object_pointer25_2 )
					{
						goto overload26;
					}
				}
				else if(Z_TYPE_P(pos25) != IS_NULL)
				{
					goto overload26;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size25) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size25 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size25 TSRMLS_CC))->native_object;
					object_pointer25_3 = (wxSize*) argument_native_object;
					if (!object_pointer25_3 )
					{
						goto overload26;
					}
				}
				else if(Z_TYPE_P(size25) != IS_NULL)
				{
					goto overload26;
				}
			}

			if(arguments_received >= 8){
				if(Z_TYPE_P(validator25) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator25 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator25 TSRMLS_CC))->native_object;
					object_pointer25_7 = (wxValidator*) argument_native_object;
					if (!object_pointer25_7 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload26;
					}
				}
				else if(Z_TYPE_P(validator25) != IS_NULL)
				{
					goto overload26;
				}
			}

			overload25_called = true;
			already_called = true;
		}
	}

	//Overload 26
	overload26:
	if(!already_called && arguments_received >= 2  && arguments_received <= 9 && (current_object_type == PHP_WXCHECKLISTBOX_TYPE || current_object_type == PHP_WXREARRANGELIST_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|OOlalos' (&parent26, &id26, &pos26, php_wxPoint_entry, &size26, php_wxSize_entry, &nStrings26, &choices26, &style26, &validator26, &name26, &name_len26)\n");
		#endif

		char parse_parameters_string[] = "zl|OOlalos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent26, &id26, &pos26, php_wxPoint_entry, &size26, php_wxSize_entry, &nStrings26, &choices26, &style26, &validator26, &name26, &name_len26 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent26) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent26 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent26 TSRMLS_CC))->native_object;
					object_pointer26_0 = (wxWindow*) argument_native_object;
					if (!object_pointer26_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload27;
					}
				}
				else if(Z_TYPE_P(parent26) != IS_NULL)
				{
					goto overload27;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos26) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos26 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos26 TSRMLS_CC))->native_object;
					object_pointer26_2 = (wxPoint*) argument_native_object;
					if (!object_pointer26_2 )
					{
						goto overload27;
					}
				}
				else if(Z_TYPE_P(pos26) != IS_NULL)
				{
					goto overload27;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size26) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size26 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size26 TSRMLS_CC))->native_object;
					object_pointer26_3 = (wxSize*) argument_native_object;
					if (!object_pointer26_3 )
					{
						goto overload27;
					}
				}
				else if(Z_TYPE_P(size26) != IS_NULL)
				{
					goto overload27;
				}
			}

			if(arguments_received >= 8){
				if(Z_TYPE_P(validator26) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator26 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator26 TSRMLS_CC))->native_object;
					object_pointer26_7 = (wxValidator*) argument_native_object;
					if (!object_pointer26_7 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload27;
					}
				}
				else if(Z_TYPE_P(validator26) != IS_NULL)
				{
					goto overload27;
				}
			}

			overload26_called = true;
			already_called = true;
		}
	}

	//Overload 27
	overload27:
	if(!already_called && arguments_received >= 5  && arguments_received <= 8 && (current_object_type == PHP_WXCHECKLISTBOX_TYPE || current_object_type == PHP_WXREARRANGELIST_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zlOOa|los' (&parent27, &id27, &pos27, php_wxPoint_entry, &size27, php_wxSize_entry, &choices27, &style27, &validator27, &name27, &name_len27)\n");
		#endif

		char parse_parameters_string[] = "zlOOa|los";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent27, &id27, &pos27, php_wxPoint_entry, &size27, php_wxSize_entry, &choices27, &style27, &validator27, &name27, &name_len27 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent27) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent27 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent27 TSRMLS_CC))->native_object;
					object_pointer27_0 = (wxWindow*) argument_native_object;
					if (!object_pointer27_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload28;
					}
				}
				else if(Z_TYPE_P(parent27) != IS_NULL)
				{
					goto overload28;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos27) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos27 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos27 TSRMLS_CC))->native_object;
					object_pointer27_2 = (wxPoint*) argument_native_object;
					if (!object_pointer27_2 )
					{
						goto overload28;
					}
				}
				else if(Z_TYPE_P(pos27) != IS_NULL)
				{
					goto overload28;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size27) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size27 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size27 TSRMLS_CC))->native_object;
					object_pointer27_3 = (wxSize*) argument_native_object;
					if (!object_pointer27_3 )
					{
						goto overload28;
					}
				}
				else if(Z_TYPE_P(size27) != IS_NULL)
				{
					goto overload28;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(validator27) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator27 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator27 TSRMLS_CC))->native_object;
					object_pointer27_6 = (wxValidator*) argument_native_object;
					if (!object_pointer27_6 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload28;
					}
				}
				else if(Z_TYPE_P(validator27) != IS_NULL)
				{
					goto overload28;
				}
			}

			overload27_called = true;
			already_called = true;
		}
	}

	//Overload 28
	overload28:
	if(!already_called && arguments_received >= 5  && arguments_received <= 8 && (current_object_type == PHP_WXCHOICE_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zlOOa|los' (&parent28, &id28, &pos28, php_wxPoint_entry, &size28, php_wxSize_entry, &choices28, &style28, &validator28, &name28, &name_len28)\n");
		#endif

		char parse_parameters_string[] = "zlOOa|los";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent28, &id28, &pos28, php_wxPoint_entry, &size28, php_wxSize_entry, &choices28, &style28, &validator28, &name28, &name_len28 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent28) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent28 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent28 TSRMLS_CC))->native_object;
					object_pointer28_0 = (wxWindow*) argument_native_object;
					if (!object_pointer28_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload29;
					}
				}
				else if(Z_TYPE_P(parent28) != IS_NULL)
				{
					goto overload29;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos28) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos28 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos28 TSRMLS_CC))->native_object;
					object_pointer28_2 = (wxPoint*) argument_native_object;
					if (!object_pointer28_2 )
					{
						goto overload29;
					}
				}
				else if(Z_TYPE_P(pos28) != IS_NULL)
				{
					goto overload29;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size28) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size28 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size28 TSRMLS_CC))->native_object;
					object_pointer28_3 = (wxSize*) argument_native_object;
					if (!object_pointer28_3 )
					{
						goto overload29;
					}
				}
				else if(Z_TYPE_P(size28) != IS_NULL)
				{
					goto overload29;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(validator28) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator28 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator28 TSRMLS_CC))->native_object;
					object_pointer28_6 = (wxValidator*) argument_native_object;
					if (!object_pointer28_6 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload29;
					}
				}
				else if(Z_TYPE_P(validator28) != IS_NULL)
				{
					goto overload29;
				}
			}

			overload28_called = true;
			already_called = true;
		}
	}

	//Overload 29
	overload29:
	if(!already_called && arguments_received >= 2  && arguments_received <= 9 && (current_object_type == PHP_WXCHOICE_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|OOlalos' (&parent29, &id29, &pos29, php_wxPoint_entry, &size29, php_wxSize_entry, &n29, &choices29, &style29, &validator29, &name29, &name_len29)\n");
		#endif

		char parse_parameters_string[] = "zl|OOlalos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent29, &id29, &pos29, php_wxPoint_entry, &size29, php_wxSize_entry, &n29, &choices29, &style29, &validator29, &name29, &name_len29 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent29) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent29 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent29 TSRMLS_CC))->native_object;
					object_pointer29_0 = (wxWindow*) argument_native_object;
					if (!object_pointer29_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload30;
					}
				}
				else if(Z_TYPE_P(parent29) != IS_NULL)
				{
					goto overload30;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos29) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos29 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos29 TSRMLS_CC))->native_object;
					object_pointer29_2 = (wxPoint*) argument_native_object;
					if (!object_pointer29_2 )
					{
						goto overload30;
					}
				}
				else if(Z_TYPE_P(pos29) != IS_NULL)
				{
					goto overload30;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size29) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size29 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size29 TSRMLS_CC))->native_object;
					object_pointer29_3 = (wxSize*) argument_native_object;
					if (!object_pointer29_3 )
					{
						goto overload30;
					}
				}
				else if(Z_TYPE_P(size29) != IS_NULL)
				{
					goto overload30;
				}
			}

			if(arguments_received >= 8){
				if(Z_TYPE_P(validator29) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator29 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator29 TSRMLS_CC))->native_object;
					object_pointer29_7 = (wxValidator*) argument_native_object;
					if (!object_pointer29_7 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload30;
					}
				}
				else if(Z_TYPE_P(validator29) != IS_NULL)
				{
					goto overload30;
				}
			}

			overload29_called = true;
			already_called = true;
		}
	}

	//Overload 30
	overload30:
	if(!already_called && arguments_received >= 1  && arguments_received <= 5 && (current_object_type == PHP_WXAUINOTEBOOK_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lOOl' (&parent30, &id30, &pos30, php_wxPoint_entry, &size30, php_wxSize_entry, &style30)\n");
		#endif

		char parse_parameters_string[] = "z|lOOl";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent30, &id30, &pos30, php_wxPoint_entry, &size30, php_wxSize_entry, &style30 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent30) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent30 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent30 TSRMLS_CC))->native_object;
					object_pointer30_0 = (wxWindow*) argument_native_object;
					if (!object_pointer30_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload31;
					}
				}
				else if(Z_TYPE_P(parent30) != IS_NULL)
				{
					goto overload31;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos30) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos30 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos30 TSRMLS_CC))->native_object;
					object_pointer30_2 = (wxPoint*) argument_native_object;
					if (!object_pointer30_2 )
					{
						goto overload31;
					}
				}
				else if(Z_TYPE_P(pos30) != IS_NULL)
				{
					goto overload31;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size30) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size30 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size30 TSRMLS_CC))->native_object;
					object_pointer30_3 = (wxSize*) argument_native_object;
					if (!object_pointer30_3 )
					{
						goto overload31;
					}
				}
				else if(Z_TYPE_P(size30) != IS_NULL)
				{
					goto overload31;
				}
			}

			overload30_called = true;
			already_called = true;
		}
	}

	//Overload 31
	overload31:
	if(!already_called && arguments_received >= 2  && arguments_received <= 7 && (current_object_type == PHP_WXANIMATIONCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|OOOls' (&parent31, &id31, &anim31, php_wxAnimation_entry, &pos31, php_wxPoint_entry, &size31, php_wxSize_entry, &style31, &name31, &name_len31)\n");
		#endif

		char parse_parameters_string[] = "zl|OOOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent31, &id31, &anim31, php_wxAnimation_entry, &pos31, php_wxPoint_entry, &size31, php_wxSize_entry, &style31, &name31, &name_len31 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent31) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent31 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent31 TSRMLS_CC))->native_object;
					object_pointer31_0 = (wxWindow*) argument_native_object;
					if (!object_pointer31_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload32;
					}
				}
				else if(Z_TYPE_P(parent31) != IS_NULL)
				{
					goto overload32;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(anim31) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxAnimation*) zend_object_store_get_object(anim31 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxAnimation*) zend_object_store_get_object(anim31 TSRMLS_CC))->native_object;
					object_pointer31_2 = (wxAnimation*) argument_native_object;
					if (!object_pointer31_2 )
					{
						goto overload32;
					}
				}
				else if(Z_TYPE_P(anim31) != IS_NULL)
				{
					goto overload32;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos31) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos31 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos31 TSRMLS_CC))->native_object;
					object_pointer31_3 = (wxPoint*) argument_native_object;
					if (!object_pointer31_3 )
					{
						goto overload32;
					}
				}
				else if(Z_TYPE_P(pos31) != IS_NULL)
				{
					goto overload32;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size31) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size31 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size31 TSRMLS_CC))->native_object;
					object_pointer31_4 = (wxSize*) argument_native_object;
					if (!object_pointer31_4 )
					{
						goto overload32;
					}
				}
				else if(Z_TYPE_P(size31) != IS_NULL)
				{
					goto overload32;
				}
			}

			overload31_called = true;
			already_called = true;
		}
	}

	//Overload 32
	overload32:
	if(!already_called && arguments_received >= 2  && arguments_received <= 7 && (current_object_type == PHP_WXSCROLLBAR_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|OOlos' (&parent32, &id32, &pos32, php_wxPoint_entry, &size32, php_wxSize_entry, &style32, &validator32, &name32, &name_len32)\n");
		#endif

		char parse_parameters_string[] = "zl|OOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent32, &id32, &pos32, php_wxPoint_entry, &size32, php_wxSize_entry, &style32, &validator32, &name32, &name_len32 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent32) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent32 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent32 TSRMLS_CC))->native_object;
					object_pointer32_0 = (wxWindow*) argument_native_object;
					if (!object_pointer32_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload33;
					}
				}
				else if(Z_TYPE_P(parent32) != IS_NULL)
				{
					goto overload33;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos32) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos32 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos32 TSRMLS_CC))->native_object;
					object_pointer32_2 = (wxPoint*) argument_native_object;
					if (!object_pointer32_2 )
					{
						goto overload33;
					}
				}
				else if(Z_TYPE_P(pos32) != IS_NULL)
				{
					goto overload33;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size32) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size32 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size32 TSRMLS_CC))->native_object;
					object_pointer32_3 = (wxSize*) argument_native_object;
					if (!object_pointer32_3 )
					{
						goto overload33;
					}
				}
				else if(Z_TYPE_P(size32) != IS_NULL)
				{
					goto overload33;
				}
			}

			if(arguments_received >= 6){
				if(Z_TYPE_P(validator32) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator32 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator32 TSRMLS_CC))->native_object;
					object_pointer32_5 = (wxValidator*) argument_native_object;
					if (!object_pointer32_5 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload33;
					}
				}
				else if(Z_TYPE_P(validator32) != IS_NULL)
				{
					goto overload33;
				}
			}

			overload32_called = true;
			already_called = true;
		}
	}

	//Overload 33
	overload33:
	if(!already_called && arguments_received >= 3  && arguments_received <= 7 && (current_object_type == PHP_WXSTATICTEXT_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zls|OOls' (&parent33, &id33, &label33, &label_len33, &pos33, php_wxPoint_entry, &size33, php_wxSize_entry, &style33, &name33, &name_len33)\n");
		#endif

		char parse_parameters_string[] = "zls|OOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent33, &id33, &label33, &label_len33, &pos33, php_wxPoint_entry, &size33, php_wxSize_entry, &style33, &name33, &name_len33 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent33) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent33 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent33 TSRMLS_CC))->native_object;
					object_pointer33_0 = (wxWindow*) argument_native_object;
					if (!object_pointer33_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload34;
					}
				}
				else if(Z_TYPE_P(parent33) != IS_NULL)
				{
					goto overload34;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos33) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos33 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos33 TSRMLS_CC))->native_object;
					object_pointer33_3 = (wxPoint*) argument_native_object;
					if (!object_pointer33_3 )
					{
						goto overload34;
					}
				}
				else if(Z_TYPE_P(pos33) != IS_NULL)
				{
					goto overload34;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size33) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size33 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size33 TSRMLS_CC))->native_object;
					object_pointer33_4 = (wxSize*) argument_native_object;
					if (!object_pointer33_4 )
					{
						goto overload34;
					}
				}
				else if(Z_TYPE_P(size33) != IS_NULL)
				{
					goto overload34;
				}
			}

			overload33_called = true;
			already_called = true;
		}
	}

	//Overload 34
	overload34:
	if(!already_called && arguments_received >= 3  && arguments_received <= 7 && (current_object_type == PHP_WXSTATICBOX_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zls|OOls' (&parent34, &id34, &label34, &label_len34, &pos34, php_wxPoint_entry, &size34, php_wxSize_entry, &style34, &name34, &name_len34)\n");
		#endif

		char parse_parameters_string[] = "zls|OOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent34, &id34, &label34, &label_len34, &pos34, php_wxPoint_entry, &size34, php_wxSize_entry, &style34, &name34, &name_len34 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent34) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent34 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent34 TSRMLS_CC))->native_object;
					object_pointer34_0 = (wxWindow*) argument_native_object;
					if (!object_pointer34_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload35;
					}
				}
				else if(Z_TYPE_P(parent34) != IS_NULL)
				{
					goto overload35;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos34) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos34 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos34 TSRMLS_CC))->native_object;
					object_pointer34_3 = (wxPoint*) argument_native_object;
					if (!object_pointer34_3 )
					{
						goto overload35;
					}
				}
				else if(Z_TYPE_P(pos34) != IS_NULL)
				{
					goto overload35;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size34) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size34 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size34 TSRMLS_CC))->native_object;
					object_pointer34_4 = (wxSize*) argument_native_object;
					if (!object_pointer34_4 )
					{
						goto overload35;
					}
				}
				else if(Z_TYPE_P(size34) != IS_NULL)
				{
					goto overload35;
				}
			}

			overload34_called = true;
			already_called = true;
		}
	}

	//Overload 35
	overload35:
	if(!already_called && arguments_received >= 3  && arguments_received <= 7 && (current_object_type == PHP_WXSTATICBITMAP_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zlO|OOls' (&parent35, &id35, &label35, php_wxBitmap_entry, &pos35, php_wxPoint_entry, &size35, php_wxSize_entry, &style35, &name35, &name_len35)\n");
		#endif

		char parse_parameters_string[] = "zlO|OOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent35, &id35, &label35, php_wxBitmap_entry, &pos35, php_wxPoint_entry, &size35, php_wxSize_entry, &style35, &name35, &name_len35 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent35) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent35 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent35 TSRMLS_CC))->native_object;
					object_pointer35_0 = (wxWindow*) argument_native_object;
					if (!object_pointer35_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload36;
					}
				}
				else if(Z_TYPE_P(parent35) != IS_NULL)
				{
					goto overload36;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(label35) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(label35 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(label35 TSRMLS_CC))->native_object;
					object_pointer35_2 = (wxBitmap*) argument_native_object;
					if (!object_pointer35_2 )
					{
						goto overload36;
					}
				}
				else if(Z_TYPE_P(label35) != IS_NULL)
				{
					goto overload36;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos35) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos35 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos35 TSRMLS_CC))->native_object;
					object_pointer35_3 = (wxPoint*) argument_native_object;
					if (!object_pointer35_3 )
					{
						goto overload36;
					}
				}
				else if(Z_TYPE_P(pos35) != IS_NULL)
				{
					goto overload36;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size35) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size35 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size35 TSRMLS_CC))->native_object;
					object_pointer35_4 = (wxSize*) argument_native_object;
					if (!object_pointer35_4 )
					{
						goto overload36;
					}
				}
				else if(Z_TYPE_P(size35) != IS_NULL)
				{
					goto overload36;
				}
			}

			overload35_called = true;
			already_called = true;
		}
	}

	//Overload 36
	overload36:
	if(!already_called && arguments_received >= 3  && arguments_received <= 8 && (current_object_type == PHP_WXCHECKBOX_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zls|OOlos' (&parent36, &id36, &label36, &label_len36, &pos36, php_wxPoint_entry, &size36, php_wxSize_entry, &style36, &validator36, &name36, &name_len36)\n");
		#endif

		char parse_parameters_string[] = "zls|OOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent36, &id36, &label36, &label_len36, &pos36, php_wxPoint_entry, &size36, php_wxSize_entry, &style36, &validator36, &name36, &name_len36 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent36) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent36 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent36 TSRMLS_CC))->native_object;
					object_pointer36_0 = (wxWindow*) argument_native_object;
					if (!object_pointer36_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload37;
					}
				}
				else if(Z_TYPE_P(parent36) != IS_NULL)
				{
					goto overload37;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos36) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos36 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos36 TSRMLS_CC))->native_object;
					object_pointer36_3 = (wxPoint*) argument_native_object;
					if (!object_pointer36_3 )
					{
						goto overload37;
					}
				}
				else if(Z_TYPE_P(pos36) != IS_NULL)
				{
					goto overload37;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size36) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size36 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size36 TSRMLS_CC))->native_object;
					object_pointer36_4 = (wxSize*) argument_native_object;
					if (!object_pointer36_4 )
					{
						goto overload37;
					}
				}
				else if(Z_TYPE_P(size36) != IS_NULL)
				{
					goto overload37;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(validator36) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator36 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator36 TSRMLS_CC))->native_object;
					object_pointer36_6 = (wxValidator*) argument_native_object;
					if (!object_pointer36_6 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload37;
					}
				}
				else if(Z_TYPE_P(validator36) != IS_NULL)
				{
					goto overload37;
				}
			}

			overload36_called = true;
			already_called = true;
		}
	}

	//Overload 37
	overload37:
	if(!already_called && arguments_received >= 2  && arguments_received <= 8 && (current_object_type == PHP_WXTEXTCTRL_TYPE || current_object_type == PHP_WXSEARCHCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|sOOlos' (&parent37, &id37, &value37, &value_len37, &pos37, php_wxPoint_entry, &size37, php_wxSize_entry, &style37, &validator37, &name37, &name_len37)\n");
		#endif

		char parse_parameters_string[] = "zl|sOOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent37, &id37, &value37, &value_len37, &pos37, php_wxPoint_entry, &size37, php_wxSize_entry, &style37, &validator37, &name37, &name_len37 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent37) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent37 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent37 TSRMLS_CC))->native_object;
					object_pointer37_0 = (wxWindow*) argument_native_object;
					if (!object_pointer37_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload38;
					}
				}
				else if(Z_TYPE_P(parent37) != IS_NULL)
				{
					goto overload38;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos37) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos37 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos37 TSRMLS_CC))->native_object;
					object_pointer37_3 = (wxPoint*) argument_native_object;
					if (!object_pointer37_3 )
					{
						goto overload38;
					}
				}
				else if(Z_TYPE_P(pos37) != IS_NULL)
				{
					goto overload38;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size37) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size37 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size37 TSRMLS_CC))->native_object;
					object_pointer37_4 = (wxSize*) argument_native_object;
					if (!object_pointer37_4 )
					{
						goto overload38;
					}
				}
				else if(Z_TYPE_P(size37) != IS_NULL)
				{
					goto overload38;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(validator37) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator37 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator37 TSRMLS_CC))->native_object;
					object_pointer37_6 = (wxValidator*) argument_native_object;
					if (!object_pointer37_6 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload38;
					}
				}
				else if(Z_TYPE_P(validator37) != IS_NULL)
				{
					goto overload38;
				}
			}

			overload37_called = true;
			already_called = true;
		}
	}

	//Overload 38
	overload38:
	if(!already_called && arguments_received >= 2  && arguments_received <= 8 && (current_object_type == PHP_WXSEARCHCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|sOOlos' (&parent38, &id38, &value38, &value_len38, &pos38, php_wxPoint_entry, &size38, php_wxSize_entry, &style38, &validator38, &name38, &name_len38)\n");
		#endif

		char parse_parameters_string[] = "zl|sOOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent38, &id38, &value38, &value_len38, &pos38, php_wxPoint_entry, &size38, php_wxSize_entry, &style38, &validator38, &name38, &name_len38 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent38) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent38 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent38 TSRMLS_CC))->native_object;
					object_pointer38_0 = (wxWindow*) argument_native_object;
					if (!object_pointer38_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload39;
					}
				}
				else if(Z_TYPE_P(parent38) != IS_NULL)
				{
					goto overload39;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos38) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos38 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos38 TSRMLS_CC))->native_object;
					object_pointer38_3 = (wxPoint*) argument_native_object;
					if (!object_pointer38_3 )
					{
						goto overload39;
					}
				}
				else if(Z_TYPE_P(pos38) != IS_NULL)
				{
					goto overload39;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size38) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size38 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size38 TSRMLS_CC))->native_object;
					object_pointer38_4 = (wxSize*) argument_native_object;
					if (!object_pointer38_4 )
					{
						goto overload39;
					}
				}
				else if(Z_TYPE_P(size38) != IS_NULL)
				{
					goto overload39;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(validator38) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator38 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator38 TSRMLS_CC))->native_object;
					object_pointer38_6 = (wxValidator*) argument_native_object;
					if (!object_pointer38_6 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload39;
					}
				}
				else if(Z_TYPE_P(validator38) != IS_NULL)
				{
					goto overload39;
				}
			}

			overload38_called = true;
			already_called = true;
		}
	}

	//Overload 39
	overload39:
	if(!already_called && arguments_received >= 2  && arguments_received <= 10 && (current_object_type == PHP_WXCOMBOBOX_TYPE || current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|sOOlalos' (&parent39, &id39, &value39, &value_len39, &pos39, php_wxPoint_entry, &size39, php_wxSize_entry, &n39, &choices39, &style39, &validator39, &name39, &name_len39)\n");
		#endif

		char parse_parameters_string[] = "zl|sOOlalos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent39, &id39, &value39, &value_len39, &pos39, php_wxPoint_entry, &size39, php_wxSize_entry, &n39, &choices39, &style39, &validator39, &name39, &name_len39 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent39) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent39 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent39 TSRMLS_CC))->native_object;
					object_pointer39_0 = (wxWindow*) argument_native_object;
					if (!object_pointer39_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload40;
					}
				}
				else if(Z_TYPE_P(parent39) != IS_NULL)
				{
					goto overload40;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos39) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos39 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos39 TSRMLS_CC))->native_object;
					object_pointer39_3 = (wxPoint*) argument_native_object;
					if (!object_pointer39_3 )
					{
						goto overload40;
					}
				}
				else if(Z_TYPE_P(pos39) != IS_NULL)
				{
					goto overload40;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size39) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size39 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size39 TSRMLS_CC))->native_object;
					object_pointer39_4 = (wxSize*) argument_native_object;
					if (!object_pointer39_4 )
					{
						goto overload40;
					}
				}
				else if(Z_TYPE_P(size39) != IS_NULL)
				{
					goto overload40;
				}
			}

			if(arguments_received >= 9){
				if(Z_TYPE_P(validator39) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator39 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator39 TSRMLS_CC))->native_object;
					object_pointer39_8 = (wxValidator*) argument_native_object;
					if (!object_pointer39_8 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload40;
					}
				}
				else if(Z_TYPE_P(validator39) != IS_NULL)
				{
					goto overload40;
				}
			}

			overload39_called = true;
			already_called = true;
		}
	}

	//Overload 40
	overload40:
	if(!already_called && arguments_received >= 6  && arguments_received <= 9 && (current_object_type == PHP_WXCOMBOBOX_TYPE || current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zlsOOa|los' (&parent40, &id40, &value40, &value_len40, &pos40, php_wxPoint_entry, &size40, php_wxSize_entry, &choices40, &style40, &validator40, &name40, &name_len40)\n");
		#endif

		char parse_parameters_string[] = "zlsOOa|los";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent40, &id40, &value40, &value_len40, &pos40, php_wxPoint_entry, &size40, php_wxSize_entry, &choices40, &style40, &validator40, &name40, &name_len40 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent40) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent40 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent40 TSRMLS_CC))->native_object;
					object_pointer40_0 = (wxWindow*) argument_native_object;
					if (!object_pointer40_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload41;
					}
				}
				else if(Z_TYPE_P(parent40) != IS_NULL)
				{
					goto overload41;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos40) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos40 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos40 TSRMLS_CC))->native_object;
					object_pointer40_3 = (wxPoint*) argument_native_object;
					if (!object_pointer40_3 )
					{
						goto overload41;
					}
				}
				else if(Z_TYPE_P(pos40) != IS_NULL)
				{
					goto overload41;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size40) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size40 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size40 TSRMLS_CC))->native_object;
					object_pointer40_4 = (wxSize*) argument_native_object;
					if (!object_pointer40_4 )
					{
						goto overload41;
					}
				}
				else if(Z_TYPE_P(size40) != IS_NULL)
				{
					goto overload41;
				}
			}

			if(arguments_received >= 8){
				if(Z_TYPE_P(validator40) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator40 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator40 TSRMLS_CC))->native_object;
					object_pointer40_7 = (wxValidator*) argument_native_object;
					if (!object_pointer40_7 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload41;
					}
				}
				else if(Z_TYPE_P(validator40) != IS_NULL)
				{
					goto overload41;
				}
			}

			overload40_called = true;
			already_called = true;
		}
	}

	//Overload 41
	overload41:
	if(!already_called && arguments_received >= 6  && arguments_received <= 9 && (current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zlsOOa|los' (&parent41, &id41, &value41, &value_len41, &pos41, php_wxPoint_entry, &size41, php_wxSize_entry, &choices41, &style41, &validator41, &name41, &name_len41)\n");
		#endif

		char parse_parameters_string[] = "zlsOOa|los";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent41, &id41, &value41, &value_len41, &pos41, php_wxPoint_entry, &size41, php_wxSize_entry, &choices41, &style41, &validator41, &name41, &name_len41 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent41) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent41 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent41 TSRMLS_CC))->native_object;
					object_pointer41_0 = (wxWindow*) argument_native_object;
					if (!object_pointer41_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload42;
					}
				}
				else if(Z_TYPE_P(parent41) != IS_NULL)
				{
					goto overload42;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos41) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos41 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos41 TSRMLS_CC))->native_object;
					object_pointer41_3 = (wxPoint*) argument_native_object;
					if (!object_pointer41_3 )
					{
						goto overload42;
					}
				}
				else if(Z_TYPE_P(pos41) != IS_NULL)
				{
					goto overload42;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size41) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size41 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size41 TSRMLS_CC))->native_object;
					object_pointer41_4 = (wxSize*) argument_native_object;
					if (!object_pointer41_4 )
					{
						goto overload42;
					}
				}
				else if(Z_TYPE_P(size41) != IS_NULL)
				{
					goto overload42;
				}
			}

			if(arguments_received >= 8){
				if(Z_TYPE_P(validator41) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator41 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator41 TSRMLS_CC))->native_object;
					object_pointer41_7 = (wxValidator*) argument_native_object;
					if (!object_pointer41_7 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload42;
					}
				}
				else if(Z_TYPE_P(validator41) != IS_NULL)
				{
					goto overload42;
				}
			}

			overload41_called = true;
			already_called = true;
		}
	}

	//Overload 42
	overload42:
	if(!already_called && arguments_received >= 7  && arguments_received <= 10 && (current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zlsOOla|los' (&parent42, &id42, &value42, &value_len42, &pos42, php_wxPoint_entry, &size42, php_wxSize_entry, &n42, &choices42, &style42, &validator42, &name42, &name_len42)\n");
		#endif

		char parse_parameters_string[] = "zlsOOla|los";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent42, &id42, &value42, &value_len42, &pos42, php_wxPoint_entry, &size42, php_wxSize_entry, &n42, &choices42, &style42, &validator42, &name42, &name_len42 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent42) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent42 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent42 TSRMLS_CC))->native_object;
					object_pointer42_0 = (wxWindow*) argument_native_object;
					if (!object_pointer42_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload43;
					}
				}
				else if(Z_TYPE_P(parent42) != IS_NULL)
				{
					goto overload43;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos42) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos42 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos42 TSRMLS_CC))->native_object;
					object_pointer42_3 = (wxPoint*) argument_native_object;
					if (!object_pointer42_3 )
					{
						goto overload43;
					}
				}
				else if(Z_TYPE_P(pos42) != IS_NULL)
				{
					goto overload43;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size42) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size42 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size42 TSRMLS_CC))->native_object;
					object_pointer42_4 = (wxSize*) argument_native_object;
					if (!object_pointer42_4 )
					{
						goto overload43;
					}
				}
				else if(Z_TYPE_P(size42) != IS_NULL)
				{
					goto overload43;
				}
			}

			if(arguments_received >= 9){
				if(Z_TYPE_P(validator42) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator42 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator42 TSRMLS_CC))->native_object;
					object_pointer42_8 = (wxValidator*) argument_native_object;
					if (!object_pointer42_8 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload43;
					}
				}
				else if(Z_TYPE_P(validator42) != IS_NULL)
				{
					goto overload43;
				}
			}

			overload42_called = true;
			already_called = true;
		}
	}

	//Overload 43
	overload43:
	if(!already_called && arguments_received >= 2  && arguments_received <= 7 && (current_object_type == PHP_WXLISTCTRL_TYPE || current_object_type == PHP_WXLISTVIEW_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|OOlos' (&parent43, &id43, &pos43, php_wxPoint_entry, &size43, php_wxSize_entry, &style43, &validator43, &name43, &name_len43)\n");
		#endif

		char parse_parameters_string[] = "zl|OOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent43, &id43, &pos43, php_wxPoint_entry, &size43, php_wxSize_entry, &style43, &validator43, &name43, &name_len43 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent43) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent43 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent43 TSRMLS_CC))->native_object;
					object_pointer43_0 = (wxWindow*) argument_native_object;
					if (!object_pointer43_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload44;
					}
				}
				else if(Z_TYPE_P(parent43) != IS_NULL)
				{
					goto overload44;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos43) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos43 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos43 TSRMLS_CC))->native_object;
					object_pointer43_2 = (wxPoint*) argument_native_object;
					if (!object_pointer43_2 )
					{
						goto overload44;
					}
				}
				else if(Z_TYPE_P(pos43) != IS_NULL)
				{
					goto overload44;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size43) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size43 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size43 TSRMLS_CC))->native_object;
					object_pointer43_3 = (wxSize*) argument_native_object;
					if (!object_pointer43_3 )
					{
						goto overload44;
					}
				}
				else if(Z_TYPE_P(size43) != IS_NULL)
				{
					goto overload44;
				}
			}

			if(arguments_received >= 6){
				if(Z_TYPE_P(validator43) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator43 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator43 TSRMLS_CC))->native_object;
					object_pointer43_5 = (wxValidator*) argument_native_object;
					if (!object_pointer43_5 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload44;
					}
				}
				else if(Z_TYPE_P(validator43) != IS_NULL)
				{
					goto overload44;
				}
			}

			overload43_called = true;
			already_called = true;
		}
	}

	//Overload 44
	overload44:
	if(!already_called && arguments_received >= 3  && arguments_received <= 11 && (current_object_type == PHP_WXRADIOBOX_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zls|OOlallos' (&parent44, &id44, &label44, &label_len44, &pos44, php_wxPoint_entry, &size44, php_wxSize_entry, &n44, &choices44, &majorDimension44, &style44, &validator44, &name44, &name_len44)\n");
		#endif

		char parse_parameters_string[] = "zls|OOlallos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent44, &id44, &label44, &label_len44, &pos44, php_wxPoint_entry, &size44, php_wxSize_entry, &n44, &choices44, &majorDimension44, &style44, &validator44, &name44, &name_len44 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent44) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent44 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent44 TSRMLS_CC))->native_object;
					object_pointer44_0 = (wxWindow*) argument_native_object;
					if (!object_pointer44_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload45;
					}
				}
				else if(Z_TYPE_P(parent44) != IS_NULL)
				{
					goto overload45;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos44) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos44 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos44 TSRMLS_CC))->native_object;
					object_pointer44_3 = (wxPoint*) argument_native_object;
					if (!object_pointer44_3 )
					{
						goto overload45;
					}
				}
				else if(Z_TYPE_P(pos44) != IS_NULL)
				{
					goto overload45;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size44) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size44 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size44 TSRMLS_CC))->native_object;
					object_pointer44_4 = (wxSize*) argument_native_object;
					if (!object_pointer44_4 )
					{
						goto overload45;
					}
				}
				else if(Z_TYPE_P(size44) != IS_NULL)
				{
					goto overload45;
				}
			}

			if(arguments_received >= 10){
				if(Z_TYPE_P(validator44) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator44 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator44 TSRMLS_CC))->native_object;
					object_pointer44_9 = (wxValidator*) argument_native_object;
					if (!object_pointer44_9 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload45;
					}
				}
				else if(Z_TYPE_P(validator44) != IS_NULL)
				{
					goto overload45;
				}
			}

			overload44_called = true;
			already_called = true;
		}
	}

	//Overload 45
	overload45:
	if(!already_called && arguments_received >= 6  && arguments_received <= 10 && (current_object_type == PHP_WXRADIOBOX_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zlsOOa|llos' (&parent45, &id45, &label45, &label_len45, &pos45, php_wxPoint_entry, &size45, php_wxSize_entry, &choices45, &majorDimension45, &style45, &validator45, &name45, &name_len45)\n");
		#endif

		char parse_parameters_string[] = "zlsOOa|llos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent45, &id45, &label45, &label_len45, &pos45, php_wxPoint_entry, &size45, php_wxSize_entry, &choices45, &majorDimension45, &style45, &validator45, &name45, &name_len45 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent45) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent45 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent45 TSRMLS_CC))->native_object;
					object_pointer45_0 = (wxWindow*) argument_native_object;
					if (!object_pointer45_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload46;
					}
				}
				else if(Z_TYPE_P(parent45) != IS_NULL)
				{
					goto overload46;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos45) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos45 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos45 TSRMLS_CC))->native_object;
					object_pointer45_3 = (wxPoint*) argument_native_object;
					if (!object_pointer45_3 )
					{
						goto overload46;
					}
				}
				else if(Z_TYPE_P(pos45) != IS_NULL)
				{
					goto overload46;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size45) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size45 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size45 TSRMLS_CC))->native_object;
					object_pointer45_4 = (wxSize*) argument_native_object;
					if (!object_pointer45_4 )
					{
						goto overload46;
					}
				}
				else if(Z_TYPE_P(size45) != IS_NULL)
				{
					goto overload46;
				}
			}

			if(arguments_received >= 9){
				if(Z_TYPE_P(validator45) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator45 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator45 TSRMLS_CC))->native_object;
					object_pointer45_8 = (wxValidator*) argument_native_object;
					if (!object_pointer45_8 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload46;
					}
				}
				else if(Z_TYPE_P(validator45) != IS_NULL)
				{
					goto overload46;
				}
			}

			overload45_called = true;
			already_called = true;
		}
	}

	//Overload 46
	overload46:
	if(!already_called && arguments_received >= 3  && arguments_received <= 8 && (current_object_type == PHP_WXRADIOBUTTON_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zls|OOlos' (&parent46, &id46, &label46, &label_len46, &pos46, php_wxPoint_entry, &size46, php_wxSize_entry, &style46, &validator46, &name46, &name_len46)\n");
		#endif

		char parse_parameters_string[] = "zls|OOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent46, &id46, &label46, &label_len46, &pos46, php_wxPoint_entry, &size46, php_wxSize_entry, &style46, &validator46, &name46, &name_len46 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent46) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent46 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent46 TSRMLS_CC))->native_object;
					object_pointer46_0 = (wxWindow*) argument_native_object;
					if (!object_pointer46_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload47;
					}
				}
				else if(Z_TYPE_P(parent46) != IS_NULL)
				{
					goto overload47;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos46) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos46 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos46 TSRMLS_CC))->native_object;
					object_pointer46_3 = (wxPoint*) argument_native_object;
					if (!object_pointer46_3 )
					{
						goto overload47;
					}
				}
				else if(Z_TYPE_P(pos46) != IS_NULL)
				{
					goto overload47;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size46) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size46 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size46 TSRMLS_CC))->native_object;
					object_pointer46_4 = (wxSize*) argument_native_object;
					if (!object_pointer46_4 )
					{
						goto overload47;
					}
				}
				else if(Z_TYPE_P(size46) != IS_NULL)
				{
					goto overload47;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(validator46) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator46 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator46 TSRMLS_CC))->native_object;
					object_pointer46_6 = (wxValidator*) argument_native_object;
					if (!object_pointer46_6 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload47;
					}
				}
				else if(Z_TYPE_P(validator46) != IS_NULL)
				{
					goto overload47;
				}
			}

			overload46_called = true;
			already_called = true;
		}
	}

	//Overload 47
	overload47:
	if(!already_called && arguments_received >= 5  && arguments_received <= 10 && (current_object_type == PHP_WXSLIDER_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zllll|OOlos' (&parent47, &id47, &value47, &minValue47, &maxValue47, &point47, php_wxPoint_entry, &size47, php_wxSize_entry, &style47, &validator47, &name47, &name_len47)\n");
		#endif

		char parse_parameters_string[] = "zllll|OOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent47, &id47, &value47, &minValue47, &maxValue47, &point47, php_wxPoint_entry, &size47, php_wxSize_entry, &style47, &validator47, &name47, &name_len47 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent47) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent47 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent47 TSRMLS_CC))->native_object;
					object_pointer47_0 = (wxWindow*) argument_native_object;
					if (!object_pointer47_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload48;
					}
				}
				else if(Z_TYPE_P(parent47) != IS_NULL)
				{
					goto overload48;
				}
			}

			if(arguments_received >= 6){
				if(Z_TYPE_P(point47) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(point47 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(point47 TSRMLS_CC))->native_object;
					object_pointer47_5 = (wxPoint*) argument_native_object;
					if (!object_pointer47_5 )
					{
						goto overload48;
					}
				}
				else if(Z_TYPE_P(point47) != IS_NULL)
				{
					goto overload48;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(size47) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size47 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size47 TSRMLS_CC))->native_object;
					object_pointer47_6 = (wxSize*) argument_native_object;
					if (!object_pointer47_6 )
					{
						goto overload48;
					}
				}
				else if(Z_TYPE_P(size47) != IS_NULL)
				{
					goto overload48;
				}
			}

			if(arguments_received >= 9){
				if(Z_TYPE_P(validator47) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator47 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator47 TSRMLS_CC))->native_object;
					object_pointer47_8 = (wxValidator*) argument_native_object;
					if (!object_pointer47_8 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload48;
					}
				}
				else if(Z_TYPE_P(validator47) != IS_NULL)
				{
					goto overload48;
				}
			}

			overload47_called = true;
			already_called = true;
		}
	}

	//Overload 48
	overload48:
	if(!already_called && arguments_received >= 1  && arguments_received <= 10 && (current_object_type == PHP_WXSPINCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lsOOlllls' (&parent48, &id48, &value48, &value_len48, &pos48, php_wxPoint_entry, &size48, php_wxSize_entry, &style48, &min48, &max48, &initial48, &name48, &name_len48)\n");
		#endif

		char parse_parameters_string[] = "z|lsOOlllls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent48, &id48, &value48, &value_len48, &pos48, php_wxPoint_entry, &size48, php_wxSize_entry, &style48, &min48, &max48, &initial48, &name48, &name_len48 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent48) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent48 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent48 TSRMLS_CC))->native_object;
					object_pointer48_0 = (wxWindow*) argument_native_object;
					if (!object_pointer48_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload49;
					}
				}
				else if(Z_TYPE_P(parent48) != IS_NULL)
				{
					goto overload49;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos48) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos48 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos48 TSRMLS_CC))->native_object;
					object_pointer48_3 = (wxPoint*) argument_native_object;
					if (!object_pointer48_3 )
					{
						goto overload49;
					}
				}
				else if(Z_TYPE_P(pos48) != IS_NULL)
				{
					goto overload49;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size48) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size48 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size48 TSRMLS_CC))->native_object;
					object_pointer48_4 = (wxSize*) argument_native_object;
					if (!object_pointer48_4 )
					{
						goto overload49;
					}
				}
				else if(Z_TYPE_P(size48) != IS_NULL)
				{
					goto overload49;
				}
			}

			overload48_called = true;
			already_called = true;
		}
	}

	//Overload 49
	overload49:
	if(!already_called && arguments_received >= 3  && arguments_received <= 8 && (current_object_type == PHP_WXGAUGE_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zll|OOlos' (&parent49, &id49, &range49, &pos49, php_wxPoint_entry, &size49, php_wxSize_entry, &style49, &validator49, &name49, &name_len49)\n");
		#endif

		char parse_parameters_string[] = "zll|OOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent49, &id49, &range49, &pos49, php_wxPoint_entry, &size49, php_wxSize_entry, &style49, &validator49, &name49, &name_len49 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent49) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent49 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent49 TSRMLS_CC))->native_object;
					object_pointer49_0 = (wxWindow*) argument_native_object;
					if (!object_pointer49_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload50;
					}
				}
				else if(Z_TYPE_P(parent49) != IS_NULL)
				{
					goto overload50;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos49) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos49 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos49 TSRMLS_CC))->native_object;
					object_pointer49_3 = (wxPoint*) argument_native_object;
					if (!object_pointer49_3 )
					{
						goto overload50;
					}
				}
				else if(Z_TYPE_P(pos49) != IS_NULL)
				{
					goto overload50;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size49) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size49 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size49 TSRMLS_CC))->native_object;
					object_pointer49_4 = (wxSize*) argument_native_object;
					if (!object_pointer49_4 )
					{
						goto overload50;
					}
				}
				else if(Z_TYPE_P(size49) != IS_NULL)
				{
					goto overload50;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(validator49) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator49 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator49 TSRMLS_CC))->native_object;
					object_pointer49_6 = (wxValidator*) argument_native_object;
					if (!object_pointer49_6 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload50;
					}
				}
				else if(Z_TYPE_P(validator49) != IS_NULL)
				{
					goto overload50;
				}
			}

			overload49_called = true;
			already_called = true;
		}
	}

	//Overload 50
	overload50:
	if(!already_called && arguments_received >= 4  && arguments_received <= 8 && (current_object_type == PHP_WXHYPERLINKCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zlss|OOls' (&parent50, &id50, &label50, &label_len50, &url50, &url_len50, &pos50, php_wxPoint_entry, &size50, php_wxSize_entry, &style50, &name50, &name_len50)\n");
		#endif

		char parse_parameters_string[] = "zlss|OOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent50, &id50, &label50, &label_len50, &url50, &url_len50, &pos50, php_wxPoint_entry, &size50, php_wxSize_entry, &style50, &name50, &name_len50 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent50) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent50 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent50 TSRMLS_CC))->native_object;
					object_pointer50_0 = (wxWindow*) argument_native_object;
					if (!object_pointer50_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload51;
					}
				}
				else if(Z_TYPE_P(parent50) != IS_NULL)
				{
					goto overload51;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(pos50) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos50 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos50 TSRMLS_CC))->native_object;
					object_pointer50_4 = (wxPoint*) argument_native_object;
					if (!object_pointer50_4 )
					{
						goto overload51;
					}
				}
				else if(Z_TYPE_P(pos50) != IS_NULL)
				{
					goto overload51;
				}
			}

			if(arguments_received >= 6){
				if(Z_TYPE_P(size50) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size50 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size50 TSRMLS_CC))->native_object;
					object_pointer50_5 = (wxSize*) argument_native_object;
					if (!object_pointer50_5 )
					{
						goto overload51;
					}
				}
				else if(Z_TYPE_P(size50) != IS_NULL)
				{
					goto overload51;
				}
			}

			overload50_called = true;
			already_called = true;
		}
	}

	//Overload 51
	overload51:
	if(!already_called && arguments_received >= 1  && arguments_received <= 11 && (current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lsOOldddds' (&parent51, &id51, &value51, &value_len51, &pos51, php_wxPoint_entry, &size51, php_wxSize_entry, &style51, &min51, &max51, &initial51, &inc51, &name51, &name_len51)\n");
		#endif

		char parse_parameters_string[] = "z|lsOOldddds";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent51, &id51, &value51, &value_len51, &pos51, php_wxPoint_entry, &size51, php_wxSize_entry, &style51, &min51, &max51, &initial51, &inc51, &name51, &name_len51 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent51) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent51 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent51 TSRMLS_CC))->native_object;
					object_pointer51_0 = (wxWindow*) argument_native_object;
					if (!object_pointer51_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload52;
					}
				}
				else if(Z_TYPE_P(parent51) != IS_NULL)
				{
					goto overload52;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos51) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos51 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos51 TSRMLS_CC))->native_object;
					object_pointer51_3 = (wxPoint*) argument_native_object;
					if (!object_pointer51_3 )
					{
						goto overload52;
					}
				}
				else if(Z_TYPE_P(pos51) != IS_NULL)
				{
					goto overload52;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size51) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size51 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size51 TSRMLS_CC))->native_object;
					object_pointer51_4 = (wxSize*) argument_native_object;
					if (!object_pointer51_4 )
					{
						goto overload52;
					}
				}
				else if(Z_TYPE_P(size51) != IS_NULL)
				{
					goto overload52;
				}
			}

			overload51_called = true;
			already_called = true;
		}
	}

	//Overload 52
	overload52:
	if(!already_called && arguments_received >= 1  && arguments_received <= 9 && (current_object_type == PHP_WXGENERICDIRCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lsOOlsls' (&parent52, &id52, &dir52, &dir_len52, &pos52, php_wxPoint_entry, &size52, php_wxSize_entry, &style52, &filter52, &filter_len52, &defaultFilter52, &name52, &name_len52)\n");
		#endif

		char parse_parameters_string[] = "z|lsOOlsls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent52, &id52, &dir52, &dir_len52, &pos52, php_wxPoint_entry, &size52, php_wxSize_entry, &style52, &filter52, &filter_len52, &defaultFilter52, &name52, &name_len52 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent52) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent52 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent52 TSRMLS_CC))->native_object;
					object_pointer52_0 = (wxWindow*) argument_native_object;
					if (!object_pointer52_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload53;
					}
				}
				else if(Z_TYPE_P(parent52) != IS_NULL)
				{
					goto overload53;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos52) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos52 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos52 TSRMLS_CC))->native_object;
					object_pointer52_3 = (wxPoint*) argument_native_object;
					if (!object_pointer52_3 )
					{
						goto overload53;
					}
				}
				else if(Z_TYPE_P(pos52) != IS_NULL)
				{
					goto overload53;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size52) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size52 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size52 TSRMLS_CC))->native_object;
					object_pointer52_4 = (wxSize*) argument_native_object;
					if (!object_pointer52_4 )
					{
						goto overload53;
					}
				}
				else if(Z_TYPE_P(size52) != IS_NULL)
				{
					goto overload53;
				}
			}

			overload52_called = true;
			already_called = true;
		}
	}

	//Overload 53
	overload53:
	if(!already_called && arguments_received >= 2  && arguments_received <= 7 && (current_object_type == PHP_WXCALENDARCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|lOOls' (&parent53, &id53, &date53, &pos53, php_wxPoint_entry, &size53, php_wxSize_entry, &style53, &name53, &name_len53)\n");
		#endif

		char parse_parameters_string[] = "zl|lOOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent53, &id53, &date53, &pos53, php_wxPoint_entry, &size53, php_wxSize_entry, &style53, &name53, &name_len53 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent53) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent53 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent53 TSRMLS_CC))->native_object;
					object_pointer53_0 = (wxWindow*) argument_native_object;
					if (!object_pointer53_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload54;
					}
				}
				else if(Z_TYPE_P(parent53) != IS_NULL)
				{
					goto overload54;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos53) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos53 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos53 TSRMLS_CC))->native_object;
					object_pointer53_3 = (wxPoint*) argument_native_object;
					if (!object_pointer53_3 )
					{
						goto overload54;
					}
				}
				else if(Z_TYPE_P(pos53) != IS_NULL)
				{
					goto overload54;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size53) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size53 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size53 TSRMLS_CC))->native_object;
					object_pointer53_4 = (wxSize*) argument_native_object;
					if (!object_pointer53_4 )
					{
						goto overload54;
					}
				}
				else if(Z_TYPE_P(size53) != IS_NULL)
				{
					goto overload54;
				}
			}

			overload53_called = true;
			already_called = true;
		}
	}

	//Overload 54
	overload54:
	if(!already_called && arguments_received >= 2  && arguments_received <= 8 && (current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|OOOlos' (&parent54, &id54, &colour54, php_wxColour_entry, &pos54, php_wxPoint_entry, &size54, php_wxSize_entry, &style54, &validator54, &name54, &name_len54)\n");
		#endif

		char parse_parameters_string[] = "zl|OOOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent54, &id54, &colour54, php_wxColour_entry, &pos54, php_wxPoint_entry, &size54, php_wxSize_entry, &style54, &validator54, &name54, &name_len54 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent54) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent54 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent54 TSRMLS_CC))->native_object;
					object_pointer54_0 = (wxWindow*) argument_native_object;
					if (!object_pointer54_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload55;
					}
				}
				else if(Z_TYPE_P(parent54) != IS_NULL)
				{
					goto overload55;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(colour54) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxColour*) zend_object_store_get_object(colour54 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxColour*) zend_object_store_get_object(colour54 TSRMLS_CC))->native_object;
					object_pointer54_2 = (wxColour*) argument_native_object;
					if (!object_pointer54_2 )
					{
						goto overload55;
					}
				}
				else if(Z_TYPE_P(colour54) != IS_NULL)
				{
					goto overload55;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos54) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos54 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos54 TSRMLS_CC))->native_object;
					object_pointer54_3 = (wxPoint*) argument_native_object;
					if (!object_pointer54_3 )
					{
						goto overload55;
					}
				}
				else if(Z_TYPE_P(pos54) != IS_NULL)
				{
					goto overload55;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size54) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size54 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size54 TSRMLS_CC))->native_object;
					object_pointer54_4 = (wxSize*) argument_native_object;
					if (!object_pointer54_4 )
					{
						goto overload55;
					}
				}
				else if(Z_TYPE_P(size54) != IS_NULL)
				{
					goto overload55;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(validator54) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator54 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator54 TSRMLS_CC))->native_object;
					object_pointer54_6 = (wxValidator*) argument_native_object;
					if (!object_pointer54_6 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload55;
					}
				}
				else if(Z_TYPE_P(validator54) != IS_NULL)
				{
					goto overload55;
				}
			}

			overload54_called = true;
			already_called = true;
		}
	}

	//Overload 55
	overload55:
	if(!already_called && arguments_received >= 2  && arguments_received <= 8 && (current_object_type == PHP_WXFONTPICKERCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|OOOlos' (&parent55, &id55, &font55, php_wxFont_entry, &pos55, php_wxPoint_entry, &size55, php_wxSize_entry, &style55, &validator55, &name55, &name_len55)\n");
		#endif

		char parse_parameters_string[] = "zl|OOOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent55, &id55, &font55, php_wxFont_entry, &pos55, php_wxPoint_entry, &size55, php_wxSize_entry, &style55, &validator55, &name55, &name_len55 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent55) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent55 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent55 TSRMLS_CC))->native_object;
					object_pointer55_0 = (wxWindow*) argument_native_object;
					if (!object_pointer55_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload56;
					}
				}
				else if(Z_TYPE_P(parent55) != IS_NULL)
				{
					goto overload56;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(font55) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxFont*) zend_object_store_get_object(font55 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxFont*) zend_object_store_get_object(font55 TSRMLS_CC))->native_object;
					object_pointer55_2 = (wxFont*) argument_native_object;
					if (!object_pointer55_2 )
					{
						goto overload56;
					}
				}
				else if(Z_TYPE_P(font55) != IS_NULL)
				{
					goto overload56;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos55) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos55 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos55 TSRMLS_CC))->native_object;
					object_pointer55_3 = (wxPoint*) argument_native_object;
					if (!object_pointer55_3 )
					{
						goto overload56;
					}
				}
				else if(Z_TYPE_P(pos55) != IS_NULL)
				{
					goto overload56;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size55) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size55 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size55 TSRMLS_CC))->native_object;
					object_pointer55_4 = (wxSize*) argument_native_object;
					if (!object_pointer55_4 )
					{
						goto overload56;
					}
				}
				else if(Z_TYPE_P(size55) != IS_NULL)
				{
					goto overload56;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(validator55) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator55 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator55 TSRMLS_CC))->native_object;
					object_pointer55_6 = (wxValidator*) argument_native_object;
					if (!object_pointer55_6 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload56;
					}
				}
				else if(Z_TYPE_P(validator55) != IS_NULL)
				{
					goto overload56;
				}
			}

			overload55_called = true;
			already_called = true;
		}
	}

	//Overload 56
	overload56:
	if(!already_called && arguments_received >= 2  && arguments_received <= 10 && (current_object_type == PHP_WXFILEPICKERCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|sssOOlos' (&parent56, &id56, &path56, &path_len56, &message56, &message_len56, &wildcard56, &wildcard_len56, &pos56, php_wxPoint_entry, &size56, php_wxSize_entry, &style56, &validator56, &name56, &name_len56)\n");
		#endif

		char parse_parameters_string[] = "zl|sssOOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent56, &id56, &path56, &path_len56, &message56, &message_len56, &wildcard56, &wildcard_len56, &pos56, php_wxPoint_entry, &size56, php_wxSize_entry, &style56, &validator56, &name56, &name_len56 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent56) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent56 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent56 TSRMLS_CC))->native_object;
					object_pointer56_0 = (wxWindow*) argument_native_object;
					if (!object_pointer56_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload57;
					}
				}
				else if(Z_TYPE_P(parent56) != IS_NULL)
				{
					goto overload57;
				}
			}

			if(arguments_received >= 6){
				if(Z_TYPE_P(pos56) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos56 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos56 TSRMLS_CC))->native_object;
					object_pointer56_5 = (wxPoint*) argument_native_object;
					if (!object_pointer56_5 )
					{
						goto overload57;
					}
				}
				else if(Z_TYPE_P(pos56) != IS_NULL)
				{
					goto overload57;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(size56) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size56 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size56 TSRMLS_CC))->native_object;
					object_pointer56_6 = (wxSize*) argument_native_object;
					if (!object_pointer56_6 )
					{
						goto overload57;
					}
				}
				else if(Z_TYPE_P(size56) != IS_NULL)
				{
					goto overload57;
				}
			}

			if(arguments_received >= 9){
				if(Z_TYPE_P(validator56) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator56 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator56 TSRMLS_CC))->native_object;
					object_pointer56_8 = (wxValidator*) argument_native_object;
					if (!object_pointer56_8 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload57;
					}
				}
				else if(Z_TYPE_P(validator56) != IS_NULL)
				{
					goto overload57;
				}
			}

			overload56_called = true;
			already_called = true;
		}
	}

	//Overload 57
	overload57:
	if(!already_called && arguments_received >= 2  && arguments_received <= 9 && (current_object_type == PHP_WXDIRPICKERCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|ssOOlos' (&parent57, &id57, &path57, &path_len57, &message57, &message_len57, &pos57, php_wxPoint_entry, &size57, php_wxSize_entry, &style57, &validator57, &name57, &name_len57)\n");
		#endif

		char parse_parameters_string[] = "zl|ssOOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent57, &id57, &path57, &path_len57, &message57, &message_len57, &pos57, php_wxPoint_entry, &size57, php_wxSize_entry, &style57, &validator57, &name57, &name_len57 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent57) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent57 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent57 TSRMLS_CC))->native_object;
					object_pointer57_0 = (wxWindow*) argument_native_object;
					if (!object_pointer57_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload58;
					}
				}
				else if(Z_TYPE_P(parent57) != IS_NULL)
				{
					goto overload58;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(pos57) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos57 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos57 TSRMLS_CC))->native_object;
					object_pointer57_4 = (wxPoint*) argument_native_object;
					if (!object_pointer57_4 )
					{
						goto overload58;
					}
				}
				else if(Z_TYPE_P(pos57) != IS_NULL)
				{
					goto overload58;
				}
			}

			if(arguments_received >= 6){
				if(Z_TYPE_P(size57) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size57 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size57 TSRMLS_CC))->native_object;
					object_pointer57_5 = (wxSize*) argument_native_object;
					if (!object_pointer57_5 )
					{
						goto overload58;
					}
				}
				else if(Z_TYPE_P(size57) != IS_NULL)
				{
					goto overload58;
				}
			}

			if(arguments_received >= 8){
				if(Z_TYPE_P(validator57) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator57 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator57 TSRMLS_CC))->native_object;
					object_pointer57_7 = (wxValidator*) argument_native_object;
					if (!object_pointer57_7 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload58;
					}
				}
				else if(Z_TYPE_P(validator57) != IS_NULL)
				{
					goto overload58;
				}
			}

			overload57_called = true;
			already_called = true;
		}
	}

	//Overload 58
	overload58:
	if(!already_called && arguments_received >= 2  && arguments_received <= 8 && (current_object_type == PHP_WXTIMEPICKERCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|lOOlos' (&parent58, &id58, &dt58, &pos58, php_wxPoint_entry, &size58, php_wxSize_entry, &style58, &validator58, &name58, &name_len58)\n");
		#endif

		char parse_parameters_string[] = "zl|lOOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent58, &id58, &dt58, &pos58, php_wxPoint_entry, &size58, php_wxSize_entry, &style58, &validator58, &name58, &name_len58 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent58) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent58 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent58 TSRMLS_CC))->native_object;
					object_pointer58_0 = (wxWindow*) argument_native_object;
					if (!object_pointer58_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload59;
					}
				}
				else if(Z_TYPE_P(parent58) != IS_NULL)
				{
					goto overload59;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos58) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos58 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos58 TSRMLS_CC))->native_object;
					object_pointer58_3 = (wxPoint*) argument_native_object;
					if (!object_pointer58_3 )
					{
						goto overload59;
					}
				}
				else if(Z_TYPE_P(pos58) != IS_NULL)
				{
					goto overload59;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size58) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size58 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size58 TSRMLS_CC))->native_object;
					object_pointer58_4 = (wxSize*) argument_native_object;
					if (!object_pointer58_4 )
					{
						goto overload59;
					}
				}
				else if(Z_TYPE_P(size58) != IS_NULL)
				{
					goto overload59;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(validator58) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator58 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator58 TSRMLS_CC))->native_object;
					object_pointer58_6 = (wxValidator*) argument_native_object;
					if (!object_pointer58_6 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload59;
					}
				}
				else if(Z_TYPE_P(validator58) != IS_NULL)
				{
					goto overload59;
				}
			}

			overload58_called = true;
			already_called = true;
		}
	}

	//Overload 59
	overload59:
	if(!already_called && arguments_received >= 2  && arguments_received <= 8 && (current_object_type == PHP_WXDATEPICKERCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|lOOlos' (&parent59, &id59, &dt59, &pos59, php_wxPoint_entry, &size59, php_wxSize_entry, &style59, &validator59, &name59, &name_len59)\n");
		#endif

		char parse_parameters_string[] = "zl|lOOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent59, &id59, &dt59, &pos59, php_wxPoint_entry, &size59, php_wxSize_entry, &style59, &validator59, &name59, &name_len59 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent59) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent59 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent59 TSRMLS_CC))->native_object;
					object_pointer59_0 = (wxWindow*) argument_native_object;
					if (!object_pointer59_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload60;
					}
				}
				else if(Z_TYPE_P(parent59) != IS_NULL)
				{
					goto overload60;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos59) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos59 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos59 TSRMLS_CC))->native_object;
					object_pointer59_3 = (wxPoint*) argument_native_object;
					if (!object_pointer59_3 )
					{
						goto overload60;
					}
				}
				else if(Z_TYPE_P(pos59) != IS_NULL)
				{
					goto overload60;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size59) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size59 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size59 TSRMLS_CC))->native_object;
					object_pointer59_4 = (wxSize*) argument_native_object;
					if (!object_pointer59_4 )
					{
						goto overload60;
					}
				}
				else if(Z_TYPE_P(size59) != IS_NULL)
				{
					goto overload60;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(validator59) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator59 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator59 TSRMLS_CC))->native_object;
					object_pointer59_6 = (wxValidator*) argument_native_object;
					if (!object_pointer59_6 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload60;
					}
				}
				else if(Z_TYPE_P(validator59) != IS_NULL)
				{
					goto overload60;
				}
			}

			overload59_called = true;
			already_called = true;
		}
	}

	//Overload 60
	overload60:
	if(!already_called && arguments_received >= 3  && arguments_received <= 8 && (current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zls|OOlos' (&parent60, &id60, &label60, &label_len60, &pos60, php_wxPoint_entry, &size60, php_wxSize_entry, &style60, &validator60, &name60, &name_len60)\n");
		#endif

		char parse_parameters_string[] = "zls|OOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent60, &id60, &label60, &label_len60, &pos60, php_wxPoint_entry, &size60, php_wxSize_entry, &style60, &validator60, &name60, &name_len60 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent60) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent60 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent60 TSRMLS_CC))->native_object;
					object_pointer60_0 = (wxWindow*) argument_native_object;
					if (!object_pointer60_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload61;
					}
				}
				else if(Z_TYPE_P(parent60) != IS_NULL)
				{
					goto overload61;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos60) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos60 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos60 TSRMLS_CC))->native_object;
					object_pointer60_3 = (wxPoint*) argument_native_object;
					if (!object_pointer60_3 )
					{
						goto overload61;
					}
				}
				else if(Z_TYPE_P(pos60) != IS_NULL)
				{
					goto overload61;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size60) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size60 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size60 TSRMLS_CC))->native_object;
					object_pointer60_4 = (wxSize*) argument_native_object;
					if (!object_pointer60_4 )
					{
						goto overload61;
					}
				}
				else if(Z_TYPE_P(size60) != IS_NULL)
				{
					goto overload61;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(validator60) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator60 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator60 TSRMLS_CC))->native_object;
					object_pointer60_6 = (wxValidator*) argument_native_object;
					if (!object_pointer60_6 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload61;
					}
				}
				else if(Z_TYPE_P(validator60) != IS_NULL)
				{
					goto overload61;
				}
			}

			overload60_called = true;
			already_called = true;
		}
	}

	//Overload 61
	overload61:
	if(!already_called && arguments_received >= 1  && arguments_received <= 8 && (current_object_type == PHP_WXCOMBOCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lsOOlos' (&parent61, &id61, &value61, &value_len61, &pos61, php_wxPoint_entry, &size61, php_wxSize_entry, &style61, &validator61, &name61, &name_len61)\n");
		#endif

		char parse_parameters_string[] = "z|lsOOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent61, &id61, &value61, &value_len61, &pos61, php_wxPoint_entry, &size61, php_wxSize_entry, &style61, &validator61, &name61, &name_len61 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent61) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent61 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent61 TSRMLS_CC))->native_object;
					object_pointer61_0 = (wxWindow*) argument_native_object;
					if (!object_pointer61_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload62;
					}
				}
				else if(Z_TYPE_P(parent61) != IS_NULL)
				{
					goto overload62;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos61) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos61 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos61 TSRMLS_CC))->native_object;
					object_pointer61_3 = (wxPoint*) argument_native_object;
					if (!object_pointer61_3 )
					{
						goto overload62;
					}
				}
				else if(Z_TYPE_P(pos61) != IS_NULL)
				{
					goto overload62;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size61) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size61 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size61 TSRMLS_CC))->native_object;
					object_pointer61_4 = (wxSize*) argument_native_object;
					if (!object_pointer61_4 )
					{
						goto overload62;
					}
				}
				else if(Z_TYPE_P(size61) != IS_NULL)
				{
					goto overload62;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(validator61) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator61 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator61 TSRMLS_CC))->native_object;
					object_pointer61_6 = (wxValidator*) argument_native_object;
					if (!object_pointer61_6 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload62;
					}
				}
				else if(Z_TYPE_P(validator61) != IS_NULL)
				{
					goto overload62;
				}
			}

			overload61_called = true;
			already_called = true;
		}
	}

	//Overload 62
	overload62:
	if(!already_called && arguments_received >= 2  && arguments_received <= 7 && (current_object_type == PHP_WXDATAVIEWCTRL_TYPE || current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE || current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|OOlos' (&parent62, &id62, &pos62, php_wxPoint_entry, &size62, php_wxSize_entry, &style62, &validator62, &name62, &name_len62)\n");
		#endif

		char parse_parameters_string[] = "zl|OOlos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent62, &id62, &pos62, php_wxPoint_entry, &size62, php_wxSize_entry, &style62, &validator62, &name62, &name_len62 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent62) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent62 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent62 TSRMLS_CC))->native_object;
					object_pointer62_0 = (wxWindow*) argument_native_object;
					if (!object_pointer62_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload63;
					}
				}
				else if(Z_TYPE_P(parent62) != IS_NULL)
				{
					goto overload63;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos62) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos62 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos62 TSRMLS_CC))->native_object;
					object_pointer62_2 = (wxPoint*) argument_native_object;
					if (!object_pointer62_2 )
					{
						goto overload63;
					}
				}
				else if(Z_TYPE_P(pos62) != IS_NULL)
				{
					goto overload63;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size62) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size62 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size62 TSRMLS_CC))->native_object;
					object_pointer62_3 = (wxSize*) argument_native_object;
					if (!object_pointer62_3 )
					{
						goto overload63;
					}
				}
				else if(Z_TYPE_P(size62) != IS_NULL)
				{
					goto overload63;
				}
			}

			if(arguments_received >= 6){
				if(Z_TYPE_P(validator62) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator62 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator62 TSRMLS_CC))->native_object;
					object_pointer62_5 = (wxValidator*) argument_native_object;
					if (!object_pointer62_5 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload63;
					}
				}
				else if(Z_TYPE_P(validator62) != IS_NULL)
				{
					goto overload63;
				}
			}

			overload62_called = true;
			already_called = true;
		}
	}

	//Overload 63
	overload63:
	if(!already_called && arguments_received >= 2  && arguments_received <= 6 && (current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|OOlo' (&parent63, &id63, &pos63, php_wxPoint_entry, &size63, php_wxSize_entry, &style63, &validator63)\n");
		#endif

		char parse_parameters_string[] = "zl|OOlo";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent63, &id63, &pos63, php_wxPoint_entry, &size63, php_wxSize_entry, &style63, &validator63 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent63) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent63 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent63 TSRMLS_CC))->native_object;
					object_pointer63_0 = (wxWindow*) argument_native_object;
					if (!object_pointer63_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload64;
					}
				}
				else if(Z_TYPE_P(parent63) != IS_NULL)
				{
					goto overload64;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos63) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos63 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos63 TSRMLS_CC))->native_object;
					object_pointer63_2 = (wxPoint*) argument_native_object;
					if (!object_pointer63_2 )
					{
						goto overload64;
					}
				}
				else if(Z_TYPE_P(pos63) != IS_NULL)
				{
					goto overload64;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size63) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size63 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size63 TSRMLS_CC))->native_object;
					object_pointer63_3 = (wxSize*) argument_native_object;
					if (!object_pointer63_3 )
					{
						goto overload64;
					}
				}
				else if(Z_TYPE_P(size63) != IS_NULL)
				{
					goto overload64;
				}
			}

			if(arguments_received >= 6){
				if(Z_TYPE_P(validator63) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator63 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator63 TSRMLS_CC))->native_object;
					object_pointer63_5 = (wxValidator*) argument_native_object;
					if (!object_pointer63_5 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload64;
					}
				}
				else if(Z_TYPE_P(validator63) != IS_NULL)
				{
					goto overload64;
				}
			}

			overload63_called = true;
			already_called = true;
		}
	}

	//Overload 64
	overload64:
	if(!already_called && arguments_received >= 2  && arguments_received <= 6 && (current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|OOlo' (&parent64, &id64, &pos64, php_wxPoint_entry, &size64, php_wxSize_entry, &style64, &validator64)\n");
		#endif

		char parse_parameters_string[] = "zl|OOlo";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent64, &id64, &pos64, php_wxPoint_entry, &size64, php_wxSize_entry, &style64, &validator64 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent64) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent64 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent64 TSRMLS_CC))->native_object;
					object_pointer64_0 = (wxWindow*) argument_native_object;
					if (!object_pointer64_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload65;
					}
				}
				else if(Z_TYPE_P(parent64) != IS_NULL)
				{
					goto overload65;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos64) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos64 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos64 TSRMLS_CC))->native_object;
					object_pointer64_2 = (wxPoint*) argument_native_object;
					if (!object_pointer64_2 )
					{
						goto overload65;
					}
				}
				else if(Z_TYPE_P(pos64) != IS_NULL)
				{
					goto overload65;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size64) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size64 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size64 TSRMLS_CC))->native_object;
					object_pointer64_3 = (wxSize*) argument_native_object;
					if (!object_pointer64_3 )
					{
						goto overload65;
					}
				}
				else if(Z_TYPE_P(size64) != IS_NULL)
				{
					goto overload65;
				}
			}

			if(arguments_received >= 6){
				if(Z_TYPE_P(validator64) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator64 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator64 TSRMLS_CC))->native_object;
					object_pointer64_5 = (wxValidator*) argument_native_object;
					if (!object_pointer64_5 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload65;
					}
				}
				else if(Z_TYPE_P(validator64) != IS_NULL)
				{
					goto overload65;
				}
			}

			overload64_called = true;
			already_called = true;
		}
	}

	//Overload 65
	overload65:
	if(!already_called && arguments_received >= 2  && arguments_received <= 9 && (current_object_type == PHP_WXFILECTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|ssslOOs' (&parent65, &id65, &defaultDirectory65, &defaultDirectory_len65, &defaultFilename65, &defaultFilename_len65, &wildCard65, &wildCard_len65, &style65, &pos65, php_wxPoint_entry, &size65, php_wxSize_entry, &name65, &name_len65)\n");
		#endif

		char parse_parameters_string[] = "zl|ssslOOs";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent65, &id65, &defaultDirectory65, &defaultDirectory_len65, &defaultFilename65, &defaultFilename_len65, &wildCard65, &wildCard_len65, &style65, &pos65, php_wxPoint_entry, &size65, php_wxSize_entry, &name65, &name_len65 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent65) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent65 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent65 TSRMLS_CC))->native_object;
					object_pointer65_0 = (wxWindow*) argument_native_object;
					if (!object_pointer65_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload66;
					}
				}
				else if(Z_TYPE_P(parent65) != IS_NULL)
				{
					goto overload66;
				}
			}

			if(arguments_received >= 7){
				if(Z_TYPE_P(pos65) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos65 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos65 TSRMLS_CC))->native_object;
					object_pointer65_6 = (wxPoint*) argument_native_object;
					if (!object_pointer65_6 )
					{
						goto overload66;
					}
				}
				else if(Z_TYPE_P(pos65) != IS_NULL)
				{
					goto overload66;
				}
			}

			if(arguments_received >= 8){
				if(Z_TYPE_P(size65) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size65 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size65 TSRMLS_CC))->native_object;
					object_pointer65_7 = (wxSize*) argument_native_object;
					if (!object_pointer65_7 )
					{
						goto overload66;
					}
				}
				else if(Z_TYPE_P(size65) != IS_NULL)
				{
					goto overload66;
				}
			}

			overload65_called = true;
			already_called = true;
		}
	}

	//Overload 66
	overload66:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2 && (current_object_type == PHP_WXINFOBAR_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|l' (&parent66, &winid66)\n");
		#endif

		char parse_parameters_string[] = "z|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent66, &winid66 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent66) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent66 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent66 TSRMLS_CC))->native_object;
					object_pointer66_0 = (wxWindow*) argument_native_object;
					if (!object_pointer66_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload67;
					}
				}
				else if(Z_TYPE_P(parent66) != IS_NULL)
				{
					goto overload67;
				}
			}

			overload66_called = true;
			already_called = true;
		}
	}

	//Overload 67
	overload67:
	if(!already_called && arguments_received >= 1  && arguments_received <= 5 && (current_object_type == PHP_WXRIBBONBAR_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lOOl' (&parent67, &id67, &pos67, php_wxPoint_entry, &size67, php_wxSize_entry, &style67)\n");
		#endif

		char parse_parameters_string[] = "z|lOOl";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent67, &id67, &pos67, php_wxPoint_entry, &size67, php_wxSize_entry, &style67 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent67) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent67 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent67 TSRMLS_CC))->native_object;
					object_pointer67_0 = (wxWindow*) argument_native_object;
					if (!object_pointer67_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload68;
					}
				}
				else if(Z_TYPE_P(parent67) != IS_NULL)
				{
					goto overload68;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos67) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos67 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos67 TSRMLS_CC))->native_object;
					object_pointer67_2 = (wxPoint*) argument_native_object;
					if (!object_pointer67_2 )
					{
						goto overload68;
					}
				}
				else if(Z_TYPE_P(pos67) != IS_NULL)
				{
					goto overload68;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size67) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size67 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size67 TSRMLS_CC))->native_object;
					object_pointer67_3 = (wxSize*) argument_native_object;
					if (!object_pointer67_3 )
					{
						goto overload68;
					}
				}
				else if(Z_TYPE_P(size67) != IS_NULL)
				{
					goto overload68;
				}
			}

			overload67_called = true;
			already_called = true;
		}
	}

	//Overload 68
	overload68:
	if(!already_called && arguments_received >= 1  && arguments_received <= 5 && (current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lOOl' (&parent68, &id68, &pos68, php_wxPoint_entry, &size68, php_wxSize_entry, &style68)\n");
		#endif

		char parse_parameters_string[] = "z|lOOl";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent68, &id68, &pos68, php_wxPoint_entry, &size68, php_wxSize_entry, &style68 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent68) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent68 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent68 TSRMLS_CC))->native_object;
					object_pointer68_0 = (wxWindow*) argument_native_object;
					if (!object_pointer68_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload69;
					}
				}
				else if(Z_TYPE_P(parent68) != IS_NULL)
				{
					goto overload69;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos68) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos68 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos68 TSRMLS_CC))->native_object;
					object_pointer68_2 = (wxPoint*) argument_native_object;
					if (!object_pointer68_2 )
					{
						goto overload69;
					}
				}
				else if(Z_TYPE_P(pos68) != IS_NULL)
				{
					goto overload69;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size68) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size68 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size68 TSRMLS_CC))->native_object;
					object_pointer68_3 = (wxSize*) argument_native_object;
					if (!object_pointer68_3 )
					{
						goto overload69;
					}
				}
				else if(Z_TYPE_P(size68) != IS_NULL)
				{
					goto overload69;
				}
			}

			overload68_called = true;
			already_called = true;
		}
	}

	//Overload 69
	overload69:
	if(!already_called && arguments_received >= 1  && arguments_received <= 5 && (current_object_type == PHP_WXRIBBONGALLERY_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lOOl' (&parent69, &id69, &pos69, php_wxPoint_entry, &size69, php_wxSize_entry, &style69)\n");
		#endif

		char parse_parameters_string[] = "z|lOOl";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent69, &id69, &pos69, php_wxPoint_entry, &size69, php_wxSize_entry, &style69 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent69) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent69 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent69 TSRMLS_CC))->native_object;
					object_pointer69_0 = (wxWindow*) argument_native_object;
					if (!object_pointer69_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload70;
					}
				}
				else if(Z_TYPE_P(parent69) != IS_NULL)
				{
					goto overload70;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos69) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos69 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos69 TSRMLS_CC))->native_object;
					object_pointer69_2 = (wxPoint*) argument_native_object;
					if (!object_pointer69_2 )
					{
						goto overload70;
					}
				}
				else if(Z_TYPE_P(pos69) != IS_NULL)
				{
					goto overload70;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size69) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size69 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size69 TSRMLS_CC))->native_object;
					object_pointer69_3 = (wxSize*) argument_native_object;
					if (!object_pointer69_3 )
					{
						goto overload70;
					}
				}
				else if(Z_TYPE_P(size69) != IS_NULL)
				{
					goto overload70;
				}
			}

			overload69_called = true;
			already_called = true;
		}
	}

	//Overload 70
	overload70:
	if(!already_called && arguments_received >= 1  && arguments_received <= 5 && (current_object_type == PHP_WXRIBBONPAGE_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lsOl' (&parent70, &id70, &label70, &label_len70, &icon70, php_wxBitmap_entry, &style70)\n");
		#endif

		char parse_parameters_string[] = "z|lsOl";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent70, &id70, &label70, &label_len70, &icon70, php_wxBitmap_entry, &style70 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent70) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxRibbonBar*) zend_object_store_get_object(parent70 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxRibbonBar*) zend_object_store_get_object(parent70 TSRMLS_CC))->native_object;
					object_pointer70_0 = (wxRibbonBar*) argument_native_object;
					if (!object_pointer70_0 || (argument_type != PHP_WXRIBBONBAR_TYPE))
					{
						goto overload71;
					}
				}
				else if(Z_TYPE_P(parent70) != IS_NULL)
				{
					goto overload71;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(icon70) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(icon70 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(icon70 TSRMLS_CC))->native_object;
					object_pointer70_3 = (wxBitmap*) argument_native_object;
					if (!object_pointer70_3 )
					{
						goto overload71;
					}
				}
				else if(Z_TYPE_P(icon70) != IS_NULL)
				{
					goto overload71;
				}
			}

			overload70_called = true;
			already_called = true;
		}
	}

	//Overload 71
	overload71:
	if(!already_called && arguments_received >= 1  && arguments_received <= 7 && (current_object_type == PHP_WXRIBBONPANEL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lsOOOl' (&parent71, &id71, &label71, &label_len71, &icon71, php_wxBitmap_entry, &pos71, php_wxPoint_entry, &size71, php_wxSize_entry, &style71)\n");
		#endif

		char parse_parameters_string[] = "z|lsOOOl";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent71, &id71, &label71, &label_len71, &icon71, php_wxBitmap_entry, &pos71, php_wxPoint_entry, &size71, php_wxSize_entry, &style71 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent71) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent71 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent71 TSRMLS_CC))->native_object;
					object_pointer71_0 = (wxWindow*) argument_native_object;
					if (!object_pointer71_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload72;
					}
				}
				else if(Z_TYPE_P(parent71) != IS_NULL)
				{
					goto overload72;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(icon71) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(icon71 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(icon71 TSRMLS_CC))->native_object;
					object_pointer71_3 = (wxBitmap*) argument_native_object;
					if (!object_pointer71_3 )
					{
						goto overload72;
					}
				}
				else if(Z_TYPE_P(icon71) != IS_NULL)
				{
					goto overload72;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(pos71) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos71 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos71 TSRMLS_CC))->native_object;
					object_pointer71_4 = (wxPoint*) argument_native_object;
					if (!object_pointer71_4 )
					{
						goto overload72;
					}
				}
				else if(Z_TYPE_P(pos71) != IS_NULL)
				{
					goto overload72;
				}
			}

			if(arguments_received >= 6){
				if(Z_TYPE_P(size71) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size71 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size71 TSRMLS_CC))->native_object;
					object_pointer71_5 = (wxSize*) argument_native_object;
					if (!object_pointer71_5 )
					{
						goto overload72;
					}
				}
				else if(Z_TYPE_P(size71) != IS_NULL)
				{
					goto overload72;
				}
			}

			overload71_called = true;
			already_called = true;
		}
	}

	//Overload 72
	overload72:
	if(!already_called && arguments_received >= 1  && arguments_received <= 5 && (current_object_type == PHP_WXRIBBONTOOLBAR_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|lOOl' (&parent72, &id72, &pos72, php_wxPoint_entry, &size72, php_wxSize_entry, &style72)\n");
		#endif

		char parse_parameters_string[] = "z|lOOl";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent72, &id72, &pos72, php_wxPoint_entry, &size72, php_wxSize_entry, &style72 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent72) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent72 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent72 TSRMLS_CC))->native_object;
					object_pointer72_0 = (wxWindow*) argument_native_object;
					if (!object_pointer72_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload73;
					}
				}
				else if(Z_TYPE_P(parent72) != IS_NULL)
				{
					goto overload73;
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos72) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos72 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos72 TSRMLS_CC))->native_object;
					object_pointer72_2 = (wxPoint*) argument_native_object;
					if (!object_pointer72_2 )
					{
						goto overload73;
					}
				}
				else if(Z_TYPE_P(pos72) != IS_NULL)
				{
					goto overload73;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size72) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size72 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size72 TSRMLS_CC))->native_object;
					object_pointer72_3 = (wxSize*) argument_native_object;
					if (!object_pointer72_3 )
					{
						goto overload73;
					}
				}
				else if(Z_TYPE_P(size72) != IS_NULL)
				{
					goto overload73;
				}
			}

			overload72_called = true;
			already_called = true;
		}
	}

	//Overload 73
	overload73:
	if(!already_called && arguments_received >= 2  && arguments_received <= 7 && (current_object_type == PHP_WXWEBVIEW_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|sOOls' (&parent73, &id73, &url73, &url_len73, &pos73, php_wxPoint_entry, &size73, php_wxSize_entry, &style73, &name73, &name_len73)\n");
		#endif

		char parse_parameters_string[] = "zl|sOOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent73, &id73, &url73, &url_len73, &pos73, php_wxPoint_entry, &size73, php_wxSize_entry, &style73, &name73, &name_len73 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent73) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent73 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent73 TSRMLS_CC))->native_object;
					object_pointer73_0 = (wxWindow*) argument_native_object;
					if (!object_pointer73_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload74;
					}
				}
				else if(Z_TYPE_P(parent73) != IS_NULL)
				{
					goto overload74;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos73) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos73 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos73 TSRMLS_CC))->native_object;
					object_pointer73_3 = (wxPoint*) argument_native_object;
					if (!object_pointer73_3 )
					{
						goto overload74;
					}
				}
				else if(Z_TYPE_P(pos73) != IS_NULL)
				{
					goto overload74;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size73) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size73 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size73 TSRMLS_CC))->native_object;
					object_pointer73_4 = (wxSize*) argument_native_object;
					if (!object_pointer73_4 )
					{
						goto overload74;
					}
				}
				else if(Z_TYPE_P(size73) != IS_NULL)
				{
					goto overload74;
				}
			}

			overload73_called = true;
			already_called = true;
		}
	}

	//Overload 74
	overload74:
	if(!already_called && arguments_received >= 2  && arguments_received <= 9 && (current_object_type == PHP_WXMEDIACTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|sOOlsos' (&parent74, &id74, &fileName74, &fileName_len74, &pos74, php_wxPoint_entry, &size74, php_wxSize_entry, &style74, &szBackend74, &szBackend_len74, &validator74, &name74, &name_len74)\n");
		#endif

		char parse_parameters_string[] = "zl|sOOlsos";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent74, &id74, &fileName74, &fileName_len74, &pos74, php_wxPoint_entry, &size74, php_wxSize_entry, &style74, &szBackend74, &szBackend_len74, &validator74, &name74, &name_len74 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent74) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent74 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent74 TSRMLS_CC))->native_object;
					object_pointer74_0 = (wxWindow*) argument_native_object;
					if (!object_pointer74_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload75;
					}
				}
				else if(Z_TYPE_P(parent74) != IS_NULL)
				{
					goto overload75;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos74) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos74 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos74 TSRMLS_CC))->native_object;
					object_pointer74_3 = (wxPoint*) argument_native_object;
					if (!object_pointer74_3 )
					{
						goto overload75;
					}
				}
				else if(Z_TYPE_P(pos74) != IS_NULL)
				{
					goto overload75;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size74) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size74 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size74 TSRMLS_CC))->native_object;
					object_pointer74_4 = (wxSize*) argument_native_object;
					if (!object_pointer74_4 )
					{
						goto overload75;
					}
				}
				else if(Z_TYPE_P(size74) != IS_NULL)
				{
					goto overload75;
				}
			}

			if(arguments_received >= 8){
				if(Z_TYPE_P(validator74) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxValidator*) zend_object_store_get_object(validator74 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxValidator*) zend_object_store_get_object(validator74 TSRMLS_CC))->native_object;
					object_pointer74_7 = (wxValidator*) argument_native_object;
					if (!object_pointer74_7 || (argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE))
					{
						goto overload75;
					}
				}
				else if(Z_TYPE_P(validator74) != IS_NULL)
				{
					goto overload75;
				}
			}

			overload74_called = true;
			already_called = true;
		}
	}

	//Overload 75
	overload75:
	if(!already_called && arguments_received >= 3  && arguments_received <= 7 && (current_object_type == PHP_WXEDITABLELISTBOX_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zls|OOls' (&parent75, &id75, &label75, &label_len75, &pos75, php_wxPoint_entry, &size75, php_wxSize_entry, &style75, &name75, &name_len75)\n");
		#endif

		char parse_parameters_string[] = "zls|OOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent75, &id75, &label75, &label_len75, &pos75, php_wxPoint_entry, &size75, php_wxSize_entry, &style75, &name75, &name_len75 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent75) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent75 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent75 TSRMLS_CC))->native_object;
					object_pointer75_0 = (wxWindow*) argument_native_object;
					if (!object_pointer75_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload76;
					}
				}
				else if(Z_TYPE_P(parent75) != IS_NULL)
				{
					goto overload76;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos75) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos75 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos75 TSRMLS_CC))->native_object;
					object_pointer75_3 = (wxPoint*) argument_native_object;
					if (!object_pointer75_3 )
					{
						goto overload76;
					}
				}
				else if(Z_TYPE_P(pos75) != IS_NULL)
				{
					goto overload76;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size75) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size75 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size75 TSRMLS_CC))->native_object;
					object_pointer75_4 = (wxSize*) argument_native_object;
					if (!object_pointer75_4 )
					{
						goto overload76;
					}
				}
				else if(Z_TYPE_P(size75) != IS_NULL)
				{
					goto overload76;
				}
			}

			overload75_called = true;
			already_called = true;
		}
	}

	//Overload 76
	overload76:
	if(!already_called && arguments_received >= 2  && arguments_received <= 7 && (current_object_type == PHP_WXBANNERWINDOW_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|lOOls' (&parent76, &winid76, &dir76, &pos76, php_wxPoint_entry, &size76, php_wxSize_entry, &style76, &name76, &name_len76)\n");
		#endif

		char parse_parameters_string[] = "zl|lOOls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent76, &winid76, &dir76, &pos76, php_wxPoint_entry, &size76, php_wxSize_entry, &style76, &name76, &name_len76 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent76) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent76 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent76 TSRMLS_CC))->native_object;
					object_pointer76_0 = (wxWindow*) argument_native_object;
					if (!object_pointer76_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						goto overload77;
					}
				}
				else if(Z_TYPE_P(parent76) != IS_NULL)
				{
					goto overload77;
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(pos76) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos76 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos76 TSRMLS_CC))->native_object;
					object_pointer76_3 = (wxPoint*) argument_native_object;
					if (!object_pointer76_3 )
					{
						goto overload77;
					}
				}
				else if(Z_TYPE_P(pos76) != IS_NULL)
				{
					goto overload77;
				}
			}

			if(arguments_received >= 5){
				if(Z_TYPE_P(size76) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size76 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size76 TSRMLS_CC))->native_object;
					object_pointer76_4 = (wxSize*) argument_native_object;
					if (!object_pointer76_4 )
					{
						goto overload77;
					}
				}
				else if(Z_TYPE_P(size76) != IS_NULL)
				{
					goto overload77;
				}
			}

			overload76_called = true;
			already_called = true;
		}
	}

	//Overload 77
	overload77:
	if(!already_called && arguments_received >= 2  && arguments_received <= 6 && (current_object_type == PHP_WXHTMLHELPWINDOW_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zl|OOll' (&parent77, &id77, &pos77, php_wxPoint_entry, &size77, php_wxSize_entry, &style77, &helpStyle77)\n");
		#endif

		char parse_parameters_string[] = "zl|OOll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent77, &id77, &pos77, php_wxPoint_entry, &size77, php_wxSize_entry, &style77, &helpStyle77 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent77) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent77 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent77 TSRMLS_CC))->native_object;
					object_pointer77_0 = (wxWindow*) argument_native_object;
					if (!object_pointer77_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent77) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(pos77) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos77 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos77 TSRMLS_CC))->native_object;
					object_pointer77_2 = (wxPoint*) argument_native_object;
					if (!object_pointer77_2 )
					{
						zend_error(E_ERROR, "Parameter 'pos' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(pos77) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'pos' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(size77) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size77 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size77 TSRMLS_CC))->native_object;
					object_pointer77_3 = (wxSize*) argument_native_object;
					if (!object_pointer77_3 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size77) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload77_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0));

				references->AddReference(parent0, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2));

				references->AddReference(parent0, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(pos0, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3));

				references->AddReference(parent0, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos0, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(size0, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0));

				references->AddReference(parent0, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos0, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size0, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0, wxString(name0, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->Create((wxWindow*) object_pointer0_0, (wxWindowID) id0, *(wxPoint*) object_pointer0_2, *(wxSize*) object_pointer0_3, (long) style0, wxString(name0, wxConvUTF8)));

				references->AddReference(parent0, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos0, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size0, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTopLevelWindow::Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(title1, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTopLevelWindow_php*)native_object)->Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(title1, wxConvUTF8)));

				references->AddReference(parent1, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTopLevelWindow::Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(title1, wxConvUTF8), *(wxPoint*) object_pointer1_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTopLevelWindow_php*)native_object)->Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(title1, wxConvUTF8), *(wxPoint*) object_pointer1_3));

				references->AddReference(parent1, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos1, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTopLevelWindow::Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(title1, wxConvUTF8), *(wxPoint*) object_pointer1_3, *(wxSize*) object_pointer1_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTopLevelWindow_php*)native_object)->Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(title1, wxConvUTF8), *(wxPoint*) object_pointer1_3, *(wxSize*) object_pointer1_4));

				references->AddReference(parent1, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos1, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size1, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTopLevelWindow::Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(title1, wxConvUTF8), *(wxPoint*) object_pointer1_3, *(wxSize*) object_pointer1_4, (long) style1))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTopLevelWindow_php*)native_object)->Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(title1, wxConvUTF8), *(wxPoint*) object_pointer1_3, *(wxSize*) object_pointer1_4, (long) style1));

				references->AddReference(parent1, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos1, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size1, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTopLevelWindow::Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(title1, wxConvUTF8), *(wxPoint*) object_pointer1_3, *(wxSize*) object_pointer1_4, (long) style1, wxString(name1, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTopLevelWindow_php*)native_object)->Create((wxWindow*) object_pointer1_0, (wxWindowID) id1, wxString(title1, wxConvUTF8), *(wxPoint*) object_pointer1_3, *(wxSize*) object_pointer1_4, (long) style1, wxString(name1, wxConvUTF8)));

				references->AddReference(parent1, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos1, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size1, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload2_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFrame::Create((wxWindow*) object_pointer2_0, (wxWindowID) id2, wxString(title2, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFrame_php*)native_object)->Create((wxWindow*) object_pointer2_0, (wxWindowID) id2, wxString(title2, wxConvUTF8)));

				references->AddReference(parent2, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFrame::Create((wxWindow*) object_pointer2_0, (wxWindowID) id2, wxString(title2, wxConvUTF8), *(wxPoint*) object_pointer2_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFrame_php*)native_object)->Create((wxWindow*) object_pointer2_0, (wxWindowID) id2, wxString(title2, wxConvUTF8), *(wxPoint*) object_pointer2_3));

				references->AddReference(parent2, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos2, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFrame::Create((wxWindow*) object_pointer2_0, (wxWindowID) id2, wxString(title2, wxConvUTF8), *(wxPoint*) object_pointer2_3, *(wxSize*) object_pointer2_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFrame_php*)native_object)->Create((wxWindow*) object_pointer2_0, (wxWindowID) id2, wxString(title2, wxConvUTF8), *(wxPoint*) object_pointer2_3, *(wxSize*) object_pointer2_4));

				references->AddReference(parent2, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos2, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size2, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFrame::Create((wxWindow*) object_pointer2_0, (wxWindowID) id2, wxString(title2, wxConvUTF8), *(wxPoint*) object_pointer2_3, *(wxSize*) object_pointer2_4, (long) style2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFrame_php*)native_object)->Create((wxWindow*) object_pointer2_0, (wxWindowID) id2, wxString(title2, wxConvUTF8), *(wxPoint*) object_pointer2_3, *(wxSize*) object_pointer2_4, (long) style2));

				references->AddReference(parent2, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos2, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size2, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFrame::Create((wxWindow*) object_pointer2_0, (wxWindowID) id2, wxString(title2, wxConvUTF8), *(wxPoint*) object_pointer2_3, *(wxSize*) object_pointer2_4, (long) style2, wxString(name2, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFrame_php*)native_object)->Create((wxWindow*) object_pointer2_0, (wxWindowID) id2, wxString(title2, wxConvUTF8), *(wxPoint*) object_pointer2_3, *(wxSize*) object_pointer2_4, (long) style2, wxString(name2, wxConvUTF8)));

				references->AddReference(parent2, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos2, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size2, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload3_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMDIChildFrame::Create((wxMDIParentFrame*) object_pointer3_0, (wxWindowID) id3, wxString(title3, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMDIChildFrame_php*)native_object)->Create((wxMDIParentFrame*) object_pointer3_0, (wxWindowID) id3, wxString(title3, wxConvUTF8)));

				references->AddReference(parent3, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMDIChildFrame::Create((wxMDIParentFrame*) object_pointer3_0, (wxWindowID) id3, wxString(title3, wxConvUTF8), *(wxPoint*) object_pointer3_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMDIChildFrame_php*)native_object)->Create((wxMDIParentFrame*) object_pointer3_0, (wxWindowID) id3, wxString(title3, wxConvUTF8), *(wxPoint*) object_pointer3_3));

				references->AddReference(parent3, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos3, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMDIChildFrame::Create((wxMDIParentFrame*) object_pointer3_0, (wxWindowID) id3, wxString(title3, wxConvUTF8), *(wxPoint*) object_pointer3_3, *(wxSize*) object_pointer3_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMDIChildFrame_php*)native_object)->Create((wxMDIParentFrame*) object_pointer3_0, (wxWindowID) id3, wxString(title3, wxConvUTF8), *(wxPoint*) object_pointer3_3, *(wxSize*) object_pointer3_4));

				references->AddReference(parent3, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos3, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size3, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMDIChildFrame::Create((wxMDIParentFrame*) object_pointer3_0, (wxWindowID) id3, wxString(title3, wxConvUTF8), *(wxPoint*) object_pointer3_3, *(wxSize*) object_pointer3_4, (long) style3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMDIChildFrame_php*)native_object)->Create((wxMDIParentFrame*) object_pointer3_0, (wxWindowID) id3, wxString(title3, wxConvUTF8), *(wxPoint*) object_pointer3_3, *(wxSize*) object_pointer3_4, (long) style3));

				references->AddReference(parent3, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos3, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size3, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMDIChildFrame::Create((wxMDIParentFrame*) object_pointer3_0, (wxWindowID) id3, wxString(title3, wxConvUTF8), *(wxPoint*) object_pointer3_3, *(wxSize*) object_pointer3_4, (long) style3, wxString(name3, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMDIChildFrame_php*)native_object)->Create((wxMDIParentFrame*) object_pointer3_0, (wxWindowID) id3, wxString(title3, wxConvUTF8), *(wxPoint*) object_pointer3_3, *(wxSize*) object_pointer3_4, (long) style3, wxString(name3, wxConvUTF8)));

				references->AddReference(parent3, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos3, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size3, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload4_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMDIParentFrame::Create((wxWindow*) object_pointer4_0, (wxWindowID) id4, wxString(title4, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMDIParentFrame_php*)native_object)->Create((wxWindow*) object_pointer4_0, (wxWindowID) id4, wxString(title4, wxConvUTF8)));

				references->AddReference(parent4, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMDIParentFrame::Create((wxWindow*) object_pointer4_0, (wxWindowID) id4, wxString(title4, wxConvUTF8), *(wxPoint*) object_pointer4_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMDIParentFrame_php*)native_object)->Create((wxWindow*) object_pointer4_0, (wxWindowID) id4, wxString(title4, wxConvUTF8), *(wxPoint*) object_pointer4_3));

				references->AddReference(parent4, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos4, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMDIParentFrame::Create((wxWindow*) object_pointer4_0, (wxWindowID) id4, wxString(title4, wxConvUTF8), *(wxPoint*) object_pointer4_3, *(wxSize*) object_pointer4_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMDIParentFrame_php*)native_object)->Create((wxWindow*) object_pointer4_0, (wxWindowID) id4, wxString(title4, wxConvUTF8), *(wxPoint*) object_pointer4_3, *(wxSize*) object_pointer4_4));

				references->AddReference(parent4, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos4, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size4, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMDIParentFrame::Create((wxWindow*) object_pointer4_0, (wxWindowID) id4, wxString(title4, wxConvUTF8), *(wxPoint*) object_pointer4_3, *(wxSize*) object_pointer4_4, (long) style4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMDIParentFrame_php*)native_object)->Create((wxWindow*) object_pointer4_0, (wxWindowID) id4, wxString(title4, wxConvUTF8), *(wxPoint*) object_pointer4_3, *(wxSize*) object_pointer4_4, (long) style4));

				references->AddReference(parent4, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos4, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size4, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMDIParentFrame::Create((wxWindow*) object_pointer4_0, (wxWindowID) id4, wxString(title4, wxConvUTF8), *(wxPoint*) object_pointer4_3, *(wxSize*) object_pointer4_4, (long) style4, wxString(name4, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMDIParentFrame_php*)native_object)->Create((wxWindow*) object_pointer4_0, (wxWindowID) id4, wxString(title4, wxConvUTF8), *(wxPoint*) object_pointer4_3, *(wxSize*) object_pointer4_4, (long) style4, wxString(name4, wxConvUTF8)));

				references->AddReference(parent4, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos4, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size4, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload5_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMiniFrame::Create((wxWindow*) object_pointer5_0, (wxWindowID) id5, wxString(title5, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMiniFrame_php*)native_object)->Create((wxWindow*) object_pointer5_0, (wxWindowID) id5, wxString(title5, wxConvUTF8)));

				references->AddReference(parent5, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMiniFrame::Create((wxWindow*) object_pointer5_0, (wxWindowID) id5, wxString(title5, wxConvUTF8), *(wxPoint*) object_pointer5_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMiniFrame_php*)native_object)->Create((wxWindow*) object_pointer5_0, (wxWindowID) id5, wxString(title5, wxConvUTF8), *(wxPoint*) object_pointer5_3));

				references->AddReference(parent5, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos5, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMiniFrame::Create((wxWindow*) object_pointer5_0, (wxWindowID) id5, wxString(title5, wxConvUTF8), *(wxPoint*) object_pointer5_3, *(wxSize*) object_pointer5_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMiniFrame_php*)native_object)->Create((wxWindow*) object_pointer5_0, (wxWindowID) id5, wxString(title5, wxConvUTF8), *(wxPoint*) object_pointer5_3, *(wxSize*) object_pointer5_4));

				references->AddReference(parent5, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos5, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size5, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMiniFrame::Create((wxWindow*) object_pointer5_0, (wxWindowID) id5, wxString(title5, wxConvUTF8), *(wxPoint*) object_pointer5_3, *(wxSize*) object_pointer5_4, (long) style5))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMiniFrame_php*)native_object)->Create((wxWindow*) object_pointer5_0, (wxWindowID) id5, wxString(title5, wxConvUTF8), *(wxPoint*) object_pointer5_3, *(wxSize*) object_pointer5_4, (long) style5));

				references->AddReference(parent5, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos5, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size5, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMiniFrame::Create((wxWindow*) object_pointer5_0, (wxWindowID) id5, wxString(title5, wxConvUTF8), *(wxPoint*) object_pointer5_3, *(wxSize*) object_pointer5_4, (long) style5, wxString(name5, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMiniFrame_php*)native_object)->Create((wxWindow*) object_pointer5_0, (wxWindowID) id5, wxString(title5, wxConvUTF8), *(wxPoint*) object_pointer5_3, *(wxSize*) object_pointer5_4, (long) style5, wxString(name5, wxConvUTF8)));

				references->AddReference(parent5, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos5, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size5, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload6_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHtmlHelpDialog::Create((wxWindow*) object_pointer6_0, (wxWindowID) id6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxHtmlHelpDialog_php*)native_object)->Create((wxWindow*) object_pointer6_0, (wxWindowID) id6));

				references->AddReference(parent6, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHtmlHelpDialog::Create((wxWindow*) object_pointer6_0, (wxWindowID) id6, wxString(title6, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxHtmlHelpDialog_php*)native_object)->Create((wxWindow*) object_pointer6_0, (wxWindowID) id6, wxString(title6, wxConvUTF8)));

				references->AddReference(parent6, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHtmlHelpDialog::Create((wxWindow*) object_pointer6_0, (wxWindowID) id6, wxString(title6, wxConvUTF8), (int) style6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxHtmlHelpDialog_php*)native_object)->Create((wxWindow*) object_pointer6_0, (wxWindowID) id6, wxString(title6, wxConvUTF8), (int) style6));

				references->AddReference(parent6, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload7_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHtmlHelpFrame::Create((wxWindow*) object_pointer7_0, (wxWindowID) id7))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxHtmlHelpFrame_php*)native_object)->Create((wxWindow*) object_pointer7_0, (wxWindowID) id7));

				references->AddReference(parent7, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHtmlHelpFrame::Create((wxWindow*) object_pointer7_0, (wxWindowID) id7, wxString(title7, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxHtmlHelpFrame_php*)native_object)->Create((wxWindow*) object_pointer7_0, (wxWindowID) id7, wxString(title7, wxConvUTF8)));

				references->AddReference(parent7, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHtmlHelpFrame::Create((wxWindow*) object_pointer7_0, (wxWindowID) id7, wxString(title7, wxConvUTF8), (int) style7))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxHtmlHelpFrame_php*)native_object)->Create((wxWindow*) object_pointer7_0, (wxWindowID) id7, wxString(title7, wxConvUTF8), (int) style7));

				references->AddReference(parent7, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHtmlHelpFrame::Create((wxWindow*) object_pointer7_0, (wxWindowID) id7, wxString(title7, wxConvUTF8), (int) style7, (wxConfigBase*) object_pointer7_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxHtmlHelpFrame_php*)native_object)->Create((wxWindow*) object_pointer7_0, (wxWindowID) id7, wxString(title7, wxConvUTF8), (int) style7, (wxConfigBase*) object_pointer7_4));

				references->AddReference(parent7, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(config7, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHtmlHelpFrame::Create((wxWindow*) object_pointer7_0, (wxWindowID) id7, wxString(title7, wxConvUTF8), (int) style7, (wxConfigBase*) object_pointer7_4, wxString(rootpath7, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxHtmlHelpFrame_php*)native_object)->Create((wxWindow*) object_pointer7_0, (wxWindowID) id7, wxString(title7, wxConvUTF8), (int) style7, (wxConfigBase*) object_pointer7_4, wxString(rootpath7, wxConvUTF8)));

				references->AddReference(parent7, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(config7, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload8_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDialog::Create((wxWindow*) object_pointer8_0, (wxWindowID) id8, wxString(title8, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDialog_php*)native_object)->Create((wxWindow*) object_pointer8_0, (wxWindowID) id8, wxString(title8, wxConvUTF8)));

				references->AddReference(parent8, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDialog::Create((wxWindow*) object_pointer8_0, (wxWindowID) id8, wxString(title8, wxConvUTF8), *(wxPoint*) object_pointer8_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDialog_php*)native_object)->Create((wxWindow*) object_pointer8_0, (wxWindowID) id8, wxString(title8, wxConvUTF8), *(wxPoint*) object_pointer8_3));

				references->AddReference(parent8, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos8, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDialog::Create((wxWindow*) object_pointer8_0, (wxWindowID) id8, wxString(title8, wxConvUTF8), *(wxPoint*) object_pointer8_3, *(wxSize*) object_pointer8_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDialog_php*)native_object)->Create((wxWindow*) object_pointer8_0, (wxWindowID) id8, wxString(title8, wxConvUTF8), *(wxPoint*) object_pointer8_3, *(wxSize*) object_pointer8_4));

				references->AddReference(parent8, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos8, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size8, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDialog::Create((wxWindow*) object_pointer8_0, (wxWindowID) id8, wxString(title8, wxConvUTF8), *(wxPoint*) object_pointer8_3, *(wxSize*) object_pointer8_4, (long) style8))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDialog_php*)native_object)->Create((wxWindow*) object_pointer8_0, (wxWindowID) id8, wxString(title8, wxConvUTF8), *(wxPoint*) object_pointer8_3, *(wxSize*) object_pointer8_4, (long) style8));

				references->AddReference(parent8, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos8, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size8, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDialog::Create((wxWindow*) object_pointer8_0, (wxWindowID) id8, wxString(title8, wxConvUTF8), *(wxPoint*) object_pointer8_3, *(wxSize*) object_pointer8_4, (long) style8, wxString(name8, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDialog_php*)native_object)->Create((wxWindow*) object_pointer8_0, (wxWindowID) id8, wxString(title8, wxConvUTF8), *(wxPoint*) object_pointer8_3, *(wxSize*) object_pointer8_4, (long) style8, wxString(name8, wxConvUTF8)));

				references->AddReference(parent8, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos8, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size8, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload9_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFindReplaceDialog::Create((wxWindow*) object_pointer9_0, (wxFindReplaceData*) object_pointer9_1, wxString(title9, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFindReplaceDialog_php*)native_object)->Create((wxWindow*) object_pointer9_0, (wxFindReplaceData*) object_pointer9_1, wxString(title9, wxConvUTF8)));

				references->AddReference(parent9, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(data9, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFindReplaceDialog::Create((wxWindow*) object_pointer9_0, (wxFindReplaceData*) object_pointer9_1, wxString(title9, wxConvUTF8), (int) style9))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFindReplaceDialog_php*)native_object)->Create((wxWindow*) object_pointer9_0, (wxFindReplaceData*) object_pointer9_1, wxString(title9, wxConvUTF8), (int) style9));

				references->AddReference(parent9, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(data9, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload10_called)
	{
		switch(arguments_received)
		{
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSymbolPickerDialog::Create(wxString(symbol10, wxConvUTF8), wxString(initialFont10, wxConvUTF8), wxString(normalTextFont10, wxConvUTF8), (wxWindow*) object_pointer10_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSymbolPickerDialog_php*)native_object)->Create(wxString(symbol10, wxConvUTF8), wxString(initialFont10, wxConvUTF8), wxString(normalTextFont10, wxConvUTF8), (wxWindow*) object_pointer10_3));

				references->AddReference(parent10, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSymbolPickerDialog::Create(wxString(symbol10, wxConvUTF8), wxString(initialFont10, wxConvUTF8), wxString(normalTextFont10, wxConvUTF8), (wxWindow*) object_pointer10_3, (wxWindowID) id10))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSymbolPickerDialog_php*)native_object)->Create(wxString(symbol10, wxConvUTF8), wxString(initialFont10, wxConvUTF8), wxString(normalTextFont10, wxConvUTF8), (wxWindow*) object_pointer10_3, (wxWindowID) id10));

				references->AddReference(parent10, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSymbolPickerDialog::Create(wxString(symbol10, wxConvUTF8), wxString(initialFont10, wxConvUTF8), wxString(normalTextFont10, wxConvUTF8), (wxWindow*) object_pointer10_3, (wxWindowID) id10, wxString(caption10, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSymbolPickerDialog_php*)native_object)->Create(wxString(symbol10, wxConvUTF8), wxString(initialFont10, wxConvUTF8), wxString(normalTextFont10, wxConvUTF8), (wxWindow*) object_pointer10_3, (wxWindowID) id10, wxString(caption10, wxConvUTF8)));

				references->AddReference(parent10, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSymbolPickerDialog::Create(wxString(symbol10, wxConvUTF8), wxString(initialFont10, wxConvUTF8), wxString(normalTextFont10, wxConvUTF8), (wxWindow*) object_pointer10_3, (wxWindowID) id10, wxString(caption10, wxConvUTF8), *(wxPoint*) object_pointer10_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSymbolPickerDialog_php*)native_object)->Create(wxString(symbol10, wxConvUTF8), wxString(initialFont10, wxConvUTF8), wxString(normalTextFont10, wxConvUTF8), (wxWindow*) object_pointer10_3, (wxWindowID) id10, wxString(caption10, wxConvUTF8), *(wxPoint*) object_pointer10_6));

				references->AddReference(parent10, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos10, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSymbolPickerDialog::Create(wxString(symbol10, wxConvUTF8), wxString(initialFont10, wxConvUTF8), wxString(normalTextFont10, wxConvUTF8), (wxWindow*) object_pointer10_3, (wxWindowID) id10, wxString(caption10, wxConvUTF8), *(wxPoint*) object_pointer10_6, *(wxSize*) object_pointer10_7))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSymbolPickerDialog_php*)native_object)->Create(wxString(symbol10, wxConvUTF8), wxString(initialFont10, wxConvUTF8), wxString(normalTextFont10, wxConvUTF8), (wxWindow*) object_pointer10_3, (wxWindowID) id10, wxString(caption10, wxConvUTF8), *(wxPoint*) object_pointer10_6, *(wxSize*) object_pointer10_7));

				references->AddReference(parent10, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos10, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size10, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
			case 9:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSymbolPickerDialog::Create(wxString(symbol10, wxConvUTF8), wxString(initialFont10, wxConvUTF8), wxString(normalTextFont10, wxConvUTF8), (wxWindow*) object_pointer10_3, (wxWindowID) id10, wxString(caption10, wxConvUTF8), *(wxPoint*) object_pointer10_6, *(wxSize*) object_pointer10_7, (long) style10))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSymbolPickerDialog_php*)native_object)->Create(wxString(symbol10, wxConvUTF8), wxString(initialFont10, wxConvUTF8), wxString(normalTextFont10, wxConvUTF8), (wxWindow*) object_pointer10_3, (wxWindowID) id10, wxString(caption10, wxConvUTF8), *(wxPoint*) object_pointer10_6, *(wxSize*) object_pointer10_7, (long) style10));

				references->AddReference(parent10, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(pos10, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(size10, "wxWindow::Create at call with 9 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload11_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxPropertySheetDialog::Create((wxWindow*) object_pointer11_0, (wxWindowID) id11, wxString(title11, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxPropertySheetDialog_php*)native_object)->Create((wxWindow*) object_pointer11_0, (wxWindowID) id11, wxString(title11, wxConvUTF8)));

				references->AddReference(parent11, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxPropertySheetDialog::Create((wxWindow*) object_pointer11_0, (wxWindowID) id11, wxString(title11, wxConvUTF8), *(wxPoint*) object_pointer11_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxPropertySheetDialog_php*)native_object)->Create((wxWindow*) object_pointer11_0, (wxWindowID) id11, wxString(title11, wxConvUTF8), *(wxPoint*) object_pointer11_3));

				references->AddReference(parent11, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos11, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxPropertySheetDialog::Create((wxWindow*) object_pointer11_0, (wxWindowID) id11, wxString(title11, wxConvUTF8), *(wxPoint*) object_pointer11_3, *(wxSize*) object_pointer11_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxPropertySheetDialog_php*)native_object)->Create((wxWindow*) object_pointer11_0, (wxWindowID) id11, wxString(title11, wxConvUTF8), *(wxPoint*) object_pointer11_3, *(wxSize*) object_pointer11_4));

				references->AddReference(parent11, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos11, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size11, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxPropertySheetDialog::Create((wxWindow*) object_pointer11_0, (wxWindowID) id11, wxString(title11, wxConvUTF8), *(wxPoint*) object_pointer11_3, *(wxSize*) object_pointer11_4, (long) style11))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxPropertySheetDialog_php*)native_object)->Create((wxWindow*) object_pointer11_0, (wxWindowID) id11, wxString(title11, wxConvUTF8), *(wxPoint*) object_pointer11_3, *(wxSize*) object_pointer11_4, (long) style11));

				references->AddReference(parent11, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos11, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size11, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxPropertySheetDialog::Create((wxWindow*) object_pointer11_0, (wxWindowID) id11, wxString(title11, wxConvUTF8), *(wxPoint*) object_pointer11_3, *(wxSize*) object_pointer11_4, (long) style11, wxString(name11, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxPropertySheetDialog_php*)native_object)->Create((wxWindow*) object_pointer11_0, (wxWindowID) id11, wxString(title11, wxConvUTF8), *(wxPoint*) object_pointer11_3, *(wxSize*) object_pointer11_4, (long) style11, wxString(name11, wxConvUTF8)));

				references->AddReference(parent11, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos11, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size11, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload12_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWizard::Create((wxWindow*) object_pointer12_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWizard_php*)native_object)->Create((wxWindow*) object_pointer12_0));

				references->AddReference(parent12, "wxWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWizard::Create((wxWindow*) object_pointer12_0, (int) id12))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWizard_php*)native_object)->Create((wxWindow*) object_pointer12_0, (int) id12));

				references->AddReference(parent12, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWizard::Create((wxWindow*) object_pointer12_0, (int) id12, wxString(title12, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWizard_php*)native_object)->Create((wxWindow*) object_pointer12_0, (int) id12, wxString(title12, wxConvUTF8)));

				references->AddReference(parent12, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWizard::Create((wxWindow*) object_pointer12_0, (int) id12, wxString(title12, wxConvUTF8), *(wxBitmap*) object_pointer12_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWizard_php*)native_object)->Create((wxWindow*) object_pointer12_0, (int) id12, wxString(title12, wxConvUTF8), *(wxBitmap*) object_pointer12_3));

				references->AddReference(parent12, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(bitmap12, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWizard::Create((wxWindow*) object_pointer12_0, (int) id12, wxString(title12, wxConvUTF8), *(wxBitmap*) object_pointer12_3, *(wxPoint*) object_pointer12_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWizard_php*)native_object)->Create((wxWindow*) object_pointer12_0, (int) id12, wxString(title12, wxConvUTF8), *(wxBitmap*) object_pointer12_3, *(wxPoint*) object_pointer12_4));

				references->AddReference(parent12, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(bitmap12, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos12, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWizard::Create((wxWindow*) object_pointer12_0, (int) id12, wxString(title12, wxConvUTF8), *(wxBitmap*) object_pointer12_3, *(wxPoint*) object_pointer12_4, (long) style12))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWizard_php*)native_object)->Create((wxWindow*) object_pointer12_0, (int) id12, wxString(title12, wxConvUTF8), *(wxBitmap*) object_pointer12_3, *(wxPoint*) object_pointer12_4, (long) style12));

				references->AddReference(parent12, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(bitmap12, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos12, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload13_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxColourDialog::Create((wxWindow*) object_pointer13_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxColourDialog_php*)native_object)->Create((wxWindow*) object_pointer13_0));

				references->AddReference(parent13, "wxWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxColourDialog::Create((wxWindow*) object_pointer13_0, (wxColourData*) object_pointer13_1))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxColourDialog_php*)native_object)->Create((wxWindow*) object_pointer13_0, (wxColourData*) object_pointer13_1));

				references->AddReference(parent13, "wxWindow::Create at call with 2 argument(s)");
				references->AddReference(data13, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload14_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFontDialog::Create((wxWindow*) object_pointer14_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFontDialog_php*)native_object)->Create((wxWindow*) object_pointer14_0));

				references->AddReference(parent14, "wxWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload15_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFontDialog::Create((wxWindow*) object_pointer15_0, *(wxFontData*) object_pointer15_1))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFontDialog_php*)native_object)->Create((wxWindow*) object_pointer15_0, *(wxFontData*) object_pointer15_1));

				references->AddReference(parent15, "wxWindow::Create at call with 2 argument(s)");
				references->AddReference(data15, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload16_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxPopupWindow::Create((wxWindow*) object_pointer16_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxPopupWindow_php*)native_object)->Create((wxWindow*) object_pointer16_0));

				references->AddReference(parent16, "wxWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxPopupWindow::Create((wxWindow*) object_pointer16_0, (int) flags16))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxPopupWindow_php*)native_object)->Create((wxWindow*) object_pointer16_0, (int) flags16));

				references->AddReference(parent16, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload17_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxControl::Create((wxWindow*) object_pointer17_0, (wxWindowID) id17))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxControl_php*)native_object)->Create((wxWindow*) object_pointer17_0, (wxWindowID) id17));

				references->AddReference(parent17, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxControl::Create((wxWindow*) object_pointer17_0, (wxWindowID) id17, *(wxPoint*) object_pointer17_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxControl_php*)native_object)->Create((wxWindow*) object_pointer17_0, (wxWindowID) id17, *(wxPoint*) object_pointer17_2));

				references->AddReference(parent17, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(pos17, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxControl::Create((wxWindow*) object_pointer17_0, (wxWindowID) id17, *(wxPoint*) object_pointer17_2, *(wxSize*) object_pointer17_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxControl_php*)native_object)->Create((wxWindow*) object_pointer17_0, (wxWindowID) id17, *(wxPoint*) object_pointer17_2, *(wxSize*) object_pointer17_3));

				references->AddReference(parent17, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos17, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(size17, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxControl::Create((wxWindow*) object_pointer17_0, (wxWindowID) id17, *(wxPoint*) object_pointer17_2, *(wxSize*) object_pointer17_3, (long) style17))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxControl_php*)native_object)->Create((wxWindow*) object_pointer17_0, (wxWindowID) id17, *(wxPoint*) object_pointer17_2, *(wxSize*) object_pointer17_3, (long) style17));

				references->AddReference(parent17, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos17, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size17, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxControl::Create((wxWindow*) object_pointer17_0, (wxWindowID) id17, *(wxPoint*) object_pointer17_2, *(wxSize*) object_pointer17_3, (long) style17, *(wxValidator*) object_pointer17_5))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxControl_php*)native_object)->Create((wxWindow*) object_pointer17_0, (wxWindowID) id17, *(wxPoint*) object_pointer17_2, *(wxSize*) object_pointer17_3, (long) style17, *(wxValidator*) object_pointer17_5));

				references->AddReference(parent17, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos17, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size17, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(validator17, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxControl::Create((wxWindow*) object_pointer17_0, (wxWindowID) id17, *(wxPoint*) object_pointer17_2, *(wxSize*) object_pointer17_3, (long) style17, *(wxValidator*) object_pointer17_5, wxString(name17, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxControl_php*)native_object)->Create((wxWindow*) object_pointer17_0, (wxWindowID) id17, *(wxPoint*) object_pointer17_2, *(wxSize*) object_pointer17_3, (long) style17, *(wxValidator*) object_pointer17_5, wxString(name17, wxConvUTF8)));

				references->AddReference(parent17, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos17, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size17, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator17, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload18_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStatusBar::Create((wxWindow*) object_pointer18_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStatusBar_php*)native_object)->Create((wxWindow*) object_pointer18_0));

				references->AddReference(parent18, "wxWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStatusBar::Create((wxWindow*) object_pointer18_0, (wxWindowID) id18))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStatusBar_php*)native_object)->Create((wxWindow*) object_pointer18_0, (wxWindowID) id18));

				references->AddReference(parent18, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStatusBar::Create((wxWindow*) object_pointer18_0, (wxWindowID) id18, (long) style18))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStatusBar_php*)native_object)->Create((wxWindow*) object_pointer18_0, (wxWindowID) id18, (long) style18));

				references->AddReference(parent18, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStatusBar::Create((wxWindow*) object_pointer18_0, (wxWindowID) id18, (long) style18, wxString(name18, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStatusBar_php*)native_object)->Create((wxWindow*) object_pointer18_0, (wxWindowID) id18, (long) style18, wxString(name18, wxConvUTF8)));

				references->AddReference(parent18, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload19_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxButton::Create((wxWindow*) object_pointer19_0, (wxWindowID) id19))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxButton_php*)native_object)->Create((wxWindow*) object_pointer19_0, (wxWindowID) id19));

				references->AddReference(parent19, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxButton::Create((wxWindow*) object_pointer19_0, (wxWindowID) id19, wxString(label19, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxButton_php*)native_object)->Create((wxWindow*) object_pointer19_0, (wxWindowID) id19, wxString(label19, wxConvUTF8)));

				references->AddReference(parent19, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxButton::Create((wxWindow*) object_pointer19_0, (wxWindowID) id19, wxString(label19, wxConvUTF8), *(wxPoint*) object_pointer19_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxButton_php*)native_object)->Create((wxWindow*) object_pointer19_0, (wxWindowID) id19, wxString(label19, wxConvUTF8), *(wxPoint*) object_pointer19_3));

				references->AddReference(parent19, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos19, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxButton::Create((wxWindow*) object_pointer19_0, (wxWindowID) id19, wxString(label19, wxConvUTF8), *(wxPoint*) object_pointer19_3, *(wxSize*) object_pointer19_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxButton_php*)native_object)->Create((wxWindow*) object_pointer19_0, (wxWindowID) id19, wxString(label19, wxConvUTF8), *(wxPoint*) object_pointer19_3, *(wxSize*) object_pointer19_4));

				references->AddReference(parent19, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos19, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size19, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxButton::Create((wxWindow*) object_pointer19_0, (wxWindowID) id19, wxString(label19, wxConvUTF8), *(wxPoint*) object_pointer19_3, *(wxSize*) object_pointer19_4, (long) style19))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxButton_php*)native_object)->Create((wxWindow*) object_pointer19_0, (wxWindowID) id19, wxString(label19, wxConvUTF8), *(wxPoint*) object_pointer19_3, *(wxSize*) object_pointer19_4, (long) style19));

				references->AddReference(parent19, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos19, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size19, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxButton::Create((wxWindow*) object_pointer19_0, (wxWindowID) id19, wxString(label19, wxConvUTF8), *(wxPoint*) object_pointer19_3, *(wxSize*) object_pointer19_4, (long) style19, *(wxValidator*) object_pointer19_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxButton_php*)native_object)->Create((wxWindow*) object_pointer19_0, (wxWindowID) id19, wxString(label19, wxConvUTF8), *(wxPoint*) object_pointer19_3, *(wxSize*) object_pointer19_4, (long) style19, *(wxValidator*) object_pointer19_6));

				references->AddReference(parent19, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos19, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size19, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator19, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxButton::Create((wxWindow*) object_pointer19_0, (wxWindowID) id19, wxString(label19, wxConvUTF8), *(wxPoint*) object_pointer19_3, *(wxSize*) object_pointer19_4, (long) style19, *(wxValidator*) object_pointer19_6, wxString(name19, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxButton_php*)native_object)->Create((wxWindow*) object_pointer19_0, (wxWindowID) id19, wxString(label19, wxConvUTF8), *(wxPoint*) object_pointer19_3, *(wxSize*) object_pointer19_4, (long) style19, *(wxValidator*) object_pointer19_6, wxString(name19, wxConvUTF8)));

				references->AddReference(parent19, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos19, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size19, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator19, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload20_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapButton::Create((wxWindow*) object_pointer20_0, (wxWindowID) id20, *(wxBitmap*) object_pointer20_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapButton_php*)native_object)->Create((wxWindow*) object_pointer20_0, (wxWindowID) id20, *(wxBitmap*) object_pointer20_2));

				references->AddReference(parent20, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(bitmap20, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapButton::Create((wxWindow*) object_pointer20_0, (wxWindowID) id20, *(wxBitmap*) object_pointer20_2, *(wxPoint*) object_pointer20_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapButton_php*)native_object)->Create((wxWindow*) object_pointer20_0, (wxWindowID) id20, *(wxBitmap*) object_pointer20_2, *(wxPoint*) object_pointer20_3));

				references->AddReference(parent20, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(bitmap20, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos20, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapButton::Create((wxWindow*) object_pointer20_0, (wxWindowID) id20, *(wxBitmap*) object_pointer20_2, *(wxPoint*) object_pointer20_3, *(wxSize*) object_pointer20_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapButton_php*)native_object)->Create((wxWindow*) object_pointer20_0, (wxWindowID) id20, *(wxBitmap*) object_pointer20_2, *(wxPoint*) object_pointer20_3, *(wxSize*) object_pointer20_4));

				references->AddReference(parent20, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(bitmap20, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos20, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size20, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapButton::Create((wxWindow*) object_pointer20_0, (wxWindowID) id20, *(wxBitmap*) object_pointer20_2, *(wxPoint*) object_pointer20_3, *(wxSize*) object_pointer20_4, (long) style20))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapButton_php*)native_object)->Create((wxWindow*) object_pointer20_0, (wxWindowID) id20, *(wxBitmap*) object_pointer20_2, *(wxPoint*) object_pointer20_3, *(wxSize*) object_pointer20_4, (long) style20));

				references->AddReference(parent20, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(bitmap20, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos20, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size20, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapButton::Create((wxWindow*) object_pointer20_0, (wxWindowID) id20, *(wxBitmap*) object_pointer20_2, *(wxPoint*) object_pointer20_3, *(wxSize*) object_pointer20_4, (long) style20, *(wxValidator*) object_pointer20_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapButton_php*)native_object)->Create((wxWindow*) object_pointer20_0, (wxWindowID) id20, *(wxBitmap*) object_pointer20_2, *(wxPoint*) object_pointer20_3, *(wxSize*) object_pointer20_4, (long) style20, *(wxValidator*) object_pointer20_6));

				references->AddReference(parent20, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(bitmap20, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos20, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size20, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator20, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapButton::Create((wxWindow*) object_pointer20_0, (wxWindowID) id20, *(wxBitmap*) object_pointer20_2, *(wxPoint*) object_pointer20_3, *(wxSize*) object_pointer20_4, (long) style20, *(wxValidator*) object_pointer20_6, wxString(name20, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapButton_php*)native_object)->Create((wxWindow*) object_pointer20_0, (wxWindowID) id20, *(wxBitmap*) object_pointer20_2, *(wxPoint*) object_pointer20_3, *(wxSize*) object_pointer20_4, (long) style20, *(wxValidator*) object_pointer20_6, wxString(name20, wxConvUTF8)));

				references->AddReference(parent20, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(bitmap20, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos20, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size20, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator20, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload21_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxToggleButton::Create((wxWindow*) object_pointer21_0, (wxWindowID) id21, wxString(label21, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxToggleButton_php*)native_object)->Create((wxWindow*) object_pointer21_0, (wxWindowID) id21, wxString(label21, wxConvUTF8)));

				references->AddReference(parent21, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxToggleButton::Create((wxWindow*) object_pointer21_0, (wxWindowID) id21, wxString(label21, wxConvUTF8), *(wxPoint*) object_pointer21_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxToggleButton_php*)native_object)->Create((wxWindow*) object_pointer21_0, (wxWindowID) id21, wxString(label21, wxConvUTF8), *(wxPoint*) object_pointer21_3));

				references->AddReference(parent21, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos21, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxToggleButton::Create((wxWindow*) object_pointer21_0, (wxWindowID) id21, wxString(label21, wxConvUTF8), *(wxPoint*) object_pointer21_3, *(wxSize*) object_pointer21_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxToggleButton_php*)native_object)->Create((wxWindow*) object_pointer21_0, (wxWindowID) id21, wxString(label21, wxConvUTF8), *(wxPoint*) object_pointer21_3, *(wxSize*) object_pointer21_4));

				references->AddReference(parent21, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos21, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size21, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxToggleButton::Create((wxWindow*) object_pointer21_0, (wxWindowID) id21, wxString(label21, wxConvUTF8), *(wxPoint*) object_pointer21_3, *(wxSize*) object_pointer21_4, (long) style21))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxToggleButton_php*)native_object)->Create((wxWindow*) object_pointer21_0, (wxWindowID) id21, wxString(label21, wxConvUTF8), *(wxPoint*) object_pointer21_3, *(wxSize*) object_pointer21_4, (long) style21));

				references->AddReference(parent21, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos21, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size21, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxToggleButton::Create((wxWindow*) object_pointer21_0, (wxWindowID) id21, wxString(label21, wxConvUTF8), *(wxPoint*) object_pointer21_3, *(wxSize*) object_pointer21_4, (long) style21, *(wxValidator*) object_pointer21_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxToggleButton_php*)native_object)->Create((wxWindow*) object_pointer21_0, (wxWindowID) id21, wxString(label21, wxConvUTF8), *(wxPoint*) object_pointer21_3, *(wxSize*) object_pointer21_4, (long) style21, *(wxValidator*) object_pointer21_6));

				references->AddReference(parent21, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos21, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size21, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(val21, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxToggleButton::Create((wxWindow*) object_pointer21_0, (wxWindowID) id21, wxString(label21, wxConvUTF8), *(wxPoint*) object_pointer21_3, *(wxSize*) object_pointer21_4, (long) style21, *(wxValidator*) object_pointer21_6, wxString(name21, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxToggleButton_php*)native_object)->Create((wxWindow*) object_pointer21_0, (wxWindowID) id21, wxString(label21, wxConvUTF8), *(wxPoint*) object_pointer21_3, *(wxSize*) object_pointer21_4, (long) style21, *(wxValidator*) object_pointer21_6, wxString(name21, wxConvUTF8)));

				references->AddReference(parent21, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos21, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size21, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(val21, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload22_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapToggleButton::Create((wxWindow*) object_pointer22_0, (wxWindowID) id22, *(wxBitmap*) object_pointer22_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapToggleButton_php*)native_object)->Create((wxWindow*) object_pointer22_0, (wxWindowID) id22, *(wxBitmap*) object_pointer22_2));

				references->AddReference(parent22, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(label22, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapToggleButton::Create((wxWindow*) object_pointer22_0, (wxWindowID) id22, *(wxBitmap*) object_pointer22_2, *(wxPoint*) object_pointer22_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapToggleButton_php*)native_object)->Create((wxWindow*) object_pointer22_0, (wxWindowID) id22, *(wxBitmap*) object_pointer22_2, *(wxPoint*) object_pointer22_3));

				references->AddReference(parent22, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(label22, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos22, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapToggleButton::Create((wxWindow*) object_pointer22_0, (wxWindowID) id22, *(wxBitmap*) object_pointer22_2, *(wxPoint*) object_pointer22_3, *(wxSize*) object_pointer22_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapToggleButton_php*)native_object)->Create((wxWindow*) object_pointer22_0, (wxWindowID) id22, *(wxBitmap*) object_pointer22_2, *(wxPoint*) object_pointer22_3, *(wxSize*) object_pointer22_4));

				references->AddReference(parent22, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(label22, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos22, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size22, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapToggleButton::Create((wxWindow*) object_pointer22_0, (wxWindowID) id22, *(wxBitmap*) object_pointer22_2, *(wxPoint*) object_pointer22_3, *(wxSize*) object_pointer22_4, (long) style22))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapToggleButton_php*)native_object)->Create((wxWindow*) object_pointer22_0, (wxWindowID) id22, *(wxBitmap*) object_pointer22_2, *(wxPoint*) object_pointer22_3, *(wxSize*) object_pointer22_4, (long) style22));

				references->AddReference(parent22, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(label22, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos22, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size22, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapToggleButton::Create((wxWindow*) object_pointer22_0, (wxWindowID) id22, *(wxBitmap*) object_pointer22_2, *(wxPoint*) object_pointer22_3, *(wxSize*) object_pointer22_4, (long) style22, *(wxValidator*) object_pointer22_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapToggleButton_php*)native_object)->Create((wxWindow*) object_pointer22_0, (wxWindowID) id22, *(wxBitmap*) object_pointer22_2, *(wxPoint*) object_pointer22_3, *(wxSize*) object_pointer22_4, (long) style22, *(wxValidator*) object_pointer22_6));

				references->AddReference(parent22, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(label22, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos22, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size22, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(val22, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapToggleButton::Create((wxWindow*) object_pointer22_0, (wxWindowID) id22, *(wxBitmap*) object_pointer22_2, *(wxPoint*) object_pointer22_3, *(wxSize*) object_pointer22_4, (long) style22, *(wxValidator*) object_pointer22_6, wxString(name22, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapToggleButton_php*)native_object)->Create((wxWindow*) object_pointer22_0, (wxWindowID) id22, *(wxBitmap*) object_pointer22_2, *(wxPoint*) object_pointer22_3, *(wxSize*) object_pointer22_4, (long) style22, *(wxValidator*) object_pointer22_6, wxString(name22, wxConvUTF8)));

				references->AddReference(parent22, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(label22, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos22, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size22, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(val22, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload23_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTreeCtrl::Create((wxWindow*) object_pointer23_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTreeCtrl_php*)native_object)->Create((wxWindow*) object_pointer23_0));

				references->AddReference(parent23, "wxWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTreeCtrl::Create((wxWindow*) object_pointer23_0, (wxWindowID) id23))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTreeCtrl_php*)native_object)->Create((wxWindow*) object_pointer23_0, (wxWindowID) id23));

				references->AddReference(parent23, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTreeCtrl::Create((wxWindow*) object_pointer23_0, (wxWindowID) id23, *(wxPoint*) object_pointer23_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTreeCtrl_php*)native_object)->Create((wxWindow*) object_pointer23_0, (wxWindowID) id23, *(wxPoint*) object_pointer23_2));

				references->AddReference(parent23, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(pos23, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTreeCtrl::Create((wxWindow*) object_pointer23_0, (wxWindowID) id23, *(wxPoint*) object_pointer23_2, *(wxSize*) object_pointer23_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTreeCtrl_php*)native_object)->Create((wxWindow*) object_pointer23_0, (wxWindowID) id23, *(wxPoint*) object_pointer23_2, *(wxSize*) object_pointer23_3));

				references->AddReference(parent23, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos23, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(size23, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTreeCtrl::Create((wxWindow*) object_pointer23_0, (wxWindowID) id23, *(wxPoint*) object_pointer23_2, *(wxSize*) object_pointer23_3, (long) style23))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTreeCtrl_php*)native_object)->Create((wxWindow*) object_pointer23_0, (wxWindowID) id23, *(wxPoint*) object_pointer23_2, *(wxSize*) object_pointer23_3, (long) style23));

				references->AddReference(parent23, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos23, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size23, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTreeCtrl::Create((wxWindow*) object_pointer23_0, (wxWindowID) id23, *(wxPoint*) object_pointer23_2, *(wxSize*) object_pointer23_3, (long) style23, *(wxValidator*) object_pointer23_5))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTreeCtrl_php*)native_object)->Create((wxWindow*) object_pointer23_0, (wxWindowID) id23, *(wxPoint*) object_pointer23_2, *(wxSize*) object_pointer23_3, (long) style23, *(wxValidator*) object_pointer23_5));

				references->AddReference(parent23, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos23, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size23, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(validator23, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTreeCtrl::Create((wxWindow*) object_pointer23_0, (wxWindowID) id23, *(wxPoint*) object_pointer23_2, *(wxSize*) object_pointer23_3, (long) style23, *(wxValidator*) object_pointer23_5, wxString(name23, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTreeCtrl_php*)native_object)->Create((wxWindow*) object_pointer23_0, (wxWindowID) id23, *(wxPoint*) object_pointer23_2, *(wxSize*) object_pointer23_3, (long) style23, *(wxValidator*) object_pointer23_5, wxString(name23, wxConvUTF8)));

				references->AddReference(parent23, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos23, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size23, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator23, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload24_called)
	{
		wxArrayString strings_array24_4;
		bool strings_continue24_4 = true;

		switch(arguments_received)
		{
			case 5:
			{
				int array_index24_4 = 0;
				zval** temp_array_value24_4 = 0;
				while(strings_continue24_4)
				{
					if(zend_hash_index_find(HASH_OF(choices24), array_index24_4, (void**)&temp_array_value24_4) == SUCCESS)
					{
						convert_to_string(*temp_array_value24_4);
						strings_array24_4.Add(wxString(Z_STRVAL_PP(temp_array_value24_4), wxConvUTF8));
						array_index24_4++;
					}
					else
					{
						strings_continue24_4 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxListBox::Create((wxWindow*) object_pointer24_0, (wxWindowID) id24, *(wxPoint*) object_pointer24_2, *(wxSize*) object_pointer24_3, strings_array24_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxListBox_php*)native_object)->Create((wxWindow*) object_pointer24_0, (wxWindowID) id24, *(wxPoint*) object_pointer24_2, *(wxSize*) object_pointer24_3, strings_array24_4));

				references->AddReference(parent24, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos24, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size24, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				int array_index24_4 = 0;
				zval** temp_array_value24_4 = 0;
				while(strings_continue24_4)
				{
					if(zend_hash_index_find(HASH_OF(choices24), array_index24_4, (void**)&temp_array_value24_4) == SUCCESS)
					{
						convert_to_string(*temp_array_value24_4);
						strings_array24_4.Add(wxString(Z_STRVAL_PP(temp_array_value24_4), wxConvUTF8));
						array_index24_4++;
					}
					else
					{
						strings_continue24_4 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxListBox::Create((wxWindow*) object_pointer24_0, (wxWindowID) id24, *(wxPoint*) object_pointer24_2, *(wxSize*) object_pointer24_3, strings_array24_4, (long) style24))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxListBox_php*)native_object)->Create((wxWindow*) object_pointer24_0, (wxWindowID) id24, *(wxPoint*) object_pointer24_2, *(wxSize*) object_pointer24_3, strings_array24_4, (long) style24));

				references->AddReference(parent24, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos24, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size24, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				int array_index24_4 = 0;
				zval** temp_array_value24_4 = 0;
				while(strings_continue24_4)
				{
					if(zend_hash_index_find(HASH_OF(choices24), array_index24_4, (void**)&temp_array_value24_4) == SUCCESS)
					{
						convert_to_string(*temp_array_value24_4);
						strings_array24_4.Add(wxString(Z_STRVAL_PP(temp_array_value24_4), wxConvUTF8));
						array_index24_4++;
					}
					else
					{
						strings_continue24_4 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxListBox::Create((wxWindow*) object_pointer24_0, (wxWindowID) id24, *(wxPoint*) object_pointer24_2, *(wxSize*) object_pointer24_3, strings_array24_4, (long) style24, *(wxValidator*) object_pointer24_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxListBox_php*)native_object)->Create((wxWindow*) object_pointer24_0, (wxWindowID) id24, *(wxPoint*) object_pointer24_2, *(wxSize*) object_pointer24_3, strings_array24_4, (long) style24, *(wxValidator*) object_pointer24_6));

				references->AddReference(parent24, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos24, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size24, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator24, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				int array_index24_4 = 0;
				zval** temp_array_value24_4 = 0;
				while(strings_continue24_4)
				{
					if(zend_hash_index_find(HASH_OF(choices24), array_index24_4, (void**)&temp_array_value24_4) == SUCCESS)
					{
						convert_to_string(*temp_array_value24_4);
						strings_array24_4.Add(wxString(Z_STRVAL_PP(temp_array_value24_4), wxConvUTF8));
						array_index24_4++;
					}
					else
					{
						strings_continue24_4 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxListBox::Create((wxWindow*) object_pointer24_0, (wxWindowID) id24, *(wxPoint*) object_pointer24_2, *(wxSize*) object_pointer24_3, strings_array24_4, (long) style24, *(wxValidator*) object_pointer24_6, wxString(name24, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxListBox_php*)native_object)->Create((wxWindow*) object_pointer24_0, (wxWindowID) id24, *(wxPoint*) object_pointer24_2, *(wxSize*) object_pointer24_3, strings_array24_4, (long) style24, *(wxValidator*) object_pointer24_6, wxString(name24, wxConvUTF8)));

				references->AddReference(parent24, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos24, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size24, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator24, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload25_called)
	{
		int array_count25_5 = 1;
		HashTable* arr_hash25_5;
		if(arguments_received > 5)
		{
			arr_hash25_5 = Z_ARRVAL_P(choices25);
			array_count25_5 = zend_hash_num_elements(arr_hash25_5);
		}
		wxString* strings_array25_5 = new wxString[array_count25_5];
		bool strings_continue25_5 = true;

		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxListBox::Create((wxWindow*) object_pointer25_0, (wxWindowID) id25))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxListBox_php*)native_object)->Create((wxWindow*) object_pointer25_0, (wxWindowID) id25));

				references->AddReference(parent25, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxListBox::Create((wxWindow*) object_pointer25_0, (wxWindowID) id25, *(wxPoint*) object_pointer25_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxListBox_php*)native_object)->Create((wxWindow*) object_pointer25_0, (wxWindowID) id25, *(wxPoint*) object_pointer25_2));

				references->AddReference(parent25, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(pos25, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxListBox::Create((wxWindow*) object_pointer25_0, (wxWindowID) id25, *(wxPoint*) object_pointer25_2, *(wxSize*) object_pointer25_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxListBox_php*)native_object)->Create((wxWindow*) object_pointer25_0, (wxWindowID) id25, *(wxPoint*) object_pointer25_2, *(wxSize*) object_pointer25_3));

				references->AddReference(parent25, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos25, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(size25, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxListBox::Create((wxWindow*) object_pointer25_0, (wxWindowID) id25, *(wxPoint*) object_pointer25_2, *(wxSize*) object_pointer25_3, (int) n25))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxListBox_php*)native_object)->Create((wxWindow*) object_pointer25_0, (wxWindowID) id25, *(wxPoint*) object_pointer25_2, *(wxSize*) object_pointer25_3, (int) n25));

				references->AddReference(parent25, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos25, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size25, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				int array_index25_5 = 0;
				zval** temp_array_value25_5 = 0;
				while(strings_continue25_5)
				{
					if(zend_hash_index_find(HASH_OF(choices25), array_index25_5, (void**)&temp_array_value25_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value25_5);
						strings_array25_5[array_index25_5] = wxString(Z_STRVAL_PP(temp_array_value25_5), wxConvUTF8);
						array_index25_5++;
					}
					else
					{
						strings_continue25_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxListBox::Create((wxWindow*) object_pointer25_0, (wxWindowID) id25, *(wxPoint*) object_pointer25_2, *(wxSize*) object_pointer25_3, (int) n25, strings_array25_5))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxListBox_php*)native_object)->Create((wxWindow*) object_pointer25_0, (wxWindowID) id25, *(wxPoint*) object_pointer25_2, *(wxSize*) object_pointer25_3, (int) n25, strings_array25_5));

				references->AddReference(parent25, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos25, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size25, "wxWindow::Create at call with 6 argument(s)");
				delete[] strings_array25_5;

				return;
				break;
			}
			case 7:
			{
				int array_index25_5 = 0;
				zval** temp_array_value25_5 = 0;
				while(strings_continue25_5)
				{
					if(zend_hash_index_find(HASH_OF(choices25), array_index25_5, (void**)&temp_array_value25_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value25_5);
						strings_array25_5[array_index25_5] = wxString(Z_STRVAL_PP(temp_array_value25_5), wxConvUTF8);
						array_index25_5++;
					}
					else
					{
						strings_continue25_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxListBox::Create((wxWindow*) object_pointer25_0, (wxWindowID) id25, *(wxPoint*) object_pointer25_2, *(wxSize*) object_pointer25_3, (int) n25, strings_array25_5, (long) style25))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxListBox_php*)native_object)->Create((wxWindow*) object_pointer25_0, (wxWindowID) id25, *(wxPoint*) object_pointer25_2, *(wxSize*) object_pointer25_3, (int) n25, strings_array25_5, (long) style25));

				references->AddReference(parent25, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos25, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size25, "wxWindow::Create at call with 7 argument(s)");
				delete[] strings_array25_5;

				return;
				break;
			}
			case 8:
			{
				int array_index25_5 = 0;
				zval** temp_array_value25_5 = 0;
				while(strings_continue25_5)
				{
					if(zend_hash_index_find(HASH_OF(choices25), array_index25_5, (void**)&temp_array_value25_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value25_5);
						strings_array25_5[array_index25_5] = wxString(Z_STRVAL_PP(temp_array_value25_5), wxConvUTF8);
						array_index25_5++;
					}
					else
					{
						strings_continue25_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxListBox::Create((wxWindow*) object_pointer25_0, (wxWindowID) id25, *(wxPoint*) object_pointer25_2, *(wxSize*) object_pointer25_3, (int) n25, strings_array25_5, (long) style25, *(wxValidator*) object_pointer25_7))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxListBox_php*)native_object)->Create((wxWindow*) object_pointer25_0, (wxWindowID) id25, *(wxPoint*) object_pointer25_2, *(wxSize*) object_pointer25_3, (int) n25, strings_array25_5, (long) style25, *(wxValidator*) object_pointer25_7));

				references->AddReference(parent25, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos25, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size25, "wxWindow::Create at call with 8 argument(s)");
				delete[] strings_array25_5;
				references->AddReference(validator25, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
			case 9:
			{
				int array_index25_5 = 0;
				zval** temp_array_value25_5 = 0;
				while(strings_continue25_5)
				{
					if(zend_hash_index_find(HASH_OF(choices25), array_index25_5, (void**)&temp_array_value25_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value25_5);
						strings_array25_5[array_index25_5] = wxString(Z_STRVAL_PP(temp_array_value25_5), wxConvUTF8);
						array_index25_5++;
					}
					else
					{
						strings_continue25_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxListBox::Create((wxWindow*) object_pointer25_0, (wxWindowID) id25, *(wxPoint*) object_pointer25_2, *(wxSize*) object_pointer25_3, (int) n25, strings_array25_5, (long) style25, *(wxValidator*) object_pointer25_7, wxString(name25, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxListBox_php*)native_object)->Create((wxWindow*) object_pointer25_0, (wxWindowID) id25, *(wxPoint*) object_pointer25_2, *(wxSize*) object_pointer25_3, (int) n25, strings_array25_5, (long) style25, *(wxValidator*) object_pointer25_7, wxString(name25, wxConvUTF8)));

				references->AddReference(parent25, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(pos25, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(size25, "wxWindow::Create at call with 9 argument(s)");
				delete[] strings_array25_5;
				references->AddReference(validator25, "wxWindow::Create at call with 9 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload26_called)
	{
		int array_count26_5 = 1;
		HashTable* arr_hash26_5;
		if(arguments_received > 5)
		{
			arr_hash26_5 = Z_ARRVAL_P(choices26);
			array_count26_5 = zend_hash_num_elements(arr_hash26_5);
		}
		wxString* strings_array26_5 = new wxString[array_count26_5];
		bool strings_continue26_5 = true;

		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCheckListBox::Create((wxWindow*) object_pointer26_0, (wxWindowID) id26))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCheckListBox_php*)native_object)->Create((wxWindow*) object_pointer26_0, (wxWindowID) id26));

				references->AddReference(parent26, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCheckListBox::Create((wxWindow*) object_pointer26_0, (wxWindowID) id26, *(wxPoint*) object_pointer26_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCheckListBox_php*)native_object)->Create((wxWindow*) object_pointer26_0, (wxWindowID) id26, *(wxPoint*) object_pointer26_2));

				references->AddReference(parent26, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(pos26, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCheckListBox::Create((wxWindow*) object_pointer26_0, (wxWindowID) id26, *(wxPoint*) object_pointer26_2, *(wxSize*) object_pointer26_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCheckListBox_php*)native_object)->Create((wxWindow*) object_pointer26_0, (wxWindowID) id26, *(wxPoint*) object_pointer26_2, *(wxSize*) object_pointer26_3));

				references->AddReference(parent26, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos26, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(size26, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCheckListBox::Create((wxWindow*) object_pointer26_0, (wxWindowID) id26, *(wxPoint*) object_pointer26_2, *(wxSize*) object_pointer26_3, (int) nStrings26))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCheckListBox_php*)native_object)->Create((wxWindow*) object_pointer26_0, (wxWindowID) id26, *(wxPoint*) object_pointer26_2, *(wxSize*) object_pointer26_3, (int) nStrings26));

				references->AddReference(parent26, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos26, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size26, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				int array_index26_5 = 0;
				zval** temp_array_value26_5 = 0;
				while(strings_continue26_5)
				{
					if(zend_hash_index_find(HASH_OF(choices26), array_index26_5, (void**)&temp_array_value26_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value26_5);
						strings_array26_5[array_index26_5] = wxString(Z_STRVAL_PP(temp_array_value26_5), wxConvUTF8);
						array_index26_5++;
					}
					else
					{
						strings_continue26_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCheckListBox::Create((wxWindow*) object_pointer26_0, (wxWindowID) id26, *(wxPoint*) object_pointer26_2, *(wxSize*) object_pointer26_3, (int) nStrings26, strings_array26_5))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCheckListBox_php*)native_object)->Create((wxWindow*) object_pointer26_0, (wxWindowID) id26, *(wxPoint*) object_pointer26_2, *(wxSize*) object_pointer26_3, (int) nStrings26, strings_array26_5));

				references->AddReference(parent26, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos26, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size26, "wxWindow::Create at call with 6 argument(s)");
				delete[] strings_array26_5;

				return;
				break;
			}
			case 7:
			{
				int array_index26_5 = 0;
				zval** temp_array_value26_5 = 0;
				while(strings_continue26_5)
				{
					if(zend_hash_index_find(HASH_OF(choices26), array_index26_5, (void**)&temp_array_value26_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value26_5);
						strings_array26_5[array_index26_5] = wxString(Z_STRVAL_PP(temp_array_value26_5), wxConvUTF8);
						array_index26_5++;
					}
					else
					{
						strings_continue26_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCheckListBox::Create((wxWindow*) object_pointer26_0, (wxWindowID) id26, *(wxPoint*) object_pointer26_2, *(wxSize*) object_pointer26_3, (int) nStrings26, strings_array26_5, (long) style26))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCheckListBox_php*)native_object)->Create((wxWindow*) object_pointer26_0, (wxWindowID) id26, *(wxPoint*) object_pointer26_2, *(wxSize*) object_pointer26_3, (int) nStrings26, strings_array26_5, (long) style26));

				references->AddReference(parent26, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos26, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size26, "wxWindow::Create at call with 7 argument(s)");
				delete[] strings_array26_5;

				return;
				break;
			}
			case 8:
			{
				int array_index26_5 = 0;
				zval** temp_array_value26_5 = 0;
				while(strings_continue26_5)
				{
					if(zend_hash_index_find(HASH_OF(choices26), array_index26_5, (void**)&temp_array_value26_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value26_5);
						strings_array26_5[array_index26_5] = wxString(Z_STRVAL_PP(temp_array_value26_5), wxConvUTF8);
						array_index26_5++;
					}
					else
					{
						strings_continue26_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCheckListBox::Create((wxWindow*) object_pointer26_0, (wxWindowID) id26, *(wxPoint*) object_pointer26_2, *(wxSize*) object_pointer26_3, (int) nStrings26, strings_array26_5, (long) style26, *(wxValidator*) object_pointer26_7))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCheckListBox_php*)native_object)->Create((wxWindow*) object_pointer26_0, (wxWindowID) id26, *(wxPoint*) object_pointer26_2, *(wxSize*) object_pointer26_3, (int) nStrings26, strings_array26_5, (long) style26, *(wxValidator*) object_pointer26_7));

				references->AddReference(parent26, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos26, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size26, "wxWindow::Create at call with 8 argument(s)");
				delete[] strings_array26_5;
				references->AddReference(validator26, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
			case 9:
			{
				int array_index26_5 = 0;
				zval** temp_array_value26_5 = 0;
				while(strings_continue26_5)
				{
					if(zend_hash_index_find(HASH_OF(choices26), array_index26_5, (void**)&temp_array_value26_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value26_5);
						strings_array26_5[array_index26_5] = wxString(Z_STRVAL_PP(temp_array_value26_5), wxConvUTF8);
						array_index26_5++;
					}
					else
					{
						strings_continue26_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCheckListBox::Create((wxWindow*) object_pointer26_0, (wxWindowID) id26, *(wxPoint*) object_pointer26_2, *(wxSize*) object_pointer26_3, (int) nStrings26, strings_array26_5, (long) style26, *(wxValidator*) object_pointer26_7, wxString(name26, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCheckListBox_php*)native_object)->Create((wxWindow*) object_pointer26_0, (wxWindowID) id26, *(wxPoint*) object_pointer26_2, *(wxSize*) object_pointer26_3, (int) nStrings26, strings_array26_5, (long) style26, *(wxValidator*) object_pointer26_7, wxString(name26, wxConvUTF8)));

				references->AddReference(parent26, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(pos26, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(size26, "wxWindow::Create at call with 9 argument(s)");
				delete[] strings_array26_5;
				references->AddReference(validator26, "wxWindow::Create at call with 9 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload27_called)
	{
		wxArrayString strings_array27_4;
		bool strings_continue27_4 = true;

		switch(arguments_received)
		{
			case 5:
			{
				int array_index27_4 = 0;
				zval** temp_array_value27_4 = 0;
				while(strings_continue27_4)
				{
					if(zend_hash_index_find(HASH_OF(choices27), array_index27_4, (void**)&temp_array_value27_4) == SUCCESS)
					{
						convert_to_string(*temp_array_value27_4);
						strings_array27_4.Add(wxString(Z_STRVAL_PP(temp_array_value27_4), wxConvUTF8));
						array_index27_4++;
					}
					else
					{
						strings_continue27_4 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCheckListBox::Create((wxWindow*) object_pointer27_0, (wxWindowID) id27, *(wxPoint*) object_pointer27_2, *(wxSize*) object_pointer27_3, strings_array27_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCheckListBox_php*)native_object)->Create((wxWindow*) object_pointer27_0, (wxWindowID) id27, *(wxPoint*) object_pointer27_2, *(wxSize*) object_pointer27_3, strings_array27_4));

				references->AddReference(parent27, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos27, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size27, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				int array_index27_4 = 0;
				zval** temp_array_value27_4 = 0;
				while(strings_continue27_4)
				{
					if(zend_hash_index_find(HASH_OF(choices27), array_index27_4, (void**)&temp_array_value27_4) == SUCCESS)
					{
						convert_to_string(*temp_array_value27_4);
						strings_array27_4.Add(wxString(Z_STRVAL_PP(temp_array_value27_4), wxConvUTF8));
						array_index27_4++;
					}
					else
					{
						strings_continue27_4 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCheckListBox::Create((wxWindow*) object_pointer27_0, (wxWindowID) id27, *(wxPoint*) object_pointer27_2, *(wxSize*) object_pointer27_3, strings_array27_4, (long) style27))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCheckListBox_php*)native_object)->Create((wxWindow*) object_pointer27_0, (wxWindowID) id27, *(wxPoint*) object_pointer27_2, *(wxSize*) object_pointer27_3, strings_array27_4, (long) style27));

				references->AddReference(parent27, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos27, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size27, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				int array_index27_4 = 0;
				zval** temp_array_value27_4 = 0;
				while(strings_continue27_4)
				{
					if(zend_hash_index_find(HASH_OF(choices27), array_index27_4, (void**)&temp_array_value27_4) == SUCCESS)
					{
						convert_to_string(*temp_array_value27_4);
						strings_array27_4.Add(wxString(Z_STRVAL_PP(temp_array_value27_4), wxConvUTF8));
						array_index27_4++;
					}
					else
					{
						strings_continue27_4 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCheckListBox::Create((wxWindow*) object_pointer27_0, (wxWindowID) id27, *(wxPoint*) object_pointer27_2, *(wxSize*) object_pointer27_3, strings_array27_4, (long) style27, *(wxValidator*) object_pointer27_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCheckListBox_php*)native_object)->Create((wxWindow*) object_pointer27_0, (wxWindowID) id27, *(wxPoint*) object_pointer27_2, *(wxSize*) object_pointer27_3, strings_array27_4, (long) style27, *(wxValidator*) object_pointer27_6));

				references->AddReference(parent27, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos27, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size27, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator27, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				int array_index27_4 = 0;
				zval** temp_array_value27_4 = 0;
				while(strings_continue27_4)
				{
					if(zend_hash_index_find(HASH_OF(choices27), array_index27_4, (void**)&temp_array_value27_4) == SUCCESS)
					{
						convert_to_string(*temp_array_value27_4);
						strings_array27_4.Add(wxString(Z_STRVAL_PP(temp_array_value27_4), wxConvUTF8));
						array_index27_4++;
					}
					else
					{
						strings_continue27_4 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCheckListBox::Create((wxWindow*) object_pointer27_0, (wxWindowID) id27, *(wxPoint*) object_pointer27_2, *(wxSize*) object_pointer27_3, strings_array27_4, (long) style27, *(wxValidator*) object_pointer27_6, wxString(name27, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCheckListBox_php*)native_object)->Create((wxWindow*) object_pointer27_0, (wxWindowID) id27, *(wxPoint*) object_pointer27_2, *(wxSize*) object_pointer27_3, strings_array27_4, (long) style27, *(wxValidator*) object_pointer27_6, wxString(name27, wxConvUTF8)));

				references->AddReference(parent27, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos27, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size27, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator27, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload28_called)
	{
		wxArrayString strings_array28_4;
		bool strings_continue28_4 = true;

		switch(arguments_received)
		{
			case 5:
			{
				int array_index28_4 = 0;
				zval** temp_array_value28_4 = 0;
				while(strings_continue28_4)
				{
					if(zend_hash_index_find(HASH_OF(choices28), array_index28_4, (void**)&temp_array_value28_4) == SUCCESS)
					{
						convert_to_string(*temp_array_value28_4);
						strings_array28_4.Add(wxString(Z_STRVAL_PP(temp_array_value28_4), wxConvUTF8));
						array_index28_4++;
					}
					else
					{
						strings_continue28_4 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxChoice::Create((wxWindow*) object_pointer28_0, (wxWindowID) id28, *(wxPoint*) object_pointer28_2, *(wxSize*) object_pointer28_3, strings_array28_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxChoice_php*)native_object)->Create((wxWindow*) object_pointer28_0, (wxWindowID) id28, *(wxPoint*) object_pointer28_2, *(wxSize*) object_pointer28_3, strings_array28_4));

				references->AddReference(parent28, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos28, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size28, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				int array_index28_4 = 0;
				zval** temp_array_value28_4 = 0;
				while(strings_continue28_4)
				{
					if(zend_hash_index_find(HASH_OF(choices28), array_index28_4, (void**)&temp_array_value28_4) == SUCCESS)
					{
						convert_to_string(*temp_array_value28_4);
						strings_array28_4.Add(wxString(Z_STRVAL_PP(temp_array_value28_4), wxConvUTF8));
						array_index28_4++;
					}
					else
					{
						strings_continue28_4 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxChoice::Create((wxWindow*) object_pointer28_0, (wxWindowID) id28, *(wxPoint*) object_pointer28_2, *(wxSize*) object_pointer28_3, strings_array28_4, (long) style28))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxChoice_php*)native_object)->Create((wxWindow*) object_pointer28_0, (wxWindowID) id28, *(wxPoint*) object_pointer28_2, *(wxSize*) object_pointer28_3, strings_array28_4, (long) style28));

				references->AddReference(parent28, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos28, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size28, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				int array_index28_4 = 0;
				zval** temp_array_value28_4 = 0;
				while(strings_continue28_4)
				{
					if(zend_hash_index_find(HASH_OF(choices28), array_index28_4, (void**)&temp_array_value28_4) == SUCCESS)
					{
						convert_to_string(*temp_array_value28_4);
						strings_array28_4.Add(wxString(Z_STRVAL_PP(temp_array_value28_4), wxConvUTF8));
						array_index28_4++;
					}
					else
					{
						strings_continue28_4 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxChoice::Create((wxWindow*) object_pointer28_0, (wxWindowID) id28, *(wxPoint*) object_pointer28_2, *(wxSize*) object_pointer28_3, strings_array28_4, (long) style28, *(wxValidator*) object_pointer28_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxChoice_php*)native_object)->Create((wxWindow*) object_pointer28_0, (wxWindowID) id28, *(wxPoint*) object_pointer28_2, *(wxSize*) object_pointer28_3, strings_array28_4, (long) style28, *(wxValidator*) object_pointer28_6));

				references->AddReference(parent28, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos28, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size28, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator28, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				int array_index28_4 = 0;
				zval** temp_array_value28_4 = 0;
				while(strings_continue28_4)
				{
					if(zend_hash_index_find(HASH_OF(choices28), array_index28_4, (void**)&temp_array_value28_4) == SUCCESS)
					{
						convert_to_string(*temp_array_value28_4);
						strings_array28_4.Add(wxString(Z_STRVAL_PP(temp_array_value28_4), wxConvUTF8));
						array_index28_4++;
					}
					else
					{
						strings_continue28_4 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxChoice::Create((wxWindow*) object_pointer28_0, (wxWindowID) id28, *(wxPoint*) object_pointer28_2, *(wxSize*) object_pointer28_3, strings_array28_4, (long) style28, *(wxValidator*) object_pointer28_6, wxString(name28, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxChoice_php*)native_object)->Create((wxWindow*) object_pointer28_0, (wxWindowID) id28, *(wxPoint*) object_pointer28_2, *(wxSize*) object_pointer28_3, strings_array28_4, (long) style28, *(wxValidator*) object_pointer28_6, wxString(name28, wxConvUTF8)));

				references->AddReference(parent28, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos28, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size28, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator28, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload29_called)
	{
		int array_count29_5 = 1;
		HashTable* arr_hash29_5;
		if(arguments_received > 5)
		{
			arr_hash29_5 = Z_ARRVAL_P(choices29);
			array_count29_5 = zend_hash_num_elements(arr_hash29_5);
		}
		wxString* strings_array29_5 = new wxString[array_count29_5];
		bool strings_continue29_5 = true;

		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxChoice::Create((wxWindow*) object_pointer29_0, (wxWindowID) id29))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxChoice_php*)native_object)->Create((wxWindow*) object_pointer29_0, (wxWindowID) id29));

				references->AddReference(parent29, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxChoice::Create((wxWindow*) object_pointer29_0, (wxWindowID) id29, *(wxPoint*) object_pointer29_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxChoice_php*)native_object)->Create((wxWindow*) object_pointer29_0, (wxWindowID) id29, *(wxPoint*) object_pointer29_2));

				references->AddReference(parent29, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(pos29, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxChoice::Create((wxWindow*) object_pointer29_0, (wxWindowID) id29, *(wxPoint*) object_pointer29_2, *(wxSize*) object_pointer29_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxChoice_php*)native_object)->Create((wxWindow*) object_pointer29_0, (wxWindowID) id29, *(wxPoint*) object_pointer29_2, *(wxSize*) object_pointer29_3));

				references->AddReference(parent29, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos29, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(size29, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxChoice::Create((wxWindow*) object_pointer29_0, (wxWindowID) id29, *(wxPoint*) object_pointer29_2, *(wxSize*) object_pointer29_3, (int) n29))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxChoice_php*)native_object)->Create((wxWindow*) object_pointer29_0, (wxWindowID) id29, *(wxPoint*) object_pointer29_2, *(wxSize*) object_pointer29_3, (int) n29));

				references->AddReference(parent29, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos29, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size29, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				int array_index29_5 = 0;
				zval** temp_array_value29_5 = 0;
				while(strings_continue29_5)
				{
					if(zend_hash_index_find(HASH_OF(choices29), array_index29_5, (void**)&temp_array_value29_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value29_5);
						strings_array29_5[array_index29_5] = wxString(Z_STRVAL_PP(temp_array_value29_5), wxConvUTF8);
						array_index29_5++;
					}
					else
					{
						strings_continue29_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxChoice::Create((wxWindow*) object_pointer29_0, (wxWindowID) id29, *(wxPoint*) object_pointer29_2, *(wxSize*) object_pointer29_3, (int) n29, strings_array29_5))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxChoice_php*)native_object)->Create((wxWindow*) object_pointer29_0, (wxWindowID) id29, *(wxPoint*) object_pointer29_2, *(wxSize*) object_pointer29_3, (int) n29, strings_array29_5));

				references->AddReference(parent29, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos29, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size29, "wxWindow::Create at call with 6 argument(s)");
				delete[] strings_array29_5;

				return;
				break;
			}
			case 7:
			{
				int array_index29_5 = 0;
				zval** temp_array_value29_5 = 0;
				while(strings_continue29_5)
				{
					if(zend_hash_index_find(HASH_OF(choices29), array_index29_5, (void**)&temp_array_value29_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value29_5);
						strings_array29_5[array_index29_5] = wxString(Z_STRVAL_PP(temp_array_value29_5), wxConvUTF8);
						array_index29_5++;
					}
					else
					{
						strings_continue29_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxChoice::Create((wxWindow*) object_pointer29_0, (wxWindowID) id29, *(wxPoint*) object_pointer29_2, *(wxSize*) object_pointer29_3, (int) n29, strings_array29_5, (long) style29))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxChoice_php*)native_object)->Create((wxWindow*) object_pointer29_0, (wxWindowID) id29, *(wxPoint*) object_pointer29_2, *(wxSize*) object_pointer29_3, (int) n29, strings_array29_5, (long) style29));

				references->AddReference(parent29, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos29, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size29, "wxWindow::Create at call with 7 argument(s)");
				delete[] strings_array29_5;

				return;
				break;
			}
			case 8:
			{
				int array_index29_5 = 0;
				zval** temp_array_value29_5 = 0;
				while(strings_continue29_5)
				{
					if(zend_hash_index_find(HASH_OF(choices29), array_index29_5, (void**)&temp_array_value29_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value29_5);
						strings_array29_5[array_index29_5] = wxString(Z_STRVAL_PP(temp_array_value29_5), wxConvUTF8);
						array_index29_5++;
					}
					else
					{
						strings_continue29_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxChoice::Create((wxWindow*) object_pointer29_0, (wxWindowID) id29, *(wxPoint*) object_pointer29_2, *(wxSize*) object_pointer29_3, (int) n29, strings_array29_5, (long) style29, *(wxValidator*) object_pointer29_7))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxChoice_php*)native_object)->Create((wxWindow*) object_pointer29_0, (wxWindowID) id29, *(wxPoint*) object_pointer29_2, *(wxSize*) object_pointer29_3, (int) n29, strings_array29_5, (long) style29, *(wxValidator*) object_pointer29_7));

				references->AddReference(parent29, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos29, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size29, "wxWindow::Create at call with 8 argument(s)");
				delete[] strings_array29_5;
				references->AddReference(validator29, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
			case 9:
			{
				int array_index29_5 = 0;
				zval** temp_array_value29_5 = 0;
				while(strings_continue29_5)
				{
					if(zend_hash_index_find(HASH_OF(choices29), array_index29_5, (void**)&temp_array_value29_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value29_5);
						strings_array29_5[array_index29_5] = wxString(Z_STRVAL_PP(temp_array_value29_5), wxConvUTF8);
						array_index29_5++;
					}
					else
					{
						strings_continue29_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxChoice::Create((wxWindow*) object_pointer29_0, (wxWindowID) id29, *(wxPoint*) object_pointer29_2, *(wxSize*) object_pointer29_3, (int) n29, strings_array29_5, (long) style29, *(wxValidator*) object_pointer29_7, wxString(name29, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxChoice_php*)native_object)->Create((wxWindow*) object_pointer29_0, (wxWindowID) id29, *(wxPoint*) object_pointer29_2, *(wxSize*) object_pointer29_3, (int) n29, strings_array29_5, (long) style29, *(wxValidator*) object_pointer29_7, wxString(name29, wxConvUTF8)));

				references->AddReference(parent29, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(pos29, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(size29, "wxWindow::Create at call with 9 argument(s)");
				delete[] strings_array29_5;
				references->AddReference(validator29, "wxWindow::Create at call with 9 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload30_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxAuiNotebook::Create((wxWindow*) object_pointer30_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxAuiNotebook_php*)native_object)->Create((wxWindow*) object_pointer30_0));

				references->AddReference(parent30, "wxWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxAuiNotebook::Create((wxWindow*) object_pointer30_0, (wxWindowID) id30))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxAuiNotebook_php*)native_object)->Create((wxWindow*) object_pointer30_0, (wxWindowID) id30));

				references->AddReference(parent30, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxAuiNotebook::Create((wxWindow*) object_pointer30_0, (wxWindowID) id30, *(wxPoint*) object_pointer30_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxAuiNotebook_php*)native_object)->Create((wxWindow*) object_pointer30_0, (wxWindowID) id30, *(wxPoint*) object_pointer30_2));

				references->AddReference(parent30, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(pos30, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxAuiNotebook::Create((wxWindow*) object_pointer30_0, (wxWindowID) id30, *(wxPoint*) object_pointer30_2, *(wxSize*) object_pointer30_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxAuiNotebook_php*)native_object)->Create((wxWindow*) object_pointer30_0, (wxWindowID) id30, *(wxPoint*) object_pointer30_2, *(wxSize*) object_pointer30_3));

				references->AddReference(parent30, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos30, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(size30, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxAuiNotebook::Create((wxWindow*) object_pointer30_0, (wxWindowID) id30, *(wxPoint*) object_pointer30_2, *(wxSize*) object_pointer30_3, (long) style30))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxAuiNotebook_php*)native_object)->Create((wxWindow*) object_pointer30_0, (wxWindowID) id30, *(wxPoint*) object_pointer30_2, *(wxSize*) object_pointer30_3, (long) style30));

				references->AddReference(parent30, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos30, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size30, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload31_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxAnimationCtrl::Create((wxWindow*) object_pointer31_0, (wxWindowID) id31))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxAnimationCtrl_php*)native_object)->Create((wxWindow*) object_pointer31_0, (wxWindowID) id31));

				references->AddReference(parent31, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxAnimationCtrl::Create((wxWindow*) object_pointer31_0, (wxWindowID) id31, *(wxAnimation*) object_pointer31_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxAnimationCtrl_php*)native_object)->Create((wxWindow*) object_pointer31_0, (wxWindowID) id31, *(wxAnimation*) object_pointer31_2));

				references->AddReference(parent31, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(anim31, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxAnimationCtrl::Create((wxWindow*) object_pointer31_0, (wxWindowID) id31, *(wxAnimation*) object_pointer31_2, *(wxPoint*) object_pointer31_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxAnimationCtrl_php*)native_object)->Create((wxWindow*) object_pointer31_0, (wxWindowID) id31, *(wxAnimation*) object_pointer31_2, *(wxPoint*) object_pointer31_3));

				references->AddReference(parent31, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(anim31, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos31, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxAnimationCtrl::Create((wxWindow*) object_pointer31_0, (wxWindowID) id31, *(wxAnimation*) object_pointer31_2, *(wxPoint*) object_pointer31_3, *(wxSize*) object_pointer31_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxAnimationCtrl_php*)native_object)->Create((wxWindow*) object_pointer31_0, (wxWindowID) id31, *(wxAnimation*) object_pointer31_2, *(wxPoint*) object_pointer31_3, *(wxSize*) object_pointer31_4));

				references->AddReference(parent31, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(anim31, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos31, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size31, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxAnimationCtrl::Create((wxWindow*) object_pointer31_0, (wxWindowID) id31, *(wxAnimation*) object_pointer31_2, *(wxPoint*) object_pointer31_3, *(wxSize*) object_pointer31_4, (long) style31))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxAnimationCtrl_php*)native_object)->Create((wxWindow*) object_pointer31_0, (wxWindowID) id31, *(wxAnimation*) object_pointer31_2, *(wxPoint*) object_pointer31_3, *(wxSize*) object_pointer31_4, (long) style31));

				references->AddReference(parent31, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(anim31, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos31, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size31, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxAnimationCtrl::Create((wxWindow*) object_pointer31_0, (wxWindowID) id31, *(wxAnimation*) object_pointer31_2, *(wxPoint*) object_pointer31_3, *(wxSize*) object_pointer31_4, (long) style31, wxString(name31, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxAnimationCtrl_php*)native_object)->Create((wxWindow*) object_pointer31_0, (wxWindowID) id31, *(wxAnimation*) object_pointer31_2, *(wxPoint*) object_pointer31_3, *(wxSize*) object_pointer31_4, (long) style31, wxString(name31, wxConvUTF8)));

				references->AddReference(parent31, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(anim31, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos31, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size31, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload32_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxScrollBar::Create((wxWindow*) object_pointer32_0, (wxWindowID) id32))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxScrollBar_php*)native_object)->Create((wxWindow*) object_pointer32_0, (wxWindowID) id32));

				references->AddReference(parent32, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxScrollBar::Create((wxWindow*) object_pointer32_0, (wxWindowID) id32, *(wxPoint*) object_pointer32_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxScrollBar_php*)native_object)->Create((wxWindow*) object_pointer32_0, (wxWindowID) id32, *(wxPoint*) object_pointer32_2));

				references->AddReference(parent32, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(pos32, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxScrollBar::Create((wxWindow*) object_pointer32_0, (wxWindowID) id32, *(wxPoint*) object_pointer32_2, *(wxSize*) object_pointer32_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxScrollBar_php*)native_object)->Create((wxWindow*) object_pointer32_0, (wxWindowID) id32, *(wxPoint*) object_pointer32_2, *(wxSize*) object_pointer32_3));

				references->AddReference(parent32, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos32, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(size32, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxScrollBar::Create((wxWindow*) object_pointer32_0, (wxWindowID) id32, *(wxPoint*) object_pointer32_2, *(wxSize*) object_pointer32_3, (long) style32))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxScrollBar_php*)native_object)->Create((wxWindow*) object_pointer32_0, (wxWindowID) id32, *(wxPoint*) object_pointer32_2, *(wxSize*) object_pointer32_3, (long) style32));

				references->AddReference(parent32, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos32, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size32, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxScrollBar::Create((wxWindow*) object_pointer32_0, (wxWindowID) id32, *(wxPoint*) object_pointer32_2, *(wxSize*) object_pointer32_3, (long) style32, *(wxValidator*) object_pointer32_5))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxScrollBar_php*)native_object)->Create((wxWindow*) object_pointer32_0, (wxWindowID) id32, *(wxPoint*) object_pointer32_2, *(wxSize*) object_pointer32_3, (long) style32, *(wxValidator*) object_pointer32_5));

				references->AddReference(parent32, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos32, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size32, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(validator32, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxScrollBar::Create((wxWindow*) object_pointer32_0, (wxWindowID) id32, *(wxPoint*) object_pointer32_2, *(wxSize*) object_pointer32_3, (long) style32, *(wxValidator*) object_pointer32_5, wxString(name32, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxScrollBar_php*)native_object)->Create((wxWindow*) object_pointer32_0, (wxWindowID) id32, *(wxPoint*) object_pointer32_2, *(wxSize*) object_pointer32_3, (long) style32, *(wxValidator*) object_pointer32_5, wxString(name32, wxConvUTF8)));

				references->AddReference(parent32, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos32, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size32, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator32, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload33_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStaticText::Create((wxWindow*) object_pointer33_0, (wxWindowID) id33, wxString(label33, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStaticText_php*)native_object)->Create((wxWindow*) object_pointer33_0, (wxWindowID) id33, wxString(label33, wxConvUTF8)));

				references->AddReference(parent33, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStaticText::Create((wxWindow*) object_pointer33_0, (wxWindowID) id33, wxString(label33, wxConvUTF8), *(wxPoint*) object_pointer33_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStaticText_php*)native_object)->Create((wxWindow*) object_pointer33_0, (wxWindowID) id33, wxString(label33, wxConvUTF8), *(wxPoint*) object_pointer33_3));

				references->AddReference(parent33, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos33, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStaticText::Create((wxWindow*) object_pointer33_0, (wxWindowID) id33, wxString(label33, wxConvUTF8), *(wxPoint*) object_pointer33_3, *(wxSize*) object_pointer33_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStaticText_php*)native_object)->Create((wxWindow*) object_pointer33_0, (wxWindowID) id33, wxString(label33, wxConvUTF8), *(wxPoint*) object_pointer33_3, *(wxSize*) object_pointer33_4));

				references->AddReference(parent33, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos33, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size33, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStaticText::Create((wxWindow*) object_pointer33_0, (wxWindowID) id33, wxString(label33, wxConvUTF8), *(wxPoint*) object_pointer33_3, *(wxSize*) object_pointer33_4, (long) style33))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStaticText_php*)native_object)->Create((wxWindow*) object_pointer33_0, (wxWindowID) id33, wxString(label33, wxConvUTF8), *(wxPoint*) object_pointer33_3, *(wxSize*) object_pointer33_4, (long) style33));

				references->AddReference(parent33, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos33, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size33, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStaticText::Create((wxWindow*) object_pointer33_0, (wxWindowID) id33, wxString(label33, wxConvUTF8), *(wxPoint*) object_pointer33_3, *(wxSize*) object_pointer33_4, (long) style33, wxString(name33, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStaticText_php*)native_object)->Create((wxWindow*) object_pointer33_0, (wxWindowID) id33, wxString(label33, wxConvUTF8), *(wxPoint*) object_pointer33_3, *(wxSize*) object_pointer33_4, (long) style33, wxString(name33, wxConvUTF8)));

				references->AddReference(parent33, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos33, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size33, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload34_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStaticBox::Create((wxWindow*) object_pointer34_0, (wxWindowID) id34, wxString(label34, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStaticBox_php*)native_object)->Create((wxWindow*) object_pointer34_0, (wxWindowID) id34, wxString(label34, wxConvUTF8)));

				references->AddReference(parent34, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStaticBox::Create((wxWindow*) object_pointer34_0, (wxWindowID) id34, wxString(label34, wxConvUTF8), *(wxPoint*) object_pointer34_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStaticBox_php*)native_object)->Create((wxWindow*) object_pointer34_0, (wxWindowID) id34, wxString(label34, wxConvUTF8), *(wxPoint*) object_pointer34_3));

				references->AddReference(parent34, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos34, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStaticBox::Create((wxWindow*) object_pointer34_0, (wxWindowID) id34, wxString(label34, wxConvUTF8), *(wxPoint*) object_pointer34_3, *(wxSize*) object_pointer34_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStaticBox_php*)native_object)->Create((wxWindow*) object_pointer34_0, (wxWindowID) id34, wxString(label34, wxConvUTF8), *(wxPoint*) object_pointer34_3, *(wxSize*) object_pointer34_4));

				references->AddReference(parent34, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos34, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size34, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStaticBox::Create((wxWindow*) object_pointer34_0, (wxWindowID) id34, wxString(label34, wxConvUTF8), *(wxPoint*) object_pointer34_3, *(wxSize*) object_pointer34_4, (long) style34))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStaticBox_php*)native_object)->Create((wxWindow*) object_pointer34_0, (wxWindowID) id34, wxString(label34, wxConvUTF8), *(wxPoint*) object_pointer34_3, *(wxSize*) object_pointer34_4, (long) style34));

				references->AddReference(parent34, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos34, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size34, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStaticBox::Create((wxWindow*) object_pointer34_0, (wxWindowID) id34, wxString(label34, wxConvUTF8), *(wxPoint*) object_pointer34_3, *(wxSize*) object_pointer34_4, (long) style34, wxString(name34, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStaticBox_php*)native_object)->Create((wxWindow*) object_pointer34_0, (wxWindowID) id34, wxString(label34, wxConvUTF8), *(wxPoint*) object_pointer34_3, *(wxSize*) object_pointer34_4, (long) style34, wxString(name34, wxConvUTF8)));

				references->AddReference(parent34, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos34, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size34, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload35_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStaticBitmap::Create((wxWindow*) object_pointer35_0, (wxWindowID) id35, *(wxBitmap*) object_pointer35_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStaticBitmap_php*)native_object)->Create((wxWindow*) object_pointer35_0, (wxWindowID) id35, *(wxBitmap*) object_pointer35_2));

				references->AddReference(parent35, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(label35, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStaticBitmap::Create((wxWindow*) object_pointer35_0, (wxWindowID) id35, *(wxBitmap*) object_pointer35_2, *(wxPoint*) object_pointer35_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStaticBitmap_php*)native_object)->Create((wxWindow*) object_pointer35_0, (wxWindowID) id35, *(wxBitmap*) object_pointer35_2, *(wxPoint*) object_pointer35_3));

				references->AddReference(parent35, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(label35, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos35, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStaticBitmap::Create((wxWindow*) object_pointer35_0, (wxWindowID) id35, *(wxBitmap*) object_pointer35_2, *(wxPoint*) object_pointer35_3, *(wxSize*) object_pointer35_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStaticBitmap_php*)native_object)->Create((wxWindow*) object_pointer35_0, (wxWindowID) id35, *(wxBitmap*) object_pointer35_2, *(wxPoint*) object_pointer35_3, *(wxSize*) object_pointer35_4));

				references->AddReference(parent35, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(label35, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos35, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size35, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStaticBitmap::Create((wxWindow*) object_pointer35_0, (wxWindowID) id35, *(wxBitmap*) object_pointer35_2, *(wxPoint*) object_pointer35_3, *(wxSize*) object_pointer35_4, (long) style35))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStaticBitmap_php*)native_object)->Create((wxWindow*) object_pointer35_0, (wxWindowID) id35, *(wxBitmap*) object_pointer35_2, *(wxPoint*) object_pointer35_3, *(wxSize*) object_pointer35_4, (long) style35));

				references->AddReference(parent35, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(label35, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos35, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size35, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxStaticBitmap::Create((wxWindow*) object_pointer35_0, (wxWindowID) id35, *(wxBitmap*) object_pointer35_2, *(wxPoint*) object_pointer35_3, *(wxSize*) object_pointer35_4, (long) style35, wxString(name35, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxStaticBitmap_php*)native_object)->Create((wxWindow*) object_pointer35_0, (wxWindowID) id35, *(wxBitmap*) object_pointer35_2, *(wxPoint*) object_pointer35_3, *(wxSize*) object_pointer35_4, (long) style35, wxString(name35, wxConvUTF8)));

				references->AddReference(parent35, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(label35, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos35, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size35, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload36_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCheckBox::Create((wxWindow*) object_pointer36_0, (wxWindowID) id36, wxString(label36, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCheckBox_php*)native_object)->Create((wxWindow*) object_pointer36_0, (wxWindowID) id36, wxString(label36, wxConvUTF8)));

				references->AddReference(parent36, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCheckBox::Create((wxWindow*) object_pointer36_0, (wxWindowID) id36, wxString(label36, wxConvUTF8), *(wxPoint*) object_pointer36_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCheckBox_php*)native_object)->Create((wxWindow*) object_pointer36_0, (wxWindowID) id36, wxString(label36, wxConvUTF8), *(wxPoint*) object_pointer36_3));

				references->AddReference(parent36, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos36, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCheckBox::Create((wxWindow*) object_pointer36_0, (wxWindowID) id36, wxString(label36, wxConvUTF8), *(wxPoint*) object_pointer36_3, *(wxSize*) object_pointer36_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCheckBox_php*)native_object)->Create((wxWindow*) object_pointer36_0, (wxWindowID) id36, wxString(label36, wxConvUTF8), *(wxPoint*) object_pointer36_3, *(wxSize*) object_pointer36_4));

				references->AddReference(parent36, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos36, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size36, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCheckBox::Create((wxWindow*) object_pointer36_0, (wxWindowID) id36, wxString(label36, wxConvUTF8), *(wxPoint*) object_pointer36_3, *(wxSize*) object_pointer36_4, (long) style36))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCheckBox_php*)native_object)->Create((wxWindow*) object_pointer36_0, (wxWindowID) id36, wxString(label36, wxConvUTF8), *(wxPoint*) object_pointer36_3, *(wxSize*) object_pointer36_4, (long) style36));

				references->AddReference(parent36, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos36, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size36, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCheckBox::Create((wxWindow*) object_pointer36_0, (wxWindowID) id36, wxString(label36, wxConvUTF8), *(wxPoint*) object_pointer36_3, *(wxSize*) object_pointer36_4, (long) style36, *(wxValidator*) object_pointer36_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCheckBox_php*)native_object)->Create((wxWindow*) object_pointer36_0, (wxWindowID) id36, wxString(label36, wxConvUTF8), *(wxPoint*) object_pointer36_3, *(wxSize*) object_pointer36_4, (long) style36, *(wxValidator*) object_pointer36_6));

				references->AddReference(parent36, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos36, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size36, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator36, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCheckBox::Create((wxWindow*) object_pointer36_0, (wxWindowID) id36, wxString(label36, wxConvUTF8), *(wxPoint*) object_pointer36_3, *(wxSize*) object_pointer36_4, (long) style36, *(wxValidator*) object_pointer36_6, wxString(name36, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCheckBox_php*)native_object)->Create((wxWindow*) object_pointer36_0, (wxWindowID) id36, wxString(label36, wxConvUTF8), *(wxPoint*) object_pointer36_3, *(wxSize*) object_pointer36_4, (long) style36, *(wxValidator*) object_pointer36_6, wxString(name36, wxConvUTF8)));

				references->AddReference(parent36, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos36, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size36, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator36, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload37_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTextCtrl::Create((wxWindow*) object_pointer37_0, (wxWindowID) id37))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTextCtrl_php*)native_object)->Create((wxWindow*) object_pointer37_0, (wxWindowID) id37));

				references->AddReference(parent37, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTextCtrl::Create((wxWindow*) object_pointer37_0, (wxWindowID) id37, wxString(value37, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTextCtrl_php*)native_object)->Create((wxWindow*) object_pointer37_0, (wxWindowID) id37, wxString(value37, wxConvUTF8)));

				references->AddReference(parent37, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTextCtrl::Create((wxWindow*) object_pointer37_0, (wxWindowID) id37, wxString(value37, wxConvUTF8), *(wxPoint*) object_pointer37_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTextCtrl_php*)native_object)->Create((wxWindow*) object_pointer37_0, (wxWindowID) id37, wxString(value37, wxConvUTF8), *(wxPoint*) object_pointer37_3));

				references->AddReference(parent37, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos37, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTextCtrl::Create((wxWindow*) object_pointer37_0, (wxWindowID) id37, wxString(value37, wxConvUTF8), *(wxPoint*) object_pointer37_3, *(wxSize*) object_pointer37_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTextCtrl_php*)native_object)->Create((wxWindow*) object_pointer37_0, (wxWindowID) id37, wxString(value37, wxConvUTF8), *(wxPoint*) object_pointer37_3, *(wxSize*) object_pointer37_4));

				references->AddReference(parent37, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos37, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size37, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTextCtrl::Create((wxWindow*) object_pointer37_0, (wxWindowID) id37, wxString(value37, wxConvUTF8), *(wxPoint*) object_pointer37_3, *(wxSize*) object_pointer37_4, (long) style37))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTextCtrl_php*)native_object)->Create((wxWindow*) object_pointer37_0, (wxWindowID) id37, wxString(value37, wxConvUTF8), *(wxPoint*) object_pointer37_3, *(wxSize*) object_pointer37_4, (long) style37));

				references->AddReference(parent37, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos37, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size37, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTextCtrl::Create((wxWindow*) object_pointer37_0, (wxWindowID) id37, wxString(value37, wxConvUTF8), *(wxPoint*) object_pointer37_3, *(wxSize*) object_pointer37_4, (long) style37, *(wxValidator*) object_pointer37_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTextCtrl_php*)native_object)->Create((wxWindow*) object_pointer37_0, (wxWindowID) id37, wxString(value37, wxConvUTF8), *(wxPoint*) object_pointer37_3, *(wxSize*) object_pointer37_4, (long) style37, *(wxValidator*) object_pointer37_6));

				references->AddReference(parent37, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos37, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size37, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator37, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTextCtrl::Create((wxWindow*) object_pointer37_0, (wxWindowID) id37, wxString(value37, wxConvUTF8), *(wxPoint*) object_pointer37_3, *(wxSize*) object_pointer37_4, (long) style37, *(wxValidator*) object_pointer37_6, wxString(name37, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTextCtrl_php*)native_object)->Create((wxWindow*) object_pointer37_0, (wxWindowID) id37, wxString(value37, wxConvUTF8), *(wxPoint*) object_pointer37_3, *(wxSize*) object_pointer37_4, (long) style37, *(wxValidator*) object_pointer37_6, wxString(name37, wxConvUTF8)));

				references->AddReference(parent37, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos37, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size37, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator37, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload38_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSearchCtrl::Create((wxWindow*) object_pointer38_0, (wxWindowID) id38))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSearchCtrl_php*)native_object)->Create((wxWindow*) object_pointer38_0, (wxWindowID) id38));

				references->AddReference(parent38, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSearchCtrl::Create((wxWindow*) object_pointer38_0, (wxWindowID) id38, wxString(value38, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSearchCtrl_php*)native_object)->Create((wxWindow*) object_pointer38_0, (wxWindowID) id38, wxString(value38, wxConvUTF8)));

				references->AddReference(parent38, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSearchCtrl::Create((wxWindow*) object_pointer38_0, (wxWindowID) id38, wxString(value38, wxConvUTF8), *(wxPoint*) object_pointer38_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSearchCtrl_php*)native_object)->Create((wxWindow*) object_pointer38_0, (wxWindowID) id38, wxString(value38, wxConvUTF8), *(wxPoint*) object_pointer38_3));

				references->AddReference(parent38, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos38, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSearchCtrl::Create((wxWindow*) object_pointer38_0, (wxWindowID) id38, wxString(value38, wxConvUTF8), *(wxPoint*) object_pointer38_3, *(wxSize*) object_pointer38_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSearchCtrl_php*)native_object)->Create((wxWindow*) object_pointer38_0, (wxWindowID) id38, wxString(value38, wxConvUTF8), *(wxPoint*) object_pointer38_3, *(wxSize*) object_pointer38_4));

				references->AddReference(parent38, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos38, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size38, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSearchCtrl::Create((wxWindow*) object_pointer38_0, (wxWindowID) id38, wxString(value38, wxConvUTF8), *(wxPoint*) object_pointer38_3, *(wxSize*) object_pointer38_4, (long) style38))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSearchCtrl_php*)native_object)->Create((wxWindow*) object_pointer38_0, (wxWindowID) id38, wxString(value38, wxConvUTF8), *(wxPoint*) object_pointer38_3, *(wxSize*) object_pointer38_4, (long) style38));

				references->AddReference(parent38, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos38, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size38, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSearchCtrl::Create((wxWindow*) object_pointer38_0, (wxWindowID) id38, wxString(value38, wxConvUTF8), *(wxPoint*) object_pointer38_3, *(wxSize*) object_pointer38_4, (long) style38, *(wxValidator*) object_pointer38_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSearchCtrl_php*)native_object)->Create((wxWindow*) object_pointer38_0, (wxWindowID) id38, wxString(value38, wxConvUTF8), *(wxPoint*) object_pointer38_3, *(wxSize*) object_pointer38_4, (long) style38, *(wxValidator*) object_pointer38_6));

				references->AddReference(parent38, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos38, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size38, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator38, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSearchCtrl::Create((wxWindow*) object_pointer38_0, (wxWindowID) id38, wxString(value38, wxConvUTF8), *(wxPoint*) object_pointer38_3, *(wxSize*) object_pointer38_4, (long) style38, *(wxValidator*) object_pointer38_6, wxString(name38, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSearchCtrl_php*)native_object)->Create((wxWindow*) object_pointer38_0, (wxWindowID) id38, wxString(value38, wxConvUTF8), *(wxPoint*) object_pointer38_3, *(wxSize*) object_pointer38_4, (long) style38, *(wxValidator*) object_pointer38_6, wxString(name38, wxConvUTF8)));

				references->AddReference(parent38, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos38, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size38, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator38, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload39_called)
	{
		int array_count39_6 = 1;
		HashTable* arr_hash39_6;
		if(arguments_received > 6)
		{
			arr_hash39_6 = Z_ARRVAL_P(choices39);
			array_count39_6 = zend_hash_num_elements(arr_hash39_6);
		}
		wxString* strings_array39_6 = new wxString[array_count39_6];
		bool strings_continue39_6 = true;

		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboBox::Create((wxWindow*) object_pointer39_0, (wxWindowID) id39))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboBox_php*)native_object)->Create((wxWindow*) object_pointer39_0, (wxWindowID) id39));

				references->AddReference(parent39, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboBox::Create((wxWindow*) object_pointer39_0, (wxWindowID) id39, wxString(value39, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboBox_php*)native_object)->Create((wxWindow*) object_pointer39_0, (wxWindowID) id39, wxString(value39, wxConvUTF8)));

				references->AddReference(parent39, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboBox::Create((wxWindow*) object_pointer39_0, (wxWindowID) id39, wxString(value39, wxConvUTF8), *(wxPoint*) object_pointer39_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboBox_php*)native_object)->Create((wxWindow*) object_pointer39_0, (wxWindowID) id39, wxString(value39, wxConvUTF8), *(wxPoint*) object_pointer39_3));

				references->AddReference(parent39, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos39, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboBox::Create((wxWindow*) object_pointer39_0, (wxWindowID) id39, wxString(value39, wxConvUTF8), *(wxPoint*) object_pointer39_3, *(wxSize*) object_pointer39_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboBox_php*)native_object)->Create((wxWindow*) object_pointer39_0, (wxWindowID) id39, wxString(value39, wxConvUTF8), *(wxPoint*) object_pointer39_3, *(wxSize*) object_pointer39_4));

				references->AddReference(parent39, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos39, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size39, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboBox::Create((wxWindow*) object_pointer39_0, (wxWindowID) id39, wxString(value39, wxConvUTF8), *(wxPoint*) object_pointer39_3, *(wxSize*) object_pointer39_4, (int) n39))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboBox_php*)native_object)->Create((wxWindow*) object_pointer39_0, (wxWindowID) id39, wxString(value39, wxConvUTF8), *(wxPoint*) object_pointer39_3, *(wxSize*) object_pointer39_4, (int) n39));

				references->AddReference(parent39, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos39, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size39, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				int array_index39_6 = 0;
				zval** temp_array_value39_6 = 0;
				while(strings_continue39_6)
				{
					if(zend_hash_index_find(HASH_OF(choices39), array_index39_6, (void**)&temp_array_value39_6) == SUCCESS)
					{
						convert_to_string(*temp_array_value39_6);
						strings_array39_6[array_index39_6] = wxString(Z_STRVAL_PP(temp_array_value39_6), wxConvUTF8);
						array_index39_6++;
					}
					else
					{
						strings_continue39_6 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboBox::Create((wxWindow*) object_pointer39_0, (wxWindowID) id39, wxString(value39, wxConvUTF8), *(wxPoint*) object_pointer39_3, *(wxSize*) object_pointer39_4, (int) n39, strings_array39_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboBox_php*)native_object)->Create((wxWindow*) object_pointer39_0, (wxWindowID) id39, wxString(value39, wxConvUTF8), *(wxPoint*) object_pointer39_3, *(wxSize*) object_pointer39_4, (int) n39, strings_array39_6));

				references->AddReference(parent39, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos39, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size39, "wxWindow::Create at call with 7 argument(s)");
				delete[] strings_array39_6;

				return;
				break;
			}
			case 8:
			{
				int array_index39_6 = 0;
				zval** temp_array_value39_6 = 0;
				while(strings_continue39_6)
				{
					if(zend_hash_index_find(HASH_OF(choices39), array_index39_6, (void**)&temp_array_value39_6) == SUCCESS)
					{
						convert_to_string(*temp_array_value39_6);
						strings_array39_6[array_index39_6] = wxString(Z_STRVAL_PP(temp_array_value39_6), wxConvUTF8);
						array_index39_6++;
					}
					else
					{
						strings_continue39_6 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboBox::Create((wxWindow*) object_pointer39_0, (wxWindowID) id39, wxString(value39, wxConvUTF8), *(wxPoint*) object_pointer39_3, *(wxSize*) object_pointer39_4, (int) n39, strings_array39_6, (long) style39))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboBox_php*)native_object)->Create((wxWindow*) object_pointer39_0, (wxWindowID) id39, wxString(value39, wxConvUTF8), *(wxPoint*) object_pointer39_3, *(wxSize*) object_pointer39_4, (int) n39, strings_array39_6, (long) style39));

				references->AddReference(parent39, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos39, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size39, "wxWindow::Create at call with 8 argument(s)");
				delete[] strings_array39_6;

				return;
				break;
			}
			case 9:
			{
				int array_index39_6 = 0;
				zval** temp_array_value39_6 = 0;
				while(strings_continue39_6)
				{
					if(zend_hash_index_find(HASH_OF(choices39), array_index39_6, (void**)&temp_array_value39_6) == SUCCESS)
					{
						convert_to_string(*temp_array_value39_6);
						strings_array39_6[array_index39_6] = wxString(Z_STRVAL_PP(temp_array_value39_6), wxConvUTF8);
						array_index39_6++;
					}
					else
					{
						strings_continue39_6 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboBox::Create((wxWindow*) object_pointer39_0, (wxWindowID) id39, wxString(value39, wxConvUTF8), *(wxPoint*) object_pointer39_3, *(wxSize*) object_pointer39_4, (int) n39, strings_array39_6, (long) style39, *(wxValidator*) object_pointer39_8))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboBox_php*)native_object)->Create((wxWindow*) object_pointer39_0, (wxWindowID) id39, wxString(value39, wxConvUTF8), *(wxPoint*) object_pointer39_3, *(wxSize*) object_pointer39_4, (int) n39, strings_array39_6, (long) style39, *(wxValidator*) object_pointer39_8));

				references->AddReference(parent39, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(pos39, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(size39, "wxWindow::Create at call with 9 argument(s)");
				delete[] strings_array39_6;
				references->AddReference(validator39, "wxWindow::Create at call with 9 argument(s)");

				return;
				break;
			}
			case 10:
			{
				int array_index39_6 = 0;
				zval** temp_array_value39_6 = 0;
				while(strings_continue39_6)
				{
					if(zend_hash_index_find(HASH_OF(choices39), array_index39_6, (void**)&temp_array_value39_6) == SUCCESS)
					{
						convert_to_string(*temp_array_value39_6);
						strings_array39_6[array_index39_6] = wxString(Z_STRVAL_PP(temp_array_value39_6), wxConvUTF8);
						array_index39_6++;
					}
					else
					{
						strings_continue39_6 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboBox::Create((wxWindow*) object_pointer39_0, (wxWindowID) id39, wxString(value39, wxConvUTF8), *(wxPoint*) object_pointer39_3, *(wxSize*) object_pointer39_4, (int) n39, strings_array39_6, (long) style39, *(wxValidator*) object_pointer39_8, wxString(name39, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboBox_php*)native_object)->Create((wxWindow*) object_pointer39_0, (wxWindowID) id39, wxString(value39, wxConvUTF8), *(wxPoint*) object_pointer39_3, *(wxSize*) object_pointer39_4, (int) n39, strings_array39_6, (long) style39, *(wxValidator*) object_pointer39_8, wxString(name39, wxConvUTF8)));

				references->AddReference(parent39, "wxWindow::Create at call with 10 argument(s)");
				references->AddReference(pos39, "wxWindow::Create at call with 10 argument(s)");
				references->AddReference(size39, "wxWindow::Create at call with 10 argument(s)");
				delete[] strings_array39_6;
				references->AddReference(validator39, "wxWindow::Create at call with 10 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload40_called)
	{
		wxArrayString strings_array40_5;
		bool strings_continue40_5 = true;

		switch(arguments_received)
		{
			case 6:
			{
				int array_index40_5 = 0;
				zval** temp_array_value40_5 = 0;
				while(strings_continue40_5)
				{
					if(zend_hash_index_find(HASH_OF(choices40), array_index40_5, (void**)&temp_array_value40_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value40_5);
						strings_array40_5.Add(wxString(Z_STRVAL_PP(temp_array_value40_5), wxConvUTF8));
						array_index40_5++;
					}
					else
					{
						strings_continue40_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboBox::Create((wxWindow*) object_pointer40_0, (wxWindowID) id40, wxString(value40, wxConvUTF8), *(wxPoint*) object_pointer40_3, *(wxSize*) object_pointer40_4, strings_array40_5))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboBox_php*)native_object)->Create((wxWindow*) object_pointer40_0, (wxWindowID) id40, wxString(value40, wxConvUTF8), *(wxPoint*) object_pointer40_3, *(wxSize*) object_pointer40_4, strings_array40_5));

				references->AddReference(parent40, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos40, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size40, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				int array_index40_5 = 0;
				zval** temp_array_value40_5 = 0;
				while(strings_continue40_5)
				{
					if(zend_hash_index_find(HASH_OF(choices40), array_index40_5, (void**)&temp_array_value40_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value40_5);
						strings_array40_5.Add(wxString(Z_STRVAL_PP(temp_array_value40_5), wxConvUTF8));
						array_index40_5++;
					}
					else
					{
						strings_continue40_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboBox::Create((wxWindow*) object_pointer40_0, (wxWindowID) id40, wxString(value40, wxConvUTF8), *(wxPoint*) object_pointer40_3, *(wxSize*) object_pointer40_4, strings_array40_5, (long) style40))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboBox_php*)native_object)->Create((wxWindow*) object_pointer40_0, (wxWindowID) id40, wxString(value40, wxConvUTF8), *(wxPoint*) object_pointer40_3, *(wxSize*) object_pointer40_4, strings_array40_5, (long) style40));

				references->AddReference(parent40, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos40, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size40, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				int array_index40_5 = 0;
				zval** temp_array_value40_5 = 0;
				while(strings_continue40_5)
				{
					if(zend_hash_index_find(HASH_OF(choices40), array_index40_5, (void**)&temp_array_value40_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value40_5);
						strings_array40_5.Add(wxString(Z_STRVAL_PP(temp_array_value40_5), wxConvUTF8));
						array_index40_5++;
					}
					else
					{
						strings_continue40_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboBox::Create((wxWindow*) object_pointer40_0, (wxWindowID) id40, wxString(value40, wxConvUTF8), *(wxPoint*) object_pointer40_3, *(wxSize*) object_pointer40_4, strings_array40_5, (long) style40, *(wxValidator*) object_pointer40_7))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboBox_php*)native_object)->Create((wxWindow*) object_pointer40_0, (wxWindowID) id40, wxString(value40, wxConvUTF8), *(wxPoint*) object_pointer40_3, *(wxSize*) object_pointer40_4, strings_array40_5, (long) style40, *(wxValidator*) object_pointer40_7));

				references->AddReference(parent40, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos40, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size40, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator40, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
			case 9:
			{
				int array_index40_5 = 0;
				zval** temp_array_value40_5 = 0;
				while(strings_continue40_5)
				{
					if(zend_hash_index_find(HASH_OF(choices40), array_index40_5, (void**)&temp_array_value40_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value40_5);
						strings_array40_5.Add(wxString(Z_STRVAL_PP(temp_array_value40_5), wxConvUTF8));
						array_index40_5++;
					}
					else
					{
						strings_continue40_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboBox::Create((wxWindow*) object_pointer40_0, (wxWindowID) id40, wxString(value40, wxConvUTF8), *(wxPoint*) object_pointer40_3, *(wxSize*) object_pointer40_4, strings_array40_5, (long) style40, *(wxValidator*) object_pointer40_7, wxString(name40, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboBox_php*)native_object)->Create((wxWindow*) object_pointer40_0, (wxWindowID) id40, wxString(value40, wxConvUTF8), *(wxPoint*) object_pointer40_3, *(wxSize*) object_pointer40_4, strings_array40_5, (long) style40, *(wxValidator*) object_pointer40_7, wxString(name40, wxConvUTF8)));

				references->AddReference(parent40, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(pos40, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(size40, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(validator40, "wxWindow::Create at call with 9 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload41_called)
	{
		wxArrayString strings_array41_5;
		bool strings_continue41_5 = true;

		switch(arguments_received)
		{
			case 6:
			{
				int array_index41_5 = 0;
				zval** temp_array_value41_5 = 0;
				while(strings_continue41_5)
				{
					if(zend_hash_index_find(HASH_OF(choices41), array_index41_5, (void**)&temp_array_value41_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value41_5);
						strings_array41_5.Add(wxString(Z_STRVAL_PP(temp_array_value41_5), wxConvUTF8));
						array_index41_5++;
					}
					else
					{
						strings_continue41_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapComboBox::Create((wxWindow*) object_pointer41_0, (wxWindowID) id41, wxString(value41, wxConvUTF8), *(wxPoint*) object_pointer41_3, *(wxSize*) object_pointer41_4, strings_array41_5))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapComboBox_php*)native_object)->Create((wxWindow*) object_pointer41_0, (wxWindowID) id41, wxString(value41, wxConvUTF8), *(wxPoint*) object_pointer41_3, *(wxSize*) object_pointer41_4, strings_array41_5));

				references->AddReference(parent41, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos41, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size41, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				int array_index41_5 = 0;
				zval** temp_array_value41_5 = 0;
				while(strings_continue41_5)
				{
					if(zend_hash_index_find(HASH_OF(choices41), array_index41_5, (void**)&temp_array_value41_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value41_5);
						strings_array41_5.Add(wxString(Z_STRVAL_PP(temp_array_value41_5), wxConvUTF8));
						array_index41_5++;
					}
					else
					{
						strings_continue41_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapComboBox::Create((wxWindow*) object_pointer41_0, (wxWindowID) id41, wxString(value41, wxConvUTF8), *(wxPoint*) object_pointer41_3, *(wxSize*) object_pointer41_4, strings_array41_5, (long) style41))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapComboBox_php*)native_object)->Create((wxWindow*) object_pointer41_0, (wxWindowID) id41, wxString(value41, wxConvUTF8), *(wxPoint*) object_pointer41_3, *(wxSize*) object_pointer41_4, strings_array41_5, (long) style41));

				references->AddReference(parent41, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos41, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size41, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				int array_index41_5 = 0;
				zval** temp_array_value41_5 = 0;
				while(strings_continue41_5)
				{
					if(zend_hash_index_find(HASH_OF(choices41), array_index41_5, (void**)&temp_array_value41_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value41_5);
						strings_array41_5.Add(wxString(Z_STRVAL_PP(temp_array_value41_5), wxConvUTF8));
						array_index41_5++;
					}
					else
					{
						strings_continue41_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapComboBox::Create((wxWindow*) object_pointer41_0, (wxWindowID) id41, wxString(value41, wxConvUTF8), *(wxPoint*) object_pointer41_3, *(wxSize*) object_pointer41_4, strings_array41_5, (long) style41, *(wxValidator*) object_pointer41_7))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapComboBox_php*)native_object)->Create((wxWindow*) object_pointer41_0, (wxWindowID) id41, wxString(value41, wxConvUTF8), *(wxPoint*) object_pointer41_3, *(wxSize*) object_pointer41_4, strings_array41_5, (long) style41, *(wxValidator*) object_pointer41_7));

				references->AddReference(parent41, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos41, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size41, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator41, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
			case 9:
			{
				int array_index41_5 = 0;
				zval** temp_array_value41_5 = 0;
				while(strings_continue41_5)
				{
					if(zend_hash_index_find(HASH_OF(choices41), array_index41_5, (void**)&temp_array_value41_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value41_5);
						strings_array41_5.Add(wxString(Z_STRVAL_PP(temp_array_value41_5), wxConvUTF8));
						array_index41_5++;
					}
					else
					{
						strings_continue41_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapComboBox::Create((wxWindow*) object_pointer41_0, (wxWindowID) id41, wxString(value41, wxConvUTF8), *(wxPoint*) object_pointer41_3, *(wxSize*) object_pointer41_4, strings_array41_5, (long) style41, *(wxValidator*) object_pointer41_7, wxString(name41, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapComboBox_php*)native_object)->Create((wxWindow*) object_pointer41_0, (wxWindowID) id41, wxString(value41, wxConvUTF8), *(wxPoint*) object_pointer41_3, *(wxSize*) object_pointer41_4, strings_array41_5, (long) style41, *(wxValidator*) object_pointer41_7, wxString(name41, wxConvUTF8)));

				references->AddReference(parent41, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(pos41, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(size41, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(validator41, "wxWindow::Create at call with 9 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload42_called)
	{
		int array_count42_6 = 1;
		HashTable* arr_hash42_6;
		if(arguments_received > 6)
		{
			arr_hash42_6 = Z_ARRVAL_P(choices42);
			array_count42_6 = zend_hash_num_elements(arr_hash42_6);
		}
		wxString* strings_array42_6 = new wxString[array_count42_6];
		bool strings_continue42_6 = true;

		switch(arguments_received)
		{
			case 7:
			{
				int array_index42_6 = 0;
				zval** temp_array_value42_6 = 0;
				while(strings_continue42_6)
				{
					if(zend_hash_index_find(HASH_OF(choices42), array_index42_6, (void**)&temp_array_value42_6) == SUCCESS)
					{
						convert_to_string(*temp_array_value42_6);
						strings_array42_6[array_index42_6] = wxString(Z_STRVAL_PP(temp_array_value42_6), wxConvUTF8);
						array_index42_6++;
					}
					else
					{
						strings_continue42_6 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapComboBox::Create((wxWindow*) object_pointer42_0, (wxWindowID) id42, wxString(value42, wxConvUTF8), *(wxPoint*) object_pointer42_3, *(wxSize*) object_pointer42_4, (int) n42, strings_array42_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapComboBox_php*)native_object)->Create((wxWindow*) object_pointer42_0, (wxWindowID) id42, wxString(value42, wxConvUTF8), *(wxPoint*) object_pointer42_3, *(wxSize*) object_pointer42_4, (int) n42, strings_array42_6));

				references->AddReference(parent42, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos42, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size42, "wxWindow::Create at call with 7 argument(s)");
				delete[] strings_array42_6;

				return;
				break;
			}
			case 8:
			{
				int array_index42_6 = 0;
				zval** temp_array_value42_6 = 0;
				while(strings_continue42_6)
				{
					if(zend_hash_index_find(HASH_OF(choices42), array_index42_6, (void**)&temp_array_value42_6) == SUCCESS)
					{
						convert_to_string(*temp_array_value42_6);
						strings_array42_6[array_index42_6] = wxString(Z_STRVAL_PP(temp_array_value42_6), wxConvUTF8);
						array_index42_6++;
					}
					else
					{
						strings_continue42_6 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapComboBox::Create((wxWindow*) object_pointer42_0, (wxWindowID) id42, wxString(value42, wxConvUTF8), *(wxPoint*) object_pointer42_3, *(wxSize*) object_pointer42_4, (int) n42, strings_array42_6, (long) style42))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapComboBox_php*)native_object)->Create((wxWindow*) object_pointer42_0, (wxWindowID) id42, wxString(value42, wxConvUTF8), *(wxPoint*) object_pointer42_3, *(wxSize*) object_pointer42_4, (int) n42, strings_array42_6, (long) style42));

				references->AddReference(parent42, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos42, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size42, "wxWindow::Create at call with 8 argument(s)");
				delete[] strings_array42_6;

				return;
				break;
			}
			case 9:
			{
				int array_index42_6 = 0;
				zval** temp_array_value42_6 = 0;
				while(strings_continue42_6)
				{
					if(zend_hash_index_find(HASH_OF(choices42), array_index42_6, (void**)&temp_array_value42_6) == SUCCESS)
					{
						convert_to_string(*temp_array_value42_6);
						strings_array42_6[array_index42_6] = wxString(Z_STRVAL_PP(temp_array_value42_6), wxConvUTF8);
						array_index42_6++;
					}
					else
					{
						strings_continue42_6 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapComboBox::Create((wxWindow*) object_pointer42_0, (wxWindowID) id42, wxString(value42, wxConvUTF8), *(wxPoint*) object_pointer42_3, *(wxSize*) object_pointer42_4, (int) n42, strings_array42_6, (long) style42, *(wxValidator*) object_pointer42_8))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapComboBox_php*)native_object)->Create((wxWindow*) object_pointer42_0, (wxWindowID) id42, wxString(value42, wxConvUTF8), *(wxPoint*) object_pointer42_3, *(wxSize*) object_pointer42_4, (int) n42, strings_array42_6, (long) style42, *(wxValidator*) object_pointer42_8));

				references->AddReference(parent42, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(pos42, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(size42, "wxWindow::Create at call with 9 argument(s)");
				delete[] strings_array42_6;
				references->AddReference(validator42, "wxWindow::Create at call with 9 argument(s)");

				return;
				break;
			}
			case 10:
			{
				int array_index42_6 = 0;
				zval** temp_array_value42_6 = 0;
				while(strings_continue42_6)
				{
					if(zend_hash_index_find(HASH_OF(choices42), array_index42_6, (void**)&temp_array_value42_6) == SUCCESS)
					{
						convert_to_string(*temp_array_value42_6);
						strings_array42_6[array_index42_6] = wxString(Z_STRVAL_PP(temp_array_value42_6), wxConvUTF8);
						array_index42_6++;
					}
					else
					{
						strings_continue42_6 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBitmapComboBox::Create((wxWindow*) object_pointer42_0, (wxWindowID) id42, wxString(value42, wxConvUTF8), *(wxPoint*) object_pointer42_3, *(wxSize*) object_pointer42_4, (int) n42, strings_array42_6, (long) style42, *(wxValidator*) object_pointer42_8, wxString(name42, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBitmapComboBox_php*)native_object)->Create((wxWindow*) object_pointer42_0, (wxWindowID) id42, wxString(value42, wxConvUTF8), *(wxPoint*) object_pointer42_3, *(wxSize*) object_pointer42_4, (int) n42, strings_array42_6, (long) style42, *(wxValidator*) object_pointer42_8, wxString(name42, wxConvUTF8)));

				references->AddReference(parent42, "wxWindow::Create at call with 10 argument(s)");
				references->AddReference(pos42, "wxWindow::Create at call with 10 argument(s)");
				references->AddReference(size42, "wxWindow::Create at call with 10 argument(s)");
				delete[] strings_array42_6;
				references->AddReference(validator42, "wxWindow::Create at call with 10 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload43_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxListCtrl::Create((wxWindow*) object_pointer43_0, (wxWindowID) id43))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxListCtrl_php*)native_object)->Create((wxWindow*) object_pointer43_0, (wxWindowID) id43));

				references->AddReference(parent43, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxListCtrl::Create((wxWindow*) object_pointer43_0, (wxWindowID) id43, *(wxPoint*) object_pointer43_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxListCtrl_php*)native_object)->Create((wxWindow*) object_pointer43_0, (wxWindowID) id43, *(wxPoint*) object_pointer43_2));

				references->AddReference(parent43, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(pos43, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxListCtrl::Create((wxWindow*) object_pointer43_0, (wxWindowID) id43, *(wxPoint*) object_pointer43_2, *(wxSize*) object_pointer43_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxListCtrl_php*)native_object)->Create((wxWindow*) object_pointer43_0, (wxWindowID) id43, *(wxPoint*) object_pointer43_2, *(wxSize*) object_pointer43_3));

				references->AddReference(parent43, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos43, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(size43, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxListCtrl::Create((wxWindow*) object_pointer43_0, (wxWindowID) id43, *(wxPoint*) object_pointer43_2, *(wxSize*) object_pointer43_3, (long) style43))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxListCtrl_php*)native_object)->Create((wxWindow*) object_pointer43_0, (wxWindowID) id43, *(wxPoint*) object_pointer43_2, *(wxSize*) object_pointer43_3, (long) style43));

				references->AddReference(parent43, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos43, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size43, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxListCtrl::Create((wxWindow*) object_pointer43_0, (wxWindowID) id43, *(wxPoint*) object_pointer43_2, *(wxSize*) object_pointer43_3, (long) style43, *(wxValidator*) object_pointer43_5))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxListCtrl_php*)native_object)->Create((wxWindow*) object_pointer43_0, (wxWindowID) id43, *(wxPoint*) object_pointer43_2, *(wxSize*) object_pointer43_3, (long) style43, *(wxValidator*) object_pointer43_5));

				references->AddReference(parent43, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos43, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size43, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(validator43, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxListCtrl::Create((wxWindow*) object_pointer43_0, (wxWindowID) id43, *(wxPoint*) object_pointer43_2, *(wxSize*) object_pointer43_3, (long) style43, *(wxValidator*) object_pointer43_5, wxString(name43, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxListCtrl_php*)native_object)->Create((wxWindow*) object_pointer43_0, (wxWindowID) id43, *(wxPoint*) object_pointer43_2, *(wxSize*) object_pointer43_3, (long) style43, *(wxValidator*) object_pointer43_5, wxString(name43, wxConvUTF8)));

				references->AddReference(parent43, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos43, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size43, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator43, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload44_called)
	{
		int array_count44_6 = 1;
		HashTable* arr_hash44_6;
		if(arguments_received > 6)
		{
			arr_hash44_6 = Z_ARRVAL_P(choices44);
			array_count44_6 = zend_hash_num_elements(arr_hash44_6);
		}
		wxString* strings_array44_6 = new wxString[array_count44_6];
		bool strings_continue44_6 = true;

		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioBox::Create((wxWindow*) object_pointer44_0, (wxWindowID) id44, wxString(label44, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioBox_php*)native_object)->Create((wxWindow*) object_pointer44_0, (wxWindowID) id44, wxString(label44, wxConvUTF8)));

				references->AddReference(parent44, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioBox::Create((wxWindow*) object_pointer44_0, (wxWindowID) id44, wxString(label44, wxConvUTF8), *(wxPoint*) object_pointer44_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioBox_php*)native_object)->Create((wxWindow*) object_pointer44_0, (wxWindowID) id44, wxString(label44, wxConvUTF8), *(wxPoint*) object_pointer44_3));

				references->AddReference(parent44, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos44, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioBox::Create((wxWindow*) object_pointer44_0, (wxWindowID) id44, wxString(label44, wxConvUTF8), *(wxPoint*) object_pointer44_3, *(wxSize*) object_pointer44_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioBox_php*)native_object)->Create((wxWindow*) object_pointer44_0, (wxWindowID) id44, wxString(label44, wxConvUTF8), *(wxPoint*) object_pointer44_3, *(wxSize*) object_pointer44_4));

				references->AddReference(parent44, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos44, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size44, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioBox::Create((wxWindow*) object_pointer44_0, (wxWindowID) id44, wxString(label44, wxConvUTF8), *(wxPoint*) object_pointer44_3, *(wxSize*) object_pointer44_4, (int) n44))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioBox_php*)native_object)->Create((wxWindow*) object_pointer44_0, (wxWindowID) id44, wxString(label44, wxConvUTF8), *(wxPoint*) object_pointer44_3, *(wxSize*) object_pointer44_4, (int) n44));

				references->AddReference(parent44, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos44, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size44, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				int array_index44_6 = 0;
				zval** temp_array_value44_6 = 0;
				while(strings_continue44_6)
				{
					if(zend_hash_index_find(HASH_OF(choices44), array_index44_6, (void**)&temp_array_value44_6) == SUCCESS)
					{
						convert_to_string(*temp_array_value44_6);
						strings_array44_6[array_index44_6] = wxString(Z_STRVAL_PP(temp_array_value44_6), wxConvUTF8);
						array_index44_6++;
					}
					else
					{
						strings_continue44_6 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioBox::Create((wxWindow*) object_pointer44_0, (wxWindowID) id44, wxString(label44, wxConvUTF8), *(wxPoint*) object_pointer44_3, *(wxSize*) object_pointer44_4, (int) n44, strings_array44_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioBox_php*)native_object)->Create((wxWindow*) object_pointer44_0, (wxWindowID) id44, wxString(label44, wxConvUTF8), *(wxPoint*) object_pointer44_3, *(wxSize*) object_pointer44_4, (int) n44, strings_array44_6));

				references->AddReference(parent44, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos44, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size44, "wxWindow::Create at call with 7 argument(s)");
				delete[] strings_array44_6;

				return;
				break;
			}
			case 8:
			{
				int array_index44_6 = 0;
				zval** temp_array_value44_6 = 0;
				while(strings_continue44_6)
				{
					if(zend_hash_index_find(HASH_OF(choices44), array_index44_6, (void**)&temp_array_value44_6) == SUCCESS)
					{
						convert_to_string(*temp_array_value44_6);
						strings_array44_6[array_index44_6] = wxString(Z_STRVAL_PP(temp_array_value44_6), wxConvUTF8);
						array_index44_6++;
					}
					else
					{
						strings_continue44_6 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioBox::Create((wxWindow*) object_pointer44_0, (wxWindowID) id44, wxString(label44, wxConvUTF8), *(wxPoint*) object_pointer44_3, *(wxSize*) object_pointer44_4, (int) n44, strings_array44_6, (int) majorDimension44))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioBox_php*)native_object)->Create((wxWindow*) object_pointer44_0, (wxWindowID) id44, wxString(label44, wxConvUTF8), *(wxPoint*) object_pointer44_3, *(wxSize*) object_pointer44_4, (int) n44, strings_array44_6, (int) majorDimension44));

				references->AddReference(parent44, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos44, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size44, "wxWindow::Create at call with 8 argument(s)");
				delete[] strings_array44_6;

				return;
				break;
			}
			case 9:
			{
				int array_index44_6 = 0;
				zval** temp_array_value44_6 = 0;
				while(strings_continue44_6)
				{
					if(zend_hash_index_find(HASH_OF(choices44), array_index44_6, (void**)&temp_array_value44_6) == SUCCESS)
					{
						convert_to_string(*temp_array_value44_6);
						strings_array44_6[array_index44_6] = wxString(Z_STRVAL_PP(temp_array_value44_6), wxConvUTF8);
						array_index44_6++;
					}
					else
					{
						strings_continue44_6 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioBox::Create((wxWindow*) object_pointer44_0, (wxWindowID) id44, wxString(label44, wxConvUTF8), *(wxPoint*) object_pointer44_3, *(wxSize*) object_pointer44_4, (int) n44, strings_array44_6, (int) majorDimension44, (long) style44))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioBox_php*)native_object)->Create((wxWindow*) object_pointer44_0, (wxWindowID) id44, wxString(label44, wxConvUTF8), *(wxPoint*) object_pointer44_3, *(wxSize*) object_pointer44_4, (int) n44, strings_array44_6, (int) majorDimension44, (long) style44));

				references->AddReference(parent44, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(pos44, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(size44, "wxWindow::Create at call with 9 argument(s)");
				delete[] strings_array44_6;

				return;
				break;
			}
			case 10:
			{
				int array_index44_6 = 0;
				zval** temp_array_value44_6 = 0;
				while(strings_continue44_6)
				{
					if(zend_hash_index_find(HASH_OF(choices44), array_index44_6, (void**)&temp_array_value44_6) == SUCCESS)
					{
						convert_to_string(*temp_array_value44_6);
						strings_array44_6[array_index44_6] = wxString(Z_STRVAL_PP(temp_array_value44_6), wxConvUTF8);
						array_index44_6++;
					}
					else
					{
						strings_continue44_6 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioBox::Create((wxWindow*) object_pointer44_0, (wxWindowID) id44, wxString(label44, wxConvUTF8), *(wxPoint*) object_pointer44_3, *(wxSize*) object_pointer44_4, (int) n44, strings_array44_6, (int) majorDimension44, (long) style44, *(wxValidator*) object_pointer44_9))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioBox_php*)native_object)->Create((wxWindow*) object_pointer44_0, (wxWindowID) id44, wxString(label44, wxConvUTF8), *(wxPoint*) object_pointer44_3, *(wxSize*) object_pointer44_4, (int) n44, strings_array44_6, (int) majorDimension44, (long) style44, *(wxValidator*) object_pointer44_9));

				references->AddReference(parent44, "wxWindow::Create at call with 10 argument(s)");
				references->AddReference(pos44, "wxWindow::Create at call with 10 argument(s)");
				references->AddReference(size44, "wxWindow::Create at call with 10 argument(s)");
				delete[] strings_array44_6;
				references->AddReference(validator44, "wxWindow::Create at call with 10 argument(s)");

				return;
				break;
			}
			case 11:
			{
				int array_index44_6 = 0;
				zval** temp_array_value44_6 = 0;
				while(strings_continue44_6)
				{
					if(zend_hash_index_find(HASH_OF(choices44), array_index44_6, (void**)&temp_array_value44_6) == SUCCESS)
					{
						convert_to_string(*temp_array_value44_6);
						strings_array44_6[array_index44_6] = wxString(Z_STRVAL_PP(temp_array_value44_6), wxConvUTF8);
						array_index44_6++;
					}
					else
					{
						strings_continue44_6 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioBox::Create((wxWindow*) object_pointer44_0, (wxWindowID) id44, wxString(label44, wxConvUTF8), *(wxPoint*) object_pointer44_3, *(wxSize*) object_pointer44_4, (int) n44, strings_array44_6, (int) majorDimension44, (long) style44, *(wxValidator*) object_pointer44_9, wxString(name44, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioBox_php*)native_object)->Create((wxWindow*) object_pointer44_0, (wxWindowID) id44, wxString(label44, wxConvUTF8), *(wxPoint*) object_pointer44_3, *(wxSize*) object_pointer44_4, (int) n44, strings_array44_6, (int) majorDimension44, (long) style44, *(wxValidator*) object_pointer44_9, wxString(name44, wxConvUTF8)));

				references->AddReference(parent44, "wxWindow::Create at call with 11 argument(s)");
				references->AddReference(pos44, "wxWindow::Create at call with 11 argument(s)");
				references->AddReference(size44, "wxWindow::Create at call with 11 argument(s)");
				delete[] strings_array44_6;
				references->AddReference(validator44, "wxWindow::Create at call with 11 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload45_called)
	{
		wxArrayString strings_array45_5;
		bool strings_continue45_5 = true;

		switch(arguments_received)
		{
			case 6:
			{
				int array_index45_5 = 0;
				zval** temp_array_value45_5 = 0;
				while(strings_continue45_5)
				{
					if(zend_hash_index_find(HASH_OF(choices45), array_index45_5, (void**)&temp_array_value45_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value45_5);
						strings_array45_5.Add(wxString(Z_STRVAL_PP(temp_array_value45_5), wxConvUTF8));
						array_index45_5++;
					}
					else
					{
						strings_continue45_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioBox::Create((wxWindow*) object_pointer45_0, (wxWindowID) id45, wxString(label45, wxConvUTF8), *(wxPoint*) object_pointer45_3, *(wxSize*) object_pointer45_4, strings_array45_5))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioBox_php*)native_object)->Create((wxWindow*) object_pointer45_0, (wxWindowID) id45, wxString(label45, wxConvUTF8), *(wxPoint*) object_pointer45_3, *(wxSize*) object_pointer45_4, strings_array45_5));

				references->AddReference(parent45, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos45, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size45, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				int array_index45_5 = 0;
				zval** temp_array_value45_5 = 0;
				while(strings_continue45_5)
				{
					if(zend_hash_index_find(HASH_OF(choices45), array_index45_5, (void**)&temp_array_value45_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value45_5);
						strings_array45_5.Add(wxString(Z_STRVAL_PP(temp_array_value45_5), wxConvUTF8));
						array_index45_5++;
					}
					else
					{
						strings_continue45_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioBox::Create((wxWindow*) object_pointer45_0, (wxWindowID) id45, wxString(label45, wxConvUTF8), *(wxPoint*) object_pointer45_3, *(wxSize*) object_pointer45_4, strings_array45_5, (int) majorDimension45))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioBox_php*)native_object)->Create((wxWindow*) object_pointer45_0, (wxWindowID) id45, wxString(label45, wxConvUTF8), *(wxPoint*) object_pointer45_3, *(wxSize*) object_pointer45_4, strings_array45_5, (int) majorDimension45));

				references->AddReference(parent45, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos45, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size45, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				int array_index45_5 = 0;
				zval** temp_array_value45_5 = 0;
				while(strings_continue45_5)
				{
					if(zend_hash_index_find(HASH_OF(choices45), array_index45_5, (void**)&temp_array_value45_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value45_5);
						strings_array45_5.Add(wxString(Z_STRVAL_PP(temp_array_value45_5), wxConvUTF8));
						array_index45_5++;
					}
					else
					{
						strings_continue45_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioBox::Create((wxWindow*) object_pointer45_0, (wxWindowID) id45, wxString(label45, wxConvUTF8), *(wxPoint*) object_pointer45_3, *(wxSize*) object_pointer45_4, strings_array45_5, (int) majorDimension45, (long) style45))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioBox_php*)native_object)->Create((wxWindow*) object_pointer45_0, (wxWindowID) id45, wxString(label45, wxConvUTF8), *(wxPoint*) object_pointer45_3, *(wxSize*) object_pointer45_4, strings_array45_5, (int) majorDimension45, (long) style45));

				references->AddReference(parent45, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos45, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size45, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
			case 9:
			{
				int array_index45_5 = 0;
				zval** temp_array_value45_5 = 0;
				while(strings_continue45_5)
				{
					if(zend_hash_index_find(HASH_OF(choices45), array_index45_5, (void**)&temp_array_value45_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value45_5);
						strings_array45_5.Add(wxString(Z_STRVAL_PP(temp_array_value45_5), wxConvUTF8));
						array_index45_5++;
					}
					else
					{
						strings_continue45_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioBox::Create((wxWindow*) object_pointer45_0, (wxWindowID) id45, wxString(label45, wxConvUTF8), *(wxPoint*) object_pointer45_3, *(wxSize*) object_pointer45_4, strings_array45_5, (int) majorDimension45, (long) style45, *(wxValidator*) object_pointer45_8))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioBox_php*)native_object)->Create((wxWindow*) object_pointer45_0, (wxWindowID) id45, wxString(label45, wxConvUTF8), *(wxPoint*) object_pointer45_3, *(wxSize*) object_pointer45_4, strings_array45_5, (int) majorDimension45, (long) style45, *(wxValidator*) object_pointer45_8));

				references->AddReference(parent45, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(pos45, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(size45, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(validator45, "wxWindow::Create at call with 9 argument(s)");

				return;
				break;
			}
			case 10:
			{
				int array_index45_5 = 0;
				zval** temp_array_value45_5 = 0;
				while(strings_continue45_5)
				{
					if(zend_hash_index_find(HASH_OF(choices45), array_index45_5, (void**)&temp_array_value45_5) == SUCCESS)
					{
						convert_to_string(*temp_array_value45_5);
						strings_array45_5.Add(wxString(Z_STRVAL_PP(temp_array_value45_5), wxConvUTF8));
						array_index45_5++;
					}
					else
					{
						strings_continue45_5 = false;
					}
				}
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioBox::Create((wxWindow*) object_pointer45_0, (wxWindowID) id45, wxString(label45, wxConvUTF8), *(wxPoint*) object_pointer45_3, *(wxSize*) object_pointer45_4, strings_array45_5, (int) majorDimension45, (long) style45, *(wxValidator*) object_pointer45_8, wxString(name45, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioBox_php*)native_object)->Create((wxWindow*) object_pointer45_0, (wxWindowID) id45, wxString(label45, wxConvUTF8), *(wxPoint*) object_pointer45_3, *(wxSize*) object_pointer45_4, strings_array45_5, (int) majorDimension45, (long) style45, *(wxValidator*) object_pointer45_8, wxString(name45, wxConvUTF8)));

				references->AddReference(parent45, "wxWindow::Create at call with 10 argument(s)");
				references->AddReference(pos45, "wxWindow::Create at call with 10 argument(s)");
				references->AddReference(size45, "wxWindow::Create at call with 10 argument(s)");
				references->AddReference(validator45, "wxWindow::Create at call with 10 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload46_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioButton::Create((wxWindow*) object_pointer46_0, (wxWindowID) id46, wxString(label46, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioButton_php*)native_object)->Create((wxWindow*) object_pointer46_0, (wxWindowID) id46, wxString(label46, wxConvUTF8)));

				references->AddReference(parent46, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioButton::Create((wxWindow*) object_pointer46_0, (wxWindowID) id46, wxString(label46, wxConvUTF8), *(wxPoint*) object_pointer46_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioButton_php*)native_object)->Create((wxWindow*) object_pointer46_0, (wxWindowID) id46, wxString(label46, wxConvUTF8), *(wxPoint*) object_pointer46_3));

				references->AddReference(parent46, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos46, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioButton::Create((wxWindow*) object_pointer46_0, (wxWindowID) id46, wxString(label46, wxConvUTF8), *(wxPoint*) object_pointer46_3, *(wxSize*) object_pointer46_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioButton_php*)native_object)->Create((wxWindow*) object_pointer46_0, (wxWindowID) id46, wxString(label46, wxConvUTF8), *(wxPoint*) object_pointer46_3, *(wxSize*) object_pointer46_4));

				references->AddReference(parent46, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos46, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size46, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioButton::Create((wxWindow*) object_pointer46_0, (wxWindowID) id46, wxString(label46, wxConvUTF8), *(wxPoint*) object_pointer46_3, *(wxSize*) object_pointer46_4, (long) style46))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioButton_php*)native_object)->Create((wxWindow*) object_pointer46_0, (wxWindowID) id46, wxString(label46, wxConvUTF8), *(wxPoint*) object_pointer46_3, *(wxSize*) object_pointer46_4, (long) style46));

				references->AddReference(parent46, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos46, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size46, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioButton::Create((wxWindow*) object_pointer46_0, (wxWindowID) id46, wxString(label46, wxConvUTF8), *(wxPoint*) object_pointer46_3, *(wxSize*) object_pointer46_4, (long) style46, *(wxValidator*) object_pointer46_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioButton_php*)native_object)->Create((wxWindow*) object_pointer46_0, (wxWindowID) id46, wxString(label46, wxConvUTF8), *(wxPoint*) object_pointer46_3, *(wxSize*) object_pointer46_4, (long) style46, *(wxValidator*) object_pointer46_6));

				references->AddReference(parent46, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos46, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size46, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator46, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRadioButton::Create((wxWindow*) object_pointer46_0, (wxWindowID) id46, wxString(label46, wxConvUTF8), *(wxPoint*) object_pointer46_3, *(wxSize*) object_pointer46_4, (long) style46, *(wxValidator*) object_pointer46_6, wxString(name46, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRadioButton_php*)native_object)->Create((wxWindow*) object_pointer46_0, (wxWindowID) id46, wxString(label46, wxConvUTF8), *(wxPoint*) object_pointer46_3, *(wxSize*) object_pointer46_4, (long) style46, *(wxValidator*) object_pointer46_6, wxString(name46, wxConvUTF8)));

				references->AddReference(parent46, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos46, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size46, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator46, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload47_called)
	{
		switch(arguments_received)
		{
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSlider::Create((wxWindow*) object_pointer47_0, (wxWindowID) id47, (int) value47, (int) minValue47, (int) maxValue47))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSlider_php*)native_object)->Create((wxWindow*) object_pointer47_0, (wxWindowID) id47, (int) value47, (int) minValue47, (int) maxValue47));

				references->AddReference(parent47, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSlider::Create((wxWindow*) object_pointer47_0, (wxWindowID) id47, (int) value47, (int) minValue47, (int) maxValue47, *(wxPoint*) object_pointer47_5))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSlider_php*)native_object)->Create((wxWindow*) object_pointer47_0, (wxWindowID) id47, (int) value47, (int) minValue47, (int) maxValue47, *(wxPoint*) object_pointer47_5));

				references->AddReference(parent47, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(point47, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSlider::Create((wxWindow*) object_pointer47_0, (wxWindowID) id47, (int) value47, (int) minValue47, (int) maxValue47, *(wxPoint*) object_pointer47_5, *(wxSize*) object_pointer47_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSlider_php*)native_object)->Create((wxWindow*) object_pointer47_0, (wxWindowID) id47, (int) value47, (int) minValue47, (int) maxValue47, *(wxPoint*) object_pointer47_5, *(wxSize*) object_pointer47_6));

				references->AddReference(parent47, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(point47, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size47, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSlider::Create((wxWindow*) object_pointer47_0, (wxWindowID) id47, (int) value47, (int) minValue47, (int) maxValue47, *(wxPoint*) object_pointer47_5, *(wxSize*) object_pointer47_6, (long) style47))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSlider_php*)native_object)->Create((wxWindow*) object_pointer47_0, (wxWindowID) id47, (int) value47, (int) minValue47, (int) maxValue47, *(wxPoint*) object_pointer47_5, *(wxSize*) object_pointer47_6, (long) style47));

				references->AddReference(parent47, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(point47, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size47, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
			case 9:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSlider::Create((wxWindow*) object_pointer47_0, (wxWindowID) id47, (int) value47, (int) minValue47, (int) maxValue47, *(wxPoint*) object_pointer47_5, *(wxSize*) object_pointer47_6, (long) style47, *(wxValidator*) object_pointer47_8))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSlider_php*)native_object)->Create((wxWindow*) object_pointer47_0, (wxWindowID) id47, (int) value47, (int) minValue47, (int) maxValue47, *(wxPoint*) object_pointer47_5, *(wxSize*) object_pointer47_6, (long) style47, *(wxValidator*) object_pointer47_8));

				references->AddReference(parent47, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(point47, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(size47, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(validator47, "wxWindow::Create at call with 9 argument(s)");

				return;
				break;
			}
			case 10:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSlider::Create((wxWindow*) object_pointer47_0, (wxWindowID) id47, (int) value47, (int) minValue47, (int) maxValue47, *(wxPoint*) object_pointer47_5, *(wxSize*) object_pointer47_6, (long) style47, *(wxValidator*) object_pointer47_8, wxString(name47, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSlider_php*)native_object)->Create((wxWindow*) object_pointer47_0, (wxWindowID) id47, (int) value47, (int) minValue47, (int) maxValue47, *(wxPoint*) object_pointer47_5, *(wxSize*) object_pointer47_6, (long) style47, *(wxValidator*) object_pointer47_8, wxString(name47, wxConvUTF8)));

				references->AddReference(parent47, "wxWindow::Create at call with 10 argument(s)");
				references->AddReference(point47, "wxWindow::Create at call with 10 argument(s)");
				references->AddReference(size47, "wxWindow::Create at call with 10 argument(s)");
				references->AddReference(validator47, "wxWindow::Create at call with 10 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload48_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrl::Create((wxWindow*) object_pointer48_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrl_php*)native_object)->Create((wxWindow*) object_pointer48_0));

				references->AddReference(parent48, "wxWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrl::Create((wxWindow*) object_pointer48_0, (wxWindowID) id48))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrl_php*)native_object)->Create((wxWindow*) object_pointer48_0, (wxWindowID) id48));

				references->AddReference(parent48, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrl::Create((wxWindow*) object_pointer48_0, (wxWindowID) id48, wxString(value48, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrl_php*)native_object)->Create((wxWindow*) object_pointer48_0, (wxWindowID) id48, wxString(value48, wxConvUTF8)));

				references->AddReference(parent48, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrl::Create((wxWindow*) object_pointer48_0, (wxWindowID) id48, wxString(value48, wxConvUTF8), *(wxPoint*) object_pointer48_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrl_php*)native_object)->Create((wxWindow*) object_pointer48_0, (wxWindowID) id48, wxString(value48, wxConvUTF8), *(wxPoint*) object_pointer48_3));

				references->AddReference(parent48, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos48, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrl::Create((wxWindow*) object_pointer48_0, (wxWindowID) id48, wxString(value48, wxConvUTF8), *(wxPoint*) object_pointer48_3, *(wxSize*) object_pointer48_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrl_php*)native_object)->Create((wxWindow*) object_pointer48_0, (wxWindowID) id48, wxString(value48, wxConvUTF8), *(wxPoint*) object_pointer48_3, *(wxSize*) object_pointer48_4));

				references->AddReference(parent48, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos48, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size48, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrl::Create((wxWindow*) object_pointer48_0, (wxWindowID) id48, wxString(value48, wxConvUTF8), *(wxPoint*) object_pointer48_3, *(wxSize*) object_pointer48_4, (long) style48))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrl_php*)native_object)->Create((wxWindow*) object_pointer48_0, (wxWindowID) id48, wxString(value48, wxConvUTF8), *(wxPoint*) object_pointer48_3, *(wxSize*) object_pointer48_4, (long) style48));

				references->AddReference(parent48, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos48, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size48, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrl::Create((wxWindow*) object_pointer48_0, (wxWindowID) id48, wxString(value48, wxConvUTF8), *(wxPoint*) object_pointer48_3, *(wxSize*) object_pointer48_4, (long) style48, (int) min48))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrl_php*)native_object)->Create((wxWindow*) object_pointer48_0, (wxWindowID) id48, wxString(value48, wxConvUTF8), *(wxPoint*) object_pointer48_3, *(wxSize*) object_pointer48_4, (long) style48, (int) min48));

				references->AddReference(parent48, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos48, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size48, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrl::Create((wxWindow*) object_pointer48_0, (wxWindowID) id48, wxString(value48, wxConvUTF8), *(wxPoint*) object_pointer48_3, *(wxSize*) object_pointer48_4, (long) style48, (int) min48, (int) max48))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrl_php*)native_object)->Create((wxWindow*) object_pointer48_0, (wxWindowID) id48, wxString(value48, wxConvUTF8), *(wxPoint*) object_pointer48_3, *(wxSize*) object_pointer48_4, (long) style48, (int) min48, (int) max48));

				references->AddReference(parent48, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos48, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size48, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
			case 9:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrl::Create((wxWindow*) object_pointer48_0, (wxWindowID) id48, wxString(value48, wxConvUTF8), *(wxPoint*) object_pointer48_3, *(wxSize*) object_pointer48_4, (long) style48, (int) min48, (int) max48, (int) initial48))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrl_php*)native_object)->Create((wxWindow*) object_pointer48_0, (wxWindowID) id48, wxString(value48, wxConvUTF8), *(wxPoint*) object_pointer48_3, *(wxSize*) object_pointer48_4, (long) style48, (int) min48, (int) max48, (int) initial48));

				references->AddReference(parent48, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(pos48, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(size48, "wxWindow::Create at call with 9 argument(s)");

				return;
				break;
			}
			case 10:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrl::Create((wxWindow*) object_pointer48_0, (wxWindowID) id48, wxString(value48, wxConvUTF8), *(wxPoint*) object_pointer48_3, *(wxSize*) object_pointer48_4, (long) style48, (int) min48, (int) max48, (int) initial48, wxString(name48, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrl_php*)native_object)->Create((wxWindow*) object_pointer48_0, (wxWindowID) id48, wxString(value48, wxConvUTF8), *(wxPoint*) object_pointer48_3, *(wxSize*) object_pointer48_4, (long) style48, (int) min48, (int) max48, (int) initial48, wxString(name48, wxConvUTF8)));

				references->AddReference(parent48, "wxWindow::Create at call with 10 argument(s)");
				references->AddReference(pos48, "wxWindow::Create at call with 10 argument(s)");
				references->AddReference(size48, "wxWindow::Create at call with 10 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload49_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxGauge::Create((wxWindow*) object_pointer49_0, (wxWindowID) id49, (int) range49))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxGauge_php*)native_object)->Create((wxWindow*) object_pointer49_0, (wxWindowID) id49, (int) range49));

				references->AddReference(parent49, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxGauge::Create((wxWindow*) object_pointer49_0, (wxWindowID) id49, (int) range49, *(wxPoint*) object_pointer49_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxGauge_php*)native_object)->Create((wxWindow*) object_pointer49_0, (wxWindowID) id49, (int) range49, *(wxPoint*) object_pointer49_3));

				references->AddReference(parent49, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos49, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxGauge::Create((wxWindow*) object_pointer49_0, (wxWindowID) id49, (int) range49, *(wxPoint*) object_pointer49_3, *(wxSize*) object_pointer49_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxGauge_php*)native_object)->Create((wxWindow*) object_pointer49_0, (wxWindowID) id49, (int) range49, *(wxPoint*) object_pointer49_3, *(wxSize*) object_pointer49_4));

				references->AddReference(parent49, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos49, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size49, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxGauge::Create((wxWindow*) object_pointer49_0, (wxWindowID) id49, (int) range49, *(wxPoint*) object_pointer49_3, *(wxSize*) object_pointer49_4, (long) style49))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxGauge_php*)native_object)->Create((wxWindow*) object_pointer49_0, (wxWindowID) id49, (int) range49, *(wxPoint*) object_pointer49_3, *(wxSize*) object_pointer49_4, (long) style49));

				references->AddReference(parent49, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos49, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size49, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxGauge::Create((wxWindow*) object_pointer49_0, (wxWindowID) id49, (int) range49, *(wxPoint*) object_pointer49_3, *(wxSize*) object_pointer49_4, (long) style49, *(wxValidator*) object_pointer49_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxGauge_php*)native_object)->Create((wxWindow*) object_pointer49_0, (wxWindowID) id49, (int) range49, *(wxPoint*) object_pointer49_3, *(wxSize*) object_pointer49_4, (long) style49, *(wxValidator*) object_pointer49_6));

				references->AddReference(parent49, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos49, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size49, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator49, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxGauge::Create((wxWindow*) object_pointer49_0, (wxWindowID) id49, (int) range49, *(wxPoint*) object_pointer49_3, *(wxSize*) object_pointer49_4, (long) style49, *(wxValidator*) object_pointer49_6, wxString(name49, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxGauge_php*)native_object)->Create((wxWindow*) object_pointer49_0, (wxWindowID) id49, (int) range49, *(wxPoint*) object_pointer49_3, *(wxSize*) object_pointer49_4, (long) style49, *(wxValidator*) object_pointer49_6, wxString(name49, wxConvUTF8)));

				references->AddReference(parent49, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos49, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size49, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator49, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload50_called)
	{
		switch(arguments_received)
		{
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHyperlinkCtrl::Create((wxWindow*) object_pointer50_0, (wxWindowID) id50, wxString(label50, wxConvUTF8), wxString(url50, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxHyperlinkCtrl_php*)native_object)->Create((wxWindow*) object_pointer50_0, (wxWindowID) id50, wxString(label50, wxConvUTF8), wxString(url50, wxConvUTF8)));

				references->AddReference(parent50, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHyperlinkCtrl::Create((wxWindow*) object_pointer50_0, (wxWindowID) id50, wxString(label50, wxConvUTF8), wxString(url50, wxConvUTF8), *(wxPoint*) object_pointer50_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxHyperlinkCtrl_php*)native_object)->Create((wxWindow*) object_pointer50_0, (wxWindowID) id50, wxString(label50, wxConvUTF8), wxString(url50, wxConvUTF8), *(wxPoint*) object_pointer50_4));

				references->AddReference(parent50, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos50, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHyperlinkCtrl::Create((wxWindow*) object_pointer50_0, (wxWindowID) id50, wxString(label50, wxConvUTF8), wxString(url50, wxConvUTF8), *(wxPoint*) object_pointer50_4, *(wxSize*) object_pointer50_5))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxHyperlinkCtrl_php*)native_object)->Create((wxWindow*) object_pointer50_0, (wxWindowID) id50, wxString(label50, wxConvUTF8), wxString(url50, wxConvUTF8), *(wxPoint*) object_pointer50_4, *(wxSize*) object_pointer50_5));

				references->AddReference(parent50, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos50, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size50, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHyperlinkCtrl::Create((wxWindow*) object_pointer50_0, (wxWindowID) id50, wxString(label50, wxConvUTF8), wxString(url50, wxConvUTF8), *(wxPoint*) object_pointer50_4, *(wxSize*) object_pointer50_5, (long) style50))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxHyperlinkCtrl_php*)native_object)->Create((wxWindow*) object_pointer50_0, (wxWindowID) id50, wxString(label50, wxConvUTF8), wxString(url50, wxConvUTF8), *(wxPoint*) object_pointer50_4, *(wxSize*) object_pointer50_5, (long) style50));

				references->AddReference(parent50, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos50, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size50, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHyperlinkCtrl::Create((wxWindow*) object_pointer50_0, (wxWindowID) id50, wxString(label50, wxConvUTF8), wxString(url50, wxConvUTF8), *(wxPoint*) object_pointer50_4, *(wxSize*) object_pointer50_5, (long) style50, wxString(name50, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxHyperlinkCtrl_php*)native_object)->Create((wxWindow*) object_pointer50_0, (wxWindowID) id50, wxString(label50, wxConvUTF8), wxString(url50, wxConvUTF8), *(wxPoint*) object_pointer50_4, *(wxSize*) object_pointer50_5, (long) style50, wxString(name50, wxConvUTF8)));

				references->AddReference(parent50, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos50, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size50, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload51_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrlDouble::Create((wxWindow*) object_pointer51_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrlDouble_php*)native_object)->Create((wxWindow*) object_pointer51_0));

				references->AddReference(parent51, "wxWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrlDouble::Create((wxWindow*) object_pointer51_0, (wxWindowID) id51))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrlDouble_php*)native_object)->Create((wxWindow*) object_pointer51_0, (wxWindowID) id51));

				references->AddReference(parent51, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrlDouble::Create((wxWindow*) object_pointer51_0, (wxWindowID) id51, wxString(value51, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrlDouble_php*)native_object)->Create((wxWindow*) object_pointer51_0, (wxWindowID) id51, wxString(value51, wxConvUTF8)));

				references->AddReference(parent51, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrlDouble::Create((wxWindow*) object_pointer51_0, (wxWindowID) id51, wxString(value51, wxConvUTF8), *(wxPoint*) object_pointer51_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrlDouble_php*)native_object)->Create((wxWindow*) object_pointer51_0, (wxWindowID) id51, wxString(value51, wxConvUTF8), *(wxPoint*) object_pointer51_3));

				references->AddReference(parent51, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos51, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrlDouble::Create((wxWindow*) object_pointer51_0, (wxWindowID) id51, wxString(value51, wxConvUTF8), *(wxPoint*) object_pointer51_3, *(wxSize*) object_pointer51_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrlDouble_php*)native_object)->Create((wxWindow*) object_pointer51_0, (wxWindowID) id51, wxString(value51, wxConvUTF8), *(wxPoint*) object_pointer51_3, *(wxSize*) object_pointer51_4));

				references->AddReference(parent51, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos51, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size51, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrlDouble::Create((wxWindow*) object_pointer51_0, (wxWindowID) id51, wxString(value51, wxConvUTF8), *(wxPoint*) object_pointer51_3, *(wxSize*) object_pointer51_4, (long) style51))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrlDouble_php*)native_object)->Create((wxWindow*) object_pointer51_0, (wxWindowID) id51, wxString(value51, wxConvUTF8), *(wxPoint*) object_pointer51_3, *(wxSize*) object_pointer51_4, (long) style51));

				references->AddReference(parent51, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos51, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size51, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrlDouble::Create((wxWindow*) object_pointer51_0, (wxWindowID) id51, wxString(value51, wxConvUTF8), *(wxPoint*) object_pointer51_3, *(wxSize*) object_pointer51_4, (long) style51, min51))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrlDouble_php*)native_object)->Create((wxWindow*) object_pointer51_0, (wxWindowID) id51, wxString(value51, wxConvUTF8), *(wxPoint*) object_pointer51_3, *(wxSize*) object_pointer51_4, (long) style51, min51));

				references->AddReference(parent51, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos51, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size51, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrlDouble::Create((wxWindow*) object_pointer51_0, (wxWindowID) id51, wxString(value51, wxConvUTF8), *(wxPoint*) object_pointer51_3, *(wxSize*) object_pointer51_4, (long) style51, min51, max51))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrlDouble_php*)native_object)->Create((wxWindow*) object_pointer51_0, (wxWindowID) id51, wxString(value51, wxConvUTF8), *(wxPoint*) object_pointer51_3, *(wxSize*) object_pointer51_4, (long) style51, min51, max51));

				references->AddReference(parent51, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos51, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size51, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
			case 9:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrlDouble::Create((wxWindow*) object_pointer51_0, (wxWindowID) id51, wxString(value51, wxConvUTF8), *(wxPoint*) object_pointer51_3, *(wxSize*) object_pointer51_4, (long) style51, min51, max51, initial51))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrlDouble_php*)native_object)->Create((wxWindow*) object_pointer51_0, (wxWindowID) id51, wxString(value51, wxConvUTF8), *(wxPoint*) object_pointer51_3, *(wxSize*) object_pointer51_4, (long) style51, min51, max51, initial51));

				references->AddReference(parent51, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(pos51, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(size51, "wxWindow::Create at call with 9 argument(s)");

				return;
				break;
			}
			case 10:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrlDouble::Create((wxWindow*) object_pointer51_0, (wxWindowID) id51, wxString(value51, wxConvUTF8), *(wxPoint*) object_pointer51_3, *(wxSize*) object_pointer51_4, (long) style51, min51, max51, initial51, inc51))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrlDouble_php*)native_object)->Create((wxWindow*) object_pointer51_0, (wxWindowID) id51, wxString(value51, wxConvUTF8), *(wxPoint*) object_pointer51_3, *(wxSize*) object_pointer51_4, (long) style51, min51, max51, initial51, inc51));

				references->AddReference(parent51, "wxWindow::Create at call with 10 argument(s)");
				references->AddReference(pos51, "wxWindow::Create at call with 10 argument(s)");
				references->AddReference(size51, "wxWindow::Create at call with 10 argument(s)");

				return;
				break;
			}
			case 11:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxSpinCtrlDouble::Create((wxWindow*) object_pointer51_0, (wxWindowID) id51, wxString(value51, wxConvUTF8), *(wxPoint*) object_pointer51_3, *(wxSize*) object_pointer51_4, (long) style51, min51, max51, initial51, inc51, wxString(name51, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxSpinCtrlDouble_php*)native_object)->Create((wxWindow*) object_pointer51_0, (wxWindowID) id51, wxString(value51, wxConvUTF8), *(wxPoint*) object_pointer51_3, *(wxSize*) object_pointer51_4, (long) style51, min51, max51, initial51, inc51, wxString(name51, wxConvUTF8)));

				references->AddReference(parent51, "wxWindow::Create at call with 11 argument(s)");
				references->AddReference(pos51, "wxWindow::Create at call with 11 argument(s)");
				references->AddReference(size51, "wxWindow::Create at call with 11 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload52_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxGenericDirCtrl::Create((wxWindow*) object_pointer52_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxGenericDirCtrl_php*)native_object)->Create((wxWindow*) object_pointer52_0));

				references->AddReference(parent52, "wxWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxGenericDirCtrl::Create((wxWindow*) object_pointer52_0, (const wxWindowID) id52))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxGenericDirCtrl_php*)native_object)->Create((wxWindow*) object_pointer52_0, (const wxWindowID) id52));

				references->AddReference(parent52, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxGenericDirCtrl::Create((wxWindow*) object_pointer52_0, (const wxWindowID) id52, wxString(dir52, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxGenericDirCtrl_php*)native_object)->Create((wxWindow*) object_pointer52_0, (const wxWindowID) id52, wxString(dir52, wxConvUTF8)));

				references->AddReference(parent52, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxGenericDirCtrl::Create((wxWindow*) object_pointer52_0, (const wxWindowID) id52, wxString(dir52, wxConvUTF8), *(wxPoint*) object_pointer52_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxGenericDirCtrl_php*)native_object)->Create((wxWindow*) object_pointer52_0, (const wxWindowID) id52, wxString(dir52, wxConvUTF8), *(wxPoint*) object_pointer52_3));

				references->AddReference(parent52, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos52, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxGenericDirCtrl::Create((wxWindow*) object_pointer52_0, (const wxWindowID) id52, wxString(dir52, wxConvUTF8), *(wxPoint*) object_pointer52_3, *(wxSize*) object_pointer52_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxGenericDirCtrl_php*)native_object)->Create((wxWindow*) object_pointer52_0, (const wxWindowID) id52, wxString(dir52, wxConvUTF8), *(wxPoint*) object_pointer52_3, *(wxSize*) object_pointer52_4));

				references->AddReference(parent52, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos52, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size52, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxGenericDirCtrl::Create((wxWindow*) object_pointer52_0, (const wxWindowID) id52, wxString(dir52, wxConvUTF8), *(wxPoint*) object_pointer52_3, *(wxSize*) object_pointer52_4, (long) style52))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxGenericDirCtrl_php*)native_object)->Create((wxWindow*) object_pointer52_0, (const wxWindowID) id52, wxString(dir52, wxConvUTF8), *(wxPoint*) object_pointer52_3, *(wxSize*) object_pointer52_4, (long) style52));

				references->AddReference(parent52, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos52, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size52, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxGenericDirCtrl::Create((wxWindow*) object_pointer52_0, (const wxWindowID) id52, wxString(dir52, wxConvUTF8), *(wxPoint*) object_pointer52_3, *(wxSize*) object_pointer52_4, (long) style52, wxString(filter52, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxGenericDirCtrl_php*)native_object)->Create((wxWindow*) object_pointer52_0, (const wxWindowID) id52, wxString(dir52, wxConvUTF8), *(wxPoint*) object_pointer52_3, *(wxSize*) object_pointer52_4, (long) style52, wxString(filter52, wxConvUTF8)));

				references->AddReference(parent52, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos52, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size52, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxGenericDirCtrl::Create((wxWindow*) object_pointer52_0, (const wxWindowID) id52, wxString(dir52, wxConvUTF8), *(wxPoint*) object_pointer52_3, *(wxSize*) object_pointer52_4, (long) style52, wxString(filter52, wxConvUTF8), (int) defaultFilter52))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxGenericDirCtrl_php*)native_object)->Create((wxWindow*) object_pointer52_0, (const wxWindowID) id52, wxString(dir52, wxConvUTF8), *(wxPoint*) object_pointer52_3, *(wxSize*) object_pointer52_4, (long) style52, wxString(filter52, wxConvUTF8), (int) defaultFilter52));

				references->AddReference(parent52, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos52, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size52, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
			case 9:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxGenericDirCtrl::Create((wxWindow*) object_pointer52_0, (const wxWindowID) id52, wxString(dir52, wxConvUTF8), *(wxPoint*) object_pointer52_3, *(wxSize*) object_pointer52_4, (long) style52, wxString(filter52, wxConvUTF8), (int) defaultFilter52, wxString(name52, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxGenericDirCtrl_php*)native_object)->Create((wxWindow*) object_pointer52_0, (const wxWindowID) id52, wxString(dir52, wxConvUTF8), *(wxPoint*) object_pointer52_3, *(wxSize*) object_pointer52_4, (long) style52, wxString(filter52, wxConvUTF8), (int) defaultFilter52, wxString(name52, wxConvUTF8)));

				references->AddReference(parent52, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(pos52, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(size52, "wxWindow::Create at call with 9 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload53_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCalendarCtrl::Create((wxWindow*) object_pointer53_0, (wxWindowID) id53))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCalendarCtrl_php*)native_object)->Create((wxWindow*) object_pointer53_0, (wxWindowID) id53));

				references->AddReference(parent53, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCalendarCtrl::Create((wxWindow*) object_pointer53_0, (wxWindowID) id53, wxDateTime(date53)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCalendarCtrl_php*)native_object)->Create((wxWindow*) object_pointer53_0, (wxWindowID) id53, wxDateTime(date53)));

				references->AddReference(parent53, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCalendarCtrl::Create((wxWindow*) object_pointer53_0, (wxWindowID) id53, wxDateTime(date53), *(wxPoint*) object_pointer53_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCalendarCtrl_php*)native_object)->Create((wxWindow*) object_pointer53_0, (wxWindowID) id53, wxDateTime(date53), *(wxPoint*) object_pointer53_3));

				references->AddReference(parent53, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos53, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCalendarCtrl::Create((wxWindow*) object_pointer53_0, (wxWindowID) id53, wxDateTime(date53), *(wxPoint*) object_pointer53_3, *(wxSize*) object_pointer53_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCalendarCtrl_php*)native_object)->Create((wxWindow*) object_pointer53_0, (wxWindowID) id53, wxDateTime(date53), *(wxPoint*) object_pointer53_3, *(wxSize*) object_pointer53_4));

				references->AddReference(parent53, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos53, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size53, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCalendarCtrl::Create((wxWindow*) object_pointer53_0, (wxWindowID) id53, wxDateTime(date53), *(wxPoint*) object_pointer53_3, *(wxSize*) object_pointer53_4, (long) style53))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCalendarCtrl_php*)native_object)->Create((wxWindow*) object_pointer53_0, (wxWindowID) id53, wxDateTime(date53), *(wxPoint*) object_pointer53_3, *(wxSize*) object_pointer53_4, (long) style53));

				references->AddReference(parent53, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos53, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size53, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCalendarCtrl::Create((wxWindow*) object_pointer53_0, (wxWindowID) id53, wxDateTime(date53), *(wxPoint*) object_pointer53_3, *(wxSize*) object_pointer53_4, (long) style53, wxString(name53, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCalendarCtrl_php*)native_object)->Create((wxWindow*) object_pointer53_0, (wxWindowID) id53, wxDateTime(date53), *(wxPoint*) object_pointer53_3, *(wxSize*) object_pointer53_4, (long) style53, wxString(name53, wxConvUTF8)));

				references->AddReference(parent53, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos53, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size53, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload54_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxColourPickerCtrl::Create((wxWindow*) object_pointer54_0, (wxWindowID) id54))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxColourPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer54_0, (wxWindowID) id54));

				references->AddReference(parent54, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxColourPickerCtrl::Create((wxWindow*) object_pointer54_0, (wxWindowID) id54, *(wxColour*) object_pointer54_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxColourPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer54_0, (wxWindowID) id54, *(wxColour*) object_pointer54_2));

				references->AddReference(parent54, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(colour54, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxColourPickerCtrl::Create((wxWindow*) object_pointer54_0, (wxWindowID) id54, *(wxColour*) object_pointer54_2, *(wxPoint*) object_pointer54_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxColourPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer54_0, (wxWindowID) id54, *(wxColour*) object_pointer54_2, *(wxPoint*) object_pointer54_3));

				references->AddReference(parent54, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(colour54, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos54, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxColourPickerCtrl::Create((wxWindow*) object_pointer54_0, (wxWindowID) id54, *(wxColour*) object_pointer54_2, *(wxPoint*) object_pointer54_3, *(wxSize*) object_pointer54_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxColourPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer54_0, (wxWindowID) id54, *(wxColour*) object_pointer54_2, *(wxPoint*) object_pointer54_3, *(wxSize*) object_pointer54_4));

				references->AddReference(parent54, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(colour54, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos54, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size54, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxColourPickerCtrl::Create((wxWindow*) object_pointer54_0, (wxWindowID) id54, *(wxColour*) object_pointer54_2, *(wxPoint*) object_pointer54_3, *(wxSize*) object_pointer54_4, (long) style54))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxColourPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer54_0, (wxWindowID) id54, *(wxColour*) object_pointer54_2, *(wxPoint*) object_pointer54_3, *(wxSize*) object_pointer54_4, (long) style54));

				references->AddReference(parent54, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(colour54, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos54, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size54, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxColourPickerCtrl::Create((wxWindow*) object_pointer54_0, (wxWindowID) id54, *(wxColour*) object_pointer54_2, *(wxPoint*) object_pointer54_3, *(wxSize*) object_pointer54_4, (long) style54, *(wxValidator*) object_pointer54_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxColourPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer54_0, (wxWindowID) id54, *(wxColour*) object_pointer54_2, *(wxPoint*) object_pointer54_3, *(wxSize*) object_pointer54_4, (long) style54, *(wxValidator*) object_pointer54_6));

				references->AddReference(parent54, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(colour54, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos54, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size54, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator54, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxColourPickerCtrl::Create((wxWindow*) object_pointer54_0, (wxWindowID) id54, *(wxColour*) object_pointer54_2, *(wxPoint*) object_pointer54_3, *(wxSize*) object_pointer54_4, (long) style54, *(wxValidator*) object_pointer54_6, wxString(name54, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxColourPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer54_0, (wxWindowID) id54, *(wxColour*) object_pointer54_2, *(wxPoint*) object_pointer54_3, *(wxSize*) object_pointer54_4, (long) style54, *(wxValidator*) object_pointer54_6, wxString(name54, wxConvUTF8)));

				references->AddReference(parent54, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(colour54, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos54, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size54, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator54, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload55_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFontPickerCtrl::Create((wxWindow*) object_pointer55_0, (wxWindowID) id55))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFontPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer55_0, (wxWindowID) id55));

				references->AddReference(parent55, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFontPickerCtrl::Create((wxWindow*) object_pointer55_0, (wxWindowID) id55, *(wxFont*) object_pointer55_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFontPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer55_0, (wxWindowID) id55, *(wxFont*) object_pointer55_2));

				references->AddReference(parent55, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(font55, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFontPickerCtrl::Create((wxWindow*) object_pointer55_0, (wxWindowID) id55, *(wxFont*) object_pointer55_2, *(wxPoint*) object_pointer55_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFontPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer55_0, (wxWindowID) id55, *(wxFont*) object_pointer55_2, *(wxPoint*) object_pointer55_3));

				references->AddReference(parent55, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(font55, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos55, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFontPickerCtrl::Create((wxWindow*) object_pointer55_0, (wxWindowID) id55, *(wxFont*) object_pointer55_2, *(wxPoint*) object_pointer55_3, *(wxSize*) object_pointer55_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFontPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer55_0, (wxWindowID) id55, *(wxFont*) object_pointer55_2, *(wxPoint*) object_pointer55_3, *(wxSize*) object_pointer55_4));

				references->AddReference(parent55, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(font55, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos55, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size55, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFontPickerCtrl::Create((wxWindow*) object_pointer55_0, (wxWindowID) id55, *(wxFont*) object_pointer55_2, *(wxPoint*) object_pointer55_3, *(wxSize*) object_pointer55_4, (long) style55))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFontPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer55_0, (wxWindowID) id55, *(wxFont*) object_pointer55_2, *(wxPoint*) object_pointer55_3, *(wxSize*) object_pointer55_4, (long) style55));

				references->AddReference(parent55, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(font55, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos55, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size55, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFontPickerCtrl::Create((wxWindow*) object_pointer55_0, (wxWindowID) id55, *(wxFont*) object_pointer55_2, *(wxPoint*) object_pointer55_3, *(wxSize*) object_pointer55_4, (long) style55, *(wxValidator*) object_pointer55_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFontPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer55_0, (wxWindowID) id55, *(wxFont*) object_pointer55_2, *(wxPoint*) object_pointer55_3, *(wxSize*) object_pointer55_4, (long) style55, *(wxValidator*) object_pointer55_6));

				references->AddReference(parent55, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(font55, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos55, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size55, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator55, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFontPickerCtrl::Create((wxWindow*) object_pointer55_0, (wxWindowID) id55, *(wxFont*) object_pointer55_2, *(wxPoint*) object_pointer55_3, *(wxSize*) object_pointer55_4, (long) style55, *(wxValidator*) object_pointer55_6, wxString(name55, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFontPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer55_0, (wxWindowID) id55, *(wxFont*) object_pointer55_2, *(wxPoint*) object_pointer55_3, *(wxSize*) object_pointer55_4, (long) style55, *(wxValidator*) object_pointer55_6, wxString(name55, wxConvUTF8)));

				references->AddReference(parent55, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(font55, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos55, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size55, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator55, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload56_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFilePickerCtrl::Create((wxWindow*) object_pointer56_0, (wxWindowID) id56))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFilePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer56_0, (wxWindowID) id56));

				references->AddReference(parent56, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFilePickerCtrl::Create((wxWindow*) object_pointer56_0, (wxWindowID) id56, wxString(path56, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFilePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer56_0, (wxWindowID) id56, wxString(path56, wxConvUTF8)));

				references->AddReference(parent56, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFilePickerCtrl::Create((wxWindow*) object_pointer56_0, (wxWindowID) id56, wxString(path56, wxConvUTF8), wxString(message56, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFilePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer56_0, (wxWindowID) id56, wxString(path56, wxConvUTF8), wxString(message56, wxConvUTF8)));

				references->AddReference(parent56, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFilePickerCtrl::Create((wxWindow*) object_pointer56_0, (wxWindowID) id56, wxString(path56, wxConvUTF8), wxString(message56, wxConvUTF8), wxString(wildcard56, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFilePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer56_0, (wxWindowID) id56, wxString(path56, wxConvUTF8), wxString(message56, wxConvUTF8), wxString(wildcard56, wxConvUTF8)));

				references->AddReference(parent56, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFilePickerCtrl::Create((wxWindow*) object_pointer56_0, (wxWindowID) id56, wxString(path56, wxConvUTF8), wxString(message56, wxConvUTF8), wxString(wildcard56, wxConvUTF8), *(wxPoint*) object_pointer56_5))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFilePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer56_0, (wxWindowID) id56, wxString(path56, wxConvUTF8), wxString(message56, wxConvUTF8), wxString(wildcard56, wxConvUTF8), *(wxPoint*) object_pointer56_5));

				references->AddReference(parent56, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos56, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFilePickerCtrl::Create((wxWindow*) object_pointer56_0, (wxWindowID) id56, wxString(path56, wxConvUTF8), wxString(message56, wxConvUTF8), wxString(wildcard56, wxConvUTF8), *(wxPoint*) object_pointer56_5, *(wxSize*) object_pointer56_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFilePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer56_0, (wxWindowID) id56, wxString(path56, wxConvUTF8), wxString(message56, wxConvUTF8), wxString(wildcard56, wxConvUTF8), *(wxPoint*) object_pointer56_5, *(wxSize*) object_pointer56_6));

				references->AddReference(parent56, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos56, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size56, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFilePickerCtrl::Create((wxWindow*) object_pointer56_0, (wxWindowID) id56, wxString(path56, wxConvUTF8), wxString(message56, wxConvUTF8), wxString(wildcard56, wxConvUTF8), *(wxPoint*) object_pointer56_5, *(wxSize*) object_pointer56_6, (long) style56))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFilePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer56_0, (wxWindowID) id56, wxString(path56, wxConvUTF8), wxString(message56, wxConvUTF8), wxString(wildcard56, wxConvUTF8), *(wxPoint*) object_pointer56_5, *(wxSize*) object_pointer56_6, (long) style56));

				references->AddReference(parent56, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos56, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size56, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
			case 9:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFilePickerCtrl::Create((wxWindow*) object_pointer56_0, (wxWindowID) id56, wxString(path56, wxConvUTF8), wxString(message56, wxConvUTF8), wxString(wildcard56, wxConvUTF8), *(wxPoint*) object_pointer56_5, *(wxSize*) object_pointer56_6, (long) style56, *(wxValidator*) object_pointer56_8))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFilePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer56_0, (wxWindowID) id56, wxString(path56, wxConvUTF8), wxString(message56, wxConvUTF8), wxString(wildcard56, wxConvUTF8), *(wxPoint*) object_pointer56_5, *(wxSize*) object_pointer56_6, (long) style56, *(wxValidator*) object_pointer56_8));

				references->AddReference(parent56, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(pos56, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(size56, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(validator56, "wxWindow::Create at call with 9 argument(s)");

				return;
				break;
			}
			case 10:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFilePickerCtrl::Create((wxWindow*) object_pointer56_0, (wxWindowID) id56, wxString(path56, wxConvUTF8), wxString(message56, wxConvUTF8), wxString(wildcard56, wxConvUTF8), *(wxPoint*) object_pointer56_5, *(wxSize*) object_pointer56_6, (long) style56, *(wxValidator*) object_pointer56_8, wxString(name56, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFilePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer56_0, (wxWindowID) id56, wxString(path56, wxConvUTF8), wxString(message56, wxConvUTF8), wxString(wildcard56, wxConvUTF8), *(wxPoint*) object_pointer56_5, *(wxSize*) object_pointer56_6, (long) style56, *(wxValidator*) object_pointer56_8, wxString(name56, wxConvUTF8)));

				references->AddReference(parent56, "wxWindow::Create at call with 10 argument(s)");
				references->AddReference(pos56, "wxWindow::Create at call with 10 argument(s)");
				references->AddReference(size56, "wxWindow::Create at call with 10 argument(s)");
				references->AddReference(validator56, "wxWindow::Create at call with 10 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload57_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDirPickerCtrl::Create((wxWindow*) object_pointer57_0, (wxWindowID) id57))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDirPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer57_0, (wxWindowID) id57));

				references->AddReference(parent57, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDirPickerCtrl::Create((wxWindow*) object_pointer57_0, (wxWindowID) id57, wxString(path57, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDirPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer57_0, (wxWindowID) id57, wxString(path57, wxConvUTF8)));

				references->AddReference(parent57, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDirPickerCtrl::Create((wxWindow*) object_pointer57_0, (wxWindowID) id57, wxString(path57, wxConvUTF8), wxString(message57, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDirPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer57_0, (wxWindowID) id57, wxString(path57, wxConvUTF8), wxString(message57, wxConvUTF8)));

				references->AddReference(parent57, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDirPickerCtrl::Create((wxWindow*) object_pointer57_0, (wxWindowID) id57, wxString(path57, wxConvUTF8), wxString(message57, wxConvUTF8), *(wxPoint*) object_pointer57_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDirPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer57_0, (wxWindowID) id57, wxString(path57, wxConvUTF8), wxString(message57, wxConvUTF8), *(wxPoint*) object_pointer57_4));

				references->AddReference(parent57, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos57, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDirPickerCtrl::Create((wxWindow*) object_pointer57_0, (wxWindowID) id57, wxString(path57, wxConvUTF8), wxString(message57, wxConvUTF8), *(wxPoint*) object_pointer57_4, *(wxSize*) object_pointer57_5))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDirPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer57_0, (wxWindowID) id57, wxString(path57, wxConvUTF8), wxString(message57, wxConvUTF8), *(wxPoint*) object_pointer57_4, *(wxSize*) object_pointer57_5));

				references->AddReference(parent57, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos57, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size57, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDirPickerCtrl::Create((wxWindow*) object_pointer57_0, (wxWindowID) id57, wxString(path57, wxConvUTF8), wxString(message57, wxConvUTF8), *(wxPoint*) object_pointer57_4, *(wxSize*) object_pointer57_5, (long) style57))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDirPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer57_0, (wxWindowID) id57, wxString(path57, wxConvUTF8), wxString(message57, wxConvUTF8), *(wxPoint*) object_pointer57_4, *(wxSize*) object_pointer57_5, (long) style57));

				references->AddReference(parent57, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos57, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size57, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDirPickerCtrl::Create((wxWindow*) object_pointer57_0, (wxWindowID) id57, wxString(path57, wxConvUTF8), wxString(message57, wxConvUTF8), *(wxPoint*) object_pointer57_4, *(wxSize*) object_pointer57_5, (long) style57, *(wxValidator*) object_pointer57_7))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDirPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer57_0, (wxWindowID) id57, wxString(path57, wxConvUTF8), wxString(message57, wxConvUTF8), *(wxPoint*) object_pointer57_4, *(wxSize*) object_pointer57_5, (long) style57, *(wxValidator*) object_pointer57_7));

				references->AddReference(parent57, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos57, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size57, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator57, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
			case 9:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDirPickerCtrl::Create((wxWindow*) object_pointer57_0, (wxWindowID) id57, wxString(path57, wxConvUTF8), wxString(message57, wxConvUTF8), *(wxPoint*) object_pointer57_4, *(wxSize*) object_pointer57_5, (long) style57, *(wxValidator*) object_pointer57_7, wxString(name57, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDirPickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer57_0, (wxWindowID) id57, wxString(path57, wxConvUTF8), wxString(message57, wxConvUTF8), *(wxPoint*) object_pointer57_4, *(wxSize*) object_pointer57_5, (long) style57, *(wxValidator*) object_pointer57_7, wxString(name57, wxConvUTF8)));

				references->AddReference(parent57, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(pos57, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(size57, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(validator57, "wxWindow::Create at call with 9 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload58_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTimePickerCtrl::Create((wxWindow*) object_pointer58_0, (wxWindowID) id58))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTimePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer58_0, (wxWindowID) id58));

				references->AddReference(parent58, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTimePickerCtrl::Create((wxWindow*) object_pointer58_0, (wxWindowID) id58, wxDateTime(dt58)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTimePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer58_0, (wxWindowID) id58, wxDateTime(dt58)));

				references->AddReference(parent58, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTimePickerCtrl::Create((wxWindow*) object_pointer58_0, (wxWindowID) id58, wxDateTime(dt58), *(wxPoint*) object_pointer58_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTimePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer58_0, (wxWindowID) id58, wxDateTime(dt58), *(wxPoint*) object_pointer58_3));

				references->AddReference(parent58, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos58, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTimePickerCtrl::Create((wxWindow*) object_pointer58_0, (wxWindowID) id58, wxDateTime(dt58), *(wxPoint*) object_pointer58_3, *(wxSize*) object_pointer58_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTimePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer58_0, (wxWindowID) id58, wxDateTime(dt58), *(wxPoint*) object_pointer58_3, *(wxSize*) object_pointer58_4));

				references->AddReference(parent58, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos58, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size58, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTimePickerCtrl::Create((wxWindow*) object_pointer58_0, (wxWindowID) id58, wxDateTime(dt58), *(wxPoint*) object_pointer58_3, *(wxSize*) object_pointer58_4, (long) style58))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTimePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer58_0, (wxWindowID) id58, wxDateTime(dt58), *(wxPoint*) object_pointer58_3, *(wxSize*) object_pointer58_4, (long) style58));

				references->AddReference(parent58, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos58, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size58, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTimePickerCtrl::Create((wxWindow*) object_pointer58_0, (wxWindowID) id58, wxDateTime(dt58), *(wxPoint*) object_pointer58_3, *(wxSize*) object_pointer58_4, (long) style58, *(wxValidator*) object_pointer58_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTimePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer58_0, (wxWindowID) id58, wxDateTime(dt58), *(wxPoint*) object_pointer58_3, *(wxSize*) object_pointer58_4, (long) style58, *(wxValidator*) object_pointer58_6));

				references->AddReference(parent58, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos58, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size58, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator58, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxTimePickerCtrl::Create((wxWindow*) object_pointer58_0, (wxWindowID) id58, wxDateTime(dt58), *(wxPoint*) object_pointer58_3, *(wxSize*) object_pointer58_4, (long) style58, *(wxValidator*) object_pointer58_6, wxString(name58, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxTimePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer58_0, (wxWindowID) id58, wxDateTime(dt58), *(wxPoint*) object_pointer58_3, *(wxSize*) object_pointer58_4, (long) style58, *(wxValidator*) object_pointer58_6, wxString(name58, wxConvUTF8)));

				references->AddReference(parent58, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos58, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size58, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator58, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload59_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDatePickerCtrl::Create((wxWindow*) object_pointer59_0, (wxWindowID) id59))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDatePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer59_0, (wxWindowID) id59));

				references->AddReference(parent59, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDatePickerCtrl::Create((wxWindow*) object_pointer59_0, (wxWindowID) id59, wxDateTime(dt59)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDatePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer59_0, (wxWindowID) id59, wxDateTime(dt59)));

				references->AddReference(parent59, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDatePickerCtrl::Create((wxWindow*) object_pointer59_0, (wxWindowID) id59, wxDateTime(dt59), *(wxPoint*) object_pointer59_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDatePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer59_0, (wxWindowID) id59, wxDateTime(dt59), *(wxPoint*) object_pointer59_3));

				references->AddReference(parent59, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos59, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDatePickerCtrl::Create((wxWindow*) object_pointer59_0, (wxWindowID) id59, wxDateTime(dt59), *(wxPoint*) object_pointer59_3, *(wxSize*) object_pointer59_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDatePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer59_0, (wxWindowID) id59, wxDateTime(dt59), *(wxPoint*) object_pointer59_3, *(wxSize*) object_pointer59_4));

				references->AddReference(parent59, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos59, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size59, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDatePickerCtrl::Create((wxWindow*) object_pointer59_0, (wxWindowID) id59, wxDateTime(dt59), *(wxPoint*) object_pointer59_3, *(wxSize*) object_pointer59_4, (long) style59))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDatePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer59_0, (wxWindowID) id59, wxDateTime(dt59), *(wxPoint*) object_pointer59_3, *(wxSize*) object_pointer59_4, (long) style59));

				references->AddReference(parent59, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos59, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size59, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDatePickerCtrl::Create((wxWindow*) object_pointer59_0, (wxWindowID) id59, wxDateTime(dt59), *(wxPoint*) object_pointer59_3, *(wxSize*) object_pointer59_4, (long) style59, *(wxValidator*) object_pointer59_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDatePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer59_0, (wxWindowID) id59, wxDateTime(dt59), *(wxPoint*) object_pointer59_3, *(wxSize*) object_pointer59_4, (long) style59, *(wxValidator*) object_pointer59_6));

				references->AddReference(parent59, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos59, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size59, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator59, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDatePickerCtrl::Create((wxWindow*) object_pointer59_0, (wxWindowID) id59, wxDateTime(dt59), *(wxPoint*) object_pointer59_3, *(wxSize*) object_pointer59_4, (long) style59, *(wxValidator*) object_pointer59_6, wxString(name59, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDatePickerCtrl_php*)native_object)->Create((wxWindow*) object_pointer59_0, (wxWindowID) id59, wxDateTime(dt59), *(wxPoint*) object_pointer59_3, *(wxSize*) object_pointer59_4, (long) style59, *(wxValidator*) object_pointer59_6, wxString(name59, wxConvUTF8)));

				references->AddReference(parent59, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos59, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size59, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator59, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload60_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCollapsiblePane::Create((wxWindow*) object_pointer60_0, (wxWindowID) id60, wxString(label60, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCollapsiblePane_php*)native_object)->Create((wxWindow*) object_pointer60_0, (wxWindowID) id60, wxString(label60, wxConvUTF8)));

				references->AddReference(parent60, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCollapsiblePane::Create((wxWindow*) object_pointer60_0, (wxWindowID) id60, wxString(label60, wxConvUTF8), *(wxPoint*) object_pointer60_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCollapsiblePane_php*)native_object)->Create((wxWindow*) object_pointer60_0, (wxWindowID) id60, wxString(label60, wxConvUTF8), *(wxPoint*) object_pointer60_3));

				references->AddReference(parent60, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos60, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCollapsiblePane::Create((wxWindow*) object_pointer60_0, (wxWindowID) id60, wxString(label60, wxConvUTF8), *(wxPoint*) object_pointer60_3, *(wxSize*) object_pointer60_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCollapsiblePane_php*)native_object)->Create((wxWindow*) object_pointer60_0, (wxWindowID) id60, wxString(label60, wxConvUTF8), *(wxPoint*) object_pointer60_3, *(wxSize*) object_pointer60_4));

				references->AddReference(parent60, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos60, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size60, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCollapsiblePane::Create((wxWindow*) object_pointer60_0, (wxWindowID) id60, wxString(label60, wxConvUTF8), *(wxPoint*) object_pointer60_3, *(wxSize*) object_pointer60_4, (long) style60))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCollapsiblePane_php*)native_object)->Create((wxWindow*) object_pointer60_0, (wxWindowID) id60, wxString(label60, wxConvUTF8), *(wxPoint*) object_pointer60_3, *(wxSize*) object_pointer60_4, (long) style60));

				references->AddReference(parent60, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos60, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size60, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCollapsiblePane::Create((wxWindow*) object_pointer60_0, (wxWindowID) id60, wxString(label60, wxConvUTF8), *(wxPoint*) object_pointer60_3, *(wxSize*) object_pointer60_4, (long) style60, *(wxValidator*) object_pointer60_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCollapsiblePane_php*)native_object)->Create((wxWindow*) object_pointer60_0, (wxWindowID) id60, wxString(label60, wxConvUTF8), *(wxPoint*) object_pointer60_3, *(wxSize*) object_pointer60_4, (long) style60, *(wxValidator*) object_pointer60_6));

				references->AddReference(parent60, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos60, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size60, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator60, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxCollapsiblePane::Create((wxWindow*) object_pointer60_0, (wxWindowID) id60, wxString(label60, wxConvUTF8), *(wxPoint*) object_pointer60_3, *(wxSize*) object_pointer60_4, (long) style60, *(wxValidator*) object_pointer60_6, wxString(name60, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxCollapsiblePane_php*)native_object)->Create((wxWindow*) object_pointer60_0, (wxWindowID) id60, wxString(label60, wxConvUTF8), *(wxPoint*) object_pointer60_3, *(wxSize*) object_pointer60_4, (long) style60, *(wxValidator*) object_pointer60_6, wxString(name60, wxConvUTF8)));

				references->AddReference(parent60, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos60, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size60, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator60, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload61_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboCtrl::Create((wxWindow*) object_pointer61_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboCtrl_php*)native_object)->Create((wxWindow*) object_pointer61_0));

				references->AddReference(parent61, "wxWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboCtrl::Create((wxWindow*) object_pointer61_0, (wxWindowID) id61))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboCtrl_php*)native_object)->Create((wxWindow*) object_pointer61_0, (wxWindowID) id61));

				references->AddReference(parent61, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboCtrl::Create((wxWindow*) object_pointer61_0, (wxWindowID) id61, wxString(value61, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboCtrl_php*)native_object)->Create((wxWindow*) object_pointer61_0, (wxWindowID) id61, wxString(value61, wxConvUTF8)));

				references->AddReference(parent61, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboCtrl::Create((wxWindow*) object_pointer61_0, (wxWindowID) id61, wxString(value61, wxConvUTF8), *(wxPoint*) object_pointer61_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboCtrl_php*)native_object)->Create((wxWindow*) object_pointer61_0, (wxWindowID) id61, wxString(value61, wxConvUTF8), *(wxPoint*) object_pointer61_3));

				references->AddReference(parent61, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos61, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboCtrl::Create((wxWindow*) object_pointer61_0, (wxWindowID) id61, wxString(value61, wxConvUTF8), *(wxPoint*) object_pointer61_3, *(wxSize*) object_pointer61_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboCtrl_php*)native_object)->Create((wxWindow*) object_pointer61_0, (wxWindowID) id61, wxString(value61, wxConvUTF8), *(wxPoint*) object_pointer61_3, *(wxSize*) object_pointer61_4));

				references->AddReference(parent61, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos61, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size61, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboCtrl::Create((wxWindow*) object_pointer61_0, (wxWindowID) id61, wxString(value61, wxConvUTF8), *(wxPoint*) object_pointer61_3, *(wxSize*) object_pointer61_4, (long) style61))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboCtrl_php*)native_object)->Create((wxWindow*) object_pointer61_0, (wxWindowID) id61, wxString(value61, wxConvUTF8), *(wxPoint*) object_pointer61_3, *(wxSize*) object_pointer61_4, (long) style61));

				references->AddReference(parent61, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos61, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size61, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboCtrl::Create((wxWindow*) object_pointer61_0, (wxWindowID) id61, wxString(value61, wxConvUTF8), *(wxPoint*) object_pointer61_3, *(wxSize*) object_pointer61_4, (long) style61, *(wxValidator*) object_pointer61_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboCtrl_php*)native_object)->Create((wxWindow*) object_pointer61_0, (wxWindowID) id61, wxString(value61, wxConvUTF8), *(wxPoint*) object_pointer61_3, *(wxSize*) object_pointer61_4, (long) style61, *(wxValidator*) object_pointer61_6));

				references->AddReference(parent61, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos61, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size61, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator61, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxComboCtrl::Create((wxWindow*) object_pointer61_0, (wxWindowID) id61, wxString(value61, wxConvUTF8), *(wxPoint*) object_pointer61_3, *(wxSize*) object_pointer61_4, (long) style61, *(wxValidator*) object_pointer61_6, wxString(name61, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxComboCtrl_php*)native_object)->Create((wxWindow*) object_pointer61_0, (wxWindowID) id61, wxString(value61, wxConvUTF8), *(wxPoint*) object_pointer61_3, *(wxSize*) object_pointer61_4, (long) style61, *(wxValidator*) object_pointer61_6, wxString(name61, wxConvUTF8)));

				references->AddReference(parent61, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos61, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size61, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator61, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload62_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDataViewCtrl::Create((wxWindow*) object_pointer62_0, (wxWindowID) id62))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDataViewCtrl_php*)native_object)->Create((wxWindow*) object_pointer62_0, (wxWindowID) id62));

				references->AddReference(parent62, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDataViewCtrl::Create((wxWindow*) object_pointer62_0, (wxWindowID) id62, *(wxPoint*) object_pointer62_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDataViewCtrl_php*)native_object)->Create((wxWindow*) object_pointer62_0, (wxWindowID) id62, *(wxPoint*) object_pointer62_2));

				references->AddReference(parent62, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(pos62, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDataViewCtrl::Create((wxWindow*) object_pointer62_0, (wxWindowID) id62, *(wxPoint*) object_pointer62_2, *(wxSize*) object_pointer62_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDataViewCtrl_php*)native_object)->Create((wxWindow*) object_pointer62_0, (wxWindowID) id62, *(wxPoint*) object_pointer62_2, *(wxSize*) object_pointer62_3));

				references->AddReference(parent62, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos62, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(size62, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDataViewCtrl::Create((wxWindow*) object_pointer62_0, (wxWindowID) id62, *(wxPoint*) object_pointer62_2, *(wxSize*) object_pointer62_3, (long) style62))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDataViewCtrl_php*)native_object)->Create((wxWindow*) object_pointer62_0, (wxWindowID) id62, *(wxPoint*) object_pointer62_2, *(wxSize*) object_pointer62_3, (long) style62));

				references->AddReference(parent62, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos62, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size62, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDataViewCtrl::Create((wxWindow*) object_pointer62_0, (wxWindowID) id62, *(wxPoint*) object_pointer62_2, *(wxSize*) object_pointer62_3, (long) style62, *(wxValidator*) object_pointer62_5))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDataViewCtrl_php*)native_object)->Create((wxWindow*) object_pointer62_0, (wxWindowID) id62, *(wxPoint*) object_pointer62_2, *(wxSize*) object_pointer62_3, (long) style62, *(wxValidator*) object_pointer62_5));

				references->AddReference(parent62, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos62, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size62, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(validator62, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDataViewCtrl::Create((wxWindow*) object_pointer62_0, (wxWindowID) id62, *(wxPoint*) object_pointer62_2, *(wxSize*) object_pointer62_3, (long) style62, *(wxValidator*) object_pointer62_5, wxString(name62, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDataViewCtrl_php*)native_object)->Create((wxWindow*) object_pointer62_0, (wxWindowID) id62, *(wxPoint*) object_pointer62_2, *(wxSize*) object_pointer62_3, (long) style62, *(wxValidator*) object_pointer62_5, wxString(name62, wxConvUTF8)));

				references->AddReference(parent62, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos62, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size62, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(validator62, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload63_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDataViewListCtrl::Create((wxWindow*) object_pointer63_0, (wxWindowID) id63))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDataViewListCtrl_php*)native_object)->Create((wxWindow*) object_pointer63_0, (wxWindowID) id63));

				references->AddReference(parent63, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDataViewListCtrl::Create((wxWindow*) object_pointer63_0, (wxWindowID) id63, *(wxPoint*) object_pointer63_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDataViewListCtrl_php*)native_object)->Create((wxWindow*) object_pointer63_0, (wxWindowID) id63, *(wxPoint*) object_pointer63_2));

				references->AddReference(parent63, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(pos63, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDataViewListCtrl::Create((wxWindow*) object_pointer63_0, (wxWindowID) id63, *(wxPoint*) object_pointer63_2, *(wxSize*) object_pointer63_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDataViewListCtrl_php*)native_object)->Create((wxWindow*) object_pointer63_0, (wxWindowID) id63, *(wxPoint*) object_pointer63_2, *(wxSize*) object_pointer63_3));

				references->AddReference(parent63, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos63, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(size63, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDataViewListCtrl::Create((wxWindow*) object_pointer63_0, (wxWindowID) id63, *(wxPoint*) object_pointer63_2, *(wxSize*) object_pointer63_3, (long) style63))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDataViewListCtrl_php*)native_object)->Create((wxWindow*) object_pointer63_0, (wxWindowID) id63, *(wxPoint*) object_pointer63_2, *(wxSize*) object_pointer63_3, (long) style63));

				references->AddReference(parent63, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos63, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size63, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDataViewListCtrl::Create((wxWindow*) object_pointer63_0, (wxWindowID) id63, *(wxPoint*) object_pointer63_2, *(wxSize*) object_pointer63_3, (long) style63, *(wxValidator*) object_pointer63_5))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDataViewListCtrl_php*)native_object)->Create((wxWindow*) object_pointer63_0, (wxWindowID) id63, *(wxPoint*) object_pointer63_2, *(wxSize*) object_pointer63_3, (long) style63, *(wxValidator*) object_pointer63_5));

				references->AddReference(parent63, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos63, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size63, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(validator63, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload64_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDataViewTreeCtrl::Create((wxWindow*) object_pointer64_0, (wxWindowID) id64))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDataViewTreeCtrl_php*)native_object)->Create((wxWindow*) object_pointer64_0, (wxWindowID) id64));

				references->AddReference(parent64, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDataViewTreeCtrl::Create((wxWindow*) object_pointer64_0, (wxWindowID) id64, *(wxPoint*) object_pointer64_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDataViewTreeCtrl_php*)native_object)->Create((wxWindow*) object_pointer64_0, (wxWindowID) id64, *(wxPoint*) object_pointer64_2));

				references->AddReference(parent64, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(pos64, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDataViewTreeCtrl::Create((wxWindow*) object_pointer64_0, (wxWindowID) id64, *(wxPoint*) object_pointer64_2, *(wxSize*) object_pointer64_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDataViewTreeCtrl_php*)native_object)->Create((wxWindow*) object_pointer64_0, (wxWindowID) id64, *(wxPoint*) object_pointer64_2, *(wxSize*) object_pointer64_3));

				references->AddReference(parent64, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos64, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(size64, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDataViewTreeCtrl::Create((wxWindow*) object_pointer64_0, (wxWindowID) id64, *(wxPoint*) object_pointer64_2, *(wxSize*) object_pointer64_3, (long) style64))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDataViewTreeCtrl_php*)native_object)->Create((wxWindow*) object_pointer64_0, (wxWindowID) id64, *(wxPoint*) object_pointer64_2, *(wxSize*) object_pointer64_3, (long) style64));

				references->AddReference(parent64, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos64, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size64, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxDataViewTreeCtrl::Create((wxWindow*) object_pointer64_0, (wxWindowID) id64, *(wxPoint*) object_pointer64_2, *(wxSize*) object_pointer64_3, (long) style64, *(wxValidator*) object_pointer64_5))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxDataViewTreeCtrl_php*)native_object)->Create((wxWindow*) object_pointer64_0, (wxWindowID) id64, *(wxPoint*) object_pointer64_2, *(wxSize*) object_pointer64_3, (long) style64, *(wxValidator*) object_pointer64_5));

				references->AddReference(parent64, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos64, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size64, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(validator64, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload65_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFileCtrl::Create((wxWindow*) object_pointer65_0, (wxWindowID) id65))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFileCtrl_php*)native_object)->Create((wxWindow*) object_pointer65_0, (wxWindowID) id65));

				references->AddReference(parent65, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFileCtrl::Create((wxWindow*) object_pointer65_0, (wxWindowID) id65, wxString(defaultDirectory65, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFileCtrl_php*)native_object)->Create((wxWindow*) object_pointer65_0, (wxWindowID) id65, wxString(defaultDirectory65, wxConvUTF8)));

				references->AddReference(parent65, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFileCtrl::Create((wxWindow*) object_pointer65_0, (wxWindowID) id65, wxString(defaultDirectory65, wxConvUTF8), wxString(defaultFilename65, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFileCtrl_php*)native_object)->Create((wxWindow*) object_pointer65_0, (wxWindowID) id65, wxString(defaultDirectory65, wxConvUTF8), wxString(defaultFilename65, wxConvUTF8)));

				references->AddReference(parent65, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFileCtrl::Create((wxWindow*) object_pointer65_0, (wxWindowID) id65, wxString(defaultDirectory65, wxConvUTF8), wxString(defaultFilename65, wxConvUTF8), wxString(wildCard65, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFileCtrl_php*)native_object)->Create((wxWindow*) object_pointer65_0, (wxWindowID) id65, wxString(defaultDirectory65, wxConvUTF8), wxString(defaultFilename65, wxConvUTF8), wxString(wildCard65, wxConvUTF8)));

				references->AddReference(parent65, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFileCtrl::Create((wxWindow*) object_pointer65_0, (wxWindowID) id65, wxString(defaultDirectory65, wxConvUTF8), wxString(defaultFilename65, wxConvUTF8), wxString(wildCard65, wxConvUTF8), (long) style65))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFileCtrl_php*)native_object)->Create((wxWindow*) object_pointer65_0, (wxWindowID) id65, wxString(defaultDirectory65, wxConvUTF8), wxString(defaultFilename65, wxConvUTF8), wxString(wildCard65, wxConvUTF8), (long) style65));

				references->AddReference(parent65, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFileCtrl::Create((wxWindow*) object_pointer65_0, (wxWindowID) id65, wxString(defaultDirectory65, wxConvUTF8), wxString(defaultFilename65, wxConvUTF8), wxString(wildCard65, wxConvUTF8), (long) style65, *(wxPoint*) object_pointer65_6))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFileCtrl_php*)native_object)->Create((wxWindow*) object_pointer65_0, (wxWindowID) id65, wxString(defaultDirectory65, wxConvUTF8), wxString(defaultFilename65, wxConvUTF8), wxString(wildCard65, wxConvUTF8), (long) style65, *(wxPoint*) object_pointer65_6));

				references->AddReference(parent65, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos65, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFileCtrl::Create((wxWindow*) object_pointer65_0, (wxWindowID) id65, wxString(defaultDirectory65, wxConvUTF8), wxString(defaultFilename65, wxConvUTF8), wxString(wildCard65, wxConvUTF8), (long) style65, *(wxPoint*) object_pointer65_6, *(wxSize*) object_pointer65_7))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFileCtrl_php*)native_object)->Create((wxWindow*) object_pointer65_0, (wxWindowID) id65, wxString(defaultDirectory65, wxConvUTF8), wxString(defaultFilename65, wxConvUTF8), wxString(wildCard65, wxConvUTF8), (long) style65, *(wxPoint*) object_pointer65_6, *(wxSize*) object_pointer65_7));

				references->AddReference(parent65, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos65, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size65, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
			case 9:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxFileCtrl::Create((wxWindow*) object_pointer65_0, (wxWindowID) id65, wxString(defaultDirectory65, wxConvUTF8), wxString(defaultFilename65, wxConvUTF8), wxString(wildCard65, wxConvUTF8), (long) style65, *(wxPoint*) object_pointer65_6, *(wxSize*) object_pointer65_7, wxString(name65, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxFileCtrl_php*)native_object)->Create((wxWindow*) object_pointer65_0, (wxWindowID) id65, wxString(defaultDirectory65, wxConvUTF8), wxString(defaultFilename65, wxConvUTF8), wxString(wildCard65, wxConvUTF8), (long) style65, *(wxPoint*) object_pointer65_6, *(wxSize*) object_pointer65_7, wxString(name65, wxConvUTF8)));

				references->AddReference(parent65, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(pos65, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(size65, "wxWindow::Create at call with 9 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload66_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxInfoBar::Create((wxWindow*) object_pointer66_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxInfoBar_php*)native_object)->Create((wxWindow*) object_pointer66_0));

				references->AddReference(parent66, "wxWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxInfoBar::Create((wxWindow*) object_pointer66_0, (wxWindowID) winid66))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxInfoBar_php*)native_object)->Create((wxWindow*) object_pointer66_0, (wxWindowID) winid66));

				references->AddReference(parent66, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload67_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonBar::Create((wxWindow*) object_pointer67_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonBar_php*)native_object)->Create((wxWindow*) object_pointer67_0));

				references->AddReference(parent67, "wxWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonBar::Create((wxWindow*) object_pointer67_0, (wxWindowID) id67))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonBar_php*)native_object)->Create((wxWindow*) object_pointer67_0, (wxWindowID) id67));

				references->AddReference(parent67, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonBar::Create((wxWindow*) object_pointer67_0, (wxWindowID) id67, *(wxPoint*) object_pointer67_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonBar_php*)native_object)->Create((wxWindow*) object_pointer67_0, (wxWindowID) id67, *(wxPoint*) object_pointer67_2));

				references->AddReference(parent67, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(pos67, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonBar::Create((wxWindow*) object_pointer67_0, (wxWindowID) id67, *(wxPoint*) object_pointer67_2, *(wxSize*) object_pointer67_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonBar_php*)native_object)->Create((wxWindow*) object_pointer67_0, (wxWindowID) id67, *(wxPoint*) object_pointer67_2, *(wxSize*) object_pointer67_3));

				references->AddReference(parent67, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos67, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(size67, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonBar::Create((wxWindow*) object_pointer67_0, (wxWindowID) id67, *(wxPoint*) object_pointer67_2, *(wxSize*) object_pointer67_3, (long) style67))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonBar_php*)native_object)->Create((wxWindow*) object_pointer67_0, (wxWindowID) id67, *(wxPoint*) object_pointer67_2, *(wxSize*) object_pointer67_3, (long) style67));

				references->AddReference(parent67, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos67, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size67, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload68_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonButtonBar::Create((wxWindow*) object_pointer68_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonButtonBar_php*)native_object)->Create((wxWindow*) object_pointer68_0));

				references->AddReference(parent68, "wxWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonButtonBar::Create((wxWindow*) object_pointer68_0, (wxWindowID) id68))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonButtonBar_php*)native_object)->Create((wxWindow*) object_pointer68_0, (wxWindowID) id68));

				references->AddReference(parent68, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonButtonBar::Create((wxWindow*) object_pointer68_0, (wxWindowID) id68, *(wxPoint*) object_pointer68_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonButtonBar_php*)native_object)->Create((wxWindow*) object_pointer68_0, (wxWindowID) id68, *(wxPoint*) object_pointer68_2));

				references->AddReference(parent68, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(pos68, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonButtonBar::Create((wxWindow*) object_pointer68_0, (wxWindowID) id68, *(wxPoint*) object_pointer68_2, *(wxSize*) object_pointer68_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonButtonBar_php*)native_object)->Create((wxWindow*) object_pointer68_0, (wxWindowID) id68, *(wxPoint*) object_pointer68_2, *(wxSize*) object_pointer68_3));

				references->AddReference(parent68, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos68, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(size68, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonButtonBar::Create((wxWindow*) object_pointer68_0, (wxWindowID) id68, *(wxPoint*) object_pointer68_2, *(wxSize*) object_pointer68_3, (long) style68))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonButtonBar_php*)native_object)->Create((wxWindow*) object_pointer68_0, (wxWindowID) id68, *(wxPoint*) object_pointer68_2, *(wxSize*) object_pointer68_3, (long) style68));

				references->AddReference(parent68, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos68, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size68, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload69_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonGallery::Create((wxWindow*) object_pointer69_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonGallery_php*)native_object)->Create((wxWindow*) object_pointer69_0));

				references->AddReference(parent69, "wxWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonGallery::Create((wxWindow*) object_pointer69_0, (wxWindowID) id69))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonGallery_php*)native_object)->Create((wxWindow*) object_pointer69_0, (wxWindowID) id69));

				references->AddReference(parent69, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonGallery::Create((wxWindow*) object_pointer69_0, (wxWindowID) id69, *(wxPoint*) object_pointer69_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonGallery_php*)native_object)->Create((wxWindow*) object_pointer69_0, (wxWindowID) id69, *(wxPoint*) object_pointer69_2));

				references->AddReference(parent69, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(pos69, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonGallery::Create((wxWindow*) object_pointer69_0, (wxWindowID) id69, *(wxPoint*) object_pointer69_2, *(wxSize*) object_pointer69_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonGallery_php*)native_object)->Create((wxWindow*) object_pointer69_0, (wxWindowID) id69, *(wxPoint*) object_pointer69_2, *(wxSize*) object_pointer69_3));

				references->AddReference(parent69, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos69, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(size69, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonGallery::Create((wxWindow*) object_pointer69_0, (wxWindowID) id69, *(wxPoint*) object_pointer69_2, *(wxSize*) object_pointer69_3, (long) style69))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonGallery_php*)native_object)->Create((wxWindow*) object_pointer69_0, (wxWindowID) id69, *(wxPoint*) object_pointer69_2, *(wxSize*) object_pointer69_3, (long) style69));

				references->AddReference(parent69, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos69, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size69, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload70_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonPage::Create((wxRibbonBar*) object_pointer70_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonPage_php*)native_object)->Create((wxRibbonBar*) object_pointer70_0));

				references->AddReference(parent70, "wxWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonPage::Create((wxRibbonBar*) object_pointer70_0, (wxWindowID) id70))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonPage_php*)native_object)->Create((wxRibbonBar*) object_pointer70_0, (wxWindowID) id70));

				references->AddReference(parent70, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonPage::Create((wxRibbonBar*) object_pointer70_0, (wxWindowID) id70, wxString(label70, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonPage_php*)native_object)->Create((wxRibbonBar*) object_pointer70_0, (wxWindowID) id70, wxString(label70, wxConvUTF8)));

				references->AddReference(parent70, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonPage::Create((wxRibbonBar*) object_pointer70_0, (wxWindowID) id70, wxString(label70, wxConvUTF8), *(wxBitmap*) object_pointer70_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonPage_php*)native_object)->Create((wxRibbonBar*) object_pointer70_0, (wxWindowID) id70, wxString(label70, wxConvUTF8), *(wxBitmap*) object_pointer70_3));

				references->AddReference(parent70, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(icon70, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonPage::Create((wxRibbonBar*) object_pointer70_0, (wxWindowID) id70, wxString(label70, wxConvUTF8), *(wxBitmap*) object_pointer70_3, (long) style70))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonPage_php*)native_object)->Create((wxRibbonBar*) object_pointer70_0, (wxWindowID) id70, wxString(label70, wxConvUTF8), *(wxBitmap*) object_pointer70_3, (long) style70));

				references->AddReference(parent70, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(icon70, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload71_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonPanel::Create((wxWindow*) object_pointer71_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonPanel_php*)native_object)->Create((wxWindow*) object_pointer71_0));

				references->AddReference(parent71, "wxWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonPanel::Create((wxWindow*) object_pointer71_0, (wxWindowID) id71))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonPanel_php*)native_object)->Create((wxWindow*) object_pointer71_0, (wxWindowID) id71));

				references->AddReference(parent71, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonPanel::Create((wxWindow*) object_pointer71_0, (wxWindowID) id71, wxString(label71, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonPanel_php*)native_object)->Create((wxWindow*) object_pointer71_0, (wxWindowID) id71, wxString(label71, wxConvUTF8)));

				references->AddReference(parent71, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonPanel::Create((wxWindow*) object_pointer71_0, (wxWindowID) id71, wxString(label71, wxConvUTF8), *(wxBitmap*) object_pointer71_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonPanel_php*)native_object)->Create((wxWindow*) object_pointer71_0, (wxWindowID) id71, wxString(label71, wxConvUTF8), *(wxBitmap*) object_pointer71_3));

				references->AddReference(parent71, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(icon71, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonPanel::Create((wxWindow*) object_pointer71_0, (wxWindowID) id71, wxString(label71, wxConvUTF8), *(wxBitmap*) object_pointer71_3, *(wxPoint*) object_pointer71_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonPanel_php*)native_object)->Create((wxWindow*) object_pointer71_0, (wxWindowID) id71, wxString(label71, wxConvUTF8), *(wxBitmap*) object_pointer71_3, *(wxPoint*) object_pointer71_4));

				references->AddReference(parent71, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(icon71, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos71, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonPanel::Create((wxWindow*) object_pointer71_0, (wxWindowID) id71, wxString(label71, wxConvUTF8), *(wxBitmap*) object_pointer71_3, *(wxPoint*) object_pointer71_4, *(wxSize*) object_pointer71_5))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonPanel_php*)native_object)->Create((wxWindow*) object_pointer71_0, (wxWindowID) id71, wxString(label71, wxConvUTF8), *(wxBitmap*) object_pointer71_3, *(wxPoint*) object_pointer71_4, *(wxSize*) object_pointer71_5));

				references->AddReference(parent71, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(icon71, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos71, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size71, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonPanel::Create((wxWindow*) object_pointer71_0, (wxWindowID) id71, wxString(label71, wxConvUTF8), *(wxBitmap*) object_pointer71_3, *(wxPoint*) object_pointer71_4, *(wxSize*) object_pointer71_5, (long) style71))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonPanel_php*)native_object)->Create((wxWindow*) object_pointer71_0, (wxWindowID) id71, wxString(label71, wxConvUTF8), *(wxBitmap*) object_pointer71_3, *(wxPoint*) object_pointer71_4, *(wxSize*) object_pointer71_5, (long) style71));

				references->AddReference(parent71, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(icon71, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos71, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size71, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload72_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonToolBar::Create((wxWindow*) object_pointer72_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonToolBar_php*)native_object)->Create((wxWindow*) object_pointer72_0));

				references->AddReference(parent72, "wxWindow::Create at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonToolBar::Create((wxWindow*) object_pointer72_0, (wxWindowID) id72))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonToolBar_php*)native_object)->Create((wxWindow*) object_pointer72_0, (wxWindowID) id72));

				references->AddReference(parent72, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonToolBar::Create((wxWindow*) object_pointer72_0, (wxWindowID) id72, *(wxPoint*) object_pointer72_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonToolBar_php*)native_object)->Create((wxWindow*) object_pointer72_0, (wxWindowID) id72, *(wxPoint*) object_pointer72_2));

				references->AddReference(parent72, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(pos72, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonToolBar::Create((wxWindow*) object_pointer72_0, (wxWindowID) id72, *(wxPoint*) object_pointer72_2, *(wxSize*) object_pointer72_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonToolBar_php*)native_object)->Create((wxWindow*) object_pointer72_0, (wxWindowID) id72, *(wxPoint*) object_pointer72_2, *(wxSize*) object_pointer72_3));

				references->AddReference(parent72, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos72, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(size72, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxRibbonToolBar::Create((wxWindow*) object_pointer72_0, (wxWindowID) id72, *(wxPoint*) object_pointer72_2, *(wxSize*) object_pointer72_3, (long) style72))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxRibbonToolBar_php*)native_object)->Create((wxWindow*) object_pointer72_0, (wxWindowID) id72, *(wxPoint*) object_pointer72_2, *(wxSize*) object_pointer72_3, (long) style72));

				references->AddReference(parent72, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos72, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size72, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload73_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWebView::Create((wxWindow*) object_pointer73_0, (wxWindowID) id73))\n\n");
				#endif

				if(current_object_type == PHP_WXWEBVIEW_TYPE)
				{
					ZVAL_BOOL(return_value, ((wxWebView_php*)native_object)->Create((wxWindow*) object_pointer73_0, (wxWindowID) id73));
				}

				references->AddReference(parent73, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWebView::Create((wxWindow*) object_pointer73_0, (wxWindowID) id73, wxString(url73, wxConvUTF8)))\n\n");
				#endif

				if(current_object_type == PHP_WXWEBVIEW_TYPE)
				{
					ZVAL_BOOL(return_value, ((wxWebView_php*)native_object)->Create((wxWindow*) object_pointer73_0, (wxWindowID) id73, wxString(url73, wxConvUTF8)));
				}

				references->AddReference(parent73, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWebView::Create((wxWindow*) object_pointer73_0, (wxWindowID) id73, wxString(url73, wxConvUTF8), *(wxPoint*) object_pointer73_3))\n\n");
				#endif

				if(current_object_type == PHP_WXWEBVIEW_TYPE)
				{
					ZVAL_BOOL(return_value, ((wxWebView_php*)native_object)->Create((wxWindow*) object_pointer73_0, (wxWindowID) id73, wxString(url73, wxConvUTF8), *(wxPoint*) object_pointer73_3));
				}

				references->AddReference(parent73, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos73, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWebView::Create((wxWindow*) object_pointer73_0, (wxWindowID) id73, wxString(url73, wxConvUTF8), *(wxPoint*) object_pointer73_3, *(wxSize*) object_pointer73_4))\n\n");
				#endif

				if(current_object_type == PHP_WXWEBVIEW_TYPE)
				{
					ZVAL_BOOL(return_value, ((wxWebView_php*)native_object)->Create((wxWindow*) object_pointer73_0, (wxWindowID) id73, wxString(url73, wxConvUTF8), *(wxPoint*) object_pointer73_3, *(wxSize*) object_pointer73_4));
				}

				references->AddReference(parent73, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos73, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size73, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWebView::Create((wxWindow*) object_pointer73_0, (wxWindowID) id73, wxString(url73, wxConvUTF8), *(wxPoint*) object_pointer73_3, *(wxSize*) object_pointer73_4, (long) style73))\n\n");
				#endif

				if(current_object_type == PHP_WXWEBVIEW_TYPE)
				{
					ZVAL_BOOL(return_value, ((wxWebView_php*)native_object)->Create((wxWindow*) object_pointer73_0, (wxWindowID) id73, wxString(url73, wxConvUTF8), *(wxPoint*) object_pointer73_3, *(wxSize*) object_pointer73_4, (long) style73));
				}

				references->AddReference(parent73, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos73, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size73, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWebView::Create((wxWindow*) object_pointer73_0, (wxWindowID) id73, wxString(url73, wxConvUTF8), *(wxPoint*) object_pointer73_3, *(wxSize*) object_pointer73_4, (long) style73, wxString(name73, wxConvUTF8)))\n\n");
				#endif

				if(current_object_type == PHP_WXWEBVIEW_TYPE)
				{
					ZVAL_BOOL(return_value, ((wxWebView_php*)native_object)->Create((wxWindow*) object_pointer73_0, (wxWindowID) id73, wxString(url73, wxConvUTF8), *(wxPoint*) object_pointer73_3, *(wxSize*) object_pointer73_4, (long) style73, wxString(name73, wxConvUTF8)));
				}

				references->AddReference(parent73, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos73, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size73, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload74_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMediaCtrl::Create((wxWindow*) object_pointer74_0, (wxWindowID) id74))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMediaCtrl_php*)native_object)->Create((wxWindow*) object_pointer74_0, (wxWindowID) id74));

				references->AddReference(parent74, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMediaCtrl::Create((wxWindow*) object_pointer74_0, (wxWindowID) id74, wxString(fileName74, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMediaCtrl_php*)native_object)->Create((wxWindow*) object_pointer74_0, (wxWindowID) id74, wxString(fileName74, wxConvUTF8)));

				references->AddReference(parent74, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMediaCtrl::Create((wxWindow*) object_pointer74_0, (wxWindowID) id74, wxString(fileName74, wxConvUTF8), *(wxPoint*) object_pointer74_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMediaCtrl_php*)native_object)->Create((wxWindow*) object_pointer74_0, (wxWindowID) id74, wxString(fileName74, wxConvUTF8), *(wxPoint*) object_pointer74_3));

				references->AddReference(parent74, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos74, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMediaCtrl::Create((wxWindow*) object_pointer74_0, (wxWindowID) id74, wxString(fileName74, wxConvUTF8), *(wxPoint*) object_pointer74_3, *(wxSize*) object_pointer74_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMediaCtrl_php*)native_object)->Create((wxWindow*) object_pointer74_0, (wxWindowID) id74, wxString(fileName74, wxConvUTF8), *(wxPoint*) object_pointer74_3, *(wxSize*) object_pointer74_4));

				references->AddReference(parent74, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos74, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size74, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMediaCtrl::Create((wxWindow*) object_pointer74_0, (wxWindowID) id74, wxString(fileName74, wxConvUTF8), *(wxPoint*) object_pointer74_3, *(wxSize*) object_pointer74_4, (long) style74))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMediaCtrl_php*)native_object)->Create((wxWindow*) object_pointer74_0, (wxWindowID) id74, wxString(fileName74, wxConvUTF8), *(wxPoint*) object_pointer74_3, *(wxSize*) object_pointer74_4, (long) style74));

				references->AddReference(parent74, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos74, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size74, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMediaCtrl::Create((wxWindow*) object_pointer74_0, (wxWindowID) id74, wxString(fileName74, wxConvUTF8), *(wxPoint*) object_pointer74_3, *(wxSize*) object_pointer74_4, (long) style74, wxString(szBackend74, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMediaCtrl_php*)native_object)->Create((wxWindow*) object_pointer74_0, (wxWindowID) id74, wxString(fileName74, wxConvUTF8), *(wxPoint*) object_pointer74_3, *(wxSize*) object_pointer74_4, (long) style74, wxString(szBackend74, wxConvUTF8)));

				references->AddReference(parent74, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos74, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size74, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
			case 8:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMediaCtrl::Create((wxWindow*) object_pointer74_0, (wxWindowID) id74, wxString(fileName74, wxConvUTF8), *(wxPoint*) object_pointer74_3, *(wxSize*) object_pointer74_4, (long) style74, wxString(szBackend74, wxConvUTF8), *(wxValidator*) object_pointer74_7))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMediaCtrl_php*)native_object)->Create((wxWindow*) object_pointer74_0, (wxWindowID) id74, wxString(fileName74, wxConvUTF8), *(wxPoint*) object_pointer74_3, *(wxSize*) object_pointer74_4, (long) style74, wxString(szBackend74, wxConvUTF8), *(wxValidator*) object_pointer74_7));

				references->AddReference(parent74, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(pos74, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(size74, "wxWindow::Create at call with 8 argument(s)");
				references->AddReference(validator74, "wxWindow::Create at call with 8 argument(s)");

				return;
				break;
			}
			case 9:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMediaCtrl::Create((wxWindow*) object_pointer74_0, (wxWindowID) id74, wxString(fileName74, wxConvUTF8), *(wxPoint*) object_pointer74_3, *(wxSize*) object_pointer74_4, (long) style74, wxString(szBackend74, wxConvUTF8), *(wxValidator*) object_pointer74_7, wxString(name74, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMediaCtrl_php*)native_object)->Create((wxWindow*) object_pointer74_0, (wxWindowID) id74, wxString(fileName74, wxConvUTF8), *(wxPoint*) object_pointer74_3, *(wxSize*) object_pointer74_4, (long) style74, wxString(szBackend74, wxConvUTF8), *(wxValidator*) object_pointer74_7, wxString(name74, wxConvUTF8)));

				references->AddReference(parent74, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(pos74, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(size74, "wxWindow::Create at call with 9 argument(s)");
				references->AddReference(validator74, "wxWindow::Create at call with 9 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload75_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxEditableListBox::Create((wxWindow*) object_pointer75_0, (wxWindowID) id75, wxString(label75, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxEditableListBox_php*)native_object)->Create((wxWindow*) object_pointer75_0, (wxWindowID) id75, wxString(label75, wxConvUTF8)));

				references->AddReference(parent75, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxEditableListBox::Create((wxWindow*) object_pointer75_0, (wxWindowID) id75, wxString(label75, wxConvUTF8), *(wxPoint*) object_pointer75_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxEditableListBox_php*)native_object)->Create((wxWindow*) object_pointer75_0, (wxWindowID) id75, wxString(label75, wxConvUTF8), *(wxPoint*) object_pointer75_3));

				references->AddReference(parent75, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos75, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxEditableListBox::Create((wxWindow*) object_pointer75_0, (wxWindowID) id75, wxString(label75, wxConvUTF8), *(wxPoint*) object_pointer75_3, *(wxSize*) object_pointer75_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxEditableListBox_php*)native_object)->Create((wxWindow*) object_pointer75_0, (wxWindowID) id75, wxString(label75, wxConvUTF8), *(wxPoint*) object_pointer75_3, *(wxSize*) object_pointer75_4));

				references->AddReference(parent75, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos75, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size75, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxEditableListBox::Create((wxWindow*) object_pointer75_0, (wxWindowID) id75, wxString(label75, wxConvUTF8), *(wxPoint*) object_pointer75_3, *(wxSize*) object_pointer75_4, (long) style75))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxEditableListBox_php*)native_object)->Create((wxWindow*) object_pointer75_0, (wxWindowID) id75, wxString(label75, wxConvUTF8), *(wxPoint*) object_pointer75_3, *(wxSize*) object_pointer75_4, (long) style75));

				references->AddReference(parent75, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos75, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size75, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxEditableListBox::Create((wxWindow*) object_pointer75_0, (wxWindowID) id75, wxString(label75, wxConvUTF8), *(wxPoint*) object_pointer75_3, *(wxSize*) object_pointer75_4, (long) style75, wxString(name75, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxEditableListBox_php*)native_object)->Create((wxWindow*) object_pointer75_0, (wxWindowID) id75, wxString(label75, wxConvUTF8), *(wxPoint*) object_pointer75_3, *(wxSize*) object_pointer75_4, (long) style75, wxString(name75, wxConvUTF8)));

				references->AddReference(parent75, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos75, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size75, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload76_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBannerWindow::Create((wxWindow*) object_pointer76_0, (wxWindowID) winid76))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBannerWindow_php*)native_object)->Create((wxWindow*) object_pointer76_0, (wxWindowID) winid76));

				references->AddReference(parent76, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBannerWindow::Create((wxWindow*) object_pointer76_0, (wxWindowID) winid76, (wxDirection) dir76))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBannerWindow_php*)native_object)->Create((wxWindow*) object_pointer76_0, (wxWindowID) winid76, (wxDirection) dir76));

				references->AddReference(parent76, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBannerWindow::Create((wxWindow*) object_pointer76_0, (wxWindowID) winid76, (wxDirection) dir76, *(wxPoint*) object_pointer76_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBannerWindow_php*)native_object)->Create((wxWindow*) object_pointer76_0, (wxWindowID) winid76, (wxDirection) dir76, *(wxPoint*) object_pointer76_3));

				references->AddReference(parent76, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos76, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBannerWindow::Create((wxWindow*) object_pointer76_0, (wxWindowID) winid76, (wxDirection) dir76, *(wxPoint*) object_pointer76_3, *(wxSize*) object_pointer76_4))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBannerWindow_php*)native_object)->Create((wxWindow*) object_pointer76_0, (wxWindowID) winid76, (wxDirection) dir76, *(wxPoint*) object_pointer76_3, *(wxSize*) object_pointer76_4));

				references->AddReference(parent76, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos76, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size76, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBannerWindow::Create((wxWindow*) object_pointer76_0, (wxWindowID) winid76, (wxDirection) dir76, *(wxPoint*) object_pointer76_3, *(wxSize*) object_pointer76_4, (long) style76))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBannerWindow_php*)native_object)->Create((wxWindow*) object_pointer76_0, (wxWindowID) winid76, (wxDirection) dir76, *(wxPoint*) object_pointer76_3, *(wxSize*) object_pointer76_4, (long) style76));

				references->AddReference(parent76, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos76, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size76, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
			case 7:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxBannerWindow::Create((wxWindow*) object_pointer76_0, (wxWindowID) winid76, (wxDirection) dir76, *(wxPoint*) object_pointer76_3, *(wxSize*) object_pointer76_4, (long) style76, wxString(name76, wxConvUTF8)))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxBannerWindow_php*)native_object)->Create((wxWindow*) object_pointer76_0, (wxWindowID) winid76, (wxDirection) dir76, *(wxPoint*) object_pointer76_3, *(wxSize*) object_pointer76_4, (long) style76, wxString(name76, wxConvUTF8)));

				references->AddReference(parent76, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(pos76, "wxWindow::Create at call with 7 argument(s)");
				references->AddReference(size76, "wxWindow::Create at call with 7 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload77_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHtmlHelpWindow::Create((wxWindow*) object_pointer77_0, (wxWindowID) id77))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxHtmlHelpWindow_php*)native_object)->Create((wxWindow*) object_pointer77_0, (wxWindowID) id77));

				references->AddReference(parent77, "wxWindow::Create at call with 2 argument(s)");

				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHtmlHelpWindow::Create((wxWindow*) object_pointer77_0, (wxWindowID) id77, *(wxPoint*) object_pointer77_2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxHtmlHelpWindow_php*)native_object)->Create((wxWindow*) object_pointer77_0, (wxWindowID) id77, *(wxPoint*) object_pointer77_2));

				references->AddReference(parent77, "wxWindow::Create at call with 3 argument(s)");
				references->AddReference(pos77, "wxWindow::Create at call with 3 argument(s)");

				return;
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHtmlHelpWindow::Create((wxWindow*) object_pointer77_0, (wxWindowID) id77, *(wxPoint*) object_pointer77_2, *(wxSize*) object_pointer77_3))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxHtmlHelpWindow_php*)native_object)->Create((wxWindow*) object_pointer77_0, (wxWindowID) id77, *(wxPoint*) object_pointer77_2, *(wxSize*) object_pointer77_3));

				references->AddReference(parent77, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(pos77, "wxWindow::Create at call with 4 argument(s)");
				references->AddReference(size77, "wxWindow::Create at call with 4 argument(s)");

				return;
				break;
			}
			case 5:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHtmlHelpWindow::Create((wxWindow*) object_pointer77_0, (wxWindowID) id77, *(wxPoint*) object_pointer77_2, *(wxSize*) object_pointer77_3, (int) style77))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxHtmlHelpWindow_php*)native_object)->Create((wxWindow*) object_pointer77_0, (wxWindowID) id77, *(wxPoint*) object_pointer77_2, *(wxSize*) object_pointer77_3, (int) style77));

				references->AddReference(parent77, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(pos77, "wxWindow::Create at call with 5 argument(s)");
				references->AddReference(size77, "wxWindow::Create at call with 5 argument(s)");

				return;
				break;
			}
			case 6:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxHtmlHelpWindow::Create((wxWindow*) object_pointer77_0, (wxWindowID) id77, *(wxPoint*) object_pointer77_2, *(wxSize*) object_pointer77_3, (int) style77, (int) helpStyle77))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxHtmlHelpWindow_php*)native_object)->Create((wxWindow*) object_pointer77_0, (wxWindowID) id77, *(wxPoint*) object_pointer77_2, *(wxSize*) object_pointer77_3, (int) style77, (int) helpStyle77));

				references->AddReference(parent77, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(pos77, "wxWindow::Create at call with 6 argument(s)");
				references->AddReference(size77, "wxWindow::Create at call with 6 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Create\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::DragAcceptFiles(bool accept)
   Enables or disables eligibility for drop file events (OnDropFiles). */
PHP_METHOD(php_wxWindow, DragAcceptFiles)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::DragAcceptFiles\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::DragAcceptFiles call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool accept0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'b' (&accept0)\n");
		#endif

		char parse_parameters_string[] = "b";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &accept0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::DragAcceptFiles(accept0)\n\n");
				#endif

				((wxWindow_php*)native_object)->DragAcceptFiles(accept0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::DragAcceptFiles\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::DoUpdateWindowUI(wxUpdateUIEvent &event)
   Does the window-specific updating after processing the update event. */
PHP_METHOD(php_wxWindow, DoUpdateWindowUI)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::DoUpdateWindowUI\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::DoUpdateWindowUI call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* event0 = 0;
	wxUpdateUIEvent* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&event0, php_wxUpdateUIEvent_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &event0, php_wxUpdateUIEvent_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(event0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxUpdateUIEvent*) zend_object_store_get_object(event0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxUpdateUIEvent*) zend_object_store_get_object(event0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxUpdateUIEvent*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'event' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(event0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'event' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::DoUpdateWindowUI(*(wxUpdateUIEvent*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->DoUpdateWindowUI(*(wxUpdateUIEvent*) object_pointer0_0);

				references->AddReference(event0, "wxWindow::DoUpdateWindowUI at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::DoUpdateWindowUI\n");
	}
}
/* }}} */

/* {{{ proto wxWindow wxWindow::FindFocus()
   Finds the window or control which currently has the keyboard focus. */
PHP_METHOD(php_wxWindow, FindFocus)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::FindFocus\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::FindFocus call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Static ");
				php_printf("Executing wxWindow::FindFocus() to return object pointer\n\n");
				#endif

				wxWindow_php* value_to_return0;
				value_to_return0 = (wxWindow_php*) wxWindow::FindFocus();
				if(value_to_return0 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return0->references.IsUserInitialized()){
					if(value_to_return0->phpObj != NULL){
						*return_value = *value_to_return0->phpObj;
						zval_add_ref(&value_to_return0->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxWindow_entry);
					((zo_wxWindow*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxWindow_php*) value_to_return0;
				}



				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::FindFocus\n");
	}
}
/* }}} */

/* {{{ proto wxWindow wxWindow::FindWindowByLabel(string label, wxWindow parent)
   Find a window by its label. */
PHP_METHOD(php_wxWindow, FindWindowByLabel)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::FindWindowByLabel\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::FindWindowByLabel call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	char* label0;
	long label_len0;
	zval* parent0 = 0;
	wxWindow* object_pointer0_1 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 's|z' (&label0, &label_len0, &parent0)\n");
		#endif

		char parse_parameters_string[] = "s|z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &label0, &label_len0, &parent0 ) == SUCCESS)
		{
			if(arguments_received >= 2){
				if(Z_TYPE_P(parent0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxWindow*) argument_native_object;
					if (!object_pointer0_1 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Static ");
				php_printf("Executing wxWindow::FindWindowByLabel(wxString(label0, wxConvUTF8)) to return object pointer\n\n");
				#endif

				wxWindow_php* value_to_return1;
				value_to_return1 = (wxWindow_php*) wxWindow::FindWindowByLabel(wxString(label0, wxConvUTF8));
				if(value_to_return1 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return1->references.IsUserInitialized()){
					if(value_to_return1->phpObj != NULL){
						*return_value = *value_to_return1->phpObj;
						zval_add_ref(&value_to_return1->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxWindow_entry);
					((zo_wxWindow*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxWindow_php*) value_to_return1;
				}



				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Static ");
				php_printf("Executing wxWindow::FindWindowByLabel(wxString(label0, wxConvUTF8), (const wxWindow*) object_pointer0_1) to return object pointer\n\n");
				#endif

				wxWindow_php* value_to_return2;
				value_to_return2 = (wxWindow_php*) wxWindow::FindWindowByLabel(wxString(label0, wxConvUTF8), (const wxWindow*) object_pointer0_1);
				if(value_to_return2 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return2->references.IsUserInitialized()){
					if(value_to_return2->phpObj != NULL){
						*return_value = *value_to_return2->phpObj;
						zval_add_ref(&value_to_return2->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxWindow_entry);
					((zo_wxWindow*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxWindow_php*) value_to_return2;
				}



				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::FindWindowByLabel\n");
	}
}
/* }}} */

/* {{{ proto wxWindow wxWindow::FindWindowByName(string name, wxWindow parent)
   Find a window by its name (as given in a window constructor or Create() function call). */
PHP_METHOD(php_wxWindow, FindWindowByName)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::FindWindowByName\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::FindWindowByName call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	char* name0;
	long name_len0;
	zval* parent0 = 0;
	wxWindow* object_pointer0_1 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 's|z' (&name0, &name_len0, &parent0)\n");
		#endif

		char parse_parameters_string[] = "s|z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &name0, &name_len0, &parent0 ) == SUCCESS)
		{
			if(arguments_received >= 2){
				if(Z_TYPE_P(parent0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(parent0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxWindow*) argument_native_object;
					if (!object_pointer0_1 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Static ");
				php_printf("Executing wxWindow::FindWindowByName(wxString(name0, wxConvUTF8)) to return object pointer\n\n");
				#endif

				wxWindow_php* value_to_return1;
				value_to_return1 = (wxWindow_php*) wxWindow::FindWindowByName(wxString(name0, wxConvUTF8));
				if(value_to_return1 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return1->references.IsUserInitialized()){
					if(value_to_return1->phpObj != NULL){
						*return_value = *value_to_return1->phpObj;
						zval_add_ref(&value_to_return1->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxWindow_entry);
					((zo_wxWindow*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxWindow_php*) value_to_return1;
				}



				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Static ");
				php_printf("Executing wxWindow::FindWindowByName(wxString(name0, wxConvUTF8), (const wxWindow*) object_pointer0_1) to return object pointer\n\n");
				#endif

				wxWindow_php* value_to_return2;
				value_to_return2 = (wxWindow_php*) wxWindow::FindWindowByName(wxString(name0, wxConvUTF8), (const wxWindow*) object_pointer0_1);
				if(value_to_return2 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return2->references.IsUserInitialized()){
					if(value_to_return2->phpObj != NULL){
						*return_value = *value_to_return2->phpObj;
						zval_add_ref(&value_to_return2->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxWindow_entry);
					((zo_wxWindow*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxWindow_php*) value_to_return2;
				}



				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::FindWindowByName\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::Fit()
   Sizes the window so that it fits around its subwindows. */
PHP_METHOD(php_wxWindow, Fit)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Fit\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Fit call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::Fit()\n\n");
				#endif

				((wxWindow_php*)native_object)->Fit();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Fit\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::FitInside()
   Similar to Fit(), but sizes the interior (virtual) size of a window. */
PHP_METHOD(php_wxWindow, FitInside)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::FitInside\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::FitInside call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::FitInside()\n\n");
				#endif

				((wxWindow_php*)native_object)->FitInside();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::FitInside\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::Freeze()
   Freezes the window or, in other words, prevents any updates from taking place on screen, the window is not redrawn at all. */
PHP_METHOD(php_wxWindow, Freeze)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Freeze\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Freeze call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::Freeze()\n\n");
				#endif

				((wxWindow_php*)native_object)->Freeze();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Freeze\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::GetAutoLayout()
   Returns the sizer of which this window is a member, if any, otherwise NULL. */
PHP_METHOD(php_wxWindow, GetAutoLayout)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetAutoLayout\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetAutoLayout call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::GetAutoLayout())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->GetAutoLayout());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetAutoLayout\n");
	}
}
/* }}} */

/* {{{ proto wxColour wxWindow::GetBackgroundColour()
   Returns the background colour of the window. */
PHP_METHOD(php_wxWindow, GetBackgroundColour)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetBackgroundColour\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetBackgroundColour call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetBackgroundColour() to return new object\n\n");
				#endif

				wxColour value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetBackgroundColour();
				((wxRefCounter *) value_to_return0.GetRefData())->IncRef();
				void* ptr = safe_emalloc(1, sizeof(wxColour_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxColour));
				object_init_ex(return_value, php_wxColour_entry);
				((wxColour_php*)ptr)->phpObj = return_value;
				zo_wxColour* zo0 = (zo_wxColour*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxColour_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetBackgroundColour\n");
	}
}
/* }}} */

/* {{{ proto wxBackgroundStyle wxWindow::GetBackgroundStyle()
   Returns the background style of the window. */
PHP_METHOD(php_wxWindow, GetBackgroundStyle)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetBackgroundStyle\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetBackgroundStyle call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetBackgroundStyle())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetBackgroundStyle());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetBackgroundStyle\n");
	}
}
/* }}} */

/* {{{ proto wxSize wxWindow::GetBestSize()
   This functions returns the best acceptable minimal size for the window. */
PHP_METHOD(php_wxWindow, GetBestSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetBestSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetBestSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetBestSize() to return new object\n\n");
				#endif

				wxSize value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetBestSize();
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo0 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxSize_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetBestSize\n");
	}
}
/* }}} */

/* {{{ proto wxSize wxWindow::GetBestVirtualSize()
   Return the largest of ClientSize and BestSize (as determined by a sizer, interior children, or other means) */
PHP_METHOD(php_wxWindow, GetBestVirtualSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetBestVirtualSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetBestVirtualSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetBestVirtualSize() to return new object\n\n");
				#endif

				wxSize value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetBestVirtualSize();
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo0 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxSize_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetBestVirtualSize\n");
	}
}
/* }}} */

/* {{{ proto wxBorder wxWindow::GetBorder(int flags)
   Get the window border style from the given flags: this is different from simply doing flags & wxBORDER_MASK because it uses GetDefaultBorder() to translate wxBORDER_DEFAULT to something reasonable. */
PHP_METHOD(php_wxWindow, GetBorder)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetBorder\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetBorder call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long flags0;
	bool overload0_called = false;
	//Parameters for overload 1
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&flags0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &flags0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload1_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetBorder((long) flags0))\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetBorder((long) flags0));


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetBorder())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetBorder());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetBorder\n");
	}
}
/* }}} */

/* {{{ proto wxWindow wxWindow::GetCapture()
   Returns the currently captured window. */
PHP_METHOD(php_wxWindow, GetCapture)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetCapture\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetCapture call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Static ");
				php_printf("Executing wxWindow::GetCapture() to return object pointer\n\n");
				#endif

				wxWindow_php* value_to_return0;
				value_to_return0 = (wxWindow_php*) wxWindow::GetCapture();
				if(value_to_return0 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return0->references.IsUserInitialized()){
					if(value_to_return0->phpObj != NULL){
						*return_value = *value_to_return0->phpObj;
						zval_add_ref(&value_to_return0->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxWindow_entry);
					((zo_wxWindow*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxWindow_php*) value_to_return0;
				}



				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetCapture\n");
	}
}
/* }}} */

/* {{{ proto wxCaret wxWindow::GetCaret()
   Returns the caret() associated with the window. */
PHP_METHOD(php_wxWindow, GetCaret)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetCaret\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetCaret call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetCaret() to return object pointer\n\n");
				#endif

				wxCaret_php* value_to_return0;
				value_to_return0 = (wxCaret_php*) ((wxWindow_php*)native_object)->GetCaret();

				if(value_to_return0 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return0->references.IsUserInitialized()){
					if(value_to_return0->phpObj != NULL){
						*return_value = *value_to_return0->phpObj;
						zval_add_ref(&value_to_return0->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxCaret_entry);
					((zo_wxCaret*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxCaret_php*) value_to_return0;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return0 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxWindow::GetCaret at call with 0 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetCaret\n");
	}
}
/* }}} */

/* {{{ proto int wxWindow::GetCharHeight()
   Returns the character height for this window. */
PHP_METHOD(php_wxWindow, GetCharHeight)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetCharHeight\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetCharHeight call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetCharHeight())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetCharHeight());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetCharHeight\n");
	}
}
/* }}} */

/* {{{ proto int wxWindow::GetCharWidth()
   Returns the average character width for this window. */
PHP_METHOD(php_wxWindow, GetCharWidth)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetCharWidth\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetCharWidth call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetCharWidth())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetCharWidth());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetCharWidth\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::Destroy()
   Destroys the window safely. */
PHP_METHOD(php_wxWindow, Destroy)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Destroy\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Destroy call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::Destroy())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->Destroy());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Destroy\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::DestroyChildren()
   Destroys all children of a window. */
PHP_METHOD(php_wxWindow, DestroyChildren)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::DestroyChildren\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::DestroyChildren call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::DestroyChildren())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->DestroyChildren());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::DestroyChildren\n");
	}
}
/* }}} */

/* {{{ proto wxPoint wxWindow::GetClientAreaOrigin()
   Get the origin of the client area of the window relative to the window top left corner (the client area may be shifted because of the borders, scrollbars, other decorations...) */
PHP_METHOD(php_wxWindow, GetClientAreaOrigin)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetClientAreaOrigin\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetClientAreaOrigin call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetClientAreaOrigin() to return new object\n\n");
				#endif

				wxPoint value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetClientAreaOrigin();
				void* ptr = safe_emalloc(1, sizeof(wxPoint_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxPoint));
				object_init_ex(return_value, php_wxPoint_entry);
				((wxPoint_php*)ptr)->phpObj = return_value;
				((wxPoint_php*)ptr)->InitProperties();
				zo_wxPoint* zo0 = (zo_wxPoint*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxPoint_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetClientAreaOrigin\n");
	}
}
/* }}} */

/* {{{ proto wxRect wxWindow::GetClientRect()
   Get the client rectangle in window (i.e. client) coordinates. */
PHP_METHOD(php_wxWindow, GetClientRect)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetClientRect\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetClientRect call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetClientRect() to return new object\n\n");
				#endif

				wxRect value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetClientRect();
				void* ptr = safe_emalloc(1, sizeof(wxRect_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxRect));
				object_init_ex(return_value, php_wxRect_entry);
				((wxRect_php*)ptr)->phpObj = return_value;
				((wxRect_php*)ptr)->InitProperties();
				zo_wxRect* zo0 = (zo_wxRect*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxRect_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetClientRect\n");
	}
}
/* }}} */

/* {{{ proto wxSize wxWindow::GetClientSize()
   This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts. */
PHP_METHOD(php_wxWindow, GetClientSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetClientSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetClientSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetClientSize() to return new object\n\n");
				#endif

				wxSize value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetClientSize();
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo0 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxSize_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetClientSize\n");
	}
}
/* }}} */

/* {{{ proto wxSizer wxWindow::GetContainingSizer()
   Returns the sizer of which this window is a member, if any, otherwise NULL. */
PHP_METHOD(php_wxWindow, GetContainingSizer)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetContainingSizer\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetContainingSizer call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetContainingSizer() to return object pointer\n\n");
				#endif

				wxSizer_php* value_to_return0;
				value_to_return0 = (wxSizer_php*) ((wxWindow_php*)native_object)->GetContainingSizer();

				if(value_to_return0 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return0->references.IsUserInitialized()){
					if(value_to_return0->phpObj != NULL){
						*return_value = *value_to_return0->phpObj;
						zval_add_ref(&value_to_return0->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxSizer_entry);
					((zo_wxSizer*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxSizer_php*) value_to_return0;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return0 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxWindow::GetContainingSizer at call with 0 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetContainingSizer\n");
	}
}
/* }}} */

/* {{{ proto wxCursor wxWindow::GetCursor()
   Return the cursor associated with this window. */
PHP_METHOD(php_wxWindow, GetCursor)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetCursor\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetCursor call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetCursor() to return object reference\n\n");
				#endif

				wxCursor_php* value_to_return0;
				value_to_return0 = (wxCursor_php*) &((wxWindow_php*)native_object)->GetCursor();

				if(value_to_return0->references.IsUserInitialized()){
					if(value_to_return0->phpObj != NULL){
						*return_value = *value_to_return0->phpObj;
						zval_add_ref(&value_to_return0->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value,php_wxCursor_entry);
					((zo_wxCursor*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxCursor_php*) value_to_return0;
				}

				if((void*)value_to_return0 != (void*)native_object && return_is_user_initialized){ //Prevent adding references to it self
					references->AddReference(return_value, "wxWindow::GetCursor at call with 0 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetCursor\n");
	}
}
/* }}} */

/* {{{ proto wxSize wxWindow::GetEffectiveMinSize()
   Merges the window's best size into the min size and returns the result. */
PHP_METHOD(php_wxWindow, GetEffectiveMinSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetEffectiveMinSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetEffectiveMinSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetEffectiveMinSize() to return new object\n\n");
				#endif

				wxSize value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetEffectiveMinSize();
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo0 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxSize_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetEffectiveMinSize\n");
	}
}
/* }}} */

/* {{{ proto wxEvtHandler wxWindow::GetEventHandler()
   Returns the event handler for this window. */
PHP_METHOD(php_wxWindow, GetEventHandler)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetEventHandler\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetEventHandler call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetEventHandler() to return object pointer\n\n");
				#endif

				wxEvtHandler_php* value_to_return0;
				value_to_return0 = (wxEvtHandler_php*) ((wxWindow_php*)native_object)->GetEventHandler();

				if(value_to_return0 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return0->references.IsUserInitialized()){
					if(value_to_return0->phpObj != NULL){
						*return_value = *value_to_return0->phpObj;
						zval_add_ref(&value_to_return0->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxEvtHandler_entry);
					((zo_wxEvtHandler*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxEvtHandler_php*) value_to_return0;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return0 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxWindow::GetEventHandler at call with 0 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetEventHandler\n");
	}
}
/* }}} */

/* {{{ proto int wxWindow::GetExtraStyle()
   Returns the extra style bits for the window. */
PHP_METHOD(php_wxWindow, GetExtraStyle)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetExtraStyle\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetExtraStyle call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetExtraStyle())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetExtraStyle());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetExtraStyle\n");
	}
}
/* }}} */

/* {{{ proto wxFont wxWindow::GetFont()
   Returns the font for this window. */
PHP_METHOD(php_wxWindow, GetFont)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetFont\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetFont call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetFont() to return new object\n\n");
				#endif

				wxFont value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetFont();
				((wxRefCounter *) value_to_return0.GetRefData())->IncRef();
				void* ptr = safe_emalloc(1, sizeof(wxFont_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxFont));
				object_init_ex(return_value, php_wxFont_entry);
				((wxFont_php*)ptr)->phpObj = return_value;
				zo_wxFont* zo0 = (zo_wxFont*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxFont_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetFont\n");
	}
}
/* }}} */

/* {{{ proto wxColour wxWindow::GetForegroundColour()
   Returns the foreground colour of the window. */
PHP_METHOD(php_wxWindow, GetForegroundColour)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetForegroundColour\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetForegroundColour call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetForegroundColour() to return new object\n\n");
				#endif

				wxColour value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetForegroundColour();
				((wxRefCounter *) value_to_return0.GetRefData())->IncRef();
				void* ptr = safe_emalloc(1, sizeof(wxColour_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxColour));
				object_init_ex(return_value, php_wxColour_entry);
				((wxColour_php*)ptr)->phpObj = return_value;
				zo_wxColour* zo0 = (zo_wxColour*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxColour_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetForegroundColour\n");
	}
}
/* }}} */

/* {{{ proto wxWindow wxWindow::GetGrandParent()
   Returns the grandparent of a window, or NULL if there isn't one. */
PHP_METHOD(php_wxWindow, GetGrandParent)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetGrandParent\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetGrandParent call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetGrandParent() to return object pointer\n\n");
				#endif

				wxWindow_php* value_to_return0;
				value_to_return0 = (wxWindow_php*) ((wxWindow_php*)native_object)->GetGrandParent();

				if(value_to_return0 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return0->references.IsUserInitialized()){
					if(value_to_return0->phpObj != NULL){
						*return_value = *value_to_return0->phpObj;
						zval_add_ref(&value_to_return0->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxWindow_entry);
					((zo_wxWindow*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxWindow_php*) value_to_return0;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return0 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxWindow::GetGrandParent at call with 0 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetGrandParent\n");
	}
}
/* }}} */

// GetXWindow implementation from:
// https://github.com/wxWidgets/wxPython/blob/master/src/helpers.cpp#L28

#ifdef __WXMSW__
#include <wx/msw/private.h>
#include <wx/msw/winundef.h>
#include <wx/msw/msvcrt.h>
#endif

#ifdef __WXGTK__
#include <gtk/gtk.h>
#include <gdk/gdkx.h>
#ifdef __WXGTK3__
#define GetXWindow(wxwin) (wxwin)->m_wxwindow ? \
                          GDK_WINDOW_XID(gtk_widget_get_window((wxwin)->m_wxwindow)) :	\
                          GDK_WINDOW_XID(gtk_widget_get_window((wxwin)->m_widget))
#else
#define GetXWindow(wxwin) (wxwin)->m_wxwindow ? \
                          GDK_WINDOW_XWINDOW((wxwin)->m_wxwindow->window) : \
                          GDK_WINDOW_XWINDOW((wxwin)->m_widget->window)
#endif
#include <locale.h>
#endif

#ifdef __WXX11__
#include "wx/x11/privx.h"
#define GetXWindow(wxwin)   ((Window)(wxwin)->GetHandle())
#endif

#ifdef __WXMAC__
#include <wx/osx/private.h>
#endif

/* {{{ proto int wxWindow::GetHandle()
   Returns the platform-specific handle of the physical window. */
PHP_METHOD(php_wxWindow, GetHandle)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetHandle\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetHandle call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetHandle())\n\n");
				#endif

                #ifdef __WXMSW__
                    ZVAL_LONG(
                        return_value, 
                        (size_t) ((wxWindow_php*)native_object)->GetHandle()
                    );
                #endif

                #if defined(__WXGTK__) || defined(__WXX11__)
                    wxWindow* win = (wxWindow*) native_object;
                    #ifdef __WXGTK3__
                        if(gtk_widget_get_window(win->m_wxwindow))
                        {
                            ZVAL_LONG(
                                return_value, 
                                (size_t) GDK_WINDOW_XID(
                                    gtk_widget_get_window(win->m_wxwindow)
                                )
                            );
                        }
                        else if(gtk_widget_get_window(win->m_widget))
                        {
                            ZVAL_LONG(
                                return_value, 
                                (size_t) GDK_WINDOW_XID(
                                    gtk_widget_get_window(win->m_widget)
                                )
                            );
                        }
                        else
                        {
                            ZVAL_LONG(return_value, 0);
                        }
                    #else
                            ZVAL_LONG(
                                return_value, 
                                (size_t) GetXWindow(win)
                            );
                    #endif
                #endif

                #ifdef __WXMAC__
                    ZVAL_LONG(
                        return_value, 
                        (size_t) ((wxWindow_php*)native_object)->GetHandle()
                    );
                #endif


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetHandle\n");
	}
}
/* }}} */

/* {{{ proto string wxWindow::GetHelpText()
   Gets the help text to be used as context-sensitive help for this window. */
PHP_METHOD(php_wxWindow, GetHelpText)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetHelpText\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetHelpText call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_STRING(wxWindow::GetHelpText().fn_str(), 1)\n\n");
				#endif

				wxString value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetHelpText();
				char* temp_string0;
				temp_string0 = (char*)malloc(sizeof(wxChar)*(value_to_return0.size()+1));
				strcpy (temp_string0, (const char *) value_to_return0.char_str() );
				ZVAL_STRING(return_value, temp_string0, 1);
				free(temp_string0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetHelpText\n");
	}
}
/* }}} */

/* {{{ proto string wxWindow::GetHelpTextAtPoint(wxPoint point, wxHelpEvent::Origin origin)
   Gets the help text to be used as context-sensitive help for this window. */
PHP_METHOD(php_wxWindow, GetHelpTextAtPoint)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetHelpTextAtPoint\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetHelpTextAtPoint call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* point0 = 0;
	wxPoint* object_pointer0_0 = 0;
	long origin0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'Ol' (&point0, php_wxPoint_entry, &origin0)\n");
		#endif

		char parse_parameters_string[] = "Ol";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &point0, php_wxPoint_entry, &origin0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(point0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(point0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(point0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxPoint*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'point' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(point0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'point' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_STRING(wxWindow::GetHelpTextAtPoint(*(wxPoint*) object_pointer0_0, (wxHelpEvent::Origin) origin0).fn_str(), 1)\n\n");
				#endif

				wxString value_to_return2;
				value_to_return2 = ((wxWindow_php*)native_object)->GetHelpTextAtPoint(*(wxPoint*) object_pointer0_0, (wxHelpEvent::Origin) origin0);
				char* temp_string2;
				temp_string2 = (char*)malloc(sizeof(wxChar)*(value_to_return2.size()+1));
				strcpy (temp_string2, (const char *) value_to_return2.char_str() );
				ZVAL_STRING(return_value, temp_string2, 1);
				free(temp_string2);

				references->AddReference(point0, "wxWindow::GetHelpTextAtPoint at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetHelpTextAtPoint\n");
	}
}
/* }}} */

/* {{{ proto int wxWindow::GetId()
   Returns the identifier of the window. */
PHP_METHOD(php_wxWindow, GetId)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetId\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetId call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetId())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetId());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetId\n");
	}
}
/* }}} */

/* {{{ proto string wxWindow::GetLabel()
   Generic way of getting a label from any window, for identification purposes. */
PHP_METHOD(php_wxWindow, GetLabel)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetLabel\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetLabel call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
	//Parameters for overload 1
	long id1;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 1 && (current_object_type == PHP_WXMENUBAR_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&id1)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &id1 ) == SUCCESS)
		{
			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_STRING(wxWindow::GetLabel().fn_str(), 1)\n\n");
				#endif

				wxString value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetLabel();
				char* temp_string0;
				temp_string0 = (char*)malloc(sizeof(wxChar)*(value_to_return0.size()+1));
				strcpy (temp_string0, (const char *) value_to_return0.char_str() );
				ZVAL_STRING(return_value, temp_string0, 1);
				free(temp_string0);


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_STRING(wxMenuBar::GetLabel((int) id1).fn_str(), 1)\n\n");
				#endif

				wxString value_to_return1;
				value_to_return1 = ((wxMenuBar_php*)native_object)->GetLabel((int) id1);
				char* temp_string1;
				temp_string1 = (char*)malloc(sizeof(wxChar)*(value_to_return1.size()+1));
				strcpy (temp_string1, (const char *) value_to_return1.char_str() );
				ZVAL_STRING(return_value, temp_string1, 1);
				free(temp_string1);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetLabel\n");
	}
}
/* }}} */

/* {{{ proto wxSize wxWindow::GetMaxClientSize()
   Returns the maximum size of window's client area. */
PHP_METHOD(php_wxWindow, GetMaxClientSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetMaxClientSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetMaxClientSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetMaxClientSize() to return new object\n\n");
				#endif

				wxSize value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetMaxClientSize();
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo0 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxSize_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetMaxClientSize\n");
	}
}
/* }}} */

/* {{{ proto int wxWindow::GetMaxHeight()
   Returns the vertical component of window maximal size. */
PHP_METHOD(php_wxWindow, GetMaxHeight)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetMaxHeight\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetMaxHeight call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetMaxHeight())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetMaxHeight());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetMaxHeight\n");
	}
}
/* }}} */

/* {{{ proto wxSize wxWindow::GetMaxSize()
   Returns the maximum size of the window. */
PHP_METHOD(php_wxWindow, GetMaxSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetMaxSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetMaxSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetMaxSize() to return new object\n\n");
				#endif

				wxSize value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetMaxSize();
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo0 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxSize_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetMaxSize\n");
	}
}
/* }}} */

/* {{{ proto int wxWindow::GetMaxWidth()
   Returns the horizontal component of window maximal size. */
PHP_METHOD(php_wxWindow, GetMaxWidth)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetMaxWidth\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetMaxWidth call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetMaxWidth())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetMaxWidth());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetMaxWidth\n");
	}
}
/* }}} */

/* {{{ proto wxSize wxWindow::GetMinClientSize()
   Returns the minimum size of window's client area, an indication to the sizer layout mechanism that this is the minimum required size of its client area. */
PHP_METHOD(php_wxWindow, GetMinClientSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetMinClientSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetMinClientSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetMinClientSize() to return new object\n\n");
				#endif

				wxSize value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetMinClientSize();
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo0 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxSize_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetMinClientSize\n");
	}
}
/* }}} */

/* {{{ proto int wxWindow::GetMinHeight()
   Returns the vertical component of window minimal size. */
PHP_METHOD(php_wxWindow, GetMinHeight)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetMinHeight\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetMinHeight call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetMinHeight())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetMinHeight());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetMinHeight\n");
	}
}
/* }}} */

/* {{{ proto wxSize wxWindow::GetMinSize()
   Returns the minimum size of the window, an indication to the sizer layout mechanism that this is the minimum required size. */
PHP_METHOD(php_wxWindow, GetMinSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetMinSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetMinSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetMinSize() to return new object\n\n");
				#endif

				wxSize value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetMinSize();
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo0 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxSize_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetMinSize\n");
	}
}
/* }}} */

/* {{{ proto int wxWindow::GetMinWidth()
   Returns the horizontal component of window minimal size. */
PHP_METHOD(php_wxWindow, GetMinWidth)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetMinWidth\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetMinWidth call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetMinWidth())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetMinWidth());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetMinWidth\n");
	}
}
/* }}} */

/* {{{ proto string wxWindow::GetName()
   Returns the window's name. */
PHP_METHOD(php_wxWindow, GetName)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetName\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetName call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_STRING(wxWindow::GetName().fn_str(), 1)\n\n");
				#endif

				wxString value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetName();
				char* temp_string0;
				temp_string0 = (char*)malloc(sizeof(wxChar)*(value_to_return0.size()+1));
				strcpy (temp_string0, (const char *) value_to_return0.char_str() );
				ZVAL_STRING(return_value, temp_string0, 1);
				free(temp_string0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetName\n");
	}
}
/* }}} */

/* {{{ proto wxWindow wxWindow::GetNextSibling()
   Returns the next window after this one among the parent's children or NULL if this window is the last child. */
PHP_METHOD(php_wxWindow, GetNextSibling)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetNextSibling\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetNextSibling call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
	//Parameters for overload 1
	zval* item1 = 0;
	wxTreeItemId* object_pointer1_0 = 0;
	bool overload1_called = false;
	//Parameters for overload 2
	zval* item2 = 0;
	wxTreeListItem* object_pointer2_0 = 0;
	bool overload2_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 1 && (current_object_type == PHP_WXTREECTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&item1, php_wxTreeItemId_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &item1, php_wxTreeItemId_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(item1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxTreeItemId*) zend_object_store_get_object(item1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxTreeItemId*) zend_object_store_get_object(item1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxTreeItemId*) argument_native_object;
					if (!object_pointer1_0 )
					{
						goto overload2;
					}
				}
				else if(Z_TYPE_P(item1) != IS_NULL)
				{
					goto overload2;
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

	//Overload 2
	overload2:
	if(!already_called && arguments_received == 1 && (current_object_type == PHP_WXTREELISTCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&item2, php_wxTreeListItem_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &item2, php_wxTreeListItem_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(item2) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxTreeListItem*) zend_object_store_get_object(item2 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxTreeListItem*) zend_object_store_get_object(item2 TSRMLS_CC))->native_object;
					object_pointer2_0 = (wxTreeListItem*) argument_native_object;
					if (!object_pointer2_0 )
					{
						zend_error(E_ERROR, "Parameter 'item' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(item2) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'item' not null, could not be retreived correctly.");
				}
			}

			overload2_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetNextSibling() to return object pointer\n\n");
				#endif

				wxWindow_php* value_to_return0;
				value_to_return0 = (wxWindow_php*) ((wxWindow_php*)native_object)->GetNextSibling();

				if(value_to_return0 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return0->references.IsUserInitialized()){
					if(value_to_return0->phpObj != NULL){
						*return_value = *value_to_return0->phpObj;
						zval_add_ref(&value_to_return0->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxWindow_entry);
					((zo_wxWindow*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxWindow_php*) value_to_return0;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return0 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxWindow::GetNextSibling at call with 0 argument(s)");
				}


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxTreeCtrl::GetNextSibling(*(wxTreeItemId*) object_pointer1_0) to return new object\n\n");
				#endif

				wxTreeItemId value_to_return1;
				value_to_return1 = ((wxTreeCtrl_php*)native_object)->GetNextSibling(*(wxTreeItemId*) object_pointer1_0);
				void* ptr = safe_emalloc(1, sizeof(wxTreeItemId_php), 0);
				memcpy(ptr, (void*) &value_to_return1, sizeof(wxTreeItemId));
				object_init_ex(return_value, php_wxTreeItemId_entry);
				((wxTreeItemId_php*)ptr)->phpObj = return_value;
				zo_wxTreeItemId* zo1 = (zo_wxTreeItemId*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo1->native_object = (wxTreeItemId_php*) ptr;

				references->AddReference(item1, "wxWindow::GetNextSibling at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload2_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxTreeListCtrl::GetNextSibling(*(wxTreeListItem*) object_pointer2_0) to return new object\n\n");
				#endif

				wxTreeListItem value_to_return1;
				value_to_return1 = ((wxTreeListCtrl_php*)native_object)->GetNextSibling(*(wxTreeListItem*) object_pointer2_0);
				void* ptr = safe_emalloc(1, sizeof(wxTreeListItem_php), 0);
				memcpy(ptr, (void*) &value_to_return1, sizeof(wxTreeListItem));
				object_init_ex(return_value, php_wxTreeListItem_entry);
				((wxTreeListItem_php*)ptr)->phpObj = return_value;
				zo_wxTreeListItem* zo1 = (zo_wxTreeListItem*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo1->native_object = (wxTreeListItem_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetNextSibling\n");
	}
}
/* }}} */

/* {{{ proto wxWindow wxWindow::GetParent()
   Returns the parent of the window, or NULL if there is no parent. */
PHP_METHOD(php_wxWindow, GetParent)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetParent\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetParent call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetParent() to return object pointer\n\n");
				#endif

				wxWindow_php* value_to_return0;
				value_to_return0 = (wxWindow_php*) ((wxWindow_php*)native_object)->GetParent();

				if(value_to_return0 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return0->references.IsUserInitialized()){
					if(value_to_return0->phpObj != NULL){
						*return_value = *value_to_return0->phpObj;
						zval_add_ref(&value_to_return0->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxWindow_entry);
					((zo_wxWindow*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxWindow_php*) value_to_return0;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return0 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxWindow::GetParent at call with 0 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetParent\n");
	}
}
/* }}} */

/* {{{ proto int wxWindow::GetPopupMenuSelectionFromUser(wxMenu &menu, wxPoint pos)
   This function shows a popup menu at the given position in this window and returns the selected id. */
PHP_METHOD(php_wxWindow, GetPopupMenuSelectionFromUser)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetPopupMenuSelectionFromUser\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetPopupMenuSelectionFromUser call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* menu0 = 0;
	wxMenu* object_pointer0_0 = 0;
	zval* pos0 = 0;
	wxPoint* object_pointer0_1 = 0;
	bool overload0_called = false;
	//Parameters for overload 1
	zval* menu1 = 0;
	wxMenu* object_pointer1_0 = 0;
	long x1;
	long y1;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O|O' (&menu0, php_wxMenu_entry, &pos0, php_wxPoint_entry)\n");
		#endif

		char parse_parameters_string[] = "O|O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &menu0, php_wxMenu_entry, &pos0, php_wxPoint_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(menu0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxMenu*) zend_object_store_get_object(menu0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxMenu*) zend_object_store_get_object(menu0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxMenu*) argument_native_object;
					if (!object_pointer0_0 )
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(menu0) != IS_NULL)
				{
					goto overload1;
				}
			}

			if(arguments_received >= 2){
				if(Z_TYPE_P(pos0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxPoint*) argument_native_object;
					if (!object_pointer0_1 )
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(pos0) != IS_NULL)
				{
					goto overload1;
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 3)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'Oll' (&menu1, php_wxMenu_entry, &x1, &y1)\n");
		#endif

		char parse_parameters_string[] = "Oll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &menu1, php_wxMenu_entry, &x1, &y1 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(menu1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxMenu*) zend_object_store_get_object(menu1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxMenu*) zend_object_store_get_object(menu1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxMenu*) argument_native_object;
					if (!object_pointer1_0 )
					{
						zend_error(E_ERROR, "Parameter 'menu' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(menu1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'menu' not null, could not be retreived correctly.");
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetPopupMenuSelectionFromUser(*(wxMenu*) object_pointer0_0))\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetPopupMenuSelectionFromUser(*(wxMenu*) object_pointer0_0));

				references->AddReference(menu0, "wxWindow::GetPopupMenuSelectionFromUser at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetPopupMenuSelectionFromUser(*(wxMenu*) object_pointer0_0, *(wxPoint*) object_pointer0_1))\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetPopupMenuSelectionFromUser(*(wxMenu*) object_pointer0_0, *(wxPoint*) object_pointer0_1));

				references->AddReference(menu0, "wxWindow::GetPopupMenuSelectionFromUser at call with 2 argument(s)");
				references->AddReference(pos0, "wxWindow::GetPopupMenuSelectionFromUser at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetPopupMenuSelectionFromUser(*(wxMenu*) object_pointer1_0, (int) x1, (int) y1))\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetPopupMenuSelectionFromUser(*(wxMenu*) object_pointer1_0, (int) x1, (int) y1));

				references->AddReference(menu1, "wxWindow::GetPopupMenuSelectionFromUser at call with 3 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetPopupMenuSelectionFromUser\n");
	}
}
/* }}} */

/* {{{ proto wxPoint wxWindow::GetPosition()
   This gets the position of the window in pixels, relative to the parent window for the child windows or relative to the display origin for the top level windows. */
PHP_METHOD(php_wxWindow, GetPosition)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetPosition\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetPosition call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetPosition() to return new object\n\n");
				#endif

				wxPoint value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetPosition();
				void* ptr = safe_emalloc(1, sizeof(wxPoint_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxPoint));
				object_init_ex(return_value, php_wxPoint_entry);
				((wxPoint_php*)ptr)->phpObj = return_value;
				((wxPoint_php*)ptr)->InitProperties();
				zo_wxPoint* zo0 = (zo_wxPoint*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxPoint_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetPosition\n");
	}
}
/* }}} */

/* {{{ proto wxWindow wxWindow::GetPrevSibling()
   Returns the previous window before this one among the parent's children or  NULL if this window is the first child. */
PHP_METHOD(php_wxWindow, GetPrevSibling)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetPrevSibling\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetPrevSibling call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
	//Parameters for overload 1
	zval* item1 = 0;
	wxTreeItemId* object_pointer1_0 = 0;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 1 && (current_object_type == PHP_WXTREECTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&item1, php_wxTreeItemId_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &item1, php_wxTreeItemId_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(item1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxTreeItemId*) zend_object_store_get_object(item1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxTreeItemId*) zend_object_store_get_object(item1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxTreeItemId*) argument_native_object;
					if (!object_pointer1_0 )
					{
						zend_error(E_ERROR, "Parameter 'item' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(item1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'item' not null, could not be retreived correctly.");
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetPrevSibling() to return object pointer\n\n");
				#endif

				wxWindow_php* value_to_return0;
				value_to_return0 = (wxWindow_php*) ((wxWindow_php*)native_object)->GetPrevSibling();

				if(value_to_return0 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return0->references.IsUserInitialized()){
					if(value_to_return0->phpObj != NULL){
						*return_value = *value_to_return0->phpObj;
						zval_add_ref(&value_to_return0->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxWindow_entry);
					((zo_wxWindow*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxWindow_php*) value_to_return0;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return0 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxWindow::GetPrevSibling at call with 0 argument(s)");
				}


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxTreeCtrl::GetPrevSibling(*(wxTreeItemId*) object_pointer1_0) to return new object\n\n");
				#endif

				wxTreeItemId value_to_return1;
				value_to_return1 = ((wxTreeCtrl_php*)native_object)->GetPrevSibling(*(wxTreeItemId*) object_pointer1_0);
				void* ptr = safe_emalloc(1, sizeof(wxTreeItemId_php), 0);
				memcpy(ptr, (void*) &value_to_return1, sizeof(wxTreeItemId));
				object_init_ex(return_value, php_wxTreeItemId_entry);
				((wxTreeItemId_php*)ptr)->phpObj = return_value;
				zo_wxTreeItemId* zo1 = (zo_wxTreeItemId*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo1->native_object = (wxTreeItemId_php*) ptr;

				references->AddReference(item1, "wxWindow::GetPrevSibling at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetPrevSibling\n");
	}
}
/* }}} */

/* {{{ proto wxRect wxWindow::GetRect()
   Returns the position and size of the window as a wxRect object. */
PHP_METHOD(php_wxWindow, GetRect)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetRect\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetRect call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetRect() to return new object\n\n");
				#endif

				wxRect value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetRect();
				void* ptr = safe_emalloc(1, sizeof(wxRect_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxRect));
				object_init_ex(return_value, php_wxRect_entry);
				((wxRect_php*)ptr)->phpObj = return_value;
				((wxRect_php*)ptr)->InitProperties();
				zo_wxRect* zo0 = (zo_wxRect*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxRect_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetRect\n");
	}
}
/* }}} */

/* {{{ proto wxPoint wxWindow::GetScreenPosition()
   Returns the window position in screen coordinates, whether the window is a child window or a top level one. */
PHP_METHOD(php_wxWindow, GetScreenPosition)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetScreenPosition\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetScreenPosition call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetScreenPosition() to return new object\n\n");
				#endif

				wxPoint value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetScreenPosition();
				void* ptr = safe_emalloc(1, sizeof(wxPoint_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxPoint));
				object_init_ex(return_value, php_wxPoint_entry);
				((wxPoint_php*)ptr)->phpObj = return_value;
				((wxPoint_php*)ptr)->InitProperties();
				zo_wxPoint* zo0 = (zo_wxPoint*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxPoint_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetScreenPosition\n");
	}
}
/* }}} */

/* {{{ proto wxRect wxWindow::GetScreenRect()
   Returns the position and size of the window on the screen as a wxRect object. */
PHP_METHOD(php_wxWindow, GetScreenRect)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetScreenRect\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetScreenRect call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetScreenRect() to return new object\n\n");
				#endif

				wxRect value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetScreenRect();
				void* ptr = safe_emalloc(1, sizeof(wxRect_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxRect));
				object_init_ex(return_value, php_wxRect_entry);
				((wxRect_php*)ptr)->phpObj = return_value;
				((wxRect_php*)ptr)->InitProperties();
				zo_wxRect* zo0 = (zo_wxRect*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxRect_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetScreenRect\n");
	}
}
/* }}} */

/* {{{ proto int wxWindow::GetScrollPos(int orientation)
   Returns the built-in scrollbar position. */
PHP_METHOD(php_wxWindow, GetScrollPos)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetScrollPos\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetScrollPos call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long orientation0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&orientation0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &orientation0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetScrollPos((int) orientation0))\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetScrollPos((int) orientation0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetScrollPos\n");
	}
}
/* }}} */

/* {{{ proto int wxWindow::GetScrollRange(int orientation)
   Returns the built-in scrollbar range. */
PHP_METHOD(php_wxWindow, GetScrollRange)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetScrollRange\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetScrollRange call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long orientation0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&orientation0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &orientation0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetScrollRange((int) orientation0))\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetScrollRange((int) orientation0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetScrollRange\n");
	}
}
/* }}} */

/* {{{ proto int wxWindow::GetScrollThumb(int orientation)
   Returns the built-in scrollbar thumb size. */
PHP_METHOD(php_wxWindow, GetScrollThumb)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetScrollThumb\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetScrollThumb call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long orientation0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&orientation0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &orientation0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetScrollThumb((int) orientation0))\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetScrollThumb((int) orientation0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetScrollThumb\n");
	}
}
/* }}} */

/* {{{ proto wxSize wxWindow::GetSize()
   See the GetSize(int*,int*) overload for more info. */
PHP_METHOD(php_wxWindow, GetSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetSize() to return new object\n\n");
				#endif

				wxSize value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetSize();
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo0 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxSize_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetSize\n");
	}
}
/* }}} */

/* {{{ proto wxSizer wxWindow::GetSizer()
   Returns the sizer associated with the window by a previous call to SetSizer(), or NULL. */
PHP_METHOD(php_wxWindow, GetSizer)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetSizer\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetSizer call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetSizer() to return object pointer\n\n");
				#endif

				wxSizer_php* value_to_return0;
				value_to_return0 = (wxSizer_php*) ((wxWindow_php*)native_object)->GetSizer();

				if(value_to_return0 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return0->references.IsUserInitialized()){
					if(value_to_return0->phpObj != NULL){
						*return_value = *value_to_return0->phpObj;
						zval_add_ref(&value_to_return0->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxSizer_entry);
					((zo_wxSizer*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxSizer_php*) value_to_return0;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return0 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxWindow::GetSizer at call with 0 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetSizer\n");
	}
}
/* }}} */

/* {{{ proto wxSize wxWindow::GetTextExtent(string string)
   Gets the dimensions of the string as it would be drawn on the window with the currently selected font. */
PHP_METHOD(php_wxWindow, GetTextExtent)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetTextExtent\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetTextExtent call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	char* string0;
	long string_len0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 's' (&string0, &string_len0)\n");
		#endif

		char parse_parameters_string[] = "s";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &string0, &string_len0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetTextExtent(wxString(string0, wxConvUTF8)) to return new object\n\n");
				#endif

				wxSize value_to_return1;
				value_to_return1 = ((wxWindow_php*)native_object)->GetTextExtent(wxString(string0, wxConvUTF8));
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return1, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo1 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo1->native_object = (wxSize_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetTextExtent\n");
	}
}
/* }}} */

/* {{{ proto wxToolTip wxWindow::GetToolTip()
   Get the associated tooltip or NULL if none. */
PHP_METHOD(php_wxWindow, GetToolTip)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetToolTip\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetToolTip call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetToolTip() to return object pointer\n\n");
				#endif

				wxToolTip_php* value_to_return0;
				value_to_return0 = (wxToolTip_php*) ((wxWindow_php*)native_object)->GetToolTip();

				if(value_to_return0 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return0->references.IsUserInitialized()){
					if(value_to_return0->phpObj != NULL){
						*return_value = *value_to_return0->phpObj;
						zval_add_ref(&value_to_return0->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxToolTip_entry);
					((zo_wxToolTip*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxToolTip_php*) value_to_return0;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return0 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxWindow::GetToolTip at call with 0 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetToolTip\n");
	}
}
/* }}} */

/* {{{ proto string wxWindow::GetToolTipText()
   Get the text of the associated tooltip or empty string if none. */
PHP_METHOD(php_wxWindow, GetToolTipText)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetToolTipText\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetToolTipText call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_STRING(wxWindow::GetToolTipText().fn_str(), 1)\n\n");
				#endif

				wxString value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetToolTipText();
				char* temp_string0;
				temp_string0 = (char*)malloc(sizeof(wxChar)*(value_to_return0.size()+1));
				strcpy (temp_string0, (const char *) value_to_return0.char_str() );
				ZVAL_STRING(return_value, temp_string0, 1);
				free(temp_string0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetToolTipText\n");
	}
}
/* }}} */

/* {{{ proto wxRect wxWindow::GetUpdateClientRect()
   Get the update rectangle bounding box in client coords. */
PHP_METHOD(php_wxWindow, GetUpdateClientRect)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetUpdateClientRect\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetUpdateClientRect call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetUpdateClientRect() to return new object\n\n");
				#endif

				wxRect value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetUpdateClientRect();
				void* ptr = safe_emalloc(1, sizeof(wxRect_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxRect));
				object_init_ex(return_value, php_wxRect_entry);
				((wxRect_php*)ptr)->phpObj = return_value;
				((wxRect_php*)ptr)->InitProperties();
				zo_wxRect* zo0 = (zo_wxRect*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxRect_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetUpdateClientRect\n");
	}
}
/* }}} */

/* {{{ proto wxRegion wxWindow::GetUpdateRegion()
   Returns the region specifying which parts of the window have been damaged. */
PHP_METHOD(php_wxWindow, GetUpdateRegion)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetUpdateRegion\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetUpdateRegion call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetUpdateRegion() to return object reference\n\n");
				#endif

				wxRegion_php* value_to_return0;
				value_to_return0 = (wxRegion_php*) &((wxWindow_php*)native_object)->GetUpdateRegion();

				if(value_to_return0->references.IsUserInitialized()){
					if(value_to_return0->phpObj != NULL){
						*return_value = *value_to_return0->phpObj;
						zval_add_ref(&value_to_return0->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value,php_wxRegion_entry);
					((zo_wxRegion*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxRegion_php*) value_to_return0;
				}

				if((void*)value_to_return0 != (void*)native_object && return_is_user_initialized){ //Prevent adding references to it self
					references->AddReference(return_value, "wxWindow::GetUpdateRegion at call with 0 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetUpdateRegion\n");
	}
}
/* }}} */

/* {{{ proto wxValidator wxWindow::GetValidator()
   Validator functions. */
PHP_METHOD(php_wxWindow, GetValidator)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetValidator\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetValidator call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetValidator() to return object pointer\n\n");
				#endif

				wxValidator_php* value_to_return0;
				value_to_return0 = (wxValidator_php*) ((wxWindow_php*)native_object)->GetValidator();

				if(value_to_return0 == NULL){
					ZVAL_NULL(return_value);
				}
				else if(value_to_return0->references.IsUserInitialized()){
					if(value_to_return0->phpObj != NULL){
						*return_value = *value_to_return0->phpObj;
						zval_add_ref(&value_to_return0->phpObj);
						return_is_user_initialized = true;
					}
					else{
						zend_error(E_ERROR, "Could not retreive original zval.");
					}
				}
				else{
					object_init_ex(return_value, php_wxValidator_entry);
					((zo_wxValidator*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object = (wxValidator_php*) value_to_return0;
				}

				if(Z_TYPE_P(return_value) != IS_NULL && (void*)value_to_return0 != (void*)native_object && return_is_user_initialized){
					references->AddReference(return_value, "wxWindow::GetValidator at call with 0 argument(s)");
				}


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetValidator\n");
	}
}
/* }}} */

/* {{{ proto wxSize wxWindow::GetVirtualSize()
   This gets the virtual size of the window in pixels. */
PHP_METHOD(php_wxWindow, GetVirtualSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetVirtualSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetVirtualSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetVirtualSize() to return new object\n\n");
				#endif

				wxSize value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetVirtualSize();
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo0 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxSize_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetVirtualSize\n");
	}
}
/* }}} */

/* {{{ proto wxSize wxWindow::GetWindowBorderSize()
   Returns the size of the left/right and top/bottom borders of this window in x and y components of the result respectively. */
PHP_METHOD(php_wxWindow, GetWindowBorderSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetWindowBorderSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetWindowBorderSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::GetWindowBorderSize() to return new object\n\n");
				#endif

				wxSize value_to_return0;
				value_to_return0 = ((wxWindow_php*)native_object)->GetWindowBorderSize();
				void* ptr = safe_emalloc(1, sizeof(wxSize_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxSize));
				object_init_ex(return_value, php_wxSize_entry);
				((wxSize_php*)ptr)->phpObj = return_value;
				zo_wxSize* zo0 = (zo_wxSize*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxSize_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetWindowBorderSize\n");
	}
}
/* }}} */

/* {{{ proto int wxWindow::GetWindowStyle()
   See GetWindowStyleFlag() for more info. */
PHP_METHOD(php_wxWindow, GetWindowStyle)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetWindowStyle\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetWindowStyle call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetWindowStyle())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetWindowStyle());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetWindowStyle\n");
	}
}
/* }}} */

/* {{{ proto int wxWindow::GetWindowStyleFlag()
   Gets the window style that was passed to the constructor or Create() method. */
PHP_METHOD(php_wxWindow, GetWindowStyleFlag)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetWindowStyleFlag\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetWindowStyleFlag call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetWindowStyleFlag())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetWindowStyleFlag());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetWindowStyleFlag\n");
	}
}
/* }}} */

/* {{{ proto wxWindowVariant wxWindow::GetWindowVariant()
   Returns the value previously passed to SetWindowVariant(). */
PHP_METHOD(php_wxWindow, GetWindowVariant)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetWindowVariant\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetWindowVariant call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetWindowVariant())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetWindowVariant());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetWindowVariant\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::HandleAsNavigationKey(wxKeyEvent event)
   This function will generate the appropriate call to Navigate() if the key event is one normally used for keyboard navigation and return true in this case. */
PHP_METHOD(php_wxWindow, HandleAsNavigationKey)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::HandleAsNavigationKey\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::HandleAsNavigationKey call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* event0 = 0;
	wxKeyEvent* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&event0, php_wxKeyEvent_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &event0, php_wxKeyEvent_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(event0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxKeyEvent*) zend_object_store_get_object(event0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxKeyEvent*) zend_object_store_get_object(event0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxKeyEvent*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'event' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(event0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'event' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::HandleAsNavigationKey(*(wxKeyEvent*) object_pointer0_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->HandleAsNavigationKey(*(wxKeyEvent*) object_pointer0_0));

				references->AddReference(event0, "wxWindow::HandleAsNavigationKey at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::HandleAsNavigationKey\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::HandleWindowEvent(wxEvent &event)
   Shorthand for: */
PHP_METHOD(php_wxWindow, HandleWindowEvent)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::HandleWindowEvent\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::HandleWindowEvent call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* event0 = 0;
	wxEvent* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'o' (&event0)\n");
		#endif

		char parse_parameters_string[] = "o";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &event0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(event0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxEvent*) zend_object_store_get_object(event0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxEvent*) zend_object_store_get_object(event0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxEvent*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXEVENT_TYPE && argument_type != PHP_WXMENUEVENT_TYPE && argument_type != PHP_WXKEYEVENT_TYPE && argument_type != PHP_WXCOMMANDEVENT_TYPE && argument_type != PHP_WXNOTIFYEVENT_TYPE && argument_type != PHP_WXTREEEVENT_TYPE && argument_type != PHP_WXBOOKCTRLEVENT_TYPE && argument_type != PHP_WXAUINOTEBOOKEVENT_TYPE && argument_type != PHP_WXAUITOOLBAREVENT_TYPE && argument_type != PHP_WXLISTEVENT_TYPE && argument_type != PHP_WXSPINEVENT_TYPE && argument_type != PHP_WXSPLITTEREVENT_TYPE && argument_type != PHP_WXSPINDOUBLEEVENT_TYPE && argument_type != PHP_WXGRIDSIZEEVENT_TYPE && argument_type != PHP_WXWIZARDEVENT_TYPE && argument_type != PHP_WXGRIDEVENT_TYPE && argument_type != PHP_WXGRIDRANGESELECTEVENT_TYPE && argument_type != PHP_WXDATAVIEWEVENT_TYPE && argument_type != PHP_WXHEADERCTRLEVENT_TYPE && argument_type != PHP_WXRIBBONBAREVENT_TYPE && argument_type != PHP_WXWEBVIEWEVENT_TYPE && argument_type != PHP_WXMEDIAEVENT_TYPE && argument_type != PHP_WXSTYLEDTEXTEVENT_TYPE && argument_type != PHP_WXCHILDFOCUSEVENT_TYPE && argument_type != PHP_WXHTMLCELLEVENT_TYPE && argument_type != PHP_WXHTMLLINKEVENT_TYPE && argument_type != PHP_WXHYPERLINKEVENT_TYPE && argument_type != PHP_WXCOLOURPICKEREVENT_TYPE && argument_type != PHP_WXFONTPICKEREVENT_TYPE && argument_type != PHP_WXSCROLLEVENT_TYPE && argument_type != PHP_WXWINDOWMODALDIALOGEVENT_TYPE && argument_type != PHP_WXDATEEVENT_TYPE && argument_type != PHP_WXCALENDAREVENT_TYPE && argument_type != PHP_WXWINDOWCREATEEVENT_TYPE && argument_type != PHP_WXWINDOWDESTROYEVENT_TYPE && argument_type != PHP_WXUPDATEUIEVENT_TYPE && argument_type != PHP_WXHELPEVENT_TYPE && argument_type != PHP_WXGRIDEDITORCREATEDEVENT_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANEEVENT_TYPE && argument_type != PHP_WXCLIPBOARDTEXTEVENT_TYPE && argument_type != PHP_WXFILECTRLEVENT_TYPE && argument_type != PHP_WXSASHEVENT_TYPE && argument_type != PHP_WXFILEDIRPICKEREVENT_TYPE && argument_type != PHP_WXCONTEXTMENUEVENT_TYPE && argument_type != PHP_WXRIBBONBUTTONBAREVENT_TYPE && argument_type != PHP_WXRIBBONGALLERYEVENT_TYPE && argument_type != PHP_WXCLOSEEVENT_TYPE && argument_type != PHP_WXACTIVATEEVENT_TYPE && argument_type != PHP_WXAUIMANAGEREVENT_TYPE && argument_type != PHP_WXSIZEEVENT_TYPE && argument_type != PHP_WXMOUSEEVENT_TYPE && argument_type != PHP_WXMOVEEVENT_TYPE && argument_type != PHP_WXTIMEREVENT_TYPE && argument_type != PHP_WXTHREADEVENT_TYPE && argument_type != PHP_WXSCROLLWINEVENT_TYPE && argument_type != PHP_WXSYSCOLOURCHANGEDEVENT_TYPE && argument_type != PHP_WXPROCESSEVENT_TYPE && argument_type != PHP_WXERASEEVENT_TYPE && argument_type != PHP_WXSETCURSOREVENT_TYPE && argument_type != PHP_WXIDLEEVENT_TYPE && argument_type != PHP_WXPAINTEVENT_TYPE && argument_type != PHP_WXPALETTECHANGEDEVENT_TYPE && argument_type != PHP_WXINITDIALOGEVENT_TYPE && argument_type != PHP_WXMAXIMIZEEVENT_TYPE && argument_type != PHP_WXNAVIGATIONKEYEVENT_TYPE && argument_type != PHP_WXFOCUSEVENT_TYPE && argument_type != PHP_WXFILESYSTEMWATCHEREVENT_TYPE && argument_type != PHP_WXDISPLAYCHANGEDEVENT_TYPE && argument_type != PHP_WXCALCULATELAYOUTEVENT_TYPE && argument_type != PHP_WXQUERYLAYOUTINFOEVENT_TYPE && argument_type != PHP_WXTASKBARICONEVENT_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'event' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(event0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'event' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::HandleWindowEvent(*(wxEvent*) object_pointer0_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->HandleWindowEvent(*(wxEvent*) object_pointer0_0));

				references->AddReference(event0, "wxWindow::HandleWindowEvent at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::HandleWindowEvent\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::HasCapture()
   Returns true if this window has the current mouse capture. */
PHP_METHOD(php_wxWindow, HasCapture)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::HasCapture\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::HasCapture call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::HasCapture())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->HasCapture());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::HasCapture\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::HasExtraStyle(int exFlag)
   Returns true if the window has the given exFlag bit set in its extra styles. */
PHP_METHOD(php_wxWindow, HasExtraStyle)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::HasExtraStyle\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::HasExtraStyle call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long exFlag0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&exFlag0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &exFlag0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::HasExtraStyle((int) exFlag0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->HasExtraStyle((int) exFlag0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::HasExtraStyle\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::HasFlag(int flag)
   Returns true if the window has the given flag bit set. */
PHP_METHOD(php_wxWindow, HasFlag)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::HasFlag\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::HasFlag call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long flag0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&flag0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &flag0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::HasFlag((int) flag0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->HasFlag((int) flag0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::HasFlag\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::HasFocus()
   Returns true if the window (or in case of composite controls, its main child window) has focus. */
PHP_METHOD(php_wxWindow, HasFocus)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::HasFocus\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::HasFocus call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::HasFocus())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->HasFocus());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::HasFocus\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::HasMultiplePages()
   This method should be overridden to return true if this window has multiple pages. */
PHP_METHOD(php_wxWindow, HasMultiplePages)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::HasMultiplePages\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::HasMultiplePages call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::HasMultiplePages())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->HasMultiplePages());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::HasMultiplePages\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::HasScrollbar(int orient)
   Returns true if this window currently has a scroll bar for this orientation. */
PHP_METHOD(php_wxWindow, HasScrollbar)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::HasScrollbar\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::HasScrollbar call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long orient0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&orient0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &orient0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::HasScrollbar((int) orient0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->HasScrollbar((int) orient0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::HasScrollbar\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::HasTransparentBackground()
   Returns true if this window background is transparent (as, for example, for wxStaticText) and should show the parent window background. */
PHP_METHOD(php_wxWindow, HasTransparentBackground)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::HasTransparentBackground\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::HasTransparentBackground call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::HasTransparentBackground())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->HasTransparentBackground());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::HasTransparentBackground\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::Hide()
   Equivalent to calling wxWindow::Show(false). */
PHP_METHOD(php_wxWindow, Hide)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Hide\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Hide call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::Hide())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->Hide());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Hide\n");
	}
}
/* }}} */

/* {{{ proto wxHitTest wxWindow::HitTest(int x, int y)
   Get the window border style from the given flags: this is different from simply doing flags & wxBORDER_MASK because it uses GetDefaultBorder() to translate wxBORDER_DEFAULT to something reasonable. */
PHP_METHOD(php_wxWindow, HitTest)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::HitTest\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::HitTest call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long x0;
	long y0;
	bool overload0_called = false;
	//Parameters for overload 1
	zval* pt1 = 0;
	wxPoint* object_pointer1_0 = 0;
	bool overload1_called = false;
	//Parameters for overload 2
	zval* point2 = 0;
	wxPoint* object_pointer2_0 = 0;
	long flags2;
	zval* flags2_ref;
	bool overload2_called = false;
	//Parameters for overload 3
	long x3;
	long y3;
	bool overload3_called = false;
	//Parameters for overload 4
	zval* point4 = 0;
	wxPoint* object_pointer4_0 = 0;
	bool overload4_called = false;
	//Parameters for overload 5
	zval* pt5 = 0;
	wxPoint* object_pointer5_0 = 0;
	long* flags5;
	zval* flags5_ref;
	bool overload5_called = false;
	//Parameters for overload 6
	zval* pos6 = 0;
	wxPoint* object_pointer6_0 = 0;
	time_t date6;
	zval* date6_ref;
	long* wd6;
	zval* wd6_ref;
	bool overload6_called = false;
	//Parameters for overload 7
	zval* point7 = 0;
	wxPoint* object_pointer7_0 = 0;
	zval* item7 = 0;
	wxDataViewItem* object_pointer7_1 = 0;
	zval* col7 = 0;
	wxDataViewColumn* object_pointer7_2 = 0;
	bool overload7_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'll' (&x0, &y0)\n");
		#endif

		char parse_parameters_string[] = "ll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &x0, &y0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&pt1, php_wxPoint_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pt1, php_wxPoint_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(pt1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pt1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pt1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxPoint*) argument_native_object;
					if (!object_pointer1_0 )
					{
						goto overload2;
					}
				}
				else if(Z_TYPE_P(pt1) != IS_NULL)
				{
					goto overload2;
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

	//Overload 2
	overload2:
	if(!already_called && arguments_received == 2 && (current_object_type == PHP_WXTREECTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'Ol' (&point2, php_wxPoint_entry, &flags2)\n");
		#endif

		char parse_parameters_string[] = "Ol";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &point2, php_wxPoint_entry, &flags2 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(point2) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(point2 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(point2 TSRMLS_CC))->native_object;
					object_pointer2_0 = (wxPoint*) argument_native_object;
					if (!object_pointer2_0 )
					{
						goto overload3;
					}
				}
				else if(Z_TYPE_P(point2) != IS_NULL)
				{
					goto overload3;
				}
			}

			overload2_called = true;
			already_called = true;

			char parse_references_string[] = "zz";
			zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_references_string, &dummy, &flags2_ref );
		}
	}

	//Overload 3
	overload3:
	if(!already_called && arguments_received == 2 && (current_object_type == PHP_WXLISTBOX_TYPE || current_object_type == PHP_WXCHECKLISTBOX_TYPE || current_object_type == PHP_WXREARRANGELIST_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'll' (&x3, &y3)\n");
		#endif

		char parse_parameters_string[] = "ll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &x3, &y3 ) == SUCCESS)
		{
			overload3_called = true;
			already_called = true;
		}
	}

	//Overload 4
	overload4:
	if(!already_called && arguments_received == 1 && (current_object_type == PHP_WXLISTBOX_TYPE || current_object_type == PHP_WXCHECKLISTBOX_TYPE || current_object_type == PHP_WXREARRANGELIST_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&point4, php_wxPoint_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &point4, php_wxPoint_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(point4) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(point4 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(point4 TSRMLS_CC))->native_object;
					object_pointer4_0 = (wxPoint*) argument_native_object;
					if (!object_pointer4_0 )
					{
						goto overload5;
					}
				}
				else if(Z_TYPE_P(point4) != IS_NULL)
				{
					goto overload5;
				}
			}

			overload4_called = true;
			already_called = true;
		}
	}

	//Overload 5
	overload5:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2 && (current_object_type == PHP_WXBOOKCTRLBASE_TYPE || current_object_type == PHP_WXAUINOTEBOOK_TYPE || current_object_type == PHP_WXLISTBOOK_TYPE || current_object_type == PHP_WXCHOICEBOOK_TYPE || current_object_type == PHP_WXNOTEBOOK_TYPE || current_object_type == PHP_WXTREEBOOK_TYPE || current_object_type == PHP_WXTOOLBOOK_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O|l' (&pt5, php_wxPoint_entry, flags5)\n");
		#endif

		char parse_parameters_string[] = "O|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pt5, php_wxPoint_entry, flags5 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(pt5) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pt5 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pt5 TSRMLS_CC))->native_object;
					object_pointer5_0 = (wxPoint*) argument_native_object;
					if (!object_pointer5_0 )
					{
						goto overload6;
					}
				}
				else if(Z_TYPE_P(pt5) != IS_NULL)
				{
					goto overload6;
				}
			}

			overload5_called = true;
			already_called = true;

			char parse_references_string[] = "z|z";
			zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_references_string, &dummy, &flags5_ref );
		}
	}

	//Overload 6
	overload6:
	if(!already_called && arguments_received >= 1  && arguments_received <= 3 && (current_object_type == PHP_WXCALENDARCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O|ll' (&pos6, php_wxPoint_entry, &date6, wd6)\n");
		#endif

		char parse_parameters_string[] = "O|ll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pos6, php_wxPoint_entry, &date6, wd6 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(pos6) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos6 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos6 TSRMLS_CC))->native_object;
					object_pointer6_0 = (wxPoint*) argument_native_object;
					if (!object_pointer6_0 )
					{
						goto overload7;
					}
				}
				else if(Z_TYPE_P(pos6) != IS_NULL)
				{
					goto overload7;
				}
			}

			overload6_called = true;
			already_called = true;

			char parse_references_string[] = "z|zz";
			zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_references_string, &dummy, &date6_ref, &wd6_ref );
		}
	}

	//Overload 7
	overload7:
	if(!already_called && arguments_received == 3 && (current_object_type == PHP_WXDATAVIEWCTRL_TYPE || current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE || current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'OOz' (&point7, php_wxPoint_entry, &item7, php_wxDataViewItem_entry, &col7)\n");
		#endif

		char parse_parameters_string[] = "OOz";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &point7, php_wxPoint_entry, &item7, php_wxDataViewItem_entry, &col7 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(point7) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(point7 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(point7 TSRMLS_CC))->native_object;
					object_pointer7_0 = (wxPoint*) argument_native_object;
					if (!object_pointer7_0 )
					{
						zend_error(E_ERROR, "Parameter 'point' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(point7) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'point' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 2){
				if(Z_TYPE_P(item7) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxDataViewItem*) zend_object_store_get_object(item7 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxDataViewItem*) zend_object_store_get_object(item7 TSRMLS_CC))->native_object;
					object_pointer7_1 = (wxDataViewItem*) argument_native_object;
					if (!object_pointer7_1 )
					{
						zend_error(E_ERROR, "Parameter 'item' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(item7) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'item' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(col7) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxDataViewColumn*) zend_object_store_get_object(col7 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxDataViewColumn*) zend_object_store_get_object(col7 TSRMLS_CC))->native_object;
					object_pointer7_2 = (wxDataViewColumn*) argument_native_object;
					if (!object_pointer7_2 || (argument_type != PHP_WXDATAVIEWCOLUMN_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'col' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(col7) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'col' not null, could not be retreived correctly.");
				}
			}

			overload7_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::HitTest((wxCoord) x0, (wxCoord) y0))\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->HitTest((wxCoord) x0, (wxCoord) y0));


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::HitTest(*(wxPoint*) object_pointer1_0))\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->HitTest(*(wxPoint*) object_pointer1_0));

				references->AddReference(pt1, "wxWindow::HitTest at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload2_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxTreeCtrl::HitTest(*(wxPoint*) object_pointer2_0, (int&) flags2) to return new object\n\n");
				#endif

				wxTreeItemId value_to_return2;
				value_to_return2 = ((wxTreeCtrl_php*)native_object)->HitTest(*(wxPoint*) object_pointer2_0, (int&) flags2);
				void* ptr = safe_emalloc(1, sizeof(wxTreeItemId_php), 0);
				memcpy(ptr, (void*) &value_to_return2, sizeof(wxTreeItemId));
				object_init_ex(return_value, php_wxTreeItemId_entry);
				((wxTreeItemId_php*)ptr)->phpObj = return_value;
				zo_wxTreeItemId* zo2 = (zo_wxTreeItemId*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo2->native_object = (wxTreeItemId_php*) ptr;

				references->AddReference(point2, "wxWindow::HitTest at call with 2 argument(s)");
				ZVAL_LONG(flags2_ref, flags2);

				return;
				break;
			}
		}
	}

	if(overload3_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxListBox::HitTest((int) x3, (int) y3))\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxListBox_php*)native_object)->HitTest((int) x3, (int) y3));


				return;
				break;
			}
		}
	}

	if(overload4_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxListBox::HitTest(*(wxPoint*) object_pointer4_0))\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxListBox_php*)native_object)->HitTest(*(wxPoint*) object_pointer4_0));

				references->AddReference(point4, "wxWindow::HitTest at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload5_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxBookCtrlBase::HitTest(*(wxPoint*) object_pointer5_0))\n\n");
				#endif

				if(current_object_type == PHP_WXAUINOTEBOOK_TYPE)
				{
					ZVAL_LONG(return_value, ((wxAuiNotebook_php*)native_object)->HitTest(*(wxPoint*) object_pointer5_0));
				}
				else if(current_object_type == PHP_WXLISTBOOK_TYPE)
				{
					ZVAL_LONG(return_value, ((wxListbook_php*)native_object)->HitTest(*(wxPoint*) object_pointer5_0));
				}
				else if(current_object_type == PHP_WXCHOICEBOOK_TYPE)
				{
					ZVAL_LONG(return_value, ((wxChoicebook_php*)native_object)->HitTest(*(wxPoint*) object_pointer5_0));
				}
				else if(current_object_type == PHP_WXNOTEBOOK_TYPE)
				{
					ZVAL_LONG(return_value, ((wxNotebook_php*)native_object)->HitTest(*(wxPoint*) object_pointer5_0));
				}
				else if(current_object_type == PHP_WXTREEBOOK_TYPE)
				{
					ZVAL_LONG(return_value, ((wxTreebook_php*)native_object)->HitTest(*(wxPoint*) object_pointer5_0));
				}
				else if(current_object_type == PHP_WXTOOLBOOK_TYPE)
				{
					ZVAL_LONG(return_value, ((wxToolbook_php*)native_object)->HitTest(*(wxPoint*) object_pointer5_0));
				}
				else if(current_object_type == PHP_WXBOOKCTRLBASE_TYPE)
				{
					ZVAL_LONG(return_value, ((wxBookCtrlBase_php*)native_object)->HitTest(*(wxPoint*) object_pointer5_0));
				}

				references->AddReference(pt5, "wxWindow::HitTest at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxBookCtrlBase::HitTest(*(wxPoint*) object_pointer5_0, (long*) flags5))\n\n");
				#endif

				if(current_object_type == PHP_WXAUINOTEBOOK_TYPE)
				{
					ZVAL_LONG(return_value, ((wxAuiNotebook_php*)native_object)->HitTest(*(wxPoint*) object_pointer5_0, (long*) flags5));
				}
				else if(current_object_type == PHP_WXLISTBOOK_TYPE)
				{
					ZVAL_LONG(return_value, ((wxListbook_php*)native_object)->HitTest(*(wxPoint*) object_pointer5_0, (long*) flags5));
				}
				else if(current_object_type == PHP_WXCHOICEBOOK_TYPE)
				{
					ZVAL_LONG(return_value, ((wxChoicebook_php*)native_object)->HitTest(*(wxPoint*) object_pointer5_0, (long*) flags5));
				}
				else if(current_object_type == PHP_WXNOTEBOOK_TYPE)
				{
					ZVAL_LONG(return_value, ((wxNotebook_php*)native_object)->HitTest(*(wxPoint*) object_pointer5_0, (long*) flags5));
				}
				else if(current_object_type == PHP_WXTREEBOOK_TYPE)
				{
					ZVAL_LONG(return_value, ((wxTreebook_php*)native_object)->HitTest(*(wxPoint*) object_pointer5_0, (long*) flags5));
				}
				else if(current_object_type == PHP_WXTOOLBOOK_TYPE)
				{
					ZVAL_LONG(return_value, ((wxToolbook_php*)native_object)->HitTest(*(wxPoint*) object_pointer5_0, (long*) flags5));
				}
				else if(current_object_type == PHP_WXBOOKCTRLBASE_TYPE)
				{
					ZVAL_LONG(return_value, ((wxBookCtrlBase_php*)native_object)->HitTest(*(wxPoint*) object_pointer5_0, (long*) flags5));
				}

				references->AddReference(pt5, "wxWindow::HitTest at call with 2 argument(s)");
				size_t elements_returned5_1 = sizeof(flags5)/sizeof(*flags5);
				array_init(flags5_ref);
				for(size_t i=0; i<elements_returned5_1; i++)
				{
					add_next_index_long(flags5_ref, flags5[i]);
				}

				return;
				break;
			}
		}
	}

	if(overload6_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxCalendarCtrl::HitTest(*(wxPoint*) object_pointer6_0))\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxCalendarCtrl_php*)native_object)->HitTest(*(wxPoint*) object_pointer6_0));

				references->AddReference(pos6, "wxWindow::HitTest at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				wxDateTime date_time6_1 = wxDateTime(date6);
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxCalendarCtrl::HitTest(*(wxPoint*) object_pointer6_0, &date_time6_1))\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxCalendarCtrl_php*)native_object)->HitTest(*(wxPoint*) object_pointer6_0, &date_time6_1));

				references->AddReference(pos6, "wxWindow::HitTest at call with 2 argument(s)");
				ZVAL_LONG(date6_ref, date_time6_1.GetTicks());

				return;
				break;
			}
			case 3:
			{
				wxDateTime date_time6_1 = wxDateTime(date6);
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxCalendarCtrl::HitTest(*(wxPoint*) object_pointer6_0, &date_time6_1, (wxDateTime::WeekDay*) wd6))\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxCalendarCtrl_php*)native_object)->HitTest(*(wxPoint*) object_pointer6_0, &date_time6_1, (wxDateTime::WeekDay*) wd6));

				references->AddReference(pos6, "wxWindow::HitTest at call with 3 argument(s)");
				ZVAL_LONG(date6_ref, date_time6_1.GetTicks());
				size_t elements_returned6_2 = sizeof(wd6)/sizeof(*wd6);
				array_init(wd6_ref);
				for(size_t i=0; i<elements_returned6_2; i++)
				{
					add_next_index_long(wd6_ref, wd6[i]);
				}

				return;
				break;
			}
		}
	}

	if(overload7_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxDataViewCtrl::HitTest(*(wxPoint*) object_pointer7_0, *(wxDataViewItem*) object_pointer7_1, (wxDataViewColumn*&) object_pointer7_2)\n\n");
				#endif

				((wxDataViewCtrl_php*)native_object)->HitTest(*(wxPoint*) object_pointer7_0, *(wxDataViewItem*) object_pointer7_1, (wxDataViewColumn*&) object_pointer7_2);

				references->AddReference(point7, "wxWindow::HitTest at call with 3 argument(s)");
				references->AddReference(item7, "wxWindow::HitTest at call with 3 argument(s)");
				references->AddReference(col7, "wxWindow::HitTest at call with 3 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::HitTest\n");
	}
}
/* }}} */

/* {{{ proto wxLayoutDirection wxWindow::GetLayoutDirection()
   Returns the layout direction for this window, Note that wxLayout_Default is returned if layout direction is not supported. */
PHP_METHOD(php_wxWindow, GetLayoutDirection)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::GetLayoutDirection\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::GetLayoutDirection call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_LONG(wxWindow::GetLayoutDirection())\n\n");
				#endif

				ZVAL_LONG(return_value, ((wxWindow_php*)native_object)->GetLayoutDirection());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::GetLayoutDirection\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::InitDialog()
   Sends an wxEVT_INIT_DIALOG event, whose handler usually transfers data to the dialog via validators. */
PHP_METHOD(php_wxWindow, InitDialog)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::InitDialog\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::InitDialog call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::InitDialog()\n\n");
				#endif

				((wxWindow_php*)native_object)->InitDialog();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::InitDialog\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::InheritAttributes()
   This function is (or should be, in case of custom controls) called during window creation to intelligently set up the window visual attributes, that is the font and the foreground and background colours. */
PHP_METHOD(php_wxWindow, InheritAttributes)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::InheritAttributes\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::InheritAttributes call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::InheritAttributes()\n\n");
				#endif

				((wxWindow_php*)native_object)->InheritAttributes();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::InheritAttributes\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::InformFirstDirection(int direction, int size, int availableOtherDir)
   wxSizer and friends use this to give a chance to a component to recalc its min size once one of the final size components is known. */
PHP_METHOD(php_wxWindow, InformFirstDirection)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::InformFirstDirection\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::InformFirstDirection call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long direction0;
	long size0;
	long availableOtherDir0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 3)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'lll' (&direction0, &size0, &availableOtherDir0)\n");
		#endif

		char parse_parameters_string[] = "lll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &direction0, &size0, &availableOtherDir0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::InformFirstDirection((int) direction0, (int) size0, (int) availableOtherDir0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->InformFirstDirection((int) direction0, (int) size0, (int) availableOtherDir0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::InformFirstDirection\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::InvalidateBestSize()
   Resets the cached best size value so it will be recalculated the next time it is needed. */
PHP_METHOD(php_wxWindow, InvalidateBestSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::InvalidateBestSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::InvalidateBestSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::InvalidateBestSize()\n\n");
				#endif

				((wxWindow_php*)native_object)->InvalidateBestSize();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::InvalidateBestSize\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::IsBeingDeleted()
   Returns true if this window is in process of being destroyed. */
PHP_METHOD(php_wxWindow, IsBeingDeleted)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::IsBeingDeleted\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::IsBeingDeleted call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::IsBeingDeleted())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->IsBeingDeleted());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::IsBeingDeleted\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::IsDoubleBuffered()
   Returns true if the window contents is double-buffered by the system, i.e. if any drawing done on the window is really done on a temporary backing surface and transferred to the screen all at once later. */
PHP_METHOD(php_wxWindow, IsDoubleBuffered)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::IsDoubleBuffered\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::IsDoubleBuffered call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::IsDoubleBuffered())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->IsDoubleBuffered());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::IsDoubleBuffered\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::IsEnabled()
   Returns true if the window is enabled, i.e. if it accepts user input, false otherwise. */
PHP_METHOD(php_wxWindow, IsEnabled)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::IsEnabled\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::IsEnabled call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
	//Parameters for overload 1
	long id1;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 1 && (current_object_type == PHP_WXMENUBAR_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&id1)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &id1 ) == SUCCESS)
		{
			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::IsEnabled())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->IsEnabled());


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxMenuBar::IsEnabled((int) id1))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxMenuBar_php*)native_object)->IsEnabled((int) id1));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::IsEnabled\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::IsExposed(int x, int y)
   Returns true if the given point or rectangle area has been exposed since the last repaint. */
PHP_METHOD(php_wxWindow, IsExposed)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::IsExposed\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::IsExposed call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long x0;
	long y0;
	bool overload0_called = false;
	//Parameters for overload 1
	zval* pt1 = 0;
	wxPoint* object_pointer1_0 = 0;
	bool overload1_called = false;
	//Parameters for overload 2
	long x2;
	long y2;
	long w2;
	long h2;
	bool overload2_called = false;
	//Parameters for overload 3
	zval* rect3 = 0;
	wxRect* object_pointer3_0 = 0;
	bool overload3_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'll' (&x0, &y0)\n");
		#endif

		char parse_parameters_string[] = "ll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &x0, &y0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&pt1, php_wxPoint_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pt1, php_wxPoint_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(pt1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pt1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pt1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxPoint*) argument_native_object;
					if (!object_pointer1_0 )
					{
						goto overload2;
					}
				}
				else if(Z_TYPE_P(pt1) != IS_NULL)
				{
					goto overload2;
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

	//Overload 2
	overload2:
	if(!already_called && arguments_received == 4)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'llll' (&x2, &y2, &w2, &h2)\n");
		#endif

		char parse_parameters_string[] = "llll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &x2, &y2, &w2, &h2 ) == SUCCESS)
		{
			overload2_called = true;
			already_called = true;
		}
	}

	//Overload 3
	overload3:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&rect3, php_wxRect_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &rect3, php_wxRect_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(rect3) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxRect*) zend_object_store_get_object(rect3 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxRect*) zend_object_store_get_object(rect3 TSRMLS_CC))->native_object;
					object_pointer3_0 = (wxRect*) argument_native_object;
					if (!object_pointer3_0 )
					{
						zend_error(E_ERROR, "Parameter 'rect' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(rect3) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'rect' not null, could not be retreived correctly.");
				}
			}

			overload3_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::IsExposed((int) x0, (int) y0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->IsExposed((int) x0, (int) y0));


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::IsExposed(*(wxPoint*) object_pointer1_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->IsExposed(*(wxPoint*) object_pointer1_0));

				references->AddReference(pt1, "wxWindow::IsExposed at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload2_called)
	{
		switch(arguments_received)
		{
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::IsExposed((int) x2, (int) y2, (int) w2, (int) h2))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->IsExposed((int) x2, (int) y2, (int) w2, (int) h2));


				return;
				break;
			}
		}
	}

	if(overload3_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::IsExposed(*(wxRect*) object_pointer3_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->IsExposed(*(wxRect*) object_pointer3_0));

				references->AddReference(rect3, "wxWindow::IsExposed at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::IsExposed\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::IsFrozen()
   Returns true if the window is currently frozen by a call to Freeze(). */
PHP_METHOD(php_wxWindow, IsFrozen)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::IsFrozen\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::IsFrozen call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::IsFrozen())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->IsFrozen());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::IsFrozen\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::IsRetained()
   Returns true if the window is retained, false otherwise. */
PHP_METHOD(php_wxWindow, IsRetained)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::IsRetained\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::IsRetained call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::IsRetained())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->IsRetained());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::IsRetained\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::IsScrollbarAlwaysShown(int orient)
   Return whether a scrollbar is always shown. */
PHP_METHOD(php_wxWindow, IsScrollbarAlwaysShown)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::IsScrollbarAlwaysShown\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::IsScrollbarAlwaysShown call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long orient0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&orient0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &orient0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::IsScrollbarAlwaysShown((int) orient0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->IsScrollbarAlwaysShown((int) orient0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::IsScrollbarAlwaysShown\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::IsShown()
   Returns true if the window is shown, false if it has been hidden. */
PHP_METHOD(php_wxWindow, IsShown)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::IsShown\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::IsShown call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::IsShown())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->IsShown());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::IsShown\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::IsShownOnScreen()
   Returns true if the window is physically visible on the screen, i.e. it is shown and all its parents up to the toplevel window are shown as well. */
PHP_METHOD(php_wxWindow, IsShownOnScreen)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::IsShownOnScreen\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::IsShownOnScreen call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::IsShownOnScreen())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->IsShownOnScreen());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::IsShownOnScreen\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::IsThisEnabled()
   Returns true if this window is intrinsically enabled, false otherwise, i.e. if Enable() Enable(false) had been called. */
PHP_METHOD(php_wxWindow, IsThisEnabled)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::IsThisEnabled\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::IsThisEnabled call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::IsThisEnabled())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->IsThisEnabled());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::IsThisEnabled\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::IsTopLevel()
   Returns true if the given window is a top-level one. */
PHP_METHOD(php_wxWindow, IsTopLevel)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::IsTopLevel\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::IsTopLevel call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::IsTopLevel())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->IsTopLevel());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::IsTopLevel\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::Layout()
   Invokes the constraint-based layout algorithm or the sizer-based algorithm for this window. */
PHP_METHOD(php_wxWindow, Layout)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Layout\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Layout call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::Layout())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->Layout());


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Layout\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::LineDown()
   Same as ScrollLines (1). */
PHP_METHOD(php_wxWindow, LineDown)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::LineDown\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::LineDown call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
	//Parameters for overload 1
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 0 && (current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload1_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::LineDown())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->LineDown());


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxStyledTextCtrl::LineDown()\n\n");
				#endif

				((wxStyledTextCtrl_php*)native_object)->LineDown();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::LineDown\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::LineUp()
   Same as ScrollLines (-1). */
PHP_METHOD(php_wxWindow, LineUp)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::LineUp\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::LineUp call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
	//Parameters for overload 1
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 0 && (current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload1_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::LineUp())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->LineUp());


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxStyledTextCtrl::LineUp()\n\n");
				#endif

				((wxStyledTextCtrl_php*)native_object)->LineUp();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::LineUp\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::Lower()
   Lowers the window to the bottom of the window hierarchy (Z-order). */
PHP_METHOD(php_wxWindow, Lower)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Lower\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Lower call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::Lower()\n\n");
				#endif

				((wxWindow_php*)native_object)->Lower();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Lower\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::Move(int x, int y, int flags)
   Moves the window to the given position. */
PHP_METHOD(php_wxWindow, Move)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Move\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Move call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long x0;
	long y0;
	long flags0;
	bool overload0_called = false;
	//Parameters for overload 1
	zval* pt1 = 0;
	wxPoint* object_pointer1_0 = 0;
	long flags1;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 2  && arguments_received <= 3)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'll|l' (&x0, &y0, &flags0)\n");
		#endif

		char parse_parameters_string[] = "ll|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &x0, &y0, &flags0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O|l' (&pt1, php_wxPoint_entry, &flags1)\n");
		#endif

		char parse_parameters_string[] = "O|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pt1, php_wxPoint_entry, &flags1 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(pt1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pt1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pt1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxPoint*) argument_native_object;
					if (!object_pointer1_0 )
					{
						zend_error(E_ERROR, "Parameter 'pt' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(pt1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'pt' not null, could not be retreived correctly.");
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::Move((int) x0, (int) y0)\n\n");
				#endif

				((wxWindow_php*)native_object)->Move((int) x0, (int) y0);


				return;
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::Move((int) x0, (int) y0, (int) flags0)\n\n");
				#endif

				((wxWindow_php*)native_object)->Move((int) x0, (int) y0, (int) flags0);


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::Move(*(wxPoint*) object_pointer1_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->Move(*(wxPoint*) object_pointer1_0);

				references->AddReference(pt1, "wxWindow::Move at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::Move(*(wxPoint*) object_pointer1_0, (int) flags1)\n\n");
				#endif

				((wxWindow_php*)native_object)->Move(*(wxPoint*) object_pointer1_0, (int) flags1);

				references->AddReference(pt1, "wxWindow::Move at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Move\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::MoveAfterInTabOrder(wxWindow &win)
   Moves this window in the tab navigation order after the specified win. */
PHP_METHOD(php_wxWindow, MoveAfterInTabOrder)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::MoveAfterInTabOrder\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::MoveAfterInTabOrder call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* win0 = 0;
	wxWindow* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&win0)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &win0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(win0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(win0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(win0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'win' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(win0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'win' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::MoveAfterInTabOrder((wxWindow*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->MoveAfterInTabOrder((wxWindow*) object_pointer0_0);

				references->AddReference(win0, "wxWindow::MoveAfterInTabOrder at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::MoveAfterInTabOrder\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::MoveBeforeInTabOrder(wxWindow &win)
   Same as MoveAfterInTabOrder() except that it inserts this window just before win instead of putting it right after it. */
PHP_METHOD(php_wxWindow, MoveBeforeInTabOrder)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::MoveBeforeInTabOrder\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::MoveBeforeInTabOrder call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* win0 = 0;
	wxWindow* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&win0)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &win0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(win0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(win0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(win0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'win' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(win0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'win' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::MoveBeforeInTabOrder((wxWindow*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->MoveBeforeInTabOrder((wxWindow*) object_pointer0_0);

				references->AddReference(win0, "wxWindow::MoveBeforeInTabOrder at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::MoveBeforeInTabOrder\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::Navigate(int flags)
   Performs a keyboard navigation action starting from this window. */
PHP_METHOD(php_wxWindow, Navigate)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Navigate\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Navigate call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long flags0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|l' (&flags0)\n");
		#endif

		char parse_parameters_string[] = "|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &flags0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::Navigate())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->Navigate());


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::Navigate((int) flags0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->Navigate((int) flags0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Navigate\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::NavigateIn(int flags)
   Performs a keyboard navigation action inside this window. */
PHP_METHOD(php_wxWindow, NavigateIn)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::NavigateIn\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::NavigateIn call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long flags0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|l' (&flags0)\n");
		#endif

		char parse_parameters_string[] = "|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &flags0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::NavigateIn())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->NavigateIn());


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::NavigateIn((int) flags0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->NavigateIn((int) flags0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::NavigateIn\n");
	}
}
/* }}} */

/* {{{ proto int wxWindow::NewControlId(int count)
   Create a new ID or range of IDs that are not currently in use. */
PHP_METHOD(php_wxWindow, NewControlId)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::NewControlId\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::NewControlId call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long count0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|l' (&count0)\n");
		#endif

		char parse_parameters_string[] = "|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &count0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Static ");
				php_printf("Executing RETURN_LONG(wxWindow::NewControlId())\n\n");
				#endif

				ZVAL_LONG(return_value, wxWindow::NewControlId());


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Static ");
				php_printf("Executing RETURN_LONG(wxWindow::NewControlId((int) count0))\n\n");
				#endif

				ZVAL_LONG(return_value, wxWindow::NewControlId((int) count0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::NewControlId\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::OnInternalIdle()
   This virtual function is normally only used internally, but sometimes an application may need it to implement functionality that should not be disabled by an application defining an OnIdle handler in a derived class. */
void wxWindow_php::OnInternalIdle()
{
	static zend_function* cached_function = NULL;
	static bool is_php_user_space_implemented = true;
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking virtual wxWindow::OnInternalIdle\n");
	php_printf("===========================================\n");
	#endif
	
	zval** params[1];
	zval* arguments[1];
	arguments[0] = NULL;
	params[0] = NULL;

	zval* return_value;
	MAKE_STD_ZVAL(return_value);
	zval function_name;
	ZVAL_STRING(&function_name, "OnInternalIdle", 0);
	char* temp_string;
	void* return_object;
	int function_called;
	
	//Parameters for conversion
		

	#ifdef USE_WXPHP_DEBUG
	php_printf("Trying to call user defined method\n");
	#endif
	
	if(is_php_user_space_implemented)
	{
		function_called = wxphp_call_method((zval**) &this->phpObj, NULL, &cached_function, "OnInternalIdle", 14, &return_value, 0, params TSRMLS_CC);
	}
	else
	{
		function_called = FAILURE;
	}
    
    	
	
	if(function_called == FAILURE)
	{
		is_php_user_space_implemented = false;
		
		#ifdef USE_WXPHP_DEBUG
		php_printf("Invocation of user defined method failed\n");
		#endif
		
	}
	else
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Returning userspace value.\n");
		#endif
		
		return;
	}
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling original method\n");
	php_printf("===========================================\n\n");
	#endif
	
	//Call original method
	wxWindow::OnInternalIdle();
}
/* }}} */

/* {{{ proto bool wxWindow::PageDown()
   Same as ScrollPages (1). */
PHP_METHOD(php_wxWindow, PageDown)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::PageDown\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::PageDown call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
	//Parameters for overload 1
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 0 && (current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload1_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::PageDown())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->PageDown());


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxStyledTextCtrl::PageDown()\n\n");
				#endif

				((wxStyledTextCtrl_php*)native_object)->PageDown();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::PageDown\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::PageUp()
   Same as ScrollPages (-1). */
PHP_METHOD(php_wxWindow, PageUp)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::PageUp\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::PageUp call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
	//Parameters for overload 1
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 0 && (current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload1_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::PageUp())\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->PageUp());


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxStyledTextCtrl::PageUp()\n\n");
				#endif

				((wxStyledTextCtrl_php*)native_object)->PageUp();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::PageUp\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::PopupMenu(wxMenu &menu, wxPoint pos)
   Pops up the given menu at the specified coordinates, relative to this window, and returns control when the user has dismissed the menu. */
PHP_METHOD(php_wxWindow, PopupMenu)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::PopupMenu\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::PopupMenu call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* menu0 = 0;
	wxMenu* object_pointer0_0 = 0;
	zval* pos0 = 0;
	wxPoint* object_pointer0_1 = 0;
	bool overload0_called = false;
	//Parameters for overload 1
	zval* menu1 = 0;
	wxMenu* object_pointer1_0 = 0;
	long x1;
	long y1;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|O' (&menu0, &pos0, php_wxPoint_entry)\n");
		#endif

		char parse_parameters_string[] = "z|O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &menu0, &pos0, php_wxPoint_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(menu0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxMenu*) zend_object_store_get_object(menu0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxMenu*) zend_object_store_get_object(menu0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxMenu*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXMENU_TYPE))
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(menu0) != IS_NULL)
				{
					goto overload1;
				}
			}

			if(arguments_received >= 2){
				if(Z_TYPE_P(pos0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pos0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pos0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxPoint*) argument_native_object;
					if (!object_pointer0_1 )
					{
						goto overload1;
					}
				}
				else if(Z_TYPE_P(pos0) != IS_NULL)
				{
					goto overload1;
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 3)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zll' (&menu1, &x1, &y1)\n");
		#endif

		char parse_parameters_string[] = "zll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &menu1, &x1, &y1 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(menu1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxMenu*) zend_object_store_get_object(menu1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxMenu*) zend_object_store_get_object(menu1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxMenu*) argument_native_object;
					if (!object_pointer1_0 || (argument_type != PHP_WXMENU_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'menu' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(menu1) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'menu' not null, could not be retreived correctly.");
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::PopupMenu((wxMenu*) object_pointer0_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->PopupMenu((wxMenu*) object_pointer0_0));

				references->AddReference(menu0, "wxWindow::PopupMenu at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::PopupMenu((wxMenu*) object_pointer0_0, *(wxPoint*) object_pointer0_1))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->PopupMenu((wxMenu*) object_pointer0_0, *(wxPoint*) object_pointer0_1));

				references->AddReference(menu0, "wxWindow::PopupMenu at call with 2 argument(s)");
				references->AddReference(pos0, "wxWindow::PopupMenu at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::PopupMenu((wxMenu*) object_pointer1_0, (int) x1, (int) y1))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->PopupMenu((wxMenu*) object_pointer1_0, (int) x1, (int) y1));

				references->AddReference(menu1, "wxWindow::PopupMenu at call with 3 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::PopupMenu\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::PostSizeEvent()
   Posts a size event to the window. */
PHP_METHOD(php_wxWindow, PostSizeEvent)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::PostSizeEvent\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::PostSizeEvent call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::PostSizeEvent()\n\n");
				#endif

				((wxWindow_php*)native_object)->PostSizeEvent();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::PostSizeEvent\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::PostSizeEventToParent()
   Posts a size event to the parent of this window. */
PHP_METHOD(php_wxWindow, PostSizeEventToParent)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::PostSizeEventToParent\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::PostSizeEventToParent call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::PostSizeEventToParent()\n\n");
				#endif

				((wxWindow_php*)native_object)->PostSizeEventToParent();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::PostSizeEventToParent\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::ProcessEvent(wxEvent &event)
   This function is public in wxEvtHandler but protected in wxWindow because for wxWindows you should always call ProcessEvent() on the pointer returned by GetEventHandler() and not on the wxWindow object itself. */
bool wxWindow_php::ProcessEvent(wxEvent& event)
{
	static zend_function* cached_function = NULL;
	static bool is_php_user_space_implemented = true;
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking virtual wxWindow::ProcessEvent\n");
	php_printf("===========================================\n");
	#endif
	
	zval** params[1];
	zval *arguments[1];
	
	//Initilize arguments array
	for(int i=0; i<1; i++)
	{
		ALLOC_INIT_ZVAL(arguments[i]);
	}

	zval* return_value;
	MAKE_STD_ZVAL(return_value);
	zval function_name;
	ZVAL_STRING(&function_name, "ProcessEvent", 0);
	char* temp_string;
	void* return_object;
	int function_called;
	
	//Parameters for conversion
	object_init_ex(arguments[0], php_wxEvent_entry);
	((zo_wxEvent*) zend_object_store_get_object(arguments[0] TSRMLS_CC))->native_object = (wxEvent_php*) &event;
		
	for(int i=0; i<1; i++)
	{
		params[i] = &arguments[i];
	}

	#ifdef USE_WXPHP_DEBUG
	php_printf("Trying to call user defined method\n");
	#endif
	
	if(is_php_user_space_implemented)
	{
		function_called = wxphp_call_method((zval**) &this->phpObj, NULL, &cached_function, "ProcessEvent", 12, &return_value, 1, params TSRMLS_CC);
	}
	else
	{
		function_called = FAILURE;
	}
    
    	
	//Delete already used parameters from memory
	for(int i=0; i<1; i++)
	{
		zval_ptr_dtor(&arguments[i]);
	}
	
	if(function_called == FAILURE)
	{
		is_php_user_space_implemented = false;
		
		#ifdef USE_WXPHP_DEBUG
		php_printf("Invocation of user defined method failed\n");
		#endif
		
	}
	else
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Returning userspace value.\n");
		#endif
		
		return Z_BVAL_P(return_value);
	}
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling original method\n");
	php_printf("===========================================\n\n");
	#endif
	
	//Call original method
	return wxWindow::ProcessEvent(event);
}
/* }}} */

/* {{{ proto bool wxWindow::ProcessWindowEvent(wxEvent &event)
   Convenient wrapper for ProcessEvent(). */
PHP_METHOD(php_wxWindow, ProcessWindowEvent)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::ProcessWindowEvent\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::ProcessWindowEvent call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* event0 = 0;
	wxEvent* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'o' (&event0)\n");
		#endif

		char parse_parameters_string[] = "o";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &event0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(event0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxEvent*) zend_object_store_get_object(event0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxEvent*) zend_object_store_get_object(event0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxEvent*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXEVENT_TYPE && argument_type != PHP_WXMENUEVENT_TYPE && argument_type != PHP_WXKEYEVENT_TYPE && argument_type != PHP_WXCOMMANDEVENT_TYPE && argument_type != PHP_WXNOTIFYEVENT_TYPE && argument_type != PHP_WXTREEEVENT_TYPE && argument_type != PHP_WXBOOKCTRLEVENT_TYPE && argument_type != PHP_WXAUINOTEBOOKEVENT_TYPE && argument_type != PHP_WXAUITOOLBAREVENT_TYPE && argument_type != PHP_WXLISTEVENT_TYPE && argument_type != PHP_WXSPINEVENT_TYPE && argument_type != PHP_WXSPLITTEREVENT_TYPE && argument_type != PHP_WXSPINDOUBLEEVENT_TYPE && argument_type != PHP_WXGRIDSIZEEVENT_TYPE && argument_type != PHP_WXWIZARDEVENT_TYPE && argument_type != PHP_WXGRIDEVENT_TYPE && argument_type != PHP_WXGRIDRANGESELECTEVENT_TYPE && argument_type != PHP_WXDATAVIEWEVENT_TYPE && argument_type != PHP_WXHEADERCTRLEVENT_TYPE && argument_type != PHP_WXRIBBONBAREVENT_TYPE && argument_type != PHP_WXWEBVIEWEVENT_TYPE && argument_type != PHP_WXMEDIAEVENT_TYPE && argument_type != PHP_WXSTYLEDTEXTEVENT_TYPE && argument_type != PHP_WXCHILDFOCUSEVENT_TYPE && argument_type != PHP_WXHTMLCELLEVENT_TYPE && argument_type != PHP_WXHTMLLINKEVENT_TYPE && argument_type != PHP_WXHYPERLINKEVENT_TYPE && argument_type != PHP_WXCOLOURPICKEREVENT_TYPE && argument_type != PHP_WXFONTPICKEREVENT_TYPE && argument_type != PHP_WXSCROLLEVENT_TYPE && argument_type != PHP_WXWINDOWMODALDIALOGEVENT_TYPE && argument_type != PHP_WXDATEEVENT_TYPE && argument_type != PHP_WXCALENDAREVENT_TYPE && argument_type != PHP_WXWINDOWCREATEEVENT_TYPE && argument_type != PHP_WXWINDOWDESTROYEVENT_TYPE && argument_type != PHP_WXUPDATEUIEVENT_TYPE && argument_type != PHP_WXHELPEVENT_TYPE && argument_type != PHP_WXGRIDEDITORCREATEDEVENT_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANEEVENT_TYPE && argument_type != PHP_WXCLIPBOARDTEXTEVENT_TYPE && argument_type != PHP_WXFILECTRLEVENT_TYPE && argument_type != PHP_WXSASHEVENT_TYPE && argument_type != PHP_WXFILEDIRPICKEREVENT_TYPE && argument_type != PHP_WXCONTEXTMENUEVENT_TYPE && argument_type != PHP_WXRIBBONBUTTONBAREVENT_TYPE && argument_type != PHP_WXRIBBONGALLERYEVENT_TYPE && argument_type != PHP_WXCLOSEEVENT_TYPE && argument_type != PHP_WXACTIVATEEVENT_TYPE && argument_type != PHP_WXAUIMANAGEREVENT_TYPE && argument_type != PHP_WXSIZEEVENT_TYPE && argument_type != PHP_WXMOUSEEVENT_TYPE && argument_type != PHP_WXMOVEEVENT_TYPE && argument_type != PHP_WXTIMEREVENT_TYPE && argument_type != PHP_WXTHREADEVENT_TYPE && argument_type != PHP_WXSCROLLWINEVENT_TYPE && argument_type != PHP_WXSYSCOLOURCHANGEDEVENT_TYPE && argument_type != PHP_WXPROCESSEVENT_TYPE && argument_type != PHP_WXERASEEVENT_TYPE && argument_type != PHP_WXSETCURSOREVENT_TYPE && argument_type != PHP_WXIDLEEVENT_TYPE && argument_type != PHP_WXPAINTEVENT_TYPE && argument_type != PHP_WXPALETTECHANGEDEVENT_TYPE && argument_type != PHP_WXINITDIALOGEVENT_TYPE && argument_type != PHP_WXMAXIMIZEEVENT_TYPE && argument_type != PHP_WXNAVIGATIONKEYEVENT_TYPE && argument_type != PHP_WXFOCUSEVENT_TYPE && argument_type != PHP_WXFILESYSTEMWATCHEREVENT_TYPE && argument_type != PHP_WXDISPLAYCHANGEDEVENT_TYPE && argument_type != PHP_WXCALCULATELAYOUTEVENT_TYPE && argument_type != PHP_WXQUERYLAYOUTINFOEVENT_TYPE && argument_type != PHP_WXTASKBARICONEVENT_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'event' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(event0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'event' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::ProcessWindowEvent(*(wxEvent*) object_pointer0_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->ProcessWindowEvent(*(wxEvent*) object_pointer0_0));

				references->AddReference(event0, "wxWindow::ProcessWindowEvent at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::ProcessWindowEvent\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::ProcessWindowEventLocally(wxEvent &event)
   Wrapper for wxEvtHandler::ProcessEventLocally(). */
PHP_METHOD(php_wxWindow, ProcessWindowEventLocally)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::ProcessWindowEventLocally\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::ProcessWindowEventLocally call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* event0 = 0;
	wxEvent* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'o' (&event0)\n");
		#endif

		char parse_parameters_string[] = "o";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &event0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(event0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxEvent*) zend_object_store_get_object(event0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxEvent*) zend_object_store_get_object(event0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxEvent*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXEVENT_TYPE && argument_type != PHP_WXMENUEVENT_TYPE && argument_type != PHP_WXKEYEVENT_TYPE && argument_type != PHP_WXCOMMANDEVENT_TYPE && argument_type != PHP_WXNOTIFYEVENT_TYPE && argument_type != PHP_WXTREEEVENT_TYPE && argument_type != PHP_WXBOOKCTRLEVENT_TYPE && argument_type != PHP_WXAUINOTEBOOKEVENT_TYPE && argument_type != PHP_WXAUITOOLBAREVENT_TYPE && argument_type != PHP_WXLISTEVENT_TYPE && argument_type != PHP_WXSPINEVENT_TYPE && argument_type != PHP_WXSPLITTEREVENT_TYPE && argument_type != PHP_WXSPINDOUBLEEVENT_TYPE && argument_type != PHP_WXGRIDSIZEEVENT_TYPE && argument_type != PHP_WXWIZARDEVENT_TYPE && argument_type != PHP_WXGRIDEVENT_TYPE && argument_type != PHP_WXGRIDRANGESELECTEVENT_TYPE && argument_type != PHP_WXDATAVIEWEVENT_TYPE && argument_type != PHP_WXHEADERCTRLEVENT_TYPE && argument_type != PHP_WXRIBBONBAREVENT_TYPE && argument_type != PHP_WXWEBVIEWEVENT_TYPE && argument_type != PHP_WXMEDIAEVENT_TYPE && argument_type != PHP_WXSTYLEDTEXTEVENT_TYPE && argument_type != PHP_WXCHILDFOCUSEVENT_TYPE && argument_type != PHP_WXHTMLCELLEVENT_TYPE && argument_type != PHP_WXHTMLLINKEVENT_TYPE && argument_type != PHP_WXHYPERLINKEVENT_TYPE && argument_type != PHP_WXCOLOURPICKEREVENT_TYPE && argument_type != PHP_WXFONTPICKEREVENT_TYPE && argument_type != PHP_WXSCROLLEVENT_TYPE && argument_type != PHP_WXWINDOWMODALDIALOGEVENT_TYPE && argument_type != PHP_WXDATEEVENT_TYPE && argument_type != PHP_WXCALENDAREVENT_TYPE && argument_type != PHP_WXWINDOWCREATEEVENT_TYPE && argument_type != PHP_WXWINDOWDESTROYEVENT_TYPE && argument_type != PHP_WXUPDATEUIEVENT_TYPE && argument_type != PHP_WXHELPEVENT_TYPE && argument_type != PHP_WXGRIDEDITORCREATEDEVENT_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANEEVENT_TYPE && argument_type != PHP_WXCLIPBOARDTEXTEVENT_TYPE && argument_type != PHP_WXFILECTRLEVENT_TYPE && argument_type != PHP_WXSASHEVENT_TYPE && argument_type != PHP_WXFILEDIRPICKEREVENT_TYPE && argument_type != PHP_WXCONTEXTMENUEVENT_TYPE && argument_type != PHP_WXRIBBONBUTTONBAREVENT_TYPE && argument_type != PHP_WXRIBBONGALLERYEVENT_TYPE && argument_type != PHP_WXCLOSEEVENT_TYPE && argument_type != PHP_WXACTIVATEEVENT_TYPE && argument_type != PHP_WXAUIMANAGEREVENT_TYPE && argument_type != PHP_WXSIZEEVENT_TYPE && argument_type != PHP_WXMOUSEEVENT_TYPE && argument_type != PHP_WXMOVEEVENT_TYPE && argument_type != PHP_WXTIMEREVENT_TYPE && argument_type != PHP_WXTHREADEVENT_TYPE && argument_type != PHP_WXSCROLLWINEVENT_TYPE && argument_type != PHP_WXSYSCOLOURCHANGEDEVENT_TYPE && argument_type != PHP_WXPROCESSEVENT_TYPE && argument_type != PHP_WXERASEEVENT_TYPE && argument_type != PHP_WXSETCURSOREVENT_TYPE && argument_type != PHP_WXIDLEEVENT_TYPE && argument_type != PHP_WXPAINTEVENT_TYPE && argument_type != PHP_WXPALETTECHANGEDEVENT_TYPE && argument_type != PHP_WXINITDIALOGEVENT_TYPE && argument_type != PHP_WXMAXIMIZEEVENT_TYPE && argument_type != PHP_WXNAVIGATIONKEYEVENT_TYPE && argument_type != PHP_WXFOCUSEVENT_TYPE && argument_type != PHP_WXFILESYSTEMWATCHEREVENT_TYPE && argument_type != PHP_WXDISPLAYCHANGEDEVENT_TYPE && argument_type != PHP_WXCALCULATELAYOUTEVENT_TYPE && argument_type != PHP_WXQUERYLAYOUTINFOEVENT_TYPE && argument_type != PHP_WXTASKBARICONEVENT_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'event' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(event0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'event' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::ProcessWindowEventLocally(*(wxEvent*) object_pointer0_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->ProcessWindowEventLocally(*(wxEvent*) object_pointer0_0));

				references->AddReference(event0, "wxWindow::ProcessWindowEventLocally at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::ProcessWindowEventLocally\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::PushEventHandler(wxEvtHandler &handler)
   Pushes this event handler onto the event stack for the window. */
PHP_METHOD(php_wxWindow, PushEventHandler)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::PushEventHandler\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::PushEventHandler call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* handler0 = 0;
	wxEvtHandler* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&handler0)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &handler0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(handler0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxEvtHandler*) zend_object_store_get_object(handler0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxEvtHandler*) zend_object_store_get_object(handler0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxEvtHandler*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXEVTHANDLER_TYPE && argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE && argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE && argument_type != PHP_WXMENU_TYPE && argument_type != PHP_WXAUIMANAGER_TYPE && argument_type != PHP_WXMOUSEEVENTSMANAGER_TYPE && argument_type != PHP_WXTIMER_TYPE && argument_type != PHP_WXEVENTBLOCKER_TYPE && argument_type != PHP_WXPROCESS_TYPE && argument_type != PHP_WXFILESYSTEMWATCHER_TYPE && argument_type != PHP_WXTASKBARICON_TYPE && argument_type != PHP_WXNOTIFICATIONMESSAGE_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'handler' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(handler0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'handler' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::PushEventHandler((wxEvtHandler*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->PushEventHandler((wxEvtHandler*) object_pointer0_0);

				references->AddReference(handler0, "wxWindow::PushEventHandler at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::PushEventHandler\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::QueueEvent(wxEvent &event)
   See ProcessEvent() for more info about why you shouldn't use this function and the reason for making this function protected in wxWindow. */
void wxWindow_php::QueueEvent(wxEvent* event)
{
	static zend_function* cached_function = NULL;
	static bool is_php_user_space_implemented = true;
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking virtual wxWindow::QueueEvent\n");
	php_printf("===========================================\n");
	#endif
	
	zval** params[1];
	zval *arguments[1];
	
	//Initilize arguments array
	for(int i=0; i<1; i++)
	{
		ALLOC_INIT_ZVAL(arguments[i]);
	}

	zval* return_value;
	MAKE_STD_ZVAL(return_value);
	zval function_name;
	ZVAL_STRING(&function_name, "QueueEvent", 0);
	char* temp_string;
	void* return_object;
	int function_called;
	
	//Parameters for conversion
	object_init_ex(arguments[0], php_wxEvent_entry);
	((zo_wxEvent*) zend_object_store_get_object(arguments[0] TSRMLS_CC))->native_object = (wxEvent_php*) event;
		
	for(int i=0; i<1; i++)
	{
		params[i] = &arguments[i];
	}

	#ifdef USE_WXPHP_DEBUG
	php_printf("Trying to call user defined method\n");
	#endif
	
	if(is_php_user_space_implemented)
	{
		function_called = wxphp_call_method((zval**) &this->phpObj, NULL, &cached_function, "QueueEvent", 10, &return_value, 1, params TSRMLS_CC);
	}
	else
	{
		function_called = FAILURE;
	}
    
    	
	//Delete already used parameters from memory
	for(int i=0; i<1; i++)
	{
		zval_ptr_dtor(&arguments[i]);
	}
	
	if(function_called == FAILURE)
	{
		is_php_user_space_implemented = false;
		
		#ifdef USE_WXPHP_DEBUG
		php_printf("Invocation of user defined method failed\n");
		#endif
		
	}
	else
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Returning userspace value.\n");
		#endif
		
		return;
	}
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling original method\n");
	php_printf("===========================================\n\n");
	#endif
	
	//Call original method
	wxWindow::QueueEvent(event);
}
/* }}} */

/* {{{ proto  wxWindow::Raise()
   Raises the window to the top of the window hierarchy (Z-order). */
PHP_METHOD(php_wxWindow, Raise)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Raise\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Raise call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::Raise()\n\n");
				#endif

				((wxWindow_php*)native_object)->Raise();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Raise\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::Refresh(bool eraseBackground, wxRect rect)
   Causes this window, and all of its children recursively (except under wxGTK1 where this is not implemented), to be repainted. */
PHP_METHOD(php_wxWindow, Refresh)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Refresh\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Refresh call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool eraseBackground0;
	zval* rect0 = 0;
	wxRect* object_pointer0_1 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|bz' (&eraseBackground0, &rect0)\n");
		#endif

		char parse_parameters_string[] = "|bz";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &eraseBackground0, &rect0 ) == SUCCESS)
		{
			if(arguments_received >= 2){
				if(Z_TYPE_P(rect0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxRect*) zend_object_store_get_object(rect0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxRect*) zend_object_store_get_object(rect0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxRect*) argument_native_object;
					if (!object_pointer0_1 || (argument_type != PHP_WXRECT_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'rect' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(rect0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'rect' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::Refresh()\n\n");
				#endif

				((wxWindow_php*)native_object)->Refresh();


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::Refresh(eraseBackground0)\n\n");
				#endif

				((wxWindow_php*)native_object)->Refresh(eraseBackground0);


				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::Refresh(eraseBackground0, (const wxRect*) object_pointer0_1)\n\n");
				#endif

				((wxWindow_php*)native_object)->Refresh(eraseBackground0, (const wxRect*) object_pointer0_1);

				references->AddReference(rect0, "wxWindow::Refresh at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Refresh\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::RefreshRect(wxRect rect, bool eraseBackground)
   Redraws the contents of the given rectangle: only the area inside it will be repainted. */
PHP_METHOD(php_wxWindow, RefreshRect)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::RefreshRect\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::RefreshRect call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* rect0 = 0;
	wxRect* object_pointer0_0 = 0;
	bool eraseBackground0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O|b' (&rect0, php_wxRect_entry, &eraseBackground0)\n");
		#endif

		char parse_parameters_string[] = "O|b";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &rect0, php_wxRect_entry, &eraseBackground0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(rect0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxRect*) zend_object_store_get_object(rect0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxRect*) zend_object_store_get_object(rect0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxRect*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'rect' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(rect0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'rect' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::RefreshRect(*(wxRect*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->RefreshRect(*(wxRect*) object_pointer0_0);

				references->AddReference(rect0, "wxWindow::RefreshRect at call with 1 argument(s)");

				return;
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::RefreshRect(*(wxRect*) object_pointer0_0, eraseBackground0)\n\n");
				#endif

				((wxWindow_php*)native_object)->RefreshRect(*(wxRect*) object_pointer0_0, eraseBackground0);

				references->AddReference(rect0, "wxWindow::RefreshRect at call with 2 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::RefreshRect\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::ReleaseMouse()
   Releases mouse input captured with CaptureMouse(). */
PHP_METHOD(php_wxWindow, ReleaseMouse)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::ReleaseMouse\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::ReleaseMouse call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::ReleaseMouse()\n\n");
				#endif

				((wxWindow_php*)native_object)->ReleaseMouse();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::ReleaseMouse\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::RemoveChild(wxWindow &child)
   Removes a child window. */
PHP_METHOD(php_wxWindow, RemoveChild)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::RemoveChild\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::RemoveChild call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* child0 = 0;
	wxWindow* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&child0)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &child0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(child0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(child0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(child0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'child' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(child0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'child' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::RemoveChild((wxWindow*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->RemoveChild((wxWindow*) object_pointer0_0);

				references->AddReference(child0, "wxWindow::RemoveChild at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::RemoveChild\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::RemoveEventHandler(wxEvtHandler &handler)
   Find the given handler in the windows event handler stack and removes (but does not delete) it from the stack. */
PHP_METHOD(php_wxWindow, RemoveEventHandler)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::RemoveEventHandler\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::RemoveEventHandler call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* handler0 = 0;
	wxEvtHandler* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&handler0)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &handler0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(handler0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxEvtHandler*) zend_object_store_get_object(handler0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxEvtHandler*) zend_object_store_get_object(handler0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxEvtHandler*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXEVTHANDLER_TYPE && argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE && argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE && argument_type != PHP_WXMENU_TYPE && argument_type != PHP_WXAUIMANAGER_TYPE && argument_type != PHP_WXMOUSEEVENTSMANAGER_TYPE && argument_type != PHP_WXTIMER_TYPE && argument_type != PHP_WXEVENTBLOCKER_TYPE && argument_type != PHP_WXPROCESS_TYPE && argument_type != PHP_WXFILESYSTEMWATCHER_TYPE && argument_type != PHP_WXTASKBARICON_TYPE && argument_type != PHP_WXNOTIFICATIONMESSAGE_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'handler' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(handler0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'handler' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::RemoveEventHandler((wxEvtHandler*) object_pointer0_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->RemoveEventHandler((wxEvtHandler*) object_pointer0_0));

				references->AddReference(handler0, "wxWindow::RemoveEventHandler at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::RemoveEventHandler\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::Reparent(wxWindow &newParent)
   Reparents the window, i.e. the window will be removed from its current parent window (e.g. */
PHP_METHOD(php_wxWindow, Reparent)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::Reparent\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::Reparent call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* newParent0 = 0;
	wxWindow* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&newParent0)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &newParent0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(newParent0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWindow*) zend_object_store_get_object(newParent0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWindow*) zend_object_store_get_object(newParent0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWindow*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'newParent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(newParent0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'newParent' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::Reparent((wxWindow*) object_pointer0_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->Reparent((wxWindow*) object_pointer0_0));

				references->AddReference(newParent0, "wxWindow::Reparent at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::Reparent\n");
	}
}
/* }}} */

/* {{{ proto wxPoint wxWindow::ScreenToClient(wxPoint pt)
   Converts from screen to client window coordinates. */
PHP_METHOD(php_wxWindow, ScreenToClient)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::ScreenToClient\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::ScreenToClient call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* pt0 = 0;
	wxPoint* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&pt0, php_wxPoint_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pt0, php_wxPoint_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(pt0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pt0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pt0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxPoint*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'pt' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(pt0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'pt' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::ScreenToClient(*(wxPoint*) object_pointer0_0) to return new object\n\n");
				#endif

				wxPoint value_to_return1;
				value_to_return1 = ((wxWindow_php*)native_object)->ScreenToClient(*(wxPoint*) object_pointer0_0);
				void* ptr = safe_emalloc(1, sizeof(wxPoint_php), 0);
				memcpy(ptr, (void*) &value_to_return1, sizeof(wxPoint));
				object_init_ex(return_value, php_wxPoint_entry);
				((wxPoint_php*)ptr)->phpObj = return_value;
				((wxPoint_php*)ptr)->InitProperties();
				zo_wxPoint* zo1 = (zo_wxPoint*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo1->native_object = (wxPoint_php*) ptr;

				references->AddReference(pt0, "wxWindow::ScreenToClient at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::ScreenToClient\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::ScrollLines(int lines)
   Scrolls the window by the given number of lines down (if lines is positive) or up. */
PHP_METHOD(php_wxWindow, ScrollLines)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::ScrollLines\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::ScrollLines call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long lines0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&lines0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &lines0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::ScrollLines((int) lines0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->ScrollLines((int) lines0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::ScrollLines\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::ScrollPages(int pages)
   Scrolls the window by the given number of pages down (if pages is positive) or up. */
PHP_METHOD(php_wxWindow, ScrollPages)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::ScrollPages\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::ScrollPages call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long pages0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&pages0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pages0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::ScrollPages((int) pages0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->ScrollPages((int) pages0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::ScrollPages\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SendSizeEvent(int flags)
   This function sends a dummy size event to the window allowing it to re-layout its children positions. */
PHP_METHOD(php_wxWindow, SendSizeEvent)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SendSizeEvent\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SendSizeEvent call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long flags0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|l' (&flags0)\n");
		#endif

		char parse_parameters_string[] = "|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &flags0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SendSizeEvent()\n\n");
				#endif

				((wxWindow_php*)native_object)->SendSizeEvent();


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SendSizeEvent((int) flags0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SendSizeEvent((int) flags0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SendSizeEvent\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SendSizeEventToParent(int flags)
   Safe wrapper for GetParent()->SendSizeEvent(). */
PHP_METHOD(php_wxWindow, SendSizeEventToParent)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SendSizeEventToParent\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SendSizeEventToParent call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long flags0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|l' (&flags0)\n");
		#endif

		char parse_parameters_string[] = "|l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &flags0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SendSizeEventToParent()\n\n");
				#endif

				((wxWindow_php*)native_object)->SendSizeEventToParent();


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SendSizeEventToParent((int) flags0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SendSizeEventToParent((int) flags0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SendSizeEventToParent\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetAutoLayout(bool autoLayout)
   Determines whether the Layout() function will be called automatically when the window is resized. */
PHP_METHOD(php_wxWindow, SetAutoLayout)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetAutoLayout\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetAutoLayout call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool autoLayout0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'b' (&autoLayout0)\n");
		#endif

		char parse_parameters_string[] = "b";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &autoLayout0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetAutoLayout(autoLayout0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetAutoLayout(autoLayout0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetAutoLayout\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::SetBackgroundColour(wxColour colour)
   Sets the background colour of the window. */
PHP_METHOD(php_wxWindow, SetBackgroundColour)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetBackgroundColour\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetBackgroundColour call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* colour0 = 0;
	wxColour* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&colour0, php_wxColour_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &colour0, php_wxColour_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(colour0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxColour*) zend_object_store_get_object(colour0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxColour*) zend_object_store_get_object(colour0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxColour*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'colour' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(colour0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'colour' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::SetBackgroundColour(*(wxColour*) object_pointer0_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->SetBackgroundColour(*(wxColour*) object_pointer0_0));

				references->AddReference(colour0, "wxWindow::SetBackgroundColour at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetBackgroundColour\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::SetBackgroundStyle(wxBackgroundStyle style)
   Sets the background style of the window. */
PHP_METHOD(php_wxWindow, SetBackgroundStyle)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetBackgroundStyle\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetBackgroundStyle call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long style0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&style0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &style0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::SetBackgroundStyle((wxBackgroundStyle) style0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->SetBackgroundStyle((wxBackgroundStyle) style0));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetBackgroundStyle\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetCanFocus(bool canFocus)
   This method is only implemented by ports which have support for native TAB traversal (such as GTK+ 2.0). */
PHP_METHOD(php_wxWindow, SetCanFocus)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetCanFocus\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetCanFocus call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool canFocus0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'b' (&canFocus0)\n");
		#endif

		char parse_parameters_string[] = "b";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &canFocus0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetCanFocus(canFocus0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetCanFocus(canFocus0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetCanFocus\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetCaret(wxCaret &caret)
   Sets the caret() associated with the window. */
PHP_METHOD(php_wxWindow, SetCaret)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetCaret\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetCaret call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* caret0 = 0;
	wxCaret* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&caret0)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &caret0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(caret0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxCaret*) zend_object_store_get_object(caret0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxCaret*) zend_object_store_get_object(caret0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxCaret*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXCARET_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'caret' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(caret0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'caret' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetCaret((wxCaret*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetCaret((wxCaret*) object_pointer0_0);

				references->AddReference(caret0, "wxWindow::SetCaret at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetCaret\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetClientSize(int width, int height)
   This sets the size of the window client area in pixels. */
PHP_METHOD(php_wxWindow, SetClientSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetClientSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetClientSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long width0;
	long height0;
	bool overload0_called = false;
	//Parameters for overload 1
	zval* size1 = 0;
	wxSize* object_pointer1_0 = 0;
	bool overload1_called = false;
	//Parameters for overload 2
	zval* rect2 = 0;
	wxRect* object_pointer2_0 = 0;
	bool overload2_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'll' (&width0, &height0)\n");
		#endif

		char parse_parameters_string[] = "ll";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &width0, &height0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&size1, php_wxSize_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &size1, php_wxSize_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(size1) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size1 TSRMLS_CC))->native_object;
					object_pointer1_0 = (wxSize*) argument_native_object;
					if (!object_pointer1_0 )
					{
						goto overload2;
					}
				}
				else if(Z_TYPE_P(size1) != IS_NULL)
				{
					goto overload2;
				}
			}

			overload1_called = true;
			already_called = true;
		}
	}

	//Overload 2
	overload2:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&rect2, php_wxRect_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &rect2, php_wxRect_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(rect2) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxRect*) zend_object_store_get_object(rect2 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxRect*) zend_object_store_get_object(rect2 TSRMLS_CC))->native_object;
					object_pointer2_0 = (wxRect*) argument_native_object;
					if (!object_pointer2_0 )
					{
						zend_error(E_ERROR, "Parameter 'rect' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(rect2) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'rect' not null, could not be retreived correctly.");
				}
			}

			overload2_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetClientSize((int) width0, (int) height0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetClientSize((int) width0, (int) height0);


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetClientSize(*(wxSize*) object_pointer1_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetClientSize(*(wxSize*) object_pointer1_0);

				references->AddReference(size1, "wxWindow::SetClientSize at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

	if(overload2_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetClientSize(*(wxRect*) object_pointer2_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetClientSize(*(wxRect*) object_pointer2_0);

				references->AddReference(rect2, "wxWindow::SetClientSize at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetClientSize\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetConstraints(wxLayoutConstraints &constraints)
   Sets the window to have the given layout constraints. */
PHP_METHOD(php_wxWindow, SetConstraints)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetConstraints\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetConstraints call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* constraints0 = 0;
	wxLayoutConstraints* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&constraints0)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &constraints0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(constraints0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxLayoutConstraints*) zend_object_store_get_object(constraints0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxLayoutConstraints*) zend_object_store_get_object(constraints0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxLayoutConstraints*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXLAYOUTCONSTRAINTS_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'constraints' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(constraints0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'constraints' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetConstraints((wxLayoutConstraints*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetConstraints((wxLayoutConstraints*) object_pointer0_0);

				references->AddReference(constraints0, "wxWindow::SetConstraints at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetConstraints\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetContainingSizer(wxSizer &sizer)
   This normally does not need to be called by user code. */
PHP_METHOD(php_wxWindow, SetContainingSizer)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetContainingSizer\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetContainingSizer call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* sizer0 = 0;
	wxSizer* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&sizer0)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &sizer0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(sizer0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSizer*) zend_object_store_get_object(sizer0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSizer*) zend_object_store_get_object(sizer0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxSizer*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXSIZER_TYPE && argument_type != PHP_WXBOXSIZER_TYPE && argument_type != PHP_WXSTATICBOXSIZER_TYPE && argument_type != PHP_WXWRAPSIZER_TYPE && argument_type != PHP_WXSTDDIALOGBUTTONSIZER_TYPE && argument_type != PHP_WXGRIDSIZER_TYPE && argument_type != PHP_WXFLEXGRIDSIZER_TYPE && argument_type != PHP_WXGRIDBAGSIZER_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'sizer' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(sizer0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'sizer' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetContainingSizer((wxSizer*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetContainingSizer((wxSizer*) object_pointer0_0);

				references->AddReference(sizer0, "wxWindow::SetContainingSizer at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetContainingSizer\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::SetCursor(wxCursor cursor)
   Sets the window's cursor. */
PHP_METHOD(php_wxWindow, SetCursor)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetCursor\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetCursor call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* cursor0 = 0;
	wxCursor* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&cursor0, php_wxCursor_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &cursor0, php_wxCursor_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(cursor0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxCursor*) zend_object_store_get_object(cursor0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxCursor*) zend_object_store_get_object(cursor0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxCursor*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'cursor' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(cursor0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'cursor' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::SetCursor(*(wxCursor*) object_pointer0_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->SetCursor(*(wxCursor*) object_pointer0_0));

				references->AddReference(cursor0, "wxWindow::SetCursor at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetCursor\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetDropTarget(wxDropTarget &target)
   Associates a drop target with this window. */
PHP_METHOD(php_wxWindow, SetDropTarget)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetDropTarget\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetDropTarget call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* target0 = 0;
	wxDropTarget* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&target0)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &target0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(target0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxDropTarget*) zend_object_store_get_object(target0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxDropTarget*) zend_object_store_get_object(target0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxDropTarget*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXDROPTARGET_TYPE && argument_type != PHP_WXFILEDROPTARGET_TYPE && argument_type != PHP_WXTEXTDROPTARGET_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'target' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(target0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'target' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetDropTarget((wxDropTarget*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetDropTarget((wxDropTarget*) object_pointer0_0);

				references->AddReference(target0, "wxWindow::SetDropTarget at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetDropTarget\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetEventHandler(wxEvtHandler &handler)
   Sets the event handler for this window. */
PHP_METHOD(php_wxWindow, SetEventHandler)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetEventHandler\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetEventHandler call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* handler0 = 0;
	wxEvtHandler* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&handler0)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &handler0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(handler0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxEvtHandler*) zend_object_store_get_object(handler0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxEvtHandler*) zend_object_store_get_object(handler0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxEvtHandler*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXEVTHANDLER_TYPE && argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE && argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE && argument_type != PHP_WXMENU_TYPE && argument_type != PHP_WXAUIMANAGER_TYPE && argument_type != PHP_WXMOUSEEVENTSMANAGER_TYPE && argument_type != PHP_WXTIMER_TYPE && argument_type != PHP_WXEVENTBLOCKER_TYPE && argument_type != PHP_WXPROCESS_TYPE && argument_type != PHP_WXFILESYSTEMWATCHER_TYPE && argument_type != PHP_WXTASKBARICON_TYPE && argument_type != PHP_WXNOTIFICATIONMESSAGE_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'handler' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(handler0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'handler' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetEventHandler((wxEvtHandler*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetEventHandler((wxEvtHandler*) object_pointer0_0);

				references->AddReference(handler0, "wxWindow::SetEventHandler at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetEventHandler\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetExtraStyle(int exStyle)
   Sets the extra style bits for the window. */
PHP_METHOD(php_wxWindow, SetExtraStyle)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetExtraStyle\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetExtraStyle call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long exStyle0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&exStyle0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &exStyle0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetExtraStyle((long) exStyle0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetExtraStyle((long) exStyle0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetExtraStyle\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetFocus()
   This sets the window to receive keyboard input. */
PHP_METHOD(php_wxWindow, SetFocus)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetFocus\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetFocus call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetFocus()\n\n");
				#endif

				((wxWindow_php*)native_object)->SetFocus();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetFocus\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetFocusFromKbd()
   This function is called by wxWidgets keyboard navigation code when the user gives the focus to this window from keyboard (e.g. */
PHP_METHOD(php_wxWindow, SetFocusFromKbd)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetFocusFromKbd\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetFocusFromKbd call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetFocusFromKbd()\n\n");
				#endif

				((wxWindow_php*)native_object)->SetFocusFromKbd();


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetFocusFromKbd\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::SetFont(wxFont font)
   Sets the font for this window. */
PHP_METHOD(php_wxWindow, SetFont)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetFont\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetFont call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* font0 = 0;
	wxFont* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&font0, php_wxFont_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &font0, php_wxFont_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(font0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxFont*) zend_object_store_get_object(font0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxFont*) zend_object_store_get_object(font0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxFont*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'font' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(font0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'font' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::SetFont(*(wxFont*) object_pointer0_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->SetFont(*(wxFont*) object_pointer0_0));

				references->AddReference(font0, "wxWindow::SetFont at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetFont\n");
	}
}
/* }}} */

/* {{{ proto bool wxWindow::SetForegroundColour(wxColour colour)
   Sets the foreground colour of the window. */
PHP_METHOD(php_wxWindow, SetForegroundColour)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetForegroundColour\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetForegroundColour call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* colour0 = 0;
	wxColour* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&colour0, php_wxColour_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &colour0, php_wxColour_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(colour0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxColour*) zend_object_store_get_object(colour0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxColour*) zend_object_store_get_object(colour0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxColour*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'colour' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(colour0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'colour' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing RETURN_BOOL(wxWindow::SetForegroundColour(*(wxColour*) object_pointer0_0))\n\n");
				#endif

				ZVAL_BOOL(return_value, ((wxWindow_php*)native_object)->SetForegroundColour(*(wxColour*) object_pointer0_0));

				references->AddReference(colour0, "wxWindow::SetForegroundColour at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetForegroundColour\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetHelpText(string helpText)
   Sets the help text to be used as context-sensitive help for this window. */
PHP_METHOD(php_wxWindow, SetHelpText)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetHelpText\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetHelpText call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	char* helpText0;
	long helpText_len0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 's' (&helpText0, &helpText_len0)\n");
		#endif

		char parse_parameters_string[] = "s";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &helpText0, &helpText_len0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetHelpText(wxString(helpText0, wxConvUTF8))\n\n");
				#endif

				((wxWindow_php*)native_object)->SetHelpText(wxString(helpText0, wxConvUTF8));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetHelpText\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetId(int winid)
   Sets the identifier of the window. */
PHP_METHOD(php_wxWindow, SetId)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetId\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetId call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long winid0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&winid0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &winid0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetId((wxWindowID) winid0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetId((wxWindowID) winid0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetId\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetInitialSize(wxSize size)
   A smart SetSize that will fill in default size components with the window's best size values. */
PHP_METHOD(php_wxWindow, SetInitialSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetInitialSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetInitialSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* size0 = 0;
	wxSize* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 0  && arguments_received <= 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '|O' (&size0, php_wxSize_entry)\n");
		#endif

		char parse_parameters_string[] = "|O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &size0, php_wxSize_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(size0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxSize*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetInitialSize()\n\n");
				#endif

				((wxWindow_php*)native_object)->SetInitialSize();


				return;
				break;
			}
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetInitialSize(*(wxSize*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetInitialSize(*(wxSize*) object_pointer0_0);

				references->AddReference(size0, "wxWindow::SetInitialSize at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetInitialSize\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetLabel(string label)
   Sets the window's label. */
PHP_METHOD(php_wxWindow, SetLabel)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetLabel\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetLabel call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	char* label0;
	long label_len0;
	bool overload0_called = false;
	//Parameters for overload 1
	long id1;
	char* label1;
	long label_len1;
	bool overload1_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 's' (&label0, &label_len0)\n");
		#endif

		char parse_parameters_string[] = "s";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &label0, &label_len0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

	//Overload 1
	overload1:
	if(!already_called && arguments_received == 2 && (current_object_type == PHP_WXMENUBAR_TYPE))
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'ls' (&id1, &label1, &label_len1)\n");
		#endif

		char parse_parameters_string[] = "ls";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &id1, &label1, &label_len1 ) == SUCCESS)
		{
			overload1_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetLabel(wxString(label0, wxConvUTF8))\n\n");
				#endif

				((wxWindow_php*)native_object)->SetLabel(wxString(label0, wxConvUTF8));


				return;
				break;
			}
		}
	}

	if(overload1_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxMenuBar::SetLabel((int) id1, wxString(label1, wxConvUTF8))\n\n");
				#endif

				((wxMenuBar_php*)native_object)->SetLabel((int) id1, wxString(label1, wxConvUTF8));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetLabel\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetLayoutDirection(wxLayoutDirection dir)
   Sets the layout direction for this window. */
PHP_METHOD(php_wxWindow, SetLayoutDirection)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetLayoutDirection\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetLayoutDirection call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long dir0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&dir0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &dir0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetLayoutDirection((wxLayoutDirection) dir0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetLayoutDirection((wxLayoutDirection) dir0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetLayoutDirection\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetMaxClientSize(wxSize size)
   Sets the maximum client size of the window, to indicate to the sizer layout mechanism that this is the maximum possible size of its client area. */
PHP_METHOD(php_wxWindow, SetMaxClientSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetMaxClientSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetMaxClientSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* size0 = 0;
	wxSize* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&size0, php_wxSize_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &size0, php_wxSize_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(size0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxSize*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetMaxClientSize(*(wxSize*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetMaxClientSize(*(wxSize*) object_pointer0_0);

				references->AddReference(size0, "wxWindow::SetMaxClientSize at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetMaxClientSize\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetMaxSize(wxSize size)
   Sets the maximum size of the window, to indicate to the sizer layout mechanism that this is the maximum possible size. */
PHP_METHOD(php_wxWindow, SetMaxSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetMaxSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetMaxSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* size0 = 0;
	wxSize* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&size0, php_wxSize_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &size0, php_wxSize_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(size0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxSize*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetMaxSize(*(wxSize*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetMaxSize(*(wxSize*) object_pointer0_0);

				references->AddReference(size0, "wxWindow::SetMaxSize at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetMaxSize\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetMinClientSize(wxSize size)
   Sets the minimum client size of the window, to indicate to the sizer layout mechanism that this is the minimum required size of window's client area. */
PHP_METHOD(php_wxWindow, SetMinClientSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetMinClientSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetMinClientSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* size0 = 0;
	wxSize* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&size0, php_wxSize_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &size0, php_wxSize_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(size0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxSize*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetMinClientSize(*(wxSize*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetMinClientSize(*(wxSize*) object_pointer0_0);

				references->AddReference(size0, "wxWindow::SetMinClientSize at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetMinClientSize\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetMinSize(wxSize size)
   Sets the minimum size of the window, to indicate to the sizer layout mechanism that this is the minimum required size. */
PHP_METHOD(php_wxWindow, SetMinSize)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetMinSize\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetMinSize call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* size0 = 0;
	wxSize* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&size0, php_wxSize_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &size0, php_wxSize_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(size0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxSize*) zend_object_store_get_object(size0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxSize*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'size' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(size0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'size' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetMinSize(*(wxSize*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetMinSize(*(wxSize*) object_pointer0_0);

				references->AddReference(size0, "wxWindow::SetMinSize at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetMinSize\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetName(string name)
   Sets the window's name. */
PHP_METHOD(php_wxWindow, SetName)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetName\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetName call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	char* name0;
	long name_len0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 's' (&name0, &name_len0)\n");
		#endif

		char parse_parameters_string[] = "s";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &name0, &name_len0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetName(wxString(name0, wxConvUTF8))\n\n");
				#endif

				((wxWindow_php*)native_object)->SetName(wxString(name0, wxConvUTF8));


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetName\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetNextHandler(wxEvtHandler &handler)
   wxWindows cannot be used to form event handler chains; this function thus will assert when called. */
PHP_METHOD(php_wxWindow, SetNextHandler)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetNextHandler\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetNextHandler call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* handler0 = 0;
	wxEvtHandler* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&handler0)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &handler0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(handler0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxEvtHandler*) zend_object_store_get_object(handler0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxEvtHandler*) zend_object_store_get_object(handler0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxEvtHandler*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXEVTHANDLER_TYPE && argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE && argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE && argument_type != PHP_WXMENU_TYPE && argument_type != PHP_WXAUIMANAGER_TYPE && argument_type != PHP_WXMOUSEEVENTSMANAGER_TYPE && argument_type != PHP_WXTIMER_TYPE && argument_type != PHP_WXEVENTBLOCKER_TYPE && argument_type != PHP_WXPROCESS_TYPE && argument_type != PHP_WXFILESYSTEMWATCHER_TYPE && argument_type != PHP_WXTASKBARICON_TYPE && argument_type != PHP_WXNOTIFICATIONMESSAGE_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'handler' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(handler0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'handler' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetNextHandler((wxEvtHandler*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetNextHandler((wxEvtHandler*) object_pointer0_0);

				references->AddReference(handler0, "wxWindow::SetNextHandler at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetNextHandler\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetOwnBackgroundColour(wxColour colour)
   Sets the background colour of the window but prevents it from being inherited by the children of this window. */
PHP_METHOD(php_wxWindow, SetOwnBackgroundColour)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetOwnBackgroundColour\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetOwnBackgroundColour call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* colour0 = 0;
	wxColour* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&colour0, php_wxColour_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &colour0, php_wxColour_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(colour0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxColour*) zend_object_store_get_object(colour0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxColour*) zend_object_store_get_object(colour0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxColour*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'colour' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(colour0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'colour' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetOwnBackgroundColour(*(wxColour*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetOwnBackgroundColour(*(wxColour*) object_pointer0_0);

				references->AddReference(colour0, "wxWindow::SetOwnBackgroundColour at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetOwnBackgroundColour\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetOwnFont(wxFont font)
   Sets the font of the window but prevents it from being inherited by the children of this window. */
PHP_METHOD(php_wxWindow, SetOwnFont)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetOwnFont\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetOwnFont call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* font0 = 0;
	wxFont* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&font0, php_wxFont_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &font0, php_wxFont_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(font0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxFont*) zend_object_store_get_object(font0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxFont*) zend_object_store_get_object(font0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxFont*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'font' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(font0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'font' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetOwnFont(*(wxFont*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetOwnFont(*(wxFont*) object_pointer0_0);

				references->AddReference(font0, "wxWindow::SetOwnFont at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetOwnFont\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetOwnForegroundColour(wxColour colour)
   Sets the foreground colour of the window but prevents it from being inherited by the children of this window. */
PHP_METHOD(php_wxWindow, SetOwnForegroundColour)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetOwnForegroundColour\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetOwnForegroundColour call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* colour0 = 0;
	wxColour* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&colour0, php_wxColour_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &colour0, php_wxColour_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(colour0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxColour*) zend_object_store_get_object(colour0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxColour*) zend_object_store_get_object(colour0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxColour*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'colour' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(colour0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'colour' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetOwnForegroundColour(*(wxColour*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetOwnForegroundColour(*(wxColour*) object_pointer0_0);

				references->AddReference(colour0, "wxWindow::SetOwnForegroundColour at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetOwnForegroundColour\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetPosition(wxPoint pt)
   A synonym for Centre(). */
PHP_METHOD(php_wxWindow, SetPosition)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetPosition\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetPosition call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* pt0 = 0;
	wxPoint* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'O' (&pt0, php_wxPoint_entry)\n");
		#endif

		char parse_parameters_string[] = "O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &pt0, php_wxPoint_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(pt0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxPoint*) zend_object_store_get_object(pt0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxPoint*) zend_object_store_get_object(pt0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxPoint*) argument_native_object;
					if (!object_pointer0_0 )
					{
						zend_error(E_ERROR, "Parameter 'pt' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(pt0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'pt' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetPosition(*(wxPoint*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetPosition(*(wxPoint*) object_pointer0_0);

				references->AddReference(pt0, "wxWindow::SetPosition at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetPosition\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetPreviousHandler(wxEvtHandler &handler)
   wxWindows cannot be used to form event handler chains; this function thus will assert when called. */
PHP_METHOD(php_wxWindow, SetPreviousHandler)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetPreviousHandler\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetPreviousHandler call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* handler0 = 0;
	wxEvtHandler* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&handler0)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &handler0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(handler0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxEvtHandler*) zend_object_store_get_object(handler0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxEvtHandler*) zend_object_store_get_object(handler0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxEvtHandler*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXEVTHANDLER_TYPE && argument_type != PHP_WXWINDOW_TYPE && argument_type != PHP_WXNONOWNEDWINDOW_TYPE && argument_type != PHP_WXTOPLEVELWINDOW_TYPE && argument_type != PHP_WXFRAME_TYPE && argument_type != PHP_WXSPLASHSCREEN_TYPE && argument_type != PHP_WXMDICHILDFRAME_TYPE && argument_type != PHP_WXMDIPARENTFRAME_TYPE && argument_type != PHP_WXMINIFRAME_TYPE && argument_type != PHP_WXPREVIEWFRAME_TYPE && argument_type != PHP_WXHTMLHELPDIALOG_TYPE && argument_type != PHP_WXHTMLHELPFRAME_TYPE && argument_type != PHP_WXDIALOG_TYPE && argument_type != PHP_WXTEXTENTRYDIALOG_TYPE && argument_type != PHP_WXPASSWORDENTRYDIALOG_TYPE && argument_type != PHP_WXMESSAGEDIALOG_TYPE && argument_type != PHP_WXFINDREPLACEDIALOG_TYPE && argument_type != PHP_WXDIRDIALOG_TYPE && argument_type != PHP_WXSYMBOLPICKERDIALOG_TYPE && argument_type != PHP_WXPROPERTYSHEETDIALOG_TYPE && argument_type != PHP_WXWIZARD_TYPE && argument_type != PHP_WXPROGRESSDIALOG_TYPE && argument_type != PHP_WXCOLOURDIALOG_TYPE && argument_type != PHP_WXFILEDIALOG_TYPE && argument_type != PHP_WXFONTDIALOG_TYPE && argument_type != PHP_WXSINGLECHOICEDIALOG_TYPE && argument_type != PHP_WXGENERICPROGRESSDIALOG_TYPE && argument_type != PHP_WXPOPUPWINDOW_TYPE && argument_type != PHP_WXPOPUPTRANSIENTWINDOW_TYPE && argument_type != PHP_WXCONTROL_TYPE && argument_type != PHP_WXSTATUSBAR_TYPE && argument_type != PHP_WXANYBUTTON_TYPE && argument_type != PHP_WXBUTTON_TYPE && argument_type != PHP_WXBITMAPBUTTON_TYPE && argument_type != PHP_WXTOGGLEBUTTON_TYPE && argument_type != PHP_WXBITMAPTOGGLEBUTTON_TYPE && argument_type != PHP_WXTREECTRL_TYPE && argument_type != PHP_WXCONTROLWITHITEMS_TYPE && argument_type != PHP_WXLISTBOX_TYPE && argument_type != PHP_WXCHECKLISTBOX_TYPE && argument_type != PHP_WXREARRANGELIST_TYPE && argument_type != PHP_WXCHOICE_TYPE && argument_type != PHP_WXBOOKCTRLBASE_TYPE && argument_type != PHP_WXAUINOTEBOOK_TYPE && argument_type != PHP_WXLISTBOOK_TYPE && argument_type != PHP_WXCHOICEBOOK_TYPE && argument_type != PHP_WXNOTEBOOK_TYPE && argument_type != PHP_WXTREEBOOK_TYPE && argument_type != PHP_WXTOOLBOOK_TYPE && argument_type != PHP_WXANIMATIONCTRL_TYPE && argument_type != PHP_WXSTYLEDTEXTCTRL_TYPE && argument_type != PHP_WXSCROLLBAR_TYPE && argument_type != PHP_WXSTATICTEXT_TYPE && argument_type != PHP_WXSTATICLINE_TYPE && argument_type != PHP_WXSTATICBOX_TYPE && argument_type != PHP_WXSTATICBITMAP_TYPE && argument_type != PHP_WXCHECKBOX_TYPE && argument_type != PHP_WXTEXTCTRL_TYPE && argument_type != PHP_WXSEARCHCTRL_TYPE && argument_type != PHP_WXCOMBOBOX_TYPE && argument_type != PHP_WXBITMAPCOMBOBOX_TYPE && argument_type != PHP_WXAUITOOLBAR_TYPE && argument_type != PHP_WXLISTCTRL_TYPE && argument_type != PHP_WXLISTVIEW_TYPE && argument_type != PHP_WXRADIOBOX_TYPE && argument_type != PHP_WXRADIOBUTTON_TYPE && argument_type != PHP_WXSLIDER_TYPE && argument_type != PHP_WXSPINCTRL_TYPE && argument_type != PHP_WXSPINBUTTON_TYPE && argument_type != PHP_WXGAUGE_TYPE && argument_type != PHP_WXHYPERLINKCTRL_TYPE && argument_type != PHP_WXSPINCTRLDOUBLE_TYPE && argument_type != PHP_WXGENERICDIRCTRL_TYPE && argument_type != PHP_WXCALENDARCTRL_TYPE && argument_type != PHP_WXPICKERBASE_TYPE && argument_type != PHP_WXCOLOURPICKERCTRL_TYPE && argument_type != PHP_WXFONTPICKERCTRL_TYPE && argument_type != PHP_WXFILEPICKERCTRL_TYPE && argument_type != PHP_WXDIRPICKERCTRL_TYPE && argument_type != PHP_WXTIMEPICKERCTRL_TYPE && argument_type != PHP_WXTOOLBAR_TYPE && argument_type != PHP_WXDATEPICKERCTRL_TYPE && argument_type != PHP_WXCOLLAPSIBLEPANE_TYPE && argument_type != PHP_WXCOMBOCTRL_TYPE && argument_type != PHP_WXDATAVIEWCTRL_TYPE && argument_type != PHP_WXDATAVIEWLISTCTRL_TYPE && argument_type != PHP_WXDATAVIEWTREECTRL_TYPE && argument_type != PHP_WXHEADERCTRL_TYPE && argument_type != PHP_WXHEADERCTRLSIMPLE_TYPE && argument_type != PHP_WXFILECTRL_TYPE && argument_type != PHP_WXINFOBAR_TYPE && argument_type != PHP_WXRIBBONCONTROL_TYPE && argument_type != PHP_WXRIBBONBAR_TYPE && argument_type != PHP_WXRIBBONBUTTONBAR_TYPE && argument_type != PHP_WXRIBBONGALLERY_TYPE && argument_type != PHP_WXRIBBONPAGE_TYPE && argument_type != PHP_WXRIBBONPANEL_TYPE && argument_type != PHP_WXRIBBONTOOLBAR_TYPE && argument_type != PHP_WXWEBVIEW_TYPE && argument_type != PHP_WXMEDIACTRL_TYPE && argument_type != PHP_WXSPLITTERWINDOW_TYPE && argument_type != PHP_WXPANEL_TYPE && argument_type != PHP_WXSCROLLEDWINDOW_TYPE && argument_type != PHP_WXHTMLWINDOW_TYPE && argument_type != PHP_WXGRID_TYPE && argument_type != PHP_WXPREVIEWCANVAS_TYPE && argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE && argument_type != PHP_WXEDITABLELISTBOX_TYPE && argument_type != PHP_WXHSCROLLEDWINDOW_TYPE && argument_type != PHP_WXPREVIEWCONTROLBAR_TYPE && argument_type != PHP_WXMENUBAR_TYPE && argument_type != PHP_WXBANNERWINDOW_TYPE && argument_type != PHP_WXMDICLIENTWINDOW_TYPE && argument_type != PHP_WXTREELISTCTRL_TYPE && argument_type != PHP_WXSASHWINDOW_TYPE && argument_type != PHP_WXSASHLAYOUTWINDOW_TYPE && argument_type != PHP_WXHTMLHELPWINDOW_TYPE && argument_type != PHP_WXVALIDATOR_TYPE && argument_type != PHP_WXTEXTVALIDATOR_TYPE && argument_type != PHP_WXGENERICVALIDATOR_TYPE && argument_type != PHP_WXMENU_TYPE && argument_type != PHP_WXAUIMANAGER_TYPE && argument_type != PHP_WXMOUSEEVENTSMANAGER_TYPE && argument_type != PHP_WXTIMER_TYPE && argument_type != PHP_WXEVENTBLOCKER_TYPE && argument_type != PHP_WXPROCESS_TYPE && argument_type != PHP_WXFILESYSTEMWATCHER_TYPE && argument_type != PHP_WXTASKBARICON_TYPE && argument_type != PHP_WXNOTIFICATIONMESSAGE_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'handler' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(handler0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'handler' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetPreviousHandler((wxEvtHandler*) object_pointer0_0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetPreviousHandler((wxEvtHandler*) object_pointer0_0);

				references->AddReference(handler0, "wxWindow::SetPreviousHandler at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetPreviousHandler\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetThemeEnabled(bool enable)
   This function tells a window if it should use the system's "theme" code to draw the windows' background instead of its own background drawing code. */
PHP_METHOD(php_wxWindow, SetThemeEnabled)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetThemeEnabled\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetThemeEnabled call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool enable0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'b' (&enable0)\n");
		#endif

		char parse_parameters_string[] = "b";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &enable0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetThemeEnabled(enable0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetThemeEnabled(enable0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetThemeEnabled\n");
	}
}
/* }}} */

/* {{{ proto  wxWindow::SetWindowVariant(wxWindowVariant variant)
   This function can be called under all platforms but only does anything under Mac OS X 10.3+ currently. */
PHP_METHOD(php_wxWindow, SetWindowVariant)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWindow::SetWindowVariant\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWindow* current_object;
	wxphp_object_type current_object_type;
	wxWindow_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWindow*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWindow::SetWindowVariant call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWINDOW_TYPE){
				references = &((wxWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNONOWNEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxNonOwnedWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOPLEVELWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxTopLevelWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFRAME_TYPE) && (!reference_type_found)){
				references = &((wxFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLASHSCREEN_TYPE) && (!reference_type_found)){
				references = &((wxSplashScreen_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICHILDFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIChildFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDIPARENTFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMDIParentFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMINIFRAME_TYPE) && (!reference_type_found)){
				references = &((wxMiniFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWFRAME_TYPE) && (!reference_type_found)){
				references = &((wxPreviewFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPFRAME_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpFrame_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxTextEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPASSWORDENTRYDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPasswordEntryDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMESSAGEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxMessageDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFINDREPLACEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFindReplaceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxDirDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSYMBOLPICKERDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSymbolPickerDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROPERTYSHEETDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxPropertySheetDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARD_TYPE) && (!reference_type_found)){
				references = &((wxWizard_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxColourDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFileDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxFontDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSINGLECHOICEDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxSingleChoiceDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICPROGRESSDIALOG_TYPE) && (!reference_type_found)){
				references = &((wxGenericProgressDialog_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPOPUPTRANSIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxPopupTransientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATUSBAR_TYPE) && (!reference_type_found)){
				references = &((wxStatusBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANYBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxAnyButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPTOGGLEBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxBitmapToggleButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCONTROLWITHITEMS_TYPE) && (!reference_type_found)){
				references = &((wxControlWithItems_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKLISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXREARRANGELIST_TYPE) && (!reference_type_found)){
				references = &((wxRearrangeList_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICE_TYPE) && (!reference_type_found)){
				references = &((wxChoice_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBOOKCTRLBASE_TYPE) && (!reference_type_found)){
				references = &((wxBookCtrlBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUINOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxAuiNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTBOOK_TYPE) && (!reference_type_found)){
				references = &((wxListbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHOICEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxChoicebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXNOTEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxNotebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREEBOOK_TYPE) && (!reference_type_found)){
				references = &((wxTreebook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBOOK_TYPE) && (!reference_type_found)){
				references = &((wxToolbook_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXANIMATIONCTRL_TYPE) && (!reference_type_found)){
				references = &((wxAnimationCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTYLEDTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxStyledTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLBAR_TYPE) && (!reference_type_found)){
				references = &((wxScrollBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICTEXT_TYPE) && (!reference_type_found)){
				references = &((wxStaticText_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICLINE_TYPE) && (!reference_type_found)){
				references = &((wxStaticLine_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBOX_TYPE) && (!reference_type_found)){
				references = &((wxStaticBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSTATICBITMAP_TYPE) && (!reference_type_found)){
				references = &((wxStaticBitmap_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCHECKBOX_TYPE) && (!reference_type_found)){
				references = &((wxCheckBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTEXTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTextCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSEARCHCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSearchCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBITMAPCOMBOBOX_TYPE) && (!reference_type_found)){
				references = &((wxBitmapComboBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXAUITOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxAuiToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXLISTVIEW_TYPE) && (!reference_type_found)){
				references = &((wxListView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBOX_TYPE) && (!reference_type_found)){
				references = &((wxRadioBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRADIOBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxRadioButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSLIDER_TYPE) && (!reference_type_found)){
				references = &((wxSlider_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRL_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINBUTTON_TYPE) && (!reference_type_found)){
				references = &((wxSpinButton_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGAUGE_TYPE) && (!reference_type_found)){
				references = &((wxGauge_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHYPERLINKCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHyperlinkCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPINCTRLDOUBLE_TYPE) && (!reference_type_found)){
				references = &((wxSpinCtrlDouble_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGENERICDIRCTRL_TYPE) && (!reference_type_found)){
				references = &((wxGenericDirCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCALENDARCTRL_TYPE) && (!reference_type_found)){
				references = &((wxCalendarCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPICKERBASE_TYPE) && (!reference_type_found)){
				references = &((wxPickerBase_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLOURPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxColourPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFONTPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFontPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxFilePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDIRPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDirPickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTIMEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTimePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATEPICKERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDatePickerCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOLLAPSIBLEPANE_TYPE) && (!reference_type_found)){
				references = &((wxCollapsiblePane_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXCOMBOCTRL_TYPE) && (!reference_type_found)){
				references = &((wxComboCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWLISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXDATAVIEWTREECTRL_TYPE) && (!reference_type_found)){
				references = &((wxDataViewTreeCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRL_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHEADERCTRLSIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxHeaderCtrlSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXFILECTRL_TYPE) && (!reference_type_found)){
				references = &((wxFileCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXINFOBAR_TYPE) && (!reference_type_found)){
				references = &((wxInfoBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONCONTROL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonControl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONBUTTONBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonButtonBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONGALLERY_TYPE) && (!reference_type_found)){
				references = &((wxRibbonGallery_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPAGE_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONPANEL_TYPE) && (!reference_type_found)){
				references = &((wxRibbonPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXRIBBONTOOLBAR_TYPE) && (!reference_type_found)){
				references = &((wxRibbonToolBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWEBVIEW_TYPE) && (!reference_type_found)){
				references = &((wxWebView_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMEDIACTRL_TYPE) && (!reference_type_found)){
				references = &((wxMediaCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSPLITTERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSplitterWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPANEL_TYPE) && (!reference_type_found)){
				references = &((wxPanel_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXGRID_TYPE) && (!reference_type_found)){
				references = &((wxGrid_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCANVAS_TYPE) && (!reference_type_found)){
				references = &((wxPreviewCanvas_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXEDITABLELISTBOX_TYPE) && (!reference_type_found)){
				references = &((wxEditableListBox_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHSCROLLEDWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHScrolledWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXPREVIEWCONTROLBAR_TYPE) && (!reference_type_found)){
				references = &((wxPreviewControlBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMENUBAR_TYPE) && (!reference_type_found)){
				references = &((wxMenuBar_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXBANNERWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxBannerWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXMDICLIENTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxMDIClientWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXTREELISTCTRL_TYPE) && (!reference_type_found)){
				references = &((wxTreeListCtrl_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXSASHLAYOUTWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxSashLayoutWindow_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXHTMLHELPWINDOW_TYPE) && (!reference_type_found)){
				references = &((wxHtmlHelpWindow_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	long variant0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'l' (&variant0)\n");
		#endif

		char parse_parameters_string[] = "l";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &variant0 ) == SUCCESS)
		{
			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWindow::SetWindowVariant((wxWindowVariant) variant0)\n\n");
				#endif

				((wxWindow_php*)native_object)->SetWindowVariant((wxWindowVariant) variant0);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWindow::SetWindowVariant\n");
	}
}
/* }}} */

BEGIN_EXTERN_C()
void php_wxWizardPage_free(void *object TSRMLS_DC) 
{
    zo_wxWizardPage* custom_object = (zo_wxWizardPage*) object;
    
	#ifdef USE_WXPHP_DEBUG
	php_printf("Obviate delete call for wxWizardPage on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n\n");
	#endif

	zend_object_std_dtor(&custom_object->zo TSRMLS_CC);
    efree(custom_object);
}

zend_object_value php_wxWizardPage_new(zend_class_entry *class_type TSRMLS_DC)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxWizardPage_new on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	zval *temp;
    zend_object_value retval;
    zo_wxWizardPage* custom_object;
    custom_object = (zo_wxWizardPage*) emalloc(sizeof(zo_wxWizardPage));

    zend_object_std_init(&custom_object->zo, class_type TSRMLS_CC);

#if PHP_VERSION_ID < 50399
	ALLOC_HASHTABLE(custom_object->zo.properties);
    zend_hash_init(custom_object->zo.properties, 0, NULL, ZVAL_PTR_DTOR, 0);
    zend_hash_copy(custom_object->zo.properties, &class_type->default_properties, (copy_ctor_func_t) zval_add_ref,(void *) &temp, sizeof(zval *));
#else
	object_properties_init(&custom_object->zo, class_type);
#endif

	retval.handle = zend_objects_store_put(custom_object, NULL, php_wxWizardPage_free, NULL TSRMLS_CC);
	retval.handlers = zend_get_std_object_handlers();

    custom_object->native_object = NULL;
	custom_object->object_type = PHP_WXWIZARDPAGE_TYPE;
	custom_object->is_user_initialized = 0;
	
    return retval;
}
END_EXTERN_C()

/* {{{ proto wxBitmap wxWizardPage::GetBitmap()
   This method is called by wxWizard to get the bitmap to display alongside the page. */
PHP_METHOD(php_wxWizardPage, GetBitmap)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWizardPage::GetBitmap\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWizardPage* current_object;
	wxphp_object_type current_object_type;
	wxWizardPage_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWizardPage*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWizardPage::GetBitmap call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWIZARDPAGE_TYPE){
				references = &((wxWizardPage_php*)native_object)->references;
				reference_type_found = true;
			}
			if((current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE) && (!reference_type_found)){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 0)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with '' ()\n");
		#endif

		overload0_called = true;
		already_called = true;
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 0:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWizardPage::GetBitmap() to return new object\n\n");
				#endif

				wxBitmap value_to_return0;
				value_to_return0 = ((wxWizardPage_php*)native_object)->GetBitmap();
				((wxRefCounter *) value_to_return0.GetRefData())->IncRef();
				void* ptr = safe_emalloc(1, sizeof(wxBitmap_php), 0);
				memcpy(ptr, (void*) &value_to_return0, sizeof(wxBitmap));
				object_init_ex(return_value, php_wxBitmap_entry);
				((wxBitmap_php*)ptr)->phpObj = return_value;
				zo_wxBitmap* zo0 = (zo_wxBitmap*) zend_object_store_get_object(return_value TSRMLS_CC);
				zo0->native_object = (wxBitmap_php*) ptr;


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWizardPage::GetBitmap\n");
	}
}
/* }}} */

/* {{{ proto wxWizardPage wxWizardPage::GetPrev()
   Get the page which should be shown when the user chooses the "Back" button: if NULL is returned, this button will be disabled. */
wxWizardPage* wxWizardPage_php::GetPrev()const
{
	static zend_function* cached_function = NULL;
	static bool is_php_user_space_implemented = true;
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking virtual wxWizardPage::GetPrev\n");
	php_printf("===========================================\n");
	#endif
	
	zval** params[1];
	zval* arguments[1];
	arguments[0] = NULL;
	params[0] = NULL;

	zval* return_value;
	MAKE_STD_ZVAL(return_value);
	zval function_name;
	ZVAL_STRING(&function_name, "GetPrev", 0);
	char* temp_string;
	void* return_object;
	int function_called;
	
	//Parameters for conversion
		

	#ifdef USE_WXPHP_DEBUG
	php_printf("Trying to call user defined method\n");
	#endif
	
	if(is_php_user_space_implemented)
	{
		function_called = wxphp_call_method((zval**) &this->phpObj, NULL, &cached_function, "GetPrev", 7, &return_value, 0, params TSRMLS_CC);
	}
	else
	{
		function_called = FAILURE;
	}
    
    	
	
	if(function_called == FAILURE)
	{
		is_php_user_space_implemented = false;
		
		#ifdef USE_WXPHP_DEBUG
		php_printf("Invocation of user defined method failed\n");
		#endif
		
		wxMessageBox("Failed to call virtual method 'wxWizardPage::GetPrev'!", "Error", wxOK|wxICON_ERROR);
	}

	#ifdef USE_WXPHP_DEBUG
	php_printf("Returning userspace value.\n");
	#endif
		
	if(Z_TYPE_P(return_value) == IS_OBJECT)
	{
		return_object = (void*) ((zo_wxWizardPage*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object;
	}

	//Threat it as a normal object on the calling function and not a php user space intiialized one
	((zo_wxWizardPage*) zend_object_store_get_object(return_value TSRMLS_CC))->is_user_initialized = 0;
	wxWizardPage_php* var = (wxWizardPage_php*) return_object;
	var->references.UnInitialize();

	return (wxWizardPage*) return_object;
	
}
/* }}} */

/* {{{ proto  wxWizardPage::wxWizardPage(wxWizard &parent, wxBitmap bitmap)
   Constructor accepts an optional bitmap which will be used for this page instead of the default one for this wizard (note that all bitmaps used should be of the same size). */
PHP_METHOD(php_wxWizardPage, __construct)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWizardPage::__construct\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWizardPage* current_object;
	wxWizardPage_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	int arguments_received = ZEND_NUM_ARGS();
	
	
	//Parameters for overload 0
	zval* parent0 = 0;
	wxWizard* object_pointer0_0 = 0;
	zval* bitmap0 = 0;
	wxBitmap* object_pointer0_1 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|O' (&parent0, &bitmap0, php_wxBitmap_entry)\n");
		#endif

		char parse_parameters_string[] = "z|O";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent0, &bitmap0, php_wxBitmap_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWizard*) zend_object_store_get_object(parent0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWizard*) zend_object_store_get_object(parent0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWizard*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWIZARD_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 2){
				if(Z_TYPE_P(bitmap0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(bitmap0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(bitmap0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxBitmap*) argument_native_object;
					if (!object_pointer0_1 )
					{
						zend_error(E_ERROR, "Parameter 'bitmap' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(bitmap0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'bitmap' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWizard*) object_pointer0_0)\n");
				#endif

				native_object = new wxWizardPage_php((wxWizard*) object_pointer0_0);

				native_object->references.Initialize();
				((wxWizardPage_php*) native_object)->references.AddReference(parent0, "wxWizardPage::wxWizardPage at call with 1 argument(s)");
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWizard*) object_pointer0_0, *(wxBitmap*) object_pointer0_1)\n");
				#endif

				native_object = new wxWizardPage_php((wxWizard*) object_pointer0_0, *(wxBitmap*) object_pointer0_1);

				native_object->references.Initialize();
				((wxWizardPage_php*) native_object)->references.AddReference(parent0, "wxWizardPage::wxWizardPage at call with 2 argument(s)");
				((wxWizardPage_php*) native_object)->references.AddReference(bitmap0, "wxWizardPage::wxWizardPage at call with 2 argument(s)");
				break;
			}
		}
	}

		
	if(already_called)
	{
		native_object->phpObj = getThis();
		

		current_object = (zo_wxWizardPage*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		current_object->native_object = native_object;
		
		current_object->is_user_initialized = 1;
		
		#ifdef ZTS 
		native_object->TSRMLS_C = TSRMLS_C;
		#endif
	}
	else
	{
		zend_error(E_ERROR, "Abstract class or wrong type/count of parameters passed to: wxWizardPage::__construct\n");
	}
	
	#ifdef USE_WXPHP_DEBUG
		php_printf("===========================================\n\n");
	#endif
}
/* }}} */

/* {{{ proto wxWizardPage wxWizardPage::GetNext()
   Get the page which should be shown when the user chooses the "Next" button: if NULL is returned, this button will be disabled. */
wxWizardPage* wxWizardPage_php::GetNext()const
{
	static zend_function* cached_function = NULL;
	static bool is_php_user_space_implemented = true;
	
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking virtual wxWizardPage::GetNext\n");
	php_printf("===========================================\n");
	#endif
	
	zval** params[1];
	zval* arguments[1];
	arguments[0] = NULL;
	params[0] = NULL;

	zval* return_value;
	MAKE_STD_ZVAL(return_value);
	zval function_name;
	ZVAL_STRING(&function_name, "GetNext", 0);
	char* temp_string;
	void* return_object;
	int function_called;
	
	//Parameters for conversion
		

	#ifdef USE_WXPHP_DEBUG
	php_printf("Trying to call user defined method\n");
	#endif
	
	if(is_php_user_space_implemented)
	{
		function_called = wxphp_call_method((zval**) &this->phpObj, NULL, &cached_function, "GetNext", 7, &return_value, 0, params TSRMLS_CC);
	}
	else
	{
		function_called = FAILURE;
	}
    
    	
	
	if(function_called == FAILURE)
	{
		is_php_user_space_implemented = false;
		
		#ifdef USE_WXPHP_DEBUG
		php_printf("Invocation of user defined method failed\n");
		#endif
		
		wxMessageBox("Failed to call virtual method 'wxWizardPage::GetNext'!", "Error", wxOK|wxICON_ERROR);
	}

	#ifdef USE_WXPHP_DEBUG
	php_printf("Returning userspace value.\n");
	#endif
		
	if(Z_TYPE_P(return_value) == IS_OBJECT)
	{
		return_object = (void*) ((zo_wxWizardPage*) zend_object_store_get_object(return_value TSRMLS_CC))->native_object;
	}

	//Threat it as a normal object on the calling function and not a php user space intiialized one
	((zo_wxWizardPage*) zend_object_store_get_object(return_value TSRMLS_CC))->is_user_initialized = 0;
	wxWizardPage_php* var = (wxWizardPage_php*) return_object;
	var->references.UnInitialize();

	return (wxWizardPage*) return_object;
	
}
/* }}} */

BEGIN_EXTERN_C()
void php_wxWizardPageSimple_free(void *object TSRMLS_DC) 
{
    zo_wxWizardPageSimple* custom_object = (zo_wxWizardPageSimple*) object;
    
	#ifdef USE_WXPHP_DEBUG
	php_printf("Obviate delete call for wxWizardPageSimple on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n\n");
	#endif

	zend_object_std_dtor(&custom_object->zo TSRMLS_CC);
    efree(custom_object);
}

zend_object_value php_wxWizardPageSimple_new(zend_class_entry *class_type TSRMLS_DC)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Calling php_wxWizardPageSimple_new on %s at line %i\n", zend_get_executed_filename(TSRMLS_C), zend_get_executed_lineno(TSRMLS_C));
	php_printf("===========================================\n");
	#endif
	
	zval *temp;
    zend_object_value retval;
    zo_wxWizardPageSimple* custom_object;
    custom_object = (zo_wxWizardPageSimple*) emalloc(sizeof(zo_wxWizardPageSimple));

    zend_object_std_init(&custom_object->zo, class_type TSRMLS_CC);

#if PHP_VERSION_ID < 50399
	ALLOC_HASHTABLE(custom_object->zo.properties);
    zend_hash_init(custom_object->zo.properties, 0, NULL, ZVAL_PTR_DTOR, 0);
    zend_hash_copy(custom_object->zo.properties, &class_type->default_properties, (copy_ctor_func_t) zval_add_ref,(void *) &temp, sizeof(zval *));
#else
	object_properties_init(&custom_object->zo, class_type);
#endif

	retval.handle = zend_objects_store_put(custom_object, NULL, php_wxWizardPageSimple_free, NULL TSRMLS_CC);
	retval.handlers = zend_get_std_object_handlers();

    custom_object->native_object = NULL;
	custom_object->object_type = PHP_WXWIZARDPAGESIMPLE_TYPE;
	custom_object->is_user_initialized = 0;
	
    return retval;
}
END_EXTERN_C()

/* {{{ proto  wxWizardPageSimple::Chain(wxWizardPageSimple &first, wxWizardPageSimple &second)
   A convenience function to make the pages follow each other. */
PHP_METHOD(php_wxWizardPageSimple, Chain)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWizardPageSimple::Chain\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWizardPageSimple* current_object;
	wxphp_object_type current_object_type;
	wxWizardPageSimple_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWizardPageSimple*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWizardPageSimple::Chain call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* first0 = 0;
	wxWizardPageSimple* object_pointer0_0 = 0;
	zval* second0 = 0;
	wxWizardPageSimple* object_pointer0_1 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 2)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'zz' (&first0, &second0)\n");
		#endif

		char parse_parameters_string[] = "zz";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &first0, &second0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(first0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWizardPageSimple*) zend_object_store_get_object(first0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWizardPageSimple*) zend_object_store_get_object(first0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWizardPageSimple*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'first' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(first0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'first' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 2){
				if(Z_TYPE_P(second0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWizardPageSimple*) zend_object_store_get_object(second0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWizardPageSimple*) zend_object_store_get_object(second0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxWizardPageSimple*) argument_native_object;
					if (!object_pointer0_1 || (argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'second' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(second0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'second' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Static ");
				php_printf("Executing wxWizardPageSimple::Chain((wxWizardPageSimple*) object_pointer0_0, (wxWizardPageSimple*) object_pointer0_1)\n\n");
				#endif

				wxWizardPageSimple::Chain((wxWizardPageSimple*) object_pointer0_0, (wxWizardPageSimple*) object_pointer0_1);


				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWizardPageSimple::Chain\n");
	}
}
/* }}} */

/* {{{ proto  wxWizardPageSimple::SetPrev(wxWizardPage &prev)
   Sets the previous page. */
PHP_METHOD(php_wxWizardPageSimple, SetPrev)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWizardPageSimple::SetPrev\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWizardPageSimple* current_object;
	wxphp_object_type current_object_type;
	wxWizardPageSimple_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWizardPageSimple*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWizardPageSimple::SetPrev call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* prev0 = 0;
	wxWizardPage* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&prev0)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &prev0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(prev0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWizardPage*) zend_object_store_get_object(prev0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWizardPage*) zend_object_store_get_object(prev0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWizardPage*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'prev' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(prev0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'prev' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWizardPageSimple::SetPrev((wxWizardPage*) object_pointer0_0)\n\n");
				#endif

				((wxWizardPageSimple_php*)native_object)->SetPrev((wxWizardPage*) object_pointer0_0);

				references->AddReference(prev0, "wxWizardPageSimple::SetPrev at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWizardPageSimple::SetPrev\n");
	}
}
/* }}} */

/* {{{ proto  wxWizardPageSimple::wxWizardPageSimple(wxWizard &parent, wxWizardPage &prev, wxWizardPage &next, wxBitmap bitmap)
   Constructor takes the previous and next pages. */
PHP_METHOD(php_wxWizardPageSimple, __construct)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWizardPageSimple::__construct\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWizardPageSimple* current_object;
	wxWizardPageSimple_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	int arguments_received = ZEND_NUM_ARGS();
	
	
	//Parameters for overload 0
	zval* parent0 = 0;
	wxWizard* object_pointer0_0 = 0;
	zval* prev0 = 0;
	wxWizardPage* object_pointer0_1 = 0;
	zval* next0 = 0;
	wxWizardPage* object_pointer0_2 = 0;
	zval* bitmap0 = 0;
	wxBitmap* object_pointer0_3 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received >= 1  && arguments_received <= 4)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z|zzO' (&parent0, &prev0, &next0, &bitmap0, php_wxBitmap_entry)\n");
		#endif

		char parse_parameters_string[] = "z|zzO";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &parent0, &prev0, &next0, &bitmap0, php_wxBitmap_entry ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(parent0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWizard*) zend_object_store_get_object(parent0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWizard*) zend_object_store_get_object(parent0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWizard*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWIZARD_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'parent' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(parent0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'parent' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 2){
				if(Z_TYPE_P(prev0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWizardPage*) zend_object_store_get_object(prev0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWizardPage*) zend_object_store_get_object(prev0 TSRMLS_CC))->native_object;
					object_pointer0_1 = (wxWizardPage*) argument_native_object;
					if (!object_pointer0_1 || (argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'prev' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(prev0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'prev' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 3){
				if(Z_TYPE_P(next0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWizardPage*) zend_object_store_get_object(next0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWizardPage*) zend_object_store_get_object(next0 TSRMLS_CC))->native_object;
					object_pointer0_2 = (wxWizardPage*) argument_native_object;
					if (!object_pointer0_2 || (argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'next' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(next0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'next' not null, could not be retreived correctly.");
				}
			}

			if(arguments_received >= 4){
				if(Z_TYPE_P(bitmap0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxBitmap*) zend_object_store_get_object(bitmap0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxBitmap*) zend_object_store_get_object(bitmap0 TSRMLS_CC))->native_object;
					object_pointer0_3 = (wxBitmap*) argument_native_object;
					if (!object_pointer0_3 )
					{
						zend_error(E_ERROR, "Parameter 'bitmap' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(bitmap0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'bitmap' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWizard*) object_pointer0_0)\n");
				#endif

				native_object = new wxWizardPageSimple_php((wxWizard*) object_pointer0_0);

				native_object->references.Initialize();
				((wxWizardPageSimple_php*) native_object)->references.AddReference(parent0, "wxWizardPageSimple::wxWizardPageSimple at call with 1 argument(s)");
				break;
			}
			case 2:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWizard*) object_pointer0_0, (wxWizardPage*) object_pointer0_1)\n");
				#endif

				native_object = new wxWizardPageSimple_php((wxWizard*) object_pointer0_0, (wxWizardPage*) object_pointer0_1);

				native_object->references.Initialize();
				((wxWizardPageSimple_php*) native_object)->references.AddReference(parent0, "wxWizardPageSimple::wxWizardPageSimple at call with 2 argument(s)");
				((wxWizardPageSimple_php*) native_object)->references.AddReference(prev0, "wxWizardPageSimple::wxWizardPageSimple at call with 2 argument(s)");
				break;
			}
			case 3:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWizard*) object_pointer0_0, (wxWizardPage*) object_pointer0_1, (wxWizardPage*) object_pointer0_2)\n");
				#endif

				native_object = new wxWizardPageSimple_php((wxWizard*) object_pointer0_0, (wxWizardPage*) object_pointer0_1, (wxWizardPage*) object_pointer0_2);

				native_object->references.Initialize();
				((wxWizardPageSimple_php*) native_object)->references.AddReference(parent0, "wxWizardPageSimple::wxWizardPageSimple at call with 3 argument(s)");
				((wxWizardPageSimple_php*) native_object)->references.AddReference(prev0, "wxWizardPageSimple::wxWizardPageSimple at call with 3 argument(s)");
				((wxWizardPageSimple_php*) native_object)->references.AddReference(next0, "wxWizardPageSimple::wxWizardPageSimple at call with 3 argument(s)");
				break;
			}
			case 4:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing __construct((wxWizard*) object_pointer0_0, (wxWizardPage*) object_pointer0_1, (wxWizardPage*) object_pointer0_2, *(wxBitmap*) object_pointer0_3)\n");
				#endif

				native_object = new wxWizardPageSimple_php((wxWizard*) object_pointer0_0, (wxWizardPage*) object_pointer0_1, (wxWizardPage*) object_pointer0_2, *(wxBitmap*) object_pointer0_3);

				native_object->references.Initialize();
				((wxWizardPageSimple_php*) native_object)->references.AddReference(parent0, "wxWizardPageSimple::wxWizardPageSimple at call with 4 argument(s)");
				((wxWizardPageSimple_php*) native_object)->references.AddReference(prev0, "wxWizardPageSimple::wxWizardPageSimple at call with 4 argument(s)");
				((wxWizardPageSimple_php*) native_object)->references.AddReference(next0, "wxWizardPageSimple::wxWizardPageSimple at call with 4 argument(s)");
				((wxWizardPageSimple_php*) native_object)->references.AddReference(bitmap0, "wxWizardPageSimple::wxWizardPageSimple at call with 4 argument(s)");
				break;
			}
		}
	}

		
	if(already_called)
	{
		native_object->phpObj = getThis();
		

		current_object = (zo_wxWizardPageSimple*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		current_object->native_object = native_object;
		
		current_object->is_user_initialized = 1;
		
		#ifdef ZTS 
		native_object->TSRMLS_C = TSRMLS_C;
		#endif
	}
	else
	{
		zend_error(E_ERROR, "Abstract class or wrong type/count of parameters passed to: wxWizardPageSimple::__construct\n");
	}
	
	#ifdef USE_WXPHP_DEBUG
		php_printf("===========================================\n\n");
	#endif
}
/* }}} */

/* {{{ proto  wxWizardPageSimple::SetNext(wxWizardPage &next)
   Sets the next page. */
PHP_METHOD(php_wxWizardPageSimple, SetNext)
{
	#ifdef USE_WXPHP_DEBUG
	php_printf("Invoking wxWizardPageSimple::SetNext\n");
	php_printf("===========================================\n");
	#endif
	
	zo_wxWizardPageSimple* current_object;
	wxphp_object_type current_object_type;
	wxWizardPageSimple_php* native_object;
	void* argument_native_object = NULL;
	
	//Other variables used thru the code
	zval* dummy = NULL;
	bool already_called = false;
	wxPHPObjectReferences* references;
	int arguments_received = ZEND_NUM_ARGS();
	bool return_is_user_initialized = false;
	
	//Get native object of the php object that called the method
	if(getThis() != NULL) 
	{
		current_object = (zo_wxWizardPageSimple*) zend_object_store_get_object(getThis() TSRMLS_CC);
		
		if(current_object->native_object == NULL)
		{
			zend_error(E_ERROR, "Failed to get the native object for wxWizardPageSimple::SetNext call\n");
			
			return;
		}
		else
		{
			native_object = current_object->native_object;
			current_object_type = current_object->object_type;
			
			bool reference_type_found = false;

			if(current_object_type == PHP_WXWIZARDPAGESIMPLE_TYPE){
				references = &((wxWizardPageSimple_php*)native_object)->references;
				reference_type_found = true;
			}
		}
	}
	#ifdef USE_WXPHP_DEBUG
	else
	{
		php_printf("Processing the method call as static\n");
	}
	#endif
	
	//Parameters for overload 0
	zval* next0 = 0;
	wxWizardPage* object_pointer0_0 = 0;
	bool overload0_called = false;
		
	//Overload 0
	overload0:
	if(!already_called && arguments_received == 1)
	{
		#ifdef USE_WXPHP_DEBUG
		php_printf("Parameters received %d\n", arguments_received);
		php_printf("Parsing parameters with 'z' (&next0)\n");
		#endif

		char parse_parameters_string[] = "z";
		if(zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, arguments_received TSRMLS_CC, parse_parameters_string, &next0 ) == SUCCESS)
		{
			if(arguments_received >= 1){
				if(Z_TYPE_P(next0) == IS_OBJECT)
				{
					wxphp_object_type argument_type = ((zo_wxWizardPage*) zend_object_store_get_object(next0 TSRMLS_CC))->object_type;
					argument_native_object = (void*) ((zo_wxWizardPage*) zend_object_store_get_object(next0 TSRMLS_CC))->native_object;
					object_pointer0_0 = (wxWizardPage*) argument_native_object;
					if (!object_pointer0_0 || (argument_type != PHP_WXWIZARDPAGE_TYPE && argument_type != PHP_WXWIZARDPAGESIMPLE_TYPE))
					{
						zend_error(E_ERROR, "Parameter 'next' could not be retreived correctly.");
					}
				}
				else if(Z_TYPE_P(next0) != IS_NULL)
				{
					zend_error(E_ERROR, "Parameter 'next' not null, could not be retreived correctly.");
				}
			}

			overload0_called = true;
			already_called = true;
		}
	}

		
	if(overload0_called)
	{
		switch(arguments_received)
		{
			case 1:
			{
				#ifdef USE_WXPHP_DEBUG
				php_printf("Executing wxWizardPageSimple::SetNext((wxWizardPage*) object_pointer0_0)\n\n");
				#endif

				((wxWizardPageSimple_php*)native_object)->SetNext((wxWizardPage*) object_pointer0_0);

				references->AddReference(next0, "wxWizardPageSimple::SetNext at call with 1 argument(s)");

				return;
				break;
			}
		}
	}

		
	//In case wrong type/count of parameters was passed
	if(!already_called)
	{
		zend_error(E_ERROR, "Wrong type or count of parameters passed to: wxWizardPageSimple::SetNext\n");
	}
}
/* }}} */

